{
	File:		CMComponent.p

	Contains:	Headers for CMM components

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
UNIT CMComponent;
INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingCMComponent}
{$SETC UsingCMComponent := 1}

{$I+}
{$SETC CMComponentIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}

{$IFC UNDEFINED UsingQuickdraw}
{$I $$Shell(PInterfaces)Quickdraw.p}
{$ENDC}

{$IFC UNDEFINED UsingComponents}
{$I $$Shell(PInterfaces)Components.p}
{$ENDC}

{$IFC UNDEFINED UsingCMApplication}
{$I $$Shell(PInterfaces)CMApplication.p}
{$ENDC}

{$SETC UsingIncludes := CMComponentIncludes}


CONST

{ CMM Components }

CMInterfaceVersion = 0;

{ CMM Component function selectors }
kCMInit = 0;
kCMMatchColors = 1;
kCMGamutTest = 2;
kCMMatchPixMap = 3;
kCMCheckPixMap = 4;
kCMConcatenateProfiles = 5;


{ Profile Responder Components }

ProfileResponderInterfaceRev = 0;

{ ProfileResponder Component function selectors }
kCMGetProfile = 0;
kCMSetProfile = 1;
kCMSetProfileDescription = 2;
kCMGetIndexedProfile = 3;
kCMDeleteDeviceProfile = 4;
kProfileResponderMaxSelector = kCMDeleteDeviceProfile;


TYPE

ProfileResponder = ComponentInstance;


{ Required CMM Component routines }

FUNCTION CMInit(CMSession: ComponentInstance; srcProfile: CMProfileHandle;
				dstProfile: CMProfileHandle): CMError;
	INLINE $2F3C, $0008, kCMInit, $7000, $A82A;

FUNCTION CMMatchColors(CMSession: ComponentInstance; myColors: CMColorList; count: LONGINT): CMError;
	INLINE $2F3C, $0008, kCMMatchColors, $7000, $A82A;

FUNCTION CMCheckColors(CMSession: ComponentInstance; myColors: CMColorList;
					   count: LONGINT; result: CMGamutResult): CMError;
	INLINE $2F3C, $000C, kCMGamutTest, $7000, $A82A;


{ Optional CMM Component routines }

FUNCTION CMMatchPixMap(CMSession: ComponentInstance; myPixMap: PixMap;
					   progressProc: PixMapCallBackProcPtr; refCon: LONGINT): CMError;
	INLINE $2F3C, $000C, kCMMatchPixMap, $7000, $A82A;

FUNCTION CMCheckPixMap(CMSession: ComponentInstance; myPixMap: PixMap;
					   progressProc: PixMapCallBackProcPtr; myBitMap: BitMap; refCon: LONGINT): CMError;
	INLINE $2F3C, $0010, kCMCheckPixMap, $7000, $A82A;

FUNCTION CMConcatenateProfiles(CMSession: ComponentInstance; thru: CMProfileHandle;
							   dst: CMProfileHandle; VAR newDst: CMProfileHandle): CMError;
	INLINE $2F3C, $000C, kCMConcatenateProfiles, $7000, $A82A;


{ ProfileResponder Component routines }

FUNCTION CMGetProfile(myProfileResponder: ProfileResponder; aProfile: CMProfileHandle;
					  VAR returnedProfile: CMProfileHandle): CMError;
	INLINE $2F3C, $0008, kCMGetProfile, $7000, $A82A;

FUNCTION CMSetProfile(myProfileResponder: ProfileResponder; newProfile: CMProfileHandle): CMError;
	INLINE $2F3C, $0004, kCMSetProfile, $7000, $A82A;

FUNCTION CMSetProfileDescription(myProfileResponder: ProfileResponder; deviceData: UNIV LONGINT;
								 hProfile: CMProfileHandle): CMError;
	INLINE $2F3C, $0008, kCMSetProfileDescription, $7000, $A82A;

FUNCTION CMGetIndexedProfile(myProfileResponder: ProfileResponder; search: CMProfileSearchRecordHandle;
							 VAR returnProfile: CMProfileHandle; VAR index: LONGINT): CMError;
	INLINE $2F3C, $000C, kCMGetIndexedProfile, $7000, $A82A;

FUNCTION CMDeleteDeviceProfile(myProfileResponder: ProfileResponder;
							   deleteMe: CMProfileHandle): CMError;
	INLINE $2F3C, $0004, kCMDeleteDeviceProfile, $7000, $A82A;


{$ENDC UsingCMComponent}

{$IFC NOT UsingIncludes}
END.
{$ENDC}