/*
	File:		CMApplication.r

	Contains:	Header for Color Matching aware applications

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __CMAPPLICATION.R__
#define __CMAPPLICATION.R__

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

/* Number of values in response.counts */
#define	onePlusLastResponse		9

/* Profile Header version */
#define	kCMApplProfileVersion	0x0100


type 'prof'
{
	startOfProfile:

	header:
		unsigned longint = (endOfProfile - startOfProfile) >> 3;	/* size */
		literal longint;											/* CMMType */
		hex longint = kCMApplProfileVersion;						/* applProfileVersion */
		literal longint 	rgbData			= 'RGB ',				/* dataType */
							cmykData		= 'CMYK',
							grayData		= 'GRAY',
							xyzData			= 'XYZ ';

		literal longint		monitorDevice	= 'mntr',				/* deviceType */
							scannerDevice	= 'scnr',
							printerDevice	= 'prtr',
							qdSystemDevice	= 'sys ',
							qdGDevice		= 'gdev';
		literal longint;											/* deviceManufacturer */
		hex longint;												/* deviceModel */
		array[2]													/* deviceAttributes */
		{
			hex longint;
		};

		unsigned longint = (profileName - startOfProfile) >> 3;		/* profileNameOffset */
		unsigned longint = (endOfProfile - startOfProfile) >> 3;	/* customDataOffset */

		unsigned hex longint;										/* flags */
		unsigned hex longint;										/* options */

		wide array[3]												/* white (XYZColor) */
		{
			unsigned hex integer;
		};
		wide array[3]												/* black (XYZColor) */
		{
			unsigned hex integer;
		};

	profile:		
		array[6]
		{															/* RGBCMY (XYZColor) */
			wide array[3]
			{
				unsigned hex integer;
			};
		};

	response:
		wide array[onePlusLastResponse]								/* response.counts */
		{
			responseCounts:		
			unsigned integer;
		};
																	/* response.data */

		wide array[$$Word(responseCounts[1])]						/* grayResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[2])]						/* redResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[3])]						/* greenResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[4])]						/* blueResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[5])]						/* cyanResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[6])]						/* magentaResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[7])]						/* yellowResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[8])]						/* ucrResponse */
		{
			unsigned integer;
		};
		wide array[$$Word(responseCounts[9])]						/* bgResponse */
		{
			unsigned integer;
		};		
		
	profileName:
		integer Script;												/* theScript */
		pstring;													/* theString (Str63) */
		
 		align word;													/* pad byte if name size is odd */
		
	endOfProfile:
};

#endif