
	//	FILE: AdHoc.H

	//	PURPOSE: Defines values internal to Gator.EXE,
	//			 the ODBC SQLCLI Test Application for Microsoft Windows

	//		  Copyright (C) 1988-1991 Microsoft Corp.


//#define SEGMENT _segment
#define SEGMENT long			// mj
#define SELF    _self

#define	LRESULT		long		// mj
#define	LPARAM		long		// mj
#define	HINSTANCE	long		// mj
#define	HMENU		long		// mj
//#define	HWND		long		// mj

#define wsprintf	sprintf
#define CSCONST

//#define ReleaseCapture()


#define lstrlen	strlen
#define lstrcpy	strcpy
#define lstrcat	strcat
#define ltoa(  s, d, c )	sprintf( d, "%10ld", s )	// ??? fix this
#define ultoa( s, d, c )	sprintf( d, "%10ld", s )	// ??? fix this

typedef unsigned int	UBOOL;
typedef char *			LPBYTE;
typedef void *			HPVOID;
typedef void			VOID;
//typedef PTR  *		HANDLE;

#include <stdio.h>

//#define HUGE                _huge
#define HUGE

typedef BYTE HUGE * HPBYTE;

	// SEG_BASED() - a pointer storage class specifier (like FAR) which
	//               creates a near pointer that points to the same segment
	//               as the given far pointer.

#define SEG_BASED(lptype) BASED((SEGMENT)lptype)


	// PmaxFromRg(rgname) - creates a pointer to the Max of an array

	//	#define pfooMax_BAR PmaxFromRg(rgfoo_BAR)

	//		expands to:

	//	#define pfooMax_BAR \
	//		(&(rgfoo_BAR)[sizeof (rgfoo_BAR) / sizeof (rgfoo_BAR)[0]])

#define PmaxFromRg(rgname)	(&(rgname)[sizeof(rgname) / sizeof(rgname)[0]])


	// LszIfSz() - work around a C6 build error with function arguments
	//             containing '?' and ':' operators and based pointers.
	//
	//	When '?' and ':' operators are used in the expression of a function
	//	argument and either choice of the '?' and ':' operators is a variable
	//	of type BYTE CSCONST *, then instead of:
	//
	//		<boolean expression> ? <szTrue> : <szFalse>

	//	use:

	//		LszIfSz(<boolean expression>, <szTrue>, <szFalse>)

#define LszIfSz(f, szTrue, szFalse) \
	(LPBYTE)((f) ? (UDWORD)(LPBYTE)(szTrue) : (UDWORD)(LPBYTE)(szFalse))


	// Size constants:

#define MAX_CONNECTIONS		20		// max server connections
#define MAX_STATEMENTS		100
#define MAX_SERVERNAME		101		// max length for server
#define MAX_CONNECTION_STRING	300	// max length for connectionString
#define MAX_INFO_STRING		300		// max length for info output buffers
#define MAX_CROW			300		// max row count for SQLExtendedFetch
#define MAX_TYPENAMELEN		30		// max length for data type name
#define MAX_CBSQLSTR		300		// max length for NativeSql output buffer
#define MAX_CBCOLNAME		300		// max length for column name
#define DEFAULT_BUFFER_LEN	300		// a default buffer length for dialogs
#define GETDATA_ROW_CBBUF	300		// size of buf for Get Data Row
#define MAX_OPTION_PARAM	300		// max length for {Set|Get}Option param

#define yWndTop				25		// y position of top of top window
#define APP_NAME	"SQL ALIASES"	// Name of section in win.ini

	// hdbc list meta-names:

#define NULL_CONNECTION		"NULL"			// null handle
#define UNCONNECTED_SERVER	"<unconnected>"	// the hdbc is not connected
#define UNKNOWN_SERVER		"<unknown>" 	// the name is unknown
#define NULL_SERVER_NAME	"<null string>"	// the name is a null string

#define NULL_STATEMENT		"NULL"			// null hstmt in the hstmt list

	// Windows doubleword selection descriptor:

typedef union
{
	LRESULT	lresult;	// result of WM_GETSEL message
	LPARAM	lparam;		// lParam arg of WM_SETSEL message
	struct
	{
		UWORD ichStart;	// LOWORD
		UWORD ichEnd;	// HIWORD
	} agr;
} SEL;

	/* Input String Arg struct:	*/

typedef struct
{
	UWORD	cuse:15;		/* use count							*/
	UBOOL	fNull:1;		/* fNull from Checkbox					*/
	SWORD	cbMax;
	SWORD	cbDefault;
	SWORD	cb;
	UCHAR	sz[ 1 ];		/* 1st byte of string allocated to max	*/
} ISA, *LPISA, **LPLPISA;


	// LszOfLpisa() - returns the pointer to the string of the Input String Arg.

#define LszOfLpisa( lpisa ) ((lpisa)->fNull ? NULL : (lpisa)->sz)


	// LszAndCbOfLpisa() - returns two arguments of the Input String Arg
	//                     - the pointer to the string, and the cb.

#define LszAndCbOfLpisa( lpisa ) LszOfLpisa(lpisa), ((lpisa)->cb)


		// CONNINFO - This struct contains arg info for
		// SQLConnect, SQLBrowseConnect, and SQLDriverConnect:

	typedef struct
	{							// Connect dialog
		LPISA	lpisaDSN;
		LPISA	lpisaUID;
		LPISA	lpisaAuthStr;
								// DriverConnect & BrowseConnect dialog
		HWND	hwnd;
		LPISA	lpisaConnStrIn;
		SWORD	cbConnStrOutMax;
		UWORD	fDriverCompletion;	// DriverConnect only
	} CONNINFO;

		// SERVERINFO - This struct contains error information for the driver manager:

	typedef struct ServerInfo
	{
		UWORD	idbc;
		HDBC	hdbc;
		char	szName[ MAX_SERVERNAME ];
		short	fStatus;
		LPBYTE	rgbMenuStatus;
	} SERVERINFO;

#define Unused    0x00		//
#define Allocated 0x01		// SQLAllocConnect
#define Connected 0x02		// SQLConnect

#define UNTOUCHED 0xCACACACA

typedef struct StmtInfo
{
	HDBC		hdbc;
	HSTMT		hstmt;
	UWORD		istmt;
	union BOUNDtag	*lpboundFirst;
	UDWORD		crow;
	UDWORD		irow;
	BOOL		fNull_pirow;
} STMTINFO;

	extern HINSTANCE hinst;		// current instance
	extern HWND  	 hwndErr;
	extern HDBC  	 hdbc;
	extern short 	 Smode;

	// Debug constants

#define DEBUG_STATUS_OK		0x0000
#define DEBUG_STATUS_OOM	0x0001
#define MAGIC_WORD			0xcccc


	typedef struct
	{	int		ifn;
		LPBYTE	lszFuncName;
	} DDAFUN;

	// This union of structs contains the information necessary for
	// re-executing asynchronous functions.  This is a linked list node.

#define AsyncFuncCommonParams()			\
		union tagAsyncFunc	*lpafNext;	\
		int					ifn;		\
		HSTMT				hstmt;		\
		UWORD				istmt;

#define AsyncFuncDDAParams(Object) \
		AsyncFuncCommonParams()    \
		LPISA lpisa ## Object ## Qualifier; \
		LPISA lpisa ## Object ## Owner;     \
		LPISA lpisa ## Object ## Name;

	typedef union tagAsyncFunc
	{
		struct	// Use this one when any function is being referenced
		{
			AsyncFuncCommonParams()
		} General;
	
		struct
		{
			AsyncFuncCommonParams()
			UWORD		icol;
			UWORD		fDescType;
			UCHAR		*lrgbDesc;
			SWORD		cbDescMax;
			SWORD		*lpcbDesc;
			SDWORD		*lpfDesc;
		} ColAttributes;
	
		struct
		{
			AsyncFuncDDAParams(Table)
			LPISA		lpisaColumnName;
		} ColumnPrivileges;
	
		struct
		{
			AsyncFuncDDAParams(Table)
			LPISA		lpisaColumnName;
		} Columns;
	
		struct	// Use this one when any DDA function is being referenced
		{
			AsyncFuncDDAParams(Table)
		} DDA;
	
		struct
		{
			AsyncFuncCommonParams()
			UWORD        icol;
			UCHAR		*lszColName;
			SWORD        cbColNameMax;
			SWORD		*lpcbColName;
			SWORD		*lpfSqlType;
			UDWORD		*lpcbColDef;
			SWORD		*lpibScale;
			SWORD		*lpfNullable;
		} DescribeCol;
	
		struct
		{
			AsyncFuncCommonParams()
			UWORD        ipar;
			SWORD		*lpfSqlType;
			UDWORD		*lpcbColDef;
			SWORD		*lpibScale;
			SWORD		*lpfNullable;
		} DescribeParam;

		struct
		{
			AsyncFuncCommonParams()
			UCHAR HUGE	*hszSqlStr;
			SDWORD		cbSqlStr;
			SDWORD		cbDefault;
		} ExecDirect;

		struct
		{
			AsyncFuncCommonParams()
		} Execute;

		struct
		{
			AsyncFuncCommonParams()
			UWORD	fFetchType;
			SDWORD	irow;
			UDWORD	*lpcrow;
			UWORD	*lrgfRowStatus;
		} ExtendedFetch;

		struct
		{
			AsyncFuncCommonParams()
		} Fetch;

		struct
		{
			AsyncFuncCommonParams()
			LPISA	lpisaPkTableQualifier;
			LPISA	lpisaPkTableOwner;
			LPISA	lpisaPkTableName;
			LPISA	lpisaFkTableQualifier;
			LPISA	lpisaFkTableOwner;
			LPISA	lpisaFkTableName;
		} ForeignKeys;
	
		struct
		{
			AsyncFuncCommonParams()
			UWORD        icol;
			SWORD        fCType;
			HPVOID       hrgbValue;
			SDWORD       cbValueMax;
			SDWORD		*lpcbValue;
		} GetData;
	
		struct
		{
			AsyncFuncCommonParams()
			UWORD fSqlType;
		} GetTypeInfo;
	
		struct
		{
			AsyncFuncCommonParams()
		} MoreResults;
	
		struct
		{
			AsyncFuncCommonParams()
			SWORD	*lpccol;
		} NumResultCols;
	
		struct
		{
			AsyncFuncCommonParams()
			PTR		*lplrgbValue;
		} ParamData;
	
		struct
		{
			AsyncFuncCommonParams()
			UCHAR HUGE	*hszSqlStr;
			SDWORD		cbSqlStr;
			SDWORD		cbDefault;
		} Prepare;
	
		struct
		{
			AsyncFuncDDAParams(Table)
		} PrimaryKeys;
	
		struct
		{
			AsyncFuncDDAParams(Proc)
			LPISA	lpisaColumnName;
		} ProcedureColumns;
	
		struct
		{
			AsyncFuncDDAParams(Proc)
		} Procedures;
	
		struct
		{
			AsyncFuncCommonParams()
			SWORD	fCType;
			HPVOID	hrgbValue;
			SDWORD	cbValue;
			SDWORD	cbDefault;
			SDWORD	cbValueMax;
		} PutData;
	
		struct
		{
			AsyncFuncCommonParams()
			UWORD	irow;
			BOOL	fRefresh;
			BOOL	fLock;
		} SetPos;
	
		struct
		{
			AsyncFuncDDAParams(Table)
			UWORD	fColType;
			UWORD	fScope;
			UWORD	fNullable;
		} SpecialColumns;
	
		struct
		{
			AsyncFuncDDAParams(Table)
			UWORD fUnique;
			UWORD fAccuracy;
		} Statistics;
	
		struct
		{
			AsyncFuncDDAParams(Table)
			LPISA	lpisaTableType;
		} TablePrivileges;
	
		struct
		{
			AsyncFuncDDAParams(Table)
			LPISA	lpisaTableType;
		} Tables;
	} AFSTRUCT, *LPAF;

	// (AFSTRUCT).<structname>.ifn values:

#define ifnNotAsync          0
	// use for function which doesn't support async

#define ifnColAttributes     1
#define ifnColumnPrivileges  2
#define ifnColumns           3
#define ifnDescribeCol       4
#define ifnDescribeParam     5
#define ifnExecDirect        6
#define ifnExecute           7
#define ifnExtendedFetch     8
#define ifnFetch             9
#define ifnForeignKeys      10
#define ifnGetData          11
#define ifnGetTypeInfo      12
#define ifnMoreResults      13
#define ifnNumResultCols    14
#define ifnParamData        15
#define ifnPrepare          16
#define ifnPrimaryKeys      17
#define ifnProcedureColumns 18
#define ifnProcedures       19
#define ifnPutData          20
#define ifnSetPos           21
#define ifnSpecialColumns   22
#define ifnStatistics       23
#define ifnTablePrivileges  24
#define ifnTables           25

		/* DDAINFO - DDA function arg struct:	*/

	typedef struct
	{								/* pointers to Input String Arg structs:	*/
		LPISA lpisaTableQualifier;
		LPISA lpisaTableOwner;
		LPISA lpisaTableName;
		LPISA lpisaTableType;
		LPISA lpisaColumnName;
		LPISA lpisaFkTableQualifier;
		LPISA lpisaFkTableOwner;
		LPISA lpisaFkTableName;
		LPISA lpisaProcQualifier;
		LPISA lpisaProcOwner;
		LPISA lpisaProcName;
		LPISA lpisaCursor;

		SWORD fSqlType;
		UWORD fColType;
		UWORD fUnique;
		UWORD fAccuracy;
		UWORD fScope;
		UWORD fNullable;
	} DDAINFO;

		/* FNAM - General Flag Name structs:	*/

	typedef struct
	{
		SWORD	fArg;
		LPBYTE	lszName;
	} FNAM;

//mj#define InitFnam(name) {name, sz_ ## name}

	typedef struct
	{
		FNAM CSCONST	*pfnamMin;
		FNAM CSCONST	*pfnamMax;
		UWORD			cchSame:14;
		UBOOL			fSigned:1;
		UBOOL			fLong:1;
	} FINFO;

	// Note: FINFO constants are declared using the DeclareFinfo() &
	// DeclareFinfoSubset() macros, so you won't find a declaration
	// containing "finfo_...", but instead "DeclareFinfo[Subset](...".

	// DeclareFinfo[Subset]() fType arg values:

#define FINFO_UWORD  0
#define FINFO_SWORD  1
#define FINFO_UDWORD 2
#define FINFO_SDWORD 3

#define GLOBAL	/* placeholder for null scope argument	*/

#define DeclareFinfo( ArgName, szSame, fType, scope ) \
					scope FINFO CSCONST finfo_ ## ArgName = \
					{	&rgfnam_ ## ArgName[0], \
						PmaxFromRg(rgfnam_ ## ArgName), \
						sizeof szSame - 1, \
						(fType & FINFO_SWORD)  != 0, \
						(fType & FINFO_UDWORD) != 0 \
					}

#define DeclareFinfoSubset( ArgName, Qualifier, szSame, fType, scope, \
							ifnamMin, ifnamMax) \
	scope FINFO CSCONST finfo_ ## ArgName ## _ ## Qualifier = \
	{	&rgfnam_ ## ArgName[ifnamMin], \
		&rgfnam_ ## ArgName[ifnamMax], \
		sizeof szSame - 1, \
		(fType & FINFO_SWORD)  != 0, \
		(fType & FINFO_UDWORD) != 0 \
	}

	// FChangedInputWindow() iiwinfo arg values:

#define iiwinfo_cbSqlStr   0
#define iiwinfo_cbValue    1
#define iiwinfo_cbSqlStrIn 2

#define ciwinfo		3	// Number of variables served by FChangedInputWindow()

	// F{Init|Proc}Input...Arg[ Msg ]() fCombo argument values:

#define VALUE_IS_ILLEGAL      1
#define VALUE_NOT_REDISPLAYED 2
#define VALUE_WAS_REDISPLAYED 3

	// FProcInput...ArgMsg() custom notification code:

#define CBN_UPDATE_CONTENTS  22

	// ProcInputString[ Sz ]ArgMsg fSelections argument values:

#define DSN_LIST        0x0001
#define NULL_SELECTIONS 0x0002
#define APPEARS_WITH_CB 0x0004

	// FreeParamsAndCols() fWhat argument values:

#define FREE_COLS   0x0001	//  lpbound->ref.fParam + 1 == FREE_COLS
#define FREE_PARAMS 0x0002	//  lpbound->ref.fParam + 1 == FREE_PARAMS
#define FREE_BOTH   0x0003	// (lpbound->ref.fParam + 1 &  FREE_BOTH) != 0
#define FREE_ALL    0x0007	// Free all params and cols for all hstmts

		// SQLSetParam and SQLBindCol arg struct union
	
	typedef union BOUNDtag
	{
		struct	// Bound Variable Reference
		{
			union BOUNDtag	* lpboundNext;
			UBOOL	fParam:1;
			UBOOL	fNull_pcb:1;
			UBOOL	fNull_rgb:1;
			UBOOL	fUnused:1;
			UWORD	iref;
		} ref;
	
		struct	// SQLBindCol arg
		{
			union BOUNDtag	* lpboundNext;
			UBOOL	fParam:1;		// = FALSE
			UBOOL	fNull_pcb:1;
			UBOOL	fNull_rgb:1;
			UBOOL	fUnused:1;
			UWORD	icol;
			SWORD	fCType;
			UDWORD	cbValueMax;
			SDWORD	cbValue;
			BYTE	rgbValue[1];
		} col;

		struct	// SQLSetParam arg
		{
			union BOUNDtag	* lpboundNext;
			UBOOL	fParam:1;		// = TRUE
			UBOOL	fNull_pcb:1;
			UBOOL	fNum_rgb:1;
			UWORD	ipar;
			SWORD	fCType;
			SWORD	fSqlType;
			UDWORD	cbColDef;
			SWORD	ibScale;
			SDWORD	cbValueMax;
			SDWORD	cbDefault;
			SDWORD	cbValue;
			UDWORD	udwValue;
			BYTE	rgbValue[1];
		} par;
	} BOUND, *LPBOUND;

#define SIZEOF_BOUND(ref) ((UWORD)&((BOUND*)0) -> ref.rgbValue[0])

	// FDisplayCbAndRgbArgs() fModes argument values:

#define NO_DATA_CHECK  0x0001
#define NEED_DATA_OK   0x0002
#define LPCB_SDWORD    0x0004
#define MID_LINE       0x0008
#define NO_NAMES       0x0010
#define BOUND_COLS     0x0020
#define INFO_VALUE     0x0040
#define HRGB_IN_OUT    0x0080
#define HRGB_UNTOUCHED 0x0100
#define HRGB_MIN_SIZE  0x0200

	// IcolBoundColChecks() fModes argument values:

#define ALWAYS_UNTOUCHED 0x0001
#define NO_ICOL_DISPLAY  0x0002

	// DisplayString() and CchGetStringDisplay() fModes argument values:

#define INPUT_STRING     0x0001  // DisplayString only
#define LENGTH_TERM      0x0002
#define IN_QUOTES        0x0004  // CchGetStringDisplay only
#define NO_METANAME      0x0008  // DisplayString only
#define BLANK_WHITESPACE 0x0010

	// GetValueDisplay(), StringDisplayCommon(),
	//  and TakeStringDisplay() ptsd argument struct:

	//	The checked variables are used when the string display goes to:

	//					output	edit 	combo	char
typedef struct		//	window	box  	box  	buffer
{                   //	------	-----	-----	------
	LPBYTE lsz; 	//	NULL	NULL	 X		 X	
	LPBYTE lpch;	//					 X		 X	
	HANDLE hasz;	//					 X		NULL
	HWND   hwnd;	//	NULL	 X					
	UWORD cbOutCur;	//					 X			
	UWORD cbOutMax;	//			 X		 X		 X	
} TSD;

	// ProcInputStringCbArgMsg() fModes argument values:

#define LPCB_IS_SWORD      0x0001
#define LPCB_FOR_PUTDATA   0x0002
#define LPCB_FOR_FILLPARAM 0x0006


		// declare all functions for application here

		// gator.c:

#define UnlockMemory(HANDLE)	myUnlockMemory(HANDLE)
#define LockMemory(HANDLE)		myLockMemory(HANDLE)


	pascal BOOL AppInit();
	pascal HWND CreateEditWindow( HINSTANCE *phinst, int idc, BYTE *szName, DWORD dwStyle );
	pascal BOOL FChangedInputWindow( UWORD iiwinfo );
	pascal VOID WinCls( HWND );
	pascal LPAF * LplpafFromHstmt( HSTMT hstmt );
	pascal LPAF LpafAdd( BOOL fAdd, int ifn, RETCODE retcode );
	pascal VOID DeleteAf( LPAF	* lplpaf );
	pascal VOID WriteTab( int ctab, int cch );
	pascal VOID WriteBottomWindow(LPBYTE lsz, BOOL fRedraw );
	pascal VOID TruncateEditContents(HWND, UWORD cchTruncate );
	pascal VOID WriteLog(LPBYTE lsz );
	pascal SWORD CcolNumResultCols();
	//pascal UWORD GetString( HWND, HANDLE *phaszBuf );
	pascal BOOL FCheckInputEdit( HWND hdlg, int idc, LPBYTE lszName, BOOL fSuccess );
	pascal HANDLE ReAllocateMemory( HANDLE, UDWORD );
	pascal VOID	UnlockMemory( HANDLE);
	pascal HPVOID LockMemory( HANDLE hmem );	// from gator.h
	pascal void FreeMemory( HANDLE );
	pascal UDWORD CbMemory( HPVOID hpb );
	pascal VOID SetDlgItemLong( HWND hdlg, int idc, long dwValue, BOOL fSigned );
	pascal VOID SetDlgItemHandleIndex(HWND hdlg, int idc, UWORD ihandle );
	pascal BOOL FGetDlgItemSWord( HWND hdlg, int idc, SWORD *lpswResult );
	pascal BOOL FGetDlgItemUWord( HWND hdlg, int idc, UWORD * lpuwResult);
	pascal BOOL FGetDlgItemSDWord( HWND hdlg, int idc, SDWORD *lpsdwResult );
	pascal BOOL FGetDlgItemUDWord( HWND hdlg, int idc, UDWORD *lpudwResult );
	pascal BOOL FAToSWord( LPBYTE lsz, SWORD	* lpswResult);
	pascal BOOL FAToUWord( LPBYTE lsz, UWORD	* lpuwResult);
	pascal BOOL FAToSDWord( LPBYTE lsz, SDWORD * lpsdwResult);
	pascal BOOL FAToUDWord( LPBYTE lsz, UDWORD * lpudwResult);
	pascal SDWORD hstrlen(HPBYTE hsz);
	pascal	VOID UpdateDropdownSize( HWND ); 
			VOID UpdateCurrentHdbc();
			VOID UpdateCurrentHstmt();
			VOID UpdateStatementList();
	pascal SERVERINFO * LpserverinfoFromHdbc( HDBC hdbc );
	pascal STMTINFO * LpstmtinfoFromHstmt( HSTMT hstmt );
	pascal VOID StackCheck( BOOL fSet );

		// auto.c:

	pascal BOOL AsyncDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal BOOL RecordDlg( HWND hdlg );
	pascal void UpdateMenu( HMENU hmenu );
	pascal void InitializeMenuTable();
	
		// connect.c:
	
	pascal VOID AllocConnect( HWND );
	pascal BOOL AllocConnectDlg(
							HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID AllocEnv( HWND );
	pascal BOOL AllocEnvDlg(
						HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID Connect( HWND );
	pascal BOOL ConnectDlg(
						HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID FillDropdownWithDSNList( HWND );
	
	pascal VOID Disconnect( HWND );
	pascal VOID FreeConnect( HWND );
	pascal VOID FreeEnv( HWND );
	pascal VOID GetInfo( HWND );
	pascal BOOL GetInfoDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID GetInfoAll( HWND );
	pascal VOID DisplayGetInfo( RETCODE retcode, UWORD fInfoType, BOOL fVerbose,
								LPBYTE lrgbInfoValue, SWORD cbInfoValueMax,
								SWORD *lpcbInfoValue );
	pascal VOID DisplayInfoValue( SWORD fCType,
						PTR lrgbInfoValue, SWORD cbTouched, SWORD cbInfoValue );
	pascal UDWORD FTXNIsoNameFromIbmnam(LPBYTE lsz, UWORD ibmnam);
	pascal VOID DataSources( HWND );
	pascal BOOL DataSourcesDlg(
							HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID DataSourcesAll( HWND );
	
		// servercn.c:
	
	pascal VOID FullConnect( HWND );
	pascal VOID FullDisconnect( HWND );
	pascal BOOL FullConnectDlg(
						HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	
		// send.c:

	pascal VOID DisplayParamData(RETCODE retcode, PTR	* lplrgbValue );
	pascal SDWORD GetDlgItemValue(HWND hdlg, int idc,
			SWORD fCType, HPVOID hrgbValue, SDWORD cbValueMax);
	pascal SDWORD CbFromAToValue(LPBYTE lszIn,
			SWORD fCType, HPVOID hrgbValue, SDWORD cbValueMax);
	pascal VOID ProcInputStringCbArgMsg(HWND hdlg, int idc, WORD message,
			UWORD fModes, SDWORD cbDefault, LPBYTE lpfCombo, PTR lpcb );
	pascal VOID DisplayValue(HWND, SWORD fCType,
			HPBYTE hrgbValue, SDWORD cbValueMax);
	pascal VOID GetValueDisplay(TSD * ptsd,
			SWORD fCType, HPBYTE hrgb, SDWORD cbTouched);
	pascal BYTE * SzConstDisplay(LPBYTE lszName, SDWORD sdwValue );
	pascal SWORD FCTypeFromFCTypeFSqlType(SWORD fCType, SWORD fSqlType );
	pascal UWORD CbFromFCType(SWORD fCType);

		// receive.c:
	
	pascal VOID DisplayNumRefs( RETCODE retcode, BOOL fParam, SWORD *lpcref );
	pascal BOOL NumResultColsDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID RowCount( HWND );
	
	pascal BOOL RowCountDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID DescribeCol( HWND );
	pascal BOOL DescribeColDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID DescribeRefAll( BOOL fParam, SWORD cref);
#ifdef CRAP
	pascal VOID DisplayDescribeRef( BOOL fParam,
			BOOL fHead, RETCODE retcode, UWORD iref,
			UCHAR	* lszColName, SWORD cbColNameMax,
			SWORD	* lpcbColName,
			SWORD	* lpfSqlType,
			UDWORD	* lpcbColDef,
			SWORD	* lpibScale,
			SWORD	* lpfNullable);
#endif CRAP
	pascal VOID DisplayDescribeRef( BOOL fParam,
			int	fHead, RETCODE retcode, UWORD iref,
			UCHAR	* lszColName, SWORD cbColNameMax,
			SWORD	* lpcbColName,
			SWORD	* lpfSqlType,
			UDWORD	* lpcbColDef,
			SWORD	* lpibScale,
			SWORD	* lpfNullable);
	pascal VOID BindCol( HWND );
	pascal BOOL BindColDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal BOOL FInsertBound(HSTMT hstmt, BOOL fParam, UWORD iref,
			LPBOUND lpbound, BOOL fUnbind);
	pascal UWORD IcolUntouchBoundCols(HSTMT hstmt);
	pascal UWORD IcolBoundColChecks(
			HSTMT hstmt, UWORD fModes, RETCODE retcode );
	pascal VOID ShowBoundCols( HWND );
	pascal LPBOUND	* LplpboundFirstFromHstmt(HSTMT hstmt);
	pascal BOOL FreeParamsAndCols(UWORD fWhat, HSTMT hstmt);
	pascal VOID DeleteBound(LPBOUND	* lplpbound);
	pascal VOID ExtendedFetch( HWND );
	pascal VOID DisplayExtendedFetch(RETCODE retcode, UWORD fFetchType,
			SDWORD irow, UDWORD *lpcrow, UWORD *lrgfRowStatus);
	pascal BOOL ExtendedFetchDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID GetData( HWND );
	pascal BOOL GetDataDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID DisplayGetData(RETCODE retcode, SWORD fCType,
			HPVOID hrgbValue, SDWORD cbValueMax, SDWORD *lpcbValue );
	pascal HPVOID AllocateBuffer( BOOL fNull_rgbBuf, SDWORD cbBuf);
	pascal BOOL FDisplayCbAndRgbArgs(	RETCODE retcode, UWORD fModes, SWORD fCType,
										LPBYTE lsz_apcb, PTR lpcb, SDWORD cbMax,
										LPBYTE lsz_rgb, HPBYTE hrgb );
	pascal VOID DisplayOutputBuf(
			SWORD fCType, HPVOID hrgbValue, SDWORD cbTouched);
	pascal VOID Untouch(HPVOID hrgb, SDWORD cb );
	pascal SDWORD CbTouchedRgbCbMax(HPVOID hrgb, SDWORD cb );
	pascal VOID  DisplayString(
			HWND, HPBYTE hsz, SDWORD cbTouched, UWORD fModes );
	pascal UWORD CchGetStringDisplay(LPBYTE lszOut, UWORD cbOutMax,
			HPBYTE hszIn, SDWORD cbTouched, UWORD fModes );
	pascal VOID StringDisplayCommon(TSD * ptsd,
			HPBYTE hsz, SDWORD cbTouched, UWORD fModes );
	pascal VOID TakeStringDisplay(TSD * ptsd, LPBYTE lsz );
	
		// misc.c:
	
	pascal VOID Transact( HWND );
	pascal BOOL TransactDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID Error( HWND );
	pascal BOOL ErrorDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID AllErrors();
	pascal VOID DisplayError(RETCODE retcode,
			UCHAR	* lszSqlState,
			SDWORD	* lpfNativeError,
			UCHAR	* lszErrorMsg,
			SWORD cbErrorMsgMax,
			SWORD	* lpcbErrorMsg);
	pascal VOID CheckSqlState(UCHAR	* lszSqlstate);
	pascal VOID SetOption(HWND, BOOL fConnect);
	pascal BOOL SetOptionDlg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	pascal VOID GetOption(HWND, BOOL fConnect);
	pascal VOID SetScrollOptions( HWND );
	pascal VOID SetPos( HWND );
	pascal BOOL FCheckArg(LPBYTE lszVarName,
			BOOL fUntouched, BOOL fExpectUntouched, BOOL fVerbose);
	pascal VOID DisplayUntouchedError(
			LPBYTE lszVarName, BOOL fUntouched, BOOL fExpectUntouched);
	pascal VOID DisplayBytesUntouchedError(
			LPBYTE lszVarName, SDWORD cbTouched, SDWORD cbExpect);
	pascal VOID TraceMsg(
			HWND hdlg, unsigned message, WORD wParam, LONG lParam );
	
		// autotest.c:
	
	pascal BOOL FAllocAutoTest( BOOL fAlloc);
	pascal VOID AutoTest( HWND );
	
		// dda.c:
	
	pascal VOID GetFunctions( HWND );
	pascal VOID DisplayGetFunctions(RETCODE retcode, UWORD fFunction,
			BOOL fNull_pfFuncResult, BOOL fExists);
	pascal VOID GetFunctionsAll( HWND );
	pascal VOID GetTypeInfo( HWND );
	pascal VOID  ColAttributes( HWND );
	pascal VOID DisplayColAttributes(
			RETCODE retcode, UWORD icol, UWORD fDescType, LPBYTE lrgbDesc,
			SWORD cbDescMax, SWORD	* lpcbDesc, SDWORD	* lpfDesc);
	pascal VOID Tables( HWND );
	pascal VOID Columns( HWND );
	pascal VOID Statistics( HWND );
	pascal VOID PrimaryKeys( HWND );
	pascal VOID ForeignKeys( HWND );
	pascal VOID TablePrivileges( HWND );
	pascal VOID ColumnPrivileges( HWND );
	pascal VOID SpecialColumns( HWND );
	pascal VOID Procedures( HWND );
	pascal VOID ProcedureColumns( HWND );
	pascal VOID GeneralDDA( HWND, DDAFUN CSCONST *pddafun );
	pascal LPISA LpisaInitISA();
	pascal LPISA LpisaCreateISA( BOOL fNull, SWORD cbMax, SWORD cbDefault, SWORD cb );
	pascal VOID ReplaceISA( LPLPISA Dest, LPISA Source );
	pascal VOID ReleaseISA( LPISA lpisa );
	pascal VOID DisplayISAs( LPSTR szName, LPISA lpisa );
	pascal VOID DisplayInputStringSzArg( HWND, LPISA lpisa, BOOL fAlone );
	pascal VOID GetInputStringSzArgDisplay(	char *szBuf, UWORD cbOutMax, LPISA lpisa );
	pascal BOOL FCheckISAs( HWND hdlg, int idc_sz, int idc_cb,
							LPBYTE lszName, BYTE	rgfCombo[2] );
	pascal BOOL FProcInputStringSzArgMsg(
			UWORD fSelections, HWND hdlg, int idc, WORD message,
			LPLPISA lplpisa, LPBYTE lpfCombo );
	pascal BOOL FProcInputPointerArgMsg( HWND hdlg, int idc, WORD message,
			BOOL *pfNum, SDWORD * pudwValue, BYTE *pfCombo );
	pascal BYTE FInitInputFlagArg(
			FINFO	* lpfinfo, HWND hdlg, int idc, SDWORD fArg );
	pascal BOOL FProcInputFlagArgMsg(FINFO	* lpfinfo,
			HWND hdlg, int idc, WORD message, LPBYTE lpfCombo, PTR lpfArg );
	pascal BOOL FCheckInputFlagArg(
			HWND hdlg, int idc, LPBYTE lszName, BYTE fCombo );
	pascal LPBYTE LszParseTextFlagArg(FINFO	* lpfinfo, PTR lpfArg );
	pascal VOID SetDlgItemFlagArg( FINFO *lpfinfo,
			HWND hdlg, int idc, BOOL fSelChange, PTR lpfArg );
	pascal LPBYTE LszNameFromFlagArg(FINFO	* lpfinfo, SDWORD fArg );
	pascal BYTE * SzHexConstDisplay(LPBYTE lszName, UDWORD udwValue );
	pascal void HideLightning( HWND );
	pascal void ShowLightning( HWND );
	pascal void OutOfMemory();
	pascal void SetWrap( HWND, BOOL fWrap );
	pascal BOOL FNeedSeparator();
	pascal VOID SeparatorWritten();
	pascal BOOL FAssertFail( LPSTR lszModule, short iLine );

#ifdef QUIET

#define INIT_ASSERT 
#define VAssert(fCond)
#define VSideAssert(fCond) fCond
#define VPanic(expression) expression

#else
	// Assert definitions:

#define INIT_ASSERT \
	static char CSCONST szModule[] = __FILE__; \
	extern BOOL fAssertOn;

	// Define the following macro to replace Windows' DebugBreak function
	// so that CodeView will break right before the next statement instead
	// of inside the code of Windows' DebugBreak function:

	// #define DebugBreak() { _asm int 3 }
#define DebugBreak()

#define VAssert(fCond) \
	{ \
	extern SDWORD sdwError; \
	\
	if (fAssertOn && !(fCond) && FAssertFail(szModule, __LINE__)) \
		DebugBreak(); \
	}

#define VSideAssert(fCond) \
	{ \
	extern SDWORD sdwError; \
	\
	if (!(fCond) && fAssertOn && FAssertFail(szModule, __LINE__)) \
		DebugBreak(); \
	}

/* this is never actually used, I don't know why it is here
#define VAssertBool(fCond) VAssert((fCond) == TRUE || (fCond) == FALSE)
*/

#define VPanic(expression) \
	{ \
	extern SDWORD sdwError; \
	\
	expression; \
	if (fAssertOn && FAssertFail(szModule, __LINE__)) \
		DebugBreak(); \
	}

	/* this is never actually used, I don't know why it's here
#ifdef NOT_YET

#define VUntested() \
	{ \
	if (fAssertOn && FDoUntested(szModule, __LINE__)) \
		DebugBreak(); \
	}

#endif // NOT_YET
*/

#endif // QUIET
