
	//
	//  PROGRAM: auto.c
	//	     Pending Copyright (C) 1992 Microsoft Corp.
	//
	//  PURPOSE: This is a Quick Test of the general functionality of a SQL
	//  driver.
	//           Core functions are tested.
	//
	//  FUNCTIONS:
	//	    AutoTest() - performs the quick test
	//     AutoTestDlg() - displays autotest selection dialog
	//
	//  FUNCTION: SQLQuickTest(Pointer to ServerStruct)
	//
	//  PURPOSE:  Processes messages
	//

#define ODBC_STRING_DEFINITIONS
#include "gator.h"

#include "auto.h"
#include "autotest.h"
#include "adhoc.h"
#include "menus.h"
#include <setjmp.h>

#ifdef MACINTOSH
#include <dos.h>			// mj
#endif MACINTOSH

	static char CSCONST szAppName[] = "ODBC Test";

	extern HDBC hdbc;

pascal struct dostime_t * CElapsed(	struct dostime_t *start, 
									struct dostime_t *end,
									struct dostime_t *elapsed )
{
#ifndef QUIET
	char szNum[ 100 ];
	
	szWrite( "Elapsed...", TRUE );
	szWrite( "StartTime: ", FALSE );
	wsprintf ( szNum, "%02d:%02d:%02d.%02d", 
					(int)start->hour, (int)start->minute, (int)start->second, 
					(int)start->hsecond );
	szWrite( szNum, TRUE );

	szWrite( "FinishTime: ", FALSE);
	wsprintf( szNum, "%02d:%02d:%02d.%02d", 
					(int)end->hour, (int)end->minute, (int)end->second, 
					(int)end->hsecond );
	szWrite( szNum, TRUE );
#endif

	if( start->hour > end->hour )
		end->hour += 24;
	elapsed->hour = end->hour - start->hour;

	if( start->minute > end->minute )
	{
		elapsed->hour--;
		end->minute += 60;
	}
	elapsed->minute = end->minute - start->minute;

	if( start->second > end->second )
	{
		elapsed->minute--;
		end->second += 60;
	}
	elapsed->second = end->second - start->second;

	if( start->hsecond > end->hsecond )
	{
		elapsed->second--;
		end->hsecond += 100;
	}
	elapsed->hsecond = end->hsecond-start->hsecond;
		
#ifndef QUIET
	szWrite( "ElapsedTime: ", FALSE);
	wsprintf( szNum, "%02d:%02d:%02d.%02d", 
				(int)elapsed->hour,		(int)elapsed->minute,
				(int)elapsed->second,	(int)elapsed->hsecond);
	szWrite( szNum, TRUE );
#endif

	return elapsed;
}

pascal struct dostime_t * CAddTime( struct dostime_t *start, 
									struct dostime_t *end,
									struct dostime_t *elapsed )
{
	int diff;

#ifndef QUIET
	char szNum[100];
	
	szWrite( "Adding...", TRUE);
	szWrite( "StartTime: ", FALSE);
	wsprintf( szNum, "%02d:%02d:%02d.%02d", 
		(int)start->hour, (int)start->minute, (int)start->second, 
		(int)start->hsecond);
	szWrite( szNum, TRUE);

	szWrite( "FinishTime: ", FALSE);
	wsprintf( szNum, "%02d:%02d:%02d.%02d", 
		(int)end->hour, (int)end->minute, (int)end->second, 
		(int)end->hsecond);
	szWrite( szNum, TRUE);
#endif

	elapsed->hsecond = start->hsecond + end->hsecond;
	elapsed->second = start->second + end->second;
	elapsed->minute = start->minute + end->minute;
	elapsed->hour = start->hour + end->hour;

	if( start->hsecond > 99 )
	{
		diff = start->hsecond % 100;
		start->second += diff;
		start->hsecond -= 100 * diff;
	}

	if( start->second > 59 )
	{
		diff = start->second % 60;
		start->minute += diff;
		start->second -= 60 * diff;
	}

	if( start->minute > 59 )
	{
		diff = start->minute % 60;
		start->hour += diff;
		start->minute -= 60 * diff;
		}

#ifndef QUIET
	szWrite( "ElapsedTime: ", FALSE );
	wsprintf( szNum, "%02d:%02d:%02d.%02d", 
				(int)elapsed->hour, (int)elapsed->minute, (int)elapsed->second, 
				(int)elapsed->hsecond );
	szWrite( szNum, TRUE );
#endif

 	return elapsed;
}

typedef struct tagMENUTABLE
	{
		UWORD fMenuItem;
		UWORD fODBCFunction;
	} MENUTABLE;

	MENUTABLE CSCONST mt[] =
	{
			// Connect Menu
		IDM_ALLOC_ENV,			SQL_API_SQLALLOCENV, 
		IDM_ALLOC_CONNECT,		SQL_API_SQLALLOCCONNECT, 
		IDM_CONNECT,			SQL_API_SQLCONNECT, 
		IDM_BROWSE_CONNECT,		SQL_API_SQLBROWSECONNECT, 
		IDM_DRIVER_CONNECT,		SQL_API_SQLDRIVERCONNECT, 
		IDM_DISCONNECT,			SQL_API_SQLDISCONNECT, 
		IDM_FREE_CONNECT,		SQL_API_SQLFREECONNECT, 
		IDM_FREE_ENV,			SQL_API_SQLFREEENV, 
		IDM_DATA_SOURCE,		SQL_API_SQLDATASOURCES, 
		IDM_GET_INFO,			SQL_API_SQLGETINFO, 
			// Statement menu
		IDM_ALLOC_STMT,			SQL_API_SQLALLOCSTMT, 
		IDM_PREPARE,			SQL_API_SQLPREPARE, 
		IDM_SET_PARAM,			SQL_API_SQLSETPARAM, 
		IDM_NUM_PARAMS,			SQL_API_SQLNUMPARAMS, 
		IDM_DESCRIBE_PARAM,		SQL_API_SQLDESCRIBEPARAM, 
		IDM_EXECUTE,			SQL_API_SQLEXECUTE, 
		IDM_EXEC_DIRECT,		SQL_API_SQLEXECDIRECT, 
		IDM_SET_CURSOR_NAME,	SQL_API_SQLSETCURSORNAME, 
		IDM_GET_CURSOR_NAME,	SQL_API_SQLGETCURSORNAME, 
		IDM_PARAM_DATA,			SQL_API_SQLPARAMDATA, 
		IDM_PUT_DATA,			SQL_API_SQLPUTDATA, 
		IDM_FREE_STMT,			SQL_API_SQLFREESTMT, 
		IDM_NATIVE_SQL,			SQL_API_SQLNATIVESQL, 
			// Results menu options
		IDM_NUM_RESULT_COLS,	SQL_API_SQLNUMRESULTCOLS, 
		IDM_DESCRIBE_COL,		SQL_API_SQLDESCRIBECOL, 
		IDM_COL_ATTRIBUTES,		SQL_API_SQLCOLATTRIBUTES, 
		IDM_ROW_COUNT,			SQL_API_SQLROWCOUNT, 
		IDM_BIND_COL,			SQL_API_SQLBINDCOL, 
		IDM_FETCH,				SQL_API_SQLFETCH, 
		IDM_EXTENDED_FETCH,		SQL_API_SQLEXTENDEDFETCH, 
		IDM_SET_POS,			SQL_API_SQLSETPOS, 
		IDM_GET_DATA,			SQL_API_SQLGETDATA, 
		IDM_MORE_RESULTS,		SQL_API_SQLMORERESULTS, 
			// Dictionary menu options
		IDM_GET_TYPE_INFO,		SQL_API_SQLGETTYPEINFO, 
		IDM_TABLES,				SQL_API_SQLTABLES, 
		IDM_COLUMNS,			SQL_API_SQLCOLUMNS, 
		IDM_STATISTICS,			SQL_API_SQLSTATISTICS, 
		IDM_PRIMARY_KEYS,		SQL_API_SQLPRIMARYKEYS, 
		IDM_FOREIGN_KEYS,		SQL_API_SQLFOREIGNKEYS, 
		IDM_TABLE_PRIVILEGES,	SQL_API_SQLTABLEPRIVILEGES, 
		IDM_COLUMN_PRIVILEGES,	SQL_API_SQLCOLUMNPRIVILEGES, 
		IDM_SPECIAL_COLUMNS,	SQL_API_SQLSPECIALCOLUMNS, 
		IDM_PROCEDURES,			SQL_API_SQLPROCEDURES, 
		IDM_PROCEDURE_COLUMNS,	SQL_API_SQLPROCEDURECOLUMNS, 
			// Options menu functions
		IDM_SET_CONNECT_OPTION,	SQL_API_SQLSETCONNECTOPTION, 
		IDM_GET_CONNECT_OPTION,	SQL_API_SQLGETCONNECTOPTION, 
		IDM_SET_STMT_OPTION,	SQL_API_SQLSETSTMTOPTION, 
		IDM_GET_STMT_OPTION,	SQL_API_SQLGETSTMTOPTION, 
		IDM_PARAM_OPTIONS,		SQL_API_SQLPARAMOPTIONS, 
		IDM_SET_SCROLL_OPTIONS,	SQL_API_SQLSETSCROLLOPTIONS, 
			// Misc menu functions
		IDM_TRANSACT,			SQL_API_SQLTRANSACT, 
		IDM_CANCEL,				SQL_API_SQLCANCEL, 
		IDM_ERROR,				SQL_API_SQLERROR, 
		IDM_GET_FUNCTIONS,		SQL_API_SQLGETFUNCTIONS, 
			// -1 Terminates
		-1, 0
	};/* mt structure */


pascal void UpdateMenu( HMENU hmenu )
{
	int			i;
	extern BOOL	fDriverMenus;
	SERVERINFO	*lpserverinfo;

	for( i = 0; mt[i].fMenuItem != -1; i++ )
	{
		lpserverinfo = LpserverinfoFromHdbc( hdbc );
		if( lpserverinfo && lpserverinfo->rgbMenuStatus )
			EnableMenuItem( hmenu, mt[i].fMenuItem,
							fDriverMenus
						 && !(lpserverinfo->rgbMenuStatus[ i / 8 ] & 1 << i % 8 )
							? MF_GRAYED : MF_ENABLED );
		else
			EnableMenuItem( hmenu, mt[i].fMenuItem, MF_ENABLED );
	}
	return;
}/* end UpdateMenu */


pascal char * FGetLogFileName( HWND hdlg, char *szFileName, char *szTitle, DWORD f )
{
#pragma unused( f, szTitle, hdlg )		// mj
	static char CSCONST szFilters[] = "Log Files (*.log)\0" "*.log\0";
	static char CSCONST szDefExt[] = "log";

#ifdef CRAP								// mj
	OPENFILENAME	ofn;

	ofn.lStructSize			= sizeof( OPENFILENAME );
	ofn.hwndOwner			= hdlg;
	ofn.lpstrFilter			= szFilters;
	ofn.lpstrCustomFilter	= NULL;
	ofn.nFilterIndex		= 1L;
	ofn.lpstrFile			= szFileName;
	ofn.nMaxFile			= SZSIZE;
	ofn.lpstrFileTitle		= NULL;
	ofn.nMaxFileTitle		= 0;
	ofn.lpstrInitialDir		= NULL;
	ofn.lpstrTitle			= szTitle;
	ofn.Flags				= OFN_CREATEPROMPT | OFN_HIDEREADONLY
							| OFN_NOREADONLYRETURN
							| f;
	ofn.nFileOffset			= 0;
	ofn.nFileExtension		= 0;
	ofn.lpstrDefExt			= szDefExt;
	if( !GetSaveFileName( &ofn ) )
		return NULL;
#endif CRAP

	return szFileName;
}
