
	//
	//  PROGRAM: autotest.c
	//	     (C) 1990-1992 Microsoft Corporation.  All right reserved.
	//
	//  PURPOSE: Provides a means for selecting autotests to be run.
	//
	//  FUNCTIONS:
	//	    AutoTest() - performs the quick test
	//     AutoTestDlg() - displays autotest selection dialog
	//
	//  FUNCTION: SQLQuickTest(Pointer to ServerStruct)
	//
	//  PURPOSE:  Processes messages
	//


#include "gator.h"

#define ODBC_STRING_DEFINITIONS
#include "tests.h"

#include "autotest.h"
#include <setjmp.h>
//#include <dos.h>		// mj
//#include "commdlg.h"	// mj

#ifdef MACINTOSH
#include <dos.h>			// mj
#endif MACINTOSH

static char CSCONST szAppName[] = "ODBC Test";
static char CSCONST szAutotest[] = "Auto_Test";
static char CSCONST szGatorIni[] = "gator.ini";
static char CSCONST szOOM[] = "Insufficent Memory to run the autotest";
static char CSCONST szNowExecute[]= "Now Executing:  ";
static char CSCONST szSourceMsg[] = "Source:  ";
static char CSCONST szTestAborted[] = " - The test run was aborted.";
static char CSCONST szLoginIni[] = "Problem reading login information from Initialization file";
static char CSCONST szCompleted[] = " completed.";
static char CSCONST szNoFailures[] = "No failures!";
static char CSCONST szAborted[] = " aborted.";
static char CSCONST szExecutionTime[] = "Total Execution Time: ";
static char CSCONST szServer0[] = "Server0";
static char CSCONST szServer1[] = "Server1";
static char CSCONST szLogin0[] = "Login0";
static char CSCONST szLogin1[] = "Login1";
static char CSCONST szPassword0[] = "Password0";
static char CSCONST szPassword1[] = "Password1";
static char CSCONST szQuery0[] = "Query0";
static char CSCONST szParamQuery0[] = "ParamQuery0";
static char CSCONST szParam0[] = "Param0";
static char CSCONST szDrivers[] = "SQL_DRIVERS";
static char CSCONST szDriverErr[] = "Cannot read driver list from Initialization file";
static char CSCONST szQuick[] = "QuickTest";
static char CSCONST szAll[] = "All";
static char CSCONST szNull[] = "";

#define MAX_SOURCESTR 2048

#define TOTAL_SOURCES 10

static BOOL DlgLog    = FALSE;
static BOOL DlgScreen = TRUE;

	// array of maps for each catagory
static long FAR * lrgfStatus;
static long FAR * lrgfStatusSave;

	// array of catagories currently selected
static int FAR * lrgiCat;

char FAR * szLogFileName = NULL;

	// array of sources currently selected
	// note: if modifications to the win.ini occur while app is running
	// this will be screwed up
static int FAR * lrgiSource;

static BOOL fIsolateTests = TRUE;
/*
typedef	struct	tagTESTLIST {
	char FAR *sz;
	char FAR *szDesc;
}	TESTLIST;
*/
typedef struct  tagCATAGORYLIST {
	char FAR *sz;
	pascal void	( * func)(struct ServerStruct *);
	pascal int	( * funcDesc)(int, char FAR *, char FAR *);
	char FAR *szDesc;
	}  CATAGORYLIST;


pascal struct dostime_t * CElapsed( struct dostime_t *start,
							struct dostime_t *end, struct dostime_t *elapsed );
pascal void LbAllEntry( HWND hdlg,int fDlgItem );
pascal void UpdateTestList( HWND hdlg );
pascal void SetTestDescription( HWND hdlg );
pascal void SetCatDescription( HWND hdlg );

static char CSCONST szRunAll[]			= "Run all tests";
static char CSCONST sz_QuickTests[]		= "QuickTests";
static char CSCONST szQuickTestsDesc[]	= "Tests that run quickly";
static char CSCONST szGatorsHDBC[]		= "ODBC Test hdbc";
// This initializer uses far string arrays from odbcstr.h:
//
#define InitCatagorylist(name, szDesc) \
	{&sz_ ## name[3], Test ## name, Test ## name ## Desc, szDesc}

static CATAGORYLIST CSCONST catl[] = {
	{sz_QuickTests, QuickTests, QuickTestsDesc, szQuickTestsDesc},
	NULL
	};

#define TOTAL_CATAGORIES (sizeof catl) / sizeof( CATAGORYLIST )

static char FAR *szSourceList = NULL;

pascal BOOL AutoTestDlg( HWND, unsigned, WORD, long );

pascal BOOL FAllocAutoTest( BOOL fAlloc )
{
	static char CSCONST szInitFile[] = "AUTOTEST.LOG";
	int i;

	if( !fAlloc) {
		ReleaseMemory(szLogFileName);
		ReleaseMemory(lrgfStatus);
		ReleaseMemory(lrgiSource);
		return TRUE;
	}

	szLogFileName = LockMemory(AllocateMemory(SZSIZE));
	lstrcat(szLogFileName, szInitFile);

	if( (lrgfStatus = LockMemory(AllocateMemory(2 * MASKSIZE *
		sizeof(long) * TOTAL_CATAGORIES
		+ (1 + TOTAL_CATAGORIES) * sizeof( int)))) == NULL)
		return FALSE;
	
	lrgiSource = LockMemory(AllocateMemory(2 * sizeof(int)));
	lrgiSource[0] = 0;
	lrgiSource[1] = -1;

	for(i = 0 ; i < 2 * MASKSIZE * TOTAL_CATAGORIES ; i++)
		lrgfStatus[i] = 0xffffffff;
	
	lrgfStatusSave = &lrgfStatus[MASKSIZE * TOTAL_CATAGORIES];

	lrgiCat = (int FAR *)&lrgfStatusSave[MASKSIZE * TOTAL_CATAGORIES];
	lrgiCat[0] = 0;
	lrgiCat[1] = -1;

	return TRUE;
} 


pascal void AutoTest( HWND hwnd )
{
	int					icat;
	int					w,i,j;
	int					isource;
	int					cTotalErrors=0;
	jmp_buf				envAutotest;
	struct ServerStruct	TestSource;
	OFSTRUCT			FileStruct;
	int					cch;
	char FAR			*szSource;
	struct dostime_t	finish;
	struct dostime_t	start;
	struct dostime_t	elapsed;
	char				szNum[ 20 ];
	long				fMask[ MASKSIZE ];

	extern HCURSOR		hSaveCursor;
	extern HCURSOR		hHourGlass;
	extern HDBC			hdbc;
	extern HENV			henv;


	szSourceList = LockMemory( AllocateMemory( MAX_SOURCESTR ) );  

	if( FDoDialogBox( szAutotest, hwnd, AutoTestDlg )) {
		ReleaseMemory( szSourceList );
		return;
	}


		// Change cursor to hourglass
		//
	SetCapture( hwnd );
//	hSaveCursor = SetCursor( hHourGlass );	// mj

	if( DlgLog )
	{
		if( setjmp( envAutotest ) != 0 )
		{
			ControlSzWrite( ENABLE, DISABLE );
			szWrite( szTestAborted, TRUE );
			goto Done;
		}
		ControlSzWrite( SAME, FControlWriteLog( envAutotest ) ? ENABLE : SAME );
	}
	if( !DlgScreen )
		ControlSzWrite( DISABLE, SAME );

	TestSource.hwnd = hwnd;
	
	for( isource = 0; lrgiSource[ isource ] > -1; isource++ ) {
		if( lrgiSource[ isource ] ) {
			for( w = 1,szSource = szSourceList; w < lrgiSource[ isource ]; w++,
				szSource =& szSource[ lstrlen( szSource )+1 ] );

			lstrcpy( TestSource.szSource, szSource );
			OpenFile( szGatorIni, &FileStruct, OF_EXIST );
			cch = GetPrivateProfileString( szSource, szServer0, szNull,
				TestSource.szValidServer0, 20, FileStruct.szPathName );
			if( *TestSource.szValidServer0 == NULL ) {
				szWrite( szLoginIni, TRUE );
				goto Done;
			}
			cch = GetPrivateProfileString( szSource, szServer1, szNull,
				TestSource.szValidServer1, 20, FileStruct.szPathName );
			cch = GetPrivateProfileString( szSource, szLogin0, szNull,
				TestSource.szValidLogin0, 20, FileStruct.szPathName );
			cch = GetPrivateProfileString( szSource, szLogin1, szNull,
				TestSource.szValidLogin1, 20, FileStruct.szPathName);
			cch = GetPrivateProfileString( szSource, szPassword0, szNull,
				TestSource.szValidPassword0, 20, FileStruct.szPathName );
			cch = GetPrivateProfileString( szSource, szPassword1,
				szNull, TestSource.szValidPassword1, 20,
				FileStruct.szPathName );
			cch = GetPrivateProfileString( szSource, szQuery0, szNull,
				TestSource.szValidQuery0, 200, FileStruct.szPathName );
			cch = GetPrivateProfileString( szSource, szParamQuery0,
				szNull, TestSource.szParamQuery0, 300, FileStruct.szPathName );
			cch = GetPrivateProfileString( szSource, szParam0, szNull,
				TestSource.szParam0, 200, FileStruct.szPathName );
			TestSource.hdbc = NULL;
			TestSource.henv = NULL;
		} else {
			szSource = szGatorsHDBC;
			TestSource.hdbc	= hdbc;
			TestSource.henv	= henv;
			*TestSource.szSource			= '\0';
			*TestSource.szValidServer0		= '\0';
			*TestSource.szValidServer1		= '\0';
			*TestSource.szValidLogin0		= '\0';
			*TestSource.szValidLogin1		= '\0';
			*TestSource.szValidPassword0	= '\0';
			*TestSource.szValidPassword1	= '\0';
		}
		for( i = 0; i < TOTAL_CATAGORIES - 1 ; i++ ) {
			if( lrgiCat[0] == 0 )
				icat = i;
			else {
				if( lrgiCat[i] == -1 )
					break;
				else
					icat = lrgiCat[i] -1;
			}
			
			TestSource.cErrors = 0;
			TestSource.cStateErrors = 0;

			if( !DlgScreen )
				ControlSzWrite(ENABLE, SAME);

			szWrite( szNowExecute,		FALSE );
			szWrite( catl[ icat ].sz,	TRUE );
			szWrite( szSourceMsg,		FALSE );
			szWrite( szSource,			TRUE );

			_dos_gettime( &start );
			wsprintf( OutStr, "Time Started: %02d:%02d:%02d.%02d",
				(int)start.hour, (int)start.minute, (int)start.second,
				(int)start.hsecond );
			szWrite( OutStr, TRUE );

			if( !DlgScreen )
				ControlSzWrite(DISABLE, SAME);

			if(!fIsolateTests ) {
				TestSource.rglMask=&lrgfStatus[icat * MASKSIZE];
				(*catl[icat].func)(&TestSource);
				if( FAbortCheck() ) {
					szWrite( "Aborted", TRUE );
					goto Done;
				}
			} else {
				TestSource.rglMask = fMask;
				for( j = 0; j < MASKSIZE; j++)
					fMask[j] = 0;

				for( j = 0; (*catl[icat].funcDesc)(j+1, NULL, NULL); j++ )
					if( lrgfStatus[MASKSIZE * icat + j/(8 * sizeof(long))] & 
						1l << j%(sizeof(long) * 8) ) {
						fMask[ j / (8 * sizeof(long)) ] |= 
							1l << j % (sizeof(long) * 8);
						(*catl[icat].func)(&TestSource);
						if(FAbortCheck()) {
							szWrite("**** Auto Test Aborted ****", TRUE);
							goto Done;
						}
						fMask[ j / (8 * sizeof(long)) ] = 0;
					}
			}
			_dos_gettime(&finish);

			if( !DlgScreen)
				ControlSzWrite(ENABLE, SAME);

			wsprintf(OutStr, "Time Finished: %02d:%02d:%02d.%02d",
				(int)finish.hour, (int)finish.minute, (int)finish.second,
				(int)finish.hsecond);
			szWrite(OutStr, TRUE);

			szWrite(catl[icat].sz, FALSE);
			switch(TestSource.cErrors)
			{
			case -1:
				szWrite(szAborted, TRUE);
				break;
			case  0:
				szWrite(szCompleted, TRUE);
				szWrite(szNoFailures,TRUE);
				break;
			case  1:
				szWrite(szCompleted, TRUE);
				wsprintf(OutStr,"%d failure.",TestSource.cErrors);
				szWrite(OutStr,TRUE);
				cTotalErrors += TestSource.cErrors;
				break;
			default:
				szWrite(szCompleted, TRUE);
				wsprintf(OutStr,"%d failures.",TestSource.cErrors);
				szWrite(OutStr,TRUE);
				cTotalErrors += TestSource.cErrors;
				break;
			}

			CElapsed(&start, &finish, &elapsed);

			szWrite(szExecutionTime, FALSE);
			wsprintf(szNum, "%02d:%02d:%02d.%02d", (int)elapsed.hour, (int)elapsed.minute,
				(int)elapsed.second, (int)elapsed.hsecond);
			szWrite(szNum, TRUE);

			if( !DlgScreen)
				ControlSzWrite(DISABLE, SAME);

			szWrite(szNull, TRUE);
			}

		/*report total failures*/
 		if( !DlgScreen)
 			ControlSzWrite(ENABLE, SAME);

		if(cTotalErrors > 0) {
			wsprintf(OutStr,"Total fail count: %d",cTotalErrors);
			szWrite(OutStr,TRUE);
			szWrite(szNull, TRUE);
		}

		if( !DlgScreen)
			ControlSzWrite(DISABLE, SAME);
		}

Done:
	ControlSzWrite(ENABLE, DISABLE);
	if( DlgLog)
		FControlWriteLog(NULL);

	// Reset cursor
	//
	ReleaseMemory(szSourceList);
	SetCursor(hSaveCursor);
	ReleaseCapture();

}


pascal BOOL AutoTestDlg(HWND hdlg, unsigned message, WORD wParam,
	long lParam)
{
	static char CSCONST szRECORD[] = "Trace";
	static char CSCONST szTitle[] = "Trace File Name";
	int fDlgStatus;
	int i;
	int icat;
	int isource;
	int cch;
	char FAR *ich;
	OFSTRUCT FileStruct;
	DWORD nindex;
	int FAR *rgw;
	int FAR *irgw;
	SWORD c;

	switch(message) {
	case WM_INITDIALOG:
		CenterDlg( hdlg );

		_fmemcpy( lrgfStatusSave, lrgfStatus, MASKSIZE * sizeof(long));
		CheckDlgButton(hdlg, IDC_AUTOTEST_LOG, DlgLog ? 1 : 0);
		CheckDlgButton(hdlg, IDC_AUTOTEST_SCREEN, DlgScreen ? 1 : 0);
		CheckDlgButton(hdlg, IDC_AUTOTEST_ISOLATE, fIsolateTests ? 1 : 0);

		OpenFile(szGatorIni, &FileStruct, OF_EXIST);
		cch = GetPrivateProfileString( szDrivers, NULL, szNull,
			szSourceList, MAX_SOURCESTR, FileStruct.szPathName );
		if( !cch ) {
			szWrite( szDriverErr, TRUE );
			fDlgStatus = IDCANCEL;
			goto EndOfDialog;
		}

		SendDlgItemMessage( hdlg, IDC_AUTOTEST_SOURCE, LB_ADDSTRING,
			(WORD)NULL, (long)szGatorsHDBC );

		for( ich = szSourceList; ich - szSourceList < cch; ich += lstrlen(ich)+1)
			SendDlgItemMessage( hdlg, IDC_AUTOTEST_SOURCE, LB_ADDSTRING,
				(WORD)NULL, (long)ich );

		SendDlgItemMessage( hdlg, IDC_AUTOTEST_GROUP, LB_ADDSTRING,
			(WORD)NULL, (long)(LPSTR)szAll );

		for( icat = 0; catl[ icat ].sz != NULL; icat++ )
			SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, LB_ADDSTRING,
				(WORD)NULL, (long)catl[ icat ].sz );

		for( isource = 0; lrgiSource[ isource ] > -1; isource++ )
			SendDlgItemMessage(hdlg, IDC_AUTOTEST_SOURCE, LB_SETSEL, 1,
				lrgiSource[ isource ] );

		for( isource = 0; lrgiCat[ isource ] > -1; isource++ )
			SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, LB_SETSEL, 1,
				lrgiCat[ isource ]);

		nindex = SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, LB_SETTOPINDEX,
			lrgiCat[0], NULL);
		nindex = SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, LB_SETSEL,
			1, lrgiCat[0]);

		SetCatDescription(hdlg);

		nindex = SendDlgItemMessage(hdlg, IDC_AUTOTEST_SOURCE, LB_SETTOPINDEX,
			lrgiSource[0], NULL);

		UpdateTestList(hdlg);
		UpdateWindow(hdlg);

		goto NextMessage;

	case WM_COMMAND:
		switch(wParam) {
		case IDC_AUTOTEST_GROUP:
			switch(HIWORD(lParam)) {
			case LBN_KILLFOCUS:
				SendDlgItemMessage(hdlg, IDC_AUTOTEST_DESCRIPTION,
					WM_SETTEXT, NULL, (long)(LPSTR)szNull);
				break;
			case LBN_SELCHANGE:
				LbAllEntry(hdlg, IDC_AUTOTEST_GROUP);
				UpdateTestList(hdlg);
			case LBN_SETFOCUS:
				SetCatDescription(hdlg);
				break;
				
			}
			break;

		case IDC_AUTOTEST_SELECT:
			switch(HIWORD(lParam)) {
			case LBN_SELCHANGE:

				icat = (int)SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP,
					LB_GETCURSEL, NULL, NULL);
				i = (int)SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
					LB_GETSELCOUNT, NULL, NULL);
				if(!i)
					SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP,
						LB_SETSEL, 0, (long)icat);
				else {
					SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP,
						LB_SETSEL, 1, (long)icat);
					SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP,
						LB_SETSEL, 0, 0);
				}

				SetTestDescription(hdlg);
				LbAllEntry(hdlg, IDC_AUTOTEST_SELECT);

				break;

			case LBN_SETFOCUS:
				SetTestDescription(hdlg);
				break;

			case LBN_KILLFOCUS:

				SendDlgItemMessage(hdlg, IDC_AUTOTEST_DESCRIPTION,
					WM_SETTEXT, NULL, (long)(LPSTR)szNull);
				icat = (int)SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP,
					LB_GETCURSEL, NULL, NULL);
				if(!icat)
					break;
				else
					icat--;

				if(SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
					LB_GETSEL, 0, NULL)) {
					for(i = 0; i < MASKSIZE; i++)
						lrgfStatus[MASKSIZE * icat + i] = 0xFFFFFFFF;
					break;
				}

					
				rgw = LockMemory(AllocateMemory(TOTAL_TESTS));
				c = (SWORD)SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
					LB_GETSELITEMS, TOTAL_TESTS, (long)rgw);
				for(i = 0; i < MASKSIZE; i++)
					lrgfStatus[MASKSIZE * icat + i]=0l;

				for(i = 0, irgw = rgw; i < c; i++, irgw++)
					lrgfStatus[MASKSIZE * icat + *irgw/(8 * sizeof(long))] |=
						1l << (*irgw - 1) % (sizeof(long) * 8);
				ReleaseMemory(rgw);

				break;
			}
			break;
			
		case IDOK:
			fDlgStatus = IDOK;
			goto EndOfDialog;

		case IDCANCEL:
			fDlgStatus = IDCANCEL;
			goto EndOfDialog;

			}
		}

	// Let Windows Process this event
	//
	return FALSE;

NextMessage:
	return TRUE;

EndOfDialog:
	if(fDlgStatus != IDCANCEL) {
		if((DlgLog = (BOOL) SendDlgItemMessage(hdlg, IDC_AUTOTEST_LOG,
			BM_GETCHECK, NULL, 0L)) == TRUE) {
			if(!FGetLogFileName(hdlg, szLogFileName, szTitle, 0L)) {
				CheckDlgButton(hdlg, IDC_AUTOTEST_LOG, FALSE);
				return TRUE;
			}
		}
		
		DlgScreen = (BOOL) SendDlgItemMessage(hdlg, IDC_AUTOTEST_SCREEN,
			BM_GETCHECK, 0, 0);
		fIsolateTests = (BOOL) SendDlgItemMessage(hdlg, IDC_AUTOTEST_ISOLATE,
			BM_GETCHECK, 0, 0);

		ReleaseMemory(lrgiSource);
		c = (SWORD)SendDlgItemMessage(hdlg, IDC_AUTOTEST_SOURCE, LB_GETSELCOUNT,
			NULL, NULL);
		lrgiSource = LockMemory(AllocateMemory((c+1) * sizeof(int) ));
		SendDlgItemMessage(hdlg, IDC_AUTOTEST_SOURCE, LB_GETSELITEMS,
			c, (long)lrgiSource);
		lrgiSource[c] = -1;


		c = (SWORD)SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, LB_GETSELCOUNT,
			NULL, NULL);
		SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, LB_GETSELITEMS,
			TOTAL_CATAGORIES * sizeof( int), (long)lrgiCat);
		lrgiCat[c] = -1;

		} else
			_fmemcpy(lrgfStatus, lrgfStatusSave, MASKSIZE * sizeof(long));

	EndDialog(hdlg, fDlgStatus);
	return TRUE;
}

pascal void LbAllEntry(HWND hdlg, int fDlgItem)
{
	int i, w;
	
	i = (int)SendDlgItemMessage(hdlg, fDlgItem,
		LB_GETCURSEL, NULL, NULL);
	w=(int)SendDlgItemMessage(hdlg, fDlgItem,
			LB_GETSEL, i, NULL);
	if(w) {
		if(!i) {
			SendMessage(hdlg, WM_SETREDRAW, FALSE, 0);
			w = (int)SendDlgItemMessage(hdlg, fDlgItem, LB_GETCOUNT, NULL,
				NULL);
			for(i = 1; i <= w; i++)
				SendDlgItemMessage(hdlg, fDlgItem,
					LB_SETSEL, 0, (long)i);
			SendMessage(hdlg, WM_SETREDRAW, TRUE, 0);
			InvalidateRect(GetDlgItem(hdlg, fDlgItem), NULL, TRUE);
		} else 
		SendDlgItemMessage(hdlg, fDlgItem, LB_SETSEL, 0, (long)0);
	}
}

pascal void UpdateTestList( HWND hdlg )
{
int icat, i;
char sz[OUTSTRLEN];
BOOL fAll;
BOOL fFirst=TRUE;
HWND hdlgSelect;

	SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
		LB_RESETCONTENT, NULL, NULL);

	icat = (int)SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP, 
		LB_GETCURSEL, NULL, NULL);

	if(!icat) {
		SendDlgItemMessage(hdlg, IDC_AUTOTEST_CATNAME, WM_SETTEXT,
			NULL, (long)(LPSTR)szAll);
		return;
	} else
		icat--;

	SendDlgItemMessage(hdlg, IDC_AUTOTEST_CATNAME, WM_SETTEXT,
		NULL, (long)catl[icat].sz);

	SendMessage(hdlgSelect = GetDlgItem(hdlg, IDC_AUTOTEST_SELECT),
		WM_SETREDRAW, FALSE, 0);
	for(i = 1; (*catl[icat].funcDesc)(i, sz, NULL); i++)
		SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
			LB_ADDSTRING, NULL, (long)(LPSTR)sz);
	SendMessage(hdlgSelect, WM_SETREDRAW, TRUE, 0);


	for(i = 0, fAll = TRUE; fAll && i < MASKSIZE; i++)
		fAll = lrgfStatus[MASKSIZE * icat + i] == 0xffffffff;
						
	SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
		LB_INSERTSTRING, 0, (long)(LPSTR)szAll);

	if(!fAll)
		for(i = 0; i < TOTAL_TESTS; i++)
			if(lrgfStatus[MASKSIZE * icat + i/(8 * sizeof(long))] & 
				1l << i%(sizeof(long) * 8)) {
				SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
					LB_SETSEL, 1, (long)i + 1);
				if(fFirst) {
					SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
						LB_SETTOPINDEX, i + 1, NULL);
					fFirst = FALSE;
				}
			}

	if(fAll)
		SendDlgItemMessage(hdlg, IDC_AUTOTEST_SELECT,
		LB_SETSEL, 1, 0);

	return;
}

pascal void SetTestDescription( HWND hdlg )
{
	int icat;
	int i;
	char szDesc[OUTSTRLEN];
			
				icat = (int)SendDlgItemMessage(hdlg, IDC_AUTOTEST_GROUP,
					LB_GETCURSEL, NULL, NULL );
				if( !icat )
					return;
				else
					icat--;

				i = (int)SendDlgItemMessage( hdlg, IDC_AUTOTEST_SELECT,
					LB_GETCURSEL, NULL, NULL );

				if( i ) {
					(*catl[icat].funcDesc)(i, NULL, szDesc );
					SendDlgItemMessage(hdlg, IDC_AUTOTEST_DESCRIPTION,
						WM_SETTEXT, NULL, (long)(LPSTR)szDesc );
				} else
					SendDlgItemMessage(hdlg, IDC_AUTOTEST_DESCRIPTION,
						WM_SETTEXT, NULL, (long)(LPSTR)szRunAll );


				return;
}


pascal void SetCatDescription( HWND hdlg )
{
	int		icat;

	icat = (int)SendDlgItemMessage( hdlg, IDC_AUTOTEST_GROUP,
		LB_GETCURSEL, NULL, NULL );
	
	if( !icat )
		SendDlgItemMessage( hdlg, IDC_AUTOTEST_DESCRIPTION,
			WM_SETTEXT, NULL,
			(long)(LPSTR)szRunAll );
	else SendDlgItemMessage( hdlg, IDC_AUTOTEST_DESCRIPTION,
			WM_SETTEXT, NULL, (long)catl[icat - 1].szDesc );
}
