
	// This module implements the functions in the Connect
	// menu which require dialogs.


#include <Quickdraw.h>
#include <types.h>
#include "gator.h"
#include "adhoc.h"
#include "connect.h"
#include <ctype.h>

#include <dos.h>			// mj

#pragma segment connect

	INIT_ASSERT

#define MIN(x,y)	( (x) <= (y) ? (x) : (y) )
#define MAX(x,y)	( (x) >= (y) ? (x) : (y) )

	extern char OutStr[ OUTSTRLEN ];	// One global OutStr!
	extern HCURSOR hSaveCursor;
	extern HCURSOR hHourGlass;

		// These are uneditable input values:
	extern HENV  henv;
	extern HDBC  hdbc;
	extern UWORD idbc;
	extern HSTMT hstmt;


	extern UWORD fInfoType;
	extern SWORD cbInfoValueMax;
//	extern UWORD fDirection;
	extern SWORD cbDSNMax;
	extern SWORD cbDescriptionMax ;
	extern BOOL  fNull_henv;
	extern BOOL  fNull_phenv;
	extern BOOL  fNull_phdbc;
	extern BOOL  fNull_rgbInfoValue;
	extern BOOL  fNull_pcbInfoValue ;
	extern BOOL  fNull_szDSN;
	extern BOOL  fNull_pcbDSN;
	extern BOOL  fNull_szDescription;
	extern BOOL  fNull_pcbDescription;

		// These values are needed only between <func> and <func>Dlg:
	extern BOOL fDriverConnect;

		// Constants in storage:
	static BYTE CSCONST szNullString[]    = "";
	static BYTE CSCONST szSpace[]         = " ";
	static BYTE CSCONST szEqual[]         = " = ";
	static BYTE CSCONST szColon[]         = ": ";
	static BYTE CSCONST szComma[]         = ", ";
	static BYTE CSCONST szPeriod[]        = ".";
	static BYTE CSCONST sz_NULL[]         = "NULL";
	static BYTE CSCONST sz_VALID[]        = "VALID";
	static BYTE CSCONST sz_DSNequal[]     = "DSN=";
	static BYTE CSCONST sz_Error[]        = "***Error*** ";
	static BYTE CSCONST szNotEqual[]      = " != ";
	static BYTE CSCONST szFormatSSError[] = "%s%s!";
	static BYTE CSCONST szFormatHex[]     = "0x%08lX";

	static BYTE CSCONST sz_DSN[]          = "DSN";
	static BYTE CSCONST sz_UID[]          = "UID";
	static BYTE CSCONST sz_AuthStr[]      = "AuthStr";
	static BYTE CSCONST sz_fInfoType[]    = "fInfoType";
//	static BYTE CSCONST sz_fDirection[]   = "fDirection";
	static BYTE CSCONST sz_rgbInfoValue[] = "rgbInfoValue";

	pascal VOID DisplayInfoValueMask( PTR lrgbInfoValue );
	pascal VOID DisplayInfoValueInt( PTR lrgbInfoValue );

	// fDriverCompletion values:

static FNAM CSCONST rgfnam_fDriverCompletion[] =
	{
		{ SQL_DRIVER_NOPROMPT,			sz_SQL_DRIVER_NOPROMPT			},
		{ SQL_DRIVER_COMPLETE,			sz_SQL_DRIVER_COMPLETE			},
		{ SQL_DRIVER_PROMPT,			sz_SQL_DRIVER_PROMPT			},
		{ SQL_DRIVER_COMPLETE_REQUIRED,	sz_SQL_DRIVER_COMPLETE_REQUIRED	}
	};

	DeclareFinfo( fDriverCompletion, "SQL_", FINFO_UWORD, static );


	// fInfoType values:

static FNAM CSCONST rgfnam_fInfoType[] =
	{
		{ SQL_ACTIVE_CONNECTIONS,		sz_SQL_ACTIVE_CONNECTIONS		},
		{ SQL_ACTIVE_STATEMENTS,		sz_SQL_ACTIVE_STATEMENTS		},
		{ SQL_DATA_SOURCE_NAME,			sz_SQL_DATA_SOURCE_NAME			},
		{ SQL_DRIVER_HDBC,				sz_SQL_DRIVER_HDBC				},
		{ SQL_DRIVER_HENV,				sz_SQL_DRIVER_HENV				},
		{ SQL_DRIVER_HSTMT,				sz_SQL_DRIVER_HSTMT				},
		{ SQL_DRIVER_NAME,				sz_SQL_DRIVER_NAME				},
		{ SQL_DRIVER_VER,				sz_SQL_DRIVER_VER				},
		{ SQL_FETCH_DIRECTION,			sz_SQL_FETCH_DIRECTION			},
		{ SQL_ODBC_API_CONFORMANCE,		sz_SQL_ODBC_API_CONFORMANCE		},
		{ SQL_ODBC_VER,					sz_SQL_ODBC_VER					},
		{ SQL_ROW_UPDATES,				sz_SQL_ROW_UPDATES				},
		{ SQL_ODBC_SAG_CLI_CONFORMANCE,	sz_SQL_ODBC_SAG_CLI_CONFORMANCE	},
		{ SQL_SERVER_NAME,				sz_SQL_SERVER_NAME				},
		{ SQL_SEARCH_PATTERN_ESCAPE,	sz_SQL_SEARCH_PATTERN_ESCAPE	},
		{ SQL_ODBC_SQL_CONFORMANCE,		sz_SQL_ODBC_SQL_CONFORMANCE		},
		{ SQL_DATABASE_NAME,			sz_SQL_DATABASE_NAME			},
		{ SQL_DBMS_NAME,				sz_SQL_DBMS_NAME				},
		{ SQL_DBMS_VER,					sz_SQL_DBMS_VER					},
		{ SQL_ACCESSIBLE_TABLES,		sz_SQL_ACCESSIBLE_TABLES		},
		{ SQL_ACCESSIBLE_PROCEDURES,	sz_SQL_ACCESSIBLE_PROCEDURES	},
		{ SQL_PROCEDURES,				sz_SQL_PROCEDURES				},
		{ SQL_CONCAT_NULL_BEHAVIOR,		sz_SQL_CONCAT_NULL_BEHAVIOR		},
		{ SQL_CURSOR_COMMIT_BEHAVIOR,	sz_SQL_CURSOR_COMMIT_BEHAVIOR	},
		{ SQL_CURSOR_ROLLBACK_BEHAVIOR,	sz_SQL_CURSOR_ROLLBACK_BEHAVIOR	},
		{ SQL_DATA_SOURCE_READ_ONLY,	sz_SQL_DATA_SOURCE_READ_ONLY	},
		{ SQL_DEFAULT_TXN_ISOLATION,	sz_SQL_DEFAULT_TXN_ISOLATION	},
		{ SQL_EXPRESSIONS_IN_ORDERBY,	sz_SQL_EXPRESSIONS_IN_ORDERBY	},
		{ SQL_IDENTIFIER_CASE,			sz_SQL_IDENTIFIER_CASE			},
		{ SQL_IDENTIFIER_QUOTE_CHAR,	sz_SQL_IDENTIFIER_QUOTE_CHAR	},
		{ SQL_MAX_COLUMN_NAME_LEN,		sz_SQL_MAX_COLUMN_NAME_LEN		},
		{ SQL_MAX_CURSOR_NAME_LEN,		sz_SQL_MAX_CURSOR_NAME_LEN		},
		{ SQL_MAX_OWNER_NAME_LEN,		sz_SQL_MAX_OWNER_NAME_LEN		},
		{ SQL_MAX_PROCEDURE_NAME_LEN,	sz_SQL_MAX_PROCEDURE_NAME_LEN	},
		{ SQL_MAX_QUALIFIER_NAME_LEN,	sz_SQL_MAX_QUALIFIER_NAME_LEN	},
		{ SQL_MAX_TABLE_NAME_LEN,		sz_SQL_MAX_TABLE_NAME_LEN		},
		{ SQL_MULT_RESULT_SETS,			sz_SQL_MULT_RESULT_SETS			},
		{ SQL_MULTIPLE_ACTIVE_TXN,		sz_SQL_MULTIPLE_ACTIVE_TXN		},
		{ SQL_OUTER_JOINS,				sz_SQL_OUTER_JOINS				},
		{ SQL_OWNER_TERM,				sz_SQL_OWNER_TERM				},
		{ SQL_PROCEDURE_TERM,			sz_SQL_PROCEDURE_TERM			},
		{ SQL_QUALIFIER_NAME_SEPARATOR,	sz_SQL_QUALIFIER_NAME_SEPARATOR	},
		{ SQL_QUALIFIER_TERM,			sz_SQL_QUALIFIER_TERM			},
		{ SQL_SCROLL_CONCURRENCY,		sz_SQL_SCROLL_CONCURRENCY		},
		{ SQL_SCROLL_OPTIONS,			sz_SQL_SCROLL_OPTIONS			},
		{ SQL_TABLE_TERM,				sz_SQL_TABLE_TERM				},
		{ SQL_TXN_CAPABLE,				sz_SQL_TXN_CAPABLE				},
		{ SQL_USER_NAME,				sz_SQL_USER_NAME				},
		{ SQL_CONVERT_FUNCTIONS,		sz_SQL_CONVERT_FUNCTIONS		},
		{ SQL_NUMERIC_FUNCTIONS,		sz_SQL_NUMERIC_FUNCTIONS		},
		{ SQL_STRING_FUNCTIONS,			sz_SQL_STRING_FUNCTIONS			},
		{ SQL_SYSTEM_FUNCTIONS,			sz_SQL_SYSTEM_FUNCTIONS			},
		{ SQL_TIMEDATE_FUNCTIONS,		sz_SQL_TIMEDATE_FUNCTIONS		},
		{ SQL_CONVERT_BIGINT,			sz_SQL_CONVERT_BIGINT			},
		{ SQL_CONVERT_BINARY,			sz_SQL_CONVERT_BINARY			},
		{ SQL_CONVERT_BIT,				sz_SQL_CONVERT_BIT				},
		{ SQL_CONVERT_CHAR,				sz_SQL_CONVERT_CHAR				},
		{ SQL_CONVERT_DATE,				sz_SQL_CONVERT_DATE				},
		{ SQL_CONVERT_DECIMAL,			sz_SQL_CONVERT_DECIMAL			},
		{ SQL_CONVERT_DOUBLE,			sz_SQL_CONVERT_DOUBLE			},
		{ SQL_CONVERT_FLOAT,			sz_SQL_CONVERT_FLOAT			},
		{ SQL_CONVERT_INTEGER,			sz_SQL_CONVERT_INTEGER			},
		{ SQL_CONVERT_LONGVARCHAR,		sz_SQL_CONVERT_LONGVARCHAR		},
		{ SQL_CONVERT_NUMERIC,			sz_SQL_CONVERT_NUMERIC			},
		{ SQL_CONVERT_REAL,				sz_SQL_CONVERT_REAL				},
		{ SQL_CONVERT_SMALLINT,			sz_SQL_CONVERT_SMALLINT			},
		{ SQL_CONVERT_TIME,				sz_SQL_CONVERT_TIME				},
		{ SQL_CONVERT_TIMESTAMP,		sz_SQL_CONVERT_TIMESTAMP		},
		{ SQL_CONVERT_TINYINT,			sz_SQL_CONVERT_TINYINT			},
		{ SQL_CONVERT_VARBINARY,		sz_SQL_CONVERT_VARBINARY		},
		{ SQL_CONVERT_VARCHAR,			sz_SQL_CONVERT_VARCHAR			},
		{ SQL_CONVERT_LONGVARBINARY,	sz_SQL_CONVERT_LONGVARBINARY	},
		{ SQL_TXN_ISOLATION_OPTION,		sz_SQL_TXN_ISOLATION_OPTION		},
		{ SQL_ODBC_SQL_OPT_IEF,			sz_SQL_ODBC_SQL_OPT_IEF			}
	};
DeclareFinfo( fInfoType, "SQL_", FINFO_UWORD, static );

		// Bitmask Name structs:

	typedef struct
	{
		UDWORD	 fValue;
		LPBYTE	 lszName;
	} BMNAM;

	// fInfoType = SQL_CONVERT_FUNCTIONS rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_FN_CVT[] =
	{
		{ SQL_FN_CVT_CONVERT,	sz_SQL_FN_CVT_CONVERT	}
	};

	// fInfoType = SQL_STRING_FUNCTIONS rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_FN_STR[] =
	{
		{ SQL_FN_STR_CONCAT,	sz_SQL_FN_STR_CONCAT	},
		{ SQL_FN_STR_INSERT,	sz_SQL_FN_STR_INSERT	},
		{ SQL_FN_STR_LEFT,		sz_SQL_FN_STR_LEFT		},
		{ SQL_FN_STR_LTRIM,		sz_SQL_FN_STR_LTRIM		},
		{ SQL_FN_STR_LENGTH,	sz_SQL_FN_STR_LENGTH	},
		{ SQL_FN_STR_LOCATE,	sz_SQL_FN_STR_LOCATE	},
		{ SQL_FN_STR_LCASE,		sz_SQL_FN_STR_LCASE		},
		{ SQL_FN_STR_REPEAT,	sz_SQL_FN_STR_REPEAT	},
		{ SQL_FN_STR_REPLACE,	sz_SQL_FN_STR_REPLACE	},
		{ SQL_FN_STR_RIGHT,		sz_SQL_FN_STR_RIGHT		},
		{ SQL_FN_STR_RTRIM,		sz_SQL_FN_STR_RTRIM		},
		{ SQL_FN_STR_SUBSTRING,	sz_SQL_FN_STR_SUBSTRING	},
		{ SQL_FN_STR_UCASE,		sz_SQL_FN_STR_UCASE		},
		{ SQL_FN_STR_ASCII,		sz_SQL_FN_STR_ASCII		},
		{ SQL_FN_STR_CHAR,		sz_SQL_FN_STR_CHAR		}
	};

// fInfoType = SQL_NUMERIC_FUNCTIONS rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_FN_NUM[] =
	{
		{ SQL_FN_NUM_ABS,		sz_SQL_FN_NUM_ABS		},
		{ SQL_FN_NUM_ACOS,		sz_SQL_FN_NUM_ACOS		},
		{ SQL_FN_NUM_ASIN,		sz_SQL_FN_NUM_ASIN		},
		{ SQL_FN_NUM_ATAN,		sz_SQL_FN_NUM_ATAN		},
		{ SQL_FN_NUM_ATAN2,		sz_SQL_FN_NUM_ATAN2		},
		{ SQL_FN_NUM_CEILING,	sz_SQL_FN_NUM_CEILING	},
		{ SQL_FN_NUM_COS,		sz_SQL_FN_NUM_COS		},
		{ SQL_FN_NUM_COT,		sz_SQL_FN_NUM_COT		},
		{ SQL_FN_NUM_EXP,		sz_SQL_FN_NUM_EXP		},
		{ SQL_FN_NUM_FLOOR,		sz_SQL_FN_NUM_FLOOR		},
		{ SQL_FN_NUM_LOG,		sz_SQL_FN_NUM_LOG		},
		{ SQL_FN_NUM_MOD,		sz_SQL_FN_NUM_MOD		},
		{ SQL_FN_NUM_SIGN,		sz_SQL_FN_NUM_SIGN		},
		{ SQL_FN_NUM_SIN,		sz_SQL_FN_NUM_SIN		},
		{ SQL_FN_NUM_SQRT,		sz_SQL_FN_NUM_SQRT		},
		{ SQL_FN_NUM_TAN,		sz_SQL_FN_NUM_TAN		},
		{ SQL_FN_NUM_PI,		sz_SQL_FN_NUM_PI		},
		{ SQL_FN_NUM_RAND,		sz_SQL_FN_NUM_RAND		}
	};

	// fInfoType = SQL_TIMEDATE_FUNCTIONS rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_FN_TD[] =
	{
		{ SQL_FN_TD_NOW,		sz_SQL_FN_TD_NOW		},
		{ SQL_FN_TD_CURDATE,	sz_SQL_FN_TD_CURDATE	},
		{ SQL_FN_TD_DAYOFMONTH,	sz_SQL_FN_TD_DAYOFMONTH	},
		{ SQL_FN_TD_DAYOFWEEK,	sz_SQL_FN_TD_DAYOFWEEK	},
		{ SQL_FN_TD_DAYOFYEAR,	sz_SQL_FN_TD_DAYOFYEAR	},
		{ SQL_FN_TD_MONTH,		sz_SQL_FN_TD_MONTH		},
		{ SQL_FN_TD_QUARTER,	sz_SQL_FN_TD_QUARTER	},
		{ SQL_FN_TD_WEEK,		sz_SQL_FN_TD_WEEK		},
		{ SQL_FN_TD_YEAR,		sz_SQL_FN_TD_YEAR		},
		{ SQL_FN_TD_CURTIME,	sz_SQL_FN_TD_CURTIME	},
		{ SQL_FN_TD_HOUR,		sz_SQL_FN_TD_HOUR		},
		{ SQL_FN_TD_MINUTE,		sz_SQL_FN_TD_MINUTE		},
		{ SQL_FN_TD_SECOND,		sz_SQL_FN_TD_SECOND		}
	};

	// fInfoType = SQL_SYSTEM_FUNCTIONS rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_FN_SYS[] =
	{
		{ SQL_FN_SYS_USERNAME,	sz_SQL_FN_SYS_USERNAME	},
		{ SQL_FN_SYS_DBNAME,	sz_SQL_FN_SYS_DBNAME	},
		{ SQL_FN_SYS_IFNULL,	sz_SQL_FN_SYS_IFNULL	}
	};

	// fInfoType = SQL_SCROLL_OPTIONS rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_SO[] =
	{
		{ SQL_SO_FORWARD_ONLY,	sz_SQL_SO_FORWARD_ONLY	},
		{ SQL_SO_KEYSET_DRIVEN,	sz_SQL_SO_KEYSET_DRIVEN	},
		{ SQL_SO_DYNAMIC,		sz_SQL_SO_DYNAMIC		},
		{ SQL_SO_MIXED,			sz_SQL_SO_MIXED			}
	};

	// fInfoType = SQL_ODBC_API_CONFORMANCE rgbInfoValue values:

#define ODBC_NONE    0
#define ODBC_LEVEL_1 1
#define ODBC_LEVEL_2 2

static BYTE CSCONST sz_ODBC_NONE[]    = "None";
static BYTE CSCONST sz_ODBC_LEVEL_1[] = "Level 1";
static BYTE CSCONST sz_ODBC_LEVEL_2[] = "Level 2";

static FNAM CSCONST rgfnam_CONFORM_ODBC[] =
	{
		{ ODBC_NONE,	sz_ODBC_NONE	},
		{ ODBC_LEVEL_1,	sz_ODBC_LEVEL_1	},
		{ ODBC_LEVEL_2,	sz_ODBC_LEVEL_2	}
	};

	// fInfoType = SQL_ODBC_SAG_CLI_CONFORMANCE rgbInfoValue values:

#define NOT_SAG_COMPLIANT 0
#define SAG_COMPLIANT     1

static BYTE CSCONST sz_NOT_SAG_COMPLIANT[] = "Not SAG-Compliant";
static BYTE CSCONST sz_SAG_COMPLIANT[]     = "SAG-Compliant";

static FNAM CSCONST rgfnam_CONFORM_SAG[] =
	{
		{ NOT_SAG_COMPLIANT,	sz_NOT_SAG_COMPLIANT	},
		{ SAG_COMPLIANT,		sz_SAG_COMPLIANT		}
	};

	// fInfoType = SQL_ODBC_SQL_CONFORMANCE rgbInfoValue values:

#define CONFORM_SQL_MINIMUM  0
#define CONFORM_SQL_CORE     1
#define CONFORM_SQL_EXTENDED 2

static BYTE CSCONST sz_CONFORM_SQL_MINIMUM[]  = "Minimum";
static BYTE CSCONST sz_CONFORM_SQL_CORE[]     = "Core";
static BYTE CSCONST sz_CONFORM_SQL_EXTENDED[] = "Extended";

static FNAM CSCONST rgfnam_CONFORM_SQL[] =
	{
		{ CONFORM_SQL_MINIMUM,	sz_CONFORM_SQL_MINIMUM	},
		{ CONFORM_SQL_CORE,		sz_CONFORM_SQL_CORE		},
		{ CONFORM_SQL_EXTENDED,	sz_CONFORM_SQL_EXTENDED	}
	};

	// fInfoType = SQL_CONCAT_NULL_BEHAVIOR rgbInfoValue values:

#define CONCAT_NULL     0
#define CONCAT_NOT_NULL 1

static BYTE CSCONST sz_CONCAT_NULL[]     = "NULL";
static BYTE CSCONST sz_CONCAT_NOT_NULL[] = "Non-Null Values";

static FNAM CSCONST rgfnam_CONCAT_NULL[] =
	{
		{ CONCAT_NULL,		sz_CONCAT_NULL		},
		{ CONCAT_NOT_NULL,	sz_CONCAT_NOT_NULL	}
	};

	// fInfoType = SQL_CURSOR_BEHAVIOR rgbInfoValue values:

#define CURSOR_CLOSE_DELETE 0
#define CURSOR_CLOSE_FIRST  1
#define CURSOR_PRESERVED    2

static BYTE CSCONST sz_CURSOR_CLOSE_DELETE[] = "Close/Delete";
static BYTE CSCONST sz_CURSOR_CLOSE_FIRST[]  = "Close/First";
static BYTE CSCONST sz_CURSOR_PRESERVED[]    = "Preserved";

static FNAM CSCONST rgfnam_CURSOR[] =
	{
		{ CURSOR_CLOSE_DELETE,	sz_CURSOR_CLOSE_DELETE	},
		{ CURSOR_CLOSE_FIRST,	sz_CURSOR_CLOSE_FIRST	},
		{ CURSOR_PRESERVED,		sz_CURSOR_PRESERVED		}
	};

	// fInfoType = SQL_DEFAULT_TXN_ISOLATION,
	//             SQL_TXN_ISOLATION_OPTION rgbInfoValue values:

static BMNAM CSCONST rgbmnam_TXN_ISOL[] =
	{
		{ SQL_TXN_READ_UNCOMMITTED,	sz_SQL_TXN_READ_UNCOMMITTED	},
		{ SQL_TXN_READ_COMMITTED,	sz_SQL_TXN_READ_COMMITTED	},
		{ SQL_TXN_REPEATABLE_READ,	sz_SQL_TXN_REPEATABLE_READ	},
		{ SQL_TXN_SERIALIZABLE,		sz_SQL_TXN_SERIALIZABLE		},
		{ SQL_TXN_VERSIONING,		sz_SQL_TXN_VERSIONING		}
	};

	// fInfoType = SQL_IDENTIFIER_CASE rgbInfoValue values:

#define CASE_UPPER               1
#define CASE_LOWER               2
#define CASE_MIXED_SENSITIVE     3
#define CASE_MIXED_NOT_SENSITIVE 4

static BYTE CSCONST sz_CASE_UPPER[]               = "Upper Case";
static BYTE CSCONST sz_CASE_LOWER[]               = "Lower Case";
static BYTE CSCONST sz_CASE_MIXED_SENSITIVE[]     = "Mixed Case/Sensitive";
static BYTE CSCONST sz_CASE_MIXED_NOT_SENSITIVE[] = "Mixed Case/Not Sensitive";

static FNAM CSCONST rgfnam_ID_CASE[] =
	{
		{ CASE_UPPER,				sz_CASE_UPPER				},
		{ CASE_LOWER,				sz_CASE_LOWER				},
		{ CASE_MIXED_SENSITIVE,		sz_CASE_MIXED_SENSITIVE		},
		{ CASE_MIXED_NOT_SENSITIVE,	sz_CASE_MIXED_NOT_SENSITIVE	}
	};

	// fInfoType = SQL_TXN_CAPABLE rgbInfoValue values:

#define TXN_NONE 0
#define TXN_DML  1
#define TXN_DDL  2

static BYTE CSCONST sz_TXN_NONE[] = "No Transactions";
static BYTE CSCONST sz_TXN_DML [] = "DML Transactions";
static BYTE CSCONST sz_TXN_DDL [] = "DDL & DML Transactions";

static FNAM CSCONST rgfnam_TXN_CAPABLE[] =
	{
		{ TXN_NONE,	sz_TXN_NONE	},
		{ TXN_DML,	sz_TXN_DML	},
		{ TXN_DDL,	sz_TXN_DDL	}
	};

	// fInfoType = SQL_FETCH_DIRECTION rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_FD[] =
	{
		{ SQL_FD_FETCH_NEXT,		sz_SQL_FD_FETCH_NEXT		},
		{ SQL_FD_FETCH_FIRST,		sz_SQL_FD_FETCH_FIRST		},
		{ SQL_FD_FETCH_LAST,		sz_SQL_FD_FETCH_LAST		},
		{ SQL_FD_FETCH_PREV,		sz_SQL_FD_FETCH_PREV		},
		{ SQL_FD_FETCH_ABSOLUTE,	sz_SQL_FD_FETCH_ABSOLUTE	},
		{ SQL_FD_FETCH_RELATIVE,	sz_SQL_FD_FETCH_RELATIVE	},
		{ SQL_FD_FETCH_RESUME,		sz_SQL_FD_FETCH_RESUME		}
	};

	// fInfoType = SQL_SCROLL_CONCURRENCY rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_SCCO[] =
	{
		{ SQL_SCCO_READ_ONLY,		sz_SQL_SCCO_READ_ONLY		},
		{ SQL_SCCO_LOCK,			sz_SQL_SCCO_LOCK			},
		{ SQL_SCCO_OPT_TIMESTAMP,	sz_SQL_SCCO_OPT_TIMESTAMP	},
		{ SQL_SCCO_OPT_VALUES,		sz_SQL_SCCO_OPT_VALUES		}
	};

	// fInfoType = SQL_CONVERT_... rgbInfoValue bitmasks:

static BMNAM CSCONST rgbmnam_CVT[] =
	{
		{ SQL_CVT_CHAR,				sz_SQL_CVT_CHAR				},
		{ SQL_CVT_NUMERIC,			sz_SQL_CVT_NUMERIC			},
		{ SQL_CVT_DECIMAL,			sz_SQL_CVT_DECIMAL			},
		{ SQL_CVT_INTEGER,			sz_SQL_CVT_INTEGER			},
		{ SQL_CVT_SMALLINT,			sz_SQL_CVT_SMALLINT			},
		{ SQL_CVT_FLOAT,			sz_SQL_CVT_FLOAT			},
		{ SQL_CVT_REAL,				sz_SQL_CVT_REAL				},
		{ SQL_CVT_DOUBLE,			sz_SQL_CVT_DOUBLE			},
		{ SQL_CVT_VARCHAR,			sz_SQL_CVT_VARCHAR			},
		{ SQL_CVT_LONGVARCHAR,		sz_SQL_CVT_LONGVARCHAR		},
		{ SQL_CVT_BINARY,			sz_SQL_CVT_BINARY			},
		{ SQL_CVT_VARBINARY,		sz_SQL_CVT_VARBINARY		},
		{ SQL_CVT_BIT,				sz_SQL_CVT_BIT				},
		{ SQL_CVT_TINYINT,			sz_SQL_CVT_TINYINT			},
		{ SQL_CVT_BIGINT,			sz_SQL_CVT_BIGINT			},
		{ SQL_CVT_DATE,				sz_SQL_CVT_DATE				},
		{ SQL_CVT_TIME,				sz_SQL_CVT_TIME				},
		{ SQL_CVT_TIMESTAMP,		sz_SQL_CVT_TIMESTAMP		},
		{ SQL_CVT_LONGVARBINARY,	sz_SQL_CVT_LONGVARBINARY	}
	};

typedef struct
{
	UWORD			fInfoType;
	BOOL			fBeginRange;
	BOOL			fIsMask;
	void CSCONST *	pvMin;
	void CSCONST *	pvMax;
} ITBM;

#define fIsMask_bmnam TRUE
#define fIsMask_fnam  FALSE

#define InitItbm( fInfoType, fBeginRange, type, qual )		\
	{	fInfoType, fBeginRange,								\
		fIsMask_ ## type, &rg ## type ## _ ## qual[0],		\
		PmaxFromRg(rg ## type ## _ ## qual)					\
	}

	// The following table MUST be in order by #define of SQL_xxx:

#undef CONCAT_NULL	// mj
static ITBM CSCONST rgitbm[] =
{
	InitItbm(SQL_FETCH_DIRECTION,			FALSE, bmnam, FD),
	InitItbm(SQL_ODBC_API_CONFORMANCE,		FALSE, fnam,  CONFORM_ODBC),
	InitItbm(SQL_ODBC_SAG_CLI_CONFORMANCE,	FALSE, fnam,  CONFORM_SAG),
	InitItbm(SQL_ODBC_SQL_CONFORMANCE,		FALSE, fnam,  CONFORM_SQL),
	InitItbm(SQL_CONCAT_NULL_BEHAVIOR,		FALSE, fnam,  CONCAT_NULL),
	InitItbm(SQL_CURSOR_COMMIT_BEHAVIOR,	FALSE, fnam,  CURSOR),
	InitItbm(SQL_CURSOR_ROLLBACK_BEHAVIOR,	FALSE, fnam,  CURSOR),
	InitItbm(SQL_DEFAULT_TXN_ISOLATION, 	FALSE, bmnam, TXN_ISOL),
	InitItbm(SQL_IDENTIFIER_CASE,			FALSE, fnam,  ID_CASE),
	InitItbm(SQL_SCROLL_CONCURRENCY,		FALSE, bmnam, SCCO),
	InitItbm(SQL_SCROLL_OPTIONS,			FALSE, bmnam, SO),
	InitItbm(SQL_TXN_CAPABLE,				FALSE, fnam,  TXN_CAPABLE),
	InitItbm(SQL_CONVERT_FUNCTIONS, 		FALSE, bmnam, FN_CVT),
	InitItbm(SQL_NUMERIC_FUNCTIONS, 		FALSE, bmnam, FN_NUM),
	InitItbm(SQL_STRING_FUNCTIONS,			FALSE, bmnam, FN_STR),
	InitItbm(SQL_SYSTEM_FUNCTIONS,			FALSE, bmnam, FN_SYS),
	InitItbm(SQL_TIMEDATE_FUNCTIONS,		FALSE, bmnam, FN_TD),
	InitItbm(SQL_CONVERT_BIGINT,			TRUE,  bmnam, CVT),
	InitItbm(SQL_CONVERT_LONGVARBINARY,		FALSE, bmnam, CVT),
	InitItbm(SQL_TXN_ISOLATION_OPTION,		FALSE, bmnam, TXN_ISOL)
};


pascal VOID GetInfoAll( HWND hwnd )
{
	static BYTE CSCONST szHead1[] = "fInfoType:";
	static BYTE CSCONST szHead2[] = "*pcbInfoValue, rgbInfoValue:";

	RETCODE			retcode;
	int				ifInfoType;
	FNAM CSCONST *	pfnam;
	BYTE			rgbInfoValue[ MAX_INFO_STRING + 1 ];
	SWORD			cbInfoValue;

		// Change cursor to hourglass

	SetCapture( hwnd );
//mj	hSaveCursor = SetCursor( hHourGlass );

	szWrite( szNullString, TRUE );
	szWrite( szHead1, FALSE );
	WriteTab( 5, (sizeof szHead1) - 1);
	szWrite( szHead2, TRUE );

	for( pfnam = finfo_fInfoType.pfnamMin, ifInfoType = 0;
		 pfnam < finfo_fInfoType.pfnamMax; pfnam++, ifInfoType++ )
	{
		if( FAbortCheck() )
		{
			static BYTE CSCONST szMsg[] = "GetInfo All canceled.";

			szWrite( szMsg, TRUE );
			break;
		}
		szWrite( SzConstDisplay( pfnam->lszName, pfnam->fArg ), FALSE );
		WriteTab( 5, strlen( OutStr ) );

		Untouch( rgbInfoValue, sizeof rgbInfoValue );
		if( pfnam->fArg == SQL_DRIVER_HSTMT )
			memcpy( rgbInfoValue, (BYTE *)&hstmt, sizeof( HSTMT ) );

		cbInfoValue = (BOOL)UNTOUCHED;

		retcode = SQLGetInfo( hdbc, pfnam->fArg,
				rgbInfoValue, MAX_INFO_STRING, &cbInfoValue );

		DisplayGetInfo( retcode, pfnam->fArg, FALSE,
			rgbInfoValue, MAX_INFO_STRING, &cbInfoValue );
		}
	return;
}/* end GetInfoAll */


		// This value is needed only between DisplayGetInfo and DisplayInfoValue:
	static ITBM CSCONST		*pitbm;


pascal VOID DisplayGetInfo(
				RETCODE retcode, UWORD fInfoType, BOOL fVerbose,
				LPBYTE lrgbInfoValue, SWORD cbInfoValueMax, SWORD *lpcbInfoValue )
{
	static BYTE CSCONST sz_apcbInfoValue[] = "*pcbInfoValue";

	BOOL fRange = FALSE;
	BOOL fFail =
		retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO;
	SWORD fCType;

	if( fVerbose )
	{
		static BYTE CSCONST szFormat[] = ", cbInfoValueMax = %d:";

		szWrite( sz_fInfoType, FALSE );
		szWrite( szEqual, FALSE );
		szWrite(
			SzConstDisplay(
				LszNameFromFlagArg( &finfo_fInfoType, fInfoType ),
				fInfoType),
			FALSE );
		wsprintf( OutStr, szFormat, cbInfoValueMax);
		szWrite( OutStr, TRUE );
	}
	fVerbose |= fFail;
	if( fVerbose )
		EchoRetcode(
			LszIfSz( fVerbose, sz_SQLGetInfo, szNullString), retcode );

	pitbm = NULL;
	switch( fInfoType )
	{
	case SQL_DRIVER_HENV:	// sizeof( HENV )  == sizeof( UDWORD )
	case SQL_DRIVER_HDBC:	// sizeof( HDBC )  == sizeof( UDWORD )
	case SQL_DRIVER_HSTMT:	// sizeof( HSTMT ) == sizeof( UDWORD )
		fCType = SQL_C_LONG;
		break;

	case SQL_ACTIVE_STATEMENTS:
	case SQL_ACTIVE_CONNECTIONS:
	case SQL_MAX_COLUMN_NAME_LEN:
	case SQL_MAX_CURSOR_NAME_LEN:
	case SQL_MAX_OWNER_NAME_LEN:
	case SQL_MAX_PROCEDURE_NAME_LEN:
	case SQL_MAX_QUALIFIER_NAME_LEN:
	case SQL_MAX_TABLE_NAME_LEN:
		fCType = SQL_C_SHORT;
		break;

	default:
		if(  // fInfoType < SQL_INFO_FIRST ||	// (implied by UWORD)
			    fInfoType > SQL_INFO_LAST )
		{
			fCType = SQL_C_DEFAULT; 	// Flag display method unknown
			break;
		}
		fCType = SQL_C_CHAR;
		for( pitbm = &rgitbm[0]; pitbm < PmaxFromRg( rgitbm ); pitbm++ )
		{
			if( pitbm->fInfoType < fInfoType )
			{
				fRange = pitbm->fBeginRange;
				continue;
			}
			if( fRange || pitbm->fInfoType == fInfoType)
				fCType = pitbm->fIsMask ? SQL_C_LONG : SQL_C_SHORT;

			break;
		}
		break;
	}
	FDisplayCbAndRgbArgs(	retcode,
							INFO_VALUE | (fVerbose ? 0 : NO_NAMES) |
								(fInfoType == SQL_DRIVER_HSTMT &&
								lrgbInfoValue != NULL ?
									(memcmp( lrgbInfoValue, (BYTE*)&hstmt,
								MIN( sizeof( HSTMT ), cbInfoValueMax) ) == 0 ?
								HRGB_IN_OUT | HRGB_UNTOUCHED : HRGB_IN_OUT ) :
								0 ),
							fCType,
							sz_apcbInfoValue, (PTR)lpcbInfoValue, cbInfoValueMax,
							sz_rgbInfoValue, lrgbInfoValue );
	return;
}/* end DisplayGetInfo */


pascal VOID DisplayInfoValue( SWORD fCType,
					PTR lrgbInfoValue, SWORD cbTouched, SWORD cbInfoValue )
{
	switch( fCType )
	{
	case SQL_C_CHAR:
		DisplayOutputBuf( SQL_C_CHAR, lrgbInfoValue, cbTouched );
		return;

	case SQL_C_SHORT:
		if( cbTouched > sizeof( int ) )
		{
			szWrite( sz_Error, FALSE );
			break;
		}
		DisplayInfoValueInt( lrgbInfoValue );
		return;

	case SQL_C_LONG:
		if( cbTouched > sizeof( UDWORD ) )
		{
			szWrite( sz_Error, FALSE );
			break;
		}
		DisplayInfoValueMask( lrgbInfoValue );
		return;

	default:
		VAssert(fCType == SQL_C_DEFAULT);
		if( (cbInfoValue == 0 || cbInfoValue == sizeof( int ))
		 &&  cbTouched <= sizeof( int ) )
		{
			DisplayInfoValueInt( lrgbInfoValue );
			szWrite( szEqual, FALSE );
		}
		if( (cbInfoValue == 0 || cbInfoValue == sizeof( UDWORD ))
		 &&  cbTouched <= sizeof( UDWORD ) )
		{
			DisplayInfoValueMask( lrgbInfoValue );
			szWrite( szEqual, FALSE );
		}
		break;
	}
	DisplayOutputBuf( 0, lrgbInfoValue, MAX( cbTouched, cbInfoValue ) );
	return;
}/* end DisplayInfoValue */


pascal VOID DisplayInfoValueMask( PTR lrgbInfoValue )
{
	wsprintf( OutStr, szFormatHex, *(UDWORD FAR *)lrgbInfoValue );
	szWrite( OutStr, FALSE );

	if( pitbm != NULL )
	{
		static BYTE CSCONST szOr[] = " | ";

		BOOL			fNewLine;
		int				cname = 3;
		UDWORD			fMaskLeft = *(UDWORD FAR *)lrgbInfoValue;
		BYTE  CSCONST *	szOper		= szEqual;
		BMNAM CSCONST *	pbmnam		= pitbm->pvMin;
		BMNAM CSCONST *	pbmnamMax	= pitbm->pvMax;

		for( ; pbmnam < pbmnamMax && fMaskLeft != 0; pbmnam++ )
			if( fMaskLeft & pbmnam->fValue )
			{
				fMaskLeft ^= pbmnam->fValue;
				fNewLine = ++cname > 5 && fMaskLeft != 0;
				szWrite( szOper, FALSE );
				szWrite( pbmnam->lszName, fNewLine );
				szOper = szOr;
				if( fNewLine )
					cname = 0;
			}
		if( fMaskLeft != 0 && fMaskLeft != *(UDWORD*)lrgbInfoValue )
		{
			static BYTE CSCONST szMsg[] = "Not all bits are named!";

			szWrite( szOr, FALSE );
			wsprintf( OutStr, szFormatHex, fMaskLeft );
			szWrite( OutStr, FALSE );
			szWrite( szPeriod, TRUE );
			szWrite( sz_Error, FALSE );
			szWrite( szMsg, TRUE );
		}
	}
	return;
}/* end DisplayInfoValueMask */


pascal VOID DisplayInfoValueInt( PTR lrgbInfoValue )
{
//	itoa( *(int*)lrgbInfoValue, OutStr, 10 );
	sprintf( OutStr, "%10d", *(int*)lrgbInfoValue );
	szWrite( OutStr, FALSE );

	if( pitbm )
	{	static BYTE CSCONST		szMsg[] = "Unknown Value";

		FNAM CSCONST	*pfnam    = pitbm->pvMin;
		FNAM CSCONST	*pfnamMax = pitbm->pvMax;

		szWrite( szEqual, FALSE );
		for( ; pfnam < pfnamMax; pfnam++ )
			if( *(SWORD FAR *)lrgbInfoValue == pfnam->fArg )
			{
				szWrite( pfnam->lszName, FALSE );
				return;
			}
		szWrite( szMsg, FALSE );
	}
	return;
}/* end DisplayInfoValueInt */


pascal UDWORD FTXNIsoNameFromIbmnam( LPBYTE lsz, UWORD ibmnam )
{
	UDWORD	fValue;

	if( ibmnam >= sizeof( rgbmnam_TXN_ISOL) / sizeof( rgbmnam_TXN_ISOL)[0] )
	{
		lsz[0] = '\0';
		return 0;
	}
	fValue = rgbmnam_TXN_ISOL[ ibmnam ].fValue;
	lstrcpy( lsz, rgbmnam_TXN_ISOL[ ibmnam ].lszName );
	lstrcat( lsz, szEqual );
	wsprintf( &lsz[ lstrlen( lsz ) ], szFormatHex, fValue );
	return fValue;
}/* end FTXNIsoNameFromIbmnam */
