
	// This module implements the functions in the Data
	// menu which require dialogs.


#include <Quickdraw.h>
#include <Types.h>
#include <ctype.h>

#include "gator.h"
#include "adhoc.h"
#include "dda.h"

#ifdef MACINTOSH
#include <dos.h>			// mj
#endif MACINTOSH

#pragma segment DDA

	INIT_ASSERT

	extern char	OutStr[ OUTSTRLEN ];	// One global OutStr!
	extern HCURSOR hSaveCursor;
	extern HCURSOR hHourGlass;

		// These are uneditable input values:
	extern HDBC		hdbc;
	extern UWORD	idbc;
	extern HSTMT	hstmt;
	extern UWORD	istmt;

		// These values are init at launch, then remembered between <func> calls:
	extern DDAINFO	*lpddainfo;

//static UWORD fFunction      = SQL_API_SQLALLOCCONNECT;
//static BOOL  fNull_pfExists = FALSE;

#define lpisaPkTableQualifier	lpisaTableQualifier
#define lpisaPkTableOwner		lpisaTableOwner
#define lpisaPkTableName		lpisaTableName

	int ifn;

		// These short term variables are shared between modules:
	extern BOOL fChangedByApp;

		// Constants in storage:
	extern FINFO FAR finfo_fSqlType_All;
	extern FINFO FAR finfo_fSqlType_NoAll;
	extern FINFO FAR finfo_BOOL;

	static BYTE CSCONST szEqual[]        = " = ";
	static BYTE CSCONST szOr[]           = " | ";
	static BYTE CSCONST szComma[]        = ", ";
	static BYTE CSCONST szPeriod[]       = ".";
	static BYTE CSCONST szColon[]        = ":";
	static BYTE CSCONST sz_Error[]       = "***Error*** ";
	static BYTE CSCONST sz_Error_input[] = "Error in input";
	static BYTE CSCONST sz_Illegal[]     = "Illegal ";
	static BYTE CSCONST sz_fFunction[]   = "fFunction";
	static BYTE CSCONST sz_apfExists[]   = "*pfExists";
	static BYTE CSCONST sz_icol[]        = "icol";
	static BYTE CSCONST sz_fDescType[]   = "fDescType";
	static BYTE CSCONST sz_cbDescMax[]   = "cbDescMax";

	static BYTE CSCONST szSel_empty_string[]  = "<empty string>";
	static BYTE CSCONST szSel_null_pointer[]  = "<null pointer>";
	static BYTE CSCONST szSel_valid_pointer[] = "<valid_pointer>";

#define LEVEL_2_API_START SQL_API_SQLBROWSECONNECT

	static FNAM CSCONST rgfnam_fFunction[] =
	{
			// Core Functions:

		{ SQL_API_SQLALLOCCONNECT,		sz_SQL_API_SQLALLOCCONNECT	},
		{ SQL_API_SQLALLOCENV,			sz_SQL_API_SQLALLOCENV		},
		{ SQL_API_SQLALLOCSTMT,			sz_SQL_API_SQLALLOCSTMT		},
		{ SQL_API_SQLBINDCOL,			sz_SQL_API_SQLBINDCOL		},
		{ SQL_API_SQLCANCEL,			sz_SQL_API_SQLCANCEL		},
		{ SQL_API_SQLCOLATTRIBUTES,		sz_SQL_API_SQLCOLATTRIBUTES	},
		{ SQL_API_SQLCONNECT,			sz_SQL_API_SQLCONNECT		},
		{ SQL_API_SQLDESCRIBECOL,		sz_SQL_API_SQLDESCRIBECOL	},
		{ SQL_API_SQLDISCONNECT,		sz_SQL_API_SQLDISCONNECT	},
		{ SQL_API_SQLERROR,				sz_SQL_API_SQLERROR			},
		{ SQL_API_SQLEXECDIRECT,		sz_SQL_API_SQLEXECDIRECT	},
		{ SQL_API_SQLEXECUTE,			sz_SQL_API_SQLEXECUTE		},
		{ SQL_API_SQLFETCH,				sz_SQL_API_SQLFETCH			},
		{ SQL_API_SQLFREECONNECT,		sz_SQL_API_SQLFREECONNECT	},
		{ SQL_API_SQLFREEENV,			sz_SQL_API_SQLFREEENV		},
		{ SQL_API_SQLFREESTMT,			sz_SQL_API_SQLFREESTMT		},
		{ SQL_API_SQLGETCURSORNAME,		sz_SQL_API_SQLGETCURSORNAME	},
		{ SQL_API_SQLNUMRESULTCOLS,		sz_SQL_API_SQLNUMRESULTCOLS	},
		{ SQL_API_SQLPREPARE,			sz_SQL_API_SQLPREPARE		},
		{ SQL_API_SQLROWCOUNT,			sz_SQL_API_SQLROWCOUNT		},
		{ SQL_API_SQLSETCURSORNAME,		sz_SQL_API_SQLSETCURSORNAME	},
		{ SQL_API_SQLSETPARAM,			sz_SQL_API_SQLSETPARAM		},
		{ SQL_API_SQLTRANSACT,			sz_SQL_API_SQLTRANSACT		},

			// Extension Level 1 Functions:

		{ SQL_API_SQLCOLUMNS,			sz_SQL_API_SQLCOLUMNS			},
		{ SQL_API_SQLDRIVERCONNECT,		sz_SQL_API_SQLDRIVERCONNECT		},
		{ SQL_API_SQLGETCONNECTOPTION,	sz_SQL_API_SQLGETCONNECTOPTION	},
		{ SQL_API_SQLGETDATA,			sz_SQL_API_SQLGETDATA			},
		{ SQL_API_SQLGETFUNCTIONS,		sz_SQL_API_SQLGETFUNCTIONS		},
		{ SQL_API_SQLGETINFO,			sz_SQL_API_SQLGETINFO			},
		{ SQL_API_SQLGETSTMTOPTION,		sz_SQL_API_SQLGETSTMTOPTION		},
		{ SQL_API_SQLGETTYPEINFO,		sz_SQL_API_SQLGETTYPEINFO		},
		{ SQL_API_SQLPARAMDATA,			sz_SQL_API_SQLPARAMDATA			},
		{ SQL_API_SQLPUTDATA,			sz_SQL_API_SQLPUTDATA			},
		{ SQL_API_SQLSETCONNECTOPTION,	sz_SQL_API_SQLSETCONNECTOPTION	},
		{ SQL_API_SQLSETSTMTOPTION,		sz_SQL_API_SQLSETSTMTOPTION		},
		{ SQL_API_SQLSPECIALCOLUMNS,	sz_SQL_API_SQLSPECIALCOLUMNS	},
		{ SQL_API_SQLSTATISTICS,		sz_SQL_API_SQLSTATISTICS		},
		{ SQL_API_SQLTABLES,			sz_SQL_API_SQLTABLES			},

			// Extension Level 2 Functions:

		{ SQL_API_SQLBROWSECONNECT,		sz_SQL_API_SQLBROWSECONNECT		},
		{ SQL_API_SQLCOLUMNPRIVILEGES,	sz_SQL_API_SQLCOLUMNPRIVILEGES	},
		{ SQL_API_SQLDATASOURCES,		sz_SQL_API_SQLDATASOURCES		},
		{ SQL_API_SQLDESCRIBEPARAM,		sz_SQL_API_SQLDESCRIBEPARAM		},
		{ SQL_API_SQLEXTENDEDFETCH,		sz_SQL_API_SQLEXTENDEDFETCH		},
		{ SQL_API_SQLFOREIGNKEYS,		sz_SQL_API_SQLFOREIGNKEYS		},
		{ SQL_API_SQLMORERESULTS,		sz_SQL_API_SQLMORERESULTS		},
		{ SQL_API_SQLNATIVESQL,			sz_SQL_API_SQLNATIVESQL			},
		{ SQL_API_SQLNUMPARAMS,			sz_SQL_API_SQLNUMPARAMS			},
		{ SQL_API_SQLPARAMOPTIONS,		sz_SQL_API_SQLPARAMOPTIONS		},
		{ SQL_API_SQLPRIMARYKEYS,		sz_SQL_API_SQLPRIMARYKEYS		},
		{ SQL_API_SQLPROCEDURECOLUMNS,	sz_SQL_API_SQLPROCEDURECOLUMNS	},
		{ SQL_API_SQLPROCEDURES,		sz_SQL_API_SQLPROCEDURES		},
		{ SQL_API_SQLSETPOS,			sz_SQL_API_SQLSETPOS			},
		{ SQL_API_SQLSETSCROLLOPTIONS,	sz_SQL_API_SQLSETSCROLLOPTIONS	},
		{ SQL_API_SQLTABLEPRIVILEGES,	sz_SQL_API_SQLTABLEPRIVILEGES	}
	};
	
	DeclareFinfo( fFunction, "SQL_API_SQL", FINFO_UWORD, static );

	static FNAM CSCONST rgfnam_fDescType[] =
	{
			// Core values:
		{ SQL_COLUMN_COUNT,				sz_SQL_COLUMN_COUNT				},
		{ SQL_COLUMN_NAME,				sz_SQL_COLUMN_NAME				},
		{ SQL_COLUMN_TYPE,				sz_SQL_COLUMN_TYPE				},
		{ SQL_COLUMN_LENGTH,			sz_SQL_COLUMN_LENGTH			},
		{ SQL_COLUMN_PRECISION,			sz_SQL_COLUMN_PRECISION			},
		{ SQL_COLUMN_SCALE,				sz_SQL_COLUMN_SCALE				},
		{ SQL_COLUMN_DISPLAY_SIZE,		sz_SQL_COLUMN_DISPLAY_SIZE		},
		{ SQL_COLUMN_NULLABLE,			sz_SQL_COLUMN_NULLABLE			},
			// Extension values:
		{ SQL_COLUMN_UNSIGNED,			sz_SQL_COLUMN_UNSIGNED			},
		{ SQL_COLUMN_MONEY,				sz_SQL_COLUMN_MONEY				},
		{ SQL_COLUMN_UPDATABLE,			sz_SQL_COLUMN_UPDATABLE			},
		{ SQL_COLUMN_AUTO_INCREMENT,	sz_SQL_COLUMN_AUTO_INCREMENT	},
		{ SQL_COLUMN_CASE_SENSITIVE,	sz_SQL_COLUMN_CASE_SENSITIVE	},
		{ SQL_COLUMN_SEARCHABLE,		sz_SQL_COLUMN_SEARCHABLE		},
		{ SQL_COLUMN_TYPE_NAME,			sz_SQL_COLUMN_TYPE_NAME			}
	};
	DeclareFinfo( fDescType, "SQL_COLUMN_", FINFO_UWORD, GLOBAL );

	static FNAM CSCONST rgfnam_fColType[] =
	{
		{ SQL_BEST_ROWID,	sz_SQL_BEST_ROWID	},
		{ SQL_ROWVER,		sz_SQL_ROWVER		}
	};
	DeclareFinfo( fColType, "SQL_", FINFO_UWORD, GLOBAL );

	static FNAM CSCONST rgfnam_fScope[] =
	{
		{ SQL_SCOPE_CURROW,			sz_SQL_SCOPE_CURROW			},
		{ SQL_SCOPE_TRANSACTION,	sz_SQL_SCOPE_TRANSACTION	},
		{ SQL_SCOPE_SESSION,		sz_SQL_SCOPE_SESSION		}
	};
	DeclareFinfo( fScope, "SQL_SCOPE_", FINFO_UWORD, GLOBAL );

	static FNAM CSCONST rgfnam_fNullable[] =
	{
		{ SQL_NO_NULLS,			sz_SQL_NO_NULLS	},
		{ SQL_NULLABLE,			sz_SQL_NULLABLE	},
		{ SQL_NULLABLE_UNKNOWN,	sz_SQL_NULLABLE_UNKNOWN	}
	};
#define ifnamMax_fNullable (sizeof rgfnam_fNullable / sizeof rgfnam_fNullable[0])

		// Include SQL_NULLABLE_UNKNOWN:
	DeclareFinfoSubset( fNullable, WithUnknown, "SQL_", FINFO_SWORD, GLOBAL,
		0, ifnamMax_fNullable);

		// Exclude SQL_NULLABLE_UNKNOWN:
	DeclareFinfoSubset( fNullable, WithoutUnknown, "SQL_", FINFO_UWORD, GLOBAL,
		0, ifnamMax_fNullable - 1);

	static FNAM CSCONST rgfnam_fUnique[] =
	{
		{ SQL_INDEX_UNIQUE,	sz_SQL_INDEX_UNIQUE	},
		{ SQL_INDEX_ALL,	sz_SQL_INDEX_ALL	}
	};
	DeclareFinfo( fUnique, "SQL_", FINFO_UWORD, GLOBAL );

	static FNAM CSCONST rgfnam_fAccuracy[] =
	{
		{ SQL_QUICK,	sz_SQL_QUICK	},
		{ SQL_ENSURE,	sz_SQL_ENSURE	}
	};
	DeclareFinfo( fAccuracy, "SQL_", FINFO_UWORD, GLOBAL );

	static FNAM CSCONST rgfnam_fUpdatable[] =
	{
		{ SQL_ATTR_READONLY,			sz_SQL_ATTR_READONLY	},
		{ SQL_ATTR_WRITE,				sz_SQL_ATTR_WRITE	},
		{ SQL_ATTR_READWRITE_UNKNOWN,	sz_SQL_ATTR_READWRITE_UNKNOWN	}
	};
	DeclareFinfo( fUpdatable, "SQL_ATTR_", FINFO_UWORD, GLOBAL );

	static FNAM CSCONST rgfnam_fSearchable[] =
	{
		{ SQL_UNSEARCHABLE,			sz_SQL_UNSEARCHABLE	},
		{ SQL_LIKE_ONLY,			sz_SQL_LIKE_ONLY	},
		{ SQL_ALL_EXCEPT_LIKE,		sz_SQL_ALL_EXCEPT_LIKE	},
		{ SQL_SEARCHABLE,			sz_SQL_SEARCHABLE	}
	};
	DeclareFinfo( fSearchable, "SQL_", FINFO_UWORD, GLOBAL );



pascal HPVOID AllocateBuffer( BOOL fNull_rgbValue, SDWORD cbValueMax )
{
	static BYTE CSCONST szMsg[] = "Note: Failed to lock memory for output buffer.";
	static BYTE CSCONST szFormat[] =
						"Note: Failed to allocate %ld bytes for output buffer.";	HANDLE	hargbValue;
	HPVOID	hrgbValue = NULL;


	if( fNull_rgbValue )
		return NULL;

	if( cbValueMax < 0 )
		cbValueMax = 0;

	if( cbValueMax < 0x7FFFFFFF )
		cbValueMax++;	// add 1 for check byte

	hargbValue = AllocateMemory( cbValueMax );
	if( hargbValue == NULL )
	{
		wsprintf( OutStr, szFormat, cbValueMax );
		szWrite( OutStr, TRUE );
		return NULL;
	}
	hrgbValue = LockMemory( hargbValue );
	if( hrgbValue )
	{
		Untouch( hrgbValue, cbValueMax );
		return hrgbValue;
	}
	FreeMemory( hargbValue );
	szWrite( szMsg, TRUE );
	return NULL;
}/* end AllocateBuffer */


pascal VOID DisplayGetFunctions( RETCODE retcode, UWORD fFunction,
									BOOL fNull_pfExists, BOOL fExists )
{
	szWrite( sz_fFunction, FALSE );
	szWrite( szEqual, FALSE );
	szWrite(
		SzConstDisplay(
			LszNameFromFlagArg( &finfo_fFunction, fFunction ), fFunction ),
		FALSE );
	szWrite( szColon, TRUE );
	EchoRetcode( sz_SQLGetFunctions, retcode );
	if( !fNull_pfExists &&
		FCheckArg( sz_apfExists, fExists == (BOOL)UNTOUCHED,
			retcode < SQL_SUCCESS, TRUE ) )
	{
		szWrite(
			SzConstDisplay(
				LszNameFromFlagArg( &finfo_BOOL, fExists), fExists ), FALSE );
		szWrite( szPeriod, TRUE );
	}
	return;
}/* end DisplayGetFunctions */


pascal VOID GetFunctionsAll( HWND )
{
	static BYTE CSCONST sz_CORE[]      = "CORE ";
	static BYTE CSCONST sz_EXTENSION[] = "EXTENSION Level ";
	static BYTE CSCONST sz_1[]         = "1 ";
	static BYTE CSCONST sz_2[]         = "2 ";
	static BYTE CSCONST sz_canceled[]  = "GetFunctions All canceled.";

	BOOL			fAbort = FALSE;
	RETCODE			retcode;
	BOOL			fExists;
	int				ifFunction;
	UWORD			fFunction;
	FNAM CSCONST	*pfnam;

	for( ifFunction = 0, pfnam = finfo_fFunction.pfnamMin;
		                 pfnam < finfo_fFunction.pfnamMax;
		 ifFunction++,   pfnam++ )
	{
		if( FAbortCheck() )
		{
			szWrite( sz_canceled, TRUE );
			fAbort = TRUE;
			break;
		}
		fFunction = pfnam->fArg;
		if( ifFunction == 0 || ifFunction == SQL_NUM_FUNCTIONS ||
			ifFunction ==
			SQL_NUM_FUNCTIONS + LEVEL_2_API_START - SQL_EXT_API_START)
			{
			szWrite( "", TRUE );
			szWrite( LszIfSz( ifFunction == 0, sz_CORE, sz_EXTENSION ),
				FALSE );
			if( ifFunction != 0 )
				szWrite(
					LszIfSz( ifFunction == SQL_NUM_FUNCTIONS, sz_1, sz_2 ),
					FALSE );

			szWrite( sz_fFunction, FALSE );
			szWrite( szColon, FALSE );
			WriteTab(5,
				(ifFunction == 0 ?
					sizeof sz_CORE - 1 :
					sizeof sz_EXTENSION - 1 + sizeof sz_1 - 1) +
				sizeof sz_fFunction - 1 + sizeof szColon - 1);
			szWrite( sz_apfExists, FALSE );
			szWrite( szColon, TRUE );
			switch( ifFunction)
				{
			case 0:
				VAssert( fFunction == 1);
				break;

			case SQL_NUM_FUNCTIONS:
				VAssert( fFunction == SQL_EXT_API_START);
				break;

			default:
				VAssert( fFunction == LEVEL_2_API_START);
				break;
				}
			}
		szWrite(SzConstDisplay(pfnam->lszName, fFunction), FALSE );
		WriteTab(5, strlen( OutStr));

		fExists = (BOOL)UNTOUCHED;
		retcode = SQLGetFunctions(hdbc, fFunction, &fExists);
		if( retcode != SQL_SUCCESS)
			EchoRetcode("", retcode );

		if( FCheckArg( sz_apfExists, fExists == (BOOL)UNTOUCHED,
				retcode < SQL_SUCCESS, FALSE ))
			szWrite(
				SzConstDisplay(
					LszNameFromFlagArg( &finfo_BOOL, fExists ), fExists ),
				TRUE );
	}/* end FOR */

	VAssert( fAbort || ifFunction == SQL_NUM_FUNCTIONS + SQL_NUM_EXTENSIONS );
	return;
}/* end GetFunctionsAll */


pascal VOID DisplayColAttributes(
						RETCODE retcode, UWORD icol, UWORD fDescType, LPBYTE lrgbDesc,
						SWORD cbDescMax, SWORD *lpcbDesc, SDWORD *lpfDesc )
{
	static BYTE CSCONST sz_rgbDesc[]  = "rgbDesc";
	static BYTE CSCONST sz_apcbDesc[] = "*pcbDesc";
	static BYTE CSCONST sz_apfDesc[]  = "*pfDesc";

	SDWORD fDesc;
	BOOL fDescTouched;

	FINFO	*lpfinfo = NULL;

	szWrite( sz_icol, FALSE );
	szWrite( szEqual, FALSE );
	szWrite(SzConstDisplay(NULL, icol), FALSE );
	szWrite( szComma, FALSE );

	szWrite( sz_fDescType, FALSE );
	szWrite( szEqual, FALSE );
	szWrite(
		SzConstDisplay(
			LszNameFromFlagArg( &finfo_fDescType, fDescType ), fDescType ),
		FALSE );
	szWrite( szComma, FALSE );

	szWrite( sz_cbDescMax, FALSE );
	szWrite( szEqual, FALSE );
	szWrite(SzConstDisplay(NULL, cbDescMax ), FALSE );
	szWrite( szColon, TRUE );

	EchoRetcode( sz_SQLColAttributes, retcode );

	if( retcode == SQL_STILL_EXECUTING)
		return;

	fDescTouched = 
		fDescType == SQL_COLUMN_NAME || fDescType == SQL_COLUMN_TYPE_NAME;

	FDisplayCbAndRgbArgs( fDescTouched ? retcode : SQL_ERROR,
		MID_LINE, SQL_C_CHAR, sz_apcbDesc, lpcbDesc, cbDescMax,
		sz_rgbDesc, lrgbDesc );

	if( lpfDesc
	 && FCheckArg( sz_apfDesc, ( fDesc = *lpfDesc ) == (SDWORD)UNTOUCHED,
			fDescTouched || retcode < SQL_SUCCESS, TRUE ) )
	{
		switch( fDescType )
		{
		case SQL_COLUMN_TYPE:
			lpfinfo = &finfo_fSqlType_NoAll;
			break;

		case SQL_COLUMN_NULLABLE:
			lpfinfo = &finfo_fNullable_WithUnknown;
			break;

		case SQL_COLUMN_UPDATABLE:
			lpfinfo = &finfo_fUpdatable;
			break;

		case SQL_COLUMN_SEARCHABLE:
			lpfinfo = &finfo_fSearchable;
			break;

		case SQL_COLUMN_UNSIGNED:
		case SQL_COLUMN_MONEY:
		case SQL_COLUMN_AUTO_INCREMENT:
		case SQL_COLUMN_CASE_SENSITIVE:
			lpfinfo = &finfo_BOOL;
			break;
		}
		szWrite(
			SzConstDisplay(
				LszIfSz( lpfinfo != NULL,
					LszNameFromFlagArg(lpfinfo, fDesc ), NULL ),
				fDesc ),
			FALSE );
	}
	if( FNeedSeparator() )
		szWrite( szPeriod, TRUE );
	return;
}/* end DisplayColAttributes */


pascal LPISA LpisaInitISA()
{
	LPISA	lpisa;


//	lpisa = LpisaCreateISA( FALSE, 1, 0, 0 );
	lpisa = LpisaCreateISA( FALSE, 256, 255, 0 );
	lpisa->sz[0] = 0;
	return lpisa;
}/* end LpisaInitISA */


pascal LPISA LpisaCreateISA( BOOL fNull, SWORD cbMax, SWORD cbDefault, SWORD cb )
{
	LPISA	lpisa;

	if( fNull )
		cbMax = cbDefault = 0;

	lpisa = AllocateBuffer( FALSE, sizeof( ISA ) - 1 + cbMax );

	lpisa->cuse      = 1;
	lpisa->fNull     = fNull;
	lpisa->cbMax     = cbMax;
	lpisa->cbDefault = cbDefault;
	lpisa->cb        = cb;
	return lpisa;
}/* end LpisaCreateISA */


pascal VOID ReplaceISA( LPLPISA lplpisaDest, LPISA lpisaSource )
{
	lpisaSource->cuse++;
	ReleaseISA( *lplpisaDest );
	*lplpisaDest = lpisaSource;
	return;
}/* end ReplaceISA */


pascal VOID ReleaseISA( LPISA lpisa )
{
	if( lpisa == NULL )
		return;

	VAssert( lpisa->cuse > 0 );
	if( --lpisa->cuse <= 0 )
		ReleaseMemory( lpisa );
	return;
}/* end ReleaseISA */


pascal VOID DisplayISAs( LPSTR szName, LPISA lpisa )
{
	static BYTE CSCONST sz_sz[] = "sz";
	static BYTE CSCONST sz_cb[] = "cb";

	SWORD cb = lpisa->cb;

	szWrite( sz_cb,   FALSE );
	szWrite( szName,  FALSE );
	szWrite( szEqual, FALSE );
	szWrite( SzConstDisplay( LszIfSz( cb == SQL_NTS, sz_SQL_NTS, NULL ), cb ),
																		FALSE );
	if( lpisa->fNull )
		return;

	szWrite( szComma,	FALSE );
	szWrite( sz_sz,		FALSE );
	szWrite( szName,	FALSE );
	szWrite( szEqual,	FALSE );
	DisplayInputStringSzArg( NULL, lpisa, FALSE );
	return;
}/* end DisplayISAs */


pascal VOID DisplayInputStringSzArg( HWND hwnd, LPISA lpisa, BOOL fAlone )
{
	LPBYTE		lsz		= LszOfLpisa( lpisa );
	SWORD		cbMax	= lpisa->cbMax;

	if( fAlone )
	{	SWORD	cch = lpisa->cb;

		if( cch < 0 || cch > cbMax )
			cch = lpisa->cbDefault;

		DisplayString( hwnd, lsz, cch, INPUT_STRING | LENGTH_TERM | NO_METANAME );
	}
	else
		DisplayString( hwnd, lsz, (SWORD)CbTouchedRgbCbMax( lsz, cbMax ),
			INPUT_STRING );
	return;
}/* end DisplayInputStringSzArg */


pascal VOID GetInputStringSzArgDisplay( char *szBuf, UWORD cbOutMax, LPISA lpisa )
{
	SWORD	cch = lpisa->cb;

	if( cch < 0 || cch > lpisa->cbMax )
		cch = lpisa->cbDefault;

	CchGetStringDisplay( szBuf, cbOutMax, LszOfLpisa( lpisa ), cch, LENGTH_TERM );
	return;
}/* end GetInputStringSzArgDisplay */


#define ifCombo_sz 0
#define ifCombo_cb 1


#ifdef MACINTOSH
pascal BOOL FCheckISAs( HWND, int, int, LPBYTE, BYTE* )
{
	return FALSE;
}
#elif WINDOWS
pascal BOOL FCheckISAs( HWND hdlg, int idc_sz, int idc_cb,
						LPBYTE lszName, BYTE lrgfCombo[2] )
{
	static BYTE CSCONST sz_sz[] = "sz";
	static BYTE CSCONST sz_cb[] = "cb";

	HWND hwnd;
	int idc;
	BYTE CSCONST * sz;

	if( ( sz = sz_sz, idc = idc_sz,
			lrgfCombo[ifCombo_sz] != VALUE_IS_ILLEGAL) &&
		( sz = sz_cb, idc = idc_cb,
			lrgfCombo[ifCombo_cb] != VALUE_IS_ILLEGAL))
		return TRUE;

	hwnd = GetDlgItem( hdlg, idc );
	lstrcpy( OutStr, sz_Illegal );
	lstrcat( OutStr, sz );
	lstrcat( OutStr, lszName );
	MessageBox( hwnd, OutStr, sz_Error_input, MB_OK );
	SetFocus( hwnd );
	return FALSE;
}
#endif MACINTOSH elif WINDOWS


#ifdef MACINTOSH
pascal BOOL FProcInputStringSzArgMsg( UWORD, HWND, int, WORD, LPLPISA, LPBYTE )
{
debugstr( "FProcInputStringSzArgMsg not implemented." );
	return FALSE;
}
#elif WINDOWS
pascal BOOL FProcInputStringSzArgMsg(	UWORD fSelections, HWND hdlg,
										int idc, WORD message,
										LPLPISA lplpisa, LPBYTE lpfCombo )
{
	BOOL	fRedisplay = TRUE;
	BOOL	fUpdateDependants = FALSE;
	BOOL	fIsNTS;
	int		isel, iselNullString;
	SWORD	cb;
	SWORD	cch;
	HWND	hwnd = GetDlgItem( hdlg, idc );
	LPISA	lpisaOld = *lplpisa;
	LPISA	lpisaNew = lpisaOld;

	if( fChangedByApp )
		return FALSE;

	fChangedByApp = TRUE;
	switch( message )
	{
	case CBN_UPDATE_CONTENTS:
		SendMessage( hwnd, CB_RESETCONTENT, 0, 0 );
		if( fSelections & DSN_LIST)
			FillDropdownWithDSNList( hwnd );

		if( fSelections & NULL_SELECTIONS )
		{
			SendMessage( hwnd, CB_ADDSTRING, 0,
				(long)(LPSTR)szSel_empty_string );
			SendMessage( hwnd, CB_ADDSTRING, 0,
				(long)(LPSTR)szSel_null_pointer );
		}
		if( ( fSelections & (DSN_LIST | NULL_SELECTIONS)) == DSN_LIST)
		{
			if( lpisaOld->fNull ||
				lpisaOld->cbDefault == 0 && lpisaOld->sz[0] == '\0')
				{
				cch = (SWORD)SendMessage( hwnd, CB_GETLBTEXTLEN, 0, 0 );
				lpisaNew =
					LpisaCreateISA( FALSE, cch + 1, cch, cch );
				SendMessage( hwnd, CB_GETLBTEXT, 0, (LONG)lpisaNew->sz );
			}
		}
		if( fSelections & DSN_LIST )
			UpdateDropdownSize( hwnd );

		goto Common;

	case CBN_EDITCHANGE:
		if( (SWORD)SendMessage( hwnd, WM_GETTEXTLENGTH, 0, 0 ) )
		{
			*lpfCombo = VALUE_NOT_REDISPLAYED;
			break;
		}
		lpisaNew = LpisaInitISA();
		goto Common;

	case CBN_SELCHANGE:
		isel = (int)SendMessage(hwnd, CB_GETCURSEL, 0, 0);
		if( fSelections & NULL_SELECTIONS
		 && (iselNullString = (int)SendMessage( hwnd, CB_GETCOUNT, 0, 0 ) - 2,
			 isel >= iselNullString ) )
			lpisaNew = isel == iselNullString
					? LpisaInitISA()
					: LpisaCreateISA( TRUE, 0, 0, 0 );
		else
		{
			cch = (SWORD)SendMessage( hwnd, CB_GETLBTEXTLEN, isel, 0 );
			lpisaNew = LpisaCreateISA( FALSE, cch + 1, cch, cch);
			SendMessage( hwnd, CB_GETLBTEXT, isel, (LONG)lpisaNew->sz );
		}
		fRedisplay = FALSE;
		goto Common;

	case CBN_DROPDOWN:
		if( *lpfCombo != VALUE_NOT_REDISPLAYED)
			break;
		goto Common;

	case CBN_KILLFOCUS:
		if( *lpfCombo != VALUE_NOT_REDISPLAYED)
			break;

		cb = (SWORD)SendMessage( hwnd, WM_GETTEXTLENGTH, 0, 0 ) + 1;
		lpisaNew = LpisaCreateISA( FALSE, cb, 0, 0);
		cch = (SWORD)GetDlgItemValue(hdlg, idc, SQL_C_CHAR,
				lpisaNew->sz, cb );
		if( cch < 0 )
		{
			ReleaseMemory( lpisaNew );
			*lpfCombo = VALUE_IS_ILLEGAL;
			break;
		}
		lpisaNew->cb = lpisaNew->cbDefault = cch;
Common:
		if( lpisaNew != lpisaOld )
		{
			fIsNTS = lpisaOld->cb == SQL_NTS;
			ReleaseISA( lpisaOld );
			*lplpisa = lpisaNew;
			if( fIsNTS )
				lpisaNew->cb = SQL_NTS;
		}
		if( fRedisplay )
		{
			if( fSelections & NULL_SELECTIONS &&
				((isel = (int)SendMessage( hwnd, CB_GETCOUNT, 0, 0 ) - 1,
				  lpisaNew->fNull ) ||
				 (isel--,
				  lpisaNew->cbDefault == 0 && lpisaNew->sz[0] == '\0')) )
				SendMessage(hwnd, CB_SETCURSEL, isel, 0 );

			else if( message == CBN_UPDATE_CONTENTS )
				DisplayInputStringSzArg( hwnd, lpisaNew,
					( fSelections & APPEARS_WITH_CB) == 0 );
		}
		*lpfCombo = VALUE_WAS_REDISPLAYED;
		fUpdateDependants = TRUE;
		break;
	}
	fChangedByApp = FALSE;
	return fUpdateDependants;
}
#endif MACINTOSH elif WINDOWS


pascal BOOL FProcInputPointerArgMsg( HWND hdlg, int idc, WORD message,
									BOOL *pfNum, SDWORD *pudwValue, BYTE *pfCombo )
{
	BOOL	fUpdateDependants = FALSE;
	int		isel;
	HWND	hwnd = GetDlgItem( hdlg, idc );

	if( fChangedByApp )
		return FALSE;

	fChangedByApp = TRUE;
	switch( message )
	{
	case CBN_UPDATE_CONTENTS:
		SendMessage( hwnd, CB_RESETCONTENT, 0, 0 );
		SendMessage( hwnd, CB_ADDSTRING, 0,
			(long)(LPSTR)szSel_valid_pointer );
		SendMessage( hwnd, CB_ADDSTRING, 0,
			(long)(LPSTR)szSel_null_pointer );
		goto Redisplay;

	case CBN_EDITCHANGE:
		if( !FGetDlgItemUDWord( hdlg, idc, (UDWORD *)pudwValue/*mj*/ ) )
		{
			*pfCombo = VALUE_IS_ILLEGAL;
			break;
		}
		if( !*pfNum)
			*pfNum = fUpdateDependants = TRUE;

		if( *pudwValue == 0 )
			goto Redisplay;

		*pfCombo = VALUE_NOT_REDISPLAYED;
		break;

	case CBN_SELCHANGE:
		*pfNum = (int)SendMessage( hwnd, CB_GETCURSEL, 0, 0 ) != 0;
		if( *pfNum)
			*pudwValue = 0;

		goto WasRedisplayed;

	case CBN_DROPDOWN:
	case CBN_KILLFOCUS:
		if( *pfCombo != VALUE_NOT_REDISPLAYED )
			break;

Redisplay:
		if( (isel = 0, !*pfNum) || (isel++, *pudwValue == 0) )
			SendDlgItemMessage( hdlg, idc, CB_SETCURSEL, isel, 0 );
		else
			SetDlgItemLong(hdlg, idc, *pudwValue, FALSE );

WasRedisplayed:
		*pfCombo = VALUE_WAS_REDISPLAYED;
		fUpdateDependants = TRUE;
		break;
	}
	fChangedByApp = FALSE;
	return fUpdateDependants;
}

#ifdef MACINTOSH
#define FINFO_BASED
#else
#define FINFO_BASED SEG_BASED( lpfinfo )
#endif MACINTOSH

pascal BYTE FInitInputFlagArg( FINFO *lpfinfo, HWND hdlg, int idc, SDWORD fArg )
{
	HWND				hwnd = GetDlgItem(hdlg, idc);
	FNAM FINFO_BASED	*pfnam    = (FNAM FINFO_BASED *)lpfinfo->pfnamMin;
	FNAM FINFO_BASED	*pfnamMax = (FNAM FINFO_BASED *)lpfinfo->pfnamMax;

	fChangedByApp = TRUE;
	SendMessage( hwnd, CB_RESETCONTENT, 0, 0 );
	for( ; pfnam < pfnamMax; pfnam++ )
		SendMessage( hwnd, CB_ADDSTRING, 0,
			(LONG)(LPSTR)SzConstDisplay( pfnam->lszName, pfnam->fArg ) );

	SetDlgItemFlagArg( lpfinfo, hdlg, idc, FALSE, &fArg );
	return VALUE_WAS_REDISPLAYED;
}/* end FInitInputFlagArg */


pascal BOOL FProcInputFlagArgMsg(	FINFO *lpfinfo, HWND hdlg, int idc,
									WORD message, LPBYTE lpfCombo, PTR lpfArg )
{
	int		isel;
	SWORD	fArg;

	if( fChangedByApp )
		return FALSE;

	switch( message )
	{
	case CBN_EDITCHANGE:
		GetDlgItemText( hdlg, idc, OutStr, OUTSTRLEN );
		if( (lpfinfo->fLong ?
				(lpfinfo->fSigned ?
					FAToSDWord( OutStr, (SDWORD*)lpfArg) :
					FAToUDWord( OutStr, (UDWORD*)lpfArg)
				) :
				(lpfinfo->fSigned ?
					FAToSWord( OutStr, (SWORD*)lpfArg ) :
					FAToUWord( OutStr, (UWORD*)lpfArg )
				)) ||
			LszParseTextFlagArg( lpfinfo, lpfArg ) )
		{
			*lpfCombo = VALUE_NOT_REDISPLAYED;
			break;
		}
		*lpfCombo = VALUE_IS_ILLEGAL;
		break;

	case CBN_SELCHANGE:
		if( *lpfCombo != VALUE_NOT_REDISPLAYED )
		{
			isel = (int)SendDlgItemMessage( hdlg, idc, CB_GETCURSEL, 0, 0 );
			if( isel == CB_ERR )
			{
				*lpfCombo = VALUE_IS_ILLEGAL;
				break;
			}
			fArg = ((FNAM FINFO_BASED*)lpfinfo->pfnamMin + isel)->fArg;
			if( lpfinfo->fLong )
				 *(SDWORD*)lpfArg = fArg;
			else *(SWORD *)lpfArg = fArg;
		}
		else
			SetDlgItemFlagArg(lpfinfo, hdlg, idc, TRUE, lpfArg );

		*lpfCombo = VALUE_WAS_REDISPLAYED;
		return TRUE;

	case CBN_DROPDOWN:
	case CBN_KILLFOCUS:
		if( *lpfCombo != VALUE_NOT_REDISPLAYED)
			break;

		SetDlgItemFlagArg( lpfinfo, hdlg, idc, FALSE, lpfArg );
		*lpfCombo = VALUE_WAS_REDISPLAYED;
		return TRUE;
	}
	return FALSE;
}


#ifdef MACINTOSH
pascal BOOL FCheckInputFlagArg( HWND, int, LPBYTE, BYTE )
{
	return FALSE;
}
#elif WINDOWS
pascal BOOL FCheckInputFlagArg(
	HWND hdlg, int idc, LPBYTE lszName, BYTE fCombo)
{
	HWND hwnd;

	if( fCombo != VALUE_IS_ILLEGAL)
		return TRUE;

	hwnd = GetDlgItem(hdlg, idc);
	lstrcpy( OutStr, sz_Illegal);
	lstrcat( OutStr, lszName );
	MessageBox(hwnd, OutStr, sz_Error_input, MB_OK);
	SetFocus(hwnd);
	return FALSE;
}
#endif MACINTOSH elif WINDOWS


pascal LPBYTE LszParseTextFlagArg( FINFO FAR * lpfinfo, PTR lpfArg )
{
	UWORD				cchSame = lpfinfo->cchSame;
	SWORD				fArg = 0;
	BYTE *				pchName = OutStr;
	BYTE *				pchSep;
	FNAM FINFO_BASED *	pfnam    = (FNAM FINFO_BASED *)lpfinfo->pfnamMin;
	FNAM FINFO_BASED *	pfnamMax = (FNAM FINFO_BASED *)lpfinfo->pfnamMax;
	LPBYTE				lpchMatch;
	LPBYTE				lszName;
	LPBYTE				lsz;

	pchSep = strchr( pchName, ':' );	// Skip heading.
	if( pchSep )
		for( pchName = pchSep; *++pchName == ' '; )
			;
	pchSep = strpbrk( pchName, "= " );
	if( pchSep )
		*pchSep = '\0';

	strupr( pchName );
	lszName = NULL;
	for( ; pfnam < pfnamMax; pfnam++ )
	{
			// Skip this one if the entry doesn't match at all, or
			//  the match is only in the part that's the same for all:
			//
		lsz = pfnam->lszName;
//mj	if( (lpchMatch =         _fstrstr( lsz, pchName ) ) == NULL ||
		if( (lpchMatch = (LPBYTE)_fstrstr( lsz, pchName ) ) == NULL ||
			(UWORD)(lpchMatch - lsz + lstrlen( pchName )) <= cchSame &&
			_fstrstr( &lsz[ cchSame ], pchName ) == NULL )
			continue;

			// Remember this one if this is the first match, or if its
			//  unique part is a substring of the one remembered:

		if( lszName == NULL ||
			_fstrstr( lszName, &lsz[ cchSame ] ) != NULL )
		{
			lszName = lsz;
			fArg = pfnam->fArg;
			continue;
		}

			// Skip this one if the unique part of
			//  the one remembered is a substring:

		if( _fstrstr( lsz, &lszName[ cchSame ] ) )
			continue;

		return NULL;	// Ambiguous.
	}
	if( lszName )
	{
		if( lpfinfo->fLong)
			 *(SDWORD*)lpfArg = fArg;
		else *(SWORD*)lpfArg = fArg;
		}
	return lszName;
}


pascal VOID SetDlgItemFlagArg(	FINFO *lpfinfo,
								HWND hdlg, int idc, BOOL fSelChange, PTR lpfArg )
{
	int isel = fSelChange ? 0 : CB_ERR;
	SDWORD fArg =
		lpfinfo->fLong ?
			*(SDWORD*)lpfArg :
			(lpfinfo->fSigned ?
				(SDWORD)*(SWORD*)lpfArg :
				(SDWORD)*(UWORD*)lpfArg);
	SWORD fArgCur = 0;
	FNAM FINFO_BASED * pfnamMin = (FNAM FINFO_BASED *)lpfinfo->pfnamMin;
	FNAM FINFO_BASED * pfnamMax = (FNAM FINFO_BASED *)lpfinfo->pfnamMax;
	FNAM FINFO_BASED * pfnamCur;

	for( pfnamCur = pfnamMin; pfnamCur < pfnamMax; pfnamCur++ )
	{
		fArgCur = pfnamCur->fArg;
		if( fArg == fArgCur )
			fSelChange = FALSE;

		else if( !fSelChange || (fArgCur >= 0 ? fArg < 0 : fArg > 0) )
			continue;

		isel = pfnamCur - pfnamMin;
		if( fArgCur >= 0 ? fArg <= fArgCur : fArg >= fArgCur)
			break;
	}
	fChangedByApp = TRUE;
	if( isel == CB_ERR )
		SetDlgItemText( hdlg, idc, SzConstDisplay( NULL, fArg ) );
	else
	{
		SendDlgItemMessage(hdlg, idc, CB_SETCURSEL, isel, 0);
		if( fSelChange)
		{
			if( lpfinfo->fLong)
			{
				if( lpfinfo->fSigned)
					 *(SDWORD*)lpfArg = fArgCur;
				else *(UDWORD*)lpfArg = (UWORD)fArgCur;
			}
			else
				*(SWORD*)lpfArg = fArgCur;
		}
	}
	fChangedByApp = FALSE;
}


pascal LPBYTE LszNameFromFlagArg( FINFO *lpfinfo, SDWORD fArg )
{
	FNAM FINFO_BASED * pfnam    = (FNAM FINFO_BASED *)lpfinfo->pfnamMin;
	FNAM FINFO_BASED * pfnamMax = (FNAM FINFO_BASED *)lpfinfo->pfnamMax;

	for( ; pfnam < pfnamMax; pfnam++ )
		if( fArg == pfnam->fArg )
			return pfnam->lszName;

	return NULL;
}/* end LszNameFromFlagArg */


pascal BYTE * SzHexConstDisplay( LPBYTE lszName, UDWORD udwValue )
{
	static BYTE CSCONST szFormat[] = "0x%08lX";

	BYTE * pch;

	wsprintf( OutStr, szFormat, udwValue );
	if( (WORD)(DWORD)lszName )
	{
		lstrcpy( pch = &OutStr[ strlen( OutStr ) ], szEqual );
		lstrcpy( pch + 3, lszName );
	}
	return OutStr;
}
