
	//
	//  PROGRAM: mfqeng.c
	//	     Pending Copyright (C) 1992 Microsoft Corp.
	//
	//  PURPOSE: This is a Quuery Engine for various types of SQL queries
	//
	//  FUNCTIONS:
	//	    QueryEngine() - Executes many queries
	//
	//  FUNCTION: SQLMFQueryEngine(Pointer to ServerStruct)
	//
	//  PURPOSE:  Processes queries
	//

#include "gator.h"
#include "tests.h"
#include "mfqeng.h"
#include <stdio.h>
//mj	#include <dos.h>

#ifdef MACINTOSH
#include <dos.h>			// mj
#endif MACINTOSH

#define  SKIP_TEST 0
#define  EXECUTE_TEST 1
#define  FILE_ERROR -1

static char CSCONST szAppName[]	= "SQL_DRIVERS";
static char CSCONST szFileName[]	= "gator.ini";
static char CSCONST szNull[]	= "";
static char CSCONST szNoOpenQFile[]	= "Unable to open query file";
static char CSCONST szR[]	= "r";
static char CSCONST szFailAllocConnect[]	= "FAIL: SQLAllocConnect";
static char CSCONST szFailConnect[]	= "FAIL: Cannot connect to database";
static char CSCONST szSpace[]	= " ";
static char CSCONST szDone[]	= "Query Test Sucessfully completed";
static char CSCONST szErrorInput[]	= "Error reading input file";
static char CSCONST szFailDisconnect[]	= "NOTE: Failed to Disconnect";
static char CSCONST szFailFreeConnect[]	= "NOTE: Failed to FreeConnect";
static char CSCONST szMSG[]	= "MSG: ";
static char CSCONST szFailAllocate[]	= "failed to allocate memory for query";

#define MAXRETURN 600
typedef struct tagFetchedData {
	char sz[MAXRETURN];
}  FDSTRUCT;


pascal struct dostime_t * CElapsed( struct dostime_t *start,
	struct dostime_t *end,
	struct dostime_t *elapsed );
pascal struct dostime_t * CAddTime( struct dostime_t *start,
	struct dostime_t *end,
	struct dostime_t *elapsed );

#define QRYSIZ 100

extern QEStruct FAR * pQES;
#define ExecDirBind    0x0001
#define ExecDirGetData  0x0002
#define PrepExecBind   0x0004
#define PrepExecGetData 0x0008

pascal VOID BruceQueries( struct ServerStruct *pTestSource )
{
	RETCODE returncode;
	HENV		henv = SQL_NULL_HENV;
	HDBC     hdbc = SQL_NULL_HDBC;
	HSTMT    hstmt = SQL_NULL_HSTMT;
	int     hFile;
	OFSTRUCT FileStruct;
	int     hFS;
	char    sz[OUTSTRLEN];
	char    szDirectory[100];
	char    szFile[100];
	WORD fCombo = 0x0000;
	char    szFile2[100];
	char  FAR *pchQuery;
	int     i,c;   // temporary for reading of result rows
	int     cch;
	int     w;
	int     fExecDirect=1;
	int     fBindFetch=1;
	FDSTRUCT FAR *pFD;
	SWORD   cCol;
	char    szNum[100];
	struct dostime_t startmain;
	struct dostime_t finishmain;
	struct dostime_t elapsed;

	hFS=OpenFile( szFileName,&FileStruct,OF_EXIST );
	_lclose(hFS);
	
	if(!pQES)
	{
		pQES=(QEStruct FAR *)LockMemory(AllocateMemory(sizeof (QEStruct)));
		pQES->fExecFlags=0x0000;
		pQES->iStartNum=0;
		pQES->iEndNum=0;
	}

	pQES->fQeng=FALSE;
	
	cch=GetPrivateProfileString(szAppName,pTestSource->szSource,
		szNull,szDirectory,100,FileStruct.szPathName);
	if(*szDirectory==NULL)
		{
		szWrite("No test directory",TRUE);
		return;
		}

	strcat(szDirectory,"\\SQL_");
	strcpy(szFile,szDirectory);
	strcpy(szFile2,szDirectory);
	
	if(FDoDialogBox("Query_Engine",pTestSource->hwnd,QueryEngineDlg))
		return;

	fCombo=pQES->fExecFlags;
	while(fCombo){
		if(fCombo&ExecDirBind)
		{
			fExecDirect=1;
			fBindFetch=1;
			fCombo&=~ExecDirBind;
		}
		else if(fCombo&ExecDirGetData)
		{
			fExecDirect=1;
			fBindFetch=0;
			fCombo&=~ExecDirGetData;
		}
		else if(fCombo&PrepExecBind)
		{
			fExecDirect=0;
			fBindFetch=1;
			fCombo&=~PrepExecBind;
		}
		else
		{
			fExecDirect=0;
			fBindFetch=0;
			fCombo&=~PrepExecGetData;
		}

	if(SQL_SUCCESS!=SQLAllocEnv(&henv))
		{
		fStateCheck(henv,hdbc,hstmt,"00000");
		szWrite("FAIL: SQLAllocEnv",TRUE);
		return;
		}
	if(SQL_SUCCESS!=SQLAllocConnect(henv, &hdbc))
		{
		fStateCheck(henv,hdbc,hstmt,"00000");
		szWrite("FAIL: SQLAllocConnect",TRUE);
		return;
		}
	returncode=SQLConnect(hdbc,pTestSource->szValidServer0,SQL_NTS,
		pTestSource->szValidLogin0,SQL_NTS,
		pTestSource->szValidPassword0,SQL_NTS);
	if(returncode!=SQL_SUCCESS&&returncode!=SQL_SUCCESS_WITH_INFO)
		{
		fStateCheck(henv,hdbc,hstmt,"00000");
		szWrite(szFailConnect,TRUE);
		return;
		}

	wsprintf(&szFile[strlen(szDirectory)],"%04d.qry",1);
	hFile=OpenFile(szFile,&FileStruct,OF_READ);
	if(hFile<1)
	{
		szWrite("Can't open query file",TRUE);
		return;
	}
	lstrcpy((char FAR *)sz,szR);
	pchQuery=ReadQuery(hFile);
	w=_lclose(hFile);
	szWrite(pchQuery,TRUE);
	returncode=SQLAllocStmt(hdbc,&hstmt);
	returncode=SQLExecDirect(hstmt,pchQuery,SQL_NTS);

	wsprintf(&szFile[strlen(szDirectory)],"%04d.qry",2);
	hFile=OpenFile(szFile,&FileStruct,OF_READ);
	if(hFile<1)
	{
		szWrite("Can't open query file",TRUE);
		return;
	}
	lstrcpy((char FAR *)sz,szR);
	pchQuery=ReadQuery(hFile);
	w=_lclose(hFile);
	szWrite(pchQuery,TRUE);

	if(fExecDirect)
		szWrite("Using ExecDirect ",FALSE);
	else
		szWrite("Using Prepare/Execute ",FALSE);
	if(fBindFetch)
		szWrite("and BindCol to retrieve data",TRUE);
	else
		szWrite("and GetData to retrieve data",TRUE);
	
	if(fBindFetch)
		pFD=(FDSTRUCT FAR *)LockMemory(AllocateMemory(sizeof
			(FDSTRUCT) * 20));
	

	_dos_gettime(&startmain);

	for(i=0;i<600;i++)
		{

		if(fExecDirect)
			returncode=SQLExecDirect(hstmt,pchQuery,SQL_NTS);
		else
			{
			returncode=SQLPrepare(hstmt,pchQuery,SQL_NTS);
			returncode=SQLExecute(hstmt);
			}

		if(returncode==SQL_SUCCESS
			||returncode==SQL_SUCCESS_WITH_INFO)
			do{
				returncode=SQLNumResultCols(hstmt,&cCol);
				for(c=1;c<=cCol;c++)
					{
					returncode=SQLDescribeCol(
						hstmt,
						c,sz,100,NULL,NULL,
						NULL,NULL,NULL);
					if(fBindFetch)
						returncode=SQLBindCol(
							hstmt,c,
							SQL_C_CHAR,
							pFD[c-1].sz,
							MAXRETURN,
							NULL);
					}
				for(returncode=SQLFetch(hstmt)
					;returncode==SQL_SUCCESS
					;returncode=SQLFetch(hstmt))
					if(!fBindFetch)
						for(c=1;c<=cCol;c++)
							SQLGetData(hstmt,c,SQL_C_CHAR,sz,OUTSTRLEN,
								NULL);
			}
			while(SQL_SUCCESS==
				SQLMoreResults(hstmt));
		}

	_dos_gettime(&finishmain);
	returncode=SQLFreeStmt(hstmt,SQL_DROP);
	if(fBindFetch)
		ReleaseMemory(pFD);
		
	ReleaseMemory(pchQuery);

	CElapsed(&startmain,&finishmain,&elapsed);

	szWrite("",TRUE);
	szWrite("Total Execution Time: ",FALSE);
	wsprintf(szNum,"%02d:%02d:%02d.%02d",
		(int)elapsed.hour,(int)elapsed.minute,
		(int)elapsed.second,
		(int)elapsed.hsecond);
	szWrite(szNum,TRUE);

	if(SQL_SUCCESS!=SQLDisconnect(hdbc))
		{
		fStateCheck(henv,hdbc,hstmt,"00000");
		szWrite(szFailDisconnect,TRUE);
		return;
		}
	if(SQL_SUCCESS!=SQLFreeConnect(hdbc))
		{
		fStateCheck(henv,NULL,hstmt,"00000");
		szWrite(szFailFreeConnect,TRUE);
		return;
		}
	if(SQL_SUCCESS!=SQLFreeEnv(henv))
		{
		fStateCheck(NULL,hdbc,hstmt,"00000");
		szWrite("NOTE: Failed to FreeEnv",TRUE);
		return;
		}
	}
	return;
}
	
