
	//
	//  PROGRAM: mfqeng.c
	//	     Pending Copyright (C) 1992 Microsoft Corp.
	//
	//  PURPOSE: This is a Quuery Engine for various types of SQL queries
	//
	//  FUNCTIONS:
	//	    QueryEngine() - Executes many queries
	//
	//  FUNCTION: SQLMFQueryEngine(Pointer to ServerStruct)
	//
	//  PURPOSE:  Processes queries
	//

#include <stdio.h>
#undef NULL
#include "gator.h"
//#undef QUIET
#include "tests.h"
#include "mfqeng.h"
//mj	#include <dos.h>

#ifdef MACINTOSH
#include <dos.h>			// mj
	LPBYTE	itoa( int,  LPBYTE, int );
#endif MACINTOSH

#define SKIP_TEST 0
#define EXECUTE_TEST 1
#define FILE_ERROR -1

static char CSCONST szAppName[] = "SQL_DRIVERS";
static char CSCONST szFileName[] = "gator.ini";
static char CSCONST szNull[] = "";
static char CSCONST szNoOpenQFile[] = "Unable to open query file";
static char CSCONST szR[] = "r";
static char CSCONST szFailAllocConnect[] = "FAIL: SQLAllocConnect";
static char CSCONST szFailConnect[] = "FAIL: Cannot connect to database";
static char CSCONST szSpace[] = " ";
static char CSCONST szDone[] = "Query Test Sucessfully completed";
static char CSCONST szErrorInput[] = "Error reading input file";
static char CSCONST szFailDisconnect[] = "NOTE: Failed to Disconnect";
static char CSCONST szFailFreeConnect[] = "NOTE: Failed to FreeConnect";
static char CSCONST szMSG[] = "MSG: ";
static char CSCONST szFailAllocate[] = "ERROR: Unable to allocate memory to load file";

#define MAXRETURN 600
typedef struct tagFetchedData {
	char sz[ MAXRETURN ];
} FDSTRUCT;

	int  ChkSum( char FAR *, char FAR * );

	pascal struct dostime_t * CElapsed( struct dostime_t *start,
		struct dostime_t *end,
		struct dostime_t *elapsed );
	pascal struct dostime_t * CAddTime( struct dostime_t *start,
		struct dostime_t *end,
		struct dostime_t *elapsed );

#define QRYSIZ 100

QEStruct FAR * pQES = NULL;
#define ExecDirBind  0x0001
#define ExecDirGetData 0x0002
#define PrepExecBind  0x0004
#define PrepExecGetData 0x0008


pascal VOID SQLMFQueryEngine( struct ServerStruct *pTestSource )
{
	RETCODE   returncode;
	HENV      henv = NULL;
	HDBC      hdbc = NULL;
	HSTMT     hstmt = NULL;
	int       hFile;
	OFSTRUCT  FileStruct;
	int       hFS;
	OFSTRUCT  RFileStruct;
	int       hRFS;
	char      sz[OUTSTRLEN];
	char      szDirectory[100];
	char      szFile[100];
	char      szFile2[100];
	WORD      fCombo = 0x0000;
	char FAR *pchQuery;
	char FAR *pch;
	FILE     *pFile;
	int       i,c;  // temporary for reading of result rows
	int       cch;
	int       w;
	int       fExecDirect = 1;
	int       fBindFetch = 1;
	FDSTRUCT FAR *pFD;
	SWORD     cCol;
	int       cFAIL = 0;
	BOOL      fFAIL;
	BOOL      fFirst;
	BOOL      fExists;
	char      szNum[100];
	struct dostime_t startmain;
	struct dostime_t finishmain;
	struct dostime_t finish;
	struct dostime_t start;
	struct dostime_t elapsed;
	struct dostime_t elapsed1;
	struct dostime_t elapsed2;
	extern HCURSOR hSaveCursor;
	extern HCURSOR hHourGlass;

	hFS = OpenFile( szFileName, &FileStruct, OF_EXIST );
	_lclose( hFS );
	
	if(!pQES) {
		pQES = (QEStruct FAR *)LockMemory(AllocateMemory(sizeof (QEStruct)));
		pQES->fExecFlags = 0x0000;
		pQES->iStartNum = 1;
		pQES->iEndNum = 0;
	}

	pQES->fQeng = TRUE;

	cch = GetPrivateProfileString(szAppName, pTestSource->szSource, 
		szNull, szDirectory, 100, FileStruct.szPathName);
	if(*szDirectory == NULL) {
		szWrite( "No test directory", TRUE );
		return;
	}

	strcat( szDirectory, "\\SQL_" );
	strcpy( szFile, szDirectory );
	strcpy( szFile2, szDirectory );
	
	if( FDoDialogBox( "Query_Engine", pTestSource->hwnd, QueryEngineDlg ) )
		return;

//mj	hSaveCursor = SetCursor( hHourGlass );
	fCombo = pQES->fExecFlags;
	while( fCombo ) {
		if( fCombo & ExecDirBind ) {
			fExecDirect = 1;
			fBindFetch = 1;
			fCombo &= ~ExecDirBind;
		} else if( fCombo & ExecDirGetData ) {
			fExecDirect = 1;
			fBindFetch = 0;
			fCombo &= ~ExecDirGetData;
		} else if( fCombo & PrepExecBind ) {
			fExecDirect = 0;
			fBindFetch = 1;
			fCombo &= ~PrepExecBind;
		} else {
			fExecDirect = 0;
			fBindFetch = 0;
			fCombo &= ~PrepExecGetData;
		}

		FUNCCALL( sz_SQLAllocEnv );
		if( SQL_SUCCESS!= SQLAllocEnv( &henv ) ) {
			fStateCheck(henv, hdbc, hstmt, "00000" );
			szWrite( "FAIL: SQLAllocEnv", TRUE );
			return;
		}
		FUNCCALL( sz_SQLAllocConnect);
		if(SQL_SUCCESS!= SQLAllocConnect(henv, &hdbc)) {
			fStateCheck(henv, hdbc, hstmt, "00000");
			szWrite( "FAIL: SQLAllocConnect", TRUE );
			return;
		}
		FUNCCALL( sz_SQLConnect);
		returncode = SQLConnect(hdbc, pTestSource->szValidServer0, SQL_NTS, 
			pTestSource->szValidLogin0, SQL_NTS, 
			pTestSource->szValidPassword0, SQL_NTS);
		if(returncode!= SQL_SUCCESS&&returncode!= SQL_SUCCESS_WITH_INFO) {
			fStateCheck(henv, hdbc, hstmt, "00000");
			szWrite(szFailConnect, TRUE );
			return;
		}

		if(fExecDirect)
			szWrite( "Using ExecDirect ", FALSE );
		else
			szWrite( "Using Prepare/Execute ", FALSE );
		if(fBindFetch)
			szWrite( "and BindCol to retrieve data", TRUE );
		else
			szWrite( "and GetData to retrieve data", TRUE );

		_dos_gettime(&startmain);
		i = pQES->iStartNum;
		for(wsprintf(&szFile[strlen(szDirectory)], "%04d.qry", i)
			;(pQES->iStartNum > pQES->iEndNum || i <= pQES->iEndNum) &&
			(hFile = OpenFile(szFile, &FileStruct, OF_READ)) >= 1
			; wsprintf(&szFile[strlen(szDirectory)], "%04d.qry", i)) {
			if(FAbortCheck()) {
				szWrite( "**** QueryEngine aborted ****", TRUE );
				return;
			}

			szWrite( "", TRUE );
			szWrite( "Test Number: ", FALSE );
			wsprintf(szNum, "%04d", i);
			szWrite(szNum, TRUE );
			lstrcpy((char FAR *)sz, szR);
			pFile = fdopen(hFile, sz);
			pchQuery = ReadQuery(hFile);
			w = fclose(pFile);

			wsprintf(&szFile[strlen(szDirectory)], "%04d.msg", i);
			if((hFile = OpenFile(szFile, &FileStruct, OF_READ)) >= 1) {
				pFile = fdopen(hFile, sz);
				pch = ReadQuery(hFile);
				w = fclose(pFile);
				szWrite(pch, TRUE );
				ReleaseMemory(pch);
			}
			szWrite(pchQuery, TRUE );

			if(pchQuery) {
				FUNCCALL( sz_SQLAllocStmt);
				returncode = SQLAllocStmt(hdbc, &hstmt);
				fStateCheck(henv, hdbc, hstmt, "00000");
				if(fExecDirect) {
					_dos_gettime(&start);
					FUNCCALL( sz_SQLExecDirect);
					returncode = SQLExecDirect(hstmt, pchQuery, SQL_NTS);
					_dos_gettime(&finish);
					CElapsed(&start, &finish, &elapsed);
				} else {
					_dos_gettime(&start);
					FUNCCALL( sz_SQLPrepare);
					returncode = SQLPrepare(hstmt, pchQuery, SQL_NTS);
					_dos_gettime(&finish);
					CElapsed(&start, &finish, &elapsed1);
					fStateCheck(henv, hdbc, hstmt, "00000");

					_dos_gettime(&start);
					FUNCCALL( sz_SQLExecute);
					returncode = SQLExecute(hstmt);
					_dos_gettime(&finish);
					CElapsed(&start, &finish, &elapsed2);
					CAddTime(&elapsed1, &elapsed2, &elapsed);
				}

				fStateCheck(henv, hdbc, hstmt, "00000");
				if(returncode == SQL_SUCCESS
					|| returncode == SQL_SUCCESS_WITH_INFO) {
					szWrite( "Query Execution Time: ", FALSE );
					wsprintf(szNum, "%02d:%02d:%02d.%02d", 
						(int)elapsed.hour, (int)elapsed.minute, 
						(int)elapsed.second, (int)elapsed.hsecond);
					szWrite(szNum, TRUE );
					wsprintf(&szFile[strlen(szDirectory)], "%04d.act", i);
					hRFS = OpenFile(szFile, &RFileStruct, OF_CREATE|OF_WRITE);
					fFirst = TRUE;
					_dos_gettime(&start);
					do {
						FUNCCALL( sz_SQLNumResultCols);
						returncode = SQLNumResultCols(hstmt, 
							&cCol);
						fStateCheck(henv, hdbc, hstmt, "00000");
						if(fBindFetch)
							pFD = (FDSTRUCT FAR *)LockMemory(AllocateMemory(
								sizeof (FDSTRUCT) * cCol));
						if(!fFirst)
							_lwrite(hRFS, "\015\n", 2);
						else
							fFirst = FALSE;

						for(c = 1; c <= cCol; c++) {
							FUNCCALL( sz_SQLDescribeCol);
							returncode = SQLDescribeCol(hstmt, c, sz, 100,
								NULL, NULL, NULL, NULL, NULL);
							if(returncode!= SQL_SUCCESS)
								fStateCheck(henv, hdbc, hstmt, "00000");
							_lwrite(hRFS, sz, lstrlen(sz));
							if(c < cCol)
								_lwrite(hRFS, ", ", 1);
							if(fBindFetch) {
								FUNCCALL( sz_SQLBindCol);
								returncode = SQLBindCol(hstmt, c, SQL_C_CHAR, 
									pFD[c-1].sz, MAXRETURN, NULL);
								if(returncode!= SQL_SUCCESS)
									fStateCheck(henv, hdbc, hstmt, "00000");
							}
						}
						_lwrite(hRFS, "\015\n", 2);
		
						if(cCol) {
							FUNCCALL( sz_SQLFetch);
							for(returncode = SQLFetch(hstmt)
								; returncode == SQL_SUCCESS
								; returncode = SQLFetch(hstmt)) {
							fStateCheck(henv, hdbc, hstmt, "00000");
							for(c = 1;c <= cCol;c++) {
								if(fBindFetch)
									_lwrite(hRFS, pFD[c-1].sz, 
										lstrlen(pFD[c-1].sz));
									else {
										FUNCCALL( sz_SQLGetData);
										SQLGetData(hstmt, c, SQL_C_CHAR, sz,
											OUTSTRLEN, NULL);
										if(returncode!= SQL_SUCCESS)
											fStateCheck(henv, hdbc, hstmt,
												"00000");
										_lwrite(hRFS, sz, strlen(sz));
									}
									if(c < cCol)
										_lwrite(hRFS, ", ", 1);
								}
								_lwrite(hRFS, "\015\n", 2);
							}
						}
						if(fBindFetch)
							ReleaseMemory(pFD);

						FUNCCALL( sz_SQLGetFunctions);
						returncode = SQLGetFunctions(hdbc, 
							SQL_API_SQLMORERESULTS, &fExists);
						if(returncode == SQL_SUCCESS && fExists) {
							FUNCCALL( sz_SQLMoreResults);
							returncode = SQLMoreResults(hstmt);
						} else
							returncode = SQL_NO_DATA_FOUND;
					}
					while(SQL_SUCCESS == returncode);
					fStateCheck(henv, hdbc, hstmt, "00000");
					_dos_gettime(&finish);
					CElapsed(&start, &finish, &elapsed);
					szWrite( "Result Retrieval Time: ", FALSE );
					wsprintf(szNum, "%02d:%02d:%02d.%02d", 
						(int)elapsed.hour, (int)elapsed.minute, 
						(int)elapsed.second, (int)elapsed.hsecond);
					szWrite(szNum, TRUE );

					w = _lclose(hRFS);
					wsprintf(&szFile2[strlen(szDirectory)], "%04d.rst", i);
					fFAIL = ChkSum(szFile, szFile2);
					cFAIL += fFAIL;
				} else {
					cFAIL++;
					fFAIL = TRUE;
					EchoRetcode(" Execute/ExecDirect", 
						returncode);
				}
				if(fFAIL)
					szWrite( " FAILED", TRUE );
				else
					szWrite( "----PASSED----", TRUE );
				FUNCCALL( sz_SQLFreeStmt);
				returncode = SQLFreeStmt(hstmt, SQL_DROP);
				hstmt = NULL;
				fStateCheck(henv, hdbc, hstmt, "00000");

				ReleaseMemory(pchQuery);
			} else {
				szWrite( " Query not executed", TRUE );
				cFAIL++;
			}
			i++;
		}
		_dos_gettime(&finishmain);
		CElapsed(&startmain, &finishmain, &elapsed);

		szWrite( "", TRUE );
		szWrite( "Total Execution Time: ", FALSE );
		wsprintf( szNum, "%02d:%02d:%02d.%02d", 
			(int)elapsed.hour, (int)elapsed.minute, 
			(int)elapsed.second, (int)elapsed.hsecond );
		szWrite( szNum, TRUE );

		szWrite( "Completed queries: ", FALSE );
		szWrite( itoa( i-pQES->iStartNum, szNum, 10 ), TRUE );
		szWrite( "Failures: ", FALSE );
		szWrite( itoa( cFAIL, szNum, 10), TRUE );


		FUNCCALL( sz_SQLDisconnect);
		if(SQL_SUCCESS!= SQLDisconnect( hdbc )) {
			fStateCheck(henv, hdbc, hstmt, "00000");
			szWrite(szFailDisconnect, TRUE );
			return;
		}
		FUNCCALL( sz_SQLFreeConnect);
		if( SQL_SUCCESS!= SQLFreeConnect( hdbc )) {
			fStateCheck( henv, NULL, hstmt, "00000");
			szWrite( szFailFreeConnect, TRUE );
			return;
		}
		FUNCCALL( sz_SQLFreeEnv );
		if(SQL_SUCCESS!= SQLFreeEnv( henv )) {
			fStateCheck( NULL, hdbc, hstmt, "00000" );
			szWrite( "NOTE: Failed to FreeEnv", TRUE );
			return;
		}
	}
	return;
}

#define SZLEN 500
	
pascal char FAR * ReadQuery(int hFile)

{
	char FAR *pchQueryBuf;
	int cch;


	pchQueryBuf = LockMemory(AllocateMemory(32L*1024+1));
		if(!pchQueryBuf)
			{
			szWrite(szFailAllocate, TRUE );
			ReleaseMemory(pchQueryBuf);
			return NULL;
			}

	cch = _lread(hFile, pchQueryBuf, 32767);
	if(32L*1024L <= cch)
		{
		szWrite( "ERROR: File too large", TRUE );
		pchQueryBuf[32L*1024+1] = '\0';
		}
	else
		pchQueryBuf[cch] = '\0';
		
	return pchQueryBuf;
}

int ChkSum(char FAR *file1, char FAR *file2)
{
	OFSTRUCT FileStruct1, FileStruct2;
	int hF1, hF2;
	int w;
	char sz[100];
	char sz1[SZLEN];
	char sz2[SZLEN];
	char *pch1;
	char *pch2;
	FILE *pF1, *pF2;

	hF1 = OpenFile(file1, &FileStruct1, OF_READ);
	if(hF1 < 1)
		{
		szWrite( "Could not open file: ", FALSE );
		szWrite(file1, TRUE );
		return 1;
		}

	lstrcpy((char FAR *)sz, szR);
	pF1 = fdopen(hF1, sz);

	hF2 = OpenFile(file2, &FileStruct2, OF_READ);
	if(hF2 < 1)
		{
		szWrite( "Could not open file: ", FALSE );
		szWrite(file2, TRUE );
		w = fclose(pF1);
		return 1;
		}

	pF2 = fdopen(hF2, sz);

	*sz1 = '\0';
	*sz2 = '\0';
	for(pch1 = fgets(sz1, SZLEN-1, pF1), 	pch2 = fgets(sz2, SZLEN-1, pF2)
		;pch1 == sz1 || pch2 == sz2
		;pch1 = fgets(sz1, SZLEN-1, pF1), 	pch2 = fgets(sz2, SZLEN-1, pF2))
		{
		if(strcmp(sz1, sz2)!= 0)
			{
			szWrite( " OutPut files did not match: ", FALSE );
			szWrite(file1, FALSE );
			szWrite( " ", FALSE );
			szWrite(file2, TRUE );
			w = fclose(pF1);
			w = fclose(pF2);
			return 1;
			}
		}

	w = fclose(pF1);
	w = fclose(pF2);
	return 0;
}


pascal BOOL QueryEngineDlg( HWND hdlg, unsigned message, WORD wparam, 
	LONG /*lParam*/ )
{
	int		fDlgStatus;
	BOOL	Translated;
	
	switch( message )
	{
	case WM_INITDIALOG:
		CenterDlg( hdlg );
		CheckDlgButton( hdlg, IDC_EDB, pQES->fExecFlags&ExecDirBind );
		CheckDlgButton( hdlg, IDC_EDG, pQES->fExecFlags&ExecDirGetData );
		CheckDlgButton( hdlg, IDC_PEB, pQES->fExecFlags&PrepExecBind );
		CheckDlgButton( hdlg, IDC_PEG, pQES->fExecFlags&PrepExecGetData );
		if(pQES->fQeng)
		{
			SetDlgItemInt( hdlg, IDC_STARTTEST, pQES->iStartNum, TRUE );
			if(pQES->iEndNum)
				SetDlgItemInt( hdlg, IDC_ENDTEST, pQES->iEndNum, TRUE );
		}

		EnableWindow( GetDlgItem( hdlg, IDC_STARTTEST), pQES->fQeng );
		EnableWindow( GetDlgItem( hdlg, IDC_BEGINTEXT), pQES->fQeng );
		EnableWindow( GetDlgItem( hdlg, IDC_ENDTEST  ), pQES->fQeng );
		EnableWindow( GetDlgItem( hdlg, IDC_ENDTEXT  ), pQES->fQeng );

		goto NextMessage;

	case WM_COMMAND:
		switch( wparam )
		{
		case IDOK:

			if( IsDlgButtonChecked( hdlg, IDC_EDB ) )
				pQES->fExecFlags |= ExecDirBind;
			else
				pQES->fExecFlags &= ~ExecDirBind;

			if( IsDlgButtonChecked( hdlg, IDC_EDG ) )
				pQES->fExecFlags |= ExecDirGetData;
			else
				pQES->fExecFlags &= ~ExecDirGetData;

			if( IsDlgButtonChecked( hdlg, IDC_PEB ) )
				pQES->fExecFlags |= PrepExecBind;
			else
				pQES->fExecFlags &= ~PrepExecBind;

			if( IsDlgButtonChecked( hdlg, IDC_PEG ) )
				pQES->fExecFlags |= PrepExecGetData;
			else
				pQES->fExecFlags &= ~PrepExecGetData;

			pQES->iStartNum = GetDlgItemInt( hdlg, IDC_STARTTEST, 
				&Translated, TRUE );
			pQES->iEndNum = GetDlgItemInt( hdlg, IDC_ENDTEST, 
				&Translated, TRUE );

			fDlgStatus = IDOK;
			goto EndOfDialog;
		case IDCANCEL:
			fDlgStatus = IDCANCEL;
			goto EndOfDialog;
		}
	}

		// Let Windows Process this event
		//
	return FALSE;

NextMessage:
	return TRUE;

EndOfDialog:
	EndDialog( hdlg, fDlgStatus );
	return TRUE;
}
