
	/* Created 3/12/93 4:58 PM by AppMaker	*/

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <Resources.h>
#include <TextEdit.h>
#include <ToolUtils.h>
#include <Sysequ.h>

#include "ResourceDefs.h"
#include "Globals.h"
#include "Miscellany.h"
#include "Windowing.h"
#include "ODBCappData.h"
#include "ODBCtest.h"
#include <SQL.H>


#define sBarWidth  		16                                 

#define Scroll1			1 
#define hDBCPopup		2 
#define hSTMTPopup		3 
#define Line4			4 
#define Scroll5			5 
#define inField			6 
#define hDBCLabel		7 
#define hStmtLabel		8 
#define Line9			9 
#define outField		10 
#define Scroll11		11 

#pragma segment ODBCtest 

	windowPop	DBCpop;
	windowPop	STMTpop;

#define MAXOUTPUT  1000

	static char	cmOutputSink[ MAXOUTPUT ];
	int			iOutputPos = 0;

	extern pascal void ScrollinWindowH(  short delta );
	extern pascal void ScrollinWindowV(  short delta );
	extern pascal void ScrollOutWindowH( short delta );
	extern pascal void ScrollOutWindowV( short delta );


void calcFieldRects()
{
	short		midPoint;

	midPoint = 32 + (curWindow->portRect.bottom - 32)/3;

	cur->teIn.top		= 32 + 10;
	cur->teIn.bottom	= midPoint - 10;
	cur->teIn.left		= 10;
	cur->teIn.right		= curWindow->portRect.right - sBarWidth - 10;

	cur->teOut.top		= midPoint + 10;
	cur->teOut.bottom	= curWindow->portRect.bottom - sBarWidth - 10;
	cur->teOut.left		= 10;
	cur->teOut.right	= curWindow->portRect.right  - sBarWidth - 10;

	return;
}/* end calcFieldRects */


void OpenODBCtest( Str255 fName, short vRefNum, short fRefNum )
{
	WindowPtr		newWindow;
//	Rect			bounds;

  
	newWindow = GetWindow( ODBCtestID );
	if( fName[ 0 ] )
		SetWTitle( newWindow, fName );
	SetPort( newWindow );
	SetNewInfo( newWindow );
	cur->hScroll		= GetNewControl( 128, newWindow );
	cur->Scroll5Handle	= GetNewControl( 129, newWindow );
	cur->vScroll		= GetNewControl( 130, newWindow );

	(**cur->Scroll5Handle).contrlAction	= (ProcPtr)ScrollinWindowV;
	(**cur->vScroll).contrlAction		= (ProcPtr)ScrollOutWindowV;
	(**cur->hScroll).contrlAction		= (ProcPtr)ScrollOutWindowH;
//	(**cur->xScroll).contrlAction		= (ProcPtr)ScrollinWindowH;


	cur->fileNum		= fRefNum;
	cur->volNum			= vRefNum;
	cur->dirty			= false;
	cur->filename		= NewString( fName );
	cur->windowKind		= WODBCtest;
	( (WindowPeek)curWindow )->windowKind = userKind + WODBCtest;
	cur->wictHandle	= GetResource( 'Wict', ODBCtestID );

	DBCpop.choice	= 1;
	DBCpop.menuID	= hDBCID;
	DBCpop.popRect.top		= 0;
	DBCpop.popRect.left		= 52;
	DBCpop.popRect.bottom	= 18;
//	DBCpop.popRect.right	= DBCpop.popRect.left + (**DBCpop.hMenu).menuWidth;
	DBCpop.popRect.right	= DBCpop.popRect.left + 188;
	InsertMenu( DBCpop.hMenu, -1 );	/* -1 means hierarchical menu	*/

	STMTpop.choice	= 1;
	STMTpop.menuID	= hSTMTID;
	STMTpop.popRect.top		= 0;
	STMTpop.popRect.left	= 316;
	STMTpop.popRect.bottom	= 18;
	STMTpop.popRect.right	= STMTpop.popRect.left + 64;
	InsertMenu( STMTpop.hMenu, -1 );

	calcFieldRects();

	SetWFont( inField );
	cur->inFieldHandle = TENew( &cur->teIn, &cur->teIn );
	TESetJust(  textJust, cur->inFieldHandle );
	TEAutoView( true,     cur->inFieldHandle );

	SetWFont( outField );
	cur->outFieldHandle = TENew( &cur->teOut, &cur->teOut );
	TESetJust(  textJust,	cur->outFieldHandle );
	TEAutoView( true,		cur->outFieldHandle );

	cur->text = cur->inFieldHandle;

	ShowWindow( newWindow );
	return;
}/* end OpenODBCtest */


void CloseODBCtest()
{
	TEDispose( cur->inFieldHandle  );
	TEDispose( cur->outFieldHandle );
		
	DisposHandle( (Handle)cur->filename );
	DiscardInfo( curWindow );
	return;
}/* end CloseODBCtest */


void TypeInODBCtest( char ch )
{
	if( cur->text == nil )
		SysBeep( 1 );
	else
	{
		TEKey( ch, cur->text );
		cur->dirty = true;
	}
	return;
}/* end TypeInODBCtest */


void DrawGrayLine( Rect bounds )
{
	PenState		savePen;

	GetPenState( &savePen );
	PenNormal();
	PenPat( &qd.gray );
	MoveTo( bounds.left, bounds.top );
	LineTo( bounds.right - 1, bounds.bottom - 1 );
	SetPenState( &savePen );
	return;
}/* end DrawGrayLine */


void TextIDBox( short textID, Rect bounds )
{
	Handle		text;

	text = GetResource( 'TEXT', textID );
	if( text )
	{
		LoadResource( text );
		HLock( text );
		TextBox(  *text, GetHandleSize( text ), &bounds, textJust );
		HUnlock( text );
	}
	return;
}/* end TextIDBox */


void UpdateWindowPop( windowPop *pwp )
{
	Str255			menuItem;
	Rect			bounds;
	PolyHandle		arrowTriangle;


	CalcMenuSize( pwp->hMenu );
//	pwp->popRect.right = pwp->popRect.left + (**pwp->hMenu).menuWidth;
	bounds = pwp->popRect;
	bounds.left		+= 12;
	GetItem( pwp->hMenu, pwp->choice, menuItem );
	TextBox( &menuItem[1], menuItem[0], &bounds, teJustLeft );

	arrowTriangle = OpenPoly();
	MoveTo( bounds.right - 17, bounds.top + 7 );
	Line( 5, 5 );
	Line( 5, -5 );
	Line( -10, 0 );
	ClosePoly();
	FillPoly( arrowTriangle, &qd.black );
	KillPoly( arrowTriangle );

	bounds = pwp->popRect;
	--bounds.right;
	--bounds.bottom;
	FrameRect( &bounds );
	MoveTo( bounds.right,		bounds.top + 2	);
	LineTo( bounds.right,		bounds.bottom	);
	LineTo( bounds.left + 2,	bounds.bottom	);
	return;
}/* end UpdateWindowPop */


void UpdateODBCtest()
{
	Rect		bounds;
	short		midPoint;


	midPoint = 32 + (curWindow->portRect.bottom - 32)/3;

	UpdateWindowPop( &DBCpop  );
	UpdateWindowPop( &STMTpop );

	TEUpdate( &cur->teIn,	cur->inFieldHandle  );
	TEUpdate( &cur->teOut,	cur->outFieldHandle );

	SetWFont( hDBCLabel  );
	bounds = DBCpop.popRect;
	bounds.left = 12;	bounds.right = 52;
	TextIDBox( 128, bounds );

	SetWFont( hStmtLabel );
	bounds.left = 268;	bounds.right = 316;
	TextIDBox( 129, bounds );

	cur->line4.top		= 32;
	cur->line4.bottom	= cur->line4.top + 1;
	cur->line4.left		= 0;
	cur->line4.right	= curWindow->portRect.right - sBarWidth;
	DrawGrayLine( cur->line4 );

	cur->line9.top		= midPoint;
	cur->line9.bottom	= cur->line9.top + 1;
	cur->line9.left		= 0;
	cur->line9.right	= curWindow->portRect.right - sBarWidth;
	DrawGrayLine( cur->line9 );

	DrawClippedGrow( -15, -15 );

	return;
}/* end UpdateODBCtest */


void ActivateODBCtest( Boolean )
{
	DrawClippedGrow( -15, -15 );
	return;
}/* end ActivateODBCtest */


pascal void WriteBottomWindow( char *lsz, BOOL fRedraw )
{
	unsigned short	cch = strlen( lsz );

		/*
		** If we are supposed to put out a newline, then
		** write the current saved output buffer and the
		** new text.  We are done.
		*/

	if( fRedraw  ||  (cch + iOutputPos >=  MAXOUTPUT)  )
	{
		if( iOutputPos )
		{
			TEInsert( cmOutputSink, iOutputPos, cur->outFieldHandle );
			iOutputPos = 0;
		}

		TEInsert( lsz, cch, cur->outFieldHandle );
		return;	
	}

		/* Otherwise save the string in the output area.  We
		** know that there is room (from above)
		*/

	strcpy( &cmOutputSink[ iOutputPos ], lsz );
	iOutputPos += cch;

	return;
}/* end WriteBottomWindow */
