
	// This module implements the functions in the Receive
	// and Misc menus which require dialogs.


#include <types.h>
#include "gator.h"
#include "adhoc.h"
#include "receive.h"
#include <stdio.h>
#include <ctype.h>
#include <ToolUtils.h>	// for HiWord

#include <dos.h>			// mj

#pragma segment receive


#define _fmemcpy	memcpy
#define HIWORD		HiWord


	INIT_ASSERT

#define MIN(x,y)	( (x) <= (y) ? (x) : (y) )
#define MAX(x,y)	( (x) >= (y) ? (x) : (y) )
#define SendMessage(w,x,y,z)

	extern char		OutStr[ OUTSTRLEN ];	// One global OutStr!

	extern STMTINFO		*lrgstmtinfo;
	extern STMTINFO		*lpstmtinfoMax;

		// These are uneditable input values:
	extern HSTMT hstmt;
	extern UWORD istmt;

		// These values are init at launch, then remembered between <func> calls:
	UWORD	icol               = 1;
	SWORD	fCType             = SQL_C_CHAR;
//	SWORD	cbColNameMax       = MAX_CBCOLNAME;
	SDWORD	cbValueMax         = 300;
	UWORD	fFetchType         = SQL_FETCH_NEXT;
	SDWORD	irow               = 1;
//	BOOL	fNull_szColName    = FALSE;
//	BOOL	fNull_pcbColName   = FALSE;
//	BOOL	fNull_pfSqlType    = FALSE;
//	BOOL	fNull_pcbColDef    = FALSE;
//	BOOL	fNull_pibScale     = FALSE;
//	BOOL	fNull_pfNullable   = FALSE;
//	BOOL	fNull_rgbValue     = FALSE;
//	BOOL	fNull_pcbValue     = FALSE;
//	BOOL	fNull_pcrow        = FALSE;
//	BOOL	fNull_rgfRowStatus = FALSE;
//	BOOL	fNull_pccol        = FALSE;

//	static BOOL		fNew_lpccol;
//	static BOOL		fNew_lpcrow;
//	static BOOL		fNew_lrgfRowStatus;

		// Constants in storage:
	UDWORD udwUNTOUCHED = UNTOUCHED;

	extern FINFO	finfo_fCType;
	extern FINFO	finfo_fSqlType_NoAll;
	extern FINFO	finfo_fNullable_WithUnknown;

			BYTE CSCONST szEqual[]         = " = ";
			BYTE CSCONST szSpace[]         = " ";
			BYTE CSCONST szComma[]         = ", ";
			BYTE CSCONST szPeriod[]        = ".";
			BYTE CSCONST szColon[]         = ": ";
			BYTE CSCONST szExclam[]        = "! ";
			BYTE CSCONST sz_Error[]        = "***Error*** ";
			BYTE CSCONST sz_untouched[]    = "untouched";
	
			BYTE CSCONST sz_fFetchType[]   = "fFetchType";
			BYTE CSCONST sz_irow[]         = "irow";
			BYTE CSCONST sz_apcrow[]       = "*pcrow";
			BYTE CSCONST sz_icol[]         = "icol";
			BYTE CSCONST sz_ipar[]         = "ipar";
			BYTE CSCONST sz_fCType[]       = "fCType";
			BYTE CSCONST sz_cbColNameMax[] = "cbColNameMax";
			BYTE CSCONST sz_cbValueMax[]   = "cbValueMax";
			BYTE CSCONST sz_apcbValue[]    = "*pcbValue";
			BYTE CSCONST sz_rgbValue[]     = "rgbValue";
			BYTE CSCONST sz_null_pointer[] = "null pointer";
	
			BYTE CSCONST szMismatchFormat[] = "%ld != length of %s = %ld!";

#define MIN_CBMAX sizeof( TIMESTAMP_STRUCT )

	// CalculateBufdat() bufdat argument struct:

typedef struct
{
	SDWORD	cbMaxImplied;
	SDWORD	cbTouched;
	SDWORD	cbImplied;
	SDWORD	cchImplied;
	SDWORD	cchActual;
	UWORD	cbDataType;
	UWORD	fTypeClass;
	UWORD	fExpect_argb;
	BOOL	fNullTerm;
	BOOL	fUntouched_cb;
	BOOL	fUntouched_argb;
	BOOL	fImplied_cb;
	BOOL	fNoData;
	BOOL	fNoDataOK;
	BOOL	fNullCheckFailed;
	BOOL	fCbWrong;
	} BUFDAT;

	// fTypeClass values:
	//
#define TYPE_FIXED    0x0001	// Fixed length numeric type
#define TYPE_VARIABLE 0x0002	// Variable length binary type
#define TYPE_CHAR     0x0004	// Character string
#define TYPE_UNKNOWN  0x0007	// Unknown

	// fExpect_argb values:
	//
#define EXPECT_UNTOUCHED 0x0001
#define EXPECT_TOUCHED   0x0002
#define EXPECT_UNKNOWN   0x0003

static pascal VOID CalculateBufdat( SWORD fCType, SDWORD cbValue,
									SDWORD cbMax, BYTE HUGE * hrgb,
									BUFDAT * pbufdat );


pascal VOID DisplayNumRefs( RETCODE retcode, BOOL fParam, SWORD *lpcref )
{
	static BYTE CSCONST sz_apccol[] = "*pccol";
	static BYTE CSCONST sz_apcpar[] = "*pcpar";

	EchoRetcode( fParam ? sz_SQLNumParams : sz_SQLNumResultCols, retcode );

	if( retcode == SQL_STILL_EXECUTING )
		return;

	if( lpcref != NULL
	 && FCheckArg( fParam ? sz_apcpar : sz_apccol,
					*lpcref == (SWORD)UNTOUCHED, retcode < SQL_SUCCESS, TRUE ) )
	{
		sprintf( OutStr, "%10d", *lpcref );	//	itoa( *lpcref, OutStr, 10 );
		szWrite( OutStr, FALSE );
		szWrite( szPeriod, TRUE );
	}
}


pascal VOID DescribeRefAll( BOOL fParam, SWORD cref )
{
	static BYTE CSCONST sz_canceled[]          = " canceled.";
	static BYTE CSCONST sz_DescribeParam_All[] = "DescribeParam All";
	static BYTE CSCONST sz_DescribeCol_All[]   = "DescribeCol All";

	int fHead = 1;
	UWORD iref;
	UCHAR szColName[MAX_CBCOLNAME + 1];
	SWORD cbColName;
	SWORD fSqlType;
	UDWORD cbColDef;
	SWORD ibScale;
	SWORD fNullable;
	RETCODE retcode;

	for( iref = 1; (SWORD)iref <= cref; iref++)
		{
		Untouch(szColName, sizeof szColName);
		cbColName = (SWORD)UNTOUCHED;
		fSqlType  = (SWORD)UNTOUCHED;
		cbColDef = (UDWORD)UNTOUCHED;
		ibScale   = (SWORD)UNTOUCHED;
		fNullable = (SWORD)UNTOUCHED;

		if( FAbortCheck())
			{
			szWrite(
				LszIfSz(fParam, sz_DescribeParam_All, sz_DescribeCol_All),
				FALSE );
			szWrite( sz_canceled, TRUE );
			break;
			}

		for( ;;)
			{
			StackCheck( TRUE );
			retcode = fParam ?
				SQLDescribeParam( hstmt, iref,
					&fSqlType, &cbColDef, &ibScale, &fNullable) :
				SQLDescribeCol( hstmt, iref,
					szColName, MAX_CBCOLNAME, &cbColName,
					&fSqlType, &cbColDef, &ibScale, &fNullable);
			StackCheck( FALSE );

			if( retcode != SQL_STILL_EXECUTING)
				break;

			if( FAbortCheck())
				{
				StackCheck( FALSE );
				EchoRetcode(
					LszIfSz(fParam,
						sz_SQLDescribeParam, sz_SQLDescribeCol),
					retcode );
				StackCheck( TRUE );
				retcode = SQLCancel( hstmt);
				StackCheck( FALSE );
				EchoRetcode(sz_SQLCancel, retcode );
				return;
				}
			}

		DisplayDescribeRef(fParam,
			fHead, retcode, iref,
			szColName, MAX_CBCOLNAME,
			&cbColName,
			&fSqlType,
			&cbColDef,
			&ibScale,
			&fNullable);
		fHead = 0;
		}
}


pascal VOID DisplayDescribeRef( BOOL fParam,
	int fHead, RETCODE retcode, UWORD iref,
	UCHAR *lszColName, SWORD cbColNameMax,
	SWORD *lpcbColName,
	SWORD *lpfSqlType,
	UDWORD *lpcbColDef,
	SWORD *lpibScale,
	SWORD *lpfNullable )
		//
		//	fHead == 2 - Echo the retcode, and label each value
		//					with its variable name.
		//	fHead == 1 - Display the heading and list of values.
		//	fHead == 0 - Display the list of values.
		//
		//	If retcode is not sucessful, echo the retcode
		//		and label each descrepant value anyway.
{
	static BYTE CSCONST sz_apcbColName[] = "*pcbColName";
	static BYTE CSCONST sz_szColName[]   = "szColName";
	static BYTE CSCONST sz_apfSqlType[]  = "*pfSqlType";
	static BYTE CSCONST sz_apcbColDef[]  = "*pcbColDef";
	static BYTE CSCONST sz_apibScale[]   = "*pibScale";
	static BYTE CSCONST sz_apfNullable[] = "*pfNullable";

	BOOL fInfo = retcode == SQL_SUCCESS_WITH_INFO;
	BOOL fFail = retcode != SQL_SUCCESS && !fInfo;
	BOOL fVerbose = fHead > 1 || fFail;
	BYTE *lsz_iref = fParam ? sz_ipar : sz_icol;

	if( fHead == 1)
		{
		if( fParam)
			{
			static BYTE CSCONST szFormat[] = "%s, %s, %s, %s, %s:";
			
			wsprintf( OutStr, szFormat, lsz_iref,
				(LPSTR)sz_apfSqlType, (LPSTR)sz_apcbColDef,
				(LPSTR)sz_apibScale, (LPSTR)sz_apfNullable);
			}
		else
			{	// if DescribeCol
			static BYTE CSCONST szFormat[] = "%s, %s, %s, %s, %s, %s, %s:";
			
			wsprintf( OutStr, szFormat, lsz_iref,
				(LPSTR)sz_apcbColName, (LPSTR)sz_szColName,
				(LPSTR)sz_apfSqlType, (LPSTR)sz_apcbColDef,
				(LPSTR)sz_apibScale, (LPSTR)sz_apfNullable);
			}
		szWrite( OutStr, TRUE );
		}
	if( fHead > 1)
		{
		szWrite( lsz_iref, FALSE );
		szWrite( szEqual, FALSE );
		}
	ltoa(iref, OutStr, 10);
	szWrite( OutStr, FALSE );
	if( fVerbose)
		szWrite( szComma, FALSE );

	if( fHead > 1 && !fParam)
		{
		szWrite( sz_cbColNameMax, FALSE );
		szWrite( szEqual, FALSE );
		sprintf( OutStr, "%10d", cbColNameMax );	//	itoa( cbColNameMax, OutStr, 10);
		szWrite( OutStr, FALSE );
		szWrite( szColon, TRUE );
		}
	if( fVerbose)
		EchoRetcode(
			LszIfSz(fParam, sz_SQLDescribeParam, sz_SQLDescribeCol),
			retcode );

	if( retcode == SQL_STILL_EXECUTING)
		return;

	if( !fParam)	// if DescribeCol
		FDisplayCbAndRgbArgs( retcode,
			fVerbose ? MID_LINE : MID_LINE | NO_NAMES, SQL_C_CHAR,
			sz_apcbColName, lpcbColName, cbColNameMax,
			sz_szColName, lszColName);

	if( (SEGMENT)lpfSqlType != NULL &&
		FCheckArg(sz_apfSqlType,
			*lpfSqlType == (SWORD)UNTOUCHED, fFail, fVerbose))
		szWrite(
			SzConstDisplay(
				LszNameFromFlagArg(&finfo_fSqlType_NoAll, *lpfSqlType ),
				*lpfSqlType ),
			FALSE );

	if( fVerbose && FNeedSeparator() )
		szWrite( szComma, TRUE );

	if( (SEGMENT)lpcbColDef != NULL &&
		FCheckArg(sz_apcbColDef,
			*lpcbColDef == (UDWORD)UNTOUCHED, fFail, fVerbose))
		{
		ultoa(*lpcbColDef, OutStr, 10);
		szWrite( OutStr, FALSE );
		}

	if( (SEGMENT)lpibScale != NULL &&
		FCheckArg(sz_apibScale,
			*lpibScale == (SWORD)UNTOUCHED, fFail, fVerbose))
	{
		sprintf( OutStr, "%10d", *lpibScale );	// itoa(*lpibScale, OutStr, 10);
		szWrite( OutStr, FALSE );
	}

	if( lpfNullable != NULL
	 && FCheckArg(sz_apfNullable,
			*lpfNullable == (SWORD)UNTOUCHED, fFail, fVerbose ) )
		szWrite(
				SzConstDisplay(	LszNameFromFlagArg(	&finfo_fNullable_WithUnknown,
													*lpfNullable ),
								*lpfNullable ),
				FALSE );

	if( FNeedSeparator() )
		szWrite( szPeriod, TRUE );

	if( !fParam
	 && ( lpcbColName != NULL && *lpcbColName >= cbColNameMax)
	 != fInfo )
	{
		static BYTE CSCONST sz_Warning[]   = "***Warning*** ";
		static BYTE CSCONST sz_was[]       = " was ";
		static BYTE CSCONST sz_not[]       = "not ";
		static BYTE CSCONST sz_trunc_but[] = "truncated, but ";
		static BYTE CSCONST sz_returned[]  = "returned!";

		szWrite( LszIfSz( fInfo, sz_Warning, sz_Error ), FALSE );
		szWrite( sz_szColName, FALSE );
		szWrite( sz_was, FALSE );
		if( fInfo)
			szWrite( sz_not, FALSE );

		szWrite( sz_trunc_but, FALSE );
		szWrite( sz_SQL_SUCCESS_WITH_INFO, FALSE );
		szWrite( sz_was, FALSE );
		if( !fInfo )
			szWrite( sz_not, FALSE );

		szWrite( sz_returned, TRUE );
	}
}


	// Find and release the entry with the same hstmt, fParam, and iref
	// if it exists; if not fUnbind, insert the new entry; return TRUE;
	// else, if no hstmt found or fUnbind, return FALSE.
	//
pascal BOOL FInsertBound(HSTMT hstmt, BOOL fParam, UWORD iref,
	LPBOUND lpbound, BOOL fUnbind)
{
	LPBOUND *lplpbound;
	LPBOUND         lpboundNext;

	if( (SEGMENT)(lplpbound = LplpboundFirstFromHstmt( hstmt)) == NULL )
		return FALSE;

	for( ; (SEGMENT)(lpboundNext = *lplpbound) != NULL;
		 lplpbound = &lpboundNext->ref.lpboundNext)
		if( !!lpboundNext->ref.fParam == !!fParam &&
			lpboundNext->ref.iref >= iref)
			{
			if( lpboundNext->ref.iref == iref)
				DeleteBound(lplpbound);

			break;
			}
	if( fUnbind || (SEGMENT)lpbound == NULL )
		return FALSE;

	lpbound->ref.lpboundNext = *lplpbound;
	lpbound->ref.fParam      = fParam;
	lpbound->ref.iref        = iref;
	*lplpbound = lpbound;
	return TRUE;
}


pascal UWORD IcolUntouchBoundCols(HSTMT hstmt)
{
	UWORD icolBoundMost = 0;
	LPBOUND *lplpbound;
	LPBOUND         lpbound;
	LPAF *lplpaf = LplpafFromHstmt( hstmt);
	LPAF         lpaf = *lplpaf;

	if( (SEGMENT)lpaf != NULL ||
		(SEGMENT)(lplpbound = LplpboundFirstFromHstmt( hstmt)) == NULL )
		return FALSE;

	for( lpbound = *lplpbound; (SEGMENT)lpbound != NULL;
		 lpbound = lpbound->col.lpboundNext )
	{
		if( lpbound->col.fParam != FALSE )  // not a col
			continue;

		lpbound->col.cbValue = (SDWORD)UNTOUCHED;
		Untouch( lpbound->col.rgbValue,
					MAX( lpbound->col.cbValueMax, MIN_CBMAX ) + 1 );
		icolBoundMost = lpbound->col.icol;
	}
	return icolBoundMost;
}


pascal UWORD IcolBoundColChecks(
	HSTMT hstmt, UWORD fModes, RETCODE retcode )
{
	static BYTE CSCONST szFormat_for_icol[] = " for column %u ";

	BOOL fExpectUntouched;
	BOOL fAnyBound = FALSE;
	BOOL fUntouchedSeen = FALSE;
	BOOL fTouchedError = FALSE;
	UWORD icolTouchedMost = 0;
	LPBOUND *lplpbound = LplpboundFirstFromHstmt( hstmt);
	LPBOUND         lpbound;

	if( lplpbound == NULL )
		return 0;

	fExpectUntouched = fModes & ALWAYS_UNTOUCHED ||
		retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO;

	for( lpbound = *lplpbound; lpbound; lpbound = lpbound->col.lpboundNext )
	{
		BOOL	fNull_rgb;
		BOOL	fNull_pcb;
		UWORD	icol;
		SWORD	fCType;
		SDWORD	cbValueMax;
		SDWORD	cbValue;
		HPVOID	hrgbValue;
		BUFDAT	bufdat;

		if( lpbound->col.fParam != FALSE )  // not a col
			continue;

		fAnyBound = TRUE;
		fNull_rgb = lpbound->col.fNull_rgb;
		fNull_pcb = lpbound->col.fNull_pcb;
		if( fNull_pcb && fNull_rgb)
			continue;

		icol       = lpbound->col.icol;
		fCType     = lpbound->col.fCType;
		cbValueMax = lpbound->col.cbValueMax;
		cbValue    = lpbound->col.cbValue;
		hrgbValue  = lpbound->col.rgbValue;

		bufdat.fNoData			= FALSE;
		bufdat.cbDataType		= CbFromFCType( fCType );
		bufdat.cbMaxImplied		= MAX( cbValueMax, MIN_CBMAX );
		bufdat.fUntouched_cb	= fNull_pcb || cbValue == (SDWORD)UNTOUCHED;
		bufdat.cbTouched		= 0;
		if( !fNull_rgb )
			bufdat.cbTouched = CbTouchedRgbCbMax( hrgbValue, bufdat.cbMaxImplied );
		bufdat.fUntouched_argb = bufdat.cbTouched == 0;

		CalculateBufdat( fCType, cbValue, cbValueMax, hrgbValue, &bufdat);

		if( bufdat.fNullCheckFailed )
		{
			static BYTE CSCONST szMsg[] = "is not zero filled!";

			szWrite( sz_Error, FALSE );
			szWrite( sz_rgbValue, FALSE );
			wsprintf( OutStr, szFormat_for_icol, icol );
			szWrite( OutStr, FALSE );
			szWrite( szMsg, TRUE );
			break;
		}
		if( !bufdat.fUntouched_cb && !bufdat.fUntouched_argb )
			switch( bufdat.fTypeClass )
			{
			case TYPE_CHAR:
				if( !bufdat.fNullTerm )
				{
					static BYTE CSCONST szMsg[] = "is unterminated!";

					szWrite( sz_Error, FALSE );
					szWrite( sz_rgbValue, FALSE );
					wsprintf( OutStr, szFormat_for_icol, icol );
					szWrite( OutStr, FALSE );
					szWrite( szMsg, TRUE );
				}
				if( bufdat.cchActual != bufdat.cchImplied )
				{
					szWrite( sz_Error, FALSE );
					szWrite( sz_apcbValue, FALSE );
					szWrite( szEqual, FALSE );
					wsprintf( OutStr, szMismatchFormat, bufdat.cchImplied,
						(LPBYTE)sz_rgbValue, bufdat.cchActual);
					szWrite( OutStr, TRUE );
				}
				DisplayBytesUntouchedError( sz_rgbValue,
										bufdat.cbTouched, bufdat.cchImplied + 1);
				break;

			case TYPE_FIXED:
				if( bufdat.cbTouched > bufdat.cbImplied )
					DisplayBytesUntouchedError(sz_rgbValue,
						bufdat.cbTouched, bufdat.cbImplied );

				break;
		}
		if( !bufdat.fUntouched_cb || !bufdat.fUntouched_argb )
		{
			BYTE CSCONST *szVarName;

			icolTouchedMost = icol;
			if( fExpectUntouched || fUntouchedSeen)
				fTouchedError = TRUE;

			if( (szVarName = sz_apcbValue, !fNull_pcb && bufdat.fUntouched_cb )
			 || (szVarName = sz_rgbValue,  !fNull_rgb && bufdat.fUntouched_argb
			     && bufdat.fExpect_argb == EXPECT_TOUCHED) )
			{
				static BYTE CSCONST szMsg[] = "is unexpectedly untouched!";

				szWrite( sz_Error,	FALSE );
				szWrite( szVarName,	FALSE );
				wsprintf( OutStr, szFormat_for_icol, icol );
				szWrite( OutStr,	FALSE );
				szWrite( szMsg,		TRUE );
			}
		}
		else if( !fNull_pcb )
		{
			fUntouchedSeen = TRUE;
			if( !fExpectUntouched && icol == 1 )
			{
				static BYTE CSCONST	szMsg[] =
								"The bound buffers for column 1 are untouched!";

				szWrite( sz_Error,	FALSE );
				szWrite( szMsg,		TRUE );
				}
			}
		}
	if( !fAnyBound )
		return 0;

	if( fTouchedError )
	{
		static BYTE CSCONST sz_not_all[] =
							"The bound column buffers are not all untouched!";
		static BYTE CSCONST sz_after[]   =
							"Found touched bound column buffers after untouched!";

		szWrite( sz_Error, FALSE );
		szWrite(LszIfSz(fExpectUntouched, sz_not_all, sz_after), TRUE );
	}
	if( (fExpectUntouched || !(fModes & NO_ICOL_DISPLAY)) &&
		icolTouchedMost > 0)
	{
		static BYTE CSCONST szFormat[] = "The highest bound icol affected = %u.";

		if( fExpectUntouched )
			szWrite( sz_Error, FALSE );

		wsprintf( OutStr, szFormat, icolTouchedMost );
		szWrite( OutStr, TRUE );
	}
	return icolTouchedMost;
}


pascal VOID ShowBoundCols( HWND hwnd )
{
	static BYTE CSCONST szHead[] =
							"hstmt, icol, fCType, cbValueMax, pcbValue, rgbValue:";

	LPBOUND		*lplpbound, lpbound;
	SWORD		fCType;
	SDWORD		cbValueMax;

	if( (SEGMENT)(lplpbound = LplpboundFirstFromHstmt( hstmt)) == NULL )
		return;

	// Change cursor to hourglass

	SetCapture( hwnd );
//mj	hSaveCursor = SetCursor(hHourGlass);

	szWrite( szHead, TRUE );

	for( lpbound = *lplpbound; lpbound; lpbound = lpbound->col.lpboundNext )
	{
		if( lpbound->col.fParam != FALSE )  // not a col
			continue;

		fCType     = lpbound->col.fCType;
		cbValueMax = lpbound->col.cbValueMax;

		szWrite("#",		FALSE );
		ltoa(istmt, OutStr, 10 );
		szWrite( OutStr,	FALSE );
		szWrite( szColon,	FALSE );

		ltoa(lpbound->col.icol, OutStr, 10 );
		szWrite( OutStr,	FALSE );
		szWrite( szComma,	FALSE );

		szWrite(
			SzConstDisplay( LszNameFromFlagArg( &finfo_fCType, fCType ), fCType ),
			FALSE );
		szWrite( szComma, FALSE );

		ltoa( cbValueMax, OutStr, 10);
		szWrite( OutStr, FALSE );

		FDisplayCbAndRgbArgs( 0,
						LPCB_SDWORD | HRGB_MIN_SIZE | NO_NAMES | BOUND_COLS,
						fCType, sz_apcbValue,
						lpbound->col.fNull_pcb ? NULL : &lpbound->col.cbValue,
						cbValueMax, sz_rgbValue,
						lpbound->col.fNull_rgb ? NULL : lpbound->col.rgbValue );
		}

	// Reset cursor

//	SetCursor( hSaveCursor );
//	ReleaseCapture();
}


pascal LPBOUND * LplpboundFirstFromHstmt( HSTMT hstmt )
{
	STMTINFO	*lpstmtinfo;

	lpstmtinfo = LpstmtinfoFromHstmt( hstmt );
	if( lpstmtinfo == NULL )
		return NULL;

	return &lpstmtinfo->lpboundFirst;
}


pascal BOOL FreeParamsAndCols( UWORD fWhat, HSTMT hstmt )
{
	BOOL		fSuccess = TRUE;
	BOOL		fAll = fWhat > FREE_BOTH;
	STMTINFO	*lpstmtinfo;

	if( !fAll && hstmt == SQL_NULL_HSTMT )
		return fSuccess;

	for( lpstmtinfo = &lrgstmtinfo[0]; lpstmtinfo < lpstmtinfoMax; lpstmtinfo++ )
		if( fAll || lpstmtinfo->hstmt == hstmt)
		{
			LPBOUND		*lplpbound = &lpstmtinfo->lpboundFirst;
			LPBOUND		lpbound;

			while( (lpbound = *lplpbound) != NULL )
				if( lpbound->ref.fParam + 1 & fWhat)
					DeleteBound( lplpbound );
				else
					lplpbound = &lpbound->ref.lpboundNext;

			if( !fAll )
				break;	// Free only one hstmt.
		}
	return fSuccess;
}


pascal void DeleteBound(LPBOUND *lplpbound)
{
	LPBOUND lpbound = *lplpbound;

	*lplpbound = lpbound->ref.lpboundNext;
	ReleaseMemory( lpbound);
}


static FNAM CSCONST rgfnam_fFetchType[] =
	{
		{ SQL_FETCH_NEXT,		sz_SQL_FETCH_NEXT		},
		{ SQL_FETCH_FIRST,		sz_SQL_FETCH_FIRST		},
		{ SQL_FETCH_LAST,		sz_SQL_FETCH_LAST		},
		{ SQL_FETCH_PREV,		sz_SQL_FETCH_PREV		},
		{ SQL_FETCH_ABSOLUTE,	sz_SQL_FETCH_ABSOLUTE	},
		{ SQL_FETCH_RELATIVE,	sz_SQL_FETCH_RELATIVE	},
		{ SQL_FETCH_RESUME,		sz_SQL_FETCH_RESUME		}
	};
DeclareFinfo(fFetchType, "SQL_FETCH_", FINFO_UWORD, GLOBAL);

static FNAM CSCONST rgfnam_fRowStatus[] =
	{
		{ SQL_ROW_SUCCESS,	sz_SQL_ROW_SUCCESS	},
		{ SQL_ROW_DELETED,	sz_SQL_ROW_DELETED	},
		{ SQL_ROW_UPDATED,	sz_SQL_ROW_UPDATED	},
		{ SQL_ROW_NOROW,	sz_SQL_ROW_NOROW	}
	};
DeclareFinfo( fRowStatus, "SQL_ROW_", FINFO_UWORD, static );

pascal VOID DisplayExtendedFetch( RETCODE retcode, UWORD fFetchType,
	SDWORD irow, UDWORD *lpcrow, UWORD *lrgfRowStatus )
{
	static BYTE CSCONST sz_rgfRowStatus[] = "rgfRowStatus";

	szWrite( sz_fFetchType, FALSE );
	szWrite( szEqual, FALSE );
	szWrite(
		SzConstDisplay(
			LszNameFromFlagArg(&finfo_fFetchType, fFetchType ), fFetchType ),
		FALSE );
	szWrite( szComma, FALSE );
	szWrite( sz_irow, FALSE );
	szWrite( szEqual, FALSE );
	ltoa( irow, OutStr, 10 );
	szWrite( OutStr, FALSE );
	szWrite( szColon, TRUE );

	EchoRetcode( sz_SQLExtendedFetch, retcode );

	if( retcode == SQL_STILL_EXECUTING)
		return;

	if( lpcrow != NULL &&
		FCheckArg(sz_apcrow, *lpcrow == (UDWORD)UNTOUCHED,
			retcode < SQL_SUCCESS, TRUE ) )
	{
		ultoa( *lpcrow, OutStr, 10 );
		szWrite( OutStr, FALSE );
	}
	if( lrgfRowStatus )
	{
		UWORD	*lpfRowStatus = &lrgfRowStatus[0];
		UWORD cw = (UWORD)
			(CbTouchedRgbCbMax( lrgfRowStatus, MAX_CROW * sizeof( UWORD ) ) +
			 							sizeof( UWORD ) - 1) / sizeof( UWORD );
		UWORD	*lpfRowStatusMax = lpfRowStatus + cw;
		int		cbDisplayed = 2;

		if( FCheckArg( sz_rgfRowStatus, cw == 0, retcode < SQL_SUCCESS, TRUE ) )
			for(;;)
			{
				UWORD fRowStatus = *lpfRowStatus;

				if( fRowStatus == (UWORD)UNTOUCHED)
				{
					szWrite( sz_Error,		FALSE );
					szWrite( sz_untouched,	FALSE );
					szWrite( szExclam,		FALSE );
				}
				else
					szWrite(	SzConstDisplay(
									LszNameFromFlagArg( &finfo_fRowStatus,
										fRowStatus ),
									fRowStatus ),
								FALSE );

				if( ++lpfRowStatus >= lpfRowStatusMax )
					break;

				szWrite( szSpace, ++cbDisplayed >= 8 && (cbDisplayed = 0, TRUE ) );
			}
	}
	if( FNeedSeparator() )
		szWrite( szPeriod, TRUE );
	return;
}


pascal VOID DisplayGetData( RETCODE retcode, SWORD fCType,
						HPVOID hrgbValue, SDWORD cbValueMax, SDWORD *lpcbValue )
{
	EchoRetcode( sz_SQLGetData, retcode );

	if( retcode == SQL_STILL_EXECUTING)
		return;

	FDisplayCbAndRgbArgs(	retcode, LPCB_SDWORD | HRGB_MIN_SIZE, fCType,
							sz_apcbValue, lpcbValue, cbValueMax,
							sz_rgbValue, hrgbValue );
	return;
}/* end DisplayGetData */


	// FDisplayCbAndRgbArgs() - display ODBC function cb and rgb output args.

	//	retcode  - return code from the ODBC function
	//	fModes   - the OR of one or more of the following masks:
	//		NO_DATA_CHECK | NEED_DATA_OK | LPCB_SDWORD |
	//		MID_LINE | NO_NAMES | BOUND_COLS | INFO_VALUE |
	//		HRGB_IN_OUT | HRGB_UNTOUCHED | HRGB_MIN_SIZE
	//
	//		NO_DATA_CHECK  if special checks are needed when SQL_NO_DATA_FOUND
	//		NEED_DATA_OK   if SQL_NEED_DATA is valid for the ODBC function
	//		LPCB_SDWORD    if lpcb is SDWORD FAR *, else it is SWORD FAR *
	//		MID_LINE       if more output will appear on the same line
	//		NO_NAMES       if arg values should not be prefixed with names
	//		BOUND_COLS     if called from ShowBoundCols
	//		INFO_VALUE     if DisplayInfoValue should be called
	//		HRGB_IN_OUT    if hrgb is an input/output argument
	//		HRGB_UNTOUCHED if the input in hrgb was untouched
	//		HRGB_MIN_SIZE  if sizeof hrgb >= MIN_CBMAX

	//	fCType   - Any one of the ODBC type constants
	//	lsz_apcb - name of the lpcb arg as a character string
	//	lpcb     - the pcb output arg from the ODBC function - if
	//				LPCB_SDWORD, then this is SDWORD FAR *, else SWORD FAR *
	//	cbMax    - the cbMax input arg to the ODBC function
	//	lsz_rgb  - name of the rgb or sz arg
	//	hrgb     - the rgb or sz arg from the ODBC function

pascal BOOL FDisplayCbAndRgbArgs(	RETCODE retcode, UWORD fModes, SWORD fCType,
									LPBYTE lsz_apcb, PTR lpcb, SDWORD cbMax,
									LPBYTE lsz_rgb, HPBYTE hrgb	)
{
	static BYTE CSCONST szImpliedFormat[]    = " (implied = %ld";
	static BYTE CSCONST sz2ndImpliedFormat[] = " or %ld";
	static BYTE CSCONST szCloseParen[]       = ")";

	BOOL	fNewLine = !(fModes & NO_NAMES) && FNeedSeparator();
	BOOL	fBoundCols = fModes & BOUND_COLS;
	BOOL	fSuccess;
	BOOL	fNull_rgb;
	BOOL	fNull_pcb;
	SDWORD	cbValue = 0;
	BUFDAT	bufdat;

	bufdat.fNoData = fModes & NO_DATA_CHECK && retcode == SQL_NO_DATA_FOUND;
	fNull_rgb = hrgb == NULL;
	fNull_pcb = lpcb == NULL;
	bufdat.cbDataType	= CbFromFCType( fCType );
	bufdat.cbMaxImplied	= fModes & HRGB_MIN_SIZE
									? MAX( cbMax, MIN_CBMAX ) : MAX( cbMax, 0 );
	bufdat.fUntouched_cb = fNull_pcb
							? TRUE
							: (fModes & LPCB_SDWORD
								? (cbValue = *(SDWORD*)lpcb ) == (SDWORD)UNTOUCHED
								: (cbValue = *(SWORD*)lpcb )  == (SWORD)UNTOUCHED);
	bufdat.cbTouched = CbTouchedRgbCbMax(hrgb, bufdat.cbMaxImplied );
	bufdat.fUntouched_argb = fModes & HRGB_IN_OUT ?
			fModes & HRGB_UNTOUCHED &&
			bufdat.cbTouched <=
			MIN( (SDWORD)bufdat.cbDataType, bufdat.cbMaxImplied ) :
			bufdat.cbTouched == 0;

	CalculateBufdat( fCType, cbValue, cbMax, hrgb, &bufdat );

	fSuccess = retcode == SQL_SUCCESS ||
		retcode == SQL_SUCCESS_WITH_INFO || bufdat.fNoData ||
		fModes & NEED_DATA_OK && retcode == SQL_NEED_DATA;
	if( fSuccess && !fNull_pcb && !fBoundCols )
		DisplayUntouchedError( lsz_apcb, bufdat.fUntouched_cb, FALSE );

	if( bufdat.fUntouched_cb ? fBoundCols : !bufdat.fNoDataOK)
	{
		if( FNeedSeparator() )
			szWrite( szComma, FALSE );

		if( !(fModes & NO_NAMES) )
		{
			szWrite( lsz_apcb, FALSE );
			szWrite( szEqual, FALSE );
		}
	}
	if( bufdat.fUntouched_cb )
	{
		if( fBoundCols )
			szWrite(
				LszIfSz(fNull_pcb, sz_null_pointer, sz_untouched ),
				FALSE );
	}
	else
	{
		if( !bufdat.fNoDataOK )
		{
			if( bufdat.fNoData ? cbValue != 0 :
					cbValue < 0 && cbValue != SQL_NULL_DATA &&
					cbValue != SQL_NO_TOTAL || bufdat.fCbWrong )
				szWrite( sz_Error, FALSE );

			szWrite(
				SzConstDisplay(	LszIfSz(	cbValue == SQL_NULL_DATA,
											sz_SQL_NULL_DATA,
											LszIfSz(cbValue == SQL_NO_TOTAL,
												sz_SQL_NO_TOTAL, NULL ) ),
								cbValue ),
				FALSE );
		}
		if( bufdat.fImplied_cb )
		{
			wsprintf( OutStr, szImpliedFormat,
				bufdat.fTypeClass == TYPE_CHAR ?
					bufdat.cchImplied : bufdat.cbImplied );
			szWrite( OutStr, FALSE );
			if( bufdat.fTypeClass == TYPE_UNKNOWN &&
				bufdat.cchImplied != bufdat.cbImplied )
			{
				wsprintf( OutStr, sz2ndImpliedFormat, bufdat.cchImplied );
				szWrite( OutStr, FALSE );
			}
			szWrite( szCloseParen, FALSE );
		}
		if( bufdat.fCbWrong )
		{
			static BYTE CSCONST szFormat[] = " != %u!";

			wsprintf( OutStr, szFormat, bufdat.cbDataType );
			szWrite( OutStr, FALSE );
		}
	}
	if( fSuccess && !fNull_rgb &&
		!(fBoundCols || bufdat.fExpect_argb == EXPECT_UNKNOWN) )
		DisplayUntouchedError( lsz_rgb, bufdat.fUntouched_argb,
								bufdat.fExpect_argb == EXPECT_UNTOUCHED );

	if( (!bufdat.fUntouched_argb || fBoundCols) && !bufdat.fNoDataOK )
	{
		if( FNeedSeparator() )
			szWrite( szComma, FALSE );

		if( fNewLine)
			szWrite( szSpace, TRUE );

		if( bufdat.fNullCheckFailed )
			szWrite( sz_Error, FALSE );

		if( !(fModes & NO_NAMES) )
		{
			szWrite( lsz_rgb, FALSE );
			szWrite( szEqual, FALSE );
		}
	}
	if( bufdat.fUntouched_argb )
	{
		if( fBoundCols)
			szWrite(	LszIfSz( fNull_rgb, sz_null_pointer, sz_untouched ),
						FALSE );

		if( !(fModes & MID_LINE) && FNeedSeparator() )
			szWrite( szPeriod, TRUE );

		return FALSE;
	}
	if( !bufdat.fNoDataOK )
	{
		if( fModes & INFO_VALUE )
			DisplayInfoValue(	fCType, hrgb,
								(SWORD)bufdat.cbTouched, (SWORD)cbValue );
		else
			DisplayOutputBuf(	fCType, hrgb, bufdat.cbTouched );
	}
	if( !bufdat.fUntouched_cb )
		switch( bufdat.fTypeClass )
		{
		case TYPE_CHAR:
			if( bufdat.cchActual != bufdat.cchImplied )
			{
				if( FNeedSeparator() )
					szWrite( szSpace, TRUE );

				szWrite( sz_Error, FALSE );
				szWrite( lsz_apcb, FALSE );
				szWrite( szEqual, FALSE );
				wsprintf( OutStr, szMismatchFormat, bufdat.cchImplied,
					lsz_rgb, bufdat.cchActual);
				szWrite( OutStr, TRUE );
			}
			DisplayBytesUntouchedError( lsz_rgb,
				bufdat.cbTouched, bufdat.cchImplied + 1);
			break;

		case TYPE_FIXED:
			if( bufdat.cbTouched > bufdat.cbImplied )
				DisplayBytesUntouchedError( lsz_rgb,
					bufdat.cbTouched, bufdat.cbImplied );

			break;
		}
	if( !(fModes & MID_LINE) && FNeedSeparator() )
		szWrite( szPeriod, TRUE );

	return TRUE;
}


static pascal VOID CalculateBufdat( SWORD fCType, SDWORD cbValue,
									SDWORD cbMax, BYTE HUGE * hrgb,
									BUFDAT * pbufdat )
{
	BOOL fNullData_cb = cbValue < 0 && cbValue != SQL_NO_TOTAL;
	BOOL fZero_cb			= cbValue == 0;
	BOOL fPos_cb			= !(fZero_cb || fNullData_cb );
	BOOL fNullCheck_argb	= FALSE;
	BOOL fNullCheck_asz		= FALSE;
	BOOL fImplied_cb		= FALSE;
	BOOL fImplied_cch		= FALSE;
	BYTE HUGE * hpb;

	switch(  fCType )
	{
	case SQL_C_CHAR:	pbufdat->fTypeClass = TYPE_CHAR;		break;
	case SQL_C_BINARY:
	case SQL_C_DEFAULT:	pbufdat->fTypeClass = TYPE_UNKNOWN;		break;
	default:			pbufdat->fTypeClass = TYPE_FIXED;		break;
	}
	if( pbufdat->fUntouched_cb )
	{
		switch( pbufdat->fTypeClass )
		{
		case TYPE_CHAR:
#ifdef SQL_NULL_DATA_UNTOUCHED
			pbufdat->fExpect_argb = cbMax > 0 ? EXPECT_UNKNOWN : EXPECT_UNTOUCHED;
#else
			pbufdat->fExpect_argb = cbMax > 0 ? EXPECT_TOUCHED : EXPECT_UNTOUCHED;
#endif
			break;

		case TYPE_FIXED:
#ifdef SQL_NULL_DATA_UNTOUCHED
			pbufdat->fExpect_argb = EXPECT_UNKNOWN;
#else
			pbufdat->fExpect_argb = EXPECT_TOUCHED;
#endif
			break;

		case TYPE_UNKNOWN:
#ifdef SQL_NULL_DATA_UNTOUCHED
			pbufdat->fExpect_argb = EXPECT_UNKNOWN;
#else
			pbufdat->fExpect_argb = cbMax > 0 ?
					EXPECT_TOUCHED : EXPECT_UNKNOWN;
#endif
			break;
		}
	}
	else
	{
		pbufdat->fNullTerm = !pbufdat->fUntouched_argb &&
			hrgb[pbufdat->cbTouched - 1] == '\0';
		pbufdat->cchActual = pbufdat->fUntouched_argb ?
				0L : pbufdat->cbTouched - pbufdat->fNullTerm;
		pbufdat->cbImplied = pbufdat->cchImplied = 0;
		switch( pbufdat->fTypeClass )
		{
		case TYPE_CHAR:
#ifdef SQL_NULL_DATA_UNTOUCHED
			pbufdat->fExpect_argb = cbMax > 0 && !fNullData_cb ?
												EXPECT_TOUCHED : EXPECT_UNTOUCHED;
#else
			pbufdat->fExpect_argb = cbMax > 0 ? EXPECT_TOUCHED : EXPECT_UNTOUCHED;
#endif
			goto CharCalcs;

		case TYPE_FIXED:
#ifdef SQL_NULL_DATA_UNTOUCHED
			pbufdat->fExpect_argb = fPos_cb ? EXPECT_TOUCHED : EXPECT_UNTOUCHED;
#else
			pbufdat->fExpect_argb = EXPECT_TOUCHED;
#endif
			pbufdat->cbImplied = pbufdat->cbDataType;
			if( fNullData_cb )
				fNullCheck_argb = fImplied_cb = TRUE;
			break;

		case TYPE_UNKNOWN:
#ifdef SQL_NULL_DATA_UNTOUCHED
			pbufdat->fExpect_argb = fNullData_cb ?
					EXPECT_UNTOUCHED :
					(cbMax > 0 ?
						EXPECT_TOUCHED :
						(fZero_cb ? EXPECT_UNTOUCHED : EXPECT_UNKNOWN));
#else
			pbufdat->fExpect_argb = cbMax > 0 ?
					EXPECT_TOUCHED :
					(fZero_cb ? EXPECT_UNTOUCHED : EXPECT_UNKNOWN );
#endif
			if( fPos_cb )
			{
				pbufdat->cbImplied = MAX( cbMax, 0 );
				fImplied_cb = cbValue == SQL_NO_TOTAL ||
					cbValue > pbufdat->cbImplied;
				if( !fImplied_cb )
					pbufdat->cbImplied = cbValue;
			}
			else if( fNullData_cb )
			{
				fNullCheck_argb = fImplied_cb = TRUE;
				pbufdat->cbImplied = pbufdat->cbTouched;
			}
CharCalcs:
			if( fPos_cb )
			{
				pbufdat->cchImplied = MAX( cbMax - 1, 0 );
				fImplied_cch = cbValue == SQL_NO_TOTAL ||
					cbValue > pbufdat->cchImplied;
				if( !fImplied_cch)
					pbufdat->cchImplied = cbValue;

				else if( pbufdat->fTypeClass == TYPE_CHAR &&
				         pbufdat->fNullTerm &&
				         pbufdat->cchActual == MAX( cbMax - 2, 0 ) &&
				         (cbMax & 1) == 0 && (cbValue & 1) == 0)
					{
						// Detect and compensate for the special case of
						// truncation, SQL_BINARY, SQL_C_CHAR, and an even
						// length buffer:
						//
					for( hpb = &hrgb[0]; isxdigit( *hpb++ ); )
						;
					if( hpb == &hrgb[ pbufdat->cchActual + 1 ] )
						pbufdat->cchImplied = pbufdat->cchActual;
					}
				}
			else
			{
				fNullCheck_asz = TRUE;
				fImplied_cch = fNullData_cb;
			}
			break;
		}
	}
	pbufdat->fNullCheckFailed = FALSE;
	if( !pbufdat->fUntouched_argb &&
		(fNullCheck_argb || fNullCheck_asz || pbufdat->fNoData) )
		for( hpb = &hrgb[0]; hpb < &hrgb[ pbufdat->cbTouched ]; hpb++)
			if( *hpb != '\0' )
			{
				pbufdat->fNullCheckFailed = TRUE;
				break;
			}
	pbufdat->fNoDataOK =
					pbufdat->fNoData && fZero_cb && !pbufdat->fNullCheckFailed;
	pbufdat->fImplied_cb = (fImplied_cb || fImplied_cch) && !pbufdat->fNoDataOK;
	pbufdat->fCbWrong = pbufdat->fTypeClass == TYPE_FIXED &&
						cbValue != (SDWORD)pbufdat->cbDataType;
}


pascal VOID DisplayOutputBuf( SWORD fCType, HPVOID hrgbValue, SDWORD cbTouched )
{
	static BYTE CSCONST szFormat[] = "x%02X";

	int cbDisplayed = 0;
	HPBYTE hpb = hrgbValue;

	switch( fCType )
	{
	case SQL_C_CHAR:
		DisplayString( NULL, hrgbValue, cbTouched, 0 );
		return;

	case SQL_C_LONG:
	case SQL_C_SHORT:
	case SQL_C_FLOAT:
	case SQL_C_DOUBLE:
	case SQL_C_DATE:
	case SQL_C_TIME:
	case SQL_C_TIMESTAMP:
	case SQL_C_TINYINT:
	case SQL_C_BIT:
		break;

	case SQL_C_DEFAULT:
	case SQL_C_BINARY:
		switch( cbTouched )
			{
		case sizeof (UCHAR):
			fCType = SQL_C_TINYINT;
			break;

		case sizeof (SWORD):
			fCType = SQL_C_SHORT;
			break;

		case sizeof (SDWORD):	// == sizeof (SFLOAT)
			DisplayValue(NULL, SQL_C_LONG, hrgbValue, cbTouched);
			cbDisplayed += 3;
			szWrite( szEqual, FALSE );
			fCType = SQL_C_FLOAT;
			break;

		case sizeof (SDOUBLE):
			fCType = SQL_C_DOUBLE;
			break;

		case sizeof (DATE_STRUCT):	// == sizeof (TIME_STRUCT)
			DisplayValue(NULL, SQL_C_DATE, hrgbValue, cbTouched);
			cbDisplayed += 3;
			szWrite( szEqual, FALSE );
			fCType = SQL_C_TIME;
			break;

		case sizeof (TIMESTAMP_STRUCT):
			fCType = SQL_C_TIMESTAMP;
			break;

		default:
			goto HexOnly;
			}
		break;

	default:
		goto HexOnly;
		}
	DisplayValue(NULL, fCType, hrgbValue, cbTouched);
	cbDisplayed += 3;
	szWrite( szEqual, FALSE );
HexOnly:
	if( cbTouched == 0)
		{
		szWrite( sz_untouched, FALSE );
		return;
		}
	if( hpb[cbTouched - 1] == '\0')
		{
		DisplayString(NULL, hrgbValue, cbTouched, 0 );
		cbDisplayed += cbTouched / 4 + 1;
		szWrite( szEqual, FALSE );
		}
	while( cbTouched-- > 1)
		{
		wsprintf( OutStr, szFormat, *hpb++);
		szWrite( OutStr, FALSE );
		szWrite( szSpace, ++cbDisplayed >= 20 && (cbDisplayed = 0, TRUE ));
		}
	wsprintf( OutStr, szFormat, *hpb);
	szWrite( OutStr, FALSE );
}


#define MASK            (sizeof( UDWORD ) - 1)
#define rgbUNTOUCHED    ((BYTE *)&udwUNTOUCHED)
#define bUNTOUCHED(lpv) (rgbUNTOUCHED[(UWORD)(UDWORD)lpv & MASK])


pascal VOID Untouch(HPVOID hrgb, SDWORD cb )
{
	UWORD ib;
	union
	{
		HPBYTE        hpb;
		UDWORD HUGE * hpudw;
	} uhp;

	uhp.hpb = hrgb;

	if( (ib = (UWORD)(UDWORD)uhp.hpb & MASK) != 0 )
	{
		UWORD cbT = 4 - ib;

		if( HIWORD( cb ) == 0 && (UWORD)cb < cbT)
			cbT = (UWORD)cb;

		_fmemcpy( uhp.hpb, &rgbUNTOUCHED[ib], cbT );
		uhp.hpb += cbT;
		cb -= cbT;
	}
	if( cb >= sizeof( UDWORD ) )
	{
		UDWORD HUGE * hpudwMax = (UDWORD FAR *)(uhp.hpb + (cb & ~(UDWORD)MASK));

		do
		{	*uhp.hpudw = UNTOUCHED;
		} while( ++uhp.hpudw < hpudwMax );
	}
	if( (ib = (UWORD)cb & MASK) != 0 )
		_fmemcpy( uhp.hpb, rgbUNTOUCHED, ib );
}


pascal SDWORD CbTouchedRgbCbMax( HPVOID hrgb, SDWORD cb )
{
	UDWORD HUGE * hpudwLim;
	UWORD ib;
	UWORD ibMin;
	union
	{	HPBYTE        hpb;
		UDWORD HUGE * hpudw;
	} uhp;


	if( cb < 0 )
		cb = 0;

	uhp.hpb = hrgb;
	if( (SEGMENT)hrgb != NULL )
		uhp.hpb += cb;

	if( (SEGMENT)uhp.hpb != NULL && *uhp.hpb != bUNTOUCHED(uhp.hpb) )
	{
		static BYTE CSCONST szFormat[] = "Check byte = 0x%02X, should be = 0x%02X!";

		if( FNeedSeparator() )
			szWrite( szSpace, TRUE );

		szWrite( sz_Error, FALSE );
		wsprintf( OutStr, szFormat, *uhp.hpb, bUNTOUCHED(uhp.hpb) );
		szWrite( OutStr, TRUE );
	}
	if( (SEGMENT)hrgb == NULL )
		return 0;

	ib = (UWORD)(UDWORD)uhp.hpb & MASK;
	while( ib > 0 )
	{
		if( --cb < 0 )
			return 0;

		if( *--uhp.hpb != rgbUNTOUCHED[ --ib ] )
			goto Touched;
	}
	hpudwLim = (UDWORD FAR *)hrgb + 1;
	while( uhp.hpudw >= hpudwLim )
		if( *--uhp.hpudw != UNTOUCHED )
		{
			++uhp.hpudw;
			break;
		}
	ib = sizeof( UDWORD );
	cb = sizeof( UDWORD ) - (uhp.hpb - (HPBYTE)hrgb );
	ibMin = cb < 0 ? 0 : (UWORD)cb;
	while( ib > ibMin )
		if( *--uhp.hpb != rgbUNTOUCHED[ --ib ] )
Touched:	return uhp.hpb - (HPBYTE)hrgb + 1;

	return 0;
}/* end CbTouchedRgbCbMax */


#undef MASK
#undef rgbUNTOUCHED
#undef bUNTOUCHED


	// DisplayString - display a character string, either unambiguously
	//		to the output window or to a specified edit window.
	//
	//	fModes values:
	//
	//	INPUT_STRING     - don't flag a non-null-terminated string as an error.
	//	LENGTH_TERM      - expect the string to not be null terminated.
	//	NO_METANAME      - don't display empty string metaname.
	//	BLANK_WHITESPACE - display tabs, carriage returns, linefeeds as spaces.
	//
pascal VOID DisplayString( HWND hwnd, HPBYTE hsz, SDWORD cbTouched, UWORD fModes )
{
	TSD		tsd;

	tsd.cbOutMax = 0x8000;

	if( hwnd != NULL )
	{
		static BYTE CSCONST sz_Edit[]      = "Edit";
		static BYTE CSCONST szNullString[] = "";

		BYTE szClass[sizeof sz_Edit];

	//	VSideAssert( GetClassName( hwnd, szClass, sizeof( szClass ) ) > 0 );

		if( *(UDWORD *)szClass != *(UDWORD CSCONST *)sz_Edit )
		{
			tsd.cbOutCur	= (UWORD)MIN( cbTouched, 0x8000) | 0x001F;
			tsd.hasz		= AllocateMemory( tsd.cbOutCur );
			tsd.lpch		= tsd.lsz = LockMemory( tsd.hasz );
			*tsd.lpch		= '\0';

			StringDisplayCommon( &tsd, hsz, cbTouched, fModes );

			SendMessage( hwnd, WM_SETTEXT, 0, (long)tsd.lsz );
			myUnlockMemory( tsd.hasz );
			FreeMemory( tsd.hasz );
			return;
		}
		SendMessage( hwnd, WM_SETREDRAW, FALSE, 0 );
		SendMessage( hwnd, WM_SETTEXT, 0, (LONG)(LPSTR)szNullString );
	}
	tsd.lsz = NULL;
	tsd.hwnd = hwnd;
	StringDisplayCommon( &tsd, hsz, cbTouched,
							(hwnd == NULL ? IN_QUOTES : 0) | fModes );

	if( hwnd )
	{
		SendMessage( hwnd, WM_SETREDRAW, TRUE, 0 );
	//	InvalidateRect( hwnd, NULL, TRUE );
	}
}/* end DisplayString */


	// CchGetStringDisplay - copy the unambiguous display
	//		of a character string to a buffer.
	//
	//	fModes values:
	//
	//	LENGTH_TERM      - expect the string to not be null terminated.
	//	IN_QUOTES        - display the string in quotes, escape imbedded quotes.
	//	BLANK_WHITESPACE - display tabs, carriage returns, linefeeds as spaces.
	//
pascal UWORD CchGetStringDisplay(	LPBYTE lszOut, UWORD cbOutMax,
									HPBYTE hszIn, SDWORD cbTouched, UWORD fModes )
{
	TSD tsd;

	tsd.lpch		= tsd.lsz = lszOut;
	tsd.hasz		= NULL;
	tsd.cbOutMax	= cbOutMax;

	StringDisplayCommon( &tsd, hszIn, cbTouched, INPUT_STRING | fModes );

	return tsd.lpch - tsd.lsz;
}/* end CchGetStringDisplay */


	// StringDisplayCommon - display a character string unambiguously.

	//	fModes values:

	//	INPUT_STRING     - don't flag a non-null-terminated string as an error.
	//	LENGTH_TERM      - expect the string to not be null terminated.
	//	IN_QUOTES        - display the string in quotes, escape imbedded quotes.
	//	NO_METANAME      - don't display empty string metaname.
	//	BLANK_WHITESPACE - display tabs, carriage returns, linefeeds as spaces.

	//	Note: assumes hsz[cbTouched] can be accessed.

pascal VOID StringDisplayCommon( TSD *ptsd,
									HPBYTE hsz, SDWORD cbTouched, UWORD fModes )
{
	static BYTE CSCONST szQuote[]         = "\"";
	static BYTE CSCONST szEllipsis[]      = "...";
	static BYTE CSCONST sz_unterminated[] = "unterminated";
	static BYTE CSCONST szFormatHex[]     = "\\x%02X";

	static BYTE CSCONST szMeta_untouched[]    = "<untouched>";
	static BYTE CSCONST szMeta_null_pointer[] = "<null pointer>";
	static BYTE CSCONST szMeta_empty_string[] = "<empty string>";

	BOOL fUnterminated		= (fModes & LENGTH_TERM) == 0;
	BOOL fMeta				= (fModes & NO_METANAME) == 0;
	BOOL fInQuotes			=  fModes & IN_QUOTES;
	BOOL fInput				=  fModes & INPUT_STRING;
	BOOL fBlankWhitespace	=  fModes & BLANK_WHITESPACE;
	BOOL fOutOfRoom			= FALSE;
	BOOL fContiguous		= FALSE;
	BOOL fCountLimit		= ptsd->lsz != NULL || ptsd->hwnd != NULL;

	if( hsz == NULL )
	{
		TakeStringDisplay( ptsd,
					LszIfSz( fInQuotes, sz_null_pointer, szMeta_null_pointer ) );
		return;
	}
	if( cbTouched == 0 )
	{
		if( !fInQuotes)
		{
			if( fUnterminated || fMeta )
				TakeStringDisplay( ptsd,
									LszIfSz(	fUnterminated,
												szMeta_untouched,
												szMeta_empty_string ) );
			return;
		}
		if( fUnterminated )
		{
			if( !fInput )
				TakeStringDisplay( ptsd, sz_Error );

			TakeStringDisplay( ptsd, sz_untouched );
			if( !fInput)
				TakeStringDisplay( ptsd, szExclam );

			return;
		}
	}
	if( fInQuotes )
		TakeStringDisplay( ptsd, szQuote );

	if( cbTouched )
	{
		BOOL   fEnd;
		HPBYTE hpbMax = &hsz[cbTouched];
		HPBYTE hpb = &hsz[0];
		UWORD  cchMost;
		UDWORD cchTotal;

		if( fCountLimit)
		{
			cchMost = ptsd->cbOutMax - 1 - (sizeof szEllipsis - 1);
			cchTotal =
				ptsd->lsz == NULL ? 0 : ptsd->lpch - ptsd->lsz;
		}
		do
		{
			SDWORD	cch;
			HPBYTE	hpbMic = hpb;
			BYTE	chCur;
			BYTE	szEscape[ 5 ];

			if( fInQuotes)
			{
					// Find the next non-printing ANSI character:

				do
				{
					if( (chCur = *hpb) >= 0x7F )
					{
						if( chCur < 0xA0 && chCur != 0x91 && chCur != 0x92 )
							break;
					}
					else
					{
						if( chCur < (BYTE)(fBlankWhitespace ? 0x21 : 0x20) )
							break;
					}
				} while( ++hpb < hpbMax );

				cch = hpb - hpbMic;
				}
			else
			{		// Find the next '\0':

				chCur	= *hpbMax;
				*hpbMax	= '\0';
				hpb		+= cch = hstrlen( hpb );
				*hpbMax	= chCur;
			}
			fEnd = hpb >= hpbMax;
			if( cch > 0 )
			{
				if( fCountLimit && (cchTotal += cch) > cchMost)
				{
					hpb -= cchTotal - cchMost;
					fOutOfRoom = TRUE;
				}
				chCur = *hpb;
				*hpb = '\0';
				TakeStringDisplay( ptsd, hpbMic );
				*hpb = chCur;

				fContiguous = FALSE;
				if( fOutOfRoom )
					break;
			}
			if( fEnd )
				break;

			chCur = *hpb;
			fEnd = ++hpb >= hpbMax;
			if( fEnd && fUnterminated && chCur == '\0' )
				break;

			if( fInQuotes )
			{
				if( !fBlankWhitespace )
					goto FormatHex;

				switch( chCur )
				{
				case  ' ':
				case '\t':
				case '\r':
				case '\n':
					if( fContiguous )
						continue;			// Skip contiguous whitespace

					fContiguous = TRUE;
					szEscape[0] =  ' '; 	// Change whitespace to blank
					szEscape[1] = '\0';
					break;

				default:
					fContiguous = FALSE;
FormatHex:
					wsprintf(szEscape, szFormatHex, chCur);
					break;
				}
			}
			else
			{
				szEscape[0] = '\1'; 		// Change embedded '\0' to '\1'
				szEscape[1] = '\0';
			}
			cchTotal += strlen( szEscape );
			fOutOfRoom = fCountLimit && cchTotal > cchMost;
			if( fOutOfRoom )
				break;

			TakeStringDisplay( ptsd, szEscape );
		} while( !fEnd );

		if( fOutOfRoom )
			TakeStringDisplay( ptsd, szEllipsis );

		if( fUnterminated && *(hpbMax - 1) == '\0' )
			fUnterminated = FALSE;
	}
	if( fInQuotes )
	{
		TakeStringDisplay( ptsd, szQuote );

		if( fUnterminated )
		{
			TakeStringDisplay( ptsd, szSpace );
			if( !fInput )
				TakeStringDisplay( ptsd, sz_Error );

			TakeStringDisplay( ptsd, sz_unterminated );
			if( !fInput )
				TakeStringDisplay( ptsd, szExclam );
		}
	}
	else if( fMeta && !fUnterminated && cbTouched == 1 )
		TakeStringDisplay( ptsd, szMeta_empty_string);
	return;
}/* end StringDisplayCommon */


pascal VOID TakeStringDisplay( TSD *ptsd, LPBYTE lsz )
{
	LPBYTE lpch;
	HANDLE hasz;
	UWORD cch;

	if( (SEGMENT)ptsd->lsz == NULL )
		{
		if( ptsd->hwnd == NULL )
			szWrite( lsz, FALSE );
		else
			SendMessage(ptsd->hwnd, EM_REPLACESEL, 0, (LONG)lsz );

		return;
		}
	lpch = ptsd->lpch;
	hasz = ptsd->hasz;
	cch = lstrlen( lsz );

	if( hasz && (UWORD)(lpch - ptsd->lsz) + cch + 1 > ptsd->cbOutCur )
	{
		ptsd->cbOutCur = cch + 1 | 0x01FF;
		myUnlockMemory( hasz );
		VSideAssert( ReAllocateMemory(hasz, ptsd->cbOutCur) == hasz);
		VSideAssert( LockMemory( hasz ) == lpch );
	}
	lstrcpy( lpch, lsz );
	ptsd->lpch = lpch + cch;
	return;
}
