
	// This module contains the functions which set up connections to
	// SQL Servers and also enables disconnections from them.
	//

#include "gator.h"
#include "adhoc.h"
#include "connect.h"

#ifdef MACINTOSH
#include <dos.h>			// mj
#endif MACINTOSH

#pragma segment servercn

extern char	OutStr[ OUTSTRLEN ];	// One global OutStr!
extern HCURSOR hSaveCursor;
extern HCURSOR hHourGlass;

extern CONNINFO FAR * lpconninfo; 	// Connection information

static BYTE CSCONST szColon[]       = ": ";
static BYTE CSCONST sz_Connection[] = "Connection to ";

extern SERVERINFO FAR * lrgserverinfo;
extern SERVERINFO FAR * lpserverinfoMax;

extern STMTINFO		*lrgstmtinfo;
extern STMTINFO		*lpstmtinfoMax;


pascal void FullConnect( HWND hwnd )
{
	static BYTE CSCONST sz_FULLCONNECT[] = "FULLCONNECT";
	static BYTE CSCONST sz_Connected[]   = "Connected to ";

	BOOL		fAllocEnv = FALSE;
	RETCODE		retcode;
	int			isel;
	HDBC		hdbcT;
	SERVERINFO 	*lpserverinfo;
	STMTINFO	*lpstmtinfo;

	extern HENV		henv;
	extern HDBC		hdbc;
	extern UWORD	idbc;
	extern HSTMT	hstmt;
	extern UWORD	istmt;
	extern HANDLE	hwndHdbcList;
	extern BOOL		fDriverMenus;
	extern UWORD	idbcMax;
	extern UWORD	istmtMax;


		// Look for free connection slot

	for( lpserverinfo = &lrgserverinfo[0];
		 lpserverinfo < lpserverinfoMax; lpserverinfo++ )
		if( lpserverinfo->hdbc    == NULL
		 && lpserverinfo->fStatus == Unused )
			break;

	if( lpserverinfo == lpserverinfoMax )
	{
		static BYTE CSCONST szTitle[] = "Maximum Connections Allocated";
		static BYTE CSCONST szMsg[]   =
			"Maximum %d connection handles.";

		wsprintf(OutStr, szMsg, MAX_CONNECTIONS);
		MessageBox(hwnd, OutStr, szTitle, MB_OK);
		return;
	}

		// Get name of server, userid, and password.
		//
	if( FDoDialogBox( sz_FULLCONNECT, hwnd, FullConnectDlg ) )
		return;

		// Change cursor to hourglass
		//
	SetCapture(hwnd);
//mj	hSaveCursor = SetCursor( hHourGlass );

	if( !henv )
	{
		StackCheck( TRUE );
		retcode = SQLAllocEnv( &henv );
		StackCheck( FALSE );
		if( retcode != SQL_SUCCESS )
		{
			EchoRetcode( sz_SQLAllocEnv,retcode );
			return;
		}
		fAllocEnv = TRUE;
		}

	StackCheck( TRUE );
	retcode=SQLAllocConnect( henv, &hdbcT );
	StackCheck( FALSE );
	if( retcode != SQL_SUCCESS )
	{
		EchoRetcode( sz_SQLAllocConnect, retcode );
		goto Done;
	}

	StackCheck( TRUE );
	retcode = SQLConnect( hdbcT,
			LszAndCbOfLpisa( lpconninfo->lpisaDSN ),
			LszAndCbOfLpisa( lpconninfo->lpisaUID ),
			LszAndCbOfLpisa( lpconninfo->lpisaAuthStr ) );
	StackCheck( FALSE );

	if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO )
		{
		static BYTE CSCONST szMsg[] = " failed.";

		EchoRetcode( sz_SQLConnect,retcode );
		szWrite( sz_Connection, FALSE );
		DisplayInputStringSzArg( NULL, lpconninfo->lpisaDSN, TRUE );
		szWrite( szMsg, TRUE );

		StackCheck( TRUE );
		retcode=SQLFreeConnect( hdbcT );
		StackCheck( FALSE );
		if( retcode != SQL_SUCCESS )
			EchoRetcode( sz_SQLFreeConnect, retcode );

		if( fAllocEnv )
		{
			StackCheck( TRUE );
			retcode = SQLFreeEnv( henv );
			StackCheck( FALSE );
			if( retcode != SQL_SUCCESS )
				EchoRetcode( sz_SQLFreeEnv,retcode );

			henv = NULL;
		}
		goto Done;
	}

	szWrite( sz_Connected, FALSE );
	DisplayInputStringSzArg( NULL, lpconninfo->lpisaDSN, TRUE );
	szWrite( ".", TRUE );

	lpserverinfo->idbc = idbc = ++idbcMax;
	lpserverinfo->hdbc = hdbc = hdbcT;
	lpserverinfo->fStatus = Connected;

	ltoa( idbc, OutStr, 10);
	lstrcat( OutStr, szColon );

	{
	UWORD cch = strlen( OutStr );

	GetInputStringSzArgDisplay(
		&OutStr[cch], OUTSTRLEN - cch, lpconninfo->lpisaDSN );
	}

	isel=(int)SendMessage( hwndHdbcList, CB_ADDSTRING, 0, (LONG)(LPSTR)OutStr );
	SendMessage( hwndHdbcList, CB_SETCURSEL, isel, 0 );

	OutStr[ MAX_SERVERNAME - 1 ] = '\0';
	lstrcpy( lpserverinfo->szName, OutStr );

	for (lpstmtinfo = &lrgstmtinfo[0];
		 lpstmtinfo < lpstmtinfoMax; lpstmtinfo++)
		if(lpstmtinfo->hstmt == NULL)
			break;

	if( lpstmtinfo == lpstmtinfoMax)
		{
		static BYTE CSCONST szTitle[] = "Storage error";
		static BYTE CSCONST szMsg[]   =
			"Maximum %d statement handles supported.";

		UpdateStatementList();
		wsprintf(OutStr, szMsg, MAX_STATEMENTS);
		MessageBox(hwnd, OutStr, szTitle, MB_ICONSTOP);
		goto Done;
		}

	StackCheck( TRUE );
	retcode = SQLAllocStmt(hdbcT, &hstmt);
	StackCheck( FALSE );
	if( retcode != SQL_SUCCESS )
		{
		EchoRetcode( sz_SQLAllocStmt,retcode );
//		StackCheck( TRUE );
//		retcode = SQLDisconnect(hdbcT);
//		StackCheck( FALSE );
//		if( retcode != SQL_SUCCESS )
//			EchoRetcode( sz_SQLDisconnect,retcode );
//
//		StackCheck( TRUE );
//		retcode = SQLFreeConnect(hdbcT);
//		StackCheck( FALSE );
//		if( retcode != SQL_SUCCESS )
//			EchoRetcode( sz_SQLFreeConnect,retcode );
//
//		if(fAllocEnv)
//			{
//			StackCheck( TRUE );
//			retcode = SQLFreeEnv( henv );
//			StackCheck( FALSE );
//			if( retcode != SQL_SUCCESS )
//			{
//				EchoRetcode( sz_SQLFreeEnv,retcode );
//
//			henv=SQL_NULL_HENV;
//			}
		}
	else
	{
		lpstmtinfo->istmt	= istmt = ++istmtMax;
		lpstmtinfo->hstmt	= hstmt;
		lpstmtinfo->hdbc	= hdbc = hdbcT;
		UpdateStatementList();
	}

	if( fDriverMenus )
		InitializeMenuTable();
Done:
		// Reset cursor
		//
	SetCursor( hSaveCursor );
	ReleaseCapture();
}


	//	This dialog procedure
	//		displays:    the last szDSN, szUID, szAuthStr
	//		prompts for: szDSN, szUID, szAuthStr
	//
pascal BOOL FullConnectDlg(
	HWND hdlg, unsigned message, WORD wParam, LONG lParam )
{
	static BYTE CSCONST sz_Data_Source[] = "Data Source";
	static BYTE CSCONST sz_User_ID[]     = "User ID";
	static BYTE CSCONST sz_Password[]    = "Password";

	BOOL  fDlgStatus;
	SWORD cb;
	LPISA lpisa;

	static BYTE fCombo_szDSN;

	switch(message)
		{
	case WM_INITDIALOG:
		CenterDlg(hdlg);

		FProcInputStringSzArgMsg(
			DSN_LIST, hdlg, IDC_SZDSN, CBN_UPDATE_CONTENTS,
			&lpconninfo->lpisaDSN, &fCombo_szDSN);

		DisplayInputStringSzArg(GetDlgItem(hdlg, IDC_SZUID),
			lpconninfo->lpisaUID, TRUE );

		DisplayInputStringSzArg(GetDlgItem(hdlg, IDC_SZAUTHSTR),
			lpconninfo->lpisaAuthStr, TRUE );
		goto NextMessage;

	case WM_COMMAND:
		switch(wParam)
			{
		case IDC_SZDSN:
			FProcInputStringSzArgMsg(
				DSN_LIST, hdlg, IDC_SZDSN, HIWORD(lParam),
				&lpconninfo->lpisaDSN, &fCombo_szDSN);
			goto NextMessage;

		case IDOK:
			SetFocus(GetDlgItem(hdlg, IDOK));
			if( !FCheckInputFlagArg(hdlg, IDC_SZDSN,
					sz_Data_Source, fCombo_szDSN))
				goto NextMessage;

			cb = (SWORD)SendDlgItemMessage(
					hdlg, IDC_SZUID, WM_GETTEXTLENGTH, 0, 0) + 1;
			lpisa = LpisaCreateISA( FALSE, cb, 0, 0 );
			cb = (SWORD)GetDlgItemValue(
					hdlg, IDC_SZUID, SQL_C_CHAR, lpisa->sz, cb);
			if( !FCheckInputEdit (hdlg, IDC_SZUID, sz_User_ID, cb >= 0 ) )
			{
				ReleaseMemory( lpisa );
				goto NextMessage;
			}
			lpisa->cb = lpisa->cbDefault = cb;
			ReleaseISA(lpconninfo->lpisaUID);
			lpconninfo->lpisaUID = lpisa;

			cb = (SWORD)SendDlgItemMessage(hdlg, IDC_SZAUTHSTR,
				WM_GETTEXTLENGTH, 0, 0) + 1;
			lpisa = LpisaCreateISA(FALSE, cb, 0, 0);
			cb = (SWORD)GetDlgItemValue(hdlg, IDC_SZAUTHSTR, SQL_C_CHAR,
				lpisa->sz, cb);
			if( !FCheckInputEdit(hdlg, IDC_SZAUTHSTR, sz_Password, cb >= 0)) {
				ReleaseMemory(lpisa);
				goto NextMessage;
			}
			lpisa->cb = lpisa->cbDefault = cb;
			ReleaseISA(lpconninfo->lpisaAuthStr);
			lpconninfo->lpisaAuthStr = lpisa;

			fDlgStatus = IDOK;
			goto EndOfDialog;

		case IDCANCEL:
			fDlgStatus = IDCANCEL;
			goto EndOfDialog;
			}
		break;
		}

	// Let Windows Process this event
	//
	return FALSE;

NextMessage:
	return TRUE;

EndOfDialog:
	EndDialog(hdlg, fDlgStatus);
	return TRUE;
}


pascal void FullDisconnect( HWND hwnd )
{
	static BYTE CSCONST sz_UNCONNECTED_SERVER[] = UNCONNECTED_SERVER;
	static BYTE CSCONST sz_closed[]             = " closed";
	static BYTE CSCONST szMsg[] = "NULL hdbc currently selected."
									"  Must select valid hdbc to disconnect.";

	RETCODE		retcode;
	SERVERINFO	*lpserverinfo;
	STMTINFO	*lpstmtinfo;

	extern HDBC		hdbc;
	extern HSTMT	hstmt;
	extern UWORD	istmt;
	extern HANDLE	hwndHdbcList;

	if( hdbc == NULL )
	{	szWrite( szMsg, TRUE );
		return;
	}
	lpserverinfo = LpserverinfoFromHdbc( hdbc );
	if( lpserverinfo == NULL )
		return;


	retcode = SQLDisconnect( hdbc );

	if( retcode != SQL_SUCCESS && retcode != SQL_SUCCESS_WITH_INFO )
	{
		EchoRetcode( sz_SQLDisconnect, retcode );
		return;
	}

	szWrite( sz_Connection, FALSE );
	szWrite(lpserverinfo->szName, FALSE );
	szWrite( sz_closed, TRUE );

	for( lpstmtinfo = &lrgstmtinfo[0];
		 lpstmtinfo < lpstmtinfoMax;	lpstmtinfo++ )
	{
		if(lpstmtinfo->hdbc == hdbc )
		{
			FreeParamsAndCols( FREE_BOTH, lpstmtinfo->hstmt );
			lpstmtinfo->hstmt	= SQL_NULL_HSTMT;
			lpstmtinfo->hdbc	= SQL_NULL_HDBC;
		}
	}

	ReleaseMemory( lpserverinfo->rgbMenuStatus );
	lpserverinfo->rgbMenuStatus	= NULL;
	lpserverinfo->fStatus		= Allocated;
	lpserverinfo->szName[0]		= 0;

	hstmt = SQL_NULL_HSTMT;
	istmt = 0;

	retcode = SQLFreeConnect( hdbc );

	if( retcode == SQL_SUCCESS )
	{
		lpserverinfo->hdbc		= NULL;
		lpserverinfo->fStatus	= Unused;
	//	ChangeSelectedComboBoxEntry( (HWND)hwndHdbcList, NULL );
	}
	else
	{
		EchoRetcode( sz_SQLFreeConnect, retcode );
		ltoa( lpserverinfo->idbc, OutStr, 10);
		lstrcat( OutStr, szColon );
		lstrcat( OutStr, sz_UNCONNECTED_SERVER );
	//	ChangeSelectedComboBoxEntry( (HWND)hwndHdbcList, OutStr );
	}
	UpdateCurrentHdbc();
	return;
}/* end FullDisconnect */
