
	/*  1988-91, Bowers Development Corp. */
	// WindowAids.c

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Fonts.h>
#include <Lists.h>
#include <Menus.h>
#include <Resources.h>
#include <ToolUtils.h>
#include <TextEdit.h>
#include <Script.h>

#include "Globals.h"
#include "Miscellany.h"
#include "Dispatcher.h"
#include "Windowing.h"
#include "ResourceDefs.h"


#define topLeft(r)	(((Point*)&(r))[0])
#define botRight(r)	(((Point*)&(r))[1])

#define sBarWidth  		16                                 

#define Scroll1			1 
#define hDBCPopup		2 
#define hSTMTPopup		3 
#define Line4			4 
#define Scroll5			5 
#define inField			6 
#define hDBCLabel		7 
#define hStmtLabel		8 
#define Line9			9 
#define outField		10 
#define Scroll11		11


#define FALSE		0
#define TRUE		1

	typedef pascal void		(*ScrollProcPtr)( short delta );


	short		textJust;		/* set by SetWFont */

	extern windowPop	DBCpop;
	extern windowPop	STMTpop;

	extern void UpdateStatementList();
	extern void UpdateCurrentHdbc();
	extern void UpdateCurrentHstmt();

#pragma segment WindowAids


static void TrackPop( windowPop *pwp )
{
	Point			corner;
	long			result;
	Rect			tempRect;

	tempRect.top	= pwp->popRect.top   + 5;
	tempRect.left	= pwp->popRect.right - 18;
	tempRect.bottom	= tempRect.top   + 7;
	tempRect.right	= tempRect.left + 13;
	EraseRect( &tempRect );
	InvalRect( &tempRect );
	corner = topLeft( pwp->popRect );
	LocalToGlobal( &corner );
	CheckItem( pwp->hMenu, pwp->choice, TRUE );
	result = PopUpMenuSelect( pwp->hMenu, corner.v, corner.h + 1, pwp->choice );
	CheckItem( pwp->hMenu, pwp->choice, FALSE );
	CalcMenuSize( pwp->hMenu );
	if( (HiWord( result ) != 0) && (LoWord( result ) != pwp->choice ) )
	{
		pwp->choice = LoWord( result );
		tempRect = pwp->popRect;
		InsetRect( &tempRect, 1, 1 );
		InvalRect( &tempRect );
	}
	return;
}/* end TrackPop */


typedef struct
{		short	header;
		short	offset;
} ictbEntry, *ictbEntryPtr;

typedef struct
{		ictbEntry	item[ 5000 ];
} WictTemplate, *WictTPtr, **WictTHndl;

typedef struct
{
		short			fontNum;
		Style			typeStyle;
		SignedByte		just;		/* AppMaker adition */
		short			typeSize;
		RGBColor		fgColor;
		RGBColor		bgColor;
		short			xferMode;
} StyleData, *StyleDataPtr;

		/* defined in TextEdit: */
	/*	doFont			= 1;		set font (family) number	*/
	/*	doFace			= 2;		set character style			*/
	/*	doSize			= 4;		set type size				*/
	/*	doColor			= 8;		set color					*/
	/*	addSize			= 16;		adjust type size			*/


#define doXferMode	0x4000		/* set transfer mode	*/
#define doByName	0x8000		/* set font by name		*/


void SetWFont( short itemNr )
{
	WictTHndl		wictHandle;
	Ptr				wictPtr;
	ictbEntryPtr	itemPtr;
	short			header;
	short			offset;
	StyleDataPtr	dataPtr;
	StyleData		data;
	StringPtr		fontPtr;
	Str255			fontName;

	wictHandle = (WictTHndl)cur->wictHandle;
	if( wictHandle )
	{
		wictPtr	= (Ptr)&(**wictHandle);
		itemPtr	= &(**wictHandle).item[ itemNr - 1 ];
		header	= itemPtr->header;
		offset	= itemPtr->offset;
		dataPtr	= (StyleDataPtr)( wictPtr + offset );
		data	= *dataPtr;
		if( (header & doFont) == 0 )
			data.fontNum = 0;
		else
		{	if( header & doByName )
			{
				fontPtr = (StringPtr)(wictPtr + data.fontNum);
				BlockMove( fontPtr, &fontName, 256 );
				GetFNum( fontName, &data.fontNum );
			}
		}
		if( (header & doFace)     == 0 )	data.typeStyle	= 0;
		if( (header & doSize)     == 0 )	data.typeSize	= 0;
		if( (header & doXferMode) == 0 )	data.xferMode	= srcCopy;
		TextFont( data.fontNum );
		TextFace( data.typeStyle );
		TextMode( data.xferMode );
		TextSize( data.typeSize );
		textJust = data.just;
	}
	return;
}/* end SetWFont */


WindowPtr GetWindow( short windowID )
{
	if( sysConfig.hasColorQD )
		 return GetNewCWindow( windowID, NULL, (WindowPtr) -1L );
	else return GetNewWindow(  windowID, NULL, (WindowPtr) -1L );
}/* end GetWindow */


Boolean GetListChoice( short *choice, ListHandle list )
{
	Boolean		result;
	Cell		selectedCell;

	SetPt( &selectedCell, 0, 0 );
	if( LGetSelect( true, &selectedCell, list ) )
	{
		*choice = selectedCell.v;
		result = true;
	}
	else
	{
		*choice = -1;
		result = false;
	}
	return result;
}/* end GetListChoice */


void SetListChoice( short choice, ListHandle list )
{
	Cell			selectedCell;

	SetPt( &selectedCell, 0, choice );
	LSetSelect (true, selectedCell, list );
}/* end SetListChoice */


void GetListRow( Str255 data, short index, ListHandle list )
{
	Cell		selectedCell;
	short		dataLen;

	SetPt( &selectedCell, 0, index );
	dataLen = 255;						/* var parameter to LGetCell	*/
	LGetCell( &data[1], &dataLen, selectedCell, list );
	data [0] = (char)dataLen;
	return;
}/* end GetListRow*/


void SetListRow( Str255 data, short index, ListHandle list )
{
	Cell	selectedCell;

	SetPt( &selectedCell, 0, index );
	LSetCell( &data [1], data [0], selectedCell, list );
	return;
}/* end SetListRow*/


void AddToList( Str255 data,  ListHandle list )
{
	short		newRow;
	
	#define maxint	32767

	newRow = LAddRow( 1, maxint, list );
	SetListRow( data, newRow, list );
	return;
}/* end AddToList */


void DrawList( ListHandle list )
{
	PenState	savePen;
	Rect		frame;

	GetPenState( &savePen );
	PenNormal();
	frame = (**list).rView;
	InsetRect( &frame, -1, -1 );
	FrameRect( &frame );
	SetPenState( &savePen );
	LUpdate( (**list ).port->visRgn, list );
	return;
}/* end DrawList */


	/* for backwards compatibility:	*/

void HiliteScroll( ControlHandle scroll, Boolean active )
{
	if( scroll )
	{	if( active )
			 HiliteControl( scroll, 0   );
		else HiliteControl( scroll, 255 );
	}
	return;
}/* end HiliteScroll */


	// Scrolling.c

#pragma segment Scrolling


pascal void ActionGlue( ControlHandle whichScroll, short partCode )
{
	short			pageSize, delta, oldValue, newValue;
	ScrollProcPtr	actionProc;


	oldValue = GetCtlValue( whichScroll );
	pageSize = GetCRefCon(  whichScroll );

	switch( partCode )
	{
	case inUpButton:	delta = -1;			break;
	case inDownButton:	delta = 1;			break;
	case inPageUp:		delta = -pageSize;	break;
	case inPageDown:	delta = pageSize;	break;
	default:			delta = 0;			break;
	}

	if( delta )
		SetCtlValue( whichScroll, oldValue + delta );

	newValue = GetCtlValue( whichScroll );
	if( newValue != oldValue )
	{
		actionProc = (ScrollProcPtr)(**whichScroll ).contrlAction;
		(*actionProc)( oldValue - newValue );
	}
	return;
}/* end ActionGlue */


	/*  1988-91, Bowers Development Corp. */
	// Windowing.c

#pragma segment Windowing


void ResizeLine9()
{
	Rect	bounds;

	bounds = cur->line9;
	if( bounds.right > curWindow->portRect.right - sBarWidth )
		bounds.right = curWindow->portRect.right - sBarWidth;
	EraseRect( &bounds );
	cur->line9.top		= 32 + (curWindow->portRect.bottom - 32)/3;
	cur->line9.bottom	= cur->line9.top + 1;
	cur->line9.left		= 0;
	cur->line9.right	= curWindow->portRect.right - sBarWidth;
	InvalRect( &cur->line9 );
	DrawGrayLine( cur->line9 );
	return;
}
/* end ResizeLine9 */


void ResizeScrollBars()
{
	Rect		portRect, contrlRect;
	short		curTop, curLeft, midPoint;

	portRect = curWindow->portRect;
	midPoint = 32 + (portRect.bottom - 32)/3;

	if( cur->Scroll5Handle )
	{
		contrlRect = (**(cur->Scroll5Handle)).contrlRect;
		curTop = contrlRect.top;
		HideControl( cur->Scroll5Handle );
		MoveControl( cur->Scroll5Handle, (portRect.right + 1) - sBarWidth, curTop );
		SizeControl( cur->Scroll5Handle, sBarWidth, midPoint + 1 - curTop );
		ShowControl( cur->Scroll5Handle );
		contrlRect = (**(cur->Scroll5Handle )).contrlRect;
		ValidRect( &contrlRect );
	}

	if( cur->vScroll )
	{
		contrlRect = (**(cur->vScroll)).contrlRect;
		curTop = midPoint;
		HideControl( cur->vScroll );
		MoveControl( cur->vScroll, (portRect.right + 1) - sBarWidth, midPoint );
		SizeControl( cur->vScroll, sBarWidth,
					((portRect.bottom + 1) - sBarWidth ) - midPoint );
		ShowControl( cur->vScroll );
		contrlRect = (**(cur->vScroll )).contrlRect;
		ValidRect( &contrlRect );
	}

	if( cur->hScroll )
	{
		contrlRect = (**(cur->hScroll)).contrlRect;
		curLeft = contrlRect.left;
		HideControl( cur->hScroll );
		MoveControl( cur->hScroll, curLeft, portRect.bottom + 1 - sBarWidth );
		SizeControl( cur->hScroll,
					 ((portRect.right + 1) - sBarWidth ) + 1 - curLeft, sBarWidth );
		ShowControl( cur->hScroll );
		contrlRect = (**(cur->hScroll)).contrlRect;
		ValidRect( &contrlRect );
	}
	return;
}/* end ResizeScrollBars */


void ResizeContent()
{
	short		midPoint;

	midPoint = 32 + (curWindow->portRect.bottom - 32)/3;

	InvalRect( &cur->teIn );
	cur->teIn.top		= 32 + 10;
	cur->teIn.bottom	= midPoint - 10;
	cur->teIn.left		= 10;
	cur->teIn.right		= curWindow->portRect.right - sBarWidth - 10;
	(**(cur->inFieldHandle)).destRect = cur->teIn;
	(**(cur->inFieldHandle)).viewRect = cur->teIn;
	InvalRect( &cur->teIn );

	InvalRect( &cur->teOut );
	cur->teOut.top		= midPoint + 10;
	cur->teOut.bottom	= curWindow->portRect.bottom - sBarWidth - 10;
	cur->teOut.left		= 10;
	cur->teOut.right	= curWindow->portRect.right  - sBarWidth - 10;
	(**(cur->outFieldHandle)).destRect = cur->teOut;
	(**(cur->outFieldHandle)).viewRect = cur->teOut;
	InvalRect( &cur->teOut );

	return;
}/* end ResizeContent */


pascal void ScrollinWindowH( short delta )
{
	if( cur->windowKind == WODBCtest )
	{
		TEScroll( 0, delta * (**(cur->inFieldHandle)).lineHeight,
					cur->inFieldHandle );
	}
	return;
}/* end ScrollinWindowH */


pascal void ScrollinWindowV( short delta )
{

	if( cur->windowKind == WODBCtest )
	{
		TEScroll( 0, delta * (**(cur->inFieldHandle)).lineHeight,
					cur->inFieldHandle );
	}
	return;
}/* end ScrollinWindowV */


pascal void ScrollOutWindowH( short delta )
{

	if( cur->windowKind == WODBCtest )
	{
		TEScroll( 0, delta * (**(cur->outFieldHandle)).lineHeight,
					cur->outFieldHandle );
	}
	return;
}/* end ScrollOutWindowH */


pascal void ScrollOutWindowV( short delta )
{

	if( cur->windowKind == WODBCtest )
	{
		TEScroll( 0, delta * (**(cur->outFieldHandle)).lineHeight,
					cur->outFieldHandle );
	}
	return;
}/* end ScrollOutWindowV */


void DoContent( WindowPtr whichWindow )
{
	Point			where;
	ControlHandle	whichControl;
	short			partCode;
	Boolean			extendSel;
	short			oldValue, newValue;


	if( whichWindow != FrontWindow() )
		SelectWindow( whichWindow );
	else
	{
		where = curEvent.where;
		GlobalToLocal( &where );

		partCode = FindControl( where, whichWindow, &whichControl );

		if( whichControl )
		{	if( ( whichControl == cur->vScroll )
			 || ( whichControl == cur->hScroll )
			 || ( whichControl == cur->Scroll5Handle ) )
			{
				if( partCode == inThumb )
				{
					oldValue = GetCtlValue(  whichControl );
					partCode = TrackControl( whichControl, where, NULL );
					newValue = GetCtlValue(  whichControl );
					((**whichControl).contrlAction)( oldValue - newValue );
				}
				else
					partCode = TrackControl( whichControl, where, (ProcPtr)&ActionGlue );
			}/* end IF scroll control */ 
		}/* end IF mouse down in a control */
		else
		{
			extendSel = curEvent.modifiers & shiftKey;
			if( cur->text && PtInRect( where, &((**(cur->text)).viewRect) ) )
			{
				 TEClick( where, extendSel, cur->text );
				 return;
			}/* end IF clicking in CURRENT edit text box */
			else
			{	if( cur->windowKind == WODBCtest )
				{
					if( PtInRect( where, &DBCpop.popRect ) )
					{	TrackPop( &DBCpop );
						UpdateCurrentHdbc();
						UpdateStatementList();
						return;
					}

					if( PtInRect( where, &STMTpop.popRect ) )
					{	TrackPop( &STMTpop );
						UpdateCurrentHstmt();
						return;
					}

					if( PtInRect( where, &(**(cur->inFieldHandle )).viewRect ) )
					{	if( cur->text )
							TEDeactivate( cur->text );
						cur->text = cur->inFieldHandle;
						TEActivate( cur->text );
						TEClick( where, FALSE, cur->text );
						return;
					}/* end IF switching to IN text box */

					if( PtInRect( where, &(**(cur->outFieldHandle)).viewRect ) )
					{
						if( cur->text )
							TEDeactivate( cur->text );
						cur->text = cur->outFieldHandle;
						TEActivate( cur->text );
						TEClick( where, FALSE, cur->text );
						return;
					}/* end IF switching to OUT text box */
				}
			}/* end if/ELSE not in current text */
		}/* end if/ELSE not control */
	}/* end if/ELSE is front window */
	return;
}/* end DoContent */


void DoDrag( WindowPtr whichWindow )
{
	RgnHandle	grayRgn;
	Rect		limitRect;

	grayRgn = GetGrayRgn();
 	limitRect = (**grayRgn).rgnBBox;
	DragWindow( whichWindow, curEvent.where, &limitRect );
	return;
}/* end DoDrag */
 

void InvalGrowBox( WindowPtr whichWindow )
{
	Rect	growBox;
	
#define port	whichWindow->portRect
	SetRect( &growBox, port.right - 15, port.bottom - 15,
					   port.right,		port.bottom );
	InvalRect( &growBox );
#undef port
	return;
}/* end InvalGrowBox */


void DoGrow( WindowPtr whichWindow )
{
#define minWidth   	55                                 
#define minHeight  	55                                
#define maxint  	32767                                

	RgnHandle		grayRgn;
	short			maxWidth;
	short			maxHeight;
	Rect			sizeRect;
	long			newSize;
	short			newWidth;
	short			newHeight;


	grayRgn = GetGrayRgn();
 	sizeRect = (**grayRgn).rgnBBox;
	maxWidth  = sizeRect.right  - sizeRect.left;
	maxHeight = sizeRect.bottom - sizeRect.top - GetMBarHeight();

	SetRect( &sizeRect, minWidth, minHeight, maxint, maxint );
	newSize = GrowWindow( whichWindow, curEvent.where, &sizeRect );
	if( newSize )
	{
		InvalGrowBox( whichWindow );	/* old position */
		newWidth  = LoWord( newSize );
		newHeight = HiWord( newSize );
		SizeWindow( whichWindow, newWidth, newHeight, true );
		ResizeContent();
		ResizeScrollBars();
		ResizeLine9();
		InvalGrowBox( whichWindow );	/* new position */
	}
	return;
}/* end DoGrow */


void DoGoAway( WindowPtr whichWindow )
{
	if( TrackGoAway( whichWindow, curEvent.where ) )
		DoClose();
	return;
}/* end DoGoAway */


void SetZoomRect( WindowPtr whichWindow, short inOrOut )
{
	Rect			windRect;
	Rect			theSect;
	Rect			zoomRect;
	Rect			gdRect;
	GDHandle		nthDevice;
	GDHandle		dominantGDevice;
	long			sectArea;
	long			greatestArea;
	short			bias;
	Boolean			sectFlag;
	GrafPtr			savePort;

	if( TrackBox( whichWindow, curEvent.where, inOrOut ) )
	{
		GetPort( &savePort);
		SetPort( whichWindow );
		EraseRect( &whichWindow->portRect );
		windRect = whichWindow->portRect;
		LocalToGlobal( &topLeft(  windRect ) );
		LocalToGlobal( &botRight( windRect ) );
		bias = windRect.top - 1
						- (**(((WindowPeek) whichWindow )->strucRgn)).rgnBBox.top;
		windRect.top = windRect.top - bias;
		nthDevice = GetDeviceList();
		greatestArea = 0;

		while( nthDevice )
		{
			if( TestDeviceAttribute( nthDevice, screenDevice ) )
			{
				if( TestDeviceAttribute( nthDevice, screenActive ) )
				{
					gdRect = (**nthDevice).gdRect;
					sectFlag = SectRect( &windRect, &gdRect, &theSect );
					sectArea = ((long)(theSect.right - theSect.left))
							        * (theSect.bottom - theSect.top);
					if( sectArea > greatestArea )
					{	greatestArea	= sectArea;
						dominantGDevice	= nthDevice;
					}
					nthDevice = GetNextDevice( nthDevice );
				}
			}
		}/* end WHILE */

		if( dominantGDevice == GetMainDevice() )
			bias = bias + GetMBarHeight();
		gdRect = (**dominantGDevice).gdRect;
		SetRect( &zoomRect, gdRect.left + 3, gdRect.top + bias + 3, gdRect.right - 3, gdRect.bottom - 3);
		(**(WStateDataHandle)(((WindowPeek)whichWindow)->dataHandle)).stdState = zoomRect;
	}
	return;
}/* end SetZoomRect */


void DoZoom( WindowPtr whichWindow, short inOrOut )
{
	if( TrackBox( whichWindow, curEvent.where, inOrOut ) )
	{
		EraseRect( &whichWindow->portRect );
		if( (inOrOut == inZoomOut) && sysConfig.hasColorQD )
			SetZoomRect( whichWindow, inOrOut);
		ZoomWindow( whichWindow, inOrOut, false );
		InvalRect( &whichWindow->portRect );
		ResizeContent();
		ResizeScrollBars();
	}
	return;
}/* end DoZoom */
