
	/*
	** CONNECT.C - This is the module containing the code for ODBC for
	** allocation and connection.
	**
	** (C) Copyright 1991, 1992 By Microsoft Corp.
	*/

#include "sample.h"
#include <Memory.h>


	//	Allocate an ODBC Driver environment (ENV) block.


SQL_API RETCODE SQLAllocEnv( HENV *phenv )
{
	HENV	henv;

	henv = (HENV)NewHandleClear( sizeof( ENV ) );
	if( henv )
		HLock( (Handle)henv );
	else
	{
		*phenv = SQL_NULL_HENV;
		return SQL_ERROR;
	}
	*phenv = henv;
	return SQL_SUCCESS;
}/* end SQLAllocEnv */


	//	Allocate a DBC block.

SQL_API RETCODE SQLAllocConnect( HENV /*lpenv*/, HDBC *phdbc )
{
	HDBC	hdbc;


	hdbc = (HDBC)NewHandleClear( sizeof( DBC ) );
	if( hdbc )
		HLock( (Handle)hdbc );
	else
	{
		*phdbc = SQL_NULL_HDBC;
		return SQL_ERROR;
	}
	*phdbc = hdbc;
	return SQL_SUCCESS;
}/* end SQLAllocConnect */


SQL_API RETCODE SQLConnect( HDBC, UCHAR*, SWORD, UCHAR*, SWORD, UCHAR*, SWORD )
{
//debugstr( "Sample Driver: SQLConnect" );
	return SQL_SUCCESS;
}/* end SQLConnect */


	//	This function as its "normal" behavior is supposed to bring up a
	//	dialog box if it isn't given enough information via "szConnStrIn".  If
	//	it is given enough information, it's supposed to use "szConnStrIn" to
	//	establish a database connection.  In either case, it returns a
	//	string to the user that is the string that was eventually used to
	//	establish the connection.

SQL_API RETCODE SQLDriverConnect( HDBC, HWND, UCHAR *szConnStrIn,
									SWORD	cbConnStrIn, UCHAR*,
									SWORD, SWORD*, UWORD fDriverCompletion )
{
	short	iRet;
	BOOL	fPrompt = FALSE;

	if(  (szConnStrIn == NULL)    || (!cbConnStrIn)
	 || ((cbConnStrIn == SQL_NTS) && (!szConnStrIn[0])) )
		fPrompt = TRUE;
	else
	{		//  Check connection string for completeness
		if( fDriverCompletion == SQL_DRIVER_COMPLETE
		 || fDriverCompletion == SQL_DRIVER_PROMPT )
			fPrompt = TRUE;
	}
	if( fPrompt )
	{
			//	It is not necessary to call "MakeProcInstance" if you
			//	generate a dialog box from a DLL.

//mj	iRet = DialogBox( s_hModule, "EDRIVERCONNECT", hwnd, FDriverConnectProc );
iRet = 333;	//mj
		if( (!iRet) || (iRet == -1) )
			return SQL_NO_DATA_FOUND;
	}
	return SQL_SUCCESS;
}/* end SQLDriverConnect */


SQL_API RETCODE SQLBrowseConnect( HDBC, UCHAR*, SWORD, UCHAR*, SWORD, SWORD* )
{
//debugstr( "Sample Driver: SQLBrowseConnect" );
	return SQL_SUCCESS;
}/* end SQLBrowseConnect */


SQL_API RETCODE SQLDisconnect( HDBC )
{
//debugstr( "Sample Driver: SQLDisconnect" );
	return SQL_SUCCESS;
}/* end SQLDisconnect */


SQL_API RETCODE SQLFreeConnect( HDBC hdbc )
{

//debugstr( "Sample Driver: SQLFreeConnect" );
	HUnlock( (Handle)hdbc );
	DisposHandle( (Handle)hdbc );
	return SQL_SUCCESS;
}/* end SQLFreeConnect */


SQL_API RETCODE SQLFreeEnv( HENV henv )
{

//debugstr( "Sample Driver: SQLFreeEnv" );
	HUnlock( (Handle)henv );
	DisposHandle( (Handle)henv );
	return SQL_SUCCESS;
}/* end SQLFreeEnv */
