
	/*
	** PREPARE.C - This is the module containing the code for SQL for
	** preparing SQL Commands and other functions prior to execution.
	**
	** (C) Copyright 1991, 1992 By Microsoft Corp.
	*/


#include <Memory.h>
#include "sample.h"
//#include <dos.h>


	//  Allocate a SQL statement

SQL_API RETCODE SQLAllocStmt( HDBC /*lpdbc*/, HSTMT *phstmt )
{
	HSTMT	hstmt;

//debugstr( "Sample Driver: SQLAllocStmt" );
	hstmt = (HSTMT)NewHandleClear( sizeof( STMT ) );
	if( hstmt == NULL )
	{
		*phstmt = SQL_NULL_HSTMT;
		return SQL_ERROR;
	}
	HLock( (Handle)hstmt );
	*phstmt = hstmt;
	return SQL_SUCCESS;
}/* end SQLAllocStmt */


SQL_API RETCODE SQLFreeStmt( HSTMT hstmt, UWORD fOption )
{
	if (fOption == SQL_DROP )
	{
		HUnlock(      (Handle)hstmt );
		DisposHandle( (Handle)hstmt );
	}
	return SQL_SUCCESS;
}/* end SQLFreeStmt */


	//  Perform a Prepare on the SQL statement

SQL_API RETCODE SQLPrepare( HSTMT, UCHAR*, SDWORD )
{
	return SQL_SUCCESS;
}/* end SQLPrepare */


	//  Set parameters on a statement handle

SQL_API RETCODE SQLSetParam( HSTMT, UWORD, SWORD, SWORD, UDWORD, SWORD, PTR, SDWORD* )
{
	return SQL_SUCCESS;
}


	//  Returns the description of a parameter marker.

SQL_API RETCODE SQLDescribeParam( HSTMT, UWORD, SWORD*, UDWORD*, SWORD*, SWORD* )
{
	return SQL_SUCCESS;
}


	//  Sets multiple values (arrays) for the set of parameter markers.

SQL_API RETCODE SQLParamOptions( HSTMT, UDWORD, UDWORD* )
{
	return SQL_SUCCESS;
}


//  Returns the number of parameter markers.

SQL_API RETCODE SQLNumParams( HSTMT, SWORD* )
{
	return SQL_SUCCESS;
}


	//  Sets options that control the behavior of cursors.

SQL_API RETCODE SQLSetScrollOptions( HSTMT, UWORD, SDWORD, UWORD )
{
	return SQL_SUCCESS;
}


	//  Set the cursor name on a statement handle

SQL_API RETCODE SQLSetCursorName( HSTMT, UCHAR*, SWORD )
{
	return SQL_SUCCESS;
}


	//  Return the cursor name for a statement handle

SQL_API RETCODE SQLGetCursorName( HSTMT, UCHAR*, SWORD, SWORD*)
{
	return SQL_SUCCESS;
}/* end SQLGetCursorName */
