/*--------------------------------------------------------------------------
  ODBCInst.h -- Prototypes for ODBC Configuration Manager 

  (c) Microsoft Corp., 1990-1993
  (c) Apple Computer, Inc. 1993
  
--------------------------------------------------------------------------*/

#ifndef __ODBCINST_H
#define __ODBCINST_H

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#ifndef __SQL
#include "SQL.H"
#endif

#ifndef __SQLEXT
#include "SQLEXT.H"
#endif

typedef unsigned int      UINT;
typedef char			* LPCSTR;

									/* Map SQLRemoveDSNFromIni on the Macintosh		*/
#define SQLRemoveDSNFromIni SQLRemoveDSN
									/* Map SQLWriteDSNToIni on the Macintosh		*/
#define SQLWriteDSNToIni SQLWriteDSN

// Constants ---------------------------------------------------------------
// SQLConfigDataSource request flags
#define  ODBC_ADD_DSN     1               // Add data source
#define  ODBC_CONFIG_DSN  2               // Configure (edit) data source
#define  ODBC_REMOVE_DSN  3               // Remove data source


// Prototypes --------------------------------------------------------------
#define INSTAPI pascal BOOL

typedef INSTAPI (*ConfigFuncPtr)();

// High level APIs

INSTAPI SQLManageDataSources( GrafPtr	pGrafPort );

INSTAPI SQLCreateDataSource( GrafPtr	pGrafPort,
							 LPCSTR     lpszDSN);

INSTAPI SQLGetTranslator( GrafPtr	pGrafPort,
						  LPSTR		lpszName,
						  UINT		cbNameMax,
						  UINT		*pcbNameOut,
						  LPSTR		lpszPath,
						  UINT		cbPathMax,
						  UINT		*pcbPathOut,
						  DWORD		*pvOption);

// Low level APIs
// NOTE: The high-level APIs should always be used. These APIs
//       have been left for compatibility.

INSTAPI SQLGetInstalledDrivers		(LPSTR		lpszBuf,
									 UINT		cbBufMax,
									 UINT		*pcbBufOut);

INSTAPI SQLConfigDataSource			(GrafPtr	pGrafPort,
									 UINT		fRequest,
									 LPCSTR		lpszDriver,
									 LPCSTR 	lpszAttributes);
							 
INSTAPI SQLRemoveDefaultDataSource	(void);

INSTAPI SQLWriteDSN					(LPCSTR		lpszDSN,
									 LPCSTR		lpszDriver);

INSTAPI SQLRemoveDSN				(LPCSTR		lpszDSN);

INSTAPI SQLGetKeywordValue			(LPCSTR		lpszDSN,		// section name
									 LPCSTR		lpszEntry,		// keyword
									 LPCSTR		lpszBuffer,		// buffer to hold data
									 UINT		cbBuffer,		// size of buffer
									 UINT		*pcbBufOut);	// actual size of buffer, not including null-terminator

INSTAPI SQLSetKeywordValue			(LPCSTR		lpszDSN,		// section name
									 LPCSTR		lpszEntry,		// keyword
									 LPCSTR		lpszBuffer,		// buffer holding data
									 int		cbBuffer);		// size of buffer

INSTAPI	SQLValidDSN					(LPCSTR		lpszDSN);


//	Driver specific Setup APIs called by installer

INSTAPI	ConfigDSN					(GrafPtr	pGrafPort,
									 UINT		fRequest,
									 LPCSTR		lpszDriver,
									 LPCSTR		lpszAttributes);

typedef INSTAPI (*ConfigDSNptr)(GrafPtr, UINT, LPCSTR, LPCSTR);

#endif // __ODBCINST_H
