#
#	File:		HelloPart.make
#
#	Contains:	Universal Makefile for OpenDoc HelloPart test part
#
#	Written by:	Nick Pilch
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#
#	To Do:
#

# DIRECTORY VARIABLES

SourceDir = :
ObjectsDir = {SourceDir}Objects:
TargetDir = {SourceDir}

# TOOL OPTIONS

RezOptions = -i "{ODRIncludes}" -i "{ODCPlusIncludes}"
CPlusOptions = -sym full -mf -model far -d XMPDebug=1 -d ASLMBUILD -d CDECL= 
				-i "{ODCPlusIncludes}"
LinkOptions = -sym full -mf -model far
LibOptions = -sym full -mf -d
BuildSharedLibraryOptions = -sym full -i "{ODCPlusIncludes}"
LinkSharedLibraryOptions = -link -mf -sym full

# DIRECTORY DEPENDENCIES

"{ObjectsDir}"  "{SourceDir}"
				
# DEFAULT RULES

.cpp.o		.cpp
	Set Echo 0
	Echo Compiling: {default}.cpp
	{CPlus} {depDir}{default}.cpp -o {targDir}{default}.cpp.o {CPlusOptions}

# FILE LIST VARIABLES

HelloPartOBJECTS = 
			"{ObjectsDir}HelloPart.cpp.o"			

# Uncomment libraries below as needed.	
HelloPartLibASLMObjects = 
			"{ODLibraries}XMPConst.cpp.o" 
			"{ODLibraries}OperatorNewLib.o" 
			"{ObjectsDir}HelloPartLibASLM.cl.o" 
			"{ODLibraries}UtilitiesLibASLM.cl.o" 
#			"{ODLibraries}UILibASLM.cl.o" 
			"{ODLibraries}CoreLibASLM.cl.o" 
#			"{ODLibraries}MessagingLibASLM.cl.o" 
#			"{ODLibraries}ImagingLibASLM.cl.o" 
#			"{ODLibraries}OSLLibASLM.cl.o" 
#			"{ODLibraries}FocusLib.cpp.o" 
			"{Libraries}LibraryManager.debug.o" 
			"{Libraries}Runtime.o" 
			"{Libraries}Interface.o" 
#			"{CLibraries}StdCLib.o"

# ROOT TARGET

HelloPart  "{TargetDir}HelloPartLibASLM"

# REZ STEP

"{ObjectsDir}"HelloPartLib.o  "{SourceDir}"HelloPart.r 
								"{ODRIncludes}StdTypes.r" 
								"{ODCPlusIncludes}StdDefs.h" 
								"{SourceDir}HelloPartDef.h"
	Set Echo 0
	Echo Rezzing: HelloPart.r
	Rez {RezOptions} "{SourceDir}"HelloPart.r -a -o {Targ}

# BUILD LIBRARIES

"{ObjectsDir}"HelloPartLib.o  {HelloPartOBJECTS}
	Set Echo 0
	Echo Libing: HelloPartLib.o
	Lib {LibOptions} {Deps} -o {Targ}

"{ObjectsDir}HelloPartLibASLM.cl.o"  
		"{ObjectsDir}HelloPartLib".o 
		"{SourceDir}HelloPart".exp
	Set Echo 0
	Echo Building: HelloPartLibASLM.cl.o
	BuildSharedLibrary 
			{BuildSharedLibraryOptions} 
			-exp "{SourceDir}HelloPart.exp" 
			-obj "{ObjectsDir}HelloPartLibASLM" 
			-far "{ObjectsDir}HelloPartLibASLM.cl.o" 
			"{ObjectsDir}HelloPartLib.o"

"{TargetDir}HelloPartLibASLM"  {HelloPartLibASLMObjects}
	Set Echo 0
	Echo Linking: HelloPartLibASLM
	LinkSharedLibrary 
			-lib "{TargetDir}HelloPartLibASLM" 
			-obj "{ObjectsDir}HelloPartLibASLM" 
			-symfile "{TargetDir}HelloPartLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{HelloPartLibASLMObjects}


# COPY RESOURCES

"{TargetDir}HelloPartLibASLM"  {HelloPartLibASLMObjects}
	Set Echo 0
	Echo Copying Resources From: HelloPartLib.o
	Echo "include "{ObjectsDir}HelloPartLib.o";" | Rez -a -o {Targ}

