//	File:		HelloPart.r
//
//	Contains:	Resources for HelloPart
//
//	Written by:	Richard Clark
//
//	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "StdTypes.r"
#include "StdDefs.h"
#include "HelloPartDef.h"

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kHelloPartKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kHelloPartCategory
			}
		}
	}
};

resource kNameMappings (kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kHelloPartID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kHelloPartKind
			}
		}
	}
};

resource kNameMappings (kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kHelloPartID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kHelloPartEditorUserString
		}
	}
};

resource kNameMappings (kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kHelloPartKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kHelloPartKindUserString
		}
	}
};

resource kNameMappings (kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kHelloPartCategory,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kHelloPartCategoryUserString
		}
	}
};

resource kNameMappings (kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kHelloPartKind,
		kXMPIsMacOSType {
			kHelloPartOSType
		}
	}
};

resource 'STR#' (5000, purgeable) {
	{ "Hello world" }
};

