#
#	File:		PartMakerSample.make
#
#	Contains:	Makefile for OpenDoc PartMakerSample test part
#
#	Written by:	PartMaker
#

# DIRECTORY VARIABLES

SourceDir = :
ObjectsDir = {SourceDir}Objects:
TargetDir = {SourceDir}

# TOOL OPTIONS

RezOptions = -i "{ODRIncludes}" -i "{ODCPlusIncludes}"
CPlusOptions = -sym full -mf -model far -d XMPDebug=1 -d ASLMBUILD -d CDECL= 
				-i "{ODCPlusIncludes}"
LinkOptions = -sym full -mf -model far
LibOptions = -sym full -mf -d
BuildSharedLibraryOptions = -sym full -i "{ODCPlusIncludes}"
LinkSharedLibraryOptions = -link -mf -sym full

# DIRECTORY DEPENDENCIES

"{ObjectsDir}"  "{SourceDir}"
				
# DEFAULT RULES

.cpp.o		.cpp
	Set Echo 0
	Echo Compiling: {default}.cpp
	{CPlus} {depDir}{default}.cpp -o {targDir}{default}.cpp.o {CPlusOptions}

# FILE LIST VARIABLES

PartMakerSampleOBJECTS = 
			"{ObjectsDir}PartMakerSample.cpp.o"			

# Uncomment libraries below as needed.	
PartMakerSampleLibASLMObjects = 
			"{ODLibraries}XMPConst.cpp.o" 
			"{ODLibraries}OperatorNewLib.o" 
			"{ObjectsDir}PartMakerSampleLibASLM.cl.o" 
			"{ODLibraries}UtilitiesLibASLM.cl.o" 
			"{ODLibraries}UILibASLM.cl.o" 
			"{ODLibraries}CoreLibASLM.cl.o" 
#			"{ODLibraries}MessagingLibASLM.cl.o" 
#			"{ODLibraries}LayoutLibASLM.cl.o" 
#			"{ODLibraries}ImagingLibASLM.cl.o" 
#			"{ODLibraries}OSLLibASLM.cl.o" 
#			"{ODLibraries}FocusLib.cpp.o" 
			"{Libraries}LibraryManager.debug.o" 
			"{Libraries}Runtime.o" 
			"{Libraries}Interface.o" 
#			"{CLibraries}StdCLib.o"

# ROOT TARGET

PartMakerSample  "{TargetDir}PartMakerSampleLibASLM"

# REZ STEP

"{ObjectsDir}"PartMakerSampleLib.o  "{SourceDir}"PartMakerSample.r 
								"{ODRIncludes}StdTypes.r" 
								"{ODCPlusIncludes}StdDefs.h" 
								"{SourceDir}PartMakerSampleDef.h"
	Set Echo 0
	Echo Rezzing: PartMakerSample.r
	Rez {RezOptions} "{SourceDir}"PartMakerSample.r -a -o {Targ}

# BUILD LIBRARIES

"{ObjectsDir}"PartMakerSampleLib.o  {PartMakerSampleOBJECTS}
	Set Echo 0
	Echo Libing: PartMakerSampleLib.o
	Lib {LibOptions} {Deps} -o {Targ}

"{ObjectsDir}PartMakerSampleLibASLM.cl.o"  
		"{ObjectsDir}PartMakerSampleLib".o 
		"{SourceDir}PartMakerSample".exp
	Set Echo 0
	Echo Building: PartMakerSampleLibASLM.cl.o
	BuildSharedLibrary 
			{BuildSharedLibraryOptions} 
			-exp "{SourceDir}PartMakerSample.exp" 
			-obj "{ObjectsDir}PartMakerSampleLibASLM" 
			-far "{ObjectsDir}PartMakerSampleLibASLM.cl.o" 
			"{ObjectsDir}PartMakerSampleLib.o"

"{TargetDir}PartMakerSampleLibASLM"  {PartMakerSampleLibASLMObjects}
	Set Echo 0
	Echo Linking: PartMakerSampleLibASLM
	LinkSharedLibrary 
			-lib "{TargetDir}PartMakerSampleLibASLM" 
			-obj "{ObjectsDir}PartMakerSampleLibASLM" 
			-symfile "{TargetDir}PartMakerSampleLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{PartMakerSampleLibASLMObjects}


# COPY RESOURCES

"{TargetDir}PartMakerSampleLibASLM"  {PartMakerSampleLibASLMObjects}
	Set Echo 0
	Echo Copying Resources From: PartMakerSampleLib.o
	Echo "include "{ObjectsDir}PartMakerSampleLib.o";" | Rez -a -o {Targ}

