/*
	File:		PartMakerSample.r

	Contains:	PartMakerSample Resources

	Written by:	PartMaker
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "StdTypes.r"
#include "StdDefs.h"
#include "PartMakerSampleDef.h"

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kPartMakerSampleKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kPartMakerSampleCategory
			}
		}
	}
};

resource kNameMappings (kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kPartMakerSampleID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kPartMakerSampleKind
			}
		}
	}
};

resource kNameMappings (kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kPartMakerSampleID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kPartMakerSampleEditorUserString
		}
	}
};

resource kNameMappings (kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kPartMakerSampleKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kPartMakerSampleKindUserString
		}
	}
};

resource kNameMappings (kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kPartMakerSampleCategory,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kPartMakerSampleCategoryUserString
		}
	}
};

resource kNameMappings (kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kPartMakerSampleKind,
		kXMPIsMacOSType {
			kPartMakerSampleOSType
		}
	}
};

//-------------------------------------------------------------------------------------
// STR# for temp content
//-------------------------------------------------------------------------------------

resource 'STR#' (kContentStringResID, purgeable) {
	{ "PartMakerSample content" }
};


//-------------------------------------------------------------------------------------
// About Box ALRT
//-------------------------------------------------------------------------------------

resource 'ALRT' (kPartMakerSampleAboutBoxID) {
	{62, 145, 210, 352},
	kPartMakerSampleAboutBoxID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	},
	centerParentWindow
};

resource 'DITL' (kPartMakerSampleAboutBoxID) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{82, 72, 102, 130},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{26, 28, 66, 180},
		StaticText {
			disabled,
			"^0"
		}
	}
};
