#
#	File:		CFrntDmp.mak
#
#	Contains:	Makefile for a CFront load/dump file
#
#	Written by:	Nick Pilch
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <5>	 3/22/94	NP		Rebuilt dependencies.
#		 <4>	 3/17/94	CG		#1151392: Rebuilt dependencies.
#		 <3>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
#									#1150864.
#		 <2>	 2/10/94	T		.cp -> .cpp
#		<12>	  2/3/94	JA		Rebuilt dependencies (from new universal
#									headers.)
#		<11>	 1/31/94	NP		Updated dependencies.
#		<10>	 12/8/93	NP		Removed ASLM dependencies.
#		 <9>	 12/7/93	NP		Fixed for new build changes.
#		 <7>	 12/6/93	NP		Rebuilt dependencies,.
#		 <6>	 12/6/93	NP		Updated dependencies.
#		 <5>	 12/3/93	T		Rename XMPError.h to ErrorDef.h
#		 <4>	 12/2/93	VL		Updated ASLM Dependencies.
#		 <3>	11/22/93	NP		Added ASLM dependency for dump file.
#		 <2>	11/19/93	NP		Fixed bug that caused a CFront.dump to be
#									rebuilt all the time.
#		 <1>	11/12/93	NP		first checked in
#
#	To Do:
#

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODODDir}"
				
#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

DumpSOURCEFILES = 
			"{ODODDir}"CFrntDmp.cpp					

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODLoadObjects}"CFrontDump.dump
#	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODLoadObjects}"CFrontDump.dump
#	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODLoadObjects}"CFrontDump.dump
	Echo -n "" > "{MPW}"ODAppName

BuildSCASLM  "{ODLoadObjects}"CFrontDump.dump
	Echo -n "" > "{MPW}"ODAppName


"{ODLoadObjects}"CFrontDump.dump  {DumpSOURCEFILES}
	Echo Precompiling: {Targ}
	{CPlus} "{ODODDir}"CFrntDmp.cpp 
			-dumpc "{ODLoadObjects}"CFrontDump.dump 
			-o "{ODLoadObjects}"CFrntDmp.cpp.o 
			{CPlusOptions}


# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-ignore "{CIncludes}"								
		-append "{MAKEFILE}"								
		-objdir "{ODLoadObjects}"							
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{DumpSOURCEFILES}
	Target "{MAKEFILE}"
	Find  "{MAKEFILE}"
	Replace '/"({ODLoadObjects})1"CFrntDmp.cpp.o	  /' '"1CFrontDump.dump"  ' "{MAKEFILE}"
	Save "{MAKEFILE}"

#*** Dependencies: Cut here ***
# This makefile was produced at 7:59:21 PM on Tue, Mar 22, 1994 by
# MakeDepend

"{ODLoadObjects}CFrontDump.dump"  
	"{ODODDir}"CFrntDmp.cpp 
	"{ODTestPartsDir}"AltPoint.h 
	"{ODCPlusIntfDir}"XMPTypes.h 
	"{ODCPlusIntfDir}"ErrorDef.h 
	"{ODCPlusIntfDir}"PlfmDef.h 
	"{ODCPlusIntfDir}"Except.h 
	"{ODUtilitiesDir}"ISOStr.h 
	"{ODUtilitiesDir}"PasclStr.h 
	"{ODUtilitiesDir}"XMPMem.h 
	"{ODCPlusIntfDir}"StdDefs.h 
	"{ODCPlusIntfDir}"PlfmType.h 
	"{ODCPlusIntfDir}"QDFix.h

