/*
	File:		SEUtils.h

	Contains:	Interface to Semantic Events Utility Functions

	Written by:	Nick Pilch

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <8>	  2/9/94	NP		Tiger Team cleanup.
		 <7>	  2/7/94	NP		Tiger Team doings.
		 <6>	 12/9/93	eeh		added ThrowIfNotAbsent
		 <5>	11/15/93	eeh		added ThrowIfCantCoerce
		 <4>	10/22/93	NP		Added GetSLongAttr.
		 <3>	 9/10/93	NP		Added some functions.
		 <2>	 8/23/93	NP		Added some utils.
		 <1>	 7/23/93	CG		first checked in
		 <1>	 7/23/93	CG		first checked in
		 <4>	 4/28/93	NP		File name changes.
		 <3>	 3/17/93	NP		Added Pathname2FSSpec declaration.
		 <2>	 3/16/93	NP		Added some methods.
		 <1>	 3/15/93	NP		first checked in

	To Do:
*/

#ifndef _SEUTILS_
#define _SEUTILS_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

#ifndef _SEMTINTF_
#include "SemtIntf.h"
#endif

const Boolean kNotSysHandler = false;
const Boolean kIsSysHandler = true;

XMPBoolean MissingParams(const AppleEvent* message);
pascal OSErr Pathname2FSSpec(DescType		/*typeCode*/,
								Ptr			dataPtr,
								Size		dataSize,
								DescType	/*toType*/,
								long		/*handlerRefCon*/,
								AEDesc*		result);
OSErr DecodeOrdinal(AEDesc ordData, long count, long* index,
    				Boolean* allFlag, Boolean* zeroFlag);
void ReallocAndStuff2nd4Bytes(XMPOSLToken* token, XMPULong value);
XMPULong GetSecondFourBytesFromDataHandle(const XMPOSLToken* token);
XMPSLong GetSLongAttr(AppleEvent* ae, AEKeyword keyword);

// does an in-place coercion!
void ThrowIfCantCoerce( AEDesc* data, DescType desiredType ) ;
void ThrowIfNotAbsent( OSErr err ) ;

#endif // _SEUTILS_