/*
	File:		XMPError.r

	Contains:	Exception strings for exception logging code.

	Written by:	Steve Smith

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 8/25/93	SS		first checked in
	To Do:
*/

#include "Types.r"


resource 'STR#' (100, "Exceptions", locked, preload) {
	{	/* array StringArray: 57 elements */
		"kXMPErrOutOfMemory",				/* [1] */
		"kXMPErrCannotResize",				/* [2] */
		"kXMPErrInvalidContainer",			/* [3] */
		"kXMPErrInvalidDocument",			/* [4] */
		"kXMPErrInvalidDraft",				/* [5] */
		"kXMPErrInvalidStorageUnit",		/* [6] */
		"kXMPErrCannotEmbed",				/* [7] */
		"kXMPErrInvalidPart",				/* [8] */
		"kXMPErrInvalidFrame",				/* [9] */
		"kXMPErrInvalidWindow",				/* [10] */
		"kXMPErrInvalidWindowState",		/* [11] */
		"kXMPErrInvalidSystemInterface",	/* [12] */
		"kXMPErrInvalidFocusSet",			/* [13] */
		"kXMPErrInvalidFocusModule",		/* [14] */
		"kXMPErrInvalidDispatchModule",		/* [15] */
		"kXMPErrInvalidType",				/* [16] */
		"kXMPErrTypeExists",				/* [17] */
		"kXMPErrInvalidName",				/* [18] */
		"kXMPErrNameExists",				/* [19] */
		"kXMPErrInvalidID",					/* [20] */
		"kXMPErrInvalidToken",				/* [21] */
		"kXMPErrInvalidExtension",			/* [22] */
		"kXMPErrInvalidValue",				/* [23] */
		"kXMPErrInvalidProperty",			/* [24] */
		"kXMPErrInvalidPosCode",			/* [25] */
		"kXMPErrInvalidValueIndex",			/* [26] */
		"kXMPErrKeyDoesNotExist",			/* [27] */
		"kXMPErrKeyAlreadyExists",			/* [28] */
		"kXMPErrWrongType",					/* [29] */
		"kXMPErrPartMissing",				/* [30] */
		"kXMPErrExtensionMissing",			/* [31] */
		"kXMPErrCannotAddProperty",			/* [32] */
		"kXMPErrCannotAddType",				/* [33] */
		"kXMPErrUnfocusedStorageUnit",		/* [34] */
		"kXMPErrInvalidPermissions",		/* [35] */
		"kXMPErrInvalidVersion",			/* [36] */
		"kXMPErrCannotCreateDraftVersion",	/* [37] */
		"kXMPErrInvalidBelowDraft",			/* [38] */
		"kXMPErrDraftNotExists",			/* [39] */
		"kXMPErrContainerExists",			/* [40] */
		"kXMPErrCannotCollapseDrafts",		/* [41] */
		"kXMPErrUnemptyDraft",				/* [42] */
		"kXMPErrInvalidContainerType",		/* [43] */
		"kXMPErrContainerNotExists",		/* [44] */
		"kXMPErrDraftExistsWithDifferentID",/* [45] */
		"kXMPErrNoPreviousDraft",			/* [46] */
		"kXMPErrInvalidPropertyName",		/* [47] */
		"kXMPErrInvalidSUCursor",			/* [48] */
		"kXMPErrVersionListInternalized",	/* [49] */
		"kXMPErrNoVersionList",				/* [50] */
		"kXMPErrNoDraftProperties",			/* [51] */
		"kXMPErrInvalidRefCount",			/* [52] */
		"kXMPErrCannotCreateFrame",			/* [53] */
		"kXMPErrCannotCreateWindow",		/* [54] */
		"kXMPErrCannotGetPersistentObject",	/* [55] */
		"kXMPErrOutstandingDraft",			/* [56] */
		"kXMPErrZeroRefCount",				/* [57] */
	}
};

resource 'STR#' (101, "Classes", locked, preload) {
	{	/* array StringArray: 51 elements */
		"XMPErrInvalidDraft"
		"XMPAEHashTable",					/* [1] */
		"XMPAEHashTableIterator",			/* [2] */
		"XMPArbitrator",					/* [3] */
		"XMPBentoContainer",				/* [4] */
		"XMPContainer",						/* [5] */
		"XMPDocument",						/* [6] */
		"XMPDraft",							/* [7] */
		"XMPEmbeddedContainer",				/* [8] */
		"XMPEmbeddedHandlers",				/* [9] */
		"XMPFileContainer",					/* [10] */
		"XMPFocusModule",					/* [11] */
		"XMPFocusModuleAssociation",		/* [12] */
		"XMPFocusOwnerIterator",			/* [13] */
		"XMPFocusSet",						/* [14] */
		"XMPFocusSetIterator",				/* [15] */
		"XMPFrame",							/* [16] */
		"XMPFSBentoHandlers",				/* [17] */
		"XMPLayout",						/* [18] */
		"XMPMacCanvas",						/* [19] */
		"XMPMacClipboard",					/* [20] */
		"XMPMacDispatcher",					/* [21] */
		"XMPMacDragAndDrop",				/* [22] */
		"XMPMacLink",						/* [23] */
		"XMPMacMessageInterface",			/* [24] */
		"XMPMacNameResolver",				/* [25] */
		"XMPMacNameSpace",					/* [26] */
		"XMPMacShape",						/* [27] */
		"XMPMacStorageSystem",				/* [28] */
		"XMPMacSymbols",					/* [29] */
		"XMPMacTransform",					/* [30] */
		"XMPMacTranslation",				/* [31] */
		"XMPMacValueIterator",				/* [32] */
		"XMPMacWindow",						/* [33] */
		"XMPMacWindowIterator",				/* [34] */
		"XMPMacWindowState",				/* [35] */
		"XMPMemBentoHandlers",				/* [36] */
		"XMPMemoryContainer",				/* [37] */
		"XMPPart",							/* [38] */
		"XMPPersistentObject",				/* [39] */
		"XMPRefCntObject",					/* [40] */
		"XMPSession",						/* [41] */
		"XMPSETransactionLink",				/* [42] */
		"XMPSimpleFocusModule",				/* [43] */
		"XMPStandardDispatchModule",		/* [44] */
		"XMPStorageUnit",					/* [45] */
		"XMPStorageUnitView",				/* [46] */
		"XMPStringHashTable",				/* [47] */
		"XMPStringHashTable",				/* [48] */
		"XMPStringHashTableIterator",		/* [49] */
		"XMPStringHashTableIterator",		/* [50] */
		"XMPUndo",							/* [51] */

	}
};
