/*
	File:		ISOStr.h

	Contains:	Routines to manipulate XMPISOStr

	Written by:	Steve Smith, Vincent Lo.

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	11/23/93	VL		Added overloaded XMPISOStrCopy, overloaded
									XMPISOStrCompare and XMPISOStrConcat.
		 <3>	 11/5/93	NP		Added ISOStrEqual and cleaned up interfaces
									to other routines.
		 <2>	 7/23/93	VL		Changed _ISOSTRING_ to _ISOSTR_.

	To Do:
*/

/************************************************************

	ISOString.h
	ISO String handling
	
	Copyright Apple Computer,Inc. 1993
	All rights reserved

************************************************************/


#ifndef _ISOSTR_
#define _ISOSTR_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif


XMPISOStr	XMPISOStrCopy (XMPISOStr dest, const XMPISOStr source);
XMPISOStr	XMPISOStrCopy (XMPISOStr dest, const XMPISOStr source, XMPULong length);
XMPISOStr	XMPISOStrConcat (XMPISOStr dest, const XMPISOStr source);
XMPISOStr	XMPISOStrConcat (XMPISOStr dest, const XMPISOStr source, XMPULong length);
XMPSLong	XMPISOStrCompare (const XMPISOStr iso1, const XMPISOStr iso2);
XMPSLong	XMPISOStrCompare (const XMPISOStr iso1, const XMPISOStr iso2, XMPULong length);
XMPBoolean	XMPISOStrEqual (const XMPISOStr iso1, const XMPISOStr iso2);
XMPULong	XMPISOStrLength (const XMPISOStr iso);
XMPISOStr	XMPISOStrFromCStr(const char* cstring);


#endif // _ISOSTR_
