/*
	File:		NmSpcUtl.cpp

	Contains:	NameSpace utility functions

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/28/94	CG		1153547: Renamed XMPSessn.h to XMPSessM.h
		 <2>	 2/17/94	eeh		bug #1143340: removed GetUserKindFromKind,
									*Editor* and *Category* (to binding.cpp)
		 <3>	  2/7/94	JA		Tiger Team Makeover!
		 <2>	 1/21/94	CG		Got rid of warnings.
		 <1>	 1/18/94	CG		first checked in
	To Do:
*/

#ifndef _NMSPCUTL_
#include "NmSpcUtl.h"
#endif

#ifndef _XMPSESSM_
#include "XMPSessM.h"
#endif

#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

#ifndef _ERRORS_
#include <Errors.h>
#endif

#ifndef _NMSPCMGR_
#include "NmSpcMgr.h"
#endif

#ifndef _NAMSPACE_
#include "NamSpace.h"
#endif

#ifndef _STDDEFS_
#include "StdDefs.h"
#endif

#include <string.h>

//------------------------------------------------------------------------------
// XMPMacGetParFileSpec
//	Get the FileSpec of this file's parent folder
//------------------------------------------------------------------------------

TMacFileSpec* XMPMacGetParFileSpec(TMacFileSpec *theFileSpec)
{
	TMacFileSpec* 	theParFileSpec=kXMPNULL;
	Str63			theName;
	XMPSLong		folderDirID = 0;
	CInfoPBRec		CinfoPB;
	
	memset (&CinfoPB,0,sizeof(CinfoPB));
	CinfoPB.hFileInfo.ioNamePtr =(StringPtr)&theName;
	CinfoPB.hFileInfo.ioFDirIndex = -1;
	CinfoPB.hFileInfo.ioVRefNum = theFileSpec->fVRefNum;
	CinfoPB.hFileInfo.ioDirID = theFileSpec->fParID;
	
	if ( fnfErr != (PBGetCatInfo( &CinfoPB, false )) )
	{
		if ( CinfoPB.hFileInfo.ioFlAttrib & (1<<4) )
		{
			theParFileSpec = new TMacFileSpec(CinfoPB.dirInfo.ioVRefNum, 
									CinfoPB.dirInfo.ioDrParID, theName);
		}
	}

	return theParFileSpec;
}



//------------------------------------------------------------------------------
// XMPGetDirID
//	Given the FSSpec of a folder, 
//     return the DirID of the desired folder or -1 if not found.
//------------------------------------------------------------------------------
XMPULong XMPGetDirID(TMacFileSpec* theFileSpec)
{ 
	CInfoPBRec				CinfoPB;
	XMPSLong				result = (-1);
	XMPULong				osResult;
	
	memset (&CinfoPB,0,sizeof(CinfoPB));
	CinfoPB.hFileInfo.ioNamePtr = theFileSpec->fName;	// ptr to folder to find
	CinfoPB.hFileInfo.ioFDirIndex = 0;
	CinfoPB.hFileInfo.ioVRefNum = theFileSpec->fVRefNum;
	CinfoPB.hFileInfo.ioDirID = theFileSpec->fParID;
		
	if ( fnfErr != ( osResult = PBGetCatInfo( &CinfoPB, false ) ) ) {
	
			// if this is a folder
		if ( CinfoPB.hFileInfo.ioFlAttrib & (1<<4) )
		{
				// the folder has been found, return its ID
			result = CinfoPB.dirInfo.ioDrDirID; 
		}
	}
	
	return ( result );
} /*XMPGetDirID*/



