/*
	File:		NmSpcUtl.h

	Contains:	Function prototypes of name space utilities

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <6>	 2/17/94	eeh		bug #1143340: removed GetUserKindFromKind,
									*Editor* and *Category* (to binding.h)
		 <5>	  2/7/94	JA		Removed spurious 'in progress' comment.
		 <4>	  2/7/94	JA		Tiger Team Makeover!
		 <3>	  2/4/94	T		class XMPSession;
		 <2>	  2/4/94	T		DONT #include header files for Class
									Definitions
		 <1>	 1/18/94	CG		first checked in
	To Do:
*/

#ifndef _NMSPCUTL_
#define _NMSPCUTL_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//==============================================================================
// Classes used by this interface
//==============================================================================

class TMacFileSpec;
class XMPSession;

//==============================================================================
// Function prototypes of name space utilities
//==============================================================================

TMacFileSpec* XMPMacGetParFileSpec(TMacFileSpec *theFileSpec);
XMPULong XMPGetDirID(TMacFileSpec* theFileSpec);

#endif // _NMSPCUTL_
