#
#	File:		Utilitys.mak
#
#	Contains:	Makefile for OpenDoc Utilities subsystem
#
#	Written by:	Vincent Lo, Nick Pilch
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		<11>	 3/28/94	CG		1153547: Renamed XMPSessn.h to XMPSessM.h -
#									updated deps.
#		<10>	 3/25/94	VL		Updated dependencies.
#		 <9>	 3/23/94	NP		Rebuilt dependencies.
#		 <8>	 3/23/94	NP		Removed dependency on Core and
#									XMPConst.cpp.
#		 <7>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
#									#1150864.
#		 <6>	  3/1/94	JA		Link in XMPConst.cpp.o in ASLM build.
#		 <5>	 2/28/94	CG		Moved XMPPart to Core.
#		 <4>	 2/16/94	JA		Rebuilt since things are including
#									AltPoint.h now.
#		 <3>	 2/10/94	T		.cppp -> .cpp  (oops!)
#		 <2>	 2/10/94	T		renaming files
#		<19>	  2/7/94	JA		Utility.h --> XMPUtils.h
#		<18>	  2/7/94	JA		Utility.h --> XMPUtils.h
#		<17>	 1/31/94	JA		Rebuilt dependencies for QDFix.h.
#		<16>	 1/18/94	CG		Added NmSpcUtl.cpp to UtilitiesObjects.
#		<15>	 1/11/94	NP		Updated dependencies.
#		<14>	12/10/93	CG		Moved resource copying to after
#									LinkSharedLibrary since link wipes out
#									resources.
#		<13>	 12/8/93	NP		Removed ASLM dependencies.
#		<12>	 12/3/93	NP		Changed option to -symfile -symFile.
#		<11>	 12/3/93	T		Rename XMPError.h to ErrorDef.h
#		<10>	 12/2/93	VL		Updated ASLM Dependencies.
#		 <9>	11/30/93	NP		Added OperatorNewLib.
#		 <8>	11/29/93	JA		Rebuilt dependencies for point/rect/poly.
#		 <7>	11/23/93	JA		Updated after moving Rect.h.
#		 <6>	11/23/93	JA		Added Rect and Polygon.
#		 <5>	11/19/93	NP		Added XMPNew.cpp
#		 <4>	10/28/93	NP		Updated dependencies.
#		 <3>	10/19/93	CG		Added libs necessary for ASLM building to
#									UtilitiesLibASLMObjects.
#		 <2>	10/18/93	CG		Put XMPPart.cpp back into source list,
#									updated dependencies.
#		 <1>	10/18/93	T		first checked in
#		<12>	 10/6/93	JA		Added Point module.
#		<11>	 9/22/93	NP		Mods for new MakeDepend scheme.
#		<10>	 9/20/93	NP		Added Except.cpp to ASLM-dependent files.
#		 <9>	 8/23/93	NP		Added ASLM dependencies.
#		 <8>	 8/20/93	VL		Updated dependencies.
#		 <7>	 8/17/93	RR		Added DictList
#		 <6>	 8/16/93	NP		Added XMPMem.
#		 <5>	 8/13/93	RR		Added OrdColl.cpp
#		 <4>	 8/10/93	VL		Fixed some dependencies problems.
#		 <3>	  8/9/93	VL		Updated dependencies.
#		 <2>	  8/9/93	NP		Updated ASLM rules.
#		 <1>	  8/4/93	VL		first checked in
#
#	To Do:
#

# DIRECTORY DEPENDENCIES

"{JediObjects}" 	"{JediUtilitiesDir}"
"{JediObjects}" 	"{JediCoreDir}"		# This is where XMPConst.cpp lives

#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

UtilitiesOBJECTS = 
			"{JediObjects}AEHshTbl.cpp.o"				
			"{JediObjects}Except.cpp.o"					
			"{JediObjects}HashTabl.a.o"					
			"{JediObjects}ISOStr.cpp.o"					
			"{JediObjects}List.cpp.o"					
			"{JediObjects}NmSpcUtl.cpp.o"				
			"{JediObjects}OrdColl.cpp.o"					
			"{JediObjects}DictList.cpp.o"				
			"{JediObjects}Node.cpp.o"					
			"{JediObjects}PasclStr.cpp.o"				
			"{JediObjects}StrHshTb.cpp.o"				
			"{JediObjects}XMPUtils.cpp.o"				
			"{JediObjects}XMPFile.cpp.o"					
#			"{JediObjects}XMPNew.cpp.o"					
#			"{JediObjects}XMPPart.cpp.o"					
			"{JediObjects}XMPMem.cpp.o"

UtilitiesSOURCEFILES = 
			"{JediUtilitiesDir}"AEHshTbl.cpp					
			"{JediUtilitiesDir}"Except.cpp					
			"{JediUtilitiesDir}"HashTabl.a					
			"{JediUtilitiesDir}"ISOStr.cpp					
			"{JediUtilitiesDir}"List.cpp						
			"{JediUtilitiesDir}"NmSpcUtl.cpp					
			"{JediUtilitiesDir}"OrdColl.cpp					
			"{JediUtilitiesDir}"DictList.cpp					
			"{JediUtilitiesDir}"Node.cpp						
			"{JediUtilitiesDir}"PasclStr.cpp					
			"{JediUtilitiesDir}"StrHshTb.cpp					
			"{JediUtilitiesDir}"XMPUtils.cpp					
			"{JediUtilitiesDir}"XMPFile.cpp					
#			"{JediUtilitiesDir}"XMPNew.cpp					
#			"{JediUtilitiesDir}"XMPPart.cpp					
			"{JediUtilitiesDir}"XMPMem.cpp			

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{JediObjects}"UtilitiesLib.o
	Echo -n "" > "{MPW}"JediAppName

BuildSC  "{JediObjects}"UtilitiesLib.o
	Echo -n "" > "{MPW}"JediAppName

BuildCFASLM  "{JediBinaryDir}UtilitiesLibASLM"
	Echo -n "" > "{MPW}"JediAppName

BuildSCASLM  "{JediBinaryDir}UtilitiesLibASLM"
	Echo -n "" > "{MPW}"JediAppName


"{JediObjects}"UtilitiesLib.o  {UtilitiesOBJECTS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}


"{JediObjects}UtilitiesLibASLM.cl.o"  
		"{JediObjects}UtilitiesLib".o 
		"{JediUtilitiesDir}Utilitys".exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{BuildSharedLibraryOptions} 
			-exp "{JediUtilitiesDir}Utilitys.exp" 
			-obj "{JediObjects}UtilitiesLibASLM" 
			-far "{JediObjects}UtilitiesLibASLM.cl.o" 
			"{JediObjects}UtilitiesLib.o"

UtilitiesLibASLMObjects = 
#			"{JediObjects}XMPConst.cpp.o" 
			"{JediObjects}OperatorNewLib.o" 
			"{JediObjects}UtilitiesLibASLM.cl.o" 
			{CompilerLibraries} 
			{ASLMLibraries} 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"
"{JediBinaryDir}UtilitiesLibASLM"  {UtilitiesLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{JediBinaryDir}UtilitiesLibASLM" 
			-obj "{JediObjects}UtilitiesLibASLM" 
			-symfile "{JediBinaryDir}UtilitiesLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{UtilitiesLibASLMObjects}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-ignore "{CIncludes}"								
		-append "{MAKEFILE}"								
		-objdir "{JediObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{JediBinaryDir}"DummyTarget					
		{UtilitiesSOURCEFILES}

#*** Dependencies: Cut here ***
# This makefile was produced at 10:43:43 AM on Mon, Mar 28, 1994 by
# MakeDepend

"{JediObjects}"AEHshTbl.cpp.o	  
	"{JediUtilitiesDir}"AEHshTbl.cpp 
	"{JediUtilitiesDir}"AEHshTbl.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"Except.cpp.o	  
	"{JediUtilitiesDir}"Except.cpp 
	"{JediCPlusIntfDir}"Except.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"HashTabl.a.o	  
	"{JediUtilitiesDir}"HashTabl.a 
	"{AIncludes}"Traps.A

"{JediObjects}"ISOStr.cpp.o	  
	"{JediUtilitiesDir}"ISOStr.cpp 
	"{JediUtilitiesDir}"ISOStr.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"List.cpp.o	  
	"{JediUtilitiesDir}"List.cpp 
	"{JediUtilitiesDir}"List.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"NmSpcUtl.cpp.o	  
	"{JediUtilitiesDir}"NmSpcUtl.cpp 
	"{JediUtilitiesDir}"NmSpcUtl.h 
	"{JediCPlusIntfDir}"XMPSessM.h 
	"{JediCPlusIntfDir}"NmSpcMgr.h 
	"{JediCPlusIntfDir}"NamSpace.h 
	"{JediCPlusIntfDir}"StdDefs.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"PlfmDef.h 
	"{JediCPlusIntfDir}"XMPObj.h 
	"{JediCPlusIntfDir}"BaseSess.h 
	"{JediCPlusIntfDir}"NmSpcMgM.h 
	"{JediCPlusIntfDir}"NamSpacM.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediUtilitiesDir}"AEHshTbl.h 
	"{JediCPlusIntfDir}"QDFix.h

"{JediObjects}"OrdColl.cpp.o	  
	"{JediUtilitiesDir}"OrdColl.cpp 
	"{JediUtilitiesDir}"OrdColl.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediUtilitiesDir}"List.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"DictList.cpp.o	  
	"{JediUtilitiesDir}"DictList.cpp 
	"{JediUtilitiesDir}"DictList.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediUtilitiesDir}"List.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"Node.cpp.o	  
	"{JediUtilitiesDir}"Node.cpp 
	"{JediUtilitiesDir}"Node.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediUtilitiesDir}"List.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"PasclStr.cpp.o	  
	"{JediUtilitiesDir}"PasclStr.cpp 
	"{JediUtilitiesDir}"PasclStr.h 
	"{JediUtilitiesDir}"ISOStr.h 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"StrHshTb.cpp.o	  
	"{JediUtilitiesDir}"StrHshTb.cpp 
	"{JediUtilitiesDir}"StrHshTb.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"XMPUtils.cpp.o	  
	"{JediUtilitiesDir}"XMPUtils.cpp 
	"{JediUtilitiesDir}"XMPUtils.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"SUView.h 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"XMPObj.h 
	"{JediCPlusIntfDir}"StorageU.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h 
	"{JediCPlusIntfDir}"RefCtObj.h

"{JediObjects}"XMPFile.cpp.o	  
	"{JediUtilitiesDir}"XMPFile.cpp 
	"{JediUtilitiesDir}"XMPFile.h 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediUtilitiesDir}"PasclStr.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h 
	"{JediCPlusIntfDir}"PlfmDef.h

"{JediObjects}"XMPMem.cpp.o	  
	"{JediUtilitiesDir}"XMPMem.cpp 
	"{JediUtilitiesDir}"XMPMem.h 
	"{JediCPlusIntfDir}"Except.h 
	"{JediCPlusIntfDir}"XMPObj.h 
	"{JediCPlusIntfDir}"XMPTypes.h 
	"{JediCPlusIntfDir}"ErrorDef.h 
	"{JediCPlusIntfDir}"PlfmDef.h 
	"{JediCPlusIntfDir}"PlfmType.h 
	"{JediCPlusIntfDir}"QDFix.h

