/*
	File:		SysSessM.h

	Contains:	XMPMacSystemSession class definition

	Written by:	Vincent Lo

	Copyright:	 1993-4 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <1>	  2/3/94	CG		first checked in
	To Do:

*/

#ifndef _BASESESS_
#define _BASESESS_

#ifndef _PLFMDEF_
#include "PlfmDef.h"
#endif

#ifndef _XMPOBJ_
#include "XMPObj.h"
#endif

//==============================================================================
// Theory of Operation
//==============================================================================

//==============================================================================
// Classes defined in this interface
//==============================================================================

class	XMPBaseSession;

//==============================================================================
// Classes used by this interface
//==============================================================================

class	XMPStorageSystem;
class	XMPNameSpaceManager;
class	XMPBinding;

//==============================================================================
// XMPBaseSession
//==============================================================================

#define kXMPBaseSessionID "appl:XMPBaseSession$class,1.0.0"

class XMPBaseSession : public XMPObject
{
  public:

	XMPVMethod XMPStorageSystem*		GetStorageSystem();

	XMPVMethod void						Close();

	XMPVMethod XMPSize					Purge(XMPSize size);

	XMPVMethod XMPNameSpaceManager*		GetNameSpaceManager();

	XMPVMethod XMPBinding*				GetBinding()
		= 0 ;

  public: // Private by convention

	XMPBaseSession();
	XMPNVMethod void	InitSession();
	XMPVMethod ~ CDECL XMPBaseSession();

  protected:

	XMPStorageSystem*		fStorage;
	XMPNameSpaceManager*	fNameSpaceManager;
};


#endif // _BASESESS_