/*
	File:		Canvas.h

	Contains:	Definitions of class XMPAbsCanvas

	Written by:	Joshua Susser & Sepp Friedrich

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):
			
		 <9>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <8>	  2/7/94	JA		The Makeover Continues!
		 <7>	  2/3/94	JA		Tiger Team Makeover!
		 <6>	 1/24/94	SS		Checkin for Joshua (see below)
		 <11+>	 1/13/94	JBS		update region support, new getters
		 <11>	  7/12/93	RCR		Help it to link. Added = 0
		 <10>	  7/12/93	RCR		Help it to compile
		 <3>	  7/6/93	JBS		separate into abstract/concrete
		 <2>	 4/30/93	JBS		8.3 file names
		 <1>	 4/14/93	JBS		first checked in
*/

#ifndef _CANVAS_
#define _CANVAS_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

#ifndef _XMPOBJ_
#include "XMPObj.h"			// base class
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class XMPAbsCanvas;

//==============================================================================
// Classes used in this interface
//==============================================================================

class XMPFacet;
class XMPPart;
class XMPShape;

//==============================================================================
// XMPCanvas
//==============================================================================

class XMPAbsCanvas : public XMPObject
{

public:

	//---------------------------------
	// overrides

//	XMPVMethod XMPSize Purge(XMPSize size);		// override from XMPObject

	//---------------------------------
	// constructor & destructor

	XMPAbsCanvas() {};

	XMPVMethod ~ CDECL XMPAbsCanvas() {};
	
	//---------------------------------
	// getters

	XMPVMethod XMPGraphicsSystem GetGraphicsSystem()
		= 0;
	
	XMPVMethod XMPPlatformCanvas GetPlatformCanvas()
		= 0;
	
	XMPVMethod XMPPart* GetOwner()
		= 0;
	XMPVMethod void SetOwner(XMPPart* owner)
		= 0;

	XMPVMethod XMPFacet* GetFacet()
		= 0;
	XMPVMethod void SetFacet(XMPFacet* facet)
		= 0;

	XMPVMethod XMPBoolean IsDynamic()
		= 0;
	
	XMPVMethod XMPBoolean IsOffscreen()
	 	= 0;

	//---------------------------------
	// update region

	XMPMethod XMPShape* GetUpdateShape()
	 	= 0;

	XMPMethod void ResetUpdateShape()
	 	= 0;

	XMPMethod void Invalidate(XMPShape* shape)
	 	= 0;

	XMPMethod void Validate(XMPShape* shape)
	 	= 0;
};

#if PLATFORM_MACINTOSH
#ifndef _CANVASM_
#include "CanvasM.h"
#endif
#endif

#endif // _CANVAS_