/*
	File:		DispMod.h

	Contains:	Abstract class XMPDispatchModule

	Written by:	Richard Rodseth

	Copyright:	 1992-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<12>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		<11>	  2/9/94	NP		Tiger Team cleanup.
		<10>	  2/7/94	NP		XMPAbsDispatcher
		 <9>	 1/21/94	RR		Restored Dispatch() signature
		 <8>	 1/15/94	RR		WinState.h -> WinStat.h, Dispatch.h ->
									Disptch.h
		 <7>	 1/11/94	T		Init... changes
		 <6>	12/20/93	RR		New init strategy
		 <5>	 12/8/93	RR		Update forward declaration. XMPMethod ->
									XMPVMethod
		 <4>	 12/2/93	RR		Use new eventType definition
		 <3>	  8/9/93	NP		Added class id string.
		 <2>	 7/21/93	NP		Added a virtual keyword (temporary for
									ASLM).
		 <1>	12/18/92	RCR		Moved from Disptch.h

	To Do:
*/

#ifndef _DISPMOD_
#define _DISPMOD_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//=====================================================================================
// Classes defined in this interface
//=====================================================================================

class XMPDispatchModule;

//=====================================================================================
// Classes used by this interface
//=====================================================================================

class XMPSession;

//=====================================================================================
// XMPDispatchModule
//=====================================================================================

#define kXMPDispatchModuleID "appl:xmpdispatchmodule$class,1.0.0"

class XMPDispatchModule
{
	ASLM_COMPATIBLE

public:
		
	XMPDispatchModule();
	
	virtual ~ CDECL XMPDispatchModule();
	
	XMPNVMethod	void InitDispatchModule(XMPSession* session);
	
	XMPVMethod XMPBoolean Dispatch(XMPEventData event)
		= 0;
	
protected:

	XMPSession* fSession; // Access to globals
	XMPBoolean  fInitialized; // Used to catch multiple initializes
	
};

#endif // _DISPMOD_
