/*
	File:		FocusOwn.h

	Contains:	Interface to XMPFocusOwnerIterator class

	Written by:	Richard Rodseth

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	  2/9/94	NP		Tiger Team cleanup.
		 <3>	  2/7/94	NP		XMPFocusOwnerIterator
		 <2>	12/23/93	RR		Added Init method. Remove arguments from
									constructor
		 <1>	 12/8/93	RR		first checked in

	To Do:
*/

#ifndef _FOCUSOWN_
#define _FOCUSOWN_

#ifndef _XMPOBJ_
#include "XMPObj.h"
#endif

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif


//=====================================================================================
// Classes defined in this interface
//=====================================================================================

class XMPFocusOwnerIterator;

//=====================================================================================
// Classes used by this interface
//=====================================================================================

class XMPFocusModule;
class XMPFrame;

//=====================================================================================
// Class XMPFocusOwnerIterator
//=====================================================================================

class XMPFocusOwnerIterator
{
public:

	XMPFocusOwnerIterator();
	
	~XMPFocusOwnerIterator();
	
	XMPNVMethod void InitFocusOwnerIterator(XMPTypeToken focus, XMPFocusModule* module);
	
	XMPVMethod XMPFrame* First() 
		= 0;
		
	XMPVMethod XMPFrame* Next() 
		= 0;
		
	XMPVMethod XMPBoolean IsNotComplete() 
		= 0;
		
protected:

	XMPTypeToken fFocus;	
	XMPFocusModule* fFocusModule;
};

#endif // _FOCUSOWN_