/*
	File:		MenuBar.h

	Contains:	Interface to XMPMenuBar class

	Written by:	Richard Rodseth

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <8>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <7>	  2/9/94	NP		Tiger Team cleanup.
		 <6>	  2/7/94	NP		Tiger Team doings.
		 <5>	  2/7/94	NP		Tiger Team doings.
		 <4>	 1/21/94	RR		Misc. cleanup
		 <3>	 12/8/93	RR		Cleanup XMPMethod and forward declarations
		 <2>	 9/22/93	RR		Move methods from MenuBarM.h. Derive from
									RefCntObj
		 <1>	  9/9/93	RR		first checked in

	To Do:
*/

// MenuBar.h

#ifndef _MENUBAR_
#define _MENUBAR_

#ifndef _REFCTOBJ_
#include "RefCtObj.h"
#endif	

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//=====================================================================================
// Classes defined in this interface
//=====================================================================================

class XMPMenuBar;	

//=====================================================================================
// Classes used by this interface
//=====================================================================================

class XMPPart;

//=====================================================================================
// Class XMPAbsMenuBar
//=====================================================================================

class XMPAbsMenuBar : public XMPRefCntObject
{
public:
	XMPAbsMenuBar() {}
	XMPVMethod ~ CDECL XMPAbsMenuBar() {}
	
	XMPVMethod void	Release()
		= 0;
		
	XMPVMethod void Display()
		= 0;

	XMPVMethod XMPMenuBar* Copy()
		= 0;	

	XMPVMethod void AddMenuLast(XMPMenuID menuID, XMPPlatformMenu menu, XMPPart* part)
		= 0;

	XMPVMethod void AddMenuBefore(XMPMenuID menuID, 
								  XMPPlatformMenu menu, 
								  XMPPart* part, 
								  XMPMenuID beforeID)
		= 0;
		
	XMPVMethod void RemoveMenu(XMPMenuID menu)
		= 0;	

	XMPVMethod XMPPlatformMenu GetMenu(XMPMenuID menu)
		= 0;	

};

#ifdef PLATFORM_MACINTOSH
#ifndef _MENUBARM_
#include "MenuBarM.h"
#endif
#endif

#endif // _MENUBAR_