/*
	File:		NmSpcItM.h

	Contains:	Definition of XMPMacValueIterator class

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <2>	 1/29/94	NP		XMPMethod changes.
		 <1>	 1/14/94	CG		first checked in
	To Do:
*/

#ifndef _NMSPCITM_
#define _NMSPCITM_

//==============================================================================
// Classes defined in this interface
//==============================================================================

class XMPMacValueIterator;

//==============================================================================
// Classes used by this interface
//==============================================================================

class XMPMacNameSpace;

//==============================================================================
// XMPMacValueIterator
//==============================================================================

#define kXMPMacValueIteratorID "appl:xmpmacvalueiterator$class,1.0.0"

class XMPMacValueIterator : public XMPAbsValueIterator
{
	ASLM_COMPATIBLE

  public:

	XMPMacValueIterator(XMPNameSpace* nameSpace);
	virtual ~ CDECL XMPMacValueIterator();

	XMPVMethod void			First(XMPISOStr* key, XMPPtr* value, XMPULong* valueLength);
//	XMPMethod void			First(XMPOSType* key, XMPPtr* value);
//	XMPMethod void			First(XMPSLong* key, XMPPtr* value);
	XMPVMethod void			Next(XMPISOStr* key, XMPPtr* value, XMPULong* valueLength);
//	XMPMethod void			Next(XMPOSType* key, XMPPtr* value);
//	XMPMethod void			Next(XMPSLong* key, XMPPtr* value);
	XMPVMethod XMPBoolean	IsNotComplete();

  private:
	XMPNVMethod void			FirstNextAux(XMPISOStr* key);
	XMPNVMethod void			FirstNextAux(XMPOSType* key);
	XMPNVMethod void			FirstNextAux(XMPSLong* key);
	void					FirstAux(XMPULong* key, XMPPtr* value);
	void					NextAux(XMPULong* key, XMPPtr* value);

	XMPNameSpace*				fNameSpace;
	XMPNSTypeSpec				fType;
	XMPStringHashTableIterator*	fStrHashIterator;
	XMPAEHashTableIterator*		fAEHashTableIterator;
};

#endif // _NMSPCITM_