/*
	File:		SUCursor.h

	Contains:	Definition of XMPStorageUnitCursor.

	Written by:	Vincent Lo, Tantek Celik

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<10>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <9>	  2/9/94	T		made destructor explicitly virtual to
									pacify ASLM
		 <8>	  2/4/94	VL		Moved to PPC Header and began code cleanup.
		 <7>	 1/12/94	VL		Init changes.
		 <6>	 8/13/93	CG		Added ASLM compatibility.
		 <5>	 7/23/93	VL		Moved parameters from constructor to
									Initialize().
		 <4>	 4/29/93	VL		8.3 Name Change.
		 <3>	  4/8/93	VL		Moved parameters from Initialize to
									constructor.
		 <2>	  4/7/93	VL		Added Initialize.
		 <1>	  4/6/93	VL		first checked in

	To Do:
*/

#ifndef _SUCURSOR_
#define _SUCURSOR_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

#ifndef _STORAGEU_
#include "StorageU.h"
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================
class XMPStorageUnitCursor;

//==============================================================================
// XMPStorageUnitCursor
//==============================================================================

#define kXMPStorageUnitCursorID "appl:xmpstorageunitcursor$class,1.0.0"

class XMPStorageUnitCursor
{
	ASLM_COMPATIBLE

public:

	XMPStorageUnitCursor();
	
	virtual	~ CDECL XMPStorageUnitCursor();
	
	XMPMethod	void InitStorageUnitCursor(XMPPropertyName propertyName,
								XMPValueType valueType,
								XMPValueIndex valueIndex);
	
	XMPMethod	void GetCursor(XMPPropertyName* propertyName,
								XMPValueType* valueType,
								XMPValueIndex* valueIndex);
									
private:

	XMPPropertyName		fCurProperty;
	XMPValueType		fCurValueType;
	XMPValueIndex		fCurValue;
};

#endif	// _SUCURSOR_