/*
	File:		StdDefs.h

	Contains:	Standard constants to be used inside code or resources

	Written by:	Caia Grisar

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<11>	 4/16/94	T		#1157828 Move kXMPKindPartsBin to a public
									header
		<10>	 3/17/94	CG		#1151392: Moved kOpenDocShellSignature from
									ContsDef.h.
		 <9>	 3/11/94	CG		Bug #1150241 - changed kXMPsmSystemScript
									to kXMPsmRoman and kXMPsmScriptLang to
									kXMPlangEnglish.
		 <8>	 1/21/94	CG		Added kXMPIsAnISOStringID.
		 <7>	 1/20/94	SS		Added kXMPPaletteWDEFID
		 <6>	 1/20/94	SS		Added icon sizes for frame views
		 <5>	 1/18/94	CG		Added kXMPKindOldMacOSType ns name and
									other defines for NMAPs.
		 <4>	 1/14/94	MB		Add some new categories
		 <3>	 1/12/94	CG		Added new NameSpace names.
		 <2>	12/10/93	CG		Renamed kXMPEditor to kXMPEditorKinds
									because the former was already being used.
		 <1>	11/18/93	CG		first checked in

	To Do:
*/

#ifndef _STDDEFS_
#define _STDDEFS_

// Shell

#define 	kOpenDocShellSignature 'jedi'

// NameSpaces

#define		kXMPContainerSuite			"ContainerSuite"
#define		kXMPKind					"KindCategories"
#define		kXMPEditorKinds				"EditorKinds"
#define		kXMPViewer					"Viewers"
#define		kXMPKindOldMacOSType		"KindOldMacOSType"

#define		kXMPSysPrefEditorKinds		"SysPrefEditorKinds"
#define		kXMPSysPrefEditorCategories	"SysPrefEditorCategories"

#define		kXMPEditorUserString		"EditorUserString"
#define		kXMPKindUserString			"KindUserString"
#define		kXMPCategoryUserString		"CategoryUserString"

#define		kNameMappings			'NMAP'
#define		kNMAPid 				127

// Kind

#define kXMPKindPartsBin "OpenDoc:Kind:PartsBin"

// Categories

#define kXMPCategoryText		"OpenDoc:Category:Text"
#define kXMPCategoryGraphics	"OpenDoc:Category:Graphics"
#define kXMPCategoryTime		"OpenDoc:Category:Time"
#define kXMPCategoryControl		"OpenDoc:Category:Control"
#define kXMPCategoryVideo		"OpenDoc:Category:Video"
#define kXMPCategorySound		"OpenDoc:Category:Sound"
#define kXMPCategoryPartsBin	"OpenDoc:Category:PartsBin"

// Resource types

#define kXMPIsMacOSTypeID				1			/* Mac OSType */
#define	kXMPIsINTLTextID				2			/* International text */
#define	kXMPIsAnISOStringID				3			/* ISOString */
#define	kXMPIsAnISOStringListID			4			/* ISOString List*/

#define kXMPPaletteWDEFID				128			/* Windoid WDEF */

// Script System constants (copied out of enums in Script.h)

#define	kXMPRomanScript 				0    		// ASCII alphabet
#define	kXMPEnglishLang					0			// English Language

// View Type Sizes

#define		kXMPTinyIconSize		12	// 12x12 pixels
#define 	kXMPSmallIconSize		16	// 16x16 pixels
#define		kXMPLargeIconSize		32	// 32x32 pixels
#define		kXMPThumbnailSize		64	// 64x64 pixels

#endif // _STDDEFS_