/*
	File:		TypLsItr.h

	Contains:	Class definition for XMPTypeListIterator.

	Written by:	Vincent Lo

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	  4/4/94	CC		first checked in

		------------------- CC ---- Renamed from TypStItr.h

		 <5>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <4>	 2/17/94	CC		#1144818 - Added declaration of class
									XMPTypeSet to enable standalone
									compilation.
		 <3>	 2/15/94	CG		#1143680 - changed fIterator to a
									OrderedCollectionIterator.
		 <2>	  2/9/94	T		made destructor explicitly virtual to
									pacify ASLM
		 <1>	  2/4/94	VL		first checked in

	To Do:

*/

#ifndef _TYPLSITR_
#define _TYPLSITR_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//=====================================================================================
// Classes defined in this interface
//=====================================================================================
class XMPTypeListIterator;

//=====================================================================================
// Classes used by this interface
//=====================================================================================
class XMPTypeList;
class OrderedCollectionIterator;

//=====================================================================================
// Class XMPTypeListIterator
//=====================================================================================

#define kXMPTypeListIteratorID "appl:xmptypelistiterator$class,1.0.0"

class XMPTypeListIterator
{
	ASLM_COMPATIBLE

public:

		XMPTypeListIterator(XMPTypeList* typeList);
		
		virtual ~ CDECL XMPTypeListIterator();

		XMPMethod	XMPType		First();
		XMPMethod	XMPType		Next();
		XMPVMethod	XMPBoolean	IsNotComplete();
		
private:

	  	XMPTypeList*				fTypeList;
		OrderedCollectionIterator*	fIterator;
};

#endif	// _TYPLSITR_