#
#	File:		ODCommon.mak
#
#	Contains:	common definitions for build rules, directories and options
#
#	Written by:	The Crew
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		<11>	 4/14/94	NP		Removed -i CIncludes from SCOptions
#		<10>	 4/13/94	NP		Fixed so that Symantec doesn't use
#									CIncludes anymore.
#		 <9>	 3/22/94	NP		Added some defaults. Changed RezOptions.
#		 <8>	 3/17/94	MB		Turned off warning 18 for the SCpp build,
#									#1150864.
#		 <7>	 3/16/94	NP		Added defaults for variables, fixed SC and
#									SCpp options to allow using the CIncludes
#									folder. 1151261 and 1121252.
#		 <6>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
#									#1150864.
#		 <5>	 3/14/94	NP		Fixed C and C++ includes variables.
#		 <4>	 3/11/94	JBS		1150211 split Layout from Imaging
#		<30>	 2/17/94	HLX		Removed ODFrameworkDir and ODHenriDir
#		 <2>	 2/10/94	T		.cp -> .cp
#		<28>	 1/31/94	JA		Added ODPolygonsDir.
#		<27>	 1/29/94	NP		Added ODCoreDir to Rez search path.
#		<26>	 1/19/94	T		added ODEditorSetupDir
#		<25>	 1/18/94	CG		Added ODBentoDir to
#									MakeDependIncludeDirs.
#		<24>	12/20/93	SS		Added PartsBin directory
#		<23>	12/10/93	NP		Modified a few variables so that ToolServer
#									builds are easier.
#		<22>	 12/7/93	NP		Fixed for new build system stuff.
#		<20>	11/23/93	NP		Removed -SCpp from BuildSharedLibrary
#									command line.
#		<19>	11/23/93	NP		Added -SCpp to BuildSharedLibraryOptions.
#		<18>	11/18/93	CG		Added {ODRezIntfDir} to GRezOptions
#		<17>	11/15/93	NP		Added load/dump file to CFront options.
#		<16>	11/8/93		HLX		Added HenriPart folder.
#		<15>	11/5/93		HLX		Added framework folder.
#		<14>	10/28/93	NP		Added core directory to include file list.
#		<13>	 10/8/93	T		comment out references to prototype
#									directories
#		<12>	 10/6/93	T		add Quality project
#		<11>	 10/6/93	T		move parts to TestParts, add
#									ODTestPartsDir
#		<10>	 9/23/93	JBS		add ODImagingDir on includes path
#		 <9>	 9/22/93	NP		Added variables for new MakeDepend scheme.
#		 <8>	  9/8/93	VL		Added ODCMDir.
#		 <7>	  9/8/93	NP		Added SCppOptions.
#		 <6>	  9/8/93	NP		Added XMPDebug flag.
#		 <5>	 8/18/93	T		JBS added ODImagingDir
#		 <5>	 8/18/93   JBS		added ODImagingDir
#		 <4>	 8/11/93	NP		Added -mf to LibOptions.
#		 <3>	 8/11/93	RR		Added -i option for UI folder
#		 <2>	  8/4/93	NP		Tweaked to make even more general.
#		 <1>	  8/2/93	NP		first checked in
#
#	To Do:
#
#	remove ODPartsBinDir from CPlusIncludes and CIncludes!
#

# DIRECTORY VARIABLES

ODPrototypeDir = {ODProjectDir}Prototype:
ODODDir = {ODProjectDir}OD:
ODTestPartsDir = {ODProjectDir}TestParts:
ODQualityDir = {ODProjectDir}Quality:

ODBinaryDir =
ODObjects = {ODBinaryDir}Objects:
ODLoadObjects = 

#ODSources = {ODPrototypeDir}Sources:
#ODInterfaces = {ODPrototypeDir}Interfaces:
#ODPrivateInterfaces = {ODPrototypeDir}PrivateInterfaces:
#ODBogusSources = {ODPrototypeDir}BogusSources:

ODIntfDir = {ODODDir}Interfaces:
ODCPlusIntfDir = {ODIntfDir}CPlusPlus:
ODRezIntfDir = {ODIntfDir}Rez:
ODImplDir = {ODODDir}Implementation:
ODCoreDir = {ODImplDir}Core:
ODImagingDir = {ODImplDir}Imaging:
ODPolygonsDir = {ODImagingDir}Polygons:
ODLayoutDir = {ODImplDir}Layout:
ODShellDir = {ODImplDir}DocShell:
ODUIDir = {ODImplDir}UI:
ODStorageDir = {ODImplDir}Storage:
ODBentoDir = {ODStorageDir}Bento:
ODCMDir = {ODStorageDir}CM:
ODMessagingDir = {ODImplDir}Messaging:
ODUtilitiesDir = {ODImplDir}Utilities:
ODOSLDir = {ODMessagingDir}OSL:
ODPartsBinDir = {ODImplDir}PartsBin:
ODEditorSetupDir = {ODImplDir}EditorSetup:

# DEFAULT DEFS

ASLMLibraries = 
CompilerLibraries = 
StdCLibraries = 
StdCPlusLibraries = 

# SHARED TOOL OPTIONS

SymOption = 

CFrontOptions = {UserODCFrontOptions} -mf -opt off -d CDECL=

SCppOptions = {UserODSCppOptions} -d CDECL=_cdecl -w18

SCOptions = {UserODSCOptions}


# This is set of include path is used for C++ compilers only. Don't add a path
# here that only C files need.

CPlusIncludeDirs = 
				-i "{ODCPlusIntfDir}"				
				-i "{ODImagingDir}"				
				-i "{ODPolygonsDir}"				
				-i "{ODLayoutDir}"				
				-i "{ODStorageDir}"				
				-i "{ODUIDir}"					
				-i "{ODUtilitiesDir}"				
				-i "{ODMessagingDir}"				
				-i "{ODOSLDir}"					
				-i "{ODCMDir}"					
				-i "{ODCoreDir}"					
				-i "{ODShellDir}"					
				-i "{ODTestPartsDir}"				
				-i "{ODQualityDir}"				
				-i "{ODPartsBinDir}"				
				-i "{ODBentoDir}"					
				
# This is set of include path is used for C compilers only. Don't add any
# paths here that only C++ source files need.
# The Apple C compiler is limited to 16 search paths.

CIncludeDirs = 
				-i "{ODStorageDir}"				
				-i "{ODOSLDir}"					
				-i "{ODCMDir}"					

MakeDependIncludeDirs = {CPlusIncludeDirs}			
						-i "{ODBentoDir}"

MakeDependMacros = 
		"ODCPlusIntfDir={ODCPlusIntfDir}"				
		"ODCoreDir={ODCoreDir}"							
		"ODMessagingDir={ODMessagingDir}"				
		"ODImagingDir={ODImagingDir}"					
		"ODPolygonsDir={ODPolygonsDir}"					
		"ODLayoutDir={ODLayoutDir}"						
		"ODUtilitiesDir={ODUtilitiesDir}"				
		"ODUIDir={ODUIDir}"								
		"ODCMDir={ODCMDir}"								
		"ODStorageDir={ODStorageDir}"					
		"ODOSLDir={ODOSLDir}"							
		"ODBentoDir={ODBentoDir}"						
		"ODShellDir={ODShellDir}"						
		"ODObjects={ODObjects}"							
		"ODCMDir={ODCMDir}"								
		"ODShellDir={ODShellDir}"						
		"ODTestPartsDir={ODTestPartsDir}"				
		"ODQualityDir={ODQualityDir}"					
		"ODProtoObjects={ODProtoObjects}"				
		"ODODDir={ODODDir}"							
		"ODLoadObjects={ODLoadObjects}"					
		"ODPartsBinDir={ODPartsBinDir}"					
		"ODEditorSetupDir={ODEditorSetupDir}"			


# SPECIFIC TOOL OPTIONS

AOptions =  {UserODAOptions} -w {SymOption}

# XMPDebug should always be defined as either 1 or 0

GCPlusOptions =									
				{UserODCPlusOptions}			
				{SCppOptions}					
				{CFrontOptions}					
				{SymOption}						
				{ASLMDefines}					
				-mbg full						
				-model far						
				-d XMPDebug=1					
				{CPlusIncludeDirs}

CPlusLoadOptions = -load "{ODLoadObjects}"CFrontDump.dump

GCOptions = {UserODCOptions}					
				{SymOption}						
 				{SCOptions}						
				{ASLMDefines}					
				-mbg full						
				-model far						
				-r								
				-d XMPDebug=1					
				{CIncludeDirs}

GRezOptions = {UserODRezOptions}				
				-i "{ODRezIntfDir}"			
				-i "{ODCPlusIntfDir}"			
				-d XMPDebug=1					
				{ASLMDefines}

LibOptions = {UserODLibOptions} {ODLibWarningOption} {SymOption} -mf

LinkOptions = {UserODLinkOptions} -model far -d -mf	
				-t APPL -c jedi {SymOption}

BuildSharedLibraryOptions = {UserODBuildSharedLibraryOptions} 
							{ASLMSCppSwitch} {CPlusIncludeDirs} {SymOption} #-keepClientFiles

LinkSharedLibraryOptions = {UserODLinkSharedLibraryOptions} 
							-link -mf {SymOption} -sn SCPP=Main

# DEFAULT RULES

.cpp.o		.cpp
	Echo Compiling: {default}.cpp
	{CPlus} {depDir}{default}.cpp -o {targDir}{default}.cpp.o {CPlusOptions} {CPlusLoadOptions}

.a.o		.a
	Echo Assembling: {default}.a
	{Asm} {depDir}{default}.a -o {targDir}{default}.a.o {AOptions}

.c.o		.c
	Echo Compiling: {default}.c
	{C} {depDir}{default}.c -o {targDir}{default}.c.o {COptions}

