#
#	File:		ODSubsys.mak
#
#	Contains:	Common Makefile definitions for OpenDoc subsystems.
#
#	Written by:	Nick Pilch
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <2>	  9/9/93	VL		Added Bento-specific options.
#		 <1>	  8/4/93	NP		first checked in
#
#	To Do:
#

# SPECIAL TOOL OPTIONS

CMVersion	= '"*** 1.0d4.2 ***"'		# quote as shown (don't ask)
MC68020		=		# set to -MC68020 for '20 generation
Dbg			= 1		# ==> generate Mac MacsBug definitions
DumpTOC		= 1		# ==> generate routines to display DOC data structures
CMDebugging	= 1		# ==> generate CMDebugging() routine
Mac			= 1		# ==> Mac specific code
Validate	= 1		# ==> generate validation code
TOC1		= 1		# ==> allow TOC format 1 input code

CPlusOptions = {GCPlusOptions}
COptions = {GCOptions}							
			-b									
			{MC68020}							
			-d CMVersion={CMVersion} 			
			-d CM_MPW={Mac} 					
			-d __DEBUG__={Dbg} 					
			-d CMDUMPTOC={DumpTOC} 				
			-d CMDEBUGGING={CMDebugging}		
			-d CMVALIDATE={Validate}			
			-d CMDEFAULT_VALIDATE={Validate}	
			-d CM_80x86=0						
			-d CM_MICROSOFT=0					
			-d CM_BORLAND=0						
			-d TOC1_SUPPORT={TOC1}
RezOptions = {GRezOptions}
