//	File:		FWContrH.h
//	Contains:	Definition for class FW_CControlMgrHelper
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

#ifndef _FWCONTRH_
#define _FWCONTRH_

// ----- Macintosh Includes -----

#ifndef __CONTROLS__
#include <Controls.h>
#endif


//========================================================================================
// CLASS FW_CControlMgrHelper
//========================================================================================

#define kFW_CControlMgrHelperID "appl:FW_CControlMgrHelper$class,1.0.0"

class FW_CControlMgrHelper
{
// ----- Initialization/destruction
public:
							FW_CControlMgrHelper();
	virtual					~FW_CControlMgrHelper();

	void					InitControlMgrHelper(const Rect& ctrlRect, Str255 title,
												 short initValue, short minValue, short maxValue,
												 short ctrlType);

public:
	ControlHandle			GetControlHandle() const;
									
	virtual void			SetBounds(const Rect& controlBounds);
	void					GetBounds(Rect& controlBounds) const;
		
	virtual void			SetValue(short value);
	short					GetValue() const;
	virtual void			SetMin(short min);
	short					GetMin() const;
	virtual void			SetMax(short max);
	short					GetMax() const;

	virtual void			Draw(WindowPtr window);
	virtual Boolean			MouseDown(WindowPtr window, const Point& where);

protected:
	virtual ControlHandle	CreateControlHandle(WindowPtr window, const Rect& ctrlRect, Str255 title,
												short initValue, short minValue, short maxValue,
												short ctrlType);	
	virtual void			SetupControl(WindowPtr window);
	virtual void			RestoreControl();

private:
	static WindowPtr		gScratchWindow;

	ControlHandle			fControlHandle;
};

//----------------------------------------------------------------------------------------
// FW_CControlMgrHelper::GetControlHandle
//----------------------------------------------------------------------------------------

ControlHandle FW_CControlMgrHelper::GetControlHandle() const
{
	return fControlHandle;
}

//----------------------------------------------------------------------------------------
// FW_CControlMgrHelper::GetBounds
//----------------------------------------------------------------------------------------

void FW_CControlMgrHelper::GetBounds(Rect& controlBounds) const
{
	controlBounds = (*fControlHandle)->contrlRect;
}

//----------------------------------------------------------------------------------------
// FW_CControlMgrHelper::GetValue
//----------------------------------------------------------------------------------------

short FW_CControlMgrHelper::GetValue() const
{
	return ::GetCtlValue(fControlHandle);
}

//----------------------------------------------------------------------------------------
// FW_CControlMgrHelper::GetMin
//----------------------------------------------------------------------------------------

short FW_CControlMgrHelper::GetMin() const
{
	return ::GetCtlMin(fControlHandle);
}

//----------------------------------------------------------------------------------------
// FW_CControlMgrHelper::GetMax
//----------------------------------------------------------------------------------------

short FW_CControlMgrHelper::GetMax() const
{
	return ::GetCtlMax(fControlHandle);
}

#endif
