/*
	File:		FWDropTr.cpp

	Contains:	Implementation for class FW_CDropTracker

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

// ----- Framework Includes

#ifndef _FWFACET_
#include "FWFacet.h"
#endif

#ifndef _FWDROPTR_
#include "FWDropTr.h"
#endif

#ifndef _FWUTIL_
#include "FWUtil.h"
#endif

// ----- OpenDoc Includes

#ifndef _EXCEPT_
#include <Except.h>
#endif

#ifndef _TRNSFORM_
#include <TrnsForm.h>
#endif


#pragma segment FWFacetSeg

//========================================================================================
// CLASS FW_CDropTracker
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CDropTracker::FW_CDropTracker
//----------------------------------------------------------------------------------------

FW_CDropTracker::FW_CDropTracker() :
	fFacet(kXMPNULL)
{
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::~FW_CDropTracker
//----------------------------------------------------------------------------------------

FW_CDropTracker::~FW_CDropTracker()
{
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::InitDropTracker
//----------------------------------------------------------------------------------------

void FW_CDropTracker::InitDropTracker(CFacet* facet)
{
	ASSERT(facet != kXMPNULL, 0);
	fFacet = facet;
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::HandleBeginTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::HandleBeginTracking(XMPPoint where)
{
	CDrawInitiator di(fFacet);
	where = fFacet->GetWindowContentTransform()->InvertPoint(where);
	this->BeginTracking(where);
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::HandleContinueTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::HandleContinueTracking(XMPPoint where)
{
	CDrawInitiator di(fFacet);
	where = fFacet->GetWindowContentTransform()->InvertPoint(where);
	this->ContinueTracking(where);
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::HandleEndTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::HandleEndTracking(XMPPoint where)
{
	CDrawInitiator di(fFacet);
	where = fFacet->GetWindowContentTransform()->InvertPoint(where);
	this->EndTracking(where);
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::BeginTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::BeginTracking(XMPPoint where)
{
	this->ContinueTracking(where);
}

//----------------------------------------------------------------------------------------
// FW_CDropTracker::EndTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::EndTracking(XMPPoint where)
{
	this->ContinueTracking(where);
}

