/*
	File:		FWDropTr.h

	Contains:	Definition for class FW_CDropTracker

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _FWDROPTR_
#define _FWDROPTR_

#ifndef _ALTPOINT_			// Just to be sure to be included before PlfmType.h
#include "AltPoint.h"
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class CFacet;


//========================================================================================
// CLASS FW_CDropTracker
//========================================================================================

class FW_CDropTracker
{
// ----- Initialization/destruction
public:
	FW_CDropTracker();
	virtual ~FW_CDropTracker();
	void InitDropTracker(CFacet* facet);
	
// ----- Dispatch tracking
	void HandleBeginTracking(XMPPoint where);
	void HandleContinueTracking(XMPPoint where);
	void HandleEndTracking(XMPPoint where);
	
// ----- Tracking
	virtual void BeginTracking(XMPPoint where);
	virtual void ContinueTracking(XMPPoint where) = 0;
	virtual void EndTracking(XMPPoint where);

// ----- Fields
protected:
	CFacet*	fFacet;
};

#endif

