//	File:		FWEventH.cpp
//	Contains:	Implementation for class MEventHandler
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

#ifndef _FWEVENTH_
#include "FWEventH.h"
#endif

#pragma segment FWEventSeg

//==============================================================================
// MEventHandler
//==============================================================================

//----------------------------------------------------------------------------------------
// MEventHandler::MEventHandler
//----------------------------------------------------------------------------------------

MEventHandler::MEventHandler()
{
	fIdentifier = kNoIdentifier;
	fNextEventHandler = kXMPNULL;
	fActive = kXMPFalse;
}

//----------------------------------------------------------------------------------------
// MEventHandler::~MEventHandler
//----------------------------------------------------------------------------------------

MEventHandler::~MEventHandler()
{
}

//----------------------------------------------------------------------------------------
// MEventHandler::SetIdentifier
//----------------------------------------------------------------------------------------

void MEventHandler::SetIdentifier(XMPID indentifier)
{
	fIdentifier = indentifier;
}

//----------------------------------------------------------------------------------------
// MEventHandler::Activate
//----------------------------------------------------------------------------------------

XMPBoolean MEventHandler::Activate()
{
	fActive = kXMPTrue;
	return kXMPTrue;
}

//----------------------------------------------------------------------------------------
// MEventHandler::Deactivate
//----------------------------------------------------------------------------------------

void MEventHandler::Deactivate()
{
	fActive = kXMPFalse;
}

//----------------------------------------------------------------------------------------
// MEventHandler::IsActive()
//----------------------------------------------------------------------------------------

XMPBoolean MEventHandler::IsActive() const
{
	return fActive;
}

