/*
	File:		FWEventH.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	 3/17/94	DS		Add CDECL to mEventHandler dtor

	To Do:
*/


#ifndef _FWEVENTH_
#define _FWEVENTH_

#ifndef _ALTPOINT_			// Just to be sure to be included before PlfmType.h
#include "AltPoint.h"
#endif

//==============================================================================
// Constant
//==============================================================================

const XMPID kNoIdentifier = 0xFFFFFFFF;

//==============================================================================
// MEventHandler
//==============================================================================

#define kMEventHandlerID "appl:meventhandler$class,1.0.0"

class MEventHandler
{
public:
	virtual ~ CDECL MEventHandler();

	XMPID			GetIdentifier() const;
	virtual void	SetIdentifier(XMPID identifier);
	
	MEventHandler*	GetNextEventHandler() const;
	void			SetNextEventHandler(MEventHandler* nextEventHandler);
	
	virtual XMPBoolean	IsActive() const;
	virtual XMPBoolean	Activate();
	virtual void		Deactivate();
	
protected:
	MEventHandler();

private:
	XMPID			fIdentifier;
	MEventHandler	*fNextEventHandler;
	XMPBoolean		fActive;
};

//========================================================================================
// Inlines
//========================================================================================

//----------------------------------------------------------------------------------------
// MEventHandler::GetIdentifier()
//----------------------------------------------------------------------------------------
inline XMPID MEventHandler::GetIdentifier() const
{
	return fIdentifier;
}

//----------------------------------------------------------------------------------------
// MEventHandler::GetNextEventHandler()
//----------------------------------------------------------------------------------------
inline MEventHandler* MEventHandler::GetNextEventHandler() const
{
	return fNextEventHandler;
}

//----------------------------------------------------------------------------------------
// MEventHandler::SetNextEventHandler()
//----------------------------------------------------------------------------------------
inline void MEventHandler::SetNextEventHandler(MEventHandler* nextEventHandler)
{
	fNextEventHandler = nextEventHandler;
}

#endif
