/*
	File:		FWViewFa.cpp

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/10/94	DS		Made CreateviewHierarchy non pure virtual.
									Also, bracketed references to fRootView
									with checks for null so we won't crash in
									the absence of a view hierarchy.
		 <2>	 3/10/94	DS		Make CreateViewHierarchy not Pure-Virtual

	To Do:
*/

//	File:		FWViewFa.cp
//	Contains:	Implementation for class FW_CViewFacet
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

// ----- Framework Includes

#ifndef _FWVIEWFA_
#include "FWViewFa.h"
#endif

#ifndef _FWVIEW_
#include "FWView.h"
#endif

#ifndef _FWUTIL_
#include "FWUtil.h"
#endif


//========================================================================================
// CLASS FW_CViewFacet
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CViewFacet::FW_CViewFacet
//----------------------------------------------------------------------------------------

FW_CViewFacet::FW_CViewFacet() :
	fRootView(kXMPNULL)
{
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::~FW_CViewFacet
//----------------------------------------------------------------------------------------

FW_CViewFacet::~FW_CViewFacet()
{
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::InitViewFacet
//----------------------------------------------------------------------------------------

void FW_CViewFacet::InitViewFacet(XMPFacet* xmpFacet)
{
	CFacet::InitFacet(xmpFacet);
	SetRootView(CreateViewHierarchy());
}

//----------------------------------------------------------------------------------------
// FW_CView::InitView
//----------------------------------------------------------------------------------------
FW_CView* FW_CViewFacet::CreateViewHierarchy()
{
	// You must implement this method
	// Here you would create you view hierarchy
	// By instantiating views and returning the root
	
	WASSERTM(false, "This method must be implemented.");
	
	return ((FW_CView*)NULL);
}


//----------------------------------------------------------------------------------------
// FW_CViewFacet::Draw
//----------------------------------------------------------------------------------------

void FW_CViewFacet::Draw(XMPShape* invalidShape)
{
	if (fRootView != kXMPNULL)
		fRootView->HandleDraw(invalidShape);
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::DoMouseDown
//----------------------------------------------------------------------------------------

XMPBoolean FW_CViewFacet::DoMouseDown(const XMPPoint& where, XMPEventData event)
{
	if (fRootView != kXMPNULL)
	{
		CDrawInitiator di(this);
		return fRootView->HandleMouseDown(where, event);
	}
	else
		return false;
}
	
//----------------------------------------------------------------------------------------
// FW_CViewFacet::DoMouseUp
//----------------------------------------------------------------------------------------

XMPBoolean FW_CViewFacet::DoMouseUp(const XMPPoint& where, XMPEventData event)
{
	if (fRootView != kXMPNULL)
	{
		CDrawInitiator di(this);
		return fRootView->HandleMouseUp(where, event);
	}
	else
		return false;
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::SetRootView
//----------------------------------------------------------------------------------------

void FW_CViewFacet::SetRootView(FW_CView* view)
{
	fRootView = view;
}
