/*
	File:		FWViewFa.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 3/10/94	DS		Make CreateViewHierarchy not Pure-Virtual

	To Do:
*/

//	File:		FWViewFa.h
//	Contains:	Definition for class FW_CViewFacet
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

#ifndef _FWVIEWFA_
#define _FWVIEWFA_

// ----- Framework Includes

#ifndef _FWFACET_
#include "FWFacet.h"
#endif


//========================================================================================
// Forward class declarations
//========================================================================================

class FW_CView;
class XMPFacet;
class XMPShape;


//========================================================================================
// CLASS FW_CViewFacet
//========================================================================================

class FW_CViewFacet : public CFacet
{
// ----- Initialization/destruction
public:
							FW_CViewFacet();
	virtual					~FW_CViewFacet();
	
	void					InitViewFacet(XMPFacet* xmpFacet);
	
	virtual void			Draw(XMPShape* invalidShape);

	virtual XMPBoolean 		DoMouseDown(const XMPPoint& where,
										XMPEventData event);
	
	virtual XMPBoolean 		DoMouseUp(const XMPPoint& where,
									  XMPEventData event);

// ----- New API
public:
	FW_CView*				GetRootView() const;
	virtual void			SetRootView(FW_CView* view);
	
	virtual FW_CView*		CreateViewHierarchy();

// ----- Fields
private:
	FW_CView*				fRootView;
};

//----------------------------------------------------------------------------------------
// FW_CViewFacet::GetRootView
//----------------------------------------------------------------------------------------

FW_CView* FW_CViewFacet::GetRootView() const
{
	return fRootView;
}

#endif

