#
#	File:		Framework.make
#
#	Contains:	xxx put contents here xxx
#
#	Written by:	xxx put writers here xxx
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <8>	 3/23/94	DS		Correct -a
#		 <7>	 3/23/94	DS		Add -a to rez step
#		<5+>	 3/17/94	DS		Correct make for SC Builds
#		 <5>	 3/14/94	DS		Add Layout object to make
#		<3+>	  3/9/94	DS		Include the new view files that Mike added
#		 <3>	  3/2/94	DS		Make should include XMPConst.cpp.o
#		 <2>	  3/1/94	DS		Made the make point to the framework source
#									in the quality directory.
#
#	To Do:
#

#
#	File:		Framework.make
#
#	Contains:	Makefile for OpenDoc Framework
#
#	Written by:	Michael Burbidge
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#

UserODCPlusOptions = 
				-i "{ODProjectDir}"Quality:QFramework:

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODProjectDir}"Quality:QFramework:
				
#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

FrameworkOBJECTS = 
			"{ODObjects}FWCtlMgr.cpp.o" 
			"{ODObjects}FWScroll.cpp.o" 
			"{ODObjects}FWWindow.cpp.o" 
			"{ODObjects}FWBorder.cpp.o" 
			"{ODObjects}FWFacet.cpp.o" 
			"{ODObjects}FWFrming.cpp.o" 
			"{ODObjects}FWEventH.cpp.o" 
			"{ODObjects}FWPart.cpp.o" 
			"{ODObjects}FWParting.cpp.o" 
			"{ODObjects}FWFrame.cpp.o" 
			"{ODObjects}FWProxy.cpp.o" 
			"{ODObjects}FWUtil.cpp.o" 
			"{ODObjects}FWSelect.cpp.o" 
			"{ODObjects}"FWContrH.cpp.o 
			"{ODObjects}"FWSclBar.cpp.o 
			"{ODObjects}"FWView.cpp.o 
			"{ODObjects}"FWViewFa.cpp.o 
			"{ODObjects}FWBaseFr.cpp.o" 
			"{ODObjects}FWDropTr.cpp.o"

FrameworkSOURCEFILES = 
			"{ODProjectDir}"Quality:QFramework:FWCtlMgr.cpp 
			"{ODProjectDir}"Quality:QFramework:FWScroll.cpp 
			"{ODProjectDir}"Quality:QFramework:FWWindow.cpp 
			"{ODProjectDir}"Quality:QFramework:FWBorder.cpp 
			"{ODProjectDir}"Quality:QFramework:FWFacet.cpp 
			"{ODProjectDir}"Quality:QFramework:FWEventH.cpp	
			"{ODProjectDir}"Quality:QFramework:FWFrame.cpp	
			"{ODProjectDir}"Quality:QFramework:FWProxy.cpp	
			"{ODProjectDir}"Quality:QFramework:FWPart.cpp	
			"{ODProjectDir}"Quality:QFramework:FWParting.cpp 
			"{ODProjectDir}"Quality:QFramework:FWFrming.cpp	
			"{ODProjectDir}"Quality:QFramework:FWUtil.cpp	
			"{ODProjectDir}"Quality:QFramework:FWSelect.cpp	
			"{ODProjectDir}"Quality:QFramework:FWBaseFr.cpp 
			"{ODProjectDir}"Quality:QFramework:FWContrH.cpp 
			"{ODProjectDir}"Quality:QFramework:FWSclBar.cpp 
			"{ODProjectDir}"Quality:QFramework:FWView.cpp 
			"{ODProjectDir}"Quality:QFramework:FWViewFa.cpp 
			"{ODProjectDir}"Quality:QFramework:FWDropTr.cpp
			
FrameworkLibASLMObjects = 
			"{ODObjects}XMPConst.cpp.o" 
			"{ODObjects}OperatorNewLib.o" 
			"{ODObjects}FrameworkLibASLM.cl.o" 
			"{ODObjects}UtilitiesLibASLM.cl.o" 
			"{ODObjects}CoreLibASLM.cl.o" 
			"{ODObjects}StorageLibASLM.cl.o" 
			"{ODObjects}ImagingLibASLM.cl.o" 
			"{ODObjects}LayoutLibASLM.cl.o" 
			"{ODObjects}MessagingLibASLM.cl.o" 
			"{ODObjects}UILibASLM.cl.o" 
			{CompilerLibraries} 
			{ASLMLibraries} 
			"{CLibraries}CPlusLib.o" 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"

# REZ STEP

"{ODObjects}"FrameworkLib.o  "{ODProjectDir}"Quality:QFramework:FWResour.r 
								"{ODRezIntfDir}StdTypes.r" 
								"{ODCPlusIntfDir}StdDefs.h"
	Echo Rezzing: {NewerDeps}
	Rez {GRezOptions} {NewerDeps} -i "{ODCPlusIntfDir}" -a -o {Targ}

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODObjects}"FrameworkLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODObjects}"FrameworkLib.o
	Echo -n "" > "{MPW}"ODAppName

#BuildCFASLM  "{ODObjects}"FrameworkLib.o
#	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODBinaryDir}FrameworkLibASLM"
	Echo -n "" > "{MPW}"ODAppName

BuildSCASLM  "{ODBinaryDir}FrameworkLibASLM"
	Echo -n "" > "{MPW}"ODAppName

clean 
	delete -y -i {FrameworkOBJECTS}

"{ODObjects}"FrameworkLib.o  {FrameworkOBJECTS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}

"{ODObjects}FrameworkLibASLM.cl.o"  
		"{ODObjects}FrameworkLib".o 
		"{ODProjectDir}"Quality:QFramework:FrameworkLibASLM.exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{BuildSharedLibraryOptions} 
			-exp "{ODProjectDir}"Quality:QFramework:FrameworkLibASLM.exp 
			-obj "{ODObjects}FrameworkLibASLM" 
			-far "{ODObjects}FrameworkLibASLM.cl.o" 
			"{ODObjects}FrameworkLib.o"

"{ODBinaryDir}FrameworkLibASLM"  {FrameworkLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{ODBinaryDir}FrameworkLibASLM" 
			-obj "{ODObjects}FrameworkLibASLM" 
			-symFile "{ODBinaryDir}FrameworkLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{FrameworkLibASLMObjects}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-append "{MAKEFILE}"								
		-objdir "{ODObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{FrameworkSOURCEFILES}

#*** Dependencies: Cut here ***

# This makefile was produced at 6:06:45 PM on Wed, Nov 24, 1993 by
# MakeDepend

# ----- Framework
"{ODObjects}"FWBaseFr.cpp.o  "{ODProjectDir}"Quality:QFramework:FWBaseFr.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWBorder.cpp.o  "{ODProjectDir}"Quality:QFramework:FWBorder.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWCtlMgr.cpp.o  "{ODProjectDir}"Quality:QFramework:FWCtlMgr.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWCtlMgr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWEventH.cpp.o  "{ODProjectDir}"Quality:QFramework:FWEventH.cpp 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h

"{ODObjects}"FWFacet.cpp.o  "{ODProjectDir}"Quality:QFramework:FWFacet.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h

"{ODObjects}"FWViewFa.cpp.o  "{ODProjectDir}"Quality:QFramework:FWViewFa.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h

"{ODObjects}"FWView.cpp.o  "{ODProjectDir}"Quality:QFramework:FWView.cpp 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWSclBar.cpp.o  "{ODProjectDir}"Quality:QFramework:FWSclBar.cpp 
	"{ODProjectDir}"Quality:QFramework:FWView.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWContrH.cpp.o  "{ODProjectDir}"Quality:QFramework:FWContrH.cpp 
	"{ODProjectDir}"Quality:QFramework:FWView.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWFrame.cpp.o  "{ODProjectDir}"Quality:QFramework:FWFrame.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h

"{ODObjects}"FWFrming.cpp.o  "{ODProjectDir}"Quality:QFramework:FWFrming.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWPart.cpp.o  "{ODProjectDir}"Quality:QFramework:FWPart.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h

"{ODObjects}"FWParting.cpp.o  "{ODProjectDir}"Quality:QFramework:FWParting.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWProxy.cpp.o  "{ODProjectDir}"Quality:QFramework:FWProxy.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWScroll.cpp.o  "{ODProjectDir}"Quality:QFramework:FWScroll.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWScroll.h

"{ODObjects}"FWUtil.cpp.o  "{ODProjectDir}"Quality:QFramework:FWUtil.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h

"{ODObjects}"FWWindow.cpp.o  "{ODProjectDir}"Quality:QFramework:FWWindow.cpp 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h

"{ODObjects}"FWSelect.cpp.o  "{ODProjectDir}"Quality:QFramework:FWSelect.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h

"{ODObjects}"FWDropTr.cpp.o  "{ODProjectDir}"Quality:QFramework:FWDropTr.cpp 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h
