#
#	File:		ButtonPart.make
#
#	Contains:	xxx put contents here xxx
#
#	Written by:	xxx put writers here xxx
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		<11>	 3/23/94	DS		Add -a to rez step
#		<9+>	 3/17/94	DS		Correct make for SC Builds
#		 <9>	 3/14/94	DS		Add Layout object to make
#		 <6>		3/11/94 DO		Fixed paths and added ButtonPartAE.cpp /.h
#		 <5>	  3/2/94	DS		Make should include XMPConst.cpp.o
#		 <4>	  3/1/94	DS		Again
#		 <3>	  3/1/94	DS		Again
#		 <2>	  3/1/94	DS		Made the ButtonPart point to the Framework
#									Source in the Quality Directory
#
#	To Do:
#

#
#	File:		ButtonPart.make
#
#	Contains:	Makefile for OpenDoc ClockPart test part
#
#	Written by:	Henri Lamiraux
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

ButtonPartIncludes = 
				-i "{ODProjectDir}"Quality:QFramework: 
				-i "{ODProjectDir}"Quality:QFramework:ButtonPart:

UserODCPlusOptions = {ButtonPartIncludes}

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODProjectDir}"Quality:QFramework:QButtonPart: 
									"{ODProjectDir}"Quality:QFramework:

# ASLM DEPENDENCIES

"{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPart.r  "{ODProjectDir}"ODASLMOption
	SetFile -m '12/7/41' "{ODProjectDir}"ODASLMOption

#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

ButtonPartOBJECTS = 
			"{ODObjects}ButtonPart.cpp.o" 
			"{ODObjects}ButtonPartAE.cpp.o"

ButtonPartLIBS = 
			"{CLibraries}CSANELib.o" 
			"{CLibraries}Math.o"

ButtonPartSOURCEFILES = 
			"{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPart.cpp 
			"{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPartAE.cpp
			
ButtonPartLibASLMObjects = 
			"{ODObjects}XMPConst.cpp.o" 
			"{ODObjects}OperatorNewLib.o" 
			"{ODObjects}ButtonPartLibASLM.cl.o" 
			"{ODObjects}UtilitiesLibASLM.cl.o" 
			"{ODObjects}CoreLibASLM.cl.o" 
			"{ODObjects}StorageLibASLM.cl.o" 
			"{ODObjects}ImagingLibASLM.cl.o" 
			"{ODObjects}LayoutLibASLM.cl.o" 
			"{ODObjects}MessagingLibASLM.cl.o" 
			"{ODObjects}UILibASLM.cl.o" 
			"{ODObjects}FrameworkLibASLM.cl.o" 
			"{ODObjects}FrameworkLib.o" 
			{CompilerLibraries} 
			{ASLMLibraries} 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"

# REZ STEP

"{ODObjects}"ButtonPartLib.o  "{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPart.r
	Echo Rezzing: {NewerDeps}
	Rez {GRezOptions} {NewerDeps} -i "{ODCPlusIntfDir}" -a -o {Targ}

###########################################################################
# ROOT TARGETS  
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODObjects}"ButtonPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODObjects}"ButtonPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODBinaryDir}ButtonPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

BuildSCASLM  "{ODBinaryDir}ButtonPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

clean 
	delete -y -i {ButtonPartOBJECTS} "{ODObjects}"ButtonPartLib.o

"{ODObjects}"ButtonPartLib.o  {ButtonPartOBJECTS} {ButtonPartLIBS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}

"{ODObjects}ButtonPartLibASLM.cl.o"  
		"{ODObjects}ButtonPartLib".o 
		"{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPartLibASLM.exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{ButtonPartIncludes} 
			{BuildSharedLibraryOptions} 
			-exp "{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPartLibASLM.exp 
			-obj "{ODObjects}ButtonPartLibASLM" 
			-far "{ODObjects}ButtonPartLibASLM.cl.o" 
			"{ODObjects}ButtonPartLib.o"

"{ODBinaryDir}ButtonPartLibASLM"  {ButtonPartLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{ODBinaryDir}ButtonPartLibASLM" 
			-obj "{ODObjects}ButtonPartLibASLM" 
			-symFile "{ODBinaryDir}ButtonPartLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{ButtonPartLibASLMObjects}

"{ODBinaryDir}ButtonPartLibASLM"  {ButtonPartLibASLMObjects}
	Echo Copying Resources From: {ODObjects}ButtonPartLib.o
	Echo "include "{ODObjects}ButtonPartLib.o";" | Rez -a -o {Targ}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-append "{MAKEFILE}"								
		-objdir "{ODObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{ButtonPartSOURCEFILES}

#*** Dependencies: Cut here ***

# ----- CClockPart
"{ODObjects}ButtonPart.cpp.o"	 
	"{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPart.cpp 
	"{ODProjectDir}"Quality:QFramework:FWCtlMgr.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h
	
"{ODObjects}ButtonPartAE.cpp.o"	 
 "{ODProjectDir}"Quality:QFramework:QButtonPart:ButtonPartAE.cpp 
	"{ODProjectDir}"Quality:QFramework:FWCtlMgr.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 