/*
	File:		ButtonPart.r

	Contains:	NMAP resource for ButtonPart

	Written by:	Lonnie Millett

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/14/94	DS		Change Binding constants as per Caia's
									changes.
		<2+>	 1/25/94	MB		Update NMAP resources to the
									Internationalizable format.

	To Do:
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#ifndef __STDTYPES_R__
	#include "StdTypes.r"
#endif __STDTYPES_R__

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

#ifndef _BUTTONDEF_
	#include "ButtonDef.h"
#endif

INCLUDE "ButtonPart.rsrc";

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (FW_kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleButtonKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kXMPCategoryControl
			}
		}
	}
};

resource kNameMappings (FW_kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kCScriptButtonPartID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kSampleButtonKind
			}
		}
	}
};

resource kNameMappings (FW_kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kCScriptButtonPartID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleButtonEditorUserString
		}
	}
};

resource kNameMappings (FW_kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleButtonKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleButtonKindUserString
		}
	}
};

resource kNameMappings (FW_kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kXMPCategoryControl,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleButtonCategoryUserString
		}
	}
};

resource kNameMappings (FW_kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kSampleButtonKind,
		kXMPIsMacOSType {
			kSampleButtonOSType
		}
	}
};
