/*
	File:		ButtonPartAE.h

	Contains:	Buttonpart AE support header

	Written by:	Donald Olson

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	 3/17/94	DS		SC doesn't like enum lists with leading
									commas, it seems..

	To Do:
*/

#ifndef _BUTTONPARTAE_
#define _BUTTONPARTAE_

#ifndef _PLFMDEF_
#include "PlfmDef.h"
#endif

#ifndef _PROPACSR_
#include "PropAcsr.h"
#endif

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif

#ifndef __OSA__
#include <OSA.h>
#endif


//==============================================================================
// Constants
//==============================================================================

enum
{
	typePartProp 		= 'pprp'
};

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif

//==============================================================================
// Theory of Operation
//==============================================================================

/*
	This a simple abstract class to aid in the processing of Apple Events that
	are requests to get or set properties. Since OpenDoc does the resolution
	first, the object accessor routines can allocate one of these classes
	according to the property for which they have been asked to create a token.
	When passed back to the event handler, the event handler need only call the
	the appropriate member function of this class, GetData or SetData, to
	process the event. The event handler must then delete the object.
*/

//==============================================================================
// Constants
//==============================================================================

//==============================================================================
// Scalar Types
//==============================================================================

//==============================================================================
// Classes defined in this interface
//==============================================================================

class ScriptButtonPartPropAccessor;

//==============================================================================
// Classes used by this interface
//==============================================================================

class CScriptButtonPart;

//==============================================================================
// PropAccessor
//==============================================================================

class ScriptButtonPartPropAccessor : public PropAccessor
{
  public:

	ScriptButtonPartPropAccessor(DescType property, CScriptButtonPart* part);

	XMPVMethod void SetData(AEDesc* objectData);
	
	XMPVMethod void GetData(AEDesc* objectData);
	
	OSErr DescListToRect(AEDesc* objectHandle, XMPRect* controlRect);


  private:

	DescType		fProperty;
	CScriptButtonPart*	fPart;
};

#endif // _BUTTONPARTAE_