/*
	File:		CClockDef.h

	Contains:	Common put contents here CClockPart

	Written by:	Lonnie Millett

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<2+>	 1/25/94	MB		Update NMAP resources to the
									Internationalizable format.
		<1+>	 1/14/94	MB		Making part binding changes
		<1+>	 1/13/94	MB		ASLM support

	To Do:
*/

#ifndef __CCLOCKDEF__
#define __CCLOCKDEF__

// Kind
#define kSampleClockKind "Apple:Kind:Framework:Sample:Clock"

// Class ID
#define kCClockPartID "appl:framework:sample:clockpart$class,1.0.0"

// Editor User String
#define kSampleClockEditorUserString "Sample Clock 1.0"

// Kind User String
#define kSampleClockKindUserString "Sample Clock"

// Category User String
#define kSampleClockCategoryUserString "Time"

// Clock OSType
#define kSampleClockOSType 'CLCK'

#ifdef ASLMBUILD
#define FW_kKindCategoryMapId		kNMAPid+1
#define FW_kEditorKindMapId			kNMAPid+2
#define FW_kEditorUserStringMapId	kNMAPid+3
#define FW_kKindUserStringMapId		kNMAPid+4
#define FW_kCategoryUserStringMapId	kNMAPid+5
#define FW_kOldMacOSTypeMapId		kNMAPid+6
#else
// For the static build, the value of FW_kKindCategoryMap must pick up where the last part
// left off. kNMAPid+31 is the last value used by the button part.
#define FW_kKindCategoryMapId		kNMAPid+32
#define FW_kEditorKindMapId			kNMAPid+33
#define FW_kEditorUserStringMapId	kNMAPid+34
#define FW_kKindUserStringMapId		kNMAPid+35
#define FW_kCategoryUserStringMapId	kNMAPid+36
#define FW_kOldMacOSTypeMapId			kNMAPid+37
// Our draw part picks up with kNMAPid+38, see QDrawDef.h
#endif

// Menus
#define kClockTypeMenu 5
#define kClockSoundsMenu 6

// Strings
#define kClockPartStrings 1000
#define kClockAnalogMenuString 1
#define kClockDigitalMenuString 2
#define kClockDigitalWidthString 3
#define kClockFaceString 4

// Sounds
#define kClockChime 1000
#define kClockTick 1001

#endif

