//	File:		ClockFac.h
//
//	Contains:	Definition for class CClockFacet
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

#ifndef _CLOCKFAC_
#define _CLOCKFAC_

#ifndef _FWFACET_
#include <FWFacet.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class CClockFacet;

//==============================================================================
// Classes used by this interface
//==============================================================================

class XMPFacet;
class XMPShape;
class CClockFrame;

//==============================================================================
// CClockFacet
//==============================================================================

class CClockFacet : public CFacet
{
public:
	CClockFacet();
	virtual ~CClockFacet();
	void InitClockFacet(XMPFacet* xmpFacet, CClockFrame* clockFrame);
	
	CClockFrame* GetClockFrame();
	
	virtual void Draw(XMPShape* invalidShape);
	
	void UpdateClockHands(XMPULong tickCount);
	void DrawClockFace();
	void DrawClockHands(XMPULong tickCount);
	void DrawHourHand(Rect* clockRect, Point* centerPoint, XMPSShort radius, XMPSShort hour, XMPSShort minute);
	void DrawMinuteHand(Rect* clockRect, Point* centerPoint, XMPSShort radius, XMPSShort minute);
	void DrawSecondHand(Rect* clockRect, Point* centerPoint, XMPSShort radius, XMPSShort second);
	void DrawDigitalClock(XMPULong tickCount);

private:
		CClockFrame* fClockFrame;
};

//----------------------------------------------------------------------------------------
// CClockFacet::GetClockFrame()
//----------------------------------------------------------------------------------------
inline CClockFrame* CClockFacet::GetClockFrame()
{
	return fClockFrame;
}

#endif
