/*
	File:		ClockFra.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	 3/17/94	DS		Add CDECL to Clock Frame dtor

	To Do:
*/

#ifndef _CLOCKFRA_
#define _CLOCKFRA_

#ifndef _FWFRAME_
#include "FWFrame.h"
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class CClockFrame;

//==============================================================================
// Classes used by this interface
//==============================================================================

class CClockPart;
class CFacet;
class XMPFrame;
class XMPShape;
class XMPMacMenuBar;

//==============================================================================
// CClockFrame
//==============================================================================

class CClockFrame : public CFrame
{
public:
	CClockFrame();
	void InitClockFrame(XMPFrame* xmpFrame, CClockPart* clockPart);
	virtual ~ CDECL CClockFrame();
	
	CClockPart* GetClockPart();
	
	CFacet* NewFacet(XMPFacet* xmpFacet);
	virtual void FacetAdded(CFacet* facet);
	virtual void FacetRemoved(CFacet* facet);
	
	virtual void FrameShapeChanged();
	
	virtual void UpdateClock(XMPULong tickCount);
	virtual XMPShape* GetNewFrameShape(CFacet* facet);
	
private:
	CClockPart* fClockPart;
	Rect fDigitalClockRect;
};

//----------------------------------------------------------------------------------------
// CClockFrame::GetClockPart
//----------------------------------------------------------------------------------------
inline CClockPart* CClockFrame::GetClockPart()
{
	return fClockPart;
}

#endif
