#
#	File:		CClockPart.make
#
#	Contains:	Makefile for OpenDoc ClockPart test part
#
#	Written by:	Lonnie Millett
#
#	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		<10>	 4/18/94	DS		Fix Rez Step
#		 <7>	 3/17/94	DS		Correct make for SC Builds
#		 <6>	 3/14/94	DS		Add Layout object to make
#		 <5>	  3/3/94	DS		Fix Make
#		 <4>	  3/2/94	DS		Make should include XMPConst.cpp.o
#		 <3>	  3/1/94	DS		Again
#		 <2>	  3/1/94	DS		Make the make point to the source in the
#									quality directory
#		<14>	 2/15/94	MB		Revert MathLib.o change
#		<6+>	 1/14/94	MB		Add a clean target to make file.
#		<5+>	 1/13/94	MB		ASLM support
#		 <3>	10/20/93	CG		Changed SimplePartLibASLM.cl.o to
#									PartRCRLibASLM.cl.o in objects list for
#									linking shared library.
#		 <2>	10/19/93	CG		Added necessary libs to
#									ClockPartLibsASLMObjects.
#		 <1>	10/18/93	T		first checked in
#
#	To Do:
#

ClockPartIncludes =  
				-i "{ODProjectDir}"Quality:QFramework: 
				-i "{ODProjectDir}"Quality:QFramework:QClockPart:

UserODCPlusOptions = {ClockPartIncludes}

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODProjectDir}"Quality:QFramework:QClockPart: 
									"{ODProjectDir}"Quality:QFramework:

# ASLM DEPENDENCIES

"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.r  "{ODProjectDir}"ODASLMOption
	SetFile -m '12/7/41' "{ODProjectDir}"ODASLMOption

#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

CClockPartOBJECTS = 
			"{ODObjects}ClockFac.cpp.o" 
			"{ODObjects}ClockFra.cpp.o" 
			"{ODObjects}ClockPar.cpp.o"

CClockPartLIBS = 
			"{CLibraries}CSANELib.o" 
			"{CLibraries}Math.o"
			
CClockPartSOURCEFILES = 
			"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFac.cpp 
			"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFra.cpp 
			"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.cpp
			
CClockPartLibASLMObjects = 
			"{ODObjects}XMPConst.cpp.o" 
			"{ODObjects}OperatorNewLib.o" 
			"{ODObjects}CClockPartLibASLM.cl.o" 
			"{ODObjects}UtilitiesLibASLM.cl.o" 
			"{ODObjects}CoreLibASLM.cl.o" 
			"{ODObjects}StorageLibASLM.cl.o" 
			"{ODObjects}LayoutLibASLM.cl.o" 
			"{ODObjects}ImagingLibASLM.cl.o" 
			"{ODObjects}MessagingLibASLM.cl.o" 
			"{ODObjects}UILibASLM.cl.o" 
			"{ODObjects}FrameworkLib.o" 
			"{ODObjects}FrameworkLibASLM.cl.o" 
			{CompilerLibraries} 
			{ASLMLibraries} 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"
			
	

# REZ STEP

"{ODObjects}"CClockPartLib.o  "{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.r 
								"{ODRezIntfDir}StdTypes.r" 
								"{ODCPlusIntfDir}StdDefs.h"
	Echo Rezzing: {NewerDeps}
	Rez {GRezOptions} {NewerDeps} -i "{ODCPlusIntfDir}" -a -o {Targ}

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODObjects}"CClockPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODObjects}"CClockPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODBinaryDir}CClockPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName
	
BuildSCASLM  "{ODBinaryDir}CClockPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

clean 
	delete -y -i {CClockPartOBJECTS}

"{ODObjects}"CClockPartLib.o  {CClockPartOBJECTS} {CClockPartLIBS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}

#"{ODObjects}"ClockPar.rsrc  
#		"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.r 
#		"{ODProjectDir}"Quality:QFramework:QClockPart:CClockDef.h
#	Echo Rezzing: {Targ}
#	Rez {GRezOptions} {Deps} -i "{ODCPlusIntfDir}" -type 'rsrc' -creator 'RSED' -o {Targ}

"{ODObjects}CClockPartLibASLM.cl.o"  
		"{ODObjects}CClockPartLib".o 
		"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPartLibASLM.exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{ClockPartIncludes} 
			{BuildSharedLibraryOptions} 
			-exp "{ODProjectDir}"Quality:QFramework:QClockPart:ClockPartLibASLM.exp 
			-obj "{ODObjects}CClockPartLibASLM" 
			-far "{ODObjects}CClockPartLibASLM.cl.o" 
			"{ODObjects}CClockPartLib.o"

"{ODBinaryDir}CClockPartLibASLM"  {CClockPartLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{ODBinaryDir}CClockPartLibASLM" 
			-obj "{ODObjects}CClockPartLibASLM" 
			-symFile "{ODBinaryDir}CClockPartLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{CClockPartLibASLMObjects}

"{ODBinaryDir}CClockPartLibASLM"  {CClockPartLibASLMObjects}
	Echo Copying Resources From: {ODObjects}CClockPartLib.o
	Echo "include "{ODObjects}CClockPartLib.o";" | Rez -a -o {Targ}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-append "{MAKEFILE}"								
		-objdir "{ODObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{CClockPartSOURCEFILES}

#*** Dependencies: Cut here ***

# ----- CClockPart
"{ODObjects}ClockFac.cpp.o"	 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFac.cpp 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFac.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFra.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:CClockDef.h 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h

"{ODObjects}ClockFra.cpp.o"	 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFra.cpp 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFra.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFac.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:CClockDef.h 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h

"{ODObjects}ClockPar.cpp.o"	 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.cpp 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockPar.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:ClockFra.h 
	"{ODProjectDir}"Quality:QFramework:QClockPart:CClockDef.h 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h
	
