/*
	File:		DrawFacet.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 3/10/94	DS		Derive DrawFacet from ViewFacet. Implement
									CreateViewHierarchy.

	To Do:
*/

/*
	File:		DrawFacet.h

	Contains:	Definition of class CDrawFacet

	Written by:	Henri Lamiraux

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _DRAWFACET_
#define _DRAWFACET_

// ----- Framework Includes -----
#ifndef _FWVIEWFACET_
#include "FWViewFa.h"
#endif

//==============================================================================
// Forward Declaration
//==============================================================================

class CDrawPart;
class CBaseShape;

//==============================================================================
//	 class CDrawFacet
//==============================================================================

class CDrawFacet : public FW_CViewFacet
{
//------------------------------------------------------------------------------
//	 Initialization/destruction
//------------------------------------------------------------------------------
public:
	CDrawFacet();
	void IDrawFacet(XMPFacet* facet, CDrawPart* drawPart);
	virtual ~CDrawFacet();

//------------------------------------------------------------------------------
//	 Inherited API
//------------------------------------------------------------------------------
public:	
	virtual FW_CView*		CreateViewHierarchy();

	virtual void 			Draw(XMPShape* invalidShape);

	virtual void			MouseEnter(const XMPPoint& where);	
	virtual XMPBoolean		DoMouseDown(const XMPPoint& where,
							 			XMPEventData event);
	virtual XMPBoolean		DoMouseDownInEmbeddedFrame(XMPFacet* embeddedXMPFacet, 
														const XMPPoint& where, 
														XMPEventData event);
	virtual XMPBoolean		DoMouseDownInEmbeddedFrameBorder(XMPFacet* embeddedXMPFacet, 
															const XMPPoint& where, 
															XMPEventData event);
	virtual void			ClipEmbeddedFacets();
	
	virtual XMPFacet*		CreateEmbeddedFacet(CProxyFrame *itsFrame, 
												XMPShape* clipShape, 
												XMPTransform* externalTransform, 
						   		 				XMPFacet* siblingFacet, 
												XMPFramePosition position);
//------------------------------------------------------------------------------
//	 New API
//------------------------------------------------------------------------------
public:
	void					DrawGrid();
	
protected:
	CBaseShape* 			WhichShape(Point mouse, XMPEventData event);

//------------------------------------------------------------------------------
//	 Data Members
//------------------------------------------------------------------------------
private:
	CDrawPart*				fDrawPart;
	EventRecord				fLastDownInEmbeddedFrame;
};
#endif