//	File:		DrawProxyBorder.cpp
//	Contains:	Implementation of class CDrawProxyBorder
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

#ifndef _DRAWPROXYBORDER_
#include "DrawProxyBorder.h"
#endif

#ifndef _DRAWPROXY_
#include "DrawProxy.h"
#endif

#ifndef _SHAPES_
#include "Shapes.h"
#endif

#pragma segment qdrawpart

//==============================================================================
// class CDrawProxyBorder
//==============================================================================

//------------------------------------------------------------------------------
// CDrawProxyBorder::CDrawProxyBorder
//------------------------------------------------------------------------------

CDrawProxyBorder::CDrawProxyBorder()
{
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::InitDrawProxyBorder
//------------------------------------------------------------------------------

void CDrawProxyBorder::InitDrawProxyBorder(CDrawProxyRun *proxyRun)
{
	InitBaseProxyBorder(proxyRun);
	fProxyRun = proxyRun;
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::~CDrawProxyBorder
//------------------------------------------------------------------------------

CDrawProxyBorder::~CDrawProxyBorder()
{
}

//------------------------------------------------------------------------------
// 	CDrawProxyBorder::DrawProxyBorder
//
// Enclosure must be prepared for drawing
//------------------------------------------------------------------------------

void CDrawProxyBorder::DrawProxyBorder(CFacet* facet, XMPFacet* embeddedFacet)
{
XMPUnused(embeddedFacet);

	fProxyRun->GetShape()->DrawShapeHandles(facet, kXMPTrue);
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::EraseProxyBorder
//
//	Enclosure must be prepared for drawing
//------------------------------------------------------------------------------

void CDrawProxyBorder::EraseProxyBorder(CFacet* facet, XMPFacet* embeddedFacet)
{	
XMPUnused(embeddedFacet);

	fProxyRun->GetShape()->DrawShapeHandles(facet, kXMPFalse);
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::WhereInProxyBorder
//
//	1--5--2
//	|	  |
//	8	  6
//	|	  |
//  3--7--4
//------------------------------------------------------------------------------

XMPSShort CDrawProxyBorder::WhereInProxyBorder(CFacet* facet, Point mouse) const
{
	return fProxyRun->GetShape()->WhichHandle(facet, mouse);
}

