//	File:		DrawProxyBorder.h
//	Contains:	Definition for class CDrawProxyBorder
//	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

#ifndef _DRAWPROXYBORDER_
#define _DRAWPROXYBORDER_

// ----- Framework Includes
#ifndef _FWBORDER_
#include <FWBorder.h>
#endif

//==============================================================================
// Forward Declarations
//==============================================================================

class CDrawProxyRun;
class CProxyShape;

//==============================================================================
// class CDrawProxyBorder
//==============================================================================

class CDrawProxyBorder : public CBaseProxyBorder
{
public:
	CDrawProxyBorder();
	void InitDrawProxyBorder(CDrawProxyRun* proxyRun);
	virtual ~CDrawProxyBorder();

	// ----- Drawing -----
	void				DrawProxyBorder(CFacet* facet, XMPFacet* embeddedFacet);
	void				EraseProxyBorder(CFacet* facet, XMPFacet* embeddedFacet);
	
	// ----- Hit Test -----
	XMPSShort			WhereInProxyBorder(CFacet* facet, Point mouse) const;

private:
	CDrawProxyRun*		fProxyRun;
};


#endif

