/*
	File:		PaletteFacet.h

	Contains:	Definition of class CPaletteFacet

	Written by:	Henri Lamiraux

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _PALETTEFACET_
#define _PALETTEFACET_

#ifndef _QDRAWPART_
#include "QDrawPart.h"
#endif

// ----- Framework Includes -----

#ifndef _FWFACET_
#include "FWFacet.h"
#endif

#ifndef _ALTPOINT_
#include "AltPoint.h"
#endif

//==============================================================================
// Constants
//==============================================================================

const XMPSShort kNbRects = 9;

//==============================================================================
// Forward Declaration
//==============================================================================

class CDrawPart;

//==============================================================================
// CPaletteFacet
//==============================================================================

class CPaletteFacet : public CFacet
{
//------------------------------------------------------------------------------
// Initialization/destruction
//------------------------------------------------------------------------------
public:
	CPaletteFacet();
	void InitPaletteFacet(XMPFacet* facet, CDrawPart* drawPart);
	virtual ~CPaletteFacet();

//------------------------------------------------------------------------------
// Inherited
//------------------------------------------------------------------------------
public:	
	virtual void 			Draw(XMPShape* invalidShape);

	virtual XMPBoolean		DoMouseDown(const XMPPoint& where,
							 			XMPEventData event);
	
//------------------------------------------------------------------------------
// New API
//------------------------------------------------------------------------------
public:
	void					CheckTool(XMPUShort oldTool, 
									  XMPUShort newTool);
	void					CheckFillFrame(XMPUShort oldFillFrame, 
									  	   XMPUShort newFillFrame);
	
private:
	XMPSShort				TestRect(const XMPPoint& pos, XMPRect* rects, XMPUShort nbRect);
	void					InvertTool(XMPUShort theTool);
	void					DrawFillFrame(XMPUShort fillFrame, const Pattern& pattern);
	void					DrawTools();
	
//------------------------------------------------------------------------------
// Data
//------------------------------------------------------------------------------
private:
	CDrawPart*				fDrawPart;
	XMPRect					fRects[kNbRects];
};
#endif