/*
	File:		PaletteFrame.cp

	Contains:	implementation of class CPaletteFrame

	Written by:	Henri Lamiraux

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _PALETTEFRAME_
#include "PaletteFrame.h"
#endif

#ifndef _QDRAWPART_
#include "QDrawPart.h"
#endif

#ifndef _UTILITIES_
#include "Utilities.h"
#endif

#ifndef _PALETTEDACET_
#include "PaletteFacet.h"
#endif

#ifndef _FWWINDOW_
#include "FWWindow.h"
#endif

// ----- Macintosh Includes -----
#ifndef mathRoutinesIncludes
#include <math routines.h>
#endif

#pragma segment qdrawpart

//=========================================================================
// CLASS CPaletteFrame
//=========================================================================

//------------------------------------------------------------------------------
// CPaletteFrame::CPaletteFrame
//------------------------------------------------------------------------------

CPaletteFrame::CPaletteFrame()
{
}

//------------------------------------------------------------------------------
// CPaletteFrame::InitPaletteFrame
//------------------------------------------------------------------------------

void CPaletteFrame::InitPaletteFrame(XMPFrame* xmpFrame, CDrawPart *drawPart)
{
	IFrame(xmpFrame, drawPart);
	fDrawPart = drawPart;
	this->SetCanBeActiveFrame(kXMPFalse);
}

//------------------------------------------------------------------------------
// CPaletteFrame::~CPaletteFrame
//------------------------------------------------------------------------------

CPaletteFrame::~CPaletteFrame()
{
}

//------------------------------------------------------------------------------
// CPaletteFrame::NewFacet
//------------------------------------------------------------------------------

CFacet* CPaletteFrame::NewFacet(XMPFacet* xmpFacet)
{
	CPaletteFacet* facet = new CPaletteFacet;
	facet->InitPaletteFacet(xmpFacet, fDrawPart);
	return facet;
}

//------------------------------------------------------------------------------
// CPaletteFrame::FacetAdded
//------------------------------------------------------------------------------

void CPaletteFrame::FacetAdded(CFacet* facet)
{
	CFrame::FacetAdded(facet);
	
	if (fDrawPart->GetPalette() == NULL)
		fDrawPart->SetPalette(NewFloatingWindow(facet->GetXMPWindow()));
}

//------------------------------------------------------------------------------
// CPaletteFrame::NewFloatingWindow
//------------------------------------------------------------------------------

CFloatingWindow* CPaletteFrame::NewFloatingWindow(XMPWindow* xmpWindow)
{
	CFloatingWindow* floatingWindow = new CFloatingWindow();
	floatingWindow->InitFloatingWindow(xmpWindow);
	return floatingWindow;
}


