/*
	File:		PaletteFrame.h

	Contains:	Definition for class CPaletteFrame

	Written by:	Henri Lamiraux

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	 3/17/94	DS		Add CDECL
*/

#ifndef _PALETTEFRAME_
#define _PALETTEFRAME_

#ifndef _QDRAWPART_
#include "QDrawPart.h"
#endif

// ----- Framework Includes -----

#ifndef _FWFRAME_
#include "FWFrame.h"
#endif

//==============================================================================
// Forward Declaration
//==============================================================================

class CDrawPart;
class CFacet;
class CFloatingWindow;
class XMPFrame;
class XMPWindow;

//==============================================================================
// CPaletteFrame
//==============================================================================

class CPaletteFrame : public CFrame
{
//------------------------------------------------------------------------------
// Initialization/destruction
//------------------------------------------------------------------------------
public:		
	CPaletteFrame();
	void InitPaletteFrame(XMPFrame* xmpFrame, CDrawPart* drawPart);
	virtual ~ CDECL CPaletteFrame();

//------------------------------------------------------------------------------
// Inherited
//------------------------------------------------------------------------------
public:		
	virtual CFacet* 		NewFacet(XMPFacet* xmpFacet);
	virtual void 			FacetAdded(CFacet* facet);
	
	
//------------------------------------------------------------------------------
// New
//------------------------------------------------------------------------------
	virtual CFloatingWindow*	NewFloatingWindow(XMPWindow* xmpWindow);
	
//------------------------------------------------------------------------------
// Data Members
//------------------------------------------------------------------------------
private:	
	CDrawPart*				fDrawPart;
};

#endif
