/*
	File:		QDrawDef.h

	Contains:	Common definitions for QDrawPart

	Written by:	Henri Lamiraux

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	  3/3/94	DS		Why do I try?
		<5+>	 1/25/94	MB		Update NMAP resources to the
									Internationalizable format.

	To Do:
*/

#ifndef _QDRAWDEF_
#define _QDRAWDEF_

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

// Kind
#define kQDrawKind "Apple:Kind:Framework:Sample:QDraw"

// Class ID
#define kCDrawPartID "appl:framework:sample:qdrawpart$class,1.0.0"

// Editor User String
#define kQDrawEditorUserString "Sample Draw 1.0"

// Kind User String
#define kQDrawKindUserString "Sample Draw"

// Category User String
#define kQDrawCategoryUserString "2D Graphics"

// Draw OSType
#define kQDrawOSType 'PICT'

#ifdef ASLMBUILD
#define FW_kKindCategoryMapId		kNMAPid+1
#define FW_kEditorKindMapId			kNMAPid+2
#define FW_kEditorUserStringMapId	kNMAPid+3
#define FW_kKindUserStringMapId		kNMAPid+4
#define FW_kCategoryUserStringMapId	kNMAPid+5
#define FW_kOldMacOSTypeMapId		kNMAPid+6
#else
// For the static build, the value of FW_kKindCategoryMap must pick up where the last part
// left off. kNMAPid+37 is the last value used by the clock part.
#define FW_kKindCategoryMapId		kNMAPid+38
#define FW_kEditorKindMapId			kNMAPid+39
#define FW_kEditorUserStringMapId	kNMAPid+40
#define FW_kKindUserStringMapId		kNMAPid+41
#define FW_kCategoryUserStringMapId	kNMAPid+42
#define FW_kOldMacOSTypeMapId			kNMAPid+43
// Our movie part picks up with kNMAPid+44, see MovieDef.h
#endif

// Frame Presentations
#define kMainPresentation			"Apple:Presentation:QDrawPart:Main"
#define kPalettePresentation	"Apple:Presentation:QDrawPart:Palette"

// ----- type -----
#define kPublishFormat	"Apple:Publish:QDraw"


#endif

