#
#	File:		QDrawPart.make
#
#	Contains:	xxx put contents here xxx
#
#	Written by:	xxx put writers here xxx
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <9>	 3/31/94	DS		Remove parttype
#		 <8>	 3/23/94	DS		Add -a to rez step
#		<6+>	 3/17/94	DS		Correct make for SC Builds
#		 <6>	 3/14/94	DS		Add Layout object to make
#		 <5>	  3/3/94	DS		\
#		 <4>	  3/2/94	DS		need to include PartType.cpp.o
#		 <3>	  3/2/94	DS		Make should include XMPConst.cpp.o
#		 <2>	  3/1/94	DS		Make the make point to the right places for
#									source.
#
#	To Do:
#

#
#	File:		QDrawPart.make
#
#	Contains:	Makefile for OpenDoc QDrawPart test part
#
#	Written by:	Henri Lamiraux
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#	To Do:
#

QDrawPartIncludes = 
				-i "{ODProjectDir}"Quality:QFramework: 
				-i "{ODProjectDir}"Quality:QFramework:QDraw:

UserODCPlusOptions = {QDrawPartIncludes}

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODProjectDir}"Quality:QFramework:QDraw: 
					"{ODProjectDir}"Quality:QFramework:

# ASLM DEPENDENCIES

"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.r  "{ODProjectDir}"ODASLMOption
	SetFile -m '12/7/41' "{ODProjectDir}"ODASLMOption
				
#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

QDrawPartOBJECTS = 
			"{ODObjects}DrawProxyBorder.cpp.o" 
			"{ODObjects}PaletteFrame.cpp.o" 
			"{ODObjects}PaletteFacet.cpp.o" 
			"{ODObjects}DrawProxy.cpp.o" 
			"{ODObjects}Utilities.cpp.o" 
			"{ODObjects}Style.cpp.o" 
			"{ODObjects}Shapes.cpp.o" 
			"{ODObjects}DrawSelection.cpp.o" 
			"{ODObjects}QDrawPart.cpp.o" 
			"{ODObjects}DrawFacet.cpp.o" 
			"{ODObjects}DrawFrame.cpp.o"
		
QDrawPartSOURCEFILES = 
			"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxyBorder.cpp 
			"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFrame.cpp 
			"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFacet.cpp 
			"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:Utilities.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:Style.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:DrawFacet.cpp	
			"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.cpp	

QDrawPartLibASLMObjects = 
			"{ODObjects}XMPConst.cpp.o" 
			"{ODObjects}OperatorNewLib.o" 
			"{ODObjects}QDrawPartLibASLM.cl.o" 
			"{ODObjects}UtilitiesLibASLM.cl.o" 
			"{ODObjects}CoreLibASLM.cl.o" 
			"{ODObjects}StorageLibASLM.cl.o" 
			"{ODObjects}LayoutLibASLM.cl.o" 
			"{ODObjects}ImagingLibASLM.cl.o" 
			"{ODObjects}UILibASLM.cl.o" 
			"{ODObjects}FrameworkLib.o" 
			"{ODObjects}FrameworkLibASLM.cl.o" 
			{CompilerLibraries} 
			{ASLMLibraries} 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"
			
# Following removed from above list
#			"{CLibraries}CPlusLib.o" 
#			"{Libraries}LibraryManager.debug.o" 
			
# REZ STEP

"{ODObjects}"QDrawPartLib.o  "{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.r 
								"{ODRezIntfDir}StdTypes.r" 
								"{ODCPlusIntfDir}StdDefs.h"
	Echo Rezzing: {NewerDeps}
	Rez {GRezOptions} {NewerDeps} -i "{ODCPlusIntfDir}" -a -o {Targ}

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODObjects}"QDrawPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODObjects}"QDrawPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODBinaryDir}QDrawPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

BuildSCASLM  "{ODBinaryDir}QDrawPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

clean 
	delete -y -i {QDrawPartOBJECTS}

"{ODObjects}"QDrawPartLib.o  {QDrawPartOBJECTS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}

"{ODObjects}QDrawPartLibASLM.cl.o"  
		"{ODObjects}QDrawPartLib".o 
		"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPartLibASLM.exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{QDrawPartIncludes} 
			{BuildSharedLibraryOptions} 
			-exp "{ODProjectDir}"Quality:QFramework:QDraw:QDrawPartLibASLM.exp 
			-obj "{ODObjects}QDrawPartLibASLM" 
			-far "{ODObjects}QDrawPartLibASLM.cl.o" 
			"{ODObjects}QDrawPartLib.o"

"{ODBinaryDir}QDrawPartLibASLM"  {QDrawPartLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{ODBinaryDir}QDrawPartLibASLM" 
			-obj "{ODObjects}QDrawPartLibASLM" 
			-symFile "{ODBinaryDir}QDrawPartLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{QDrawPartLibASLMObjects}

"{ODBinaryDir}QDrawPartLibASLM"  {QDrawPartLibASLMObjects}
	Echo Copying Resources From: {ODObjects}QDrawPartLib.o
	Echo "include "{ODObjects}QDrawPartLib.o";" | Rez -a -o {Targ}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-append "{MAKEFILE}"								
		-objdir "{ODObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{QDrawPartSOURCEFILES}

#*** Dependencies: Cut here ***

# This makefile was produced at 17:16:49 on Fri, Oct 15, 1993 by
# MakeDepend

# ----- QDrawPart
"{ODObjects}"DrawFacet.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:DrawFacet.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h

"{ODObjects}"DrawFrame.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Utilities.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h

"{ODObjects}"DrawProxy.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxyBorder.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h

"{ODObjects}"QDrawPart.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h

"{ODObjects}"Shapes.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:Shapes.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Utilities.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h

"{ODObjects}"Style.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:Style.cpp 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h

"{ODObjects}"Utilities.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:Utilities.cpp 
	"{ODProjectDir}"Quality:QFramework:QDraw:Utilities.h

"{ODObjects}"PaletteFacet.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:PaletteFacet.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h

"{ODObjects}"PaletteFrame.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:PaletteFrame.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Utilities.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:PaletteFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWWindow.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h

"{ODObjects}"DrawSelection.cpp.o  "{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawFrame.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawProxy.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawPart.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Shapes.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:Style.h 
	"{ODProjectDir}"Quality:QFramework:FWBorder.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:QDrawDef.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:QDraw:DrawSelection.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h
