/*
	File:		Utilities.cpp

	Contains:	Some Utilities

	Written by:	Henri Lamiraux

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
*/

#ifndef _UTILITIES_
#include "Utilities.h"
#endif

// ----- Framework Includes -----

#ifndef _ALTPOINT_
#include "AltPoint.h"
#endif

// ----- Macintosh Includes -----

#ifndef __EVENTS__
#include <Events.h>
#endif

#pragma segment qdrawpart

//-------------------------------------------------------------------------
// WaitForTick
//-------------------------------------------------------------------------

void WaitForTick()
{
	long tick = ::TickCount()+1;
	while (tick >= ::TickCount()) {}
}

//-------------------------------------------------------------------------
// MapPoint
//-------------------------------------------------------------------------

void MapPoint(Point& pt, const Rect& srcRect, const Rect& dstRect)
{
	pt.h = ((pt.h - srcRect.left) * (dstRect.right - dstRect.left)) / (srcRect.right - srcRect.left) + dstRect.left;
	pt.v = ((pt.v - srcRect.top) * (dstRect.bottom - dstRect.top)) / (srcRect.bottom - srcRect.top) + dstRect.top;
}
