/*
	File:		MovieFac.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 4/12/94	DS		Replace ClipShapeChanged and
									ExternalTransformChanged with
									GeometryChanged

	To Do:
*/

//	File:		MovieFac.h
//
//	Contains:	Definition for class CMovieFacet
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

#ifndef _MOVIEFAC_
#define _MOVIEFAC_

#ifndef _FWFACET_
#include "FWFacet.h"
#endif

#ifndef __MOVIES__
#include <Movies.h>
#endif

#ifndef __ALIASES__
#include <Aliases.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class CMovieFacet;

//==============================================================================
// Classes used by this interface
//==============================================================================

class XMPFacet;
class XMPShape;
class XMPRect;
class CMovieFrame;
class XMPDragItemIterator;

//==============================================================================
// Constants
//==============================================================================

//==============================================================================
// CMovieFacet
//==============================================================================

class CMovieFacet : public CFacet
{
public:
	CMovieFacet();
	virtual ~CMovieFacet();
	void InitMovieFacet(XMPFacet* xmpFacet, CMovieFrame* movieFrame);
	
	CMovieFrame* GetMovieFrame();
	
	Movie GetMovie();
	virtual void SetMovie(Movie newMovie);
	
	void AdjustMovieBox();
	void GetMovieBoundingBox(XMPRect* boundingBox);
	
	virtual void StartMovie();
	virtual void StopMovie();
	virtual void SetMovieLooping(XMPBoolean loop);
	
	virtual void Draw(XMPShape* invalidShape);
	virtual void GeometryChanged();
	
	virtual void WindowActivated();
	virtual void WindowDeActivated();
	
	virtual XMPBoolean DoMouseDown(const XMPPoint& where, XMPEventData event);
	XMPBoolean DoMovieKey(XMPEventData event);
	void DoMovieSetVisible(XMPBoolean visible);
	XMPBoolean DoMovieIdle();
	void DoMovieActivate(XMPBoolean activate);
	
	XMPBoolean IsControllerVisible();
	
	//--- Selection ------
	void GetCurrentSelection(TimeValue* currentTime, TimeValue* duration);
	void SetCurrentSelection(TimeValue currentTime, TimeValue duration);
	XMPBoolean IsEmpty();
	void CloseSelection();
	void ClearSelection(TimeValue currentTime, TimeValue duration);
	void SelectAll();
	Handle CopySelection();
	
	//--- Drag and Drop ------
	virtual void DragEnter(XMPDragItemIterator* dragInfo, XMPPoint where);
	virtual XMPBoolean DrawDragHiliteInside();
	PicHandle GetMovieAsPict();
	void PasteMovieToSelection(Movie newMovie, TimeValue currentTime, TimeValue duration);
	void PasteHandleToSelection(Handle newHandle, OSType handleType, TimeValue currentTime, TimeValue duration);

private:
	CMovieFrame* fMovieFrame;
	Movie fMovie;
	MovieController fMovieController;
};

//----------------------------------------------------------------------------------------
// CMovieFacet::GetMovieFrame()
//----------------------------------------------------------------------------------------
inline CMovieFrame* CMovieFacet::GetMovieFrame()
{
	return fMovieFrame;
}

//----------------------------------------------------------------------------------------
// CMovieFacet::GetMovie
//----------------------------------------------------------------------------------------
inline Movie CMovieFacet::GetMovie()
{
	return fMovie;
}

#endif
