/*
	File:		MovieFra.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	 3/17/94	DS		Add CDECL to Movie Frame dtor

	To Do:
*/

#ifndef _MOVIEFRA_
#define _MOVIEFRA_

#ifndef _FWFRAME_
#include "FWFrame.h"
#endif

#ifndef __MOVIES__
#include <Movies.h>
#endif

#ifndef __ALIASES__
#include <Aliases.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class CMovieFrame;

//==============================================================================
// Classes used by this interface
//==============================================================================

class CMoviePart;
class CFacet;
class XMPFrame;
class XMPShape;
class XMPMacMenuBar;

//==============================================================================
// CMovieFrame
//==============================================================================

class CMovieFrame : public CFrame
{
public:
	CMovieFrame();
	void InitMovieFrame(XMPFrame* xmpFrame, CMoviePart* moviePart);
	virtual ~ CDECL CMovieFrame();
	
	CMoviePart* GetMoviePart();
	
	CFacet* NewFacet(XMPFacet* xmpFacet);
	virtual void FacetAdded(CFacet* facet);
	virtual XMPWindow*  CreateChildWindow(XMPISOStr windowTitle);

	virtual void FrameShapeChanged();
	
	virtual void FocusStateChanged(XMPTypeToken focus, XMPBoolean newState);

	virtual XMPBoolean HandleKeyDown(XMPEventData event);
	virtual XMPBoolean DoMenuEvent(XMPMenuBar *menuBar, XMPCommandID commandID);
	
	void UpdateMovie();
	void AdjustFrameSize(XMPRect* movieBox);
	
	void SetNewMovie(Movie newMovie);
	
	//----- Selection -------
	void CloseSelection();
	void ClearSelection(TimeValue currentTime, TimeValue duration);
	void SelectAll();
	void PasteMovieToSelection(Movie newMovie, TimeValue currentTime, TimeValue duration);
	void PasteHandleToSelection(Handle newHandle, OSType handleType, TimeValue currentTime, TimeValue duration);

	void ToggleLooping(XMPBoolean looping);

private:
	CMoviePart* fMoviePart;
};

//----------------------------------------------------------------------------------------
// CMovieFrame::GetMoviePart
//----------------------------------------------------------------------------------------
inline CMoviePart* CMovieFrame::GetMoviePart()
{
	return fMoviePart;
}

#endif
