#
#	File:		CMoviePart.make
#
#	Contains:	Makefile for OpenDoc MoviePart test part
#
#	Written by:	Lonnie Millett
#
#	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <8>	 3/23/94	DS		Add -a to rez step
#		<6+>	 3/17/94	DS		Correct make for SC Builds
#		 <6>	 3/14/94	DS		Add Layout object to make
#		 <5>	  3/2/94	DS		Good Grief!
#		 <4>	  3/2/94	DS		Make should include XMPConst.cpp.o
#		 <3>	  3/2/94	DS		Again
#		 <2>	  3/1/94	DS		Make Source point to QFramework dirs
#		<6+>	 1/26/94	HL		
#		<4+>	 1/14/94	MB		Add a clean target to make file.
#		<3+>	 1/13/94	MB		ASLM support
#	To Do:
#


MoviePartIncludes = 
				-i "{ODProjectDir}"Quality:QFramework: 
				-i "{ODProjectDir}"Quality:QFramework:QMoviePart:

UserODCPlusOptions = {MoviePartIncludes}

# ASLM DEPENDENCIES

"{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.r  "{ODProjectDir}"ODASLMOption
	SetFile -m '12/7/41' "{ODProjectDir}"ODASLMOption

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODProjectDir}"Quality:QFramework:QMoviePart: 
									"{ODProjectDir}"Quality:QFramework:

#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

CMoviePartOBJECTS = 
			"{ODObjects}MovieSel.cpp.o" 
			"{ODObjects}MovieFac.cpp.o" 
			"{ODObjects}MovieFra.cpp.o" 
			"{ODObjects}MoviePar.cpp.o"

CMoviePartSOURCEFILES = 
			"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieSel.cpp 
			"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFac.cpp 
			"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFra.cpp 
			"{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.cpp
			
CMoviePartLibASLMObjects = 
			"{ODObjects}XMPConst.cpp.o" 
			"{ODObjects}OperatorNewLib.o" 
			"{ODObjects}CMoviePartLibASLM.cl.o" 
			"{ODObjects}UtilitiesLibASLM.cl.o" 
			"{ODObjects}CoreLibASLM.cl.o" 
			"{ODObjects}StorageLibASLM.cl.o" 
			"{ODObjects}LayoutLibASLM.cl.o" 
			"{ODObjects}ImagingLibASLM.cl.o" 
			"{ODObjects}MessagingLibASLM.cl.o" 
			"{ODObjects}UILibASLM.cl.o" 
			"{ODObjects}FrameworkLib.o" 
			"{ODObjects}FrameworkLibASLM.cl.o" 
			{CompilerLibraries} 
			{ASLMLibraries} 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"

# REZ STEP

"{ODObjects}"CMoviePartLib.o  "{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.r 
								"{ODRezIntfDir}StdTypes.r" 
								"{ODCPlusIntfDir}StdDefs.h" 
								"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieDef.h
	Echo Rezzing: {NewerDeps}
	Rez {GRezOptions} {NewerDeps} -i "{ODCPlusIntfDir}" -a -o {Targ}

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODObjects}"CMoviePartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODObjects}"CMoviePartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODBinaryDir}CMoviePartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

BuildSCASLM  "{ODBinaryDir}CMoviePartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

clean 
	delete -y -i {CMoviePartOBJECTS}

"{ODObjects}"CMoviePartLib.o  {CMoviePartOBJECTS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}

"{ODObjects}CMoviePartLibASLM.cl.o"  
		"{ODObjects}CMoviePartLib".o 
		"{ODProjectDir}"Quality:QFramework:QMoviePart:CMoviePartLibASLM.exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{MoviePartIncludes} 
			{BuildSharedLibraryOptions} 
			-exp "{ODProjectDir}"Quality:QFramework:QMoviePart:CMoviePartLibASLM.exp 
			-obj "{ODObjects}CMoviePartLibASLM" 
			-far "{ODObjects}CMoviePartLibASLM.cl.o" 
			"{ODObjects}CMoviePartLib.o"

"{ODBinaryDir}CMoviePartLibASLM"  {CMoviePartLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{ODBinaryDir}CMoviePartLibASLM" 
			-obj "{ODObjects}CMoviePartLibASLM" 
			-symFile "{ODBinaryDir}CMoviePartLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{CMoviePartLibASLMObjects}

"{ODBinaryDir}CMoviePartLibASLM"  {CMoviePartLibASLMObjects}
	Echo Copying Resources From: {ODObjects}CMoviePartLib.o
	Echo "include "{ODObjects}CMoviePartLib.o";" | Rez -a -o {Targ}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-append "{MAKEFILE}"								
		-objdir "{ODObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{CMoviePartSOURCEFILES}

#*** Dependencies: Cut here ***

# ----- CMoviePart

"{ODObjects}"MovieFac.cpp.o  "{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFac.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFac.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFra.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieDef.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieSel.h

"{ODObjects}"MovieFra.cpp.o  "{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFra.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFac.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFra.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieDef.h

"{ODObjects}"MoviePar.cpp.o  "{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFac.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFra.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieDef.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieSel.h

"{ODObjects}"MovieSel.cpp.o  "{ODProjectDir}"Quality:QFramework:QMoviePart:MovieSel.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFac.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieFra.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MoviePar.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieDef.h 
	"{ODProjectDir}"Quality:QFramework:QMoviePart:MovieSel.h
