/*
	File:		ODText.h

	Contains:	Definition for class COpenDocText

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _ODTEXT_
#define _ODTEXT_

#ifndef _ALTPOINT_			// Just to be sure to be included before PlfmType.h
#include "AltPoint.h"
#endif

// ----- Textension Includes -----

#ifndef _Textension_
#include "Textension.h"
#endif

//========================================================================================
// CLASS COpenDocText
//========================================================================================

class COpenDocText : public CTextension
{
//----------------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
					COpenDocText();
	virtual			~COpenDocText();
	
	OSErr			InitOpenDocText(GrafPtr textPort,
									TTextensionHandlers* handlers,
									TSize sizeInfo);

//----------------------------------------------------------------------------------------
//	 New API
//
public:
	virtual void NotifyEmbeddedPartsOfPositionChange(long firstFormatLine,
													 long lastFormatLine);

//----------------------------------------------------------------------------------------
//	 Inherited API
//
protected:
	virtual void 	EndEdit(const TEditInfo* editInfo,
							long firstFormatLine, long lastFormatLine,
							TOffset* selOffset=nil, Boolean updateKeyScript=true);
};

#endif
