/*
	File:		RulerFacet.h

	Contains:	Definition for class CRulerFacet

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _RULERFACET_
#define _RULERFACET_

#ifndef _ALTPOINT_			// Just to be sure to be included before PlfmType.h
#include "AltPoint.h"
#endif

#ifndef _FWFACET_
#include "FWFacet.h"
#endif

#ifndef _TEXTPART_
#include "TextPart.h"
#endif


//========================================================================================
// CLASS CRulerFacet
//========================================================================================

class CRulerFacet : public CFacet
{
private:
	static const RGBColor kGray;
	static const RGBColor kBlack;
	
// ----- Construction/destruction
public:
	CRulerFacet();
	void IRulerFacet(XMPFacet* facet, CTextPart* textPart);
	virtual ~CRulerFacet();

// ----- Inherited API
public:
	virtual void 			Draw(XMPShape* invalidShape);
	virtual XMPBoolean		DoMouseDown(const XMPPoint& where,
							 			XMPEventData event);
	virtual void			MouseEnter(const XMPPoint& where);

// ----- New API
protected:
	virtual void			DrawBackground(RgnHandle invalidRgn, const Rect& boundingBox);
	virtual void			DrawTools(RgnHandle invalidRgn, const Rect& boundingBox);
	virtual void			DrawRuler(RgnHandle invalidRgn, const Rect& boundingBox);

// ----- Fields
private:
	CTextPart*				fTextPart;
	Rect					fToolAreas[CTextPart::kNumberOfTools];
	short					fSelectedTool;
};

#endif
