/*
	File:		RulerFrame.cp

	Contains:	implementation of class CRulerFrame

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _TEXTPART_
#include "TextPart.h"
#endif

#ifndef _RULERFRAME_
#include "RulerFrame.h"
#endif

#ifndef _RULERFACET_
#include "RulerFacet.h"
#endif

#pragma segment TextPartSegment


//========================================================================================
// CLASS CRulerFrame
//========================================================================================

//----------------------------------------------------------------------------------------
// CRulerFrame::CRulerFrame
//----------------------------------------------------------------------------------------

CRulerFrame::CRulerFrame() :
	CFrame(),
	fTextPart(NULL)
{
}

//----------------------------------------------------------------------------------------
// CRulerFrame::CRulerFrame
//----------------------------------------------------------------------------------------

void CRulerFrame::IRulerFrame(XMPFrame* xmpFrame, CTextPart* textPart)
{
	IFrame(xmpFrame, textPart);
	SetFrontClicks(kXMPTrue);
	fTextPart = textPart;
}

//----------------------------------------------------------------------------------------
// CRulerFrame::~CRulerFrame
//----------------------------------------------------------------------------------------

CRulerFrame::~CRulerFrame()
{
}

//----------------------------------------------------------------------------------------
// CRulerFrame::FocusStateChanged
//----------------------------------------------------------------------------------------

void CRulerFrame::FocusStateChanged(XMPTypeToken focus, XMPBoolean newState)
{
	CFrame::FocusStateChanged(focus, newState);
}

//----------------------------------------------------------------------------------------
// CRulerFrame::NewFacet
//----------------------------------------------------------------------------------------

CFacet* CRulerFrame::NewFacet(XMPFacet* xmpFacet)
{
	CRulerFacet* facet = new CRulerFacet;
	facet->IRulerFacet(xmpFacet, fTextPart);
	return facet;
}

