/*
	File:		RulerFrame.h

	Contains:	Definition for class CRulerFrame.h

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _RULERFRAME_
#define _RULERFRAME_

#ifndef _ALTPOINT_			// Just to be sure to be included before PlfmType.h
#include "AltPoint.h"
#endif

#ifndef _FWFRAME_
#include "FWFrame.h"
#endif


//========================================================================================
// Forward class declarations
//========================================================================================

class CTextPart;
class CTextFacet;


//========================================================================================
// CRulerFrame
//========================================================================================

class CRulerFrame : public CFrame
{
// ----- Initialization/destruction
public:		
	CRulerFrame();
	void IRulerFrame(XMPFrame* xmpFrame, CTextPart* textPart);
	virtual ~CRulerFrame();

// ----- From CFrame
public:		
	virtual void			FocusStateChanged(XMPTypeToken focus, XMPBoolean newState);
	virtual CFacet*		NewFacet(XMPFacet* xmpFacet);
	
// ----- Data Members
private:	
	CTextPart*				fTextPart;
};

#endif
