/*
	File:		TextFrame.h

	Contains:	Definition for class CDrawFrame

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _TEXTFRAME_
#define _TEXTFRAME_

#ifndef _FWFRMING_
#include "FWFrming.h"
#endif

#ifndef __TEXTEDIT__
#include "TextEdit.h"
#endif


//========================================================================================
// Forward class declarations
//========================================================================================

class CTextPart;
class CTextFacet;
class CRulerFrame;


//========================================================================================
// CTextFrame
//========================================================================================

class CTextFrame : public CEmbeddingFrame
{
// ----- Initialization/destruction
public:		
	CTextFrame();
	void ITextFrame(XMPFrame* xmpFrame, CTextPart* textPart);
	virtual ~CTextFrame();

// ----- From CFrame
public:		
	virtual XMPBoolean		HandleKeyDown(XMPEventData event);
	virtual XMPBoolean		DoIdle();
	virtual void			FrameShapeChanged();
	virtual void			FocusStateChanged(XMPTypeToken focus, XMPBoolean newState);
	virtual CFacet*			NewFacet(XMPFacet* xmpFacet);
	virtual XMPBoolean		DoMenuEvent(XMPMenuBar *menuBar, XMPCommandID commandID);
	virtual void 			FacetAdded(CFacet* facet);
	virtual void 			FacetRemoved(CFacet* facet);
	
// ----- New Methods
public:
	XMPFrame*				GetRulerFrame()
								{ return fRulerFrame; }

protected:
	virtual void			ShowRuler();
	virtual void			HideRuler();
	
private:
	void					GrowFrame();
	void					SetFontSize(short fontSize);

// ----- Constants
public:
	enum { kBorderInset = 4 };
	
// ----- Data Members
private:	
	CTextPart*				fTextPart;
	XMPFrame*				fRulerFrame;
};

#endif
