#
#	File:		TextPart.make
#
#	Contains:	xxx put contents here xxx
#
#	Written by:	xxx put writers here xxx
#
#	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#		 <9>	 3/31/94	DS		Remove parttype
#		 <8>	 3/23/94	DS		Add -a to rez step ( Really )
#		 <7>	 3/23/94	DS		Add -a to rez step
#		 <6>	 3/14/94	DS		Add Layout object to make
#		 <5>	  3/2/94	DS		Make Fix
#		 <4>	  3/2/94	DS		Make Fix
#		 <3>	  3/2/94	DS		Make should include XMPConst.cpp.o
#		 <2>	  3/1/94	DS		Make sources point to quality directories
#
#	To Do:
#

#
#	File:		TextPart.make
#
#	Contains:	Makefile for OpenDoc TextPart test part
#
#	Written by:	Mike Burbidge
#
#	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.
#

# Add defines for Textension

TextPartIncludes = 
				-i "{ODProjectDir}"Quality:QFramework: 
				-i "{ODProjectDir}"Quality:QFramework:QTextPart: 
				-i "{ODProjectDir}"Quality:QFramework:QTextPart:Textension:TextensionIntf:

UserODCPlusOptions = 
				-d txtnSys7 -d txtnRulers -d qUniversalHeaders 
				{TextPartIncludes}

# DIRECTORY DEPENDENCIES

"{ODObjects}" 	"{ODProjectDir}"Quality:QFramework:QTextPart: 
					"{ODProjectDir}"Quality:QFramework:
				
# ASLM DEPENDENCIES

"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.r  "{ODProjectDir}"ODASLMOption
	SetFile -m '12/7/41' "{ODProjectDir}"ODASLMOption

#
# FILE LIST VARIABLES
#
# YOU MUST UPDATE BOTH LISTS BELOW WHEN ADDING A SOURCE FILE, I.E., UPDATE
# BOTH THE OBJECTS AND SOURCEFILES VARIABLES. This is a pain, but believe me,
# there's no way around it.
#

TextPartOBJECTS = 
			"{ODObjects}TextPart.cpp.o" 
			"{ODObjects}TextFrame.cpp.o" 
			"{ODObjects}RulerFrame.cpp.o" 
			"{ODObjects}TextFacet.cpp.o" 
			"{ODObjects}RulerFacet.cpp.o" 
			"{ODObjects}TextUtil.cpp.o" 
			"{ODObjects}EmbedRun.cpp.o" 
			"{ODObjects}TextProxy.cpp.o" 
			"{ODObjects}ValueStream.cpp.o" 
			"{ODObjects}TextSelc.cpp.o" 
			"{ODObjects}ODText.cpp.o" 
			"{ODObjects}GrfxRun.cpp.o" 
			"{ODObjects}StyleInfo.cpp.o"
					
TextPartSOURCEFILES = 
			"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFrame.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFacet.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:EmbedRun.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:TextProxy.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:ValueStream.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:TextSelc.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.cpp 
			"{ODProjectDir}"Quality:QFramework:QTextPart:StyleInfo.cpp

TextPartLibASLMObjects = 
			"{ODObjects}XMPConst.cpp.o" 
			"{ODObjects}OperatorNewLib.o" 
			"{ODObjects}TextPartLibASLM.cl.o" 
			"{ODObjects}UtilitiesLibASLM.cl.o" 
			"{ODObjects}CoreLibASLM.cl.o" 
			"{ODObjects}StorageLibASLM.cl.o" 
			"{ODObjects}BentoLibASLM.cl.o" 
			"{ODObjects}LayoutLibASLM.cl.o" 
			"{ODObjects}ImagingLibASLM.cl.o" 
			"{ODObjects}MessagingLibASLM.cl.o" 
			"{ODObjects}UILibASLM.cl.o" 
			"{ODObjects}FrameworkLibASLM.cl.o" 
			"{ODObjects}FrameworkLib.o" 
			"{Libraries}LibraryManager.debug.o" 
			"{ODProjectDir}"Quality:QFramework:QTextPart:Textension:TextensionLib.o 
			"{CLibraries}CPlusLib.o" 
			"{CLibraries}StdCLib.o" 
			"{Libraries}Interface.o" 
			"{Libraries}Runtime.o"

# REZ STEP

"{ODObjects}"TextPartLib.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.r 
								"{ODRezIntfDir}StdTypes.r" 
								"{ODCPlusIntfDir}StdDefs.h"
	Echo Rezzing: {NewerDeps}
	Rez {GRezOptions} {NewerDeps} -i "{ODCPlusIntfDir}" -a -o {Targ}

###########################################################################
# ROOT TARGETS
###########################################################################

# BUILD LIBRARIES

BuildCF  "{ODObjects}"TextPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildSC  "{ODObjects}"TextPartLib.o
	Echo -n "" > "{MPW}"ODAppName

BuildCFASLM  "{ODBinaryDir}TextPartLibASLM"
	Echo -n "" > "{MPW}"ODAppName

clean 
	delete -y -i {TextPartOBJECTS} "{ODObjects}"TextPart.rsrc

"{ODObjects}"TextPartLib.o  {TextPartOBJECTS}
	Echo Libing: {Targ}
	Lib {LibOptions} {Deps} -o {Targ}

"{ODObjects}TextPartLibASLM.cl.o"  
		"{ODObjects}TextPartLib".o 
		"{ODProjectDir}"Quality:QFramework:QTextPart:TextPartLibASLM.exp
	Echo Building: {Targ}
	BuildSharedLibrary 
			{TextPartIncludes} 
			{BuildSharedLibraryOptions} 
			-exp "{ODProjectDir}"Quality:QFramework:QTextPart:TextPartLibASLM.exp 
			-obj "{ODObjects}TextPartLibASLM" 
			-far "{ODObjects}TextPartLibASLM.cl.o" 
			"{ODObjects}TextPartLib.o"

"{ODBinaryDir}TextPartLibASLM"  {TextPartLibASLMObjects}
	Echo Linking: {Targ}
	LinkSharedLibrary 
			-lib "{ODBinaryDir}TextPartLibASLM" 
			-obj "{ODObjects}TextPartLibASLM" 
			-symFile "{ODBinaryDir}TextPartLibASLM.SYM" 
			{LinkSharedLibraryOptions} 
			{TextPartLibASLMObjects}

"{ODBinaryDir}TextPartLibASLM"  {TextPartLibASLMObjects}
	Echo Copying Resources From: {ODObjects}TextPartLib.o
	Echo "include "{ODObjects}TextPartLib.o";" | Rez -a -o {Targ}

# UPDATING DEPENDENCIES

MakeDepend 
	MakeDepend												
		-append "{MAKEFILE}"								
		-objdir "{ODObjects}"								
		{MakeDependIncludeDirs}								
		{MakeDependMacros}									
		-t	"{ODBinaryDir}"DummyTarget					
		{TextPartSOURCEFILES}

#*** Dependencies: Cut here ***

# This makefile was produced at 8:00:01 on Wed, Dec 15, 1993 by
# ObjectMaster

"{ODObjects}"EmbedRun.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:EmbedRun.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:EmbedRun.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextProxy.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextSelc.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ValueStream.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.h

"{ODObjects}"ODText.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:ODText.cpp 
	"{ODProjectDir}"Quality:QFramework:QTextPart:EmbedRun.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.h

"{ODObjects}"RulerFacet.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:RulerFacet.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.h

"{ODObjects}"RulerFrame.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:RulerFrame.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h

"{ODObjects}"TextFacet.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextSelc.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.h

"{ODObjects}"TextFrame.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:StyleInfo.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.h

"{ODObjects}"TextPart.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:EmbedRun.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:RulerFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:StyleInfo.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextProxy.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextSelc.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ValueStream.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.h

"{ODObjects}"TextProxy.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextProxy.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextProxy.h

"{ODObjects}"TextSelc.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextSelc.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWProxy.h 
	"{ODProjectDir}"Quality:QFramework:FWSelect.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:EmbedRun.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextProxy.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextSelc.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ValueStream.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.h

"{ODObjects}"TextUtil.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.cpp 
	"{ODProjectDir}"Quality:QFramework:FWBaseFr.h 
	"{ODProjectDir}"Quality:QFramework:FWDropTr.h 
	"{ODProjectDir}"Quality:QFramework:FWEventH.h 
	"{ODProjectDir}"Quality:QFramework:FWFacet.h 
	"{ODProjectDir}"Quality:QFramework:FWFrame.h 
	"{ODProjectDir}"Quality:QFramework:FWFrming.h 
	"{ODProjectDir}"Quality:QFramework:FWPart.h 
	"{ODProjectDir}"Quality:QFramework:FWParting.h 
	"{ODProjectDir}"Quality:QFramework:FWUtil.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ODText.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextDef.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFacet.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextFrame.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextPart.h 
	"{ODProjectDir}"Quality:QFramework:QTextPart:TextUtil.h

"{ODObjects}"ValueStream.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:ValueStream.cpp 
	"{ODProjectDir}"Quality:QFramework:QTextPart:ValueStream.h

"{ODObjects}"GrfxRun.cpp.o  "{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.cpp 
	"{ODProjectDir}"Quality:QFramework:QTextPart:GrfxRun.h

