/*
	File:		TextProxy.h

	Contains:	Definition for class CTextProxyRun

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _TEXTPROXY_
#define _TEXTPROXY_

#ifndef _FWPROXY_
#include "FWProxy.h"
#endif


//==============================================================================
// Forward class declarations
//==============================================================================

class XMPPart;
class XMPFrame;
class XMPTransform;
class CEmbeddingPart;
class CTextPart;


//==============================================================================
// CLASS CTextProxyRun
//==============================================================================

class CTextProxyRun : public CProxyRun
{
// ----- Construct/destruct/initialize
public:
	CTextProxyRun();
	void InitTextProxyRun(CEmbeddingPart* embeddingPart);
	virtual ~CTextProxyRun();

// ----- from CProxyRun
public:
	virtual void UsedShapeChanged(XMPFrame* xmpFrame);
	virtual void GetFacetExternalTransform(XMPFrame* xmpFrame,
										   XMPTransform* facetTransform);
	virtual void SetSelectState(XMPBoolean state);

// ----- New methods and fields
public:
	void		SetBoundingBox(const Rect& rect);
	void		GetBoundingBox(Rect& rect) const;
	
private:
	Rect		fBoundingBox;
};

#endif
