/*
	File:		ValueStream.h

	Contains:	Definition for class CValueStream

	Written by:	Mike Burbidge

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef _VALUESTREAM_
#define _VALUESTREAM_

#ifndef _ALTPOINT_			// Just to be sure to be included before PlfmType.h
#include "AltPoint.h"
#endif

#ifndef _Streams_
#include "Streams.h"
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class XMPStorageUnit;


//========================================================================================
// CLASS CValueStream
//========================================================================================

class	CValueStream	:	public CStream
{
public:
	CValueStream();
	
	void InitValueStream(XMPStorageUnit *su);
	virtual ~CValueStream();
	
	virtual OSErr WriteBytes(const void* theBytes, long bytesCount);
	virtual OSErr ReadBytes(void* theBytes, long bytesCount);
	
	virtual long GetPosition() const;
	virtual void SetPosition(long newPosition);
	virtual void Skip(long count);

	virtual long GetSize() const;
	
	virtual OSErr Append(long count);
		// Appends "count" bytes at the end of the stream, position is not changed
		
	virtual void Empty();
	
	virtual OSErr Load(long size, Ptr* data);
		//fPosition is advanced by "size"
		
	virtual void Unload(Ptr data);
		//should be called even if "Load" returns an error

// ----- New API
public:
	XMPStorageUnit *GetStorageUnit()
		{ return fSU; }

private:
	XMPStorageUnit *fSU;
};

#endif
