/*
	File:		DragPart.r

	Contains:	NMAP resource for DragPart

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <8>	 3/18/94	CC		Removed user string definitions for
									Apple:OSType:Scrap:TEXT and
									Apple:OSType:Scrap:stly.  (1151640)
		 <7>	 3/14/94	CC		TEMPORARY changes to define user strings
									for Apple:OSType:Scrap:TEXT and
									Apple:OSType:Scrap:stly.  (1144421)
		 <6>	 3/11/94	CG		Bug #1150241 - changed smSystemScript to
									smRoman and smScriptLang to langEnglish.
		 <5>	  2/8/94	JA		Moved 'kNMAPIDxx' consts here from
									DragDef.h
		 <4>	 1/18/94	CG		Added new NMAP, changed format of NMAPs.
		 <3>	 1/14/94	CG		Added NMAPs for user strings.
		 <2>	 1/12/94	CG		Updated NMAP resources.
		 <1>	 12/6/93	CG		first checked in
	To Do:
*/


#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#ifndef __STDTYPES_R__
	#include "StdTypes.r"
#endif __STDTYPES_R__

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

#ifndef _DRAGDEF_
	#include "DragDef.h"
#endif _DRAGDEF_

#ifdef ASLMBUILD
#define kNMAPid1 kNMAPid+1
#define kNMAPid2 kNMAPid+2
#define kNMAPid3 kNMAPid+3
#define kNMAPid4 kNMAPid+4
#define kNMAPid5 kNMAPid+5
#define kNMAPid6 kNMAPid+6
#else
#define kNMAPid1 kNMAPid+7
#define kNMAPid2 kNMAPid+8
#define kNMAPid3 kNMAPid+9
#define kNMAPid4 kNMAPid+10
#define kNMAPid5 kNMAPid+11
#define kNMAPid6 kNMAPid+12
#endif ASLMBUILD


resource kNameMappings (kNMAPid1) {
	kXMPKind,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPKindTestDrag,
		kXMPIsAnISOStringList {
			/* array ValueList: 1 elements */
			/* [1] */
			{
				kXMPCategoryText
			}
		}
	}
};


resource kNameMappings (kNMAPid2) {
	kXMPEditorKinds,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kDragPartID,
		kXMPIsAnISOStringList {
			/* array ValueList: 3 elements */
			{
				/* [1] */
				kXMPKindTestDrag,
				/* [2] */
				"Apple:OSType:Scrap:TEXT",	/* $$$$$ ISO kinds should not be hard coded */
				/* [3] */
				"Apple:OSType:Scrap:styl"	/* $$$$$ ISO kinds should not be hard coded */
			}
		}
	}
};

resource kNameMappings (kNMAPid3) {
	kXMPEditorUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kDragPartID,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kDragEditorUserString
		}
	}
};

resource kNameMappings (kNMAPid4) {
	kXMPKindUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPKindTestDrag,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kDragKindUserString
		}
	}
};

resource kNameMappings (kNMAPid5) {
	kXMPCategoryUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPCategoryText,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kDragCategoryUserString
		}
	}
};

resource kNameMappings (kNMAPid6) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPKindTestDrag,
		kXMPIsMacOSType {
			kDragOSType
		}
	}
};

