/*
	File:		DrawPart.r

	Contains:	Resources for DrawPart

	Written by:	Caia Grisar

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<10>	 3/17/94	CG		#1151392: Moved kOpenDocShellSignature from
									ContsDef.h to StdDefs.h
		 <9>	 3/11/94	CG		Bug #1150241 - changed smSystemScript to
									smRoman and smScriptLang to langEnglish.
		 <8>	  2/8/94	JA		Moved 'kNMAPIDxx' consts here from
									DrawDef.h
		 <7>	 1/29/94	NP		Changed hard-coded reference to use
									constant.
		 <6>	 1/20/94	SS		Added icon suites, BNDL, and FREF
		 <5>	 1/18/94	CG		Added new NMAP, changed format of NMAPs.
		 <4>	 1/14/94	CG		Added NMAP for user strings.
		 <3>	 1/12/94	CG		Updated NMAP resources.
		 <2>	 12/6/93	CG		Added include for DrawDef.h
		 <1>	11/18/93	CG		first checked in
	To Do:
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"

#ifndef __STDTYPES_R__
	#include "StdTypes.r"
#endif __STDTYPES_R__

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

#ifndef _DRAWDEF_
	#include "DrawDef.h"
#endif _DRAWDEF_

#ifdef ASLMBUILD
#define kNMAPid1 kNMAPid+1
#define kNMAPid2 kNMAPid+2
#define kNMAPid3 kNMAPid+3
#define kNMAPid4 kNMAPid+4
#define kNMAPid5 kNMAPid+5
#define kNMAPid6 kNMAPid+6
#else
#define kNMAPid1 kNMAPid+1
#define kNMAPid2 kNMAPid+2
#define kNMAPid3 kNMAPid+3
#define kNMAPid4 kNMAPid+4
#define kNMAPid5 kNMAPid+5
#define kNMAPid6 kNMAPid+6
#endif ASLMBUILD

resource kNameMappings (kNMAPid1) {
	kXMPKind,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPKindTestDraw,
		kXMPIsAnISOStringList {
			/* array ValueList: 1 elements */
			/* [1] */
			{
				kXMPCategoryGraphics
			}
		}
	}
};


resource kNameMappings (kNMAPid2) {
	kXMPEditorKinds,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kDrawPartID,
		kXMPIsAnISOStringList {
			/* array ValueList: 1 elements */
			/* [1] */
			{
				kXMPKindTestDraw
			}
		}
	}
};

resource kNameMappings (kNMAPid3) {
	kXMPEditorUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kDrawPartID,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kDrawEditorUserString
		}
	}
};

resource kNameMappings (kNMAPid4) {
	kXMPKindUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPKindTestDraw,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kDrawKindUserString
		}
	}
};

resource kNameMappings (kNMAPid5) {
	kXMPCategoryUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPCategoryGraphics,
		kXMPIsINTLText {
			kXMPRomanScript,
			kXMPEnglishLang,
			kDrawCategoryUserString
		}
	}
};

resource kNameMappings (kNMAPid6) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kXMPKindTestDraw,
		kXMPIsMacOSType {
			kDrawOSType
		}
	}
};

resource 'BNDL' (90) {
	kOpenDocShellSignature,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF', { 0, 90 },
		/* [2] */
		'ICN#', { 0, 90 }
	}
};

resource 'FREF' (90) { kDrawOSType, 0, "" };

resource 'icl8' (90) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0 B0B0"
	$"9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9F9F 9FFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 0505 0505 0505 0505"
	$"ECEC ECEC ECEC ECEC ECEC ECEC ECEC ECFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ICN#' (90) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF A222 A223 8000 C445 8888 8889"
		$"8000 9111 A222 A223 8000 C445 8888 8889"
		$"8000 9111 A222 A223 8000 C445 8888 8889"
		$"8000 9111 A222 A223 8000 C445 FFFF FFFF"
		$"8080 8889 9010 C445 8202 A223 A020 8001"
		$"8101 8889 8808 9111 C040 A223 8404 8001"
		$"8080 8889 9010 C445 8202 A223 A020 8001"
		$"8101 8889 8808 9111 C040 A223 FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'icl4' (90) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F555 5555 5555 5555 DDDD DDDD DDDD DDDF"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"F111 1111 1111 1111 6666 6666 6666 666F"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ics8' (90) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FFB0 B0B0 B0B0 B0B0 9F9F 9F9F 9F9F 9FFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FF05 0505 0505 0505 ECEC ECEC ECEC ECFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ics4' (90) {
	$"FFFF FFFF FFFF FFFF F555 5555 DDDD DDDF"
	$"F555 5555 DDDD DDDF F555 5555 DDDD DDDF"
	$"F555 5555 DDDD DDDF F555 5555 DDDD DDDF"
	$"F555 5555 DDDD DDDF F555 5555 DDDD DDDF"
	$"F111 1111 6666 666F F111 1111 6666 666F"
	$"F111 1111 6666 666F F111 1111 6666 666F"
	$"F111 1111 6666 666F F111 1111 6666 666F"
	$"F111 1111 6666 666F FFFF FFFF FFFF FFFF"
};

resource 'ics#' (90) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF AAAB D5D5 AAAB D5D5 AAAB D5D5 FFFF"
		$"CCAB D5D5 B3FF AAD5 CCAB D5D5 B3FF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

