/*
	File:		DigitalSignature.h

	Copyright:	 1984-1993 by Apple Computer, Inc., all rights reserved.

	WARNING
	This file was auto generated by the interfacer tool. Modifications
	must be made to the master file.

*/

#ifndef __DIGITALSIGNATURE__
#define __DIGITALSIGNATURE__

#ifndef __FILES__
#include <Files.h>
/*	#include <Types.h>											*/
/*		#include <ConditionalMacros.h>							*/
/*		#include <MixedMode.h>									*/
/*			#include <Traps.h>									*/
/*	#include <OSUtils.h>										*/
/*	#include <SegLoad.h>										*/
#endif

#ifndef __MEMORY__
#include <Memory.h>
#endif

#ifndef __TYPES__
#endif

#define __DigitalSignature(count, selector) = { 0x203C, count, selector, 0xAA5D}

#define kSIGNewContext 1900

#define kSIGDisposeContext 1901

#define kSIGSignPrepare 1902

#define kSIGSign 1903

#define kSIGVerifyPrepare 1904

#define kSIGVerify 1905

#define kSIGDigestPrepare 1906

#define kSIGDigest 1907

#define kSIGProcessData 1908

#define kSIGShowSigner 1909

#define kSIGGetSignerInfo 1910

#define kSIGGetCertInfo 1911

#define kSIGGetCertNameAttributes 1912

#define kSIGGetCertIssuerNameAttributes 1913

#define kSIGFileIsSigned 2500

#define kSIGSignFile 2501

#define kSIGVerifyFile 2502

enum  {
	kSIGCountryCode,
	kSIGOrganization,
	kSIGStreetAddress,
	kSIGState,
	kSIGLocality,
	kSIGCommonName,
	kSIGTitle,
	kSIGOrganizationUnit,
	kSIGPostalCode
};

typedef unsigned short SIGNameAttributeType;

enum  {
	kSIGValid,
	kSIGPending,
	kSIGExpired,
	kSIGInvalid
};

typedef unsigned short SIGCertStatus;

typedef unsigned short SIGSignatureStatus;

#define gestaltDigitalSignatureVersion 'dsig'

#define kSIGDigestSize 16

typedef Byte SIGDigestData[16], *SIGDigestDataPtr;

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct SIGCertInfo {
	unsigned long				startDate;
	unsigned long				endDate;
	SIGCertStatus				certStatus;
	unsigned long				certAttributeCount;
	unsigned long				issuerAttributeCount;
	Str255						serialNumber;
};
#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif

typedef struct SIGCertInfo SIGCertInfo;

typedef SIGCertInfo *SIGCertInfoPtr;

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct SIGSignerInfo {
	unsigned long				signingTime;
	unsigned long				certCount;
	unsigned long				certSetStatusTime;
	SIGSignatureStatus			signatureStatus;
};
#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif

typedef struct SIGSignerInfo SIGSignerInfo;

typedef SIGSignerInfo *SIGSignerInfoPtr;

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct SIGNameAttributesInfo {
	Boolean						onNewLevel;
	SIGNameAttributeType		attributeType;
	ScriptCode					attributeScript;
	Str255						attribute;
};
#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif

typedef struct SIGNameAttributesInfo SIGNameAttributesInfo;

typedef SIGNameAttributesInfo *SIGNameAttributesInfoPtr;

typedef Ptr SIGContextPtr;

typedef Ptr SIGSignaturePtr;

#define kSIGSignerCertIndex 0

typedef pascal Boolean (*SIGStatusProcPtr)(void);

enum {
	uppSIGStatusProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
};

#if USESROUTINEDESCRIPTORS
typedef UniversalProcPtr SIGStatusUPP;

#define CallSIGStatusProc(userRoutine)		\
		CallUniversalProc((UniversalProcPtr)(userRoutine), uppSIGStatusProcInfo)
#define NewSIGStatusProc(userRoutine)		\
		(SIGStatusUPP) NewRoutineDescriptor((ProcPtr)(userRoutine), uppSIGStatusProcInfo, GetCurrentISA())
#else
typedef SIGStatusProcPtr SIGStatusUPP;

#define CallSIGStatusProc(userRoutine)		\
		(*(userRoutine))()
#define NewSIGStatusProc(userRoutine)		\
		(SIGStatusUPP)(userRoutine)
#endif

#define kSIGSignatureIconResID -16800

#define kSIGValidSignatureIconResID -16799

#define kSIGInvalidSignatureIconResID -16798

#ifdef __cplusplus
extern "C" {
#endif

extern pascal OSErr SIGNewContext(SIGContextPtr *context)
 FOURWORDINLINE(0x203C, 2, 1900, 0xAA5D);
extern pascal OSErr SIGDisposeContext(SIGContextPtr context)
 FOURWORDINLINE(0x203C, 2, 1901, 0xAA5D);
extern pascal OSErr SIGSignPrepare(SIGContextPtr context, const FSSpec *signerFile, ConstStr255Param prompt, Size *signatureSize)
 FOURWORDINLINE(0x203C, 8, 1902, 0xAA5D);
extern pascal OSErr SIGSign(SIGContextPtr context, SIGSignaturePtr signature, SIGStatusUPP statusProc)
 FOURWORDINLINE(0x203C, 6, 1903, 0xAA5D);
extern pascal OSErr SIGVerifyPrepare(SIGContextPtr context, SIGSignaturePtr signature, Size signatureSize, SIGStatusUPP statusProc)
 FOURWORDINLINE(0x203C, 8, 1904, 0xAA5D);
extern pascal OSErr SIGVerify(SIGContextPtr context)
 FOURWORDINLINE(0x203C, 2, 1905, 0xAA5D);
extern pascal OSErr SIGDigestPrepare(SIGContextPtr context)
 FOURWORDINLINE(0x203C, 2, 1906, 0xAA5D);
extern pascal OSErr SIGDigest(SIGContextPtr context, SIGDigestData digest)
 FOURWORDINLINE(0x203C, 4, 1907, 0xAA5D);
extern pascal OSErr SIGProcessData(SIGContextPtr context, const void *data, Size dataSize)
 FOURWORDINLINE(0x203C, 6, 1908, 0xAA5D);
extern pascal OSErr SIGShowSigner(SIGContextPtr context, ConstStr255Param prompt)
 FOURWORDINLINE(0x203C, 4, 1909, 0xAA5D);
extern pascal OSErr SIGGetSignerInfo(SIGContextPtr context, SIGSignerInfo *signerInfo)
 FOURWORDINLINE(0x203C, 4, 1910, 0xAA5D);
extern pascal OSErr SIGGetCertInfo(SIGContextPtr context, unsigned long certIndex, SIGCertInfo *certInfo)
 FOURWORDINLINE(0x203C, 6, 1911, 0xAA5D);
extern pascal OSErr SIGGetCertNameAttributes(SIGContextPtr context, unsigned long certIndex, unsigned long attributeIndex, SIGNameAttributesInfo *attributeInfo)
 FOURWORDINLINE(0x203C, 8, 1912, 0xAA5D);
extern pascal OSErr SIGGetCertIssuerNameAttributes(SIGContextPtr context, unsigned long certIndex, unsigned long attributeIndex, SIGNameAttributesInfo *attributeInfo)
 FOURWORDINLINE(0x203C, 8, 1913, 0xAA5D);
extern pascal OSErr SIGFileIsSigned(const FSSpec *fileSpec)
 FOURWORDINLINE(0x203C, 2, 2500, 0xAA5D);
extern pascal OSErr SIGSignFile(SIGContextPtr context, Size signatureSize, const FSSpec *fileSpec, SIGStatusUPP statusProc)
 FOURWORDINLINE(0x203C, 8, 2501, 0xAA5D);
extern pascal OSErr SIGVerifyFile(SIGContextPtr context, const FSSpec *fileSpec, SIGStatusUPP statusProc)
 FOURWORDINLINE(0x203C, 6, 2502, 0xAA5D);
#ifdef __cplusplus
}
#endif

#endif

