/*
	File:		DgItmItr.h

	Contains:	Class definition for DragItem.
	
	Written by:	Vincent Lo

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <2>	  2/9/94	T		made destructor explicitly virtual to
									pacify ASLM
		 <1>	  2/4/94	VL		first checked in

	To Do:
*/

#ifndef _DGITMITR_
#define _DGITMITR_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//=====================================================================================
// Classes defined in this interface
//=====================================================================================
class XMPDragItemIterator;

//=====================================================================================
// Classes used by this interface
//=====================================================================================
class XMPStorageUnit;
class LinkedListIterator;

//=====================================================================================
// XMPDragItemIterator
//=====================================================================================

#define kXMPDragItemIteratorID "appl:xmpdragitemiterator$class,1.0.0"

class XMPDragItemIterator
{
	ASLM_COMPATIBLE

public:

	XMPDragItemIterator(LinkedListIterator* dragItemListIter);
	
	virtual	~ CDECL XMPDragItemIterator();
	
	XMPMethod	XMPStorageUnit*	First();
	XMPMethod	XMPStorageUnit*	Next();
	XMPMethod	XMPBoolean		IsNotComplete();
	
private:

	LinkedListIterator *fDragItemListIter;
};

#endif	// _DGITMITR_