/*
	File:		Foci.h

	Contains:	Declarations of standard Foci for the Macintosh. (Defined in StdConst.cpp)

	Written by:	Richard Rodseth

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	  3/1/94	JA		Made string consts extern. (1147295)
		 <3>	  2/9/94	NP		Tiger Team cleanup.
		 <2>	  2/7/94	NP		Tiger Team doings.
		 <1>	 1/25/94	RR		first checked in

	To Do:
*/


#ifndef _FOCI_
#define _FOCI_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

// Focus Types for the Arbitrator. 
// These strings are tokenized using XMPSession::Tokenize()

extern const XMPTypeToken kXMPNullFocus ; 		// = 0;	// Returned by iterators. Ignored	
extern const XMPFocusType kXMPKeyFocus ; 		// = "Key";	
extern const XMPFocusType kXMPMenuFocus ; 		// = "Menu";	
extern const XMPFocusType kXMPSelectionFocus ; 	// = "Selection";	
extern const XMPFocusType kXMPModalFocus ; 		// = "Modal";	
extern const XMPFocusType kXMPScrollingFocus ; 	// = "Scrolling";	

#endif // _FOCI_