/*
	File:		FocusSet.h

	Contains:	Interface to XMPFocusSet class

	Written by:	Richard Rodseth

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <7>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <6>	  2/9/94	NP		Tiger Team cleanup.
		 <5>	  2/7/94	NP		Tiger Team doings.
		 <4>	 1/10/94	RR		Added CreateIterator
		 <3>	12/23/93	RR		Added InitFocusSet
		 <2>	12/22/93	RR		XMPMethod usage
		 <1>	 12/8/93	RR		first checked in

	To Do:
*/

#ifndef _FOCUSSET_
#define _FOCUSSET_

#ifndef _XMPOBJ_
#include "XMPObj.h"
#endif

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif


//=====================================================================================
// Classes defined in this interface
//=====================================================================================

class XMPFocusSet;				

//=====================================================================================
// Classes used by this interface
//=====================================================================================

class XMPFocusSetIterator;
class LinkedList;

//=====================================================================================
// XMPFocusSet
//=====================================================================================

#define kXMPFocusSetID "appl:xmpfocusset$class,1.0.0"

class XMPFocusSet
{
	ASLM_COMPATIBLE

  public:

	XMPFocusSet();
		
	virtual ~ CDECL XMPFocusSet();
	
	XMPNVMethod void InitFocusSet();
	
	XMPMethod void Add(XMPTypeToken focus);
	
	XMPMethod void Remove(XMPTypeToken focus);

	XMPMethod XMPBoolean Contains(XMPTypeToken focus);
	
	XMPMethod XMPFocusSetIterator* CreateIterator();
	
  public: // to XMPFocusSetIterator only

	LinkedList*	GetImplementation();

  private:
	
	LinkedList* fImplementation;
};

#endif // _FOCUSSET_