/*
	File:		NmSpcMgM.h

	Contains:	Definition of XMPMacNameSpaceManager class

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <3>	  2/3/94	CG		System Session break out changes.
		 <2>	 1/29/94	NP		XMPMethod changes and change to parameters
									of CreateNameSpace.
		 <1>	 1/14/94	CG		first checked in
	To Do:
*/

#ifndef _NMSPCMGM_
#define _NMSPCMGM_

//==============================================================================
// Classes defined in this interface
//==============================================================================

class XMPMacNameSpaceManager;

//==============================================================================
// Classes used by this interface
//==============================================================================

class XMPMacNameSpace;
class XMPStringHashTable;
class XMPBaseSession;

//==============================================================================
// XMPMacNameSpaceManager
//==============================================================================

#define kXMPMacNameSpaceManagerID "appl:xmpmacnamespacemanager$class,1.0.0"

class XMPMacNameSpaceManager : public XMPAbsNameSpaceManager
{
	ASLM_COMPATIBLE

  public:

	XMPMacNameSpaceManager();
	XMPNVMethod void InitNameSpaceManager(XMPBaseSession* session, XMPHeap heap);
	XMPVMethod ~ CDECL XMPMacNameSpaceManager();
	
	XMPVMethod XMPNameSpace*	CreateNameSpace(XMPISOStr		spaceName,
												XMPNameSpace*	inheritsFrom,
												XMPULong		numExpectedEntries);

	XMPVMethod void				DeleteNameSpace(XMPNameSpace* theNameSpace);

	XMPVMethod XMPNameSpace*	HasNameSpace(XMPISOStr spaceName);

	XMPVMethod XMPSize			Purge(XMPSize howMuch);
	
 private:

	XMPStringHashTable*	fNameSpaceTable;
	XMPBaseSession*		fSession;
	XMPHeap				fHeap;
};

#endif // _NMSPCMGM_