/*
	File:		PfTLItr.h.h

	Contains:	Class definition for XMPPlatformTypeListIterator.

	Written by:	Vincent Lo

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	  4/4/94	CC		first checked in

		------------------- CC ---- Renamed from PfTSItr.h

		 <5>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <4>	 2/17/94	CC		#1144818 - Added declaration of class
									XMPPlatformTypeSet to enable standalone
									compilation.
		 <3>	 2/15/94	CC		Bug #1142949 - Standardize iterator method
									names.
		 <2>	  2/9/94	T		made destructor explicitly virtual to
									pacify ASLM
		 <1>	  2/4/94	VL		first checked in

	To Do:

*/

#ifndef _PFTLITR_
#define _PFTLITR_

#ifndef _PLFMTYPE_
#include "PlfmType.h"
#endif

//=====================================================================================
// Classes defined in this interface
//=====================================================================================
class XMPPlatformTypeListIterator;

//=====================================================================================
// Classes used by this interface
//=====================================================================================
class XMPPlatformTypeList;
class OrderedCollectionIterator;

//=====================================================================================
// Class XMPPlatformTypeListIterator
//=====================================================================================

#define kXMPPlatformTypeListIteratorID "appl:xmpplatformtypelistiterator$class,1.0.0"

class XMPPlatformTypeListIterator
{
	ASLM_COMPATIBLE

public:

	XMPPlatformTypeListIterator(XMPPlatformTypeList* typeList);

	virtual ~ CDECL XMPPlatformTypeListIterator();

	XMPMethod XMPPlatformType	First();
	XMPMethod XMPPlatformType	Next();
	XMPMethod XMPBoolean		IsNotComplete();
		
private:

	XMPPlatformTypeList*		fPlatformTypeList;
	OrderedCollectionIterator*	fIterator;
};


#endif	// _PFTLITR_