/*
	File:		PlfmDef.h

	Contains:	Platform specific definitions

	Written by:	Vincent Lo

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<26>	 3/28/94	CG		1153547: Defined XMPSession as
									XMPMacSession.
		<25>	  2/7/94	JA		Define ppcinterfaces for benefit of GX
									headers.
		<24>	  2/1/94	JA		Added PLATFORM_MACINTOSH.
		<23>	 1/21/94	CC		Added XMPMacLinkSource.
		<22>	12/15/93	NP		Added XMPMacUndo.
		<21>	12/14/93	VL		Added XMPNVMethod.
		<20>	 12/8/93	RR		Removed XMPWindowIterator
		<19>	11/15/93	NP		Changed XMPSymbols to XMPNameSpaceManager.
		<18>	11/12/93	JBS		added XMPFacet, removed XMPLayout*
		<17>	11/10/93	CC		Added define for XMPLinkSpec
		<16>	 9/10/93	RR		Added XMPMenuBar
		<15>	  9/3/93	JBS		added XMPLayoutFrameIterator
		<15>	 8/20/93	JBS		Added XMPLayout
		<14>	 7/21/93	NP		Added pascal and static #defines.
		<13>	  7/6/93	JBS		Added XMPCanvas, XMPShape, XMPTransform
		<12>	  7/6/93	PH		Add XMPStorageSystem
		<11>	  7/2/93	CG		Added SemtIntf, MssgIntf, NamRslvr.
		<10>	  7/2/93	NP		Added NamSpace.
		 <9>	  7/1/93	VL		Added XMPClipboard, XMPDragAndDrop,
									XMPTranslation.
		 <8>	  7/1/93	NP		Added XMPLink to #defines.
		 <6>	 6/29/93	RCR		Added Define for XMPMacWindow.
		 <5>	 6/24/93	RCR		Added Define for XMPMacDispatcher.
		 <4>	 6/17/93	VL		Changed XMPUnused.
		 <3>	 4/29/93	VL		8.3 Name Change.
		 <2>	 4/12/93	VL		Added XMPUnused.
		 <1>	  4/6/93	VL		first checked in

	To Do:
*/

#ifndef _PLFMDEF_
#define _PLFMDEF_

//==============================================================================
// Configuration
//==============================================================================

#define PLATFORM_MACINTOSH 1	/* This is the Mac implementation */

// The QuickDraw GX headers want this symbol to be defined if the universal
// interfaces are being used.
#ifndef ppcinterfaces
#define ppcinterfaces 1
#endif

//==============================================================================
// Macros
//==============================================================================

#define	XMPMethod	virtual	
#define XMPVMethod	virtual
#define XMPNVMethod
#define XMPPascal	pascal
#define XMPStatic	static

//------------------------------------------------------------------------------
//
// XMPUnused is for parameters not used in a function. It is similar to 
// #pragma unused. As a matter of fact, XMPUnused can be a pragma statement
// when it functions correctly in C++. For the time being, we have this little 
// macro to get rid of the compiler warnings. Please use this macro instead of
// commenting out the parameter name.

#define XMPUnused(x)	((void) &x)

#define XMPDispatcher 			XMPMacDispatcher
#define XMPWindow 				XMPMacWindow
#define XMPMenuBar 				XMPMacMenuBar
#define XMPDragAndDrop 			XMPMacDragAndDrop
#define XMPTranslation 			XMPMacTranslation
#define XMPClipboard 			XMPMacClipboard
#define XMPStorageSystem		XMPMacStorageSystem
#define XMPWindowState 			XMPMacWindowState
#define XMPLink 				XMPMacLink
#define XMPLinkSource 			XMPMacLinkSource
#define XMPLinkSpec 			XMPMacLinkSpec
#define XMPNameSpace 			XMPMacNameSpace
#define XMPNameSpaceManager 	XMPMacNameSpaceManager
#define XMPValueIterator 		XMPMacValueIterator
#define XMPSemanticInterface	XMPMacSemanticInterface
#define XMPMessageInterface		XMPMacMessageInterface
#define XMPNameResolver			XMPMacNameResolver
#define XMPCanvas				XMPMacCanvas
#define XMPShape				XMPMacShape
#define XMPTransform			XMPMacTransform
#define XMPFacet				XMPMacFacet
#define XMPUndo					XMPMacUndo
#define XMPSession				XMPMacSession

#endif	// _PLFMDEF_
