/*
	File:		Polygon.h

	Contains:	OpenDoc polygon data structure

	Written by:	Jens Alfke

	Copyright:	 1993-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 2/17/94	JA		first checked in
		----------------------------Ripped out methods, moved to CPlusPlus.
		 <6>	 2/16/94	JA		Stop including Point.h.
		 <5>	  2/8/94	JA		Include <FixMath.h> before GX header to
									avoid conflicts.
		 <4>	  2/7/94	JA		Only declare Mac-specific methods if on Mac
									platform.
		 <3>	  2/3/94	JA		Tiger Team Makeover!
		 <2>	 1/31/94	JA		Added Contains and AsQDRegion and improved
									New methods.
		 <1>	11/29/93	JA		first checked in
		----------------------------Moved from Utilities to Imaging project
		 <4>	11/24/93	VL		Rolled back changes as ASLM build breaks
									the THINK build.
		 <3>	11/23/93	VL		Made this work with ASLM.
		 <2>	11/23/93	VL		Added ASLM string.
		 <1>	11/23/93	JA		first checked in

	To Do:
*/


#ifndef _POLYGON_
#define _POLYGON_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//==============================================================================
// XMPContour
//==============================================================================

struct XMPContour {
	XMPSLong	nVertices;					// Variable-size struct:
	XMPPoint	vertex[1];					// Array size is actually nVertices
};

//==============================================================================
// XMPPolygon
//==============================================================================

struct XMPPolygon {
	XMPSLong	nContours;					// Variable-size struct:
	XMPContour	firstContour;				// Rest of contours follow after first
};

#endif //_POLYGON_