/*
	File:		RegObjIt.h

	Contains:	Iterator for objects registered with XMPSession::RegisterObject.

	Written by:	Nick Pilch

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 3/26/94	NP		first checked in

	To Do:
*/

#ifndef _REGOBJIT_
#define _REGOBJIT_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

//==============================================================================
// Theory of Operation
//==============================================================================

/*
	This iterator can be used to iterate over objects registered with
	XMPSession::RegisterObject.
*/

//==============================================================================
// Constants
//==============================================================================

//==============================================================================
// Scalar Types
//==============================================================================

//==============================================================================
// Classes defined in this interface
//==============================================================================

class XMPRegisteredObjectIterator;

//==============================================================================
// Classes used by this interface
//==============================================================================

class XMPPersistentObject;

//==============================================================================
// XMPClass
//==============================================================================

class XMPRegisteredObjectIterator
{
  public:

	XMPRegisteredObjectIterator(XMPISOStr collection);
	XMPNVMethod void InitRegisteredObjectIterator();
	XMPVMethod ~XMPRegisteredObjectIterator();

	XMPNVMethod void		First(XMPPersistentObject** object,
									XMPSLong* refCon);
	XMPNVMethod void		Next(XMPPersistentObject** object,
									XMPSLong* refCon);
	XMPNVMethod XMPBoolean	IsNotComplete();
		
  private:

	
};

#endif // _REGOBJIT_