/*
	File:		SURefItr.h

	Contains:	definition of XMPStorageUnitRefIterator

	Written by: Vincent Lo

	Copyright:	 1992-1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 3/25/94	JA		Added missing #include (1147588)
		 <2>	 3/25/94	VL		#1147173, #1144732: made this class
									platform independent.
		 <1>	  2/4/94	VL		first checked in

*/

#ifndef _SUREFITR_
#define _SUREFITR_

#ifndef _XMPTYPES_
#include "XMPTypes.h"
#endif

#ifndef _STORAGEU_
#include "StorageU.h"		//JPA: For XMPStorageUnitRef
#endif


//==============================================================================
// Classes defined in this interface
//==============================================================================
class	XMPStorageUnitRefIterator;

//==============================================================================
// Classes used by this interface
//==============================================================================
class	XMPStorageUnit;

//==============================================================================
// XMPStorageUnitRefIterator
//==============================================================================

#define kXMPStorageUnitRefIteratorID "appl:xmpstorageunitrefiterator$class,1.0.0"

class XMPStorageUnitRefIterator
{
public:

	XMPStorageUnitRefIterator() {}
	XMPVMethod	~XMPStorageUnitRefIterator() {}
	
	XMPVMethod	void InitStorageUnitRefIterator(XMPStorageUnit* storageUnit)
		= 0;
	
	XMPVMethod	XMPStorageUnitRef	First()
		= 0;
		
	XMPVMethod	XMPStorageUnitRef	Next()
		= 0;
	
	XMPVMethod	XMPBoolean			IsNotComplete()
		= 0;
	
};

#endif	// _SUREFITR_