/*
	File:		ODTypes.r

	Contains:	OpenDoc Resource templates

	Written by:	Caia Grisar

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	 1/21/94	CG		More NMAP changes.
		 <2>	 1/18/94	CG		New NMAP format!
		 <1>	11/17/93	CG		first checked in
	To Do:
*/

#ifndef __STDTYPES_R__
#define __STDTYPES_R__

#ifndef SystemSevenOrBetter
#define SystemSevenOrBetter 0
#endif

#ifndef SystemSevenOrLater					/* <19> KIP - Define to 0 if it is not defined */
#define SystemSevenOrLater 0
#endif

#ifndef _STDDEFS_
#include "StdDefs.h"
#endif

/*----------------------------NMAP  NMAP Template-----------------------------------*/
type 'NMAP' {
	wstring;									/* NameSpace name */
	integer = $$Countof(KeyList);
	array KeyList {
		wstring;								/* A Key */
		switch {
			case kXMPIsMacOSType:
				key int = kXMPIsMacOSTypeID;
				literal longint;				/* an OSType */
			case kXMPIsINTLText:
				key int = kXMPIsINTLTextID;
				integer;						/* an international text struct */
				integer;
				wstring;
			case kXMPIsAnISOString:
				key int = kXMPIsAnISOStringID;
				wstring;						/* an ISOString */			
			case kXMPIsAnISOStringList:
				key int = kXMPIsAnISOStringListID;
				integer = $$Countof(ValueList);
				array ValueList {				/* an array of ISOStrings */
					wstring;				
				};
		};		
	};
};




#endif __STDTYPES_R__
