/*
	File:		ODTypesM.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	  4/4/94	RR		XMP -> OD

	To Do:
*/

// This is a handmade file, where Macintosh-specific types, defined as ODForeign in the IDL files,
// are defined.
// This file is included in ODObject.xh by a "passThru" statement in ODObject.idl

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __AEREGISTRY_
#include <AERegistry.h>
#endif

#ifndef SOM_Module_OpenDoc_Global_Types_defined
#include <ODTypes.xh>
#endif

#ifndef __TIME_H__
#include <time.h>
#endif

#ifndef __FIXMATH__
#include <FixMath.h>			// Must include before GX headers...
#endif
#ifndef graphicsTypesIncludes
#include <graphics types.h>		// Another fine GX header
#endif

class ODPart;

#define kODNULL   0

#define ODVersionString "1.0.0d2"

#define GetIndString getindstring

typedef time_t ODTime;

// File System

typedef FSSpec			ODFileSpec;
typedef ScriptCode		ODScriptCode;
typedef short			ODFileRefNum;

// Runtime

typedef ProcessSerialNumber	ODProcessID;

typedef OSType			ODOSType;

// Imaging

typedef GrafPtr 		ODPlatformCanvas;

/* $$$$$
typedef	Fixed			ODFixed;				// fixed-point (16.16) value
*/
typedef Region 			ODRegion;
typedef RgnPtr			ODRgnPtr;	
typedef RgnHandle		ODRgnHandle;
typedef	void*			ODPlatformShape;		// Graphics-system-dependent shape data
typedef void*			ODPlatformTransform;	// Graphics-system-dependent transform data
typedef gxShape 		ODgxShape;


// Windows

typedef WindowPtr    	ODPlatformWindow;

// Menus

typedef MenuHandle		ODPlatformMenu;	
typedef Handle			ODPlatformMenuBar;

// Semantic Interface

typedef AEDesc			ODObjectSpec;

struct ODOSLToken
{
	DescType	descriptorType;
	Handle		dataHandle;
};

// UniversalProcPtrs
#if USESROUTINEDESCRIPTORS
typedef UniversalProcPtr ODEventHandlerUPP ;
typedef UniversalProcPtr ODDescCoercionHandlerUPP ;
typedef UniversalProcPtr ODPtrCoercionHandlerUPP ;
typedef UniversalProcPtr ODCoercionHandlerUPP;
typedef UniversalProcPtr ODObjectAccessorUPP;
typedef UniversalProcPtr ODCompareUPP;
typedef UniversalProcPtr ODCountUPP ;
typedef UniversalProcPtr ODDisposeTokenUPP ;
typedef UniversalProcPtr ODGetMarkTokenUPP ;
typedef UniversalProcPtr ODMarkUPP ;
typedef UniversalProcPtr ODAdjustMarksUPP ;
typedef UniversalProcPtr ODGetErrDescUPP ;
typedef UniversalProcPtr ODPreDispatchUPP ;
typedef UniversalProcPtr ODTokenInquiryUPP ;
typedef UniversalProcPtr ODSpecialHandlerUPP;
#else	// if not USESROUTINEDESCRIPTORS

typedef ODError (*ODEventHandlerProcPtr)(ODPart*		thePart,
											AppleEvent*	theAppleEvent,
											AppleEvent*	reply,
											ODSLong	handlerRefcon);

typedef ODError (*ODCoercionHandler)();

typedef ODError (*ODDescCoercionHandler)(ODPart*		thePart,
											AEDesc*		theAEDesc,
											DescType	toType,
											ODSLong	handlerRefCon,
											AEDesc*		result);

typedef ODError (*ODPtrCoercionHandler)(ODPart*		thePart,
											DescType	typeCode,
											ODPtr		dataPtr,
											ODSize		dataSize,
											DescType	toType,
											ODSLong	handlerRefCon,
											AEDesc*		result);

typedef ODError (*ODAccessorProcPtr)(ODPart*				thePart,
										DescType			desiredClass,
										ODOSLToken*		container,
										DescType			containerClass,
										DescType			form,
										AEDesc*				selectionData,
										ODOSLToken*		value,
										ODSLong			handlerRefCon);

typedef ODError (*ODCompareProcPtr)(ODPart*				thePart,
										DescType			oper,
										ODOSLToken*		obj1,
										ODOSLToken*		obj2,
										ODBoolean*			result,
										ODSLong			refCon);

typedef ODError (*ODCountProcPtr)(ODPart*			thePart,
									DescType			desiredType,
									DescType			containerClass,
									ODOSLToken*		container,
									ODSLong*			result,
									ODSLong			refCon);

typedef ODError (*ODDisposeTokenProcPtr)(ODPart*			thePart,
											ODOSLToken*	unneededToken,
											ODSLong		refCon);

typedef ODError (*ODGetErrDescProcPtr)(ODPart*		thePart,
											AEDesc**	errDesc,
											ODSLong	refCon);

typedef ODError (*ODGetMarkTokenProcPtr)(ODPart*				thePart,
											ODOSLToken*		dContainerToken,
											DescType			containerClass,
											ODOSLToken*		result,
											ODSLong			refCon);

typedef ODError (*ODMarkProcPtr)(ODPart*				thePart,
									ODOSLToken*		dToken,
									ODOSLToken*		markToken,
									ODSLong			index,
									ODSLong			refCon);

typedef ODError (*ODAdjustMarksProcPtr)(ODPart*				thePart,
											ODSLong			newStart,
											ODSLong			newStop,
											ODOSLToken*		markToken,
											ODSLong			refCon);

typedef ODError (*ODPreDispatchProcPtr)(ODPart*		thePart,
												AppleEvent*	theAppleEvent,
												AppleEvent*	reply,
												ODSLong	handlerRefcon);

typedef ODError (*ODSpecialHandlerPtr)();

typedef ODPart* (*ODTokenInquiryProcPtr)(ODOSLToken*	token,
											ODSLong		refCon);

typedef ODEventHandlerProcPtr ODEventHandlerUPP ;
typedef ODDescCoercionHandler ODDescCoercionHandlerUPP ;
typedef ODPtrCoercionHandler ODPtrCoercionHandlerUPP ;
typedef ODCoercionHandler ODCoercionHandlerUPP;
typedef ODAccessorProcPtr ODObjectAccessorUPP ;
typedef ODCompareProcPtr ODCompareUPP;
typedef ODCountProcPtr ODCountUPP ;
typedef ODGetMarkTokenProcPtr ODGetMarkTokenUPP ;
typedef ODMarkProcPtr ODMarkUPP ;
typedef ODAdjustMarksProcPtr ODAdjustMarksUPP ;
typedef ODDisposeTokenProcPtr ODDisposeTokenUPP ;
typedef ODGetErrDescProcPtr ODGetErrDescUPP ;
typedef ODPreDispatchProcPtr ODPreDispatchUPP ;
typedef ODTokenInquiryProcPtr ODTokenInquiryUPP ;
typedef ODSpecialHandlerPtr ODSpecialHandlerUPP ;
typedef ODCoercionHandler ODCoercionHandlerUPP ;
#endif		// USESROUTINEDESCRIPTORS
