/************************************************************

	Assert.h
	Diagnostics
	
	Copyright  Apple Computer,Inc.  1987-1990, 1994.
	All Rights Reserved.

************************************************************/

#undef assert

#ifdef NDEBUG

	#define assert(ignore) ((void) 0)

#else

	#ifdef __CFM68K__
		#ifndef __SC__
			#pragma push
		#endif
		#pragma lib_export on
	#endif
	#ifdef __cplusplus
		extern "C" {
	#endif
	void __assertprint(const char* file, int line, const char* expr);
	#ifdef __cplusplus
		}
	#endif
	#ifdef __CFM68K__
		#ifndef __SC__
			#pragma pop
		#else
			#pragma lib_export off
		#endif
	#endif
	
	#define assert(expression) \
		( (expression) ? (void) 0 : (__assertprint(__FILE__, __LINE__, #expression)) )
			
#endif


