/* @(#) somk/somltype.h 2.2 5/3/93 15:04:20 [8/2/93 08:46:06] */

/*
 * 96F8647, 96F8648 (C) Copyright IBM Corp. 1992, 1993
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 */

/*
 *    SOMLTYPE.H
 *    SOMEXTERN and SOMLINK macros for C and C++ on AIX and OS/2
 */

/* === Define SOMEXTERN
 * 
 * assumptions: (1) __cplusplus is defined when compiling C++ code
 */
#ifdef __cplusplus
  #define SOMEXTERN extern "C"
  #ifdef __STR__
    #undef __STR__
  #endif
#else
  #define SOMEXTERN extern
#endif



/* === Assure a definition for SOMLINK
 *     note: if SOMLINK is already defined, it is not changed.
 *
 * assumptions: (1) __IBMCPP__ is defined by CSet/2 on OS/2 when compiling C++ code
 *              (2) _CL386 may be defined if not using an IBM compiler
 *              (3) neither _CL386 nor __IBMCPP__ are defined on AIX
 */
#ifndef SOMLINK
  #ifdef __IBMCPP__
    #define SOMLINK _System
  #else
    #ifdef _CL386
      #define SOMLINK _syscall
    #else
      #define SOMLINK
    #endif
  #endif
#endif

/*
 * === Backwards Source Level Compatability for __IBMC__
 */
#ifdef __IBMC__
    #pragma linkage(somAssert                 , system)
    #pragma linkage(somBeginPersistentIds     , system)
    #pragma linkage(somBuildClass             , system)
    #pragma linkage(somCheckId                , system)
    #pragma linkage(somClassResolve           , system)
    #pragma linkage(somCompareIds             , system)
    #pragma linkage(somConstructClass         , system)
    #pragma linkage(somDataResolve            , system)
    #pragma linkage(somEndPersistentIds       , system)
    #pragma linkage(somEnvironmentNew         , system)
    #pragma linkage(somGenericApply           , system)
    #pragma linkage(somGetClass               , system)
    #pragma linkage(somIdFromString           , system)
    #pragma linkage(somIsObj                  , system)
    #pragma linkage(somLPrintf                , system)
    #pragma linkage(somParentResolve          , system)
    #pragma linkage(somParentNumResolve       , system)
    #pragma linkage(somPrefixLevel            , system)
    #pragma linkage(somPrintf                 , system)
    #pragma linkage(somRegisterId             , system)
    #pragma linkage(somResolve                , system)
    #pragma linkage(somApply                  , system)
    #pragma linkage(somResolveByName          , system)
    #pragma linkage(somSetExpectedIds         , system)
    #pragma linkage(somStringFromId           , system)
    #pragma linkage(somTest                   , system)
    #pragma linkage(somTestCls                , system)
    #pragma linkage(somTotalRegIds            , system)
    #pragma linkage(somUniqueKey              , system)
    #pragma linkage(somVprintf                , system)
    #pragma linkage(somTD_classInitRoutine    , system)
    #pragma linkage(somTD_SOMCalloc           , system)
    #pragma linkage(somTD_SOMClassInitFuncName, system)
    #pragma linkage(somTD_SOMDeleteModule     , system)
    #pragma linkage(somTD_SOMError            , system)
    #pragma linkage(somTD_SOMFree             , system)
    #pragma linkage(somTD_SOMLoadModule       , system)
    #pragma linkage(somTD_SOMMalloc           , system)
    #pragma linkage(somTD_SOMOutCharRoutine   , system)
    #pragma linkage(somTD_SOMRealloc          , system)
#endif


