/************************************************************

Created: Wednesday, May 4, 1994 at 5:40:38 PM
    MakeStrLanguageModel.h
	
    An example function library which will build a
	speech recognition language model from STR# resource(s).

        Copyright Apple Computer, Inc.    1994
        All rights reserved

************************************************************/


#ifndef		__MAKESTRLANGUAGEMODEL__
#define		__MAKESTRLANGUAGEMODEL__

#ifndef		__SPEECHRECOGNITION__
#include	"SpeechRecognition.h"
#endif

/* A function to build a simple LanguageModel from an 'STR#' resource.

	The indexed strings are turned into LMPhrase elements of the
	LanguageModel, each with a refcon value set to the index within
	the string.
	
	The LanguageModel itself has the stringList resource id stored
	as its refcon, allowing the program to switch off of the resID to
	find which language model is which, and further off of a known
	string index (1 based) which is obtained from the LMPhrase.
*/

OSErr MakeStrLanguageModel (RecognitionSystem recSystem,
	LanguageModel *languageModel, short stringListID);

#endif	/* __MAKESTRLANGUAGEMODEL__ */
