{
 graphics:
    gxFont routines
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT FontRoutines;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingFontRoutines}
{$SETC UsingFontRoutines := 1}


{$I+}
{$SETC FontRoutinesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingFontTypes}
{$I $$Shell(PInterfaces)FontTypes.p}
{$ENDC}
{$SETC UsingIncludes := FontRoutinesIncludes}

FUNCTION GXNewFont(storage: GxFontStorageTag; reference: GxFontStorageReference; attributes: GxFontAttribute): GxFont; C;
FUNCTION GXGetFont(fontID: GxFont; VAR reference: GxFontStorageReference; VAR attributes: GxFontAttribute): GxFontStorageTag; C;
FUNCTION GXFindFont(storage: GxFontStorageTag; reference: GxFontStorageReference; VAR attributes: GxFontAttribute): GxFont; C;
PROCEDURE GXSetFont(fontID: GxFont; storage: GxFontStorageTag; reference: GxFontStorageReference; attributes: GxFontAttribute); C;
PROCEDURE GXDisposeFont(fontID: GxFont); C;
PROCEDURE GXChangedFont(fontID: GxFont); C;

FUNCTION GXGetFontFormat(fontID: GxFont): GxFontFormatTag; C;
FUNCTION GXGetDefaultFont: GxFont; C;
FUNCTION GXSetDefaultFont(fontID: GxFont): GxFont; C;
FUNCTION GXFindFonts(familyID: GxFont; name: GxFontName; platform: GxFontPlatform; script: GxFontScript; language: GxFontLanguage;
		length: LongInt; text: ByteArray; index, count: LongInt; VAR fonts: GxFont): LongInt; C;
FUNCTION GXCountFontGlyphs(fontID: GxFont): LongInt; C;

FUNCTION GXCountFontTables(fontID: GxFont): LongInt; C;
FUNCTION GXGetFontTable(fontID: GxFont; index: LongInt; tableData: Ptr; VAR tableTag: GxFontTableTag): LongInt; C;
FUNCTION GXFindFontTable(fontID: GxFont; tableTag: GxFontTableTag; tableData: Ptr; VAR index: LongInt): LongInt; C;
FUNCTION GXGetFontTableParts(fontID: GxFont; index, offset, length: LongInt; tableData: Ptr; VAR tableTag: GxFontTableTag): LongInt; C;
FUNCTION GXFindFontTableParts(fontID: GxFont; tableTag: GxFontTableTag; offset, length: LongInt; tableData: Ptr; VAR index: LongInt): LongInt; C;
FUNCTION GXSetFontTable(fontID: GxFont; index: LongInt; tableTag: GxFontTableTag; length: LongInt; tableData: Ptr): LongInt; C;
FUNCTION GXSetFontTableParts(fontID: GxFont; index: LongInt; tableTag: GxFontTableTag; offset, oldLength, newLength: LongInt; tableData: Ptr): LongInt; C;
FUNCTION GXDeleteFontTable(fontID: GxFont; index: LongInt; tableTag: GxFontTableTag): LongInt; C;

FUNCTION GXCountFontNames(fontID: GxFont): LongInt; C;
FUNCTION GXGetFontName(fontID: GxFont; index: LongInt; VAR name: GxFontName; VAR platform: GxFontPlatform; VAR script: GxFontScript;
		VAR language: GxFontLanguage; VAR text: Byte): LongInt; C;
FUNCTION GXFindFontName(fontID: GxFont; name: GxFontName; platform: GxFontPlatform; script: GxFontScript;
		language: GxFontLanguage; VAR text: Byte; VAR index: LongInt): LongInt; C;
FUNCTION GXSetFontName(fontID: GxFont; name: GxFontName; platform: GxFontPlatform; script: GxFontScript;
		language: GxFontLanguage; length: LongInt; text: ByteArray): LongInt; C;
FUNCTION GXDeleteFontName(fontID: GxFont; index: LongInt; name: GxFontName; platform: GxFontPlatform; script: GxFontScript; language: GxFontLanguage): LongInt; C;
FUNCTION GXNewFontNameID(fontID: GxFont): GxFontName; C;

FUNCTION GXCountFontEncodings(fontID: GxFont): LongInt; C;
FUNCTION GXGetFontEncoding(fontID: GxFont; index: LongInt; VAR script: GxFontScript; VAR language: GxFontLanguage): GxFontPlatform; C;
FUNCTION GXFindFontEncoding(fontID: GxFont; platform: GxFontPlatform; script: GxFontScript; language: GxFontLanguage): LongInt; C;
FUNCTION GXApplyFontEncoding(fontID: GxFont; index: LongInt; VAR length: LongInt; text: ByteArray; count: LongInt;
		VAR glyphs: UnsignedLongint; VAR was16Bit: SignedByte): LongInt; C;

FUNCTION GXCountFontVariations(aGxFont: GxFont): LongInt; C;
FUNCTION GXFindFontVariation(aGxFont: GxFont; variationTag: GxFontTableTag; VAR minValue, defaultValue, maxValue: Fixed;
		VAR name: GxFontName): LongInt; C;
FUNCTION GXGetFontVariation(aGxFont: GxFont; index: LongInt; VAR minValue, defaultValue, maxValue: Fixed; VAR name: GxFontName): GxFontTableTag; C;

FUNCTION GXCountFontInstances(aGxFont: GxFont): LongInt; C;
FUNCTION GXGetFontInstance(aGxFont: GxFont; index: LongInt; VAR variation: GxFontVariation): GxFontName; C;
FUNCTION GXSetFontInstance(fontID: GxFont; index: LongInt; name: GxFontName; variation: GxFontVariationArray): LongInt; C;
FUNCTION GXDeleteFontInstance(fontID: GxFont; index: LongInt; name: GxFontName): LongInt; C;

FUNCTION GXCountFontDescriptors(fontID: GxFont): LongInt; C;
FUNCTION GXGetFontDescriptor(fontID: GxFont; index: LongInt; VAR descriptorValue: Fixed): GxFontTableTag; C;
FUNCTION GXFindFontDescriptor(fontID: GxFont; descriptorTag: GxFontTableTag; VAR descriptorValue: Fixed): LongInt; C;
FUNCTION GXSetFontDescriptor(fontID: GxFont; index: LongInt; descriptorTag: GxFontTableTag; descriptorValue: Fixed): LongInt; C;
FUNCTION GXDeleteFontDescriptor(fontID: GxFont; index: LongInt; descriptorTag: GxFontTableTag): LongInt; C;

FUNCTION GXCountFontFeatures(fontID: GxFont): LongInt; C;
FUNCTION GXGetFontFeature(fontID: GxFont; index: LongInt; VAR flags: GxFontFeatureFlag; VAR settingCount: LongInt;
		VAR settings: GxFontFeatureSetting; VAR feature: GxFontFeature): GxFontName; C;
FUNCTION GXFindFontFeature(fontID: GxFont; feature: GxFontFeature; VAR flags: GxFontFeatureFlag; VAR settingCount: LongInt;
		VAR settings: GxFontFeatureSetting; VAR index: LongInt): GxFontName; C;

PROCEDURE GXFlattenFont(source: GxFont; VAR scalerStream: Ptr; VAR block: GxSpoolBlock); C;


{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
