{
 graphics:
    debugging routines
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.    
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT GraphicsDebugging;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingGraphicsDebugging}
{$SETC UsingGraphicsDebugging := 1}


{$I+}
{$SETC GraphicsDebuggingIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingGraphicsTypes}
{$I $$Shell(PInterfaces)GraphicsTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$SETC UsingIncludes := GraphicsDebuggingIncludes}


{ Validation Constants and Types }
CONST
	{ These tell what routines to validate. Choose one: }
	gxNoValidation 				= 0;	{ No Validation }
	gxPublicValidation			= 1;	{ Validate Public API Calls }
	gxInternalValidation		= 2;	{ Validate internal calls also }
	
	{ These tell what level of validation to perform on objects. Choose one: }
	gxTypeValidation			= 0;
	gxStructureValidation		= 16;
	gxAllObjectValidation		= 32;
	
	{ These tell how to validate memory manager blocks. Choose any combination: }
	gxNoMemoryManagerValidation	= 0;
	gxApBlockValidation			= 256;
	gxFontBlockValidation		= 512;
	gxApHeapValidation			= 1024;
	gxFontHeapValidation		= 2048;
	gxCheckApHeapValidation		= 4096;
	gxCheckFontHeapValidation	= 8192;


TYPE
	GxValidationLevel = LongInt;


{ DrawError Constants and Types }
CONST
	no_draw_error					= 1;
	shape_emptyType					= 2;
	shape_inverse_fullType			= 3;
	rectangle_zero_width			= 4;
	rectangle_zero_height			= 5;
	polygon_empty					= 6;
	path_empty						= 7;
	bitmap_zero_width				= 8;
	bitmap_zero_height				= 9;
	text_empty						= 10;
	glyph_empty						= 11;
	layout_empty					= 12;
	picture_empty					= 13;
	shape_no_fill					= 14;
	shape_no_enclosed_area			= 15;
	shape_no_enclosed_pixels		= 16;
	shape_very_small				= 17;
	shape_very_large				= 18;
	shape_contours_cancel			= 19;
	pen_too_small					= 20;
	text_size_too_small				= 21;
	dash_empty						= 22;
	start_cap_empty					= 23;
	pattern_empty					= 24;
	textFace_empty					= 25;
	shape_primitive_empty			= 26;
	shape_primitive_very_small		= 27;
	transfer_equals_noMode			= 28;
	transfer_matrix_ignores_source	= 29;
	transfer_matrix_ignores_device	= 30;
	transfer_source_reject			= 31;
	transfer_mode_ineffective		= 32;
	colorSet_no_entries				= 33;
	bitmap_colorSet_one_entry		= 34;
	transform_scale_too_small		= 35;
	transform_map_too_large			= 36;
	transform_move_too_large		= 37;
	transform_scale_too_large		= 38;
	transform_rotate_too_large		= 39;
	transform_perspective_too_large	= 40;
	transform_skew_too_large		= 41;
	transform_clip_no_intersection	= 42;
	transform_clip_empty			= 43;
	transform_no_viewPorts			= 44;
	viewPort_disposed				= 45;
	viewPort_clip_empty				= 46;
	viewPort_clip_no_intersection	= 47;
	viewPort_scale_too_small		= 48;
	viewPort_map_too_large			= 49;
	viewPort_move_too_large			= 50;
	viewPort_scale_too_large		= 51;
	viewPort_rotate_too_large		= 52;
	viewPort_perspective_too_large	= 53;
	viewPort_skew_too_large			= 54;
	viewPort_viewGroup_offscreen	= 55;
	viewDevice_clip_no_intersection	= 56;
	viewDevice_scale_too_small		= 57;
	viewDevice_map_too_large		= 58;
	viewDevice_move_too_large		= 59;
	viewDevice_scale_too_large		= 60;
	viewDevice_rotate_too_large		= 61;
	viewDevice_perspective_too_large = 62;
	viewDevice_skew_too_large		= 63;

TYPE
	GxDrawError = LongInt;

	GxUserDebugFunction = ProcPtr;


FUNCTION GXGetShapeDrawError(source: GxShape): GxDrawError; C;

PROCEDURE GXValidateAll; C;
PROCEDURE GXValidateColorSet(aGxColorSet: GxColorSet); C;
PROCEDURE GXValidateColorProfile(aGxColorProfile: GxColorProfile); C;
PROCEDURE GXValidateGraphicsClient(aGxGraphicsClient: GxGraphicsClient); C;
PROCEDURE GXValidateInk(aGxInk: GxInk); C;
PROCEDURE GXValidateShape(aGxShape: GxShape); C;
PROCEDURE GXValidateStyle(aGxStyle: GxStyle); C;
PROCEDURE GXValidateTag(aGxTag: GxTag); C;
PROCEDURE GXValidateTransform(aGxTransform: GxTransform); C;
PROCEDURE GXValidateViewDevice(aGxViewDevice: GxViewDevice); C;
PROCEDURE GXValidateViewPort(aGxViewPort: GxViewPort); C;
PROCEDURE GXValidateViewGroup(aGxViewGroup: GxViewGroup); C;

FUNCTION GXGetValidation: GxValidationLevel; C;
PROCEDURE GXSetValidation(aGxValidationLevel: GxValidationLevel); C;

FUNCTION GXGetValidationError(VAR procedureName: SignedByte; VAR argument: Ptr; VAR argumentNumber: LongInt): LongInt; C;
FUNCTION GXGetGraphicsBugParametersPointer(VAR graphicsBugParameters: Ptr): Boolean; C;
FUNCTION GXGetUserGraphicsDebug(VAR reference: LongInt): GxUserDebugFunction; C;
PROCEDURE GXSetUserGraphicsDebug(userFunction: GxUserDebugFunction; reference: LongInt); C;


{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
