{
 graphics:
    public interface definition
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Josh Horwich, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.

    Thanks to Bruce Leak for taking many mushy ideas and making them consistent and logical.
    Thanks to Mike Reed for the Mathematica, Athens, conics, cubics and the tireless (but well-voiced) concerns.
    Thanks to Bill Atkinson, Ernie Beernink for the inspiration and the well-trodden gxPath.
    Thanks to Jerome Coonen for the permission to do this in the first place.
    Thanks to Jim Batson and Gifford Calenda for not getting in the way.
    Thanks to Sampo Kaasila for the vector proofs, rotated parabolas and the gxFont scaler.
    Thanks to Scott Knaster, Will Stein, Jim Friedlander, Gene Pope, Laurie Girand and a host of others for
        their unflagging support, without which this project would have been abandoned long ago.
    Thanks to Andrew Singer and Michael Kahl for the speedy development environment.

    The sorting routine is originally from Knuth, coded in assembly by B. Atkinson and then in C by Galyn Susman.
    The matrix routines and gxCurve walking routines were originally coded by Sampo Kaasila.
    The gxPolygon and gxPath blitting edge walk was developed originally by Art Cabral.
    The gxHalftone matrix was developed by Daniel I. Lipton.
    The gxColor matching algorithms were developed by Robin Myers.
    The code was developed in C (not C++) and assembly in THINK C 1.0, 2.0, 3.0, 4.0, and 5.0, and MPW 3.0, 3.1 and 3.2.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT GraphicsRoutines;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingGraphicsRoutines}
{$SETC UsingGraphicsRoutines := 1}


{$I+}
{$SETC GraphicsRoutinesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingGraphicsTypes}
{$I $$Shell(PInterfaces)GraphicsTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingGraphicsErrors}
{$I $$Shell(PInterfaces)GraphicsErrors.p}
{$ENDC}
{$IFC UNDEFINED UsingFontTypes}
{$I $$Shell(PInterfaces)FontTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingMemoryTypes}
{$I $$Shell(PInterfaces)MemoryTypes.p}
{$ENDC}
{$SETC UsingIncludes := GraphicsRoutinesIncludes}


FUNCTION GXCountGraphicsFunctions(graphicsFunction: ByteArray): LongInt; C;
PROCEDURE GXInsertGraphicsFunction(graphicsFunction: ByteArray; index: LongInt; address: Ptr; identifier, reference: LongInt; device: GxViewDevice); C;
FUNCTION GXGetGraphicsFunction(graphicsFunction: ByteArray; index: LongInt; VAR identifier, reference: LongInt; VAR device: GxViewDevice): Ptr; C;
PROCEDURE GXSetGraphicsFunction(graphicsFunction: ByteArray; index: LongInt; address: Ptr; identifier, reference: LongInt; device: GxViewDevice); C;
PROCEDURE GXRemoveGraphicsFunction(graphicsFunction: ByteArray; index: LongInt); C;

FUNCTION GXGetGraphicsFunctionAddress(graphicsFunction: ByteArray): Ptr; C;

FUNCTION GXGetGraphicsFunctionReference: LongInt; C;
FUNCTION GXGetGraphicsFunctionDone(VAR result: LongInt): Boolean; C;
PROCEDURE GXSetGraphicsFunctionDone(isDone, result: LongInt); C;

FUNCTION GXNewGraphicsClient(memoryStart: Ptr; memoryLength, separateStack: LongInt): GxGraphicsClient; C;
FUNCTION GXGetGraphicsClient: GxGraphicsClient; C;
PROCEDURE GXSetGraphicsClient(client: GxGraphicsClient); C;
PROCEDURE GXDisposeGraphicsClient(client: GxGraphicsClient); C;
FUNCTION GXGetGraphicsClientHeap(client: GxGraphicsClient): GxHeapPointer; C;

FUNCTION GXGetGraphicsClients(index, count: LongInt; VAR clients: GxGraphicsClient): LongInt; C;
{returns the count }

PROCEDURE GXEnterGraphics; C;
PROCEDURE GXExitGraphics; C;

FUNCTION GXGetGraphicsError(VAR stickyError: GxGraphicsError): GxGraphicsError; C;
FUNCTION GXGetGraphicsNotice(VAR stickyNotice: GxGraphicsNotice): GxGraphicsNotice; C;
FUNCTION GXGetGraphicsWarning(VAR stickyWarning: GxGraphicsWarning): GxGraphicsWarning; C;
PROCEDURE GXPostGraphicsError(error: GxGraphicsError); C;
PROCEDURE GXPostGraphicsNotice(notice: GxGraphicsNotice); C;
PROCEDURE GXPostGraphicsWarning(warning: GxGraphicsWarning); C;
FUNCTION GXGetUserGraphicsError(VAR reference: LongInt): GxUserErrorFunction; C;
FUNCTION GXGetUserGraphicsNotice(VAR reference: LongInt): GxUserNoticeFunction; C;
FUNCTION GXGetUserGraphicsWarning(VAR reference: LongInt): GxUserWarningFunction; C;
PROCEDURE GXSetUserGraphicsError(userFunction: GxUserErrorFunction; reference: LongInt); C;
PROCEDURE GXSetUserGraphicsNotice(userFunction: GxUserNoticeFunction; reference: LongInt); C;
PROCEDURE GXSetUserGraphicsWarning(userFunction: GxUserWarningFunction; reference: LongInt); C;

PROCEDURE GXIgnoreGraphicsNotice(notice: GxGraphicsNotice); C;
PROCEDURE GXPopGraphicsNotice; C;
PROCEDURE GXIgnoreGraphicsWarning(warning: GxGraphicsWarning); C;
PROCEDURE GXPopGraphicsWarning; C;

FUNCTION GXNewShapeVector(aType: GxShapeType; vector: FixedArray): GxShape; C;
PROCEDURE GXSetShapeVector(target: GxShape; vector: FixedArray); C;

FUNCTION GXNewBitmap(data: GxBitmapPointer; position: GxPointPointer): GxShape; C;
FUNCTION GXNewCurve(data: GxCurvePointer): GxShape; C;
FUNCTION GXNewGlyphs(charCount: LongInt; text: ByteArray; positions: GxPointArray; advance: LongIntArray;
		tangents: GxPointArray; styleRuns: IntegerArray; glyphStyles: GxStyleArray): GxShape; C;
FUNCTION GXNewLine(data: GxLinePointer): GxShape; C;
FUNCTION GXNewPaths(data: GxPathsPointer): GxShape; C;
FUNCTION GXNewPicture(count: LongInt; shapes: GxShapeArray; styles: GxStyleArray; inks: GxInkArray; transforms: GxTransformArray): GxShape; C;
FUNCTION GXNewPoint(data: GxPointPointer): GxShape; C;
FUNCTION GXNewPolygons(data: GxPolygonsPointer): GxShape; C;
FUNCTION GXNewRectangle(data: GxRectanglePointer): GxShape; C;
FUNCTION GXNewText(charCount: LongInt; text: ByteArray; position: GxPointPointer): GxShape; C;

FUNCTION GXGetBitmap(source: GxShape; VAR data: GxBitmap; VAR position: GxPoint): GxBitmapPointer; C;
FUNCTION GXGetCurve(source: GxShape; VAR data: GxCurve): GxCurvePointer; C;
FUNCTION GXGetGlyphs(source: GxShape; VAR charCount: LongInt; VAR text: Byte; VAR positions: GxPoint; VAR advance: LongInt;
		VAR tangents: GxPoint; VAR runCount: LongInt; VAR styleRuns: Integer; VAR glyphStyles: GxStyle): LongInt; C;
FUNCTION GXGetLine(source: GxShape; VAR data: GxLine): GxLinePointer; C;
FUNCTION GXGetPaths(source: GxShape; VAR data: GxPaths): LongInt; C;
FUNCTION GXGetPicture(source: GxShape; VAR shapes: GxShape; VAR styles: GxStyle; VAR inks: GxInk; VAR transforms: GxTransform): LongInt; C;
FUNCTION GXGetPoint(source: GxShape; VAR data: GxPoint): GxPointPointer; C;
FUNCTION GXGetPolygons(source: GxShape; VAR data: GxPolygons): LongInt; C;
FUNCTION GXGetRectangle(source: GxShape; VAR data: GxRectangle): GxRectanglePointer; C;
FUNCTION GXGetText(source: GxShape; VAR charCount: LongInt; VAR text: Byte; VAR position: GxPoint): LongInt; C;

PROCEDURE GXSetBitmap(target: GxShape; data: GxBitmapPointer; position: GxPointPointer); C;
PROCEDURE GXSetCurve(target: GxShape; data: GxCurvePointer); C;
PROCEDURE GXSetGlyphs(target: GxShape; charCount: LongInt; text: ByteArray; positions: GxPointArray;
		advance: LongIntArray; tangents: GxPointArray; styleRuns: IntegerArray; glyphStyles: GxStyleArray); C;
PROCEDURE GXSetLine(target: GxShape; data: GxLinePointer); C;
PROCEDURE GXSetPaths(target: GxShape; data: GxPathsPointer); C;
PROCEDURE GXSetPicture(target: GxShape; count: LongInt; shapes: GxShapeArray; styles: GxStyleArray;
		inks: GxInkArray; transforms: GxTransformArray); C;
PROCEDURE GXSetPoint(target: GxShape; data: GxPointPointer); C;
PROCEDURE GXSetPolygons(target: GxShape; data: GxPolygonsPointer); C;
PROCEDURE GXSetRectangle(target: GxShape; data: GxRectanglePointer); C;
PROCEDURE GXSetText(target: GxShape; charCount: LongInt; text: ByteArray; position: GxPointPointer); C;

PROCEDURE GXDrawBitmap(data: GxBitmapPointer; position: GxPointPointer); C;
PROCEDURE GXDrawCurve(data: GxCurvePointer); C;
PROCEDURE GXDrawGlyphs(charCount: LongInt; text: ByteArray; positions: GxPointArray; advance: LongIntArray;
		tangents: GxPointArray; styleRuns: IntegerArray; glyphStyles: GxStyleArray); C;
PROCEDURE GXDrawLine(data: GxLinePointer); C;
PROCEDURE GXDrawPaths(data: GxPathsPointer; fill: GxShapeFill); C;
PROCEDURE GXDrawPicture(count: LongInt; shapes: GxShapeArray; styles: GxStyleArray; inks: GxInkArray; transforms: GxTransformArray); C;
PROCEDURE GXDrawPoint(data: GxPointPointer); C;
PROCEDURE GXDrawPolygons(data: GxPolygonsPointer; fill: GxShapeFill); C;
PROCEDURE GXDrawRectangle(data: GxRectanglePointer; fill: GxShapeFill); C;
PROCEDURE GXDrawText(charCount: LongInt; text: ByteArray; position: GxPointPointer); C;

FUNCTION GXNewColorProfile(profile: GxProfilePointer; responses: GxProfileResponsePointer): GxColorProfile; C;
FUNCTION GXNewColorSet(space: GxColorSpace; count: LongInt; colors: GxSetColorArray): GxColorSet; C;
FUNCTION GXNewInk: GxInk; C;
FUNCTION GXNewShape(aType: GxShapeType): GxShape; C;
FUNCTION GXNewStyle: GxStyle; C;
FUNCTION GXNewTag(tagType, length: LongInt; data: Ptr): GxTag; C;
FUNCTION GXNewTransform: GxTransform; C;
FUNCTION GXNewViewDevice(group: GxViewGroup; bitmapShape: GxShape): GxViewDevice; C;
FUNCTION GXNewViewGroup: GxViewGroup; C;
FUNCTION GXNewViewPort(group: GxViewGroup): GxViewPort; C;

PROCEDURE GXDisposeColorProfile(target: GxColorProfile); C;
PROCEDURE GXDisposeColorSet(target: GxColorSet); C;
PROCEDURE GXDisposeInk(target: GxInk); C;
PROCEDURE GXDisposeShape(target: GxShape); C;
PROCEDURE GXDisposeStyle(target: GxStyle); C;
PROCEDURE GXDisposeTag(target: GxTag); C;
PROCEDURE GXDisposeTransform(target: GxTransform); C;
PROCEDURE GXDisposeViewDevice(target: GxViewDevice); C;
PROCEDURE GXDisposeViewGroup(target: GxViewGroup); C;
PROCEDURE GXDisposeViewPort(target: GxViewPort); C;

FUNCTION GXCloneColorProfile(source: GxColorProfile): GxColorProfile; C;
FUNCTION GXCloneColorSet(source: GxColorSet): GxColorSet; C;
FUNCTION GXCloneInk(source: GxInk): GxInk; C;
FUNCTION GXCloneShape(source: GxShape): GxShape; C;
FUNCTION GXCloneStyle(source: GxStyle): GxStyle; C;
FUNCTION GXCloneTag(source: GxTag): GxTag; C;
FUNCTION GXCloneTransform(source: GxTransform): GxTransform; C;

FUNCTION GXCopyToColorProfile(target, source: GxColorProfile): GxColorProfile; C;
FUNCTION GXCopyToColorSet(target, source: GxColorSet): GxColorSet; C;
FUNCTION GXCopyToInk(target, source: GxInk): GxInk; C;
FUNCTION GXCopyToShape(target, source: GxShape): GxShape; C;
FUNCTION GXCopyToStyle(target, source: GxStyle): GxStyle; C;
FUNCTION GXCopyToTag(target, source: GxTag): GxTag; C;
FUNCTION GXCopyToTransform(target, source: GxTransform): GxTransform; C;
FUNCTION GXCopyToViewDevice(target, source: GxViewDevice): GxViewDevice; C;
FUNCTION GXCopyToViewPort(target, source: GxViewPort): GxViewPort; C;

FUNCTION GXEqualColorProfile(one, two: GxColorProfile): Boolean; C;
FUNCTION GXEqualColorSet(one, two: GxColorSet): Boolean; C;
FUNCTION GXEqualInk(one, two: GxInk): Boolean; C;
FUNCTION GXEqualShape(one, two: GxShape): Boolean; C;
FUNCTION GXEqualStyle(one, two: GxStyle): Boolean; C;
FUNCTION GXEqualTag(one, two: GxTag): Boolean; C;
FUNCTION GXEqualTransform(one, two: GxTransform): Boolean; C;
FUNCTION GXEqualViewDevice(one, two: GxViewDevice): Boolean; C;
FUNCTION GXEqualViewPort(one, two: GxViewPort): Boolean; C;

PROCEDURE GXResetInk(target: GxInk); C;
PROCEDURE GXResetShape(target: GxShape); C;
PROCEDURE GXResetStyle(target: GxStyle); C;
PROCEDURE GXResetTransform(target: GxTransform); C;

PROCEDURE GXLoadColorProfile(target: GxColorProfile); C;
PROCEDURE GXLoadColorSet(target: GxColorSet); C;
PROCEDURE GXLoadInk(target: GxInk); C;
PROCEDURE GXLoadShape(target: GxShape); C;
PROCEDURE GXLoadStyle(target: GxStyle); C;
PROCEDURE GXLoadTag(target: GxTag); C;
PROCEDURE GXLoadTransform(target: GxTransform); C;

PROCEDURE GXUnloadColorProfile(target: GxColorProfile); C;
PROCEDURE GXUnloadColorSet(target: GxColorSet); C;
PROCEDURE GXUnloadInk(target: GxInk); C;
PROCEDURE GXUnloadShape(target: GxShape); C;
PROCEDURE GXUnloadStyle(target: GxStyle); C;
PROCEDURE GXUnloadTag(target: GxTag); C;
PROCEDURE GXUnloadTransform(target: GxTransform); C;

PROCEDURE GXCacheShape(source: GxShape); C;
FUNCTION GXCopyDeepToShape(target, source: GxShape): GxShape; C;
PROCEDURE GXDrawShape(source: GxShape); C;
PROCEDURE GXDisposeShapeCache(target: GxShape); C;

FUNCTION GXGetDefaultColorProfile: GxColorProfile; C;
FUNCTION GXGetDefaultShape(aType: GxShapeType): GxShape; C;
FUNCTION GXGetDefaultColorSet(pixelDepth: LongInt): GxColorSet; C;


PROCEDURE GXSetDefaultShape(target: GxShape); C;
PROCEDURE GXSetDefaultColorSet(target: GxColorSet; pixelDepth: LongInt); C;

FUNCTION GXGetTag(source: GxTag; VAR tagType: LongInt; data: Ptr): LongInt; C;
PROCEDURE GXSetTag(target: GxTag; tagType, length: LongInt; data: Ptr); C;

FUNCTION GXGetShapeBounds(source: GxShape; index: LongInt; VAR bounds: GxRectangle): GxRectanglePointer; C;
FUNCTION GXGetShapeFill(source: GxShape): GxShapeFill; C;
FUNCTION GXGetShapeInk(source: GxShape): GxInk; C;
FUNCTION GXGetShapePixel(source: GxShape; x, y: LongInt; VAR data: GxColor; VAR index: LongInt): LongInt; C;
FUNCTION GXGetShapeStyle(source: GxShape): GxStyle; C;
FUNCTION GXGetShapeTransform(source: GxShape): GxTransform; C;
FUNCTION GXGetShapeType(source: GxShape): GxShapeType; C;
FUNCTION GXGetShapeTypographicBounds(source: GxShape; VAR bounds: GxRectangle): GxRectanglePointer; C;
FUNCTION GXGetBitmapParts(source: GxShape; bounds: GxLongRectanglePointer): GxShape; C;
PROCEDURE GXGetStyleFontMetrics(sourceStyle: GxStyle; VAR before, after, caretAngle, caretOffset: GxPoint); C;
PROCEDURE GXGetShapeFontMetrics(source: GxShape; VAR before, after, caretAngle, caretOffset: GxPoint); C;

PROCEDURE GXSetShapeBounds(target: GxShape; newBounds: GxRectanglePointer); C;
PROCEDURE GXSetShapeFill(target: GxShape; newFill: GxShapeFill); C;
PROCEDURE GXSetShapeInk(target: GxShape; newInk: GxInk); C;
PROCEDURE GXSetShapePixel(target: GxShape; x, y: LongInt; newColor: GxColorPointer; newIndex: LongInt); C;
PROCEDURE GXSetShapeStyle(target: GxShape; newStyle: GxStyle); C;
PROCEDURE GXSetShapeTransform(target: GxShape; newTransform: GxTransform); C;
PROCEDURE GXSetShapeType(target: GxShape; newType: GxShapeType); C;
PROCEDURE GXSetBitmapParts(target: GxShape; bounds: GxLongRectanglePointer; bitmapShape: GxShape); C;

PROCEDURE GXSetShapeGeometry(target, geometry: GxShape); C;

FUNCTION GXGetShapeCurveError(source: GxShape): Fixed; C;
FUNCTION GXGetShapeDash(source: GxShape; VAR dash: GxDashRecord): GxDashPointer; C;
FUNCTION GXGetShapeCap(source: GxShape; VAR cap: GxCapRecord): GxCapPointer; C;
FUNCTION GXGetShapeFace(source: GxShape; VAR face: GxTextFace): LongInt; C;	{ returns the number of layers }
FUNCTION GXGetShapeFont(source: GxShape): GxFont; C;
FUNCTION GXGetShapeJoin(source: GxShape; VAR join: GxJoinRecord): GxJoinPointer; C;
FUNCTION GXGetShapeJustification(source: GxShape): Fract; C;
FUNCTION GXGetShapePattern(source: GxShape; VAR pattern: GxPatternRecord): GxPatternPointer; C;
FUNCTION GXGetShapePen(source: GxShape): Fixed; C;
FUNCTION GXGetShapeEncoding(source: GxShape; VAR script: GxFontScript; VAR language: GxFontLanguage): GxFontPlatform; C;
FUNCTION GXGetShapeTextSize(source: GxShape): Fixed; C;
FUNCTION GXGetShapeFontVariations(source: GxShape; VAR variations: GxFontVariation): LongInt; C;
FUNCTION GXGetShapeFontVariationSuite(source: GxShape; VAR variations: GxFontVariation): LongInt; C;

FUNCTION GXGetStyleCurveError(source: GxStyle): Fixed; C;
FUNCTION GXGetStyleDash(source: GxStyle; VAR dash: GxDashRecord): GxDashPointer; C;
FUNCTION GXGetStyleCap(source: GxStyle; VAR cap: GxCapRecord): GxCapPointer; C;
FUNCTION GXGetStyleFace(source: GxStyle; VAR face: GxTextFace): LongInt; C;		{ returns the number of layers }
FUNCTION GXGetStyleFont(source: GxStyle): GxFont; C;
FUNCTION GXGetStyleJoin(source: GxStyle; VAR join: GxJoinRecord): GxJoinPointer; C;
FUNCTION GXGetStyleJustification(source: GxStyle): Fract; C;
FUNCTION GXGetStylePattern(source: GxStyle; VAR pattern: GxPatternRecord): GxPatternPointer; C;
FUNCTION GXGetStylePen(source: GxStyle): Fixed; C;
FUNCTION GXGetStyleEncoding(source: GxStyle; VAR script: GxFontScript; VAR language: GxFontLanguage): GxFontPlatform; C;
FUNCTION GXGetStyleTextSize(source: GxStyle): Fixed; C;
FUNCTION GXGetStyleFontVariations(source: GxStyle; VAR variations: GxFontVariation): LongInt; C;
FUNCTION GXGetStyleFontVariationSuite(source: GxStyle; VAR variations: GxFontVariation): LongInt; C;

PROCEDURE GXSetShapeCurveError(target: GxShape; error: Fixed); C;
PROCEDURE GXSetShapeDash(target: GxShape; dash: GxDashPointer); C;
PROCEDURE GXSetShapeCap(target: GxShape; cap: GxCapPointer); C;
PROCEDURE GXSetShapeFace(target: GxShape; face: GxTextFacePointer); C;
PROCEDURE GXSetShapeFont(target: GxShape; aFont: GxFont); C;
PROCEDURE GXSetShapeJoin(target: GxShape; join: GxJoinPointer); C;
PROCEDURE GXSetShapeJustification(target: GxShape; justify: Fract); C;
PROCEDURE GXSetShapePattern(target: GxShape; pattern: GxPatternPointer); C;
PROCEDURE GXSetShapePen(target: GxShape; pen: Fixed); C;
PROCEDURE GXSetShapeEncoding(target: GxShape; platform: GxFontPlatform; script: GxFontScript; language: GxFontLanguage); C;
PROCEDURE GXSetShapeTextSize(target: GxShape; size: Fixed); C;
PROCEDURE GXSetShapeFontVariations(target: GxShape; count: LongInt; variations: GxFontVariationArray); C;

PROCEDURE GXSetStyleCurveError(target: GxStyle; error: Fixed); C;
PROCEDURE GXSetStyleDash(target: GxStyle; dash: GxDashPointer); C;
PROCEDURE GXSetStyleCap(target: GxStyle; cap: GxCapPointer); C;
PROCEDURE GXSetStyleFace(target: GxStyle; face: GxTextFacePointer); C;
PROCEDURE GXSetStyleFont(target: GxStyle; aFont: GxFont); C;
PROCEDURE GXSetStyleJoin(target: GxStyle; join: GxJoinPointer); C;
PROCEDURE GXSetStyleJustification(target: GxStyle; justify: Fract); C;
PROCEDURE GXSetStylePattern(target: GxStyle; pattern: GxPatternPointer); C;
PROCEDURE GXSetStylePen(target: GxStyle; pen: Fixed); C;
PROCEDURE GXSetStyleEncoding(target: GxStyle; platform: GxFontPlatform; script: GxFontScript; language: GxFontLanguage); C;
PROCEDURE GXSetStyleTextSize(target: GxStyle; size: Fixed); C;
PROCEDURE GXSetStyleFontVariations(target: GxStyle; count: LongInt; variations: GxFontVariationArray); C;

FUNCTION GXGetShapeColor(source: GxShape; VAR data: GxColor): GxColorPointer; C;
FUNCTION GXGetShapeTransfer(source: GxShape; VAR data: GxTransferMode): GxTransferModePointer; C;

FUNCTION GXGetInkColor(source: GxInk; VAR data: GxColor): GxColorPointer; C;
FUNCTION GXGetInkTransfer(source: GxInk; VAR data: GxTransferMode): GxTransferModePointer; C;

PROCEDURE GXSetShapeColor(target: GxShape; data: GxColorPointer); C;
PROCEDURE GXSetShapeTransfer(target: GxShape; data: GxTransferModePointer); C;

PROCEDURE GXSetInkColor(target: GxInk; data: GxColorPointer); C;
PROCEDURE GXSetInkTransfer(target: GxInk; data: GxTransferModePointer); C;

FUNCTION GXGetShapeClip(source: GxShape): GxShape; C;
FUNCTION GXGetShapeMapping(source: GxShape; VAR map: GxMapping): GxMappingPointer; C;
FUNCTION GXGetShapeHitTest(source: GxShape; VAR tolerance: Fixed): GxShapePart; C;
FUNCTION GXGetShapeViewPorts(source: GxShape; VAR list: GxViewPort): LongInt; C;

FUNCTION GXGetTransformClip(source: GxTransform): GxShape; C;
FUNCTION GXGetTransformMapping(source: GxTransform; VAR map: GxMapping): GxMappingPointer; C;
FUNCTION GXGetTransformHitTest(source: GxTransform; VAR tolerance: Fixed): GxShapePart; C;
FUNCTION GXGetTransformViewPorts(source: GxTransform; VAR list: GxViewPort): LongInt; C;

PROCEDURE GXSetShapeClip(target, clip: GxShape); C;
PROCEDURE GXSetShapeMapping(target: GxShape; map: GxMappingPointer); C;
PROCEDURE GXSetShapeHitTest(target: GxShape; mask: GxShapePart; tolerance: Fixed); C;
PROCEDURE GXSetShapeViewPorts(target: GxShape; count: LongInt; list: GxViewPortArray); C;

PROCEDURE GXSetTransformClip(target: GxTransform; clip: GxShape); C;
PROCEDURE GXSetTransformMapping(target: GxTransform; map: GxMappingPointer); C;
PROCEDURE GXSetTransformHitTest(target: GxTransform; mask: GxShapePart; tolerance: Fixed); C;
PROCEDURE GXSetTransformViewPorts(target: GxTransform; count: LongInt; list: GxViewPortArray); C;

FUNCTION GXGetColorSet(source: GxColorSet; VAR space: GxColorSpace; VAR colors: GxSetColor): LongInt; C;
FUNCTION GXGetColorProfile(source: GxColorProfile; VAR profile: GxProfileRecord; VAR responses: GxProfileResponse): LongInt; C;

PROCEDURE GXSetColorSet(target: GxColorSet; space: GxColorSpace; count: LongInt; colors: GxSetColorArray); C;
PROCEDURE GXSetColorProfile(target: GxColorProfile; profile: GxProfilePointer; responses: GxProfileResponsePointer); C;

FUNCTION GXGetViewDeviceBitmap(source: GxViewDevice): GxShape; C;
FUNCTION GXGetViewDeviceClip(source: GxViewDevice): GxShape; C;
FUNCTION GXGetViewDeviceMapping(source: GxViewDevice; VAR map: GxMapping): GxMappingPointer; C;
FUNCTION GXGetViewDeviceViewGroup(source: GxViewDevice): GxViewGroup; C;

PROCEDURE GXSetViewDeviceBitmap(target: GxViewDevice; bitmapShape: GxShape); C;
PROCEDURE GXSetViewDeviceClip(target: GxViewDevice; clip: GxShape); C;
PROCEDURE GXSetViewDeviceMapping(target: GxViewDevice; map: GxMappingPointer); C;
PROCEDURE GXSetViewDeviceViewGroup(target: GxViewDevice; group: GxViewGroup); C;

FUNCTION GXGetViewPortChildren(source: GxViewPort; VAR list: GxViewPort): LongInt; C;
FUNCTION GXGetViewPortClip(source: GxViewPort): GxShape; C;
FUNCTION GXGetViewPortDither(source: GxViewPort): LongInt; C;
FUNCTION GXGetViewPortHalftone(source: GxViewPort; VAR data: GxHalftone): Boolean; C;
FUNCTION GXGetViewPortMapping(source: GxViewPort; VAR map: GxMapping): GxMappingPointer; C;
FUNCTION GXGetViewPortParent(source: GxViewPort): GxViewPort; C;
FUNCTION GXGetViewPortViewGroup(source: GxViewPort): GxViewGroup; C;

PROCEDURE GXSetViewPortChildren(target: GxViewPort; count: LongInt; list: GxViewPortArray); C;
PROCEDURE GXSetViewPortClip(target: GxViewPort; clip: GxShape); C;
PROCEDURE GXSetViewPortDither(target: GxViewPort; level: LongInt); C;
PROCEDURE GXSetViewPortHalftone(target: GxViewPort; data: GxHalftonePointer); C;
PROCEDURE GXSetViewPortMapping(target: GxViewPort; map: GxMappingPointer); C;
PROCEDURE GXSetViewPortParent(target, parent: GxViewPort); C;
PROCEDURE GXSetViewPortViewGroup(target: GxViewPort; group: GxViewGroup); C;

FUNCTION GXGetColorProfileTags(source: GxColorProfile; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetColorSetTags(source: GxColorSet; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetInkTags(source: GxInk; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetShapeTags(source: GxShape; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetStyleTags(source: GxStyle; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetTransformTags(source: GxTransform; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetViewDeviceTags(source: GxViewDevice; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;
FUNCTION GXGetViewPortTags(source: GxViewPort; tagType, index, count: LongInt; VAR items: GxTag): LongInt; C;

PROCEDURE GXSetColorProfileTags(target: GxColorProfile; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetColorSetTags(target: GxColorSet; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetInkTags(target: GxInk; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetShapeTags(target: GxShape; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetStyleTags(target: GxStyle; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetTransformTags(target: GxTransform; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetViewDeviceTags(target: GxViewDevice; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;
PROCEDURE GXSetViewPortTags(target: GxViewPort; tagType, index, oldCount, newCount: LongInt; items: GxTagArray); C;

FUNCTION GXGetInkAttributes(source: GxInk): GxInkAttribute; C;
FUNCTION GXGetShapeAttributes(source: GxShape): GxShapeAttribute; C;
FUNCTION GXGetShapeInkAttributes(source: GxShape): GxInkAttribute; C;
FUNCTION GXGetShapeStyleAttributes(source: GxShape): GxStyleAttribute; C;
FUNCTION GXGetStyleAttributes(source: GxStyle): GxStyleAttribute; C;
FUNCTION GXGetShapeTextAttributes(source: GxShape): GxTextAttribute; C;
FUNCTION GXGetStyleTextAttributes(source: GxStyle): GxTextAttribute; C;
FUNCTION GXGetViewDeviceAttributes(source: GxViewDevice): GxDeviceAttribute; C;
FUNCTION GXGetViewPortAttributes(source: GxViewPort): GxPortAttribute; C;

PROCEDURE GXSetInkAttributes(target: GxInk; attributes: GxInkAttribute); C;
PROCEDURE GXSetShapeAttributes(target: GxShape; attributes: GxShapeAttribute); C;
PROCEDURE GXSetShapeInkAttributes(target: GxShape; attributes: GxInkAttribute); C;
PROCEDURE GXSetShapeStyleAttributes(target: GxShape; attributes: GxStyleAttribute); C;
PROCEDURE GXSetStyleAttributes(target: GxStyle; attributes: GxStyleAttribute); C;
PROCEDURE GXSetShapeTextAttributes(target: GxShape; attributes: GxTextAttribute); C;
PROCEDURE GXSetStyleTextAttributes(target: GxStyle; attributes: GxTextAttribute); C;
PROCEDURE GXSetViewDeviceAttributes(target: GxViewDevice; attributes: GxDeviceAttribute); C;
PROCEDURE GXSetViewPortAttributes(target: GxViewPort; attributes: GxPortAttribute); C;

FUNCTION GXGetColorProfileOwners(source: GxColorProfile): LongInt; C;
FUNCTION GXGetColorSetOwners(source: GxColorSet): LongInt; C;
FUNCTION GXGetInkOwners(source: GxInk): LongInt; C;
FUNCTION GXGetShapeOwners(source: GxShape): LongInt; C;
FUNCTION GXGetStyleOwners(source: GxStyle): LongInt; C;
FUNCTION GXGetTagOwners(source: GxTag): LongInt; C;
FUNCTION GXGetTransformOwners(source: GxTransform): LongInt; C;

PROCEDURE GXLockShape(target: GxShape); C;
PROCEDURE GXLockTag(target: GxTag); C;
PROCEDURE GXUnlockShape(target: GxShape); C;
PROCEDURE GXUnlockTag(target: GxTag); C;
FUNCTION GXGetShapeStructure(source: GxShape; VAR length: LongInt): Ptr; C;
FUNCTION GXGetTagStructure(source: GxTag; VAR length: LongInt): Ptr; C;

FUNCTION GXGetColorDistance(target, source: GxColorPointer): Fixed; C;
FUNCTION GXShapeLengthToPoint(target: GxShape; index: LongInt; length: Fixed; VAR location, tangent: GxPoint): GxPointPointer; C;

FUNCTION GXGetShapeArea(source: GxShape; index: LongInt; VAR area: GxWide): GxWidePointer; C;
FUNCTION GXGetShapeCacheSize(source: GxShape): LongInt; C;
FUNCTION GXGetShapeCenter(source: GxShape; index: LongInt; VAR center: GxPoint): GxPointPointer; C;
FUNCTION GXGetShapeDirection(source: GxShape; contour: LongInt): GxContourDirection; C;
FUNCTION GXGetShapeIndex(source: GxShape; contour, vector: LongInt): LongInt; C;
FUNCTION GXGetShapeLength(source: GxShape; index: LongInt; VAR length: GxWide): GxWidePointer; C;
FUNCTION GXGetShapeSize(source: GxShape): LongInt; C;

FUNCTION GXCountShapeContours(source: GxShape): LongInt; C;
FUNCTION GXCountShapePoints(source: GxShape; contour: LongInt): LongInt; C;

FUNCTION GXGetShapeDashPositions(source: GxShape; VAR dashMappings: GxMapping): LongInt; C;	{ returns the number of positions }
FUNCTION GXGetShapeDeviceArea(source: GxShape; port: GxViewPort; device: GxViewDevice): LongInt; C;
FUNCTION GXGetShapeDeviceBounds(source: GxShape; port: GxViewPort; device: GxViewDevice; VAR bounds: GxRectangle): Boolean; C;
FUNCTION GXGetShapeDeviceColors(source: GxShape; port: GxViewPort; device: GxViewDevice; VAR width: LongInt): GxColorSet; C;
FUNCTION GXGetShapeGlobalBounds(source: GxShape; port: GxViewPort; group: GxViewGroup; VAR bounds: GxRectangle): Boolean; C;
FUNCTION GXGetShapeGlobalViewDevices(source: GxShape; port: GxViewPort; VAR list: GxViewDevice): LongInt; C;
FUNCTION GXGetShapeGlobalViewPorts(source: GxShape; VAR list: GxViewPort): LongInt; C;
FUNCTION GXGetShapeLocalBounds(source: GxShape; VAR bounds: GxRectangle): GxRectanglePointer; C;
FUNCTION GXGetShapePatternPositions(source: GxShape; VAR positions: GxPoint): LongInt; C;	{ returns the number of positions }
PROCEDURE GXGetShapeLocalFontMetrics(sourceShape: GxShape; VAR before, after, caretAngle, caretOffset: GxPoint); C;
PROCEDURE GXGetShapeDeviceFontMetrics(sourceShape: GxShape; port: GxViewPort; device: GxViewDevice;
		VAR before, after, caretAngle, caretOffset: GxPoint); C;

FUNCTION GXGetViewGroupViewDevices(source: GxViewGroup; VAR list: GxViewDevice): LongInt; C;
FUNCTION GXGetViewGroupViewPorts(source: GxViewGroup; VAR list: GxViewPort): LongInt; C;

FUNCTION GXGetViewPortGlobalMapping(source: GxViewPort; VAR map: GxMapping): GxMappingPointer; C;
FUNCTION GXGetViewPortViewDevices(source: GxViewPort; VAR list: GxViewDevice): LongInt; C;

FUNCTION GXHitTestPicture(target: GxShape; test: GxPointPointer; VAR result: GxHitTestInfo; level, depth: LongInt): GxShape; C;

FUNCTION GXIntersectRectangle(VAR target: GxRectangle; source, operand: GxRectanglePointer): Boolean; C;
FUNCTION GXUnionRectangle(VAR target: GxRectangle; source, operand: GxRectanglePointer): GxRectanglePointer; C;

FUNCTION GXTouchesRectanglePoint(target: GxRectanglePointer; test: GxPointPointer): Boolean; C;
FUNCTION GXTouchesShape(target, test: GxShape): Boolean; C;
FUNCTION GXTouchesBoundsShape(target: GxRectanglePointer; test: GxShape): Boolean; C;

FUNCTION GXContainsRectangle(container, test: GxRectanglePointer): Boolean; C;
FUNCTION GXContainsShape(container, test: GxShape): Boolean; C;
FUNCTION GXContainsBoundsShape(container: GxRectanglePointer; test: GxShape; index: LongInt): Boolean; C;

FUNCTION GXConvertColor(VAR target: GxColor; space: GxColorSpace; aSet: GxColorSet; profile: GxColorProfile): GxColorPointer; C;
FUNCTION GXCombineColor(VAR target: GxColor; operand: GxInk): GxColorPointer; C;

FUNCTION GXCheckColor(source: GxColorPointer; space: GxColorSpace; aSet: GxColorSet; profile: GxColorProfile): Boolean; C;
FUNCTION GXCheckBitmapColor(source: GxShape; area: GxLongRectanglePointer; space: GxColorSpace;
		aSet: GxColorSet; profile: GxColorProfile): GxShape; C;

FUNCTION GXGetHalftoneDeviceAngle(source: GxViewDevice; data: GxHalftonePointer): Fixed; C;

FUNCTION GXGetColorSetParts(source: GxColorSet; index, count: LongInt; VAR space: GxColorSpace; VAR data: GxSetColor): LongInt; C;
FUNCTION GXGetGlyphParts(source: GxShape; index, charCount: LongInt; VAR byteLength: LongInt; VAR text: Byte;
		VAR positions: GxPoint; VAR advanceBits: LongInt; VAR tangents: GxPoint; VAR runCount: LongInt;
		VAR styleRuns: Integer; VAR styles: GxStyle): LongInt; C;	{ returns the glyph count }
FUNCTION GXGetPathParts(source: GxShape; index, count: LongInt; VAR data: GxPaths): LongInt; C;
FUNCTION GXGetPictureParts(source: GxShape; index, count: LongInt; VAR shapes: GxShape; VAR styles: GxStyle;
		VAR inks: GxInk; VAR transforms: GxTransform): LongInt; C;
FUNCTION GXGetPolygonParts(source: GxShape; index, count: LongInt; VAR data: GxPolygons): LongInt; C;
FUNCTION GXGetShapeParts(source: GxShape; index, count: LongInt; destination: GxShape): GxShape; C;
FUNCTION GXGetTextParts(source: GxShape; index, charCount: LongInt; VAR text: Byte): LongInt; C;

PROCEDURE GXSetColorSetParts(target: GxColorSet; index, oldCount, newCount: LongInt; data: GxSetColorArray); C;
PROCEDURE GXSetGlyphParts(source: GxShape; index, oldCharCount, newCharCount: LongInt; text: ByteArray; positions: GxPointArray;
		advanceBits: LongIntArray; tangents: GxPointArray; styleRuns: IntegerArray; styles: GxStyleArray); C;
PROCEDURE GXSetPathParts(target: GxShape; index, count: LongInt; data: GxPathsPointer; flags: GxEditShapeFlag); C;
PROCEDURE GXSetPictureParts(target: GxShape; index, oldCount, newCount: LongInt; shapes: GxShapeArray;
		styles: GxStyleArray; inks: GxInkArray; transforms: GxTransformArray); C;
PROCEDURE GXSetPolygonParts(target: GxShape; index, count: LongInt; data: GxPolygonsPointer; flags: GxEditShapeFlag); C;
PROCEDURE GXSetShapeParts(target: GxShape; index, count: LongInt; insert: GxShape; flags: GxEditShapeFlag); C;
PROCEDURE GXSetTextParts(target: GxShape; index, oldCharCount, newCharCount: LongInt; text: ByteArray); C;

FUNCTION GXGetShapePoints(source: GxShape; index, count: LongInt; VAR data: GxPoint): LongInt; C;
PROCEDURE GXSetShapePoints(target: GxShape; index, count: LongInt; data: GxPointArray); C;

FUNCTION GXGetGlyphPositions(source: GxShape; index, charCount: LongInt; VAR advance: LongInt; VAR positions: GxPoint): LongInt; C;
FUNCTION GXGetGlyphTangents(source: GxShape; index, charCount: LongInt; VAR tangents: GxPoint): LongInt; C;
PROCEDURE GXSetGlyphPositions(target: GxShape; index, charCount: LongInt; advance: LongIntArray; positions: GxPointArray); C;
PROCEDURE GXSetGlyphTangents(target: GxShape; index, charCount: LongInt; tangents: GxPointArray); C;

FUNCTION GXGetGlyphMetrics(source: GxShape; VAR advances: GxPoint; VAR boundingBoxes: GxRectangle; VAR sideBearings: GxPoint): LongInt; C;

PROCEDURE GXDifferenceShape(target, operand: GxShape); C;
PROCEDURE GXExcludeShape(target, operand: GxShape); C;
PROCEDURE GXIntersectShape(target, operand: GxShape); C;
PROCEDURE GXMapShape(target: GxShape; map: GxMappingPointer); C;
PROCEDURE GXMoveShape(target: GxShape; deltaX, deltaY: Fixed); C;
PROCEDURE GXMoveShapeTo(target: GxShape; x, y: Fixed); C;
PROCEDURE GXReverseDifferenceShape(target, operand: GxShape); C;
PROCEDURE GXRotateShape(target: GxShape; degrees, xOffset, yOffset: Fixed); C;
PROCEDURE GXScaleShape(target: GxShape; hScale, vScale, xOffset, yOffset: Fixed); C;
PROCEDURE GXSkewShape(target: GxShape; xSkew, ySkew, xOffset, yOffset: Fixed); C;
PROCEDURE GXUnionShape(target, operand: GxShape); C;

PROCEDURE GXDifferenceTransform(target: GxTransform; operand: GxShape); C;
PROCEDURE GXExcludeTransform(target: GxTransform; operand: GxShape); C;
PROCEDURE GXIntersectTransform(target: GxTransform; operand: GxShape); C;
PROCEDURE GXMapTransform(target: GxTransform; map: GxMappingPointer); C;
PROCEDURE GXMoveTransform(target: GxTransform; deltaX, deltaY: Fixed); C;
PROCEDURE GXMoveTransformTo(target: GxTransform; x, y: Fixed); C;
PROCEDURE GXReverseDifferenceTransform(target: GxTransform; operand: GxShape); C;
PROCEDURE GXRotateTransform(target: GxTransform; degrees, xOffset, yOffset: Fixed); C;
PROCEDURE GXScaleTransform(target: GxTransform; hScale, vScale, xOffset, yOffset: Fixed); C;
PROCEDURE GXSkewTransform(target: GxTransform; xSkew, ySkew, xOffset, yOffset: Fixed); C;
PROCEDURE GXUnionTransform(target: GxTransform; operand: GxShape); C;

PROCEDURE GXBreakShape(target: GxShape; index: LongInt); C;
PROCEDURE GXChangedShape(target: GxShape); C;
FUNCTION GXHitTestShape(target: GxShape; test: GxPointPointer; VAR result: GxHitTestInfo): GxShapePart; C;
FUNCTION GXHitTestDevice(target: GxShape; port: GxViewPort; device: GxViewDevice; test, tolerance: GxPointPointer): GxShape; C;
PROCEDURE GXInsetShape(target: GxShape; inset: Fixed); C;
PROCEDURE GXInvertShape(target: GxShape); C;
PROCEDURE GXPrimitiveShape(target: GxShape); C;
PROCEDURE GXReduceShape(target: GxShape; contour: LongInt); C;
PROCEDURE GXReverseShape(target: GxShape; contour: LongInt); C;
PROCEDURE GXSimplifyShape(target: GxShape); C;

PROCEDURE GXLockColorProfile(source: gxColorProfile); C;
PROCEDURE GXUnlockColorProfile(source: gxColorProfile); C;
FUNCTION GXGetColorProfileStructure(source: gxColorProfile; VAR length: LongInt) : Ptr; C;

PROCEDURE GXFlattenShape(source: GxShape; flags: GxFlattenFlag; VAR block: GxSpoolBlock); C;
FUNCTION GXUnflattenShape(VAR block: GxSpoolBlock; count: LongInt; portList: GxViewPortArray): GxShape; C;


{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
