{ graphics:
	toolbox interfaces
	by Cary Clark, Georgiann Delaney, Herb Derby, Michael Fairman, Pablo Fernicola, Dave Good, Josh Horwich, Barton House, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1994 Apple Computer, Inc.  All rights reserved.
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT GraphicsToolbox;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingGraphicsToolbox}
{$SETC UsingGraphicsToolbox := 1}


{$I+}
{$SETC GraphicsToolboxIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingWindows}
{$I $$Shell(PInterfaces)Windows.p}
{$ENDC}
{$IFC UNDEFINED UsingFontTypes}
{$I $$Shell(PInterfaces)FontTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingGraphicsTypes}
{$I $$Shell(PInterfaces)GraphicsTypes.p}
{$ENDC}
{$SETC UsingIncludes := GraphicsToolboxIncludes}


{ QD to QD GX Translator Types }

CONST
	gxDefaultOptionsTranslation		= $0000;
	gxOptimizedTranslation			= $0001;
	gxReplaceLineWidthTranslation	= $0002;
	gxSimpleScalingTranslation		= $0004;
	gxSimpleGeometryTranslation		= $0008;	{ implies simple scaling }
	gxSimpleLinesTranslation		= $000C;	{ implies simple geometry & scaling }
	gxLayoutTextTranslation			= $0010;	{ turn on gxLine layout (normally off) }
	gxRasterTargetTranslation		= $0020;
	gxPostScriptTargetTranslation	= $0040;
	gxVectorTargetTranslation		= $0080;

TYPE
	GxTranslationOption = LongInt;

CONST
	gxContainsFormsBegin			= $0001;
	gxContainsFormsEnd				= $0002;
	gxContainsPostScript			= $0004;
	gxContainsEmptyPostScript		= $0008;

TYPE
	GxTranslationStatistic = LongInt;


{ QuickDraw Tag Types }
CONST
	gxQuickDrawPictTag = $70696374;				{ 'pict' }

TYPE
	GxQuickDrawPict = RECORD
		{ translator inputs }
		options:		GxTranslationOption;
		srcRect:		Rect;
		styleStretch:	Point;

		{ size of quickdraw picture data }
		dataLength:		LongInt;

		{ file alias }
		alias:			GxBitmapDataSourceAlias;	
		END;

	GxShapeSpoolFunction = ProcPtr;
	GxUserViewPortFilter = ProcPtr;
	GxConvertQDFontFunction = ProcPtr;


{ WindowRecord utilities }
FUNCTION GXNewWindowViewPort(qdWindow: WindowPtr) : GxViewPort; C;
FUNCTION GXGetWindowViewPort(qdWindow: WindowPtr) : GxViewPort; C;
FUNCTION GXGetViewPortWindow(portOrder: gxViewPort) : WindowPtr; C;

{ GDevice utilities }
FUNCTION GXGetViewDeviceGDevice(theDevice: gxViewDevice) : GDHandle; C;
FUNCTION GXGetGDeviceViewDevice(qdGDevice: GDHandle) : GxViewDevice; C;

{ gxPoint utilities }
PROCEDURE GXConvertQDPoint(VAR shortPt: Point; portOrder: GxViewPort; VAR fixedPt: GxPoint); C;

{ mouse utilities }
PROCEDURE GXGetGlobalMouse(VAR globalPt: GxPoint); C; { return mouse location in fixed-gxPoint global space }
PROCEDURE GXGetViewPortMouse(portOrder: GxViewPort; VAR localPt: GxPoint); C;	{ return fixed-gxPoint local mouse (gxViewPort == 0 --> default) }

{ printing utilities }
FUNCTION GXGetViewPortFilter(portOrder: GxViewPort; VAR refCon: LongInt) : GxUserViewPortFilter; C;
PROCEDURE GXSetViewPortFilter(portOrder: GxViewPort; filter: GxUserViewPortFilter; refCon: LongInt); C;
 
{ QD to QD GX Translator functions }
PROCEDURE GXInstallQDTranslator(port: GrafPtr; options: GxTranslationOption; srcRect: Rect; dstRect: Rect;
								styleStretch: Point; userFunction : GxShapeSpoolFunction; reference: LongInt); C;
FUNCTION GXRemoveQDTranslator(port: GrafPtr; VAR statistic: GxTranslationStatistic) : gxTranslationStatistic; C;
FUNCTION GXConvertPICTToShape(pict: PicHandle; options: GxTranslationOption; srcRect: Rect; dstRect: Rect;
							styleStretch: Point; destination: GxShape; stats: GxTranslationStatistic) : GxShape; C;
	
{ Find the best GX style given a QD font and face. Called by the QD->GX translator }
FUNCTION GXConvertQDFont(theStyle: gxStyle; txFont: LongInt; txFace: LongInt) : LongInt; C;
FUNCTION GXGetConvertQDFont : GxConvertQDFontFunction; C;
PROCEDURE GXSetConvertQDFont(userFuntion: GxConvertQDFontFunction); C;

{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}

