{
 graphics:
    public object and constant definitions
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Josh Horwich, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.    
}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT GraphicsTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingGraphicsTypes}
{$SETC UsingGraphicsTypes := 1}


{$I+}
{$SETC GraphicsTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$SETC UsingIncludes := GraphicsTypesIncludes}

TYPE

{$IFC UNDEFINED VoidDefined}
{$SETC VoidDefined := 1}
	VOID = RECORD END;
{$ENDC}

	GxShape = ^Void;
	GxShapePointer = ^GxShape;
	GxShapeArray = ARRAY [0..0] OF GxShape;
	
	GxStyle = ^Void;
	GxStylePointer = ^GxStyle;
	GxStyleArray = ARRAY [0..0] OF GxStyle;
	
	GxInk = ^Void;
	GxInkPointer = ^GxInk;
	GxInkArray = ARRAY [0..0] OF GxInk;
	
	GxTransform = ^Void;
	GxTransformPointer = ^GxTransform;
	GxTransformArray = ARRAY [0..0] OF GxTransform;
	
	GxTag = ^Void;
	GxTagPointer = ^GxTag;
	GxTagArray = ARRAY [0..0] OF GxTag;
	
	GxColorSet = ^Void;
	GxColorSetPointer = ^GxColorSet;
	GxColorSetArray = ARRAY [0..0] OF GxColorSet;
	
	GxColorProfile = ^Void;
	GxColorProfilePointer = ^GxColorProfile;
	GxColorProfileArray = ARRAY [0..0] OF GxColorProfile;
	
	GxGraphicsClient = ^Void;
	GxGraphicsClientPointer = ^GxGraphicsClient;
	GxGraphicsClientArray = ARRAY [0..0] OF GxGraphicsClient;
	
	GxViewGroup = ^Void;
	GxViewGroupPointer = ^GxViewGroup;
	GxViewGroupArray = ARRAY [0..0] OF GxViewGroup;
	
	GxViewPort = ^Void;
	GxViewPortPointer = ^GxViewPort;
	GxViewPortArray = ARRAY [0..0] OF GxViewPort;
	
	GxViewDevice = ^Void;
	GxViewDevicePointer = ^GxViewDevice;
	GxViewDeviceArray = ARRAY [0..0] OF GxViewDevice;
	
	GxColorSpace = LongInt;
	GxColorSpacePointer = ^GxColorSpace;
	GxColorSpaceArray = ARRAY [0..0] OF GxColorSpace;
	

{ gxShape enumerations }
CONST
	gxEmptyType		= 1;
	gxPointType		= 2;
	gxLineType		= 3;
	gxCurveType		= 4;
	gxRectangleType	= 5;
	gxPolygonType	= 6;
	gxPathType		= 7;
	gxBitmapType	= 8;
	gxTextType		= 9;
	gxGlyphType		= 10;
	gxLayoutType	= 11;
	gxFullType		= 12;
	gxPictureType	= 13;


TYPE
	GxShapeType = LongInt;

{ Fill Types }
CONST
	gxNoFill				= 1;
	gxOpenFrameFill			= 2;
	gxFrameFill				= 2;
	gxClosedFrameFill		= 3;
	gxHollowFill			= 3;
	gxEvenOddFill			= 4;
	gxSolidFill				= 4;
	gxWindingFill			= 5;
	gxInverseEvenOddFill	= 6;
	gxInverseSolidFill		= 6;
	gxInverseFill			= 6;
	gxInverseWindingFill	= 7;


TYPE
GxShapeFill = LongInt;


CONST
	gxNoAttributes			= 1;
	gxDirectShape			= 1;
	gxRemoteShape			= 2;
	gxCachedShape			= 4;
	gxLockedShape			= 8;
	gxGroupShape			= 16;
	gxMapTransformShape		= 32;
	gxUniqueItemsShape		= 64;
	gxIgnorePlatformShape	= 128;
	gxNoMetricsGridShape	= 256;
	gxDiskShape				= 512;
	gxMemoryShape			= 1024;
	
TYPE
	GxShapeAttribute = LongInt;


{ gxShape editing enumerations }
CONST
	gxBreakNeitherEdit		= 0;
	gxBreakLeftEdit			= 1;
	gxBreakRightEdit		= 2;
	gxRemoveDuplicatePointsEdit = 4;

TYPE
	GxEditShapeFlag = LongInt;



CONST
	gxCounterclockwiseDirection	= 1;
	gxClockwiseDirection		= 2;

TYPE
	GxContourDirection = LongInt;


{ gxShape structures }

	GxLine = RECORD
		first: GxPoint;
		last: GxPoint;
		END;
	GxLinePointer = ^GxLine;

	GxCurve = RECORD
		first: GxPoint;
		control: GxPoint;
		last: GxPoint;
		END;
	GxCurvePointer = ^GxCurve;

	GxRectangle = RECORD
		left: Fixed;
		top: Fixed;
		right: Fixed;
		bottom: Fixed;
		END;
	GxRectanglePointer = ^GxRectangle;

	GxPolygon = RECORD
		vectors: LongInt;
		vector: ARRAY [0..1] OF GxPoint;
		END;
	GxPolygonPointer = ^GxPolygon;

	GxPolygons = RECORD
		contours: LongInt;
		contour: ARRAY [0..1] OF GxPolygon;
		END;
	GxPolygonsPointer = ^GxPolygons;

	GxPath = RECORD
		vectors: LongInt;
		controlBits: ARRAY [0..1] OF LongInt;
		vector: ARRAY [0..1] OF GxPoint;
		END;
	GxPathPointer = ^GxPath;

	GxPaths = RECORD
		contours: LongInt;
		contour: ARRAY [0..1] OF GxPath;
		END;
	GxPathsPointer = ^GxPaths;

	GxBitmap = RECORD
		image: ^SignedByte;
		width: LongInt;
		height: LongInt;
		rowBytes: LongInt;
		pixelSize: LongInt;
		space: GxColorSpace;
		colorSet: GxColorSet;
		profile: GxColorProfile;
		END;
	GxBitmapPointer = ^GxBitmap;

	GxLongRectangle = RECORD
		left: LongInt;
		top: LongInt;
		right: LongInt;
		bottom: LongInt;
		END;
	GxLongRectanglePointer = ^GxLongRectangle;
	GxLongRectangleArray = ARRAY [0..0] OF GxLongRectangle;


{ gxStyle enumerations }
CONST
	gxCenterFrameStyle	= 0;
	gxSourceGridStyle	= 1;
	gxDeviceGridStyle	= 2;
	gxInsideFrameStyle	= 4;
	gxOutsideFrameStyle	= 8;
	gxAutoInsetStyle	= 16;

TYPE
	GxStyleAttribute = LongInt;

{ Dash Attributes }
CONST
	gxBendDash			= 1;
	gxBreakDash			= 2;
	gxClipDash			= 4;
	gxLevelDash			= 8;
	gxAutoAdvanceDash	= 16;

TYPE
	GxDashAttribute = LongInt;

{ Pattern Attributes }
CONST
	gxPortAlignPattern	= 1;
	gxPortMapPattern	= 2;

TYPE
	GxPatternAttribute = LongInt;

{ Join Attributes }
CONST
	gxSharpJoin = 0;
	gxCurveJoin = 1;
	gxLevelJoin = 2;

TYPE
	GxJoinAttribute = LongInt;

{ Cap Attributes }
CONST
	gxLevelStartCap	= 1;
	gxLevelEndCap	= 2;

TYPE
	GxCapAttribute = LongInt;


{ Text Attributes }
CONST
	gxAutoAdvanceText	= 1;
	gxNoContourGridText	= 2;
	gxNoMetricsGridText	= 4;
	gxAnchorPointsText	= 8;
	gxVerticalText		= 16;
	noOpticalScaleText	= 32;

TYPE
	GxTextAttribute		= LongInt;

{ Textface Layer Flags }
CONST
	gxUnderlineAdvanceLayer			= 1;
	gxSkipWhiteSpaceLayer			= 2;
	gxUnderlineIntervalLayer		= 4;
	gxUnderlineContinuationLayer	= 8;
	gxWhiteLayer					= 16;
	gxClipLayer						= 32;
	gxStringLayer					= 64;

TYPE
	GxLayerFlag = LongInt;


{ gxStyle structures }
	GxFaceLayer = RECORD
		outlineFill: GxShapeFill;
		flags: GxLayerFlag;
		outlineStyle: GxStyle;
		outlineTransform: GxTransform;
		boldOutset: GxPoint;
		END;
	GxFaceLayerPointer = ^GxFaceLayer;
	GxFaceLayerArray = ARRAY [0..0] OF GxFaceLayer;


	GxTextFace = RECORD
		faceLayers: LongInt;
		advanceMapping: GxMapping;
		faceLayer: ARRAY [0..1] OF GxFaceLayer;
		END;
	GxTextFacePointer = ^GxTextFace;
	GxTextFaceArray = ARRAY [0..0] OF GxTextFace;


	GxJoinRecord = RECORD
		attributes: GxJoinAttribute;
		join: GxShape;
		miter: Fixed;
		END;
	GxJoinPointer = ^GxJoinRecord;
	GxJoinArray = ARRAY [0..0] OF GxJoinRecord;
	
	
	GxDashRecord = RECORD
		attributes: GxDashAttribute;
		dash: GxShape;
		advance: Fixed;
		phase: Fract;
		scale: Fixed;
		END;
	GxDashPointer = ^GxDashRecord;
	GxDashArray = ARRAY [0..0] OF GxDashRecord;
	
	
	GxPatternRecord = RECORD
		attributes: GxPatternAttribute;
		pattern: GxShape;
		u: GxPoint;
		v: GxPoint;
		END;
	GxPatternPointer = ^GxPatternRecord;
	GxPatternArray = ARRAY [0..0] OF GxPatternRecord;
	
	
	GxCapRecord = RECORD
		attributes: GxCapAttribute;
		startCap: GxShape;
		endCap: GxShape;
		END;
	GxCapPointer = ^GxCapRecord;
	GxCapArray = ARRAY [0..0] OF GxCapRecord;
	

{ gxInk enumerations }


CONST
	gxPortAlignDitherInk	= 1;
	gxForceDitherInk		= 2;
	gxSuppressDitherInk		= 4;
	gxSuppressHalftoneInk	= 8;


TYPE
	GxInkAttribute = LongInt;
	GxInkAttributePointer = ^GxInkAttribute;
	GxInkAttributeArray = ARRAY [0..0] OF GxInkAttribute;


{ TransferMode Component Mode Types }
CONST
	gxNoMode		= 0;
	gxCopyMode		= 1;
	gxAddMode		= 2;
	gxBlendMode		= 3;
	gxMigrateMode	= 4;
	gxMinimumMode	= 5;
	gxMaximumMode	= 6;
	gxHighlightMode	= 7;
	gxAndMode		= 8;
	gxOrMode		= 9;
	gxXorMode		= 10;
	gxRampAndMode	= 11;
	gxRampOrMode	= 12;
	gxRampXorMode	= 13;
	gxOverMode		= 14;
	gxAtopMode		= 15;
	gxExcludeMode	= 16;
	gxFadeMode		= 17;

TYPE
	GxComponentMode = Byte;


{ TransferMode Flags }
CONST
	gxRejectSourceTransfer = 1;
	gxRejectDeviceTransfer = 2;
	gxSingleComponentTransfer = 4;


TYPE
	GxTransferFlag = LongInt;


{ TransferMode Component Flags }
CONST
	gxOverResultComponent	= 1;
	gxReverseComponent		= 2;

TYPE
	GxComponentFlag = Byte;


{ gxInk structures }
	GxTransferComponent = RECORD
		mode: GxComponentMode;
		flags: GxComponentFlag;
		sourceMinimum: GxColorValue;
		sourceMaximum: GxColorValue;
		deviceMinimum: GxColorValue;
		deviceMaximum: GxColorValue;
		clampMinimum: GxColorValue;
		clampMaximum: GxColorValue;
		operand: GxColorValue;
		END;

	GxTransferMode = RECORD
		space: GxColorSpace;
		colorSet: GxColorSet;
		profile: GxColorProfile;
		sourceMatrix: ARRAY [0..5, 0..4] OF Fixed;
		deviceMatrix: ARRAY [0..5, 0..4] OF Fixed;
		resultMatrix: ARRAY [0..5, 0..4] OF Fixed;
		flags: GxTransferFlag;
		component: ARRAY [0..4] OF GxTransferComponent;
		END;
	GxTransferModePointer = ^GxTransferMode;
	

{ gxColor space enumerations }

CONST
	gxNoColorPacking		= 0;	{ 16 bits per channel }
	gxAlphaSpace			= 128;	{ Space includes alpha channel }
	gxWord5ColorPacking		= 1280;	{ 5 bits per channel, right-justified }
	gxLong8ColorPacking		= 2048;	{ 8 bits per channel, right-justified }
	gxLong10ColorPacking	= 2560;	{ 10 bits per channel, right-justified }
	gxAlphaFirstPacking		= 4096;	{ Alpha channel is the first channel in packed space }

	gxNoSpace		= 0;
	gxRGBSpace		= 1;
	gxCMYKSpace		= 2;
	gxHSVSpace		= 3;
	gxHLSSpace		= 4;
	gxCIESpace		= 5;
	gxXYZSpace		= 6;
	gxLUVSpace		= 7;
	gxLABSpace		= 8;
	gxYIQSpace		= 9;
	gxNTSCSpace		= 9;
	gxPALSpace		= 9;
	gxGraySpace		= 10;
	gxIndexedSpace	= 11;
	gxRGBASpace		= gxRGBSpace + gxAlphaSpace;
	gxGrayASpace	= gxGraySpace + gxAlphaSpace;
	gxRGB16Space	= gxWord5ColorPacking + gxRGBSpace;
	gxRGB32Space	= gxLong8ColorPacking + gxRGBSpace;
	gxARGB32Space	= gxLong8ColorPacking + gxAlphaFirstPacking + gxRGBASpace;
	gxCMYK32Space	= gxLong8ColorPacking + gxCMYKSpace;
	gxHSV32Space	= gxLong10ColorPacking + gxHSVSpace;
	gxHLS32Space	= gxLong10ColorPacking + gxHLSSpace;
	gxCIE32Space	= gxLong10ColorPacking + gxCIESpace;
	gxXYZ32Space	= gxLong10ColorPacking + gxXYZSpace;
	gxLUV32Space	= gxLong10ColorPacking + gxLUVSpace;
	gxLAB32Space	= gxLong10ColorPacking + gxLABSpace;
	gxYIQ32Space	= gxLong10ColorPacking + gxYIQSpace;
	gxNTSC32Space	= gxYIQ32Space;
	gxPAL32Space	= gxYIQ32Space;

{ gxColor space structures }
TYPE
	GxRGBColor = RECORD
		red: GxColorValue;
		green: GxColorValue;
		blue: GxColorValue;
		END;

	GxRGBAColor = RECORD
		red: GxColorValue;
		green: GxColorValue;
		blue: GxColorValue;
		alpha: GxColorValue;
		END;

	GxHSVColor = RECORD
		hue: GxColorValue;
		saturation: GxColorValue;
		value: GxColorValue;
		END;

	GxHLSColor = RECORD
		hue: GxColorValue;
		lightness: GxColorValue;
		saturation: GxColorValue;
		END;

	GxCMYKColor = RECORD
		cyan: GxColorValue;
		magenta: GxColorValue;
		yellow: GxColorValue;
		black: GxColorValue;
		END;

	GxCIEColor = RECORD
		x: GxColorValue;
		y: GxColorValue;
		z: GxColorValue;
		END;

	GxYIQColor = RECORD
		y: GxColorValue;
		i: GxColorValue;
		q: GxColorValue;
		END;

	GxGrayAColor = RECORD
		gray: GxColorValue;
		alpha: GxColorValue;
		END;

	GxColorIndex = LongInt;
	GxIndexedColor = RECORD
		index: GxColorIndex;
		colorSet: GxColorSet;
		END;

	GxColor = RECORD
		space: GxColorSpace;
		profile: GxColorProfile;
		CASE Integer OF
			1: (cmyk: GxCMYKColor);
			2: (rgb: GxRGBColor);
			3: (rgba: GxRGBAColor);
			4: (hsv: GxHSVColor);
			5: (hls: GxHLSColor);
			6: (cie: GxCIEColor);
			7: (yiq: GxYIQColor);
			8: (gray: GxColorValue);
			9: (graya: GxGrayAColor);
			10: (pixel16: UnsignedLongint);
			11: (pixel32: UnsignedLong);
			12: (indexed: GxIndexedColor);
			13: (component: ARRAY [0..4] OF GxColorValue);
		END;
	GxColorPointer = ^GxColor;
	GxColorArray = ARRAY [0..0] OF GxColor;
	
{ gxColorSet structures }
	GxSetColor = RECORD
		CASE Integer OF
			1: (cmyk: GxCMYKColor);
			2: (rgb: GxRGBColor);
			3: (rgba: GxRGBAColor);
			4: (hsv: GxHSVColor);
			5: (hls: GxHLSColor);
			6: (cie: GxCIEColor);
			7: (yiq: GxYIQColor);
			8: (gray: GxColorValue);
			9: (graya: GxGrayAColor);
			10: (pixel16: UnsignedLongint);
			11: (pixel32: UnsignedLong);
			12: (component: ARRAY [0..4] OF GxColorValue);
	END;
	GxSetColorArray = ARRAY [0..0] OF GxSetColor;
	
{ gxColorProfile enumerations }
CONST
	gxPerceptualProfile		= 0;
	gxColorimetricProfile	= 1;
	gxSaturationProfile		= 2;
	gxSuppressMatchProfile	= 4;

TYPE
	GxProfileAttribute = LongInt;

{ gxColorProfile structures }
CONST
	gxGrayResponse				= 1;
	gxRedResponse				= 2;
	gxGreenResponse				= 3;
	gxBlueResponse				= 4;
	gxCyanResponse				= 5;
	gxMagentaResponse			= 6;
	gxYellowResponse			= 7;
	gxUnderColorRemovalResponse	= 8;
	gxBlackGenerationResponse	= 9;
	gxOnePlusLastResponse		= 10;

TYPE
	GxResponseColor = LongInt;


	GxProfileResponse = RECORD
		colorCount: ARRAY [0..10] OF Integer;
		data: ARRAY [0..1] OF GxColorValue;
		END;
	GxProfileResponsePointer = ^GxProfileResponse;
	
	GxProfileRecord = RECORD
		red: GxCIEColor;
		green: GxCIEColor;
		blue: GxCIEColor;
		cyan: GxCIEColor;
		magenta: GxCIEColor;
		yellow: GxCIEColor;
		black: GxCIEColor;
		white: GxCIEColor;
		END;
	GxProfilePointer = ^GxProfileRecord;
	
{ gxTransform enumerations }
CONST
	gxNoPart			= 0;
	gxBoundsPart		= 1;
	gxGeometryPart		= 2;
	gxPenPart			= 4;
	gxCornerPointPart	= 8;
	gxControlPointPart	= 16;
	gxEdgePart			= 32;
	gxJoinPart			= 64;
	gxStartCapPart		= 128;
	gxEndCapPart		= 256;
	gxDashPart			= 512;
	gxPatternPart		= 1024;
	gxGlyphBoundsPart	= 64;
	gxGlyphFirstPart	= 128;
	gxGlyphLastPart		= 256;
	gxSideBearingPart	= 512;
	gxAnyPart			= 2047;


TYPE
	GxShapePart = LongInt;

{ gxTransform structures }
	GxHitTestInfo = RECORD
		what: GxShapePart;
		index: LongInt;
		distance: Fixed;
		which: GxShape;
		containerPicture: GxShape;
		containerIndex: LongInt;
		totalIndex: LongInt;
		END;

{ gxViewPort enumerations }
CONST
	gxGrayPort			= 1;
	gxAlwaysGridPort	= 2;


TYPE
	GxPortAttribute = LongInt;


{ gxViewDevice enumerations }
CONST
	gxDirectDevice		= 1;
	gxRemoteDevice		= 2;
	gxInactiveDevice	= 4;


TYPE
	GxDeviceAttribute = LongInt;

{ Halftone dot types }
CONST
	gxRoundDot			= 1;
	gxSpiralDot			= 2;
	gxSquareDot			= 3;
	gxLineDot			= 4;
	gxEllipticDot		= 5;
	gxTriangleDot		= 6;
	dispersedDot		= 7;


TYPE
	GxDotType = LongInt;


{ gxViewPort structures }
CONST
	gxNoTint			= 1;
	gxLuminanceTint		= 2;
	gxAverageTint		= 3;
	gxMixtureTint		= 4;
	gxComponent1Tint	= 5;
	gxComponent2Tint	= 6;
	gxComponent3Tint	= 7;
	gxComponent4Tint	= 8;


TYPE
	GxTintType = LongInt;

	GxHalftone = RECORD
		angle: Fixed;
		frequency: Fixed;
		method: GxDotType;
		tinting: GxTintType;
		dotColor: GxColor;
		backgroundColor: GxColor;
		tintSpace: GxColorSpace;
		END;
	GxHalftonePointer = ^GxHalftone;

{ gxViewGroup enumerations }
CONST
	gxOpenReadSpool		= 1;
	gxOpenWriteSpool	= 2;
	gxReadSpool			= 3;
	gxWriteSpool		= 4;
	gxCloseSpool		= 5;

TYPE
	GxSpoolCommand = LongInt;

	GxGraphicsOpcode = Byte;

	GxSpoolBlock = RECORD
		spoolProcedure: ProcPtr;
		buffer: ^VOID;
		bufferSize: LongInt;
		count: LongInt;
		operationSize: LongInt;
		operationOffset: LongInt;
		lastTypeOpcode: GxGraphicsOpcode;
		currentOperation: GxGraphicsOpcode;
		currentOperand: GxGraphicsOpcode;
		compressed: Byte;
		END;
	GxSpoolBlockPointer = ^GxSpoolBlock;


CONST
	gxFontListFlatten		= 1;
	gxFontGlyphsFlatten		= 2;
	gxFontVariationsFlatten	= 4;
	gxBitmapAliasFlatten	= 8;
	
	gxBitmapFileAliasTagType = 'bfil';
	gxBitmapFileAliasImageValue = 1;
	
TYPE
	GxFlattenFlag = LongInt;


{ gxGraphicsClient constants }
CONST
	GxGraphicsSystemClient	= -1;
	
	GxStaticHeapClient		= 1;
	
TYPE
	GxClientAttribute = LongInt;
	
{ Patching Constants }
CONST
	GxOriginalGraphicsFunction		= -1;
	GxOriginalGraphicsIdentifier	= 'grfx';

{ Bitmap-from-disk Types }	
TYPE
	gxBitmapDataSourceAlias = RECORD
		fileOffset: LongInt;
		aliasRecordSize: LongInt;
		aliasRecord: ARRAY [0..1] OF Byte;
	END;

{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
