{
 layout types.h -- Line Layout types

    by Dave Opstad and Eric Mader,
    with special thanks to the following folks:
         Mark Davis, for starting it all off;
         Russ Sonnenschein, for many good ideas;
         Cary Clark, Dave Good, Rob Johnson, Keith McGreggor, and Chris Yerga for the graphics system;
         Richard Becker, Lynn Bekkala and Mike Reed for fonts and the gxFont system;
         Robert Dierkes and the SQE team for testing and good ideas;
         Parry Kejriwal and Richard Klein, for gxFont tools;
         Diane Patterson, for great patience in writing documentation;
         Hugo Ayala, Tom Dowdy, Dan Lipton, Sean Parent and the rest of the PrintShop;
         Mitch Allen for managing to manage us; and
         many other good folk at Apple!

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT LayoutTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingLayoutTypes}
{$SETC UsingLayoutTypes := 1}


{ Copyright 1988-1992 Apple Computer, Inc.  All rights reserved. }

{$I+}
{$SETC LayoutTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$IFC UNDEFINED UsingGraphicsTypes}
{$I $$Shell(PInterfaces)GraphicsTypes.p}
{$ENDC}
{$SETC UsingIncludes := LayoutTypesIncludes}

TYPE

PtrArray = ARRAY [0..0] OF Ptr;

GxGlyphcode = UnsignedLongint;
GxGlyphcodePointer = ^GxGlyphcode;
GxGlyphcodeArray = ARRAY [0..0] OF GxGlyphcode;

{ single glyph in a gxFont }
GxByteOffset = LongInt;
GxByteOffsetPointer = ^GxByteOffset;
GxByteOffsetArray = ARRAY [0..0] OF GxByteOffset;

{ byte offset within backing store }

{ The actual constants for feature types and selectors have been moved to a library. }

GxRunFeatureType = UnsignedLongint;
GxRunFeatureTypePointer = ^GxRunFeatureType;
GxRunFeatureTypeArray = ARRAY [0..0] OF GxRunFeatureType;

GxRunFeatureSelector = UnsignedLongint;
GxRunFeatureSelectorPointer = ^GxRunFeatureSelector;
GxRunFeatureSelectorArray = ARRAY [0..0] OF GxRunFeatureSelector;


{
 If tracking is not desired, specify the following value in the track field in the
    gxRunControls record (note that a track of 0 does *not* mean to turn tracking off;
    rather, it means to use normal tracking). 
}


CONST
gxRomanBaseline = 0;
gxIdeographicCenterBaseline = 1;
gxIdeographicLowBaseline = 2;
gxHangingBaseline = 3;
gxMathBaseline = 4;
gxLastBaseline = 31;
gxNumberOfBaselineTypes = 32;
gxNoOverrideBaseline = 255;

TYPE
GxBaselineType = UnsignedLong;
GxBaselineTypePointer = ^GxBaselineType;
GxBaselineTypeArray = ARRAY [0..0] OF GxBaselineType;


GxBaselineDeltas = ARRAY [0..32] OF Fixed;
GxBaselineDeltasPointer = ^GxBaselineDeltas;
GxBaselineDeltasArray = ARRAY [0..0] OF GxBaselineDeltas;


{
 gxJustificationPriority defines the gxPoint during the justification process at which a
    glyph will begin to receive deltas before and after itself. 
}


CONST
gxKashidaPriority = 0;
gxWhiteSpacePriority = 1;
gxInterCharPriority = 2;
gxNullJustificationPriority = 3;
gxNumberOfJustificationPriorities = 4;

TYPE
GxJustificationPriority = Byte;
GxJustificationPriorityPointer = ^GxJustificationPriority;
GxJustificationPriorityArray = ARRAY [0..0] OF GxJustificationPriority;


{
 gxJustificationFlags are used to control which fields of a gxWidthDeltaRecord are to be
    overridden and which are not if a gxPriorityJustificationOverride or
    gxGlyphJustificationOverride (qq.v.) is specified. 
}


CONST
gxOverridePriority = 32768;
gxOverrideLimits = 16384;
gxOverrideUnlimited = 8192;
gxUnlimitedGapAbsorption = 4096;
gxJustificationPriorityMask = 15;
gxAllJustificationFlags = 61455;

TYPE
GxJustificationFlags = UnsignedInteger;
GxJustificationFlagsPointer = ^GxJustificationFlags;
GxJustificationFlagsArray = ARRAY [0..0] OF GxJustificationFlags;


{ The directional behavior of a glyph can be overridden using a gxDirectionOverride. }


CONST
gxNoDirectionOverride = 0;
gxImposeLeftToRight = 1;
gxImposeRightToLeft = 2;
gxImposeArabic = 3;

TYPE
GxDirectionOverride = UnsignedInteger;
GxDirectionOverridePointer = ^GxDirectionOverride;
GxDirectionOverrideArray = ARRAY [0..0] OF GxDirectionOverride;


{ gxRunControlFlags describe the nonparametric layout options contained in a gxStyle. }

GxRunControlFlags = UnsignedLong;
GxRunControlFlagsPointer = ^GxRunControlFlags;
GxRunControlFlagsArray = ARRAY [0..0] OF GxRunControlFlags;


{
 gxHighlightType is used to distinguish various highlighting methods, both in terms of
    character offset based vs. visual based, and in terms of angled sides vs. non-angled
    sides. 
}


CONST
gxHighlightStraight = 0;
gxHighlightAverageAngle = 1;

TYPE
GxHighlightType = UnsignedLong;
GxHighlightTypePointer = ^GxHighlightType;
GxHighlightTypeArray = ARRAY [0..0] OF GxHighlightType;


{
 gxCaretType is used to control whether the caret that is returned from GXGetLayoutCaret
    is a split caret or a (keyboard-syncronized) single caret. 
}


CONST
gxSplitCaretType = 0;
gxLeftRightKeyboardCaret = 1;
gxRightLeftKeyboardCaret = 2;

TYPE
GxCaretType = UnsignedLong;
GxCaretTypePointer = ^GxCaretType;
GxCaretTypeArray = ARRAY [0..0] OF GxCaretType;


{
 gxLayoutOffsetState describes the characteristics of a given gxByteOffset in some
    layout. It is returned by the GXGetOffsetGlyphs call. Note that the gxOffsetInsideLigature
    value is returned in addition to the 8/16 (or invalid) indication. 
}


CONST
gxOffset8_8 = 0;
gxOffset8_16 = 1;
gxOffset16_8 = 2;
gxOffset16_16 = 3;
gxOffsetInvalid = 4;
gxOffsetInsideLigature = 32768;

TYPE
GxLayoutOffsetState = UnsignedInteger;
GxLayoutOffsetStatePointer = ^GxLayoutOffsetState;
GxLayoutOffsetStateArray = ARRAY [0..0] OF GxLayoutOffsetState;


{
 gxLayoutOptionsFlags are single-bit flags contained in a gxLayoutOptions record. We also
    define here some utility constants that are useful in setting various fields in the
    gxLayoutOptions record. 
}

GxLayoutOptionsFlags = UnsignedLong;
GxLayoutOptionsFlagsPointer = ^GxLayoutOptionsFlags;
GxLayoutOptionsFlagsArray = ARRAY [0..0] OF GxLayoutOptionsFlags;


{ A gxRunFeature describes a feature and a level for that feature. }

GxRunFeature = RECORD
	featureType: GxRunFeatureType;
	featureSelector: GxRunFeatureSelector;
	END;
GxRunFeaturePointer = ^GxRunFeature;
GxRunFeatureArray = ARRAY [0..0] OF GxRunFeature;


{
 A gxWidthDeltaRecord contains all of the information needed to describe the behavior of one
    class of glyphs during the justification process. 
}

GxWidthDeltaRecord = RECORD
	beforeGrowLimit: Fixed;
	beforeShrinkLimit: Fixed;
	afterGrowLimit: Fixed;
	afterShrinkLimit: Fixed;
	growFlags: GxJustificationFlags;
	shrinkFlags: GxJustificationFlags;
	END;
GxWidthDeltaPointer = ^GxWidthDeltaRecord;
GxWidthDeltaArray = ARRAY [0..0] OF GxWidthDeltaRecord;


{
 gxPriorityJustificationOverride contains an array of WidthDeltaRecords, one for each
    gxJustificationPriority. 
}

GxPriorityJustificationOverride = RECORD
	deltas: ARRAY [0..4] OF GxWidthDeltaRecord;
	END;
GxPriorityJustificationOverridePointer = ^GxPriorityJustificationOverride;
GxPriorityJustificationOverrideArray = ARRAY [0..0] OF GxPriorityJustificationOverride;


{
 gxGlyphJustificationOverride contains a gxWidthDeltaRecord that is to be used for a
    specific glyph in a specific run (this limitation is because glyphcodes vary by gxFont). 
}

GxGlyphJustificationOverride = RECORD
	glyph: GxGlyphcode;
	override: GxWidthDeltaRecord;
	END;
GxGlyphJustificationOverridePointer = ^GxGlyphJustificationOverride;
GxGlyphJustificationOverrideArray = ARRAY [0..0] OF GxGlyphJustificationOverride;


{ gxRunControls contains flags, shifts, imposed widths and overrides for a run. }
{ NOTE: a value of "gxNoTracking" in track disables tracking }

GxRunControls = RECORD
	flags: GxRunControlFlags;
	beforeWithStreamShift: Fixed;
	afterWithStreamShift: Fixed;
	crossStreamShift: Fixed;
	imposedWidth: Fixed;
	track: Fixed;
	hangingInhibitFactor: Fract;
	kerningInhibitFactor: Fract;
	decompositionAdjustmentFactor: Fixed;
	baselineType: GxBaselineType;
	END;
GxRunControlsPointer = ^GxRunControls;
GxRunControlsArray = ARRAY [0..0] OF GxRunControls;


{
 A gxGlyphSubstitution describes one client-provided substitution that occurs after all
    other automatic glyph changes have happened. 
}

GxGlyphSubstitution = RECORD
	originalGlyph: GxGlyphcode;
	substituteGlyph: GxGlyphcode;
	END;
GxGlyphSubstitutionPointer = ^GxGlyphSubstitution;
GxGlyphSubstitutionArray = ARRAY [0..0] OF GxGlyphSubstitution;


{
 gxKerningAdjustmentFactors specify an adjustment to automatic kerning.
    The adjustment is ax + b where x is the automatic kerning value, a
    is scaleFactor, and b is adjustmentPointSizeFactor times the run's
    gxPoint size. 
}

GxKerningAdjustmentFactors = RECORD
	scaleFactor: Fract;
	adjustmentPointSizeFactor: Fixed;
	END;
GxKerningAdjustmentFactorsPointer = ^GxKerningAdjustmentFactors;
GxKerningAdjustmentFactorsArray = ARRAY [0..0] OF GxKerningAdjustmentFactors;


{
 A gxKerningAdjustment identifies with- and cross-stream kerning adjustments
    for specific glyph pairs. 
}

GxKerningAdjustment = RECORD
	firstGlyph: GxGlyphcode;
	secondGlyph: GxGlyphcode;
	withStreamFactors: GxKerningAdjustmentFactors;
	crossStreamFactors: GxKerningAdjustmentFactors;
	END;
GxKerningAdjustmentPointer = ^GxKerningAdjustment;
GxKerningAdjustmentArray = ARRAY [0..0] OF GxKerningAdjustment;


{
 a value of gxResetCrossStreamFactor in crossStreamFactors.adjustmentPointSizeFactor
    will reset the cross-stream kerning to the baseline. 
}

GxLayoutHitInfo = RECORD
	firstPartialDist: Fixed;
	lastPartialDist: Fixed;
	hitSideOffset: GxByteOffset;
	nonHitSideOffset: GxByteOffset;
	leadingEdge: Boolean;
	inLoose: Boolean;
	END;
GxLayoutHitInfoPointer = ^GxLayoutHitInfo;
GxLayoutHitInfoArray = ARRAY [0..0] OF GxLayoutHitInfo;


{
 A gxLineBaselineRecord contains the deltas from 0 to all the different baselines for
    the layout. It can be filled via a call to GetBaselineDeltas (q.v.). 
}

GxLineBaselineRecord = RECORD
	deltas: GxBaselineDeltas;
	END;
GxLineBaselinePointer = ^GxLineBaselineRecord;
GxLineBaselineArray = ARRAY [0..0] OF GxLineBaselineRecord;


{
 The gxLayoutOptions type contains information about the layout characteristics of the
    whole gxLine. 
}

GxLayoutOptions = RECORD
	width: Fixed;
	flush: Fract;
	just: Fract;
	flags: GxLayoutOptionsFlags;
	baselineRec: ^GxLineBaselineRecord;
	END;
GxLayoutOptionsPointer = ^GxLayoutOptions;
GxLayoutOptionsArray = ARRAY [0..0] OF GxLayoutOptions;



{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
