{
	FILENAME
		PrintingMessages.p

	DESCRIPTION
		This file defines all the universal printing messages,
		and Printing Manager API functions callable only from
		within a message override.

	COPYRIGHT
		Copyright  Apple Computer, Inc. 1989, 1990, 1991, 1992, 1993
		All rights reserved. 
	
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT PrintingMessages;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingPrintingMessages}
{$SETC UsingPrintingMessages := 1}

{$I+}
{$SETC PrintingMessagesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$SETC UsingIncludes := PrintingMessagesIncludes}

CONST



{---------------------------------------}
{ dialog panel constants   }
{---------------------------------------}
	gxPanelNoEvt 					= 0;
	gxPanelOpenEvt 					= 1;		{ initialize and draw }
	gxPanelCloseEvt 				= 2;		{ your panel is going away ( panel switch; confirm or cancel ) }
	gxPanelHitEvt					= 3;		{ there's a hit in your panel }
	gxPanelActivateEvt				= 4;		{ the dialog window has just been activated }
	gxPanelDeactivateEvt 			= 5;		{ the dialog window is about to be deactivated }
	gxPanelIconFocusEvt 			= 6;		{ the focus changes from the panel to the icon list }
	gxPanelPanelFocusEvt 			= 7;		{ the focus changes from the icon list to the panel }
	gxPanelFilterEvt				= 8;		{ this is called to filter every event }
	gxPanelCancelEvt				= 9;		{ the user has cancelled the dialog }
	gxPanelConfirmEvt				= 10;		{ the user has confirmed the dialog }
	gxPanelDialogEvt				= 11;		{ event to be handle by dialoghandler ( you get to see all events ) }
	gxPanelOtherEvt					= 12;		{ osEvts; etc. }
	gxPanelUserWillConfirmEvt		= 13;		{ user has selected confirm; time to parse panel interdependencies }

{ possible panel responses to dialog handler calls }
	gxPanelNoResult			 	= 0;
	gxPanelCancelConfirmation 	= 1;		{ only valid from panelUserWillConfirmEvt - used to keep the dialog from going away }


{ values for the evtAction field in PanelInfoRecord }
	gxOtherAction 				= 0;				{ current item will not change }
	gxClosePanelAction			= 1;				{ panel will be closed }
	gxCancelDialogAction		= 2;				{ dialog will be cancelled }
	gxConfirmDialogAction		= 3;				{ dialog will be confirmed }

	gxApplicationPanel 		= 0;
	gxExtensionPanel		= 1;
	gxDriverPanel			= 2;
	

	gxRangeNotParsed		= 0;		{ default initial value }
	gxRangeParsed			= 1;
	gxRangeBadFromValue		= 2;
	gxRangeBadToValue		= 3;

{----------------------------------------}
{ status-related constants...  }
{----------------------------------------}
	gxNonFatalError = 1;				{ effects icon on spooling dialog }
	gxFatalError = 2;					{ sends up cool alert on spooling dialog }
	gxPrinterReady = 3;					{ signals PFE to leave alert mode }
	gxUserAttention = 4;				{ signals initiation of a modal alert }
	gxUserAlert = 5;					{ signals initiation of a moveable modal alert }
	gxPageTransmission = 6;				{ signals page sent to printer; increments page count in strings to user }
	gxOpenConnectionStatus = 7;			{ signals PFE to begin animation on printer icon }
	gxInformationalStatus = 8;			{ default status type; no side effects }
	gxSpoolingPageStatus = 9;			{ signals page spooled; increments page count in spooling dialog }
	gxEndStatus = 10;					{ signals end of spooling }
	gxPercentageStatus = 11;			{ signals the PFE as to the amount of the job which is currently complete }


{-----------------------------------------------}
{ paper mapping-related constants...  }
{-----------------------------------------------}
	gxDefaultTrayMapping		= 0;
	gxConfiguredTrayMapping		= 1;

{ ------------------------------------------------------------------------------

					Constants for Universal Printing Messages

-------------------------------------------------------------------------------- }



{ options for gxCreateSpoolFile message }
	gxNoCreateOptions	= $00000000;		{ just create the file }
	gxInhibitAlias		= $00000001;		{ do not create an alias in the PMD folder }
	gxInhibitUniqueName	= $00000002;		{ do not append to the filename to make it unique }


{options for gxCloseSpoolFile message }
	gxNoCloseOptions	= $00000000;		{ just close the file }
	gxDeleteOnClose		= $00000001;		{ delete the file rather than closing it }
	gxUpdateJobData		= $00000002;		{ write current job information into file prior to closing }
	gxMakeRemoteFile	= $00000004;		{ mark job as a remote file }


{ options for gxCreateImageFile message }
	gxNoImageFile 		= $00000000;				{ don't create image file }
	gxMakeImageFile 	= $00000001;				{ create an image file }
	gxEachPlane			= $00000002;				{ only save up planes before rewinding }
	gxEachPage			= $00000004;				{ save up entire pages before rewinding }
	gxEntireFile		= gxEachPlane + gxEachPage;	{ save up the entire file before rewinding }


{ options for gxBufferData message }
	gxNoBufferOptions	= $00000000, 
	gxMakeBufferHex		= $00000001; 
	gxDontSplitBuffer	= $00000002;




TYPE

{--------------------------}
{ abstract data types...   }
{--------------------------}

gxSpoolFile = ^LONGINT;
gxPanelEvent = LONGINT;
gxPanelResult = LONGINT;

gxPanelInfoRecord  = PACKED RECORD
	panelEvt: gxPanelEvent;			{ why we're calling }
	panelResId: INTEGER;			{ 'ppnl' resource id of current panel }
	pDlg: DialogPtr;				{ pointer to dialog }
	theEvent: EventRecordPtr;		{ pointer to event }
	itemHit: INTEGER;				{ actual item number as dialog mgr thinks }
	itemCount: INTEGER;				{ number of items before your items }
	evtAction: INTEGER;				{ once this event is processed;; the action that will result }
										{ (only meaningful in filtering; used for parsing) }
	errorStringId: INTEGER;			{ STR id of string to put in error alert (0 means no string) }
	theFormat: gxFormat;			{ the current format (only meaningful in a format dialog) }
	refCon: LongInt;				{ refCon passed in PanelSetupRecord }
	END;
					

gxPrintingPanelKind = LONGINT;

{ The gxPanelSetupInfo structure is passed to the dialog handler when the client calls }
{ to setup panels for the dialog }


gxPanelSetupRecord  = PACKED RECORD
	panelKind: gxPrintingPanelKind;
	panelResId: INTEGER;
	resourceRefNum: INTEGER;
	refCon: LongInt;
	END;


gxParsePageRangeResult = LONGINT;		{ returned by gxParsePageRange message }

gxStatusRecord  = PACKED RECORD			{ for status messages }
	statusType: INTEGER;				{ one of the ids listed above ( nonFatalError; etc. ) }
	statusId: INTEGER;					{ specific status ( out of paper; etc. ) - To be defined }
	statusAlertId: INTEGER;				{	cool alert id (if any) for status }
	statusOwner: Signature;				{ creator type of status owner }
	statResId: INTEGER;					{ id for 'stat' resource }
	statResIndex: INTEGER;				{ index into 'stat' resource for this status }
	dialogResult: INTEGER;				{ id of button string selected on dismissal of cool alert }
	bufferLen: INTEGER;					{ number of bytes in status buffer - total record size must be <= 512 }
	statusBuffer: ARRAY [1..1] OF Byte;	{ user response from alert }
	END;


gxDisplayRecord  = PACKED RECORD		{ for WriteStatusToDTPWindow message }
	useText: Boolean;
	hPicture: Handle;
	theText: Str255;
	END;


gxTrayMapping = LONGINT;

gxPrintingBuffer  = PACKED RECORD		{ for gxDumpBuffer and gxFreeBuffer messages }
	size: LongInt;						{	size of buffer in bytes }
	userData: LongInt;					{	client assigned id for the buffer }
	data: ARRAY [1..1] OF Byte;			{ array of size bytes }
	END;



gxPageInfoRecord  = PACKED RECORD		{ for gxRenderPage message }
	docPageNum: LongInt;				{ number of page being printed }
	copyNum: LongInt;					{ copy number being printed }
	formatChanged: Boolean;				{ true if format changed from last page }
	pageChanged: Boolean;				{ true if page contents changed from last page }
	internalUse: LongInt;				{ private }
	END;



{ ------------------------------------------------------------------------------

				API Functions callable only from within message overrides

-------------------------------------------------------------------------------- }

FUNCTION GXGetJob: gxJob;
	C;

FUNCTION GXGetMessageHandlerResFile: INTEGER;
	C;
	
FUNCTION GXSpoolingAborted: Boolean;
	C;
	
FUNCTION GXJobIdle: OSErr;
	C;

FUNCTION GXReportStatus ( statusID: INTEGER;  statusIndex: INTEGER): OSErr;
	C;

FUNCTION GXAlertTheUser (VAR theStatus: gxStatusRecord): OSErr;
	C;

FUNCTION GXSetupDialogPanel (VAR theSetup: gxPanelSetupRecord): OSErr;
	C;

FUNCTION GXCountTrays (VAR numTrays: gxTrayIndex): OSErr;
	C;
	
FUNCTION GXGetTrayName (trayNumber: gxTrayIndex; VAR trayName: Str31): OSErr;
	C;

FUNCTION GXSetTrayPaperType (whichTray: gxTrayIndex; thePaperType: gxPaperType): OSErr;
	C;

FUNCTION GXGetTrayPaperType (whichTray: gxTrayIndex; thePaperType: gxPaperType): OSErr;
	C;

FUNCTION GXGetTrayMapping (VAR theMapping: gxTrayMapping): OSErr;
	C;

PROCEDURE GXCleanupStartJob;
	C;

PROCEDURE GXCleanupStartPage;
	C;

PROCEDURE GXCleanupOpenConnection;
	C;

PROCEDURE GXCleanupStartSendPage;
	C;


{ ------------------------------------------------------------------------------

								Universal Printing Messages

-------------------------------------------------------------------------------- }


FUNCTION Send_GXJobIdle: OSErr;
	C;
FUNCTION Forward_GXJobIdle : OSErr;
	C;

FUNCTION Send_GXJobStatus (VAR pStatus: gxStatusRecord): OSErr;
	C;
FUNCTION Forward_GXJobStatus (VAR pStatus: gxStatusRecord): OSErr;
	C;

FUNCTION Send_GXPrintingEvent (theEvent: EventRecordPtr; filterEvent: Boolean): OSErr;
	C;
FUNCTION Forward_GXPrintingEvent (theEvent: EventRecordPtr; filterEvent: Boolean): OSErr;
	C;


FUNCTION Send_GXJobDefaultFormatDialog (VAR dlgResult: gxDialogResult): OSErr;
	C;
FUNCTION Forward_GXJobDefaultFormatDialog (VAR dlgResult: gxDialogResult): OSErr;
	C;
	
FUNCTION Send_GXFormatDialog (theFormat: gxFormat; title: StringPtr; VAR dlgResult: gxDialogResult): OSErr;
	C;
FUNCTION Forward_GXFormatDialog (theFormat: gxFormat; title: StringPtr; VAR dlgResult: gxDialogResult): OSErr;
	C;
	
FUNCTION Send_GXJobPrintDialog (VAR dlgResult: gxDialogResult): OSErr;
	C;
FUNCTION Forward_GXJobPrintDialog (VAR dlgResult: gxDialogResult): OSErr;
	C;

FUNCTION Send_GXFilterPanelEvent (VAR pHitInfo: gxPanelInfoRecord; VAR returnImmed: Boolean): OSErr;
	C;

FUNCTION Send_GXHandlePanelEvent (VAR pHitInfo: gxPanelInfoRecord; VAR panelResponse: gxPanelResult): OSErr;
	C;

FUNCTION Send_GXParsePageRange (fromString: StringPtr; toString: StringPtr; VAR result: gxParsePageRangeResult): OSErr;
	C;
FUNCTION Forward_GXParsePageRange (fromString: StringPtr; toString: StringPtr; VAR result: gxParsePageRangeResult): OSErr;
	C;
	
	
FUNCTION Send_GXDefaultJob : OSErr;
	C;
FUNCTION Forward_GXDefaultJob : OSErr;
	C;
	
FUNCTION Send_GXDefaultFormat (theFormat: gxFormat): OSErr;
	C;
FUNCTION Forward_GXDefaultFormat (theFormat: gxFormat): OSErr;
	C;

FUNCTION Send_GXDefaultPaperType (thePaperType: gxPaperType ): OSErr;
	C;
FUNCTION Forward_GXDefaultPaperType (thePaperType: gxPaperType ): OSErr;
	C;
	
FUNCTION Send_GXDefaultPrinter (thePrinter: gxPrinter): OSErr;
	C;
FUNCTION Forward_GXDefaultPrinter (thePrinter: gxPrinter): OSErr;
	C;
	

FUNCTION Send_GXCreateSpoolFile (pFileSpec: FSSpecPtr; createOptions: LongInt; VAR theSpoolFile: gxSpoolFile): OSErr;
	C;
FUNCTION Forward_GXCreateSpoolFile (pFileSpec: FSSpecPtr; createOptions: LongInt; VAR theSpoolFile: gxSpoolFile): OSErr;
	C;
	
FUNCTION Send_GXSpoolPage (theSpoolFile: gxSpoolFile; theFormat: gxFormat; thePage: gxShape): OSErr;
	C;
FUNCTION Forward_GXSpoolPage (theSpoolFile: gxSpoolFile; theFormat: gxFormat; thePage: gxShape): OSErr;
	C;

FUNCTION Send_GXSpoolData (theSpoolFile: gxSpoolFile; data: Ptr; VAR length: LongInt): OSErr;
	C;
FUNCTION Forward_GXSpoolData (theSpoolFile: gxSpoolFile; data: Ptr; VAR length: LongInt): OSErr;
	C;

FUNCTION Send_GXSpoolResource (theSpoolFile: gxSpoolFile; theResource: Handle; theType: ResType; id: INTEGER): OSErr;
	C;
FUNCTION Forward_GXSpoolResource (theSpoolFile: gxSpoolFile; theResource: Handle; theType: ResType; id: INTEGER): OSErr;
	C;

FUNCTION Send_GXCompleteSpoolFile (theSpoolFile: gxSpoolFile): OSErr;
	C;
FUNCTION Forward_GXCompleteSpoolFile (theSpoolFile: gxSpoolFile): OSErr;
	C;


FUNCTION Send_GXCountPages (theSpoolFile: gxSpoolFile; VAR numPages: LongInt): OSErr;
	C;
FUNCTION Forward_GXCountPages (theSpoolFile: gxSpoolFile; VAR numPages: LongInt): OSErr;
	C;

FUNCTION Send_GXDespoolPage (theSpoolFile: gxSpoolFile; numPages: LongInt; theFormat: gxFormat; VAR thePage: gxShape; VAR formatChanged: Boolean): OSErr;
	C;
FUNCTION Forward_GXDespoolPage (theSpoolFile: gxSpoolFile; numPages: LongInt; theFormat: gxFormat; VAR thePage: gxShape; VAR formatChanged: Boolean): OSErr;
	C;

FUNCTION Send_GXDespoolData (theSpoolFile: gxSpoolFile; data:Ptr; VAR length: LongInt): OSErr;
	C;
FUNCTION Forward_GXDespoolData (theSpoolFile: gxSpoolFile; data:Ptr; VAR length: LongInt): OSErr;
	C;

FUNCTION Send_GXDespoolResource (theSpoolFile: gxSpoolFile; theType: ResType; id: INTEGER; VAR theResource: Handle): OSErr;
	C;
FUNCTION Forward_GXDespoolResource (theSpoolFile: gxSpoolFile; theType: ResType; id: INTEGER; VAR theResource: Handle): OSErr;
	C;

FUNCTION Send_GXCloseSpoolFile (theSpoolFile: gxSpoolFile; closeOptions: LongInt): OSErr;
	C;
FUNCTION Forward_GXCloseSpoolFile (theSpoolFile: gxSpoolFile; closeOptions: LongInt): OSErr;
	C;
	
	
FUNCTION Send_GXStartJob (docName: StringPtr; pageCount: LongInt): OSErr;
	C;
FUNCTION Forward_GXStartJob (docName: StringPtr; pageCount: LongInt): OSErr;
	C;
	
FUNCTION Send_GXFinishJob : OSErr;
	C;
FUNCTION Forward_GXFinishJob : OSErr;
	C;
	
FUNCTION Send_GXStartPage (theFormat: gxFormat; numViewPorts: LongInt; VAR viewPortList: gxViewPort) : OSErr;
	C;
FUNCTION Forward_GXStartPage (theFormat: gxFormat; numViewPorts: LongInt; VAR viewPortList: gxViewPort) : OSErr;
	C;

FUNCTION Send_GXFinishPage : OSErr;
	C;
FUNCTION Forward_GXFinishPage : OSErr;
	C;
	
FUNCTION Send_GXPrintPage (theFormat: gxFormat; thePage: gxShape) : OSErr;
	C;
FUNCTION Forward_GXPrintPage (theFormat: gxFormat; thePage: gxShape) : OSErr;
	C;
	

FUNCTION Send_GXSetupImageData (imageData: Ptr) : OSErr;
	C;
FUNCTION Forward_GXSetupImageData (imageData: Ptr) : OSErr;
	C;

FUNCTION Send_GXImageJob(theSpoolFile: gxSpoolFile, VAR closeOptions: LongInt): OSErr;
	C;
FUNCTION Forward_GXImageJob (theSpoolFile: gxSpoolFile, VAR closeOptions: LongInt): OSErr;
	C;

FUNCTION Send_GXImageDocument (theSpoolFile: gxSpoolFile; imageData: Ptr): OSErr;
	C;
FUNCTION Forward_GXImageDocument (theSpoolFile: gxSpoolFile; imageData: Ptr): OSErr;
	C;

FUNCTION Send_GXImagePage (theSpoolFile: gxSpoolFile; pageNumber: LongInt; theFormat: gxFormat; imageData: Ptr): OSErr;
	C;
FUNCTION Forward_GXImagePage (theSpoolFile: gxSpoolFile; long pageNumber, theFormat: gxFormat; imageData: Ptr): OSErr;
	C;

FUNCTION Send_GXRenderPage (theFormat: gxFormat; thePage: gxShape; VAR pageInfo: gxPageInfoRecord; imageData: Ptr): OSErr;
	C;
FUNCTION Forward_GXRenderPage (theFormat: gxFormat; thePage: gxShape; VAR pageInfo: gxPageInfoRecord; imageData: Ptr): OSErr;
	C;


FUNCTION Send_GXCreateImageFile (pFileSpec: FSSpecPtr; imageFileOptions: LongInt; VAR theImageFile: LongInt): OSErr;
	C;
FUNCTION Forward_GXCreateImageFile (pFileSpec: FSSpecPtr; imageFileOptions: LongInt; VAR theImageFile: LongInt): OSErr;
	C;


FUNCTION Send_GXOpenConnection : OSErr;
	C;
FUNCTION Forward_GXOpenConnection : OSErr;
	C;

FUNCTION Send_GXCloseConnection : OSErr;
	C;
FUNCTION Forward_GXCloseConnection : OSErr;
	C;

FUNCTION Send_GXStartSendPage (theFormat: gxFormat): OSErr;
	C;
FUNCTION Forward_GXStartSendPage (theFormat: gxFormat): OSErr;
	C;

FUNCTION Send_GXFinishSendPage : OSErr;
	C;
FUNCTION Forward_GXFinishSendPage : OSErr;
	C;


FUNCTION Send_GXWriteData (data: Ptr; length: LongInt): OSErr;
	C;
FUNCTION Forward_GXWriteData (data: Ptr; length: LongInt): OSErr;
	C;

FUNCTION Send_GXBufferData (data: Ptr; length: LongInt; bufferOptions: LongInt ): OSErr;
	C;
FUNCTION Forward_GXBufferData (data: Ptr; length: LongInt; bufferOptions: LongInt ): OSErr;
	C;

FUNCTION Send_GXDumpBuffer (VAR theBuffer: gxPrintingBuffer): OSErr;
	C;
FUNCTION Forward_GXDumpBuffer (VAR theBuffer: gxPrintingBuffer): OSErr;
	C;

FUNCTION Send_GXFreeBuffer (VAR theBuffer: gxPrintingBuffer): OSErr;
	C;
FUNCTION Forward_GXFreeBuffer (VAR theBuffer: gxPrintingBuffer): OSErr;
	C;


FUNCTION Send_GXCheckStatus (data: Ptr; length: LongInt; statusType: INTEGER; owner: Signature ): OSErr;
	C;
FUNCTION Forward_GXCheckStatus (data: Ptr; length: LongInt; statusType: INTEGER; owner: Signature ): OSErr;
	C;

FUNCTION Send_GXGetDeviceStatus (cmdData: Ptr; cmdSize: LongInt; responseData: Ptr; VAR responseSize: LongInt; termination: Str255 ): OSErr;
	C;
FUNCTION Forward_GXGetDeviceStatus (Ptr cmdData, long cmdSize, Ptr responseData, long *responseSize, Str255 termination): OSErr;
	C;


FUNCTION Send_GXFetchTaggedData (data: Ptr; length: LongInt; VAR data: Handle; owner: Signature ): OSErr;
	C;
FUNCTION Forward_GXFetchTaggedData (data: Ptr; length: LongInt; VAR data: Handle; owner: Signature ): OSErr;
	C;


OSErr	Send_GXGetDTPMenuList (menuHdl: MenuHandle): OSErr;
	C;
OSErr	Forward_GXGetDTPMenuList (menuHdl: MenuHandle): OSErr;
	C;

OSErr	Send_GXDTPMenuSelect (id: INTEGER): OSErr;
	C;
OSErr	Forward_GXDTPMenuSelect (id: INTEGER): OSErr;
	C;

OSErr	Send_GXHandleAlertFilter (theJob: gxJob; VAR pStatusRec: gxStatusRecord; pDialog: DialogPtr; theEvent: EventRecordPtr; VAR itemHit: INTEGER; VAR returnImmed: Boolean): OSErr;
	C;
OSErr	Forward_GXHandleAlertFilter (theJob: gxJob; VAR pStatusRec: gxStatusRecord; pDialog: DialogPtr; theEvent: EventRecordPtr; VAR itemHit: INTEGER; VAR returnImmed: Boolean): OSErr;
	C;
	

FUNCTION Send_GXJobFormatModeQuery (theQuery: gxQueryType; srcData: Ptr; dstData: Ptr): OSErr;
	C;
FUNCTION Forward_GXJobFormatModeQuery (theQuery: gxQueryType; srcData: Ptr; dstData: Ptr): OSErr;
	C;

FUNCTION Send_GXWriteStatusToDTPWindow (VAR pStatusRec: gxStatusRecord; VAR pDisplay: gxDisplayRecord): OSErr;
	C;
FUNCTION Forward_GXWriteStatusToDTPWindow (VAR pStatusRec: gxStatusRecord; VAR pDisplay: gxDisplayRecord): OSErr;
	C;

FUNCTION Send_GXInitializeStatusAlert (VAR pStatusRec: gxStatusRecord; pDialog: DialogPtr): OSErr;
	C;
FUNCTION Forward_GXInitializeStatusAlert (VAR pStatusRec: gxStatusRecord; pDialog: DialogPtr): OSErr;
	C;

FUNCTION Send_GXHandleAlertStatus (VAR pStatusRec: gxStatusRecord): OSErr;
	C;
FUNCTION Forward_GXHandleAlertStatus (VAR pStatusRec: gxStatusRecord): OSErr;
	C;
	
FUNCTION Send_GXHandleAlertEvent (VAR pStatusRec: gxStatusRecord; pDialog: DialogPtr; theEvent: EventRecordPtr; VAR response: INTEGER): OSErr;
	C;
FUNCTION Forward_GXHandleAlertEvent (VAR pStatusRec: gxStatusRecord; pDialog: DialogPtr; theEvent: EventRecordPtr; VAR response: INTEGER): OSErr;
	C;
		

PROCEDURE Send_GXCleanupStartJob;
	C;
PROCEDURE Forward_GXCleanupStartJob;
	C;

PROCEDURE Send_GXCleanupStartPage;
	C;
PROCEDURE Forward_GXCleanupStartPage;
	C;

PROCEDURE Send_GXCleanupOpenConnection;
	C;
PROCEDURE Forward_GXCleanupOpenConnection;
	C;

PROCEDURE Send_GXCleanupStartSendPage;
	C;
PROCEDURE Forward_GXCleanupStartSendPage;
	C;


FUNCTION Send_GXDefaultDesktopPrinter (dtpName: Str31): OSErr;
	C;
FUNCTION Forward_GXDefaultDesktopPrinter (dtpName: Str31): OSErr;
	C;
	
FUNCTION Send_GXCaptureOutputDevice (capture: Boolean): OSErr;
	C;
FUNCTION Forward_GXCaptureOutputDevice (capture: Boolean): OSErr;
	C;


FUNCTION Send_GXOpenConnectionRetry (theType: ResType; retry: LongInt, VAR retryopenPtr: Boolean; anErr: OSErr): OSErr;
	C;
FUNCTION Forward_GXOpenConnectionRetry (theType: ResType; retry: LongInt, VAR retryopenPtr: Boolean; anErr: OSErr): OSErr;
	C;
	
FUNCTION Send_GXExamineSpoolFile (theSpoolFile: gxSpoolFile): OSErr;
	C;
FUNCTION Forward_GXExamineSpoolFile (theSpoolFile: gxSpoolFile): OSErr;
	C;

FUNCTION Send_GXFinishSendPlane : OSErr;
	C;
FUNCTION Forward_GXFinishSendPlane : OSErr;
	C;

FUNCTION Send_GXDoesPaperFit( whichTray: gxTrayIndex; paper: gxPaperType; VAR fits: Boolean ): OSErr;
	C;
FUNCTION Forward_GXDoesPaperFit( whichTray: gxTrayIndex; paper: gxPaperType; VAR fits: Boolean ): OSErr;
	C;
	
FUNCTION Send_GXChooserMessage (message: INTEGER; caller: INTEGER; objName: StringPtr;
									zoneName: StringPtr; theList:ListHandle; p2: LongInt): OSErr;
	C;
FUNCTION Forward_GXChooserMessage (message: INTEGER; caller: INTEGER; objName: StringPtr;
									zoneName: StringPtr; theList:ListHandle; p2: LongInt): OSErr;
	C;


FUNCTION Send_GXFindPrinterProfile (thePrinter: gxPrinter; searchData: Ptr; index: LongInt; VAR returnedProfile; VAR numProfiles: LongInt): OSErr;
	C;
FUNCTION Forward_GXFindPrinterProfile (thePrinter: gxPrinter; searchData: Ptr; index: LongInt; VAR returnedProfile; VAR numProfiles: LongInt): OSErr;
	C;
	
FUNCTION Send_GXFindFormatProfile (theFormat: gxFormat; searchData: Ptr; index: LongInt; VAR returnedProfile; VAR numProfiles: LongInt): OSErr;
	C;
FUNCTION Forward_GXFindFormatProfile (theFormat: gxFormat; searchData: Ptr; index: LongInt; VAR returnedProfile; VAR numProfiles: LongInt): OSErr;
	C;
	
FUNCTION Send_GXSetPrinterProfile (thePrinter: gxPrinter; oldProfile: gxColorProfile; newProfile: gxColorProfile): OSErr;
	C;
FUNCTION Forward_GXSetPrinterProfile (thePrinter: gxPrinter, oldProfile: gxColorProfile; newProfile: gxColorProfile): OSErr;
	C;

FUNCTION Send_GXSetFormatProfile (theFormat: gxFormat; oldProfile: gxColorProfile; newProfile: gxColorProfile): OSErr;
	C;
FUNCTION Forward_GXSetFormatProfile (theFormat: gxFormat; oldProfile: gxColorProfile; newProfile: gxColorProfile): OSErr;
	C;



{$ENDC}    { UsingPrintingMessages }

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
