{

FILENAME
	PrintingResTypes.p

DESCRIPTION
	This module contains resource constants which can be
	included by the C compiler or the Rez compiler.  These constants
	are used by creators of Printer Drivers or Printing Extensions.
		
COPYRIGHT
	 Copyright Apple Computer, Inc. 1988-1993
	 All rights reserved. 
	
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT PrintingResTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingPrintingResTypes}
{$SETC UsingPrintingResTypes := 1}

{$I+}
{$SETC PrintingResTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}
{$SETC UsingIncludes := PrintingResTypesIncludes}

{ Constants }


CONST

{ ------------------------------------------------------------------------------- }
{ Basic client types }
{ ------------------------------------------------------------------------------- }


	gxPrintingManagerType =		'pmgr';

	gxImagingSystemType =		'gxis';
	gxPrinterDriverType =		'pdvr';
	gxPrintingExtensionType =	'pext';

	gxUnknownPrinterType =		'none';
	gxAnyPrinterType =			'univ';
	gxQuickdrawPrinterType =	'qdrw';
	gxPortableDocPrinterType =	'gxpd';

	gxRasterPrinterType =		'rast';
	gxPostscriptPrinterType =	'post';
	gxVectorPrinterType =		'vect';


{ ------------------------------------------------------------------------------- }
{ Printing collection tags have the following ID }
{ ------------------------------------------------------------------------------- }


	gxPrintingTagID = (-28672);


{ ------------------------------------------------------------------------------- }
{ Resource types and IDs used by both extension and driver writers }
{ ------------------------------------------------------------------------------- }


{ Resources in a printer driver or extension must be based off of this ID }

	gxPrintingDriverBaseID = (-27648);
	gxPrintingExtensionBaseID = (-27136);

{ override resources tell the system what messages a driver or extension }
{ is overriding.  A driver may have a series of these resources. }

	gxOverrideType =			'over';
	



{ ------------------------------------------------------------------------------- }
{ Message ID definitions by both extension and driver writers }
{ ------------------------------------------------------------------------------- }


{ identifiers for universal message overrides... }


	gxInitialize =				0;
	gxShutDown =				1;

	gxJobIdle =					2;
	gxJobStatus =				3;
	gxPrintingEvent =			4;

	gxJobDefaultFormatDialog =	5;
	gxFormatDialog =			6;
	gxJobPrintDialog =			7;
	gxFilterPanelEvent =		8;
	gxHandlePanelEvent =		9;
	gxParsePageRange =			10;

	gxDefaultJob =				11;
	gxDefaultFormat =			12;
	gxDefaultPaperType =		13;
	gxDefaultPrinter =			14;

	gxCreateSpoolFile =			15;
	gxSpoolPage =				16;
	gxSpoolData =				17;
	gxSpoolResource =			18;
	gxCompleteSpoolFile =		19;

	gxCountPages =				20;
	gxDespoolPage =				21;
	gxDespoolData =				22;
	gxDespoolResource =			23;
	gxCloseSpoolFile =			24;

	gxStartJob =				25;
	gxFinishJob =				26;
	gxStartPage =				27;
	gxFinishPage =				28;
	gxPrintPage =				29;

	gxSetupImageData =			30;
	gxImageJob =				31;
	gxImageDocument =			32;
	gxImagePage =				33;
	gxRenderPage =				34;
	gxCreateImageFile =			35;

	gxOpenConnection =			36;
	gxCloseConnection =			37;
	gxStartSendPage =			38;
	gxFinishSendPage =			39;

	gxWriteData =				40;
	gxBufferData =				41;
	gxDumpBuffer =				42;
	gxFreeBuffer =				43;

	gxCheckStatus =				44;
	gxGetDeviceStatus =			45;

	gxFetchTaggedData =			46;

	gxGetDTPMenuList =			47;
	gxDTPMenuSelect =			48;
	gxHandleAlertFilter =		49;

	gxJobFormatModeQuery =		50;

	gxWriteStatusToDTPWindow =	51;
	gxInitializeStatusAlert =	52;
	gxHandleAlertStatus =		53;
	gxHandleAlertEvent =		54;

	gxCleanupStartJob =			55;
	gxCleanupStartPage =		56;
	gxCleanupOpenConnection =	57;
	gxCleanupStartSendPage =	58;

	gxDefaultDesktopPrinter =	59;
	gxCaptureOutputDevice =		60;

	gxOpenConnectionRetry =		61;
	gxExamineSpoolFile =		62;

	gxFinishSendPlane =			63;
	gxDoesPaperFit =			64;
	gxChooserMessage =			65;

	gxFindPrinterProfile =		66;
	gxFindFormatProfile =		67;
	gxSetPrinterProfile =		68;
	gxSetFormatProfile =		69;

{ identifiers for Quickdraw message overrides... }


	gxPrOpenDoc = 	 			0;
	gxPrCloseDoc = 	 			1;
	gxPrOpenPage = 	 			2;
	gxPrClosePage =  			3;
	gxPrintDefault = 			4;
	gxPrStlDialog =  			5;
	gxPrJobDialog =  			6;
	gxPrStlInit = 				7;
	gxPrJobInit = 	 			8;
	gxPrDlgMain = 	 			9;
	gxPrValidate = 	 			10;
	gxPrJobMerge = 	 			11;
	gxPrGeneral = 	 			12;
	gxConvertPrintRecordTo =	13;
	gxConvertPrintRecordFrom =	14;
	gxPrintRecordToJob = 	 	15;


{ identifiers for raster imaging message overrides... }


	gxRasterDataIn =			0;
	gxRasterLineFeed =			1;
	gxRasterPackageBitmap =		2;


{ identifiers for PostScript imaging message overrides... }


		gxPostscriptQueryPrinter =					0;
		gxPostscriptInitializePrinter =				1;
		gxPostscriptResetPrinter =					2;
		gxPostscriptExitServer =					3;
		gxPostscriptGetStatusText =					4;
		gxPostscriptGetPrinterText =				5;
		gxPostscriptScanStatusText =				6;
		gxPostscriptScanPrinterText =				7;
		gxPostscriptGetDocumentProcSetList =		8;
		gxPostscriptDownloadProcSetList =			9;
		gxPostscriptGetPrinterGlyphsInformation =	10;
		gxPostscriptStreamFont =					11;
		gxPostscriptDoDocumentHeader =				12;
		gxPostscriptDoDocumentSetUp =				13;
		gxPostscriptDoDocumentTrailer =				14;
		gxPostscriptDoPageSetUp =					15;
		gxPostscriptSelectPaperType =				16;
		gxPostscriptDoPageTrailer =					17;
		gxPostscriptEjectPage =						18;
		gxPostscriptProcessShape =					19;


{ identifiers for Vector imaging message overrides... }


	gxVectorPackageData =		0;
	gxVectorLoadPens =	 		1;
	gxVectorVectorizeShape =	2;

{ printing alert type }

	gxPrintingAlertType	=	'plrt';

	gxStatusType	=		'stat';
	gxExtendedDITLType	=	'xdtl';
	gxPrintPanelType	=	'ppnl';

	gxCollectionType	=	'cltn';

// communication resource types 

/*
	The looker resource is used by the Chooser PACK to determine what kind
	of communications this driver supports. (In order to generate/handle the 
	pop-up menu for "Connect via:".
	
	The looker resource is also used by PrinterShare to determine the AppleTalk NBP Type
	for servers created for this driver.
*/
	gxLookerType	= 'look';
	gxLookerID		= -4096;
{ ---------------------------------- 'comm' ---------------------------------- }
{ The communications method and private data used to connect to the printer }
	gxDeviceCommunicationsType = 			'comm';


{ ------------------------------------------------------------------------------- }
{ Resource types and IDs used by extension writers }
{ ------------------------------------------------------------------------------- }


	gxExtensionUniversalOverrideID =		gxPrintingExtensionBaseID;

	gxExtensionImagingOverrideSelectorID =	gxPrintingExtensionBaseID;

	gxExtensionScopeType =			'scop';
		gxDriverScopeID =				gxPrintingExtensionBaseID;
		gxPrinterScopeID =				gxPrintingExtensionBaseID + 1;
		gxPrinterExceptionScopeID =		gxPrintingExtensionBaseID + 2;

	gxExtensionLoadType =			'load';
		gxExtensionLoadID =				gxPrintingExtensionBaseID;
	
		gxExtensionLoadFirst =			0x00000100;
		gxExtensionLoadAnywhere =		0x7FFFFFFF;
		gxExtensionLoadLast =			0xFFFFFF00;

	gxExtensionOptimizationType =	'eopt';
		gxExtensionOptimizationID =		gxPrintingExtensionBaseID;


{ ------------------------------------------------------------------------------- }
{ Resource types and IDs used by driver writers }
{ ------------------------------------------------------------------------------- }


	gxDriverUniversalOverrideID =		(gxPrintingDriverBaseID);
	gxDriverImagingOverrideID =			(gxPrintingDriverBaseID + 1);
	gxDriverCompatibilityOverrideID =	(gxPrintingDriverBaseID + 2);


	gxDriverFileFormatType =			'pfil';
	gxDriverFileFormatID =				(gxPrintingDriverBaseID);


{ IMAGING RESOURCES }

{ The imaging system resource specifies which imaging system a printer }
{ driver wishes to use. }

	gxImagingSystemSelectorType =		'isys';
	gxImagingSystemSelectorID =			(gxPrintingDriverBaseID);


{ 'exft' resource ID -- exclude font list }
	kExcludeFontListType =		'exft';
	kExcludeFontListID =		(gxPrintingDriverBaseID);

{ Resource for type for color matching }

	gxColorMatchingDataType =			'prof';
	gxColorMatchingDataID =				(gxPrintingDriverBaseID);


{ Resource type and id for the tray count }

	gxTrayCountDataType =				'tray';
	gxTrayCountDataID =					(gxPrintingDriverBaseID);


{ Resource type for the tray names }

	gxTrayNameDataType =				'tryn';


{ IO Resources }

{ Resource type and ID for default IO and buffering resources }

	gxUniversalIOPrefsType =			'iobm';
	gxUniversalIOPrefsID =				(gxPrintingDriverBaseID);


{ Resource types and IDs for default implementation of CaptureOutputDevice. }
{ The default implementation of CaptureOutputDevice only handles PAP devices }

	gxCaptureType =							'cpts';
	gxCaptureStringID =						(gxPrintingDriverBaseID);
	gxReleaseStringID =						(gxPrintingDriverBaseID + 1);
	gxUncapturedAppleTalkType =				(gxPrintingDriverBaseID + 2);
	gxCapturedAppleTalkType =				(gxPrintingDriverBaseID + 3);


{ Resource type and ID for raster driver rendering preferences }

	gxRasterPrefsType =					'rdip';
		gxRasterPrefsID =				(gxPrintingDriverBaseID);


{ Resource type for specifiying a colorSet }

	gxColorSetResType =	'crst';


{ Resource type and ID for raster driver packaging preferences }

	gxRasterPackType =					'rpck';
	gxRasterPackID =					(gxPrintingDriverBaseID);


{ Resource type and ID for raster driver packaging options }

	gxRasterNumNone =			0;	{ number isn't output at all }
	gxRasterNumDirect =			1;	{ lowest minWidth bytes as data }
	gxRasterNumToASCII =		2;	{ minWidth ASCII characters }

	gxRasterPackOptionsType =			'ropt';
	gxRasterPackOptionsID =				(gxPrintingDriverBaseID);


{ Resource type for the PostScript imaging system procedure set control resource }

	gxPostscriptProcSetControlType =	'prec';


{ Resource type for the PostScript imaging system printer font resource }

	gxPostscriptPrinterFontType = 		'pfnt';


{ Resource type and id for the PostScript imaging system imaging preferences }

	gxPostscriptPrefsType =				'pdip';
	gxPostscriptPrefsID =				(gxPrintingDriverBaseID);

{ Resource type and id for the PostScript imaging system default scanning code }

	gxPostscriptScanningType =			'scan';
	gxPostscriptScanningID =			(gxPrintingDriverBaseID);


{ Old Application Support Resources }

	gxCustType = 			'cust';
	gxCustID = 				-8192;

	gxReslType = 			'resl';
	gxReslID = 	 			-8192;
	gxDiscreteResolution = 	0;

	gxStlDialogResID = 		-8192;
	gxJobDialogResID = 		-8191;


	gxScaleTableType =		'stab';
	gxDITLControlType = 	'dctl';
	gxPrintRecordType =		'PREC';

{ ------------------------------------------------------------------------------- }
{ Resource types and IDs used in papertype files }
{ ------------------------------------------------------------------------------- }


{ Resource type and ID for driver papertypes placed in individual files }

	gxSignatureType =					'sig ';
	gxPapertypeSignatureID =			0;


{ file type for driver papertypes placed in individual files }

	gxDrvrPaperType =					'drpt';


{ Paper Type Creators (OSType's) }

	gxSysPaperType	= 'sypt';	{ System paper type creator }
	gxUserPaperType	= 'uspt';	{ User paper type creators  }

	gxPaperTypeType		= 'ptyp';


{$ENDC}    { UsingPrintingResTypes }

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
