{
 graphics:    
    gxFont file structures
    
    by  Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good,
        Barton House, Robert Johnson, Eric Mader, Keith McGreggor,
        Dave Opstad, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
        
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.

}

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
    UNIT SfntTypes;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingSfntTypes}
{$SETC UsingSfntTypes := 1}


{$I+}
{$SETC SfntTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}
{$IFC UNDEFINED UsingMathTypes}
{$I $$Shell(PInterfaces)MathTypes.p}
{$ENDC}
{$SETC UsingIncludes := SfntTypesIncludes}

TYPE
GxFontTableTag = LongInt;
GxFontTableTagPointer = ^GxFontTableTag;
GxFontTableTagArray = ARRAY [0..0] OF GxFontTableTag;

GxFontVariationTag = LongInt;
GxFontVariationTagPointer = ^GxFontVariationTag;
GxFontVariationTagArray = ARRAY [0..0] OF GxFontVariationTag;

GxFontFormatTag = LongInt;
GxFontFormatTagPointer = ^GxFontFormatTag;
GxFontFormatTagArray = ARRAY [0..0] OF GxFontFormatTag;

GxFontStorageTag = LongInt;
GxFontStorageTagPointer = ^GxFontStorageTag;
GxFontStorageTagArray = ARRAY [0..0] OF GxFontStorageTag;


GxFontVariation = RECORD
	name: GxFontVariationTag;
	value: Fixed;
	END;
GxFontVariationPointer = ^GxFontVariation;
GxFontVariationArray = ARRAY [0..0] OF GxFontVariation;

GxFontDescriptor = GxFontVariation;
GxFontDescriptorPointer = ^GxFontDescriptor;
GxFontDescriptorArray = ARRAY [0..0] OF GxFontDescriptor;


GxFontRunFeature = RECORD
	featureType: UnsignedLongint;
	setting: UnsignedLongint;
	END;
GxFontRunFeaturePointer = ^GxFontRunFeature;
GxFontRunFeatureArray = ARRAY [0..0] OF GxFontRunFeature;


GxFontFeatureSetting = RECORD
	setting: UnsignedLongint;
	nameID: UnsignedLongint;
	END;
GxFontFeatureSettingPointer = ^GxFontFeatureSetting;
GxFontFeatureSettingArray = ARRAY [0..0] OF GxFontFeatureSetting;

GxSfntDirectoryEntry = RECORD
	tableTag: GxFontTableTag;
	checkSum: UnsignedLong;
	offset: UnsignedLong;
	length: UnsignedLong;
	END;
GxSfntDirectoryEntryPointer = ^GxSfntDirectoryEntry;
GxSfntDirectoryEntryArray = ARRAY [0..0] OF GxSfntDirectoryEntry;


{

 *  The search fields limits numOffsets to 4096.
 
}

GxSfntDirectory = RECORD
	format: GxFontFormatTag;
	numOffsets: UnsignedLongint;
	searchRange: UnsignedLongint;
	entrySelector: UnsignedLongint;
	rangeShift: UnsignedLongint;
	table: ARRAY [0..1] OF GxSfntDirectoryEntry;
	END;
GxSfntDirectoryPointer = ^GxSfntDirectory;
GxSfntDirectoryArray = ARRAY [0..0] OF GxSfntDirectory;


GxSfntCMapSubHeader = RECORD
	format: UnsignedLongint;
	length: UnsignedLongint;
	languageID: UnsignedLongint;
	END;
GxSfntCMapSubHeaderPointer = ^GxSfntCMapSubHeader;
GxSfntCMapSubHeaderArray = ARRAY [0..0] OF GxSfntCMapSubHeader;


GxSfntCMapEncoding = RECORD
	platformID: UnsignedLongint;
	scriptID: UnsignedLongint;
	offset: UnsignedLong;
	END;
GxSfntCMapEncodingPointer = ^GxSfntCMapEncoding;
GxSfntCMapEncodingArray = ARRAY [0..0] OF GxSfntCMapEncoding;


GxSfntCMapHeader = RECORD
	version: UnsignedLongint;
	numTables: UnsignedLongint;
	encoding: ARRAY [0..1] OF GxSfntCMapEncoding;
	END;
GxSfntCMapHeaderPointer = ^GxSfntCMapHeader;
GxSfntCMapHeaderArray = ARRAY [0..0] OF GxSfntCMapHeader;


GxSfntNameRecord = RECORD
	platformID: UnsignedLongint;
	scriptID: UnsignedLongint;
	languageID: UnsignedLongint;
	nameID: UnsignedLongint;
	length: UnsignedLongint;
	offset: UnsignedLongint;
	END;
GxSfntNamePointer = ^GxSfntNameRecord;
GxSfntNameArray = ARRAY [0..0] OF GxSfntNameRecord;


GxSfntNameHeader = RECORD
	format: UnsignedLongint;
	count: UnsignedLongint;
	stringOffset: UnsignedLongint;
	record: ARRAY [0..1] OF GxSfntNameRecord;
	END;
GxSfntNameHeaderPointer = ^GxSfntNameHeader;
GxSfntNameHeaderArray = ARRAY [0..0] OF GxSfntNameHeader;


GxSfntVariationAxis = RECORD
	axisTag: GxFontVariationTag;
	minValue: Fixed;
	defaultValue: Fixed;
	maxValue: Fixed;
	flags: Integer;
	nameID: Integer;
	END;
GxSfntVariationAxisPointer = ^GxSfntVariationAxis;
GxSfntVariationAxisArray = ARRAY [0..0] OF GxSfntVariationAxis;


GxSfntInstance = RECORD
	nameID: Integer;
	flags: Integer;
	coord: ARRAY [0..1] OF Fixed;
	END;
GxSfntInstancePointer = ^GxSfntInstance;
GxSfntInstanceArray = ARRAY [0..0] OF GxSfntInstance;


GxSfntVariationHeader = RECORD
	version: Fixed;
	offsetToData: UnsignedLongint;
	countSizePairs: UnsignedLongint;
	axisCount, axisSize: UnsignedLongint;
	instanceCount, instanceSize: UnsignedLongint;
	axis: ARRAY [0..1] OF GxSfntVariationAxis;
	instance: ARRAY [0..1] OF GxSfntInstance;
	END;
GxSfntVariationHeaderPointer = ^GxSfntVariationHeader;
GxSfntVariationHeaderArray = ARRAY [0..0] OF GxSfntVariationHeader;


GxSfntDescriptorHeader = RECORD
	version: Fixed;
	descriptorCount: LongInt;
	descriptor: ARRAY [0..1] OF GxFontDescriptor;
	END;
GxSfntDescriptorHeaderPointer = ^GxSfntDescriptorHeader;
GxSfntDescriptorHeaderArray = ARRAY [0..0] OF GxSfntDescriptorHeader;


GxSfntFeatureSet = RECORD
	runCount: UnsignedLongint;
	nameID: UnsignedLongint;
	flags: UnsignedLongint;
	groupID: UnsignedLongint;
	offsetToRuns: LongInt;
	END;
GxSfntFeatureSetPointer = ^GxSfntFeatureSet;
GxSfntFeatureSetArray = ARRAY [0..0] OF GxSfntFeatureSet;


GxSfntFeatureName = RECORD
	featureType: UnsignedLongint;
	settingCount: UnsignedLongint;
	offsetToSettings: LongInt;
	featureFlags: UnsignedLongint;
	nameID: UnsignedLongint;
	END;
GxSfntFeatureNamePointer = ^GxSfntFeatureName;
GxSfntFeatureNameArray = ARRAY [0..0] OF GxSfntFeatureName;


GxSfntFeatureHeader = RECORD
	version: LongInt;
	featureNameCount: UnsignedLongint;
	featureSetCount: UnsignedLongint;
	offsetToFeatureSets: LongInt;
	names: ARRAY [0..1] OF GxSfntFeatureName;
	sets: ARRAY [0..1] OF GxSfntFeatureSet;
	settings: ARRAY [0..1] OF GxFontFeatureSetting;
	runs: ARRAY [0..1] OF GxFontRunFeature;
	END;
GxSfntFeatureHeaderPointer = ^GxSfntFeatureHeader;
GxSfntFeatureHeaderArray = ARRAY [0..0] OF GxSfntFeatureHeader;


{

 *      OS/2 Table
 
}


{$ENDC}

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
