/* graphics libraries:    
    font menu library interfaces
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.
*/

#pragma once
	#ifndef fontMenuLibraryIncludes
	#define fontMenuLibraryIncludes
	
	#ifndef __Menus__
		#include <Menus.h>
	#endif
	
	#ifndef fontTypesIncludes
		#include "font types.h"
	#endif
	
	#ifndef graphicsTypesIncludes
		#include "graphics types.h"
	#endif
	
	#ifndef layoutRoutinesIncludes
		#include "layout routines.h"
	#endif
	
	#ifndef fontRoutinesIncludes
		#include "font routines.h"
	#endif
	
	#ifdef __cplusplus
	extern "C" {
	#endif
	
	enum fontMenuAttributes {
		noInstancesFontMenu = 1
	};
	typedef long fontMenuAttribute;
	
	typedef boolean (*fontFilterProc)(gxFont fontID);
	
	void SortMenu(MenuHandle menu);
	long FontMenu(MenuHandle menu);
	long FontPlatformMenu(MenuHandle menu, gxFontPlatform platform, gxFontScript script, gxFontLanguage language);
	long FontFamilyMenu(MenuHandle menu);
	long FontFamilyPlatformMenu(MenuHandle menu, gxFontPlatform platform, gxFontScript script, gxFontLanguage language);
	MenuHandle FontStyleMenu(short menuID, gxFont family);
	short HierFontMenu(MenuHandle theMenu, short firstHierMenuID, fontFilterProc proc, fontMenuAttribute attr);
	gxFont DoHierFontMenuCommand(long menuResult, short hierFontMenuID, long *instanceIndex);
	short DoHierFontMenuCommandStyle(long menuResult, short hierFontMenuID, gxStyle aStyle, long matchInfo);
	short DoHierFontMenuCommandShape(long menuResult, short hierFontMenuID, gxShape aShape);
	long FontToQD(gxFont fontID, long* styleBits);

	long GetMenuRunFeatures(MenuHandle menu, gxFont fontID, gxRunFeature feature[]);
	void SetMenuRunFeatures(MenuHandle menu, gxFont fontID, long count, const gxRunFeature feature[]);
	void FontFeatureMenu(MenuHandle menu, gxFont fontID);
	
	#ifdef __cplusplus
	}
	#endif
#endif
