/* graphics:
	font routines
	by Cary Clark, Georgiann Delaney, Herb Derby, Michael Fairman, Pablo Fernicola, Dave Good, Josh Horwich, Barton House, Robert Johnson, Keith McGreggor, Mike Reed, Oliver Steele, David Van Brink, Chris Yerga
	Copyright 1987 - 1994 Apple Computer, Inc.  All rights reserved.	*/

#pragma once

#ifndef fontRoutinesIncludes
	#define fontRoutinesIncludes

	#ifndef mathTypesIncludes
		#include "math types.h"
	#endif

	#ifndef fontTypesIncludes
		#include "font types.h"
	#endif
	
	#ifndef graphicsLinkageIncludes
		#include "graphics linkage.h"
	#endif

	struct scalerStream;
	struct gxSpoolBlock;
		
	#ifdef __cplusplus
	extern "C" {
	#endif

	gxFont GXNewFont(gxFontStorageTag storage, gxFontStorageReference reference, gxFontAttribute attributes) GXInlineCode(0x201, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontStorageTag GXGetFont(gxFont fontID, gxFontStorageReference *reference, gxFontAttribute *attributes) GXInlineCode(0x202, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFont GXFindFont(gxFontStorageTag storage, gxFontStorageReference reference, gxFontAttribute* attributes) GXInlineCode(0x203, gxNeedClient|gxNeedHeap|gxNeedStack);
	void GXSetFont(gxFont fontID, gxFontStorageTag storage, gxFontStorageReference reference, gxFontAttribute attributes) GXInlineCode(0x204, gxNeedClient|gxNeedHeap|gxNeedStack);
	void GXDisposeFont(gxFont fontID) GXInlineCode(0x205, gxNeedClient|gxNeedHeap|gxNeedStack);
	void GXChangedFont(gxFont fontID) GXInlineCode(0x206, gxNeedClient|gxNeedHeap|gxNeedStack);

	gxFontFormatTag GXGetFontFormat(gxFont fontID) GXInlineCode(0x207, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFont GXGetDefaultFont(void) GXInlineCode(0x208, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFont GXSetDefaultFont(gxFont fontID) GXInlineCode(0x209, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFonts(gxFont familyID, gxFontName name, gxFontPlatform platform, gxFontScript script, gxFontLanguage language,
		long length, const unsigned char text[], long index, long count, gxFont fonts[]) GXInlineCode(0x20a, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXCountFontGlyphs(gxFont fontID) GXInlineCode(0x20b, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontTables(gxFont fontID) GXInlineCode(0x20c, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXGetFontTable(gxFont fontID, long index, void* tableData, gxFontTableTag* tableTag) GXInlineCode(0x20d, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFontTable(gxFont fontID, gxFontTableTag tableTag, void* tableData, long* index) GXInlineCode(0x20e, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXGetFontTableParts(gxFont fontID, long index, long offset, long length, void* tableData, gxFontTableTag* tableTag) GXInlineCode(0x20f, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFontTableParts(gxFont fontID, gxFontTableTag tableTag, long offset, long length, void* tableData, long* index) GXInlineCode(0x210, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXSetFontTable(gxFont fontID, long index, gxFontTableTag tableTag, long length, const void* tableData) GXInlineCode(0x211, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXSetFontTableParts(gxFont fontID, long index, gxFontTableTag tableTag, long offset, long oldLength, long newLength, const void* tableData) GXInlineCode(0x212, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXDeleteFontTable(gxFont fontID, long index, gxFontTableTag tableTag) GXInlineCode(0x213, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontNames(gxFont fontID) GXInlineCode(0x214, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXGetFontName(gxFont fontID, long index, gxFontName *name, gxFontPlatform *platform,
		gxFontScript *script, gxFontLanguage *language, unsigned char text[]) GXInlineCode(0x215, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFontName(gxFont fontID, gxFontName name, gxFontPlatform platform,
		gxFontScript script, gxFontLanguage language, unsigned char text[], long *index) GXInlineCode(0x216, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXSetFontName(gxFont fontID, gxFontName name, gxFontPlatform platform, gxFontScript script, gxFontLanguage language,
		long length, const unsigned char text[]) GXInlineCode(0x217, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXDeleteFontName(gxFont fontID, long index, gxFontName name, gxFontPlatform platform, gxFontScript script,
		gxFontLanguage language) GXInlineCode(0x218, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontName GXNewFontNameID(gxFont fontID) GXInlineCode(0x219, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontEncodings(gxFont fontID) GXInlineCode(0x21a, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontPlatform GXGetFontEncoding(gxFont fontID, long index, gxFontScript *script, gxFontLanguage* language) GXInlineCode(0x21b, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFontEncoding(gxFont fontID, gxFontPlatform platform, gxFontScript script, gxFontLanguage language) GXInlineCode(0x21c, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXApplyFontEncoding(gxFont fontID, long index, long* length, const unsigned char text[],
		long count, unsigned short glyphs[], char was16Bit[]) GXInlineCode(0x21d, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontVariations(gxFont) GXInlineCode(0x21e, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFontVariation(gxFont, gxFontVariationTag variationTag, Fixed* minValue, Fixed* defaultValue, Fixed* maxValue, gxFontName* name) GXInlineCode(0x21f, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontVariationTag GXGetFontVariation(gxFont, long index, Fixed* minValue, Fixed* defaultValue, Fixed* maxValue, gxFontName* name) GXInlineCode(0x220, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontInstances(gxFont) GXInlineCode(0x221, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontName GXGetFontInstance(gxFont, long index, gxFontVariation variation[]) GXInlineCode(0x222, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXSetFontInstance(gxFont fontID, long index, gxFontName name, const gxFontVariation variation[]) GXInlineCode(0x223, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXDeleteFontInstance(gxFont fontID, long index, gxFontName name) GXInlineCode(0x224, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontDescriptors(gxFont fontID) GXInlineCode(0x225, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontDescriptorTag GXGetFontDescriptor(gxFont fontID, long index, Fixed* descriptorValue) GXInlineCode(0x226, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXFindFontDescriptor(gxFont fontID, gxFontDescriptorTag descriptorTag, Fixed* descriptorValue) GXInlineCode(0x227, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXSetFontDescriptor(gxFont fontID, long index, gxFontDescriptorTag descriptorTag, Fixed descriptorValue) GXInlineCode(0x228, gxNeedClient|gxNeedHeap|gxNeedStack);
	long GXDeleteFontDescriptor(gxFont fontID, long index, gxFontDescriptorTag descriptorTag) GXInlineCode(0x229, gxNeedClient|gxNeedHeap|gxNeedStack);

	long GXCountFontFeatures(gxFont fontID) GXInlineCode(0x22a, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontName GXGetFontFeature(gxFont fontID, long index, gxFontFeatureFlag* flags, long* settingCount, gxFontFeatureSetting settings[], gxFontFeature* feature) GXInlineCode(0x22b, gxNeedClient|gxNeedHeap|gxNeedStack);
	gxFontName GXFindFontFeature(gxFont fontID, gxFontFeature feature, gxFontFeatureFlag* flags, long* settingCount, gxFontFeatureSetting settings[], long* index) GXInlineCode(0x22c, gxNeedClient|gxNeedHeap|gxNeedStack);

	void GXFlattenFont(gxFont source, struct scalerStream* stream, struct gxSpoolBlock* block) GXInlineCode(0x22d, gxNeedClient|gxNeedHeap|gxNeedStack);

	#ifdef __cplusplus
	}
	#endif

#endif
