/* graphics libraries:
    graphics state routines 
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.    */

#pragma once
#ifndef graphicsStateLibraryIncludes
#define graphicsStateLibraryIncludes
	#ifndef graphicsTypesIncludes
		#include "graphics types.h"
	#endif
    
	#ifdef __cplusplus
	extern "C" {
	#endif

	struct graphicsStateRecord {
		gxShape defaultShapes[gxPictureType - 1];
	};
    
	typedef struct graphicsStateRecord *graphicsState;
	
	#ifndef __cplusplus
		typedef struct graphicsStateRecord graphicsStateRecord;
	#endif
    
	extern graphicsState lastGraphicsState;
    
	graphicsState NewGraphicsState(void);
	void DisposeGraphicsState(graphicsState);
	void GetGraphicsState(graphicsState);
	void SetGraphicsState(graphicsState);
	graphicsState SwapGraphicsState(graphicsState);
    
	#ifdef __cplusplus
	}
	#endif
#endif
