/* graphics libraries:
    graphicsBug apple events interface 
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.    */

#pragma once
#ifndef graphicsBugLibraryIncludes
#define graphicsBugLibraryIncludes

#ifndef graphicsTypesIncludes
    #include "graphics types.h"
#endif
    
	#ifdef __cplusplus
	extern "C" {
	#endif

	#define creatorType				'gBug'
	#ifdef __APPLEEVENTS__
		#define bugEventClass			'gBug'
	
		#define getBugWindowEvent		'gBWi'
		#define selectBugWindowPartEvent	'gBWP'
		#define pasteBugTextEvent		'gBPa'
		#define waitThenContinueEvent		'gBWa'
	
		#define errorString				'errS'
		#define chooseWindowPartBoolean 	'cWPB'
		#define quitGraphicsApBoolean		'qGAB'
	#endif
	
	enum graphicsBugRequests {
		noticeMessage,
		warningMessage,
		errorMessage,
		debugMessage,
		commandMessage
	};
	
	enum graphicsBugCommands {
		noAction,
		executeCommand
	};
	
	enum graphicsBugStatus {
		graphicsBugReady,
		graphicsBugRunning,
		graphicsBugBusy,
		lastCommandError
	};
	
	struct graphicsBugParameters {
		long			message;
		unsigned char	command;
		unsigned char	status;
		unsigned char	toggle;
		char			string[81];
	};

	#define maximumIdle 25
	
	boolean SendMessageToGraphicsBug(long command, const char *str, unsigned long num, boolean waitForCompletion);
	void DirectDebugMessageToGraphicsBug(void);

	#ifdef __cplusplus
	}
	#endif
#endif
