/* graphics libraries:  
    primitive flattening library routine interfaces
    by Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
    Copyright 1987 - 1993 Apple Computer, Inc.  All rights reserved.    */

#pragma once
#ifndef storageLibraryIncludes
	#define storageLibraryIncludes
	#ifndef __TYPES__
		#include <Types.h>
	#endif

	#ifndef graphicsStreamTypesIncludes
		#include "graphics stream types.h"
	#endif

 	#ifdef __cplusplus
	extern "C" {
	#endif

 	struct userSpool {
		gxSpoolBlock	spool;
		long			reference;
		long			position;
		long			size;
		void			*data;
		void			*userField;
	};

	#ifndef __cplusplus
		typedef struct userSpool userSpool;
	#endif

	Handle ShapeToHandle(gxShape source);
	gxShape HandleToShape(Handle target, long count, const gxViewPort portList[]);
	void ShapeToFRef(gxShape source, short fileRef);
	gxShape FRefToShape(short fileRef, long count, const gxViewPort portList[]);
	void ShapeToFile(gxShape source, Str255 fileName, short vRefNum, OSType creator, OSType fileType);
	gxShape FileToShape(Str255 fileName, short vRefNum, long count, const gxViewPort portList[]);
	Handle FontToHandle(gxFont fontID, long glyphBits[]);
	gxFont HandleToFont(Handle source);

	#ifdef __cplusplus
	}
	#endif
#endif
