
{
 Telephones.p
 Pascal Interface to the Telephone Manager

  Copyright Apple Computer, Inc. 1990-1993
  All rights reserved
}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT Telephones;
    INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingTelephones}
{$SETC UsingTelephones := 1}

{$I+}
{$SETC TelephonesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}

{$IFC UNDEFINED UsingDialogs}
{$I $$Shell(PInterfaces)Dialogs.p}
{$ENDC}

{$IFC UNDEFINED UsingEvents}
{$I $$Shell(PInterfaces)Events.p}
{$ENDC}

{$IFC UNDEFINED CTBUtilities}
{$I $$Shell(PInterfaces)CTBUtilities.p}
{$ENDC}

{$SETC UsingIncludes := TelephonesIncludes}


CONST

	classTEL			= 'vbnd';		{ telephone tool file type }
	
	curTELVersion		= 2;			{ current Telephone Manager version }
	
{ TELErr }

	telGenericError = -1;
	telNoErr = 0;
	telNoTools = 8;						{ no telephone tools found in extension folder }
	
	telBadTermErr		= -10001;		{ invalid TELHandle or handle not found}
	telBadDNErr			= -10002;		{ telDNHandleType not found or invalid }
	telBadCAErr			= -10003;		{ telCAHandleType not found or invalid }
	telBadHandErr		= -10004;		{ bad handle specified }
	telBadProcErr		= -10005;		{ bad msgProc specified }
	telCAUnavail		= -10006;		{ a new CA is not available }
	telNoMemErr			= -10007;		{ no memory to allocate a handle }
	telNoOpenErr		= -10008;		{ unable to open terminal }
	
	telBadHTypeErr		= -10010;		{ bad hook type specified }
	telHTypeNotSupp		= -10011;		{ hook type not supported by this tool }
	telBadLevelErr		= -10012;		{ bad volume level setting }
	telBadVTypeErr		= -10013;		{ bad volume type err }
	telVTypeNotSupp		= -10014;		{ volume type not supported by this tool}
	telBadAPattErr		= -10015;		{ bad alerting pattern specified }
	telAPattNotSupp		= -10016; 		{ alerting pattern not supported by tool}
	telBadIndex			= -10017;		{ bad index specified }
	telIndexNotSupp		= -10018;		{ index not supported by this tool }
	telBadStateErr		= -10019;		{ bad device state specified }
	telStateNotSupp		= -10020;		{ device state not supported by tool }
	telBadIntExt		= -10021;		{ bad internal/external specifier }
	telIntExtNotSupp	= -10022;		{ internal/ external type not supported by tool }
	telBadDNDType		= -10023;		{ DND type not supported by this tool }
	telDNDTypeNotSupp	= -10024;		{ DND type not supported }
	
	telFeatNotSub		= -10030;		{ feature not subscribed }
	telFeatNotAvail		= -10031; 		{ feature subscribed but not available }
	telFeatActive		= -10032;		{ feature already active }
	telFeatNotSupp		= -10033;		{ feature program call not supported by this tool }

	telConfLimitErr  	= -10040;		{ limit specified is too high for this configuration }
	telConfNoLimit		= -10041;		{ no limit was specified but required}			 	 
	telConfErr			= -10042;		{ hTELCA1 was not a conference initiator }
	telConfRej			= -10043;		{ conference request was rejected }
	telTransferErr		= -10044;		{ implicit transfer not prepared }
	telTransferReject	= -10045;		{ transfer request rejected }
	telCBErr			= -10046;		{ call back feature not set previously }
	telConfLimitExceeded = -10047;		{ attempt to exceed switch conference limits }

	telBadDNType		= -10050;		{ dn type invalid }
	telBadPageID		= -10051;		{ bad page ID specified}
	telBadIntercomID	= -10052;		{ bad intercom ID specified }
	telBadFeatureID		= -10053;		{ bad feature ID specified }
	telBadFwdType		= -10054;		{ bad fwdType specified }
	telBadPickupGroupID = -10055; 		{ bad pickup group ID specified }
	telBadParkID		= -10056;		{ bad park id specified }
	telBadSelect		= -10057;		{ unable to select or deselect dn }
	telBadBearerType	= -10058;		{ bad bearerType specified }
	telBadRate			= -10059;		{ bad rate specified }
	telDNTypeNotSupp	= -10060;		{ dn type not supported by tool }
	telFwdTypeNotSupp	= -10061;		{ forward type not supported by tool }
	telBadDisplayMode	= -10062;		{ bad display mode specified }
	telDisplayModeNotSupp = -10063;		{ display mode not supported by tool }
	telNoCallbackRef	= -10064;		{ no callback ref was specified, but is required }
	
	telAlreadyOpen		= -10070;		{ terminal already open }
	telStillNeeded		= -10071;		{ terminal driver still needed by someone else }
	telTermNotOpen		= -10072;		{ terminal not opened via TELOpenTerm }

	telCANotAcceptable 	= -10080; 		{ CA not "acceptable" }
	telCANotRejectable 	= -10081; 		{ CA not "rejectable" }
	telCANotDeflectable	= -10082;		{ CA not "deflectable" }

	telPBErr			= -10090;		{ parameter block error, bad format }
	telBadFunction		= -10091;		{ bad MsgCode specified }

{	telNoTools			= -10101;		  Unable to find any telephone tools }
	telNoSuchTool		= -10102;		{ Unable to find tool with rmtName specified }	
	telUnknownErr		= -10103;		{ Unable to set config }
	telNoCommFolder		= -10106;		{ Communications/Extension  not found }
	telInitFailed		= -10107;		{ InitTEL failed }

	telChooseDisaster		= chooseDisaster;	
	telChooseFailed			= chooseFailed;		
	telChooseAborted		= chooseAborted;
	telChooseOKMinor		= chooseOKMinor;	
	telChooseOKMajor		= chooseOKMajor;	
	telChooseCancel			= chooseCancel;		
	
	telChooseOKTermChanged	= 4;		


{ PHYSICAL TERMINAL CONSTANTS }

{HOOK STATE CONSTANTS }
	telHandset			= 1;	{ handset hookswitch }
	telSpeakerphone		= 2;	{ speakerphone 'on' switch }

	telDeviceOnHook 	= 0; 	{ device on hook }
	telDeviceOffHook 	= 1;	{ device off hook }


{ VOLUME CONTROL CONSTANTS }
	telHandsetSpeakerVol	= 1; 	{ volume of the handset speaker }
	telHandsetMicVol 		= 2; 	{ sensitivity of the handset mic }
	telSpeakerphoneVol 		= 3; 	{ speakerphone volume }
	telSpeakerphoneMicVol 	= 4; 	{ sensitivity of the spkrphone mic }
	telRingerVol 			= 5; 	{ volume of the ringer }

	telVolSame				= 0; 	{ leaves the volume at previous level }
	telVolMin				= 1; 	{ turns volume down to minimum level, but not off }
	telVolMax				= 100;	{ highest level allowed by the Telephone Manager }

	telVolStateSame			= 0; 	{ leaves device in same state }
	telVolStateOff			= 1; 	{ turns the device off , }
									{ but doesn't change the volume setting. }
									{ Use for mute functions. }
	telVolStateOn			= 2; 	{ turns the device on.  Volume setting is }
									{ the same as previously set.}

{ DISPLAY CONSTANTS }
	telNormalDisplayMode 	= 1;	{ normal display mode }
	telInspectMode			= 2;	{ inspect display mode }
	telMiscMode				= 3;	{ miscellaneous Display Mode }
	telRetrieveMode			= 4;	{ message Retrieval Mode }
	telDirectoryQueryMode	= 5;	{ electronic Directory Mode }

	telEntireDisplay		= 0;	{ entire Display }

{ KEY PRESS CONSTANTS }
	telHangupKey 			= 1;		{ drop, or release, key pressed }
	telHoldKey				= 2;		{ hold key kressed }
	telConferenceKey		= 3;		{ conference key pressed }		
	telTransferKey			= 4;		{ transfer key kressed }
	telForwardKey			= 5;		{ call forward key kressed }
	telCallbackKey			= 6;		{ call back key kressed }
	telDNDKey				= 7;		{ do not disturb key kressed }
	telCallPickupKey		= 8;		{ call pickup key kressed }
	telCallParkKey			= 9;		{ call park key kressed }
	telCallDeflectKey 		= 10;		{ call deflect key kressed }
	telVoiceMailAccessKey	= 11;		{ message waiting key kressed }
	telCallRejectKey		= 12; 		{ call reject key kressed }
	telOtherKey				= 16;		{ other key kressed }


	telKeyPadPress 			= 1;		{ key pressed on 12 digit keypad}		
	telFeatureKeyPress		= 2;		{ feature Key Pressed }

	telTerminalEnabled		= 0;
	telTerminalDisabled		= 1;
	
{ ALERT PATTERN }

	telPattern0				= 0;
	telPattern1				= 1;
	telPattern2				= 2;
	telPattern3				= 3;
	telPattern4				= 4;
	telPattern5				= 5;
	telPattern6				= 6;
	telPattern7				= 7;
 	telPatternOff			= 8;
 	telPatternUndefined		= 15;

{ DN TYPES }

	telAllDNs				= 0;  	{ counts all types of DNs }
	telInternalDNs			= 1; 	{ connected to PBX or other non-public switch }
	telInternalDNsOnly		= 2; 	{ connected to PBX or other non-public switch }
									{ and able to place internal calls only }
	telExternalDNsOnly		= 3; 	{ connected to public network }
	telDNTypeUnknown		= 4;	{ DN type unknown }
	
{ CALL FORWARDING TYPES }

	telForwardImmediate		= 1;	{ immediately forward calls }
	telForwardBusy 			= 2;	{ forward on busy }
	telForwardNoAnswer 		= 3;	{ forward on no answer }
	telForwardBusyNA		= 4;	{ forwarding for busy and no answer}
	telForwardTypeUnknown 	= 5;	{ type of forwarding is unknown }

{ CALL FORWARDING MESSAGES }

	telForwardCleared		= 0;	{ forwarding has been cleared }
	telForwardEst 			= 1; 	{ forwarding has been established}
	telForwardFailed		= 2;	{ attempt to setup forwarding has failed}

{ DO NOT DISTURB TYPES }

	telDNDIntExt			= 0;	{ do not disturb for all internal and external calls}
	telDNDExternal			= 1;	{ do not disturb for external calls only }
	telDNDInternal			= 2;	{ do not disturb for internal calls only }
	telDNDNonIntercom 		= 3;	{ do not disturb for all calls except intercom}

{ DO NOT DISTURB MESSAGES }

	telDNDCleared			= 0;	{ do not disturb has been cleared }
	telDNDEst 				= 1; 	{ do not disturb has been established }
	telDNDFailed			= 2;	{ attempt to setup do not disturb has failed }

{ VOICE MAIL MESSAGES }

	telAllVoiceMessagesRead	= 0;	{ all messages have been read, none are  waiting }
									{ to be read }
	telNewVoiceMessage 		= 1; 	{ a new message has arrived or messages are waiting }
									{ for this dn }

{ DNSELECT MESSAGES }

	telDNDeselected			= 0;	{ dn has been deselected }
	telDNSelected			= 1;	{ dn has been selected }

{ CALL ORIGINATORS }

	telInternalCall			= 0;	{ return nth internal CA }
	telExternalCall			= 1;	{ return nth external CA }
	telUnknownCallOrigin 	= 2;	{ call type is unknown }
	telAllCallOrigins 		= 2; 	{ return nth CA internal or external }

{ CALL TYPES }

	telVoiceMailAccessOut	= (-7);
	telPageOut				= (-6);
	telIntercomOut			= (-5);
	telCallbackOut			= (-4);
	telPickup				= (-3);
	telParkRetrieve			= (-2);
	telNormalOut			= (-1);
	telUnknownCallType		= 0;
	telNormalIn				= 1;
	telForwardedImmediate	= 2;
	telForwardedBusy		= 3; 
	telForwardedNoAnswer	= 4; 
	telTransfer				= 5;
	telDeflected			= 6;
	telIntercepted			= 7;			
	telDeflectRecall		= 8;
	telParkRecall			= 9;
	telTransferRecall		= 10;
	telIntercomIn			= 11;
	telCallback				= 12;

{ DIAL TYPES }

	telDNDialable			= 0;	{ this dn could be dialed via TELSetupCall }
	telDNNorthAmerican		= 1;	{ rmtDN is standard North America 10 digit number }
	telDNInternational		= 2;	{ rmtDN is an international number }
	telDNAlmostDialable		= 3;	{ rmtDN is almost dialable, }
									{ missing prefix such as 9 or 1 }
	telDNUnknown			= 15;	{ unknown whether dn is dialable }


{ CALL PROGRESS MESSAGES }

	telCAPDialTone 			= 1;	{ dial tone }		
	telCAPRinging			= 2;	{ destination CA is alerting }
	telCAPDialing			= 3;	{ dialing in progress }
	telCAPReorder 			= 4;	{ reorder }
	telCAPBusy 				= 5; 	{ busy }
	telCAPRouted 			= 6; 	{ call routed; rmtDN will hold the routing directory }
									{ number routeDN and routePartyName have been updated}
	telCAPRoutedOff 		= 7;  	{ call routed off-network; no further progress will }
									{ be available } 
	telCAPTimeout  			= 8;  	{ call timed out }
	telCAPUpdate			= 9;	{ rmtName and rmtDN information has been updated }
	telCAPPrompt			= 10;	{ the network is prompting for more information }
	telCAPWaiting			= 11;	{ call is proceeding, but there is no response yet }
									{ from the destination.}
	telCAPUnknown			= 15;	{ call progress state unknown }

{ OUTGOING CALL MESSAGES }

	telPhysical				= 0;	{ user lifted handset and initiated call }
	telProgrammatic			= 1;	{ programmatic initiation of outgoing call }

{ DISCONNECT MESSAGES }

	telLocalDisconnect		= 0; 	{ local party, this user, responsible for disconnect }
	telRemoteDisconnect 	= 1;	{ remote party responsible for disconnect } 
	
{ DISCONNECT TYPES }

	telCADNormal 			= 1;	{ normal disconnect }
 	telCADBusy 				= 2;	{ remote user busy }
 	telCADNoResponse 		= 3;	{ remote not responding }
	telCADRejected			= 4;	{ call rejected }
	telCADNumberChanged 	= 5; 	{ number changed }
	telCADInvalidDest 		= 6; 	{ invalid destination address }
	telCADFacilityRejected	= 7; 	{ requested facility rejected }
	telCADUnobtainableDest 	= 9; 	{ destination not obtainable }
	telCADCongested 		= 10; 	{ network congestion }
	telCADIncompatibleDest	= 11;	{ incompatible destination }
	telCADTimeout 			= 12;	{ call timed out }
	telCADUnknown 			= 15; 	{ reason unknown }

{ CONFERENCE MESSAGES }

	telConferencePrepFailed		= 0;	{ conference could not be prepared }
	telConferencePending		= 1;	{ conference prepared successfully }
	telConferenceEstFailed		= 2;	{ conference could not be established }
	telConferenceEst			= 3; 	{ conference established }
	
{ TRANSFER MESSAGES }

	telTransferPrepFailed	= 0;		{ transfer could not be prepared }
	telTransferPending		= 1;		{ transfer prepared successfully }
	telTransferEst			= 2;		{ consult or blind transfer successful }
	telTransferFailed		= 3;		{ consult or blind transfer failed }
	telTransferred			= 4; 		{ message to originator of CA specifying }
										{ that call was telTransferred to rmtDN }

{ HOLD MESSAGES }

	telHoldCleared			= 0;
	telHoldEst				= 1;
	telHoldFailed			= 2;

{ RECEIVE DIGIT MESSAGES }

	telDigitAudible 		= 0; 
	telDigitNotAudible 		= 1; 

{ CALL PARK MESSAGES }

	telCallParkEst 				= 1; 	{ call has been successfully parked }
	telCallParkRetrieveEst		= 2;	{ parked call has been successfully retrieved }
	telCallParkFailed			= 3;	{ attempt to setup call park has failed }
	telCallParkRetrieveFailed 	= 4; 	{ attempt to retrieve parked call failed }
	telCallParkRecall			= 5;	{ call park has been recalled }
	
{ CALL BACK MESSAGES }

	telCallbackCleared			= 0;	{ call back has been cleared }
	telCallbackEst 				= 1; 	{ call back has been established }
	telCallbackNowAvail			= 2;	{ call can be called back with TELCallBackNow }
										{ if CA is zero, else call IS calling back on CA }
	telCallbackFailed			= 3;	{ attempt to setup callback has failed }
	telCallbackDesired			= 4;	{ a user has called this terminal, received no }
										{ answer and desires this terminal to call it }
										{ back }
	telCallbackDesiredCleared	= 5; 	{ call back for no answer no longer desired }
	telCalledback				= 6;	{ call back has occurred successfully }
 
{ CALL REJECT MESSAGES }
	telCallRejectFailed			= 0;	{ attempt to reject call has failed }
	telCallRejectEst 	 		= 1; 	{ call successfully rejected }
	telCallRejected				= 2;	{ message to originator that call was rejected }

{ CALL DEFLECT MESSAGES }
	telCallDeflectFailed		= 0;  	{ attempt to deflect call has failed }
	telCallDeflectEst 			= 1; 	{ call successfully deflected }
	telCallDeflectRecall 		= 2;	{ deflected call has been recalled }
	telCallDeflected			= 3;	{ message to originator that call was deflected }
										{ to rmtDN }
	telAutoDeflectImmediate		= 4;	{ a call was automatically deflected from this }
										{ terminal as a result of immediate call }
										{ forwarding }
	telAutoDeflectBusy			= 5;	{ a call was automatically deflected from this }
										{ terminal as a result of call forwarding on busy }
	telAutoDeflectNoAnswer		= 6;	{ a call was automatically deflected from this }
										{ terminal as a result of call forwarding on }
										{ no answer }

{ CONFERENCE SPLIT MESSAGES }

	telConferenceSplitFailed	= 0;	{ CA could not be split }
	telConferenceSplitEst		= 1;	{ CA split successfully }

{ CONFERENCE DROP MESSAGES }

	telConferenceDropFailed		= 0;	{ CA could not be dropped }
	telConferenceDropped		= 1;	{ CA dropped successfully }

{ CALL PICKUP MESSAGES }

	telCallPickupEst			= 0;	{ call Pickup was successful }
	telCallPickupFailed			= 1;	{ call pickup failed }
	telCallPickedUp				= 2;	{ message to originator that call was picked }
										{ up at a different dn }

{ PAGING MESSAGES }

	telPageEst					= 0;	{ paging was successful }
	telPageComplete				= 1;	{ paging activity completed }
	telPageFailed				= 2;	{ paging failed }

{ INTERCOM MESSAGES }

	telIntercomEst				= 0;	{ intercom was successful }
	telIntercomComplete			= 1;	{ intercom activity completed }
	telIntercomFailed			= 2;	{ intercom failed }

{ MODEM TONE MESSAGES }

	telModemToneDetected		= 0;	{ modem tone was detected }
	telModemToneCleared			= 1;	{ modem tone went away }

{ FAX TONE MESSAGES }

	telFaxToneDetected			= 0;	{ fax tone was detected }
	telFaxToneCleared			= 1;	{ fax tone went away }

{ IN USE MESSAGES }

	telInUsePrivate				= 0;	{ MADN is in use, and can't be accessed }
	telInUseCanAccess			= 1;	{ MADN is in use, and others can access it }
										{ and join in }
	telInUseCanMakePrivate		= 2;	{ MADN is in use, but available for any one }
										{ person to access }
	telInUseCleared				= 3;	{ MADN is no longer in use }
 
{ CALL APPEARANCE STATES }

	telCAIdleState				= 0;	{ a call doesn't exist at this time }
	telCAInUseState				= 1; 	{ the call is active but at another terminal }
	telCAOfferState				= 2;	{ a call is being offered to the terminal }
	telCAQueuedState			= 3;	{ a call is being queued at this terminal }
	telCAAlertingState			= 4;	{ a call is alerting at the terminal }
	telCADialToneState			= 5;	{ initiated Outgoing call has dialtone }
	telCADialingState			= 6;	{ initiated Outgoing call is dialing }
	telCAWaitingState			= 7;	{ initiated Outgoing call is waiting for }
										{ response from destination }
	telCARingingState			= 8;	{ the outgoing call is ringing. }
	telCABusyState				= 9;	{ destination is busy or can't be reached }
	telCAHeldState				= 10;	{ call has been put on hold by this terminal }
	telCAConferencedState		= 11;	{ this CA is part of a conference now }
	telCAActiveState			= 12;	{ the call is active and parties are free }
										{ to exchange data }
	telCAReorderState			= 13;	{ CA is in a reorder state }
	telCAConferencedHeldState	= 14;	{ CA is a conference call in a held state }
	telCAUnknownState			= 15;	{ the call state is unknown }

{ TERMINAL MESSAGE EVENTMASKS }		

	telTermHookMsg		= $00000001; 	{ the hookswitch state has changed }	
	telTermKeyMsg		= $00000002; 	{ a phone pad key has been depressed }	
	telTermVolMsg		= $00000004;	{ volume setting has changed }	
	telTermDisplayMsg	= $00000008;	{ display has changed }		
	telTermEnableMsg	= $00000010;	{ terminal has become enabled }	
	telTermOpenMsg		= $00000020;	{ terminal has been opened }
	telTermCloseMsg		= $00000040;	{ terminal is shutting down }			
	telTermResetMsg 	= $00000080;	{ terminal has been reset }		
	telTermErrorMsg		= $00000100;	{ hard equipment error }		
	telTermOtherMsg		= $80000000;	{ vendor defined error }	
	telAllTermMsgs		= $000001FF;	{ mask to all non tool specific terminal events }

{ dn MESSAGE EVENTMASK CONSTANTS }		
	telDNForwardMsg		= $00000001;	{ forward feature activity }
	telDNDNDMsg			= $00000002;	{ do not disturb feature activity }	
	telDNVoiceMailMsg 	= $00000004;	{ message has arrived for this dn }	
	telDNSelectedMsg	= $00000008;	{ dn has been selected or deselected }
	telDNOtherMsg		= $80000000;	{ a custom message for use by tools }
	telAllDNMsgs		= $0000000F;	{ mask to all non tool specific dn events }
 
{ CA MESSAGE EVENTMASK CONSTANTS }		
	telCAAlertingMsg		= $00000001;	{ CA is alerting  }
	telCAOfferMsg			= $00000002;	{ CA is being offered a call }
	telCAProgressMsg  		= $00000004;	{ call progress info for this CA }
	telCAOutgoingMsg		= $00000008;	{ CA is initiating an outgoing call }
	telCADisconnectMsg		= $00000010;	{ CA disconnected / dropped or rmt disc} 
	telCAActiveMsg			= $00000020;	{ CA is active and voice/data is free to }
											{ flow end to end }	
	telCAConferenceMsg		= $00000040;	{ conference activity on CA }	
	telCATransferMsg		= $00000080;	{ transfer feature activity }	
	telCAHoldMsg			= $00000100;	{ hold feature activity }	
	telCADigitsMsg			= $00000200; 	{ remote signaling digits arrived }	
	telCACallParkMsg		= $00000400;	{ CA call park feature activity }	
	telCACallbackMsg		= $00000800;	{ CA call back feature activity  }	
	telCARejectMsg			= $00001000; 	{ CA is rejected }
	telCADeflectMsg			= $00002000; 	{ CA is deflected }
	telCAForwardMsg			= $00004000;	{ CA is forwarded to this dn  }
	telCAConferenceSplitMsg	= $00008000;	{ conference split activity  }
	telCAConferenceDropMsg	= $00010000; 	{ conference drop activity  }
	telCAQueuedMsg			= $00020000; 	{ CA has been queued  }
	telCAInUseMsg			= $00040000; 	{ CA is in use  }
	telCACallPickupMsg		= $00080000;	{ CA pickup activity }
	telCAPagingMsg			= $00100000;	{ CA paging activity }
	telCAIntercomMsg		= $00200000;	{ CA intercom activity }
	telCAModemToneMsg		= $00400000;	{ modem tones detected }
	telCAFaxToneMsg			= $00800000;	{ fax tones detected }
	telCAIdleMsg			= $01000000;	{ CA has transitioned into idle state }
	telCASuccessiveAlertMsg	= $02000000; 	{ phone is alerting, one per ring }
	telCAUserUserInfoMsg	= $04000000;	{ user to user information has arrrived }
											{ for this CA }
	telCAOtherMsg			= $80000000; 	{ tool specific CA msg }
	telAllCAMsgs			= $07FFFFFF;	{ mask to all non tool specific CA events }

{ Flags bits for TELRecord }

	telNoMenus			= $00010000;	{ tells tool not to display any custom menus }
	telQuiet			= $00020000;	{ tells tool not to display any dialog boxes or alerts }
	
{ Features Flag bits for TELTermRecord }

	pcmAvail			= $00000001;	{ true if PCM voice data accessible }
	hasHandset			= $00000002;	{ true if a phone/handset is attached }
	hasSpeakerphone		= $00000004;	{ true if a 2 way speakerphone is attached }
	canOnHookDial 		= $00000008;	{ can on-hook dial }
	hasRinger			= $00000010;	{ terminal has its own ringer }
	canSetDisplay  		= $00000020;	{ application can write to the display }
	hasKeypad			= $00000040;	{ attached phone has standard 12 key pad }
	hasVideo			= $00000080;	{ terminal has a videophone }
	hasOther			= $00000100;	{ reserved for future use }
	crossDNConference	= $00000200; 	{ can perform cross-DN conferences }
	hasSubaddress		= $00000400;	{ attached network supports subaddressing }
	hasUserUserInfo 	= $00000800; 	{ network supports user-to-user info }
	{ other bits in featureFlags are reserved by Apple for future use }

{ Features Flags bits for TELDNRecord }

	dndSub					= $00000001;		{ do not disturb subscribed}
	dndAvail				= $00000002;		{ do not disturb available}
	dndActive				= $00000004;		{ do not disturb active}

	voiceMailAccessSub		= $00000008;		{ message waiting subscribed }
	voiceMailAccessAvail 	= $00000010;		{ message waiting available }
	voiceMailAccessActive	= $00000020;		{ message waiting active}
	
	pagingSub				= $00000040;		{ paging is subscribed}
	pagingAvail				= $00000080;		{ paging is available}
	pagingActive			= $00000100;		{ paging is active}

	intercomSub				= $00000200;		{ intercom is subscribed}
	intercomAvail			= $00000400;		{ intercom is available}
	intercomActive			= $00000800;		{ intercom is active}
	
	dnSelectSub				= $00001000; 		{ dn Select is subscribed}
	dnSelectAvail			= $00002000; 		{ dn Select is available}
	dnSelectActive			= $00004000; 		{ dn is selected }
	
	callPickupSub			= $00008000; 		{ call pickup is subscribed }
	callPickupAvail			= $00010000; 		{ call pickup is available}

	dnInUse					= $00020000; 		{ a CA is allocated for this dn }
	logicalDN 				= $00040000; 		{ this dn is not on this terminal }
	dnAccessible			= $00080000; 		{ commands can be sent to this dn }
	canInitiate				= $00100000; 		{ an outgoing CA can be initiated }
	voiceMessageWaiting		= $00200000;		{ a message is waiting for this dn }
	{ other bits in featureFlags are reserved by Apple for future use }

{ Forward Flags bits for TELDNRecord }

	immediateForwardSub		= $00000001;		{ Immed call forward subscribed }
	immediateForwardAvail	= $00000002;		{ Immed call forward available }
	immediateForwardActive	= $00000004;		{ Immed call forward active }	

	busyForwardSub			= $00000008;		{ forward on busy subscribed }
	busyForwardAvail		= $00000010;		{ forward on busy available }
	busyForwardActive		= $00000020;		{ forward on busy active }

	noAnswerForwardSub		= $00000040;		{ no answer call forward subscribed }
	noAnswerForwardAvail	= $00000080;		{ no answer call forward available }
	noAnswerForwardActive	= $00000100;		{ no answer call forward active }	

	busyNAForwardSub		= $00000200;		{ busy & no answer call forward subscribed }
	busyNAForwardAvail		= $00000400;		{ busy & no answer call forward available }
	busyNAForwardActive		= $00000800;		{ busy & no answer call forward active }	
	{ other bits in forwardFlags are reserved by Apple for future use }

{ Constants for FeaturesFlag in TELCARecord }
	holdSub					= $00000001;		{ hold subscribed }
	holdAvail				= $00000002;		{ hold available }
	holdActive				= $00000004;		{ hold active }

	conferenceSub			= $00000008;		{ conference subscribed }
	conferenceAvail			= $00000010;		{ conference available }
	conferenceActive		= $00000020;		{ conference active }
	
	conferenceDropSub		= $00000040;		{ conference drop subscribed }
	conferenceDropAvail		= $00000080;		{ a call to TELDrop will drop this }
												{ CA only from a conference}

	conferenceSplitSub		= $00000100;		{ conference split subscribed }
	conferenceSplitAvail	= $00000200;		{ conference split available for this CA }
	numToConferenceRequired	= $00000400;		{ the number of CAs to be conferenced }
												{ is required in TELConferencePrep }

	transferSub				= $00000800;		{ transfer subscribed }
	transferAvail			= $00001000;		{ transfer available }
	transferActive			= $00002000;		{ transfer active}
	
	caRelated				= $00004000;		{ this CA is specified in some other }
												{ CA's relatedCA field }
	{ other bits in FeaturesFlag are reserved by Apple for future use}

{ Constants for otherFeatures in TELCARecord }
	callbackSub				= $00000001; 		{ call back subscribed }	
	callbackAvail			= $00000002;		{ call back available }
	callbackActive			= $00000004;		{ call back active }
	callbackClearSub		= $00000008;		{ call back cancel subscribed }

	callbackNowSub			= $00000010;		{ call back now subscribed }
	callbackNowAvail		= $00000020;		{ call back now available }

	callbackBusy			= $00000040;		{ call back on busy }
	callbackNoAnswer		= $00000080;		{ call back on no answer }
	callbackReturnsRef		= $00000100;		{ call back returns a reference }

	parkSub					= $00000200;		{ call park subscribed }
	parkAvail				= $00000400;		{ call park available }
	parkActive				= $00000800;		{ call park active }
	parkRetrieveSub			= $00001000;		{ call park retrieve subscribed }
	parkRetrieveWithID		= $00002000;		{ retrieve parked calls with IDs }
	parkWithReturnedID		= $00004000;		{ park call to a specific remote ID }
	parkWithGivenID			= $00040000;		{ for switch that requires ID for parking }
	
	rejectable				= $00008000;   		{ CA is rejectable }
	deflectable				= $00010000;   		{ CA is deflectable }
	acceptable				= $00020000;		{ CA is acceptable }	
	{ other bits in otherfeaturesFlag are reserved by Apple for future use }


{ Constants for handleType in FeatureList structure below }
	telHandleType		 	= 0;		{ feature requires a terminal handle }
	telDNHandleType	 		= 1;		{ feature requires a DN handle }
	telCAHandleType	 		= 2;		{ feature requires a CA handle }


TYPE
	TELErr 				= OSErr;
	
	TELFlags			= LONGINT;
	TELFeatureFlags		= LONGINT;
	
	TELDNFeatureFlags 	= LONGINT;
	TELDNForwardFlags 	= LONGINT;
	
	TELCAFeatureFlags 	= LONGINT;
	TELCAOtherFeatures 	= LONGINT;

	TELTermPtr			= ^TELTermRecord;
	TELTermRecord		= RECORD
		tRef				: INTEGER;
		featureFlags		: TELFeatureFlags;
		handsetSpeakerVol 	: INTEGER;
		handsetMicVol		: INTEGER;	
		speakerphoneVol		: INTEGER;
		speakerphoneMicVol	: INTEGER;
		ringerVol			: INTEGER;
		otherVol			: INTEGER;
		ringerTypes			: INTEGER;
		hasDisplay		  	: INTEGER;
		displayRows			: INTEGER;
		numDNs				: INTEGER;
		maxAllocCA			: INTEGER;
		curAllocCA			: INTEGER;
		reserved			: LONGINT;
	END;

	TELHandle		 =  ^TELPtr;
	TELPtr			 =  ^TELRecord;
	TELRecord 		 = 	    RECORD
		procID    		: INTEGER;
		
		flags			: TELFlags;
		reserved		: INTEGER;
		
		refCon			: LONGINT;
		userData		: LONGINT;
		
		defproc			: ProcPtr;
		
		config 			: Ptr;
		oldConfig 		: Ptr;
		
		pTELTerm		: TELTermPtr;
		
		telPrivate		: LONGINT;
		reserved1  		: LONGINT;
		reserved2  		: LONGINT;
	
		pTELTermSize	: LONGINT;
		version   		: INTEGER;
	END;
	

	TELDNHandle 	= ^TELDNPtr;
	TELDNPtr 		= ^TELDNRecord;
	TELDNRecord		=	RECORD		
		dnRef				: INTEGER;
		dn					: StringPtr;	
		dnPartyName			: StringPtr;
		dnSubaddress		: StringPtr;
		hTEL				: TELHandle;
		maxAllocCA			: INTEGER;
		curAllocCA			: INTEGER;
		dnType				: INTEGER;
		featureFlags		: TELDNFeatureFlags;
		numPageIDs			: INTEGER;
		numIntercomIDs		: INTEGER;
		numPickupIDs		: INTEGER;
		forwardFlags		: TELDNForwardFlags;
		iForwardDN			: StringPtr;	
		iForwardSubaddress	: StringPtr;
		iForwardPartyName	: StringPtr;
		bForwardDN			: StringPtr;	
		bForwardSubaddress	: StringPtr;
		bForwardPartyName	: StringPtr;
		naForwardDN			: StringPtr;
		naForwardSubaddress	: StringPtr;
		naForwardPartyName	: StringPtr;
		naForwardRings		: INTEGER;
		telDNPrivate		: LONGINT;
		refCon				: LONGINT;
		userData			: LONGINT;
		reserved			: LONGINT;	
	END;


	TELCAHandle 	= ^TELCAPtr;
	TELCAPtr  		= ^TELCARecord;	
	TELCARecord 	= RECORD
		caRef	 		: INTEGER;
		hTELDN	 		: TELDNHandle; 
		hTEL			: TELHandle;
		caState			: INTEGER; 		
		relatedCA		: TELCAHandle;
		connectTime		: LONGINT;
		intExt			: INTEGER;	
		callType		: INTEGER;
		dialType		: INTEGER;
		bearerType		: INTEGER;
		rate			: INTEGER;
		rmtDN			: StringPtr;				
		rmtPartyName	: StringPtr;
		rmtSubaddress 	: StringPtr;
		routeDN			: StringPtr;
		routePartyName 	: StringPtr;
		routeSubaddress : StringPtr;
		priority		: INTEGER;	
		conferenceLimit	: INTEGER; 
		featureFlags	: TELCAFeatureFlags;
		otherFeatures	: TELCAOtherFeatures;	
		telCAPrivate	: LONGINT;
		refCon			: LONGINT;
		userData		: LONGINT;
		reserved		: LONGINT;
	END;
	
	
	FeatureListPtr		= ^FeatureList;
	FeatureList			= RECORD
		featureID		: INTEGER;
		featureName		: StringPtr;
		handleType		: INTEGER;
		nextFeature		: FeatureListPtr
	END;


{ CA MESSAGE STRUCTURES FOR MSGINFO }

	CAGenericMsgRec	= RECORD
		rmtDN			: StringPtr;
		rmtName			: StringPtr;
		rmtSubaddress 	: StringPtr;
		dialType 		: INTEGER;
	END;
	
	
	CAUserUserInfoMsgRec	= RECORD
		userUserInfo	: StringPtr;
	END;
	
	
	CAConfMsgRec	= RECORD
		relatedCA		: TELCAHandle;
	END;
	
	
	CATransfMsgRec	= RECORD
		rmtDN			: StringPtr;
		rmtName			: StringPtr;
		rmtSubaddress 	: StringPtr;
		dialType		: INTEGER;
		prepCA			: TELCAHandle;
	END;
	
	
	
FUNCTION InitTEL: TELErr;

FUNCTION TELGetInfo(hTEL: TELHandle): TELErr;
FUNCTION TELOpenTerm(hTEL: TELHandle): TELErr;
FUNCTION TELResetTerm(hTEL: TELHandle): TELErr;
FUNCTION TELCloseTerm(hTEL: TELHandle): TELErr;

FUNCTION TELTermMsgHand(hTEL: TELHandle; eventMask: LONGINT; msgProc:ProcPtr; 
	globals: LONGINT): TELErr;
FUNCTION TELClrTermMsgHand(hTEL: TELHandle; msgProc:ProcPtr): TELErr;
FUNCTION TELTermEventsSupp(hTEL: TELHandle; VAR eventMask: LONGINT) : TELErr;

FUNCTION TELGetProcID(rmtName: Str255): INTEGER;
FUNCTION TELNew(procID: INTEGER; flags: TELFlags; refCon: LONGINT; userData: LONGINT): TELHandle;
FUNCTION TELDefault(VAR theConfig: Ptr; procID: INTEGER; allocate: BOOLEAN): TELErr;
FUNCTION TELValidate(hTEL: TELHandle): BOOLEAN;
FUNCTION TELGetConfig(hTEL: TELHandle): Ptr;
FUNCTION TELSetConfig(hTEL: TELHandle; thePtr: Ptr): INTEGER;
FUNCTION TELChoose(VAR hTEL:TELHandle; where: Point; idleProc:ProcPtr): TELErr;

FUNCTION TELSetupPreflight(procID: INTEGER; VAR magicCookie: LONGINT): Handle;
PROCEDURE TELSetupSetup(procID: INTEGER; theConfig: Ptr; count: INTEGER;
	theDialog: DialogPtr; VAR magicCookie: LONGINT);
FUNCTION TELSetupFilter(procID: INTEGER; theConfig: Ptr; count: INTEGER;
	theDialog: DialogPtr; VAR theEvent: EventRecord; VAR theItem: INTEGER;
	VAR magicCookie: LONGINT): BOOLEAN;
PROCEDURE TELSetupItem(procID: INTEGER; theConfig: Ptr; count: INTEGER;
	theDialog: DialogPtr; VAR theItem: INTEGER; VAR magicCookie: LONGINT);
PROCEDURE TELSetupCleanup(procID: INTEGER; theConfig: Ptr; count: INTEGER;
	theDialog: DialogPtr; VAR magicCookie: LONGINT);
PROCEDURE TELSetupXCleanup(procID: INTEGER; theConfig: Ptr; count: INTEGER;
	theDialog: DialogPtr; OKed: Boolean; VAR magicCookie: LONGINT);
PROCEDURE TELSetupPostflight(procID: INTEGER);

FUNCTION TELDispose(hTEL: TELHandle): TELErr;

FUNCTION TELCountDNs(hTEL: TELHandle; dnType: INTEGER; physical: BOOLEAN): INTEGER;
FUNCTION TELDNLookupByIndex( hTEL: TELHandle; dnType: INTEGER; physical: BOOLEAN;
	index: INTEGER; VAR hTELDN: TELDNHandle): TELErr;
FUNCTION TELDNLookupByName( hTEL: TELHandle; dn: Str255; 
	VAR hTELDN: TELDNHandle): TELErr;
FUNCTION TELDNSelect(hTELDN: TELDNHandle; select: BOOLEAN): TELErr;
FUNCTION TELDNDispose(hTELDN: TELDNHandle): TELErr;
FUNCTION TELGetDNInfo(hTELDN: TELDNHandle): TELErr;
FUNCTION TELGetDNFlags(hTELDN: TELDNHandle; VAR dnFeatureFlags: LONGINT;
	VAR dnForwardFlags: LONGINT): TELErr;

FUNCTION TELDNMsgHand (hTELDN: TELDNHandle; allDNs: BOOLEAN; eventMask:LONGINT;
	msgProc: ProcPtr; globals:LONGINT): TELErr;
FUNCTION TELClrDNMsgHand(hTELDN: TELDNHandle; msgProc: ProcPtr): TELErr;
FUNCTION TELDNEventsSupp(hTELDN: TELDNHandle; VAR eventMask: LONGINT): TELErr;

FUNCTION TELCountCAs(hTELDN: TELDNHandle; internalExternal: INTEGER): INTEGER;
FUNCTION TELCALookup(hTELDN: TELDNHandle; internalExternal : INTEGER;
	index: INTEGER; VAR hTELCA: TELCAHandle): TELErr;
FUNCTION TELCADispose(hTELCA: TELCAHandle): TELErr;
FUNCTION TELGetCAState(hTELCA: TELCAHandle; VAR state: INTEGER): TELErr;
FUNCTION TELGetCAFlags(hTELCA: TELCAHandle; VAR caFeatureFlags: LONGINT;
	VAR caOtherFeatures: LONGINT): TELErr;
FUNCTION TELGetCAInfo(hTELCA: TELCAHandle): TELErr;

FUNCTION TELCAMsgHand(hTELDN: TELDNHandle; eventMask:LONGINT; 
	msgProc: ProcPtr; globals: LONGINT): TELErr;
FUNCTION TELClrCAMsgHand(hTELDN: TELDNHandle; msgProc: ProcPtr): TELErr;
FUNCTION TELCAEventsSupp(hTELDN: TELDNHandle; VAR eventMask: LONGINT): TELErr;
	
FUNCTION TELSetupCall(hTELDN: TELDNHandle; VAR hTELCA: TELCAHandle; destDN,
	destName, destSubaddr, userUserInfo: Str255; bearerType: INTEGER;
	rate: INTEGER): TELErr;
FUNCTION TELConnect(hTELCA: TELCAHandle): TELErr;
FUNCTION TELDialDigits(hTELCA: TELCAHandle; digits: Str255): TELErr;

FUNCTION TELAcceptCall(hTELCA: TELCAHandle): TELErr;
FUNCTION TELRejectCall(hTELCA: TELCAHandle; reason: INTEGER): TELErr;
FUNCTION TELDeflectCall(hTELCA: TELCAHandle; rmtDN, rmtName, 	
	rmtSubaddress: Str255): TELErr;
FUNCTION TELAnswerCall(hTELCA: TELCAHandle): TELErr;
FUNCTION TELDrop(hTELCA: TELCAHandle; userUserInfo:Str255): TELErr;
	
FUNCTION TELHold(hTELCA: TELCAHandle): TELErr;
FUNCTION TELRetrieve(hTELCA: TELCAHandle): TELErr;

FUNCTION TELConferencePrep(hTELCA1: TELCAHandle; hTELCA2: TELCAHandle;
	numToConference: INTEGER): TELErr;
FUNCTION TELConferenceEstablish(hTELCA1, hTELCA2: TELCAHandle): TELErr;
FUNCTION TELConferenceSplit(hTELCA: TELCAHandle): TELErr;

FUNCTION TELTransferPrep(hTELCA1: TELCAHandle; hTELCA2: TELCAHandle): TELErr;
FUNCTION TELTransferEstablish(hTELCA1, hTELCA2: TELCAHandle): TELErr;
FUNCTION TELTransferBlind(hTELCA1: TELCAHandle; rmtDN: Str255; 
	rmtName: Str255; rmtSubaddress : Str255): TELErr;
	
FUNCTION TELForwardSet(hTELDN: TELDNHandle; forwardDN, forwardPartyName,
	forwardSubaddr: Str255; forwardType: INTEGER; numRings: INTEGER): TELErr;
FUNCTION TELForwardClear(hTELDN: TELDNHandle; ftype:INTEGER): TELErr;
	
FUNCTION TELCallbackSet(hTELCA: TELCAHandle; VAR callbackRef: INTEGER): TELErr;
FUNCTION TELCallbackClear(hTEL: TELHandle; callbackRef: INTEGER): TELErr;
FUNCTION TELCallbackNow(hTELCA: TELCAHandle; callbackRef: INTEGER): TELErr;
	
FUNCTION TELDNDSet(hTELDN: TELDNHandle; dndType: INTEGER): TELErr;
FUNCTION TELDNDClear(hTELDN: TELDNHandle; dndType: INTEGER): TELErr;
	
FUNCTION TELCallPickup(hTELCA: TELCAHandle; pickupDN: Str255; 
	pickupGroupID: INTEGER): TELErr;
	
FUNCTION TELParkCall(hTELCA: TELCAHandle; VAR parkRetrieveID: StringPtr;
	parkID:Str255): TELErr;
FUNCTION TELRetrieveParkedCall(hTELCA: TELCAHandle;
	parkRetrieveID:Str255): TELErr;
	
FUNCTION TELVoiceMailAccess(hTELCA: TELCAHandle) : TELErr;
FUNCTION TELPaging(hTELCA: TELCAHandle; pageID: INTEGER) : TELErr;
FUNCTION TELIntercom(hTELCA: TELCAHandle; intercomID: INTEGER) : TELErr;
	
FUNCTION TELOtherFeatureList(hTEL: TELHandle; VAR fList: FeatureListPtr): TELErr;
FUNCTION TELOtherFeatureImplement(hTEL: TELHandle; theHandle: Handle; 
	featureID: INTEGER): TELErr;
FUNCTION TELToolFunctions(hTEL: TELHandle; msgcode: INTEGER;
	VAR supportsIt: BOOLEAN): TELErr;
FUNCTION TELOtherFunction(hTEL: TELHandle; paramblock: Ptr; size: LONGINT): TELErr;
	
FUNCTION TELGetHooksw(hTEL: TELHandle; hookType: INTEGER; VAR onHook : BOOLEAN): TELErr;
FUNCTION TELSetHooksw(hTEL: TELHandle; hookType: INTEGER; onHook : BOOLEAN): TELErr;
FUNCTION TELGetVolume(hTEL: TELHandle; volType: INTEGER; VAR level: INTEGER;
	VAR volState: INTEGER): TELErr;
FUNCTION TELSetVolume(hTEL: TELHandle; volType: INTEGER; VAR level: INTEGER;
	volState:INTEGER): TELErr;
FUNCTION TELAlert(hTEL: TELHandle; VAR level: INTEGER; alertPattern: INTEGER): TELErr;
FUNCTION TELGetDisplay(hTEL: TELHandle; index: INTEGER; 
	VAR displayMode: INTEGER; VAR text: StringPtr): TELErr;
FUNCTION TELSetDisplay(hTEL: TELHandle; index: INTEGER; displayMode: INTEGER;
	text: Str255): TELErr;
	
PROCEDURE TELIdle(hTEL: TELHandle);
PROCEDURE TELActivate(hTEL: TELHandle; activate: BOOLEAN);
PROCEDURE TELResume(hTEL: TELHandle; resume: BOOLEAN);
FUNCTION TELMenu(hTEL: TELHandle; menuID: INTEGER; item: INTEGER): BOOLEAN;
PROCEDURE TELEvent(hTEL: TELHandle; VAR theEvent: EventRecord);
PROCEDURE TELGetToolName(procID: INTEGER; VAR name: Str255);
FUNCTION TELGetVersion(hTEL: TELHandle): Handle;
FUNCTION TELGetTELVersion: INTEGER;
	
FUNCTION TELIntlToEnglish(hTEL: TELHandle; inputPtr: Ptr; 
	VAR outputPtr: Ptr; language: INTEGER): OSErr;
FUNCTION TELEnglishToIntl(hTEL: TELHandle; inputPtr: Ptr; 
	VAR outputPtr: Ptr; language: INTEGER): OSErr;
		

{$ENDC} {UsingTelephones}

{$IFC NOT UsingIncludes}
	END.
{$ENDC}
