
	/* Created 3/12/93 4:51 PM by AppMaker	*/

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <TextEdit.h>
#include <ToolUtils.h>
#include <Resources.h>

#include "ResourceDefs.h"
#include "Miscellany.h"
#include "DialogAids.h"
#include "Windowing.h"
#include "getSQLdialogs.h"

#define FALSE	0
#define TRUE	1

#define OKButton			1	/** These 2 defines apply to ALL dialogs	**/
#define CancelButton		2 


	extern Str255		hdbcText;
	extern Str255		hstmtText;


#pragma segment futilities


static void TrackPopup( Rect bounds, short menuID, short *choice )
{
	MenuHandle		menu;
	Point			corner;
	long			result;
	Rect			triangleRect;

	menu = (MenuHandle)( GetResource( 'MENU', menuID ) );
	if( menu )
	{
		InsertMenu( menu, -1 );
		triangleRect.top	= bounds.top   + 5;
		triangleRect.left	= bounds.right - 18;
		triangleRect.bottom	= triangleRect.top   + 7;
		triangleRect.right	= triangleRect.left + 13;
		EraseRect( &triangleRect );
#define topLeft(r)	(((Point*)&(r))[0])
		corner = topLeft( bounds );
		LocalToGlobal( &corner );
		CheckItem( menu, *choice, true );
		result = PopUpMenuSelect( menu, corner.v, corner.h + 1, *choice );
		CheckItem( menu, *choice, false );
		DeleteMenu( menuID );
		InvalRect( &triangleRect );		/* because we always erase triangleRect	*/
		if( (HiWord( result ) != 0) && (LoWord( result ) != *choice ) )
		{
			*choice = LoWord( result );
			InsetRect( &bounds, 1, 1 );
			InvalRect( &bounds );
		}
	}
	return;
}/* end TrackPopup */


void DoPopup( short itemNr, short menuID, short *Choice )
{
	short			itemType;
	Handle			itemHandle;
	Rect			itemRect;

	GetDItem( qd.thePort, itemNr, &itemType, &itemHandle, &itemRect );
	TrackPopup( itemRect, menuID, Choice );
	return;
}/* end DoPopup */


pascal void RectItem( DialogPtr, short itemNr )
{
	PenState	savePen;
	short		itemType;
	Handle		itemHandle;
	Rect		itemRect;


	GetPenState( &savePen );
	PenNormal();
	GetDItem( qd.thePort, itemNr, &itemType, &itemHandle, &itemRect );
	FrameRect( &itemRect );
	SetPenState( &savePen );
	return;
}/*end RectItem */


void SetDText( short itemNr, Str255 text )
{
	short		itemType;
	Handle		itemHandle;
	Rect		itemRect;

	GetDItem( qd.thePort, itemNr, &itemType, &itemHandle, &itemRect );
	SetIText( itemHandle, text );
	return;
}/* end SetDText */


void GetDText( short itemNr, Str255 text )
{
	short		itemType;
	Handle		itemHandle;
	Rect		itemRect;

	GetDItem( qd.thePort, itemNr, &itemType, &itemHandle, &itemRect );
	GetIText( itemHandle, text );
	return;
}/* end GetDText */


UpdateText( MenuHandle popMenu, short choice, Str255 text, short FieldNr )
{
	GetItem( popMenu, choice, text );
	SetDText( FieldNr, text );
	return;
}/* end UpdateText */


updateCBpop(	MenuHandle szmh, short szChoice, Str255 szText,
				MenuHandle cbmh, short cbChoice, Str255 cbText, short cbTxFieldNr )
{
	short			ItemCount;
	unsigned char	b;


	ItemCount = CountMItems( szmh );
	b = 0;
	if( szChoice <= ItemCount - 2 )
		b = szText[0];
	sprintf( cbText, "%d", b );
	c2pstr(  cbText );
	SetItem( cbmh, 1, cbText );
		/* fix up the edit text box:	*/
	if( cbChoice == 1 )
		SetDText( cbTxFieldNr, cbText );
	return;
}/* end updateCBpop */


tx2cb(	short itemNr, Str255 szText,
		short cbField, MenuHandle cbMenu, short cbChoice, Str255 cbText )
{
	GetDText( itemNr, szText );							/* get source text	*/

	sprintf( cbText, "%d", szText[0] );
	c2pstr(  cbText );
	SetItem( cbMenu, 1, cbText );
	if( cbChoice == 1 )
		SetDText( cbField, cbText );
	return;
}/* end tx2cb */


#pragma segment getSQLdialogs

#define NullHenvCheck		3 
#define NULLLabel			4 
#define NullPhdbcOutCheck	5 

Boolean GetSQLAllocConnect( SQLAllocConnectRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLAllocConnectID, nil, (WindowPtr) -1L );
	SetPort( theDialog );
	SetCheckbox( NullHenvCheck,		info->NullHenvChecked		);
	SetCheckbox( NullPhdbcOutCheck,	info->NullPhdbcOutChecked	);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;		done = TRUE;		break;
		case CancelButton:	result = FALSE;		done = TRUE;		break;
		case NullHenvCheck:
			DoCheckbox( itemNr, &info->NullHenvChecked );
			break;
		case NullPhdbcOutCheck:
			DoCheckbox( itemNr, &info->NullPhdbcOutChecked );
			break;
		}/* end SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLAllocConnect */



#define NullPhenvOutCheck	3 


Boolean GetSQLAllocEnv( SQLAllocEnvRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLAllocEnvID, nil, (WindowPtr) -1L );
	SetPort( theDialog );
	SetCheckbox ( NullPhenvOutCheck, info->fNull_phenv );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;		done = TRUE;		break;
		case CancelButton:	result = FALSE;		done = TRUE;		break;
		case NullPhenvOutCheck:
			DoCheckbox( itemNr, &info->fNull_phenv );
			break;
		}
	}

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLAllocEnv */


#define hdbcLabel			3 
#define hdbcTxLabel			4 
#define NullPhstmtOutCheck	5 


Boolean GetSQLAllocStmt( SQLAllocStmtRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLAllocStmtID, nil, (WindowPtr) -1L );
	SetPort( theDialog );
	SetCheckbox( NullPhstmtOutCheck, info->NullPhstmtOutChecked );
	SetDText( hdbcTxLabel, hdbcText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullPhstmtOutCheck:
			DoCheckbox( itemNr, &info->NullPhstmtOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLAllocStmt */


#define hstmtLabel					3 
#define hstmtTxLabel				4 
#define icolLabel					5 
#define icolTxField					6 
#define fCTypeLabel					7 
#define fCTypePop4Popup				8 
#define fCTypeTxField				9 
#define NullRgbValuePointerCheck	10 
#define cbValueMaxLabel				11 
#define cbValueMaxField				12 
#define NullPcbValuePointerCheck	13 


static pascal void DrawfCTypePop4Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fCTypePop4ID, 0 );
	return;
}/* end DrawfCTypePop4Popup */


Boolean GetSQLBindCol( SQLBindColRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLBindColID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fCTypePop4Menu );
	if( info->fCTypeChoice < 1 || info->fCTypeChoice > ItemCount )
	{
		info->fCTypeChoice = 1;
		GetItem( fCTypePop4Menu, 1, info->fCTypeText );
	}

	SetDText(		icolTxField,				info->icolText			);
	SetDText(		fCTypeTxField,				info->fCTypeText		);
	SetDText(		cbValueMaxField,			info->cbValueMaxText	);
	SetCheckbox(	NullRgbValuePointerCheck,	info->NullRgbValuePointerChecked );
	SetCheckbox(	NullPcbValuePointerCheck,	info->NullPcbValuePointerChecked );
	SetUserItem(	fCTypePop4Popup,			(ProcPtr)&DrawfCTypePop4Popup );

	SetDText( hstmtTxLabel, hstmtText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;		break;
		case CancelButton:	result = FALSE;	done = TRUE;		break;

		case icolTxField:		GetDText( itemNr, info->icolText );			break;
		case fCTypeTxField:		GetDText( itemNr, info->fCTypeText );		break;
		case cbValueMaxField:	GetDText( itemNr, info->cbValueMaxText );	break;

		case NullRgbValuePointerCheck:
			DoCheckbox( itemNr, &info->NullRgbValuePointerChecked );	break;
		case NullPcbValuePointerCheck:
			DoCheckbox( itemNr, &info->NullPcbValuePointerChecked );	break;

		case fCTypePop4Popup:
			DoPopup( fCTypePop4Popup, fCTypePop4ID, &info->fCTypeChoice );
			GetItem( fCTypePop4Menu, info->fCTypeChoice, info->fCTypeText );
			SetDText( fCTypeTxField, info->fCTypeText );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLBindCol */


#define hdbcLabel				3 
#define szConnStrInLabel		4 
#define szConnStrIn55Popup		5 
#define szConnStrInTxField		6 
#define cbConnStrInLabel		7 
#define cbConnStrIn55Popup		8 
#define cbConnStrInTxField		9 
#define NullSzConnStrOutCheck	10 
#define cbConnStrOutMaxLabel	11 
#define MaxTxField				12 
#define NullPcbConnStrOutCheck	13 
#define hdbcTxLabel				14 


static pascal void DrawszConnStrIn55Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, szConnStrIn55ID, 0 );
	return;
}/* end DrawszConnStrIn55Popup */


static pascal void DrawcbConnStrIn55Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbConnStrIn55ID, 0 );
	return;
}/* end DrawcbConnStrIn55Popup */


Boolean GetSQLBrowseConnect( SQLBrowseConnectRec *info )
{
	DialogPtr			theDialog;
	GrafPtr				savePort;
	Boolean				result;
	Boolean				done;
	short				itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLBrowseConnectID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( szConnStrIn55Menu );
	if( info->szConnStrIn55Choice < 1 || info->szConnStrIn55Choice > ItemCount )
	{
		info->szConnStrIn55Choice	= 1;
		info->cbConnStrIn55Choice	= 1;
		GetItem( szConnStrIn55Menu,	1, info->szConnStrInText	);
		GetItem( cbConnStrIn55Menu,	1, info->cbConnStrInText	);
	}

	SetDText( szConnStrInTxField,	info->szConnStrInText	);
	SetDText( cbConnStrInTxField,	info->cbConnStrInText	);
	SetDText( MaxTxField,			info->MaxText			);
	SetCheckbox( NullSzConnStrOutCheck,		info->NullSzConnStrOutChecked	);
	SetCheckbox( NullPcbConnStrOutCheck,	info->NullPcbConnStrOutChecked	);
	SetUserItem( szConnStrIn55Popup,	(ProcPtr)&DrawszConnStrIn55Popup	);
	SetUserItem( cbConnStrIn55Popup,	(ProcPtr)&DrawcbConnStrIn55Popup	);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;		done = TRUE;		break;
		case CancelButton:	result = FALSE;		done = TRUE;		break;

		case szConnStrInTxField:
			tx2cb(	  itemNr, info->szConnStrInText,
					cbConnStrInTxField, cbConnStrIn55Menu, info->cbConnStrIn55Choice,
					info->cbConnStrInText );
			break;
		case cbConnStrInTxField:
			GetDText( itemNr, info->cbConnStrInText );
			break;
		case MaxTxField:
			GetDText( itemNr, info->MaxText );
			break;

		case NullSzConnStrOutCheck:
			DoCheckbox( itemNr, &info->NullSzConnStrOutChecked );
			break;
		case NullPcbConnStrOutCheck:
			DoCheckbox( itemNr, &info->NullPcbConnStrOutChecked );
			break;

		case szConnStrIn55Popup:
			DoPopup( szConnStrIn55Popup, szConnStrIn55ID, &info->szConnStrIn55Choice );
			UpdateText( szConnStrIn55Menu, info->szConnStrIn55Choice,
						info->szConnStrInText, szConnStrInTxField );
			updateCBpop(	szConnStrIn55Menu,
							info->szConnStrIn55Choice,
							info->szConnStrInText,
							cbConnStrIn55Menu,
							info->cbConnStrIn55Choice,
							info->cbConnStrInText, cbConnStrInTxField );
			break;
		case cbConnStrIn55Popup:
			DoPopup( cbConnStrIn55Popup, cbConnStrIn55ID, &info->cbConnStrIn55Choice );
			UpdateText( cbConnStrIn55Menu, info->cbConnStrIn55Choice,
						info->cbConnStrInText, cbConnStrInTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLBrowseConnect */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define icolLabel			5 
#define icolTxField			6 
#define fDescTypeLabel		7 
#define fDescType6Popup		8 
#define fDescTypeTxField	9 
#define NullRgbDescOutCheck	10 
#define cbDescMaxLabel		11 
#define cbDescMax9Field		12 
#define NullPcbDescOutCheck	13 
#define NullPfDescOutCheck	14 


static pascal void DrawfDescType6Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fDescType6ID, 0 );
	return;
}/* end DrawfDescType6Popup */


Boolean GetSQLColAttributes( SQLColAttributesRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLColAttributesID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fDescType6Menu );
	if( info->fDescTypeChoice < 1 || info->fDescTypeChoice > ItemCount )
	{
		info->fDescTypeChoice = 1;
		GetItem( fDescType6Menu, 1, info->fDescTypeText );
	}

	SetCheckbox( NullRgbDescOutCheck,	info->NullRgbDescOutChecked );
	SetCheckbox( NullPcbDescOutCheck,	info->NullPcbDescOutChecked );
	SetCheckbox( NullPfDescOutCheck,	info->NullPfDescOutChecked );
	SetDText( icolTxField,				info->icolText );
	SetDText( fDescTypeTxField,			info->fDescTypeText );
	SetDText( cbDescMax9Field,			info->cbDescMaxText );
	SetUserItem( fDescType6Popup,		(ProcPtr)&DrawfDescType6Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case icolTxField:		GetDText( itemNr, info->icolText );			break;
		case cbDescMax9Field:	GetDText( itemNr, info->cbDescMaxText );	break;
		case fDescTypeTxField:	GetDText( itemNr, info->fDescTypeText );	break;

		case fDescType6Popup:
			DoPopup( fDescType6Popup, fDescType6ID, &info->fDescTypeChoice );
			GetItem( fDescType6Menu, info->fDescTypeChoice, info->fDescTypeText );
			SetDText( fDescTypeTxField, info->fDescTypeText );
			break;

		case NullRgbDescOutCheck:
			DoCheckbox( itemNr, &info->NullRgbDescOutChecked );
			break;
		case NullPcbDescOutCheck:
			DoCheckbox( itemNr, &info->NullPcbDescOutChecked );
			break;
		case NullPfDescOutCheck:
			DoCheckbox( itemNr, &info->NullPfDescOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLColAttributes */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define QualifierTxField	6 
#define OwnerTxField		7 
#define NameTxField			8 
#define cbTableLabel		9 
#define cbQualifierField	10 
#define cbOwnerField		11 
#define cbNameField			12 
#define szColumnLabel		13 
#define cbColumnLabel		14 
#define ColumnTxField		15 
#define cbColumnField		16 
#define QualifierLabel		17 
#define Qualifier56Popup	18 
#define OwnerLabel			19 
#define Owner56Popup		20 
#define NameLabel			21 
#define Name56Popup			22 
#define NameLabel			23 
#define Column56Popup		24 
#define QualifierLabel		25 
#define cbQualifier56Popup	26 
#define OwnerLabel			27 
#define cbOwner56Popup		28
#define NameLabel			29 
#define cbName56Popup		30 
#define NameLabel			31 
#define cbColumn56Popup		32 


static pascal void DrawQualifier56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop56ID, 0 );
	return;
}/* end DrawQualifier56Popup */


static pascal void DrawOwner56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop56ID, 0 );
	return;
}/* end DrawOwner56Popup */


static pascal void DrawName56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop56ID, 0 );
	return;
}/* end DrawName56Popup */


static pascal void DrawColumn56Popup( DialogPtr,  short itemNr )
{
	DrawPopup( itemNr, ColumnPop56ID, 0 );
	return;
}/* end DrawColumn56Popup */


static pascal void DrawcbQualifier56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop56ID, 0 );
	return;
}/* end DrawcbQualifier56Popup */


static pascal void DrawcbOwner56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop56ID, 0 );
	return;
}/* end DrawcbOwner56Popup */


static pascal void DrawcbName56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop56ID, 0 );
	return;
}/* end DrawcbName56Popup */


static pascal void DrawcbColumn56Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbColumnPop56ID, 0 );
	return;
}/* end DrawcbColumn56Popup */


Boolean GetSQLColumnPrivileges( SQLColumnPrivilegesRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLColumnPrivilegesID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop56Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->ColumnChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->cbColumnChoice	= 1;

		GetItem( QualifierPop56Menu,	1, info->QualifierText		);
		GetItem( OwnerPop56Menu,		1, info->OwnerText			);
		GetItem( NamePop56Menu,			1, info->NameText			);
		GetItem( ColumnPop56Menu,		1, info->ColumnText			);
		GetItem( cbQualifierPop56Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop56Menu,		1, info->cbOwnerText		);
		GetItem( cbNamePop56Menu,		1, info->cbNameText			);
		GetItem( cbColumnPop56Menu,		1, info->cbColumnText		);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( ColumnTxField,	info->ColumnText		);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);
	SetDText( cbColumnField,	info->cbColumnText		);

	SetUserItem( Qualifier56Popup,		(ProcPtr)&DrawQualifier56Popup		);
	SetUserItem( Owner56Popup,			(ProcPtr)&DrawOwner56Popup			);
	SetUserItem( Name56Popup,			(ProcPtr)&DrawName56Popup			);
	SetUserItem( Column56Popup,			(ProcPtr)&DrawColumn56Popup			);
	SetUserItem( cbQualifier56Popup,	(ProcPtr)&DrawcbQualifier56Popup	);
	SetUserItem( cbOwner56Popup,		(ProcPtr)&DrawcbOwner56Popup		);
	SetUserItem( cbName56Popup,			(ProcPtr)&DrawcbName56Popup			);
	SetUserItem( cbColumn56Popup,		(ProcPtr)&DrawcbColumn56Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop56Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop56Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop56Menu, info->cbNameChoice,
					info->cbNameText );
			break;
		case ColumnTxField:
			tx2cb(	itemNr, info->ColumnText,
					cbColumnField, cbColumnPop56Menu, info->cbColumnChoice,
					info->cbColumnText );
			break;

		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;
		case cbColumnField:		GetDText( itemNr, info->cbColumnText );		break;

		case Qualifier56Popup:
			DoPopup( Qualifier56Popup, QualifierPop56ID, &info->QualifierChoice );
			UpdateText( QualifierPop56Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop56Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop56Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner56Popup:
			DoPopup( Owner56Popup, OwnerPop56ID, &info->OwnerChoice );
			UpdateText( OwnerPop56Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop56Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop56Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name56Popup:
			DoPopup( Name56Popup, NamePop56ID, &info->NameChoice );
			UpdateText( NamePop56Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop56Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop56Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;
		case Column56Popup:
			DoPopup( Column56Popup, ColumnPop56ID, &info->ColumnChoice );
			UpdateText( ColumnPop56Menu, info->ColumnChoice,
						info->ColumnText, ColumnTxField );
			updateCBpop(	ColumnPop56Menu,
							info->ColumnChoice,
							info->ColumnText,
							cbColumnPop56Menu,
							info->cbColumnChoice,
							info->cbColumnText, cbColumnField );
			break;

		case cbQualifier56Popup:
			DoPopup( cbQualifier56Popup, cbQualifierPop56ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop56Menu, info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner56Popup:
			DoPopup( cbOwner56Popup, cbOwnerPop56ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop56Menu, info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName56Popup:
			DoPopup( cbName56Popup, cbNamePop56ID, &info->cbNameChoice );
			UpdateText( cbNamePop56Menu, info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		case cbColumn56Popup:
			DoPopup( cbColumn56Popup, cbColumnPop56ID, &info->cbColumnChoice );
			UpdateText( cbColumnPop56Menu, info->cbColumnChoice,
						info->cbColumnText, cbColumnField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLColumnPrivileges */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define QualifierTxField	6 
#define OwnerTxField		7 
#define NameTxField			8 
#define ColumnTxField		9 
#define cbTableLabel		10 
#define cbQualifierField		11 
#define QualifierLabel		12 
#define cbQualifier40Popup	13 
#define cbOwnerLabel		14 
#define cbOwner40Popup		15 
#define cbOwnerField			16 
#define cbNameLabel			17 
#define cbName40Popup		18 
#define cbNameField			19 
#define cbColNameField		20 
#define szColumnLabel		21 
#define cbColNameLabel		22 
#define cbColName40Popup	23 
#define QualLabel			24 
#define Qualifier40Popup	25 
#define OwnerLabel			26 
#define Owner40Popup		27 
#define NameLabel			28 
#define Name40Popup			29 
#define ColumnLabel			30 
#define Column40Popup		31


static pascal void DrawQualifier40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop40ID, 0 );
	return;
}/* end DrawQualifier40Popup */


static pascal void DrawOwner40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop40ID, 0 );
	return;
}/* end DrawOwner40Popup */


static pascal void DrawName40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop40ID, 0 );
	return;
}/* end DrawName40Popup */


static pascal void DrawColumn40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, ColNamePop40ID, 0 );
	return;
}/* end DrawColumn40Popup */


static pascal void DrawcbQualifier40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop40ID, 0 );
	return;
}/* end DrawcbQualifier40Popup */


static pascal void DrawcbOwner40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop40ID, 0 );
	return;
}/* end DrawcbOwner40Popup */


static pascal void DrawcbName40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop40ID, 0 );
	return;
}/* end DrawcbName40Popup */


static pascal void DrawcbColName40Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbColNamePop40ID, 0 );
	return;
}/* end DrawcbColName40Popup */


Boolean GetSQLColumns( SQLColumnsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLColumnsID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( Qualifier40Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->ColumnChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->cbColNameChoice	= 1;

		GetItem( Qualifier40Menu,	1, info->QualifierText		);
		GetItem( Owner40Menu,		1, info->OwnerText			);
		GetItem( Name40Menu,		1, info->NameText			);
		GetItem( ColName40Menu,		1, info->ColumnText			);
		GetItem( cbQualifier40Menu,	1, info->cbQualifierText	);
		GetItem( cbOwner40Menu,		1, info->cbOwnerText		);
		GetItem( cbName40Menu,		1, info->cbNameText			);
		GetItem( cbColName40Menu,	1, info->cbColNameText		);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( ColumnTxField,	info->ColumnText		);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);
	SetDText( cbColNameField,	info->cbColNameText		);

	SetUserItem( Qualifier40Popup,		(ProcPtr)&DrawQualifier40Popup		);
	SetUserItem( Owner40Popup,			(ProcPtr)&DrawOwner40Popup			);
	SetUserItem( Name40Popup,			(ProcPtr)&DrawName40Popup			);
	SetUserItem( Column40Popup,			(ProcPtr)&DrawColumn40Popup			);
	SetUserItem( cbQualifier40Popup,	(ProcPtr)&DrawcbQualifier40Popup	);
	SetUserItem( cbOwner40Popup,		(ProcPtr)&DrawcbOwner40Popup		);
	SetUserItem( cbName40Popup,			(ProcPtr)&DrawcbName40Popup			);
	SetUserItem( cbColName40Popup,		(ProcPtr)&DrawcbColName40Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifier40Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwner40Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbName40Menu, info->cbNameChoice,
					info->cbNameText );
			break;
		case ColumnTxField:
			tx2cb(	itemNr, info->ColumnText,
					cbColNameField, cbColName40Menu, info->cbColNameChoice,
					info->cbColNameText );
			break;

		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText	);	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText		);	break;
		case cbNameField:		GetDText( itemNr, info->cbNameText		);	break;
		case cbColNameField:	GetDText( itemNr, info->cbColNameText	);	break;

		case Qualifier40Popup:
			DoPopup( Qualifier40Popup, QualifierPop40ID, &info->QualifierChoice );
			UpdateText( Qualifier40Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	Qualifier40Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifier40Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner40Popup:
			DoPopup( Owner40Popup, OwnerPop40ID, &info->OwnerChoice );
			UpdateText( Owner40Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	Owner40Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwner40Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name40Popup:
			DoPopup( Name40Popup, NamePop40ID, &info->NameChoice );
			UpdateText( Name40Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	Name40Menu,
							info->NameChoice,
							info->NameText,
							cbName40Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;
		case Column40Popup:
			DoPopup( Column40Popup, ColNamePop40ID, &info->ColumnChoice );
			UpdateText( ColName40Menu, info->ColumnChoice,
						info->ColumnText, ColumnTxField );
			updateCBpop(	ColName40Menu,
							info->ColumnChoice,
							info->ColumnText,
							cbColName40Menu,
							info->cbColNameChoice,
							info->cbColNameText, cbColNameField );
			break;

		case cbQualifier40Popup:
			DoPopup( cbQualifier40Popup, cbQualifierPop40ID, &info->cbQualifierChoice );
			UpdateText( cbQualifier40Menu, info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner40Popup:
			DoPopup( cbOwner40Popup, cbOwnerPop40ID, &info->cbOwnerChoice );
			UpdateText( cbOwner40Menu, info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName40Popup:
			DoPopup( cbName40Popup, cbNamePop40ID, &info->cbNameChoice );
			UpdateText( cbName40Menu, info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		case cbColName40Popup:
			DoPopup( cbColName40Popup, cbColNamePop40ID, &info->cbColNameChoice );
			UpdateText( cbColName40Menu,	info->cbColNameChoice,
						info->cbColNameText,	cbColNameField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLColumns */


#define hdbcLabel			3 
#define hdbcTxLabel			4 
#define szDSNTxField		5 
#define szUIDTxField		6 
#define szAuthStrTxField	7 
#define szDSNLabel			8 
#define szDSNPopup			9 
#define szUIDLabel			10 
#define szUIDPopup			11 
#define szAuthStrLabel		12 
#define szAuthStrPopup		13 
#define CbDSNLabel			14 
#define cbDSNpopup			15 
#define CbUIDLabel			16 
#define cbUIDpopup			17 
#define cbAuthStrLabel		18 
#define cbAuthStrPopup		19 
#define cbDSNtxField		20 
#define cbUIDtxField		21 
#define cbAuthStrTxField	22 


static pascal void DrawszDSNPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, szDSNID, 0 );
	return;
}/* end DrawszDSNPopup */


static pascal void DrawszUIDPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, szUIDID, 0 );
	return;
}/* end DrawszUIDPopup */


static pascal void DrawszAuthStrPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, szAuthStrID, 0 );
	return;
}/* end DrawszAuthStrPopup */


static pascal void DrawcbDSNpopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbDSNpopID, 0 );
	return;
}/* end DrawcbDSNpopup */


static pascal void DrawcbUIDpopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbUIDpopID, 0 );
	return;
}/* end DrawcbUIDPopup */


static pascal void DrawcbAuthStrPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbAuthStrPopID, 0 );
	return;
}/* end DrawcbAuthStrPopup */


InitSQLConnectText(	MenuHandle szMenu, short *szChoice, Str255 szText,
					MenuHandle cbMenu, short *cbChoice, Str255 cbText )
{
	short		ItemCount;


	ItemCount = CountMItems( szMenu );
	if( *szChoice < 1 || *szChoice > ItemCount )
	{
		if( ItemCount > 2 )
			 *szChoice = ItemCount - 1;		/* get empty string as default	*/
		else *szChoice = 1;
		*cbChoice = 1;
	}
	if( *cbChoice < 1 || *cbChoice > 2 )
		*cbChoice = 1;

	GetItem( szMenu, *szChoice, szText );
	GetItem( cbMenu, *cbChoice, cbText );
	return;
}/* end InitSQLConnectText */


Boolean GetSQLConnect( SQLConnectRec *info )
{
	DialogPtr	theDialog;
	GrafPtr		savePort;
	Boolean		result;
	Boolean		done;
	short		itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLConnectID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( szDSNMenu );
	if( info->szDSNChoice < 1 || info->szDSNChoice > ItemCount )
	{
		initPopWithDSNs( szDSNMenu );		/* get the DSN list to the Popup	*/
		info->szDSNChoice		= 1;
		info->szUIDChoice		= 1;
		info->szAuthStrChoice	= 1;
		info->cbDSNChoice		= 1;
		info->cbUIDChoice		= 1;
		info->cbAuthStrChoice	= 1;

		GetItem( szDSNMenu,		1, info->szDSNText	);
		GetItem( szUIDMenu,		1, info->szUIDText	);
		GetItem( szAuthStrMenu,	1, info->szAuthStrText	);
		GetItem( cbDSNMenu,		1, info->cbDSNText	);
		GetItem( cbUIDMenu,		1, info->cbUIDText	);
		GetItem( cbAuthStrMenu,	1, info->cbAuthStrText	);
	}

	SetDText( szDSNTxField,		info->szDSNText		);
	SetDText( szUIDTxField,		info->szUIDText		);
	SetDText( szAuthStrTxField,	info->szAuthStrText	);
	SetDText( cbDSNtxField,		info->cbDSNText		);
	SetDText( cbUIDtxField,		info->cbUIDText		);
	SetDText( cbAuthStrTxField,	info->cbAuthStrText	);

	SetUserItem( szDSNPopup,		(ProcPtr)&DrawszDSNPopup );
	SetUserItem( szUIDPopup,		(ProcPtr)&DrawszUIDPopup );
	SetUserItem( szAuthStrPopup,	(ProcPtr)&DrawszAuthStrPopup );
	SetUserItem( cbDSNpopup,		(ProcPtr)&DrawcbDSNpopup );
	SetUserItem( cbUIDpopup,		(ProcPtr)&DrawcbUIDpopup );
	SetUserItem( cbAuthStrPopup,	(ProcPtr)&DrawcbAuthStrPopup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:			result = TRUE;		done = TRUE;			break;
		case CancelButton:		result = FALSE;		done = TRUE;			break;

		case szDSNTxField:
			tx2cb(	itemNr, info->szDSNText,
					cbDSNtxField, cbDSNMenu, info->cbDSNChoice,	info->cbDSNText );
			break;
		case szUIDTxField:
			tx2cb(	itemNr, info->szUIDText,
					cbUIDtxField, cbUIDMenu, info->cbUIDChoice,	info->cbUIDText );
			break;
		case szAuthStrTxField:
			tx2cb(	itemNr, info->szAuthStrText,
					cbAuthStrTxField, cbAuthStrMenu, info->cbAuthStrChoice,
					info->cbAuthStrText );
			break;

		case cbDSNtxField:		GetDText( itemNr, info->cbDSNText		);	break;
		case cbUIDtxField:		GetDText( itemNr, info->cbUIDText		);	break;
		case cbAuthStrTxField:	GetDText( itemNr, info->cbAuthStrText	);	break;

		case szDSNPopup:
			DoPopup( szDSNPopup, szDSNID, &info->szDSNChoice );
			UpdateText( szDSNMenu, info->szDSNChoice, info->szDSNText, szDSNTxField );
			updateCBpop(	szDSNMenu, info->szDSNChoice,
							info->szDSNText,
							cbDSNMenu,
							info->cbDSNChoice,
							info->cbDSNText, cbDSNtxField );
			break;
		case szUIDPopup:
			DoPopup( szUIDPopup, szUIDID, &info->szUIDChoice );
			UpdateText( szUIDMenu, info->szUIDChoice, info->szUIDText, szUIDTxField );
			updateCBpop(	szUIDMenu, info->szUIDChoice,
							info->szUIDText,
							cbUIDMenu,
							info->cbUIDChoice,
							info->cbUIDText, cbUIDtxField );
			break;
		case szAuthStrPopup:
			DoPopup( szAuthStrPopup, szAuthStrID, &info->szAuthStrChoice );
			UpdateText( szAuthStrMenu,	info->szAuthStrChoice,
										info->szAuthStrText, szAuthStrTxField );
			updateCBpop(	szAuthStrMenu, info->szAuthStrChoice,
							info->szAuthStrText,
							cbAuthStrMenu,
							info->cbAuthStrChoice,
							info->cbAuthStrText, cbAuthStrTxField );
			break;
		case cbDSNpopup:
			DoPopup( cbDSNpopup, cbDSNpopID, &info->cbDSNChoice );
			UpdateText( cbDSNMenu,	info->cbDSNChoice,
										info->cbDSNText, cbDSNtxField );
			break;
		case cbUIDpopup:
			DoPopup( cbUIDpopup, cbUIDpopID, &info->cbUIDChoice );
			UpdateText( cbUIDMenu,	info->cbUIDChoice,
										info->cbUIDText, cbUIDtxField );
			break;
		case cbAuthStrPopup:
			DoPopup( cbAuthStrPopup, cbAuthStrPopID, &info->cbAuthStrChoice );
			UpdateText( cbAuthStrMenu,	info->cbAuthStrChoice,
										info->cbAuthStrText, cbAuthStrTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE not OK or Cancel */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLConnect */


#define NullHenvCheck				3 
#define fDirectionLabel				4 
#define fDirectionPopup				5 
#define fDirectionTxField			6 
#define NullSzDSNOutCheck			7 
#define cbDSNMaxLabel				8 
#define cbDSNMaxTxField				9 
#define NullPcbDSNOutCheck			10 
#define NullSzDescriptionOutCheck	11 
#define cbDescriptionMaxLabel		12 
#define cbDescMaxTxField			13 
#define NullPcbDescriptionOutCheck	14 
#define NULLLabel					15 


static pascal void DrawfDirectionPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fDirectionID, 0 );
	return;
}/* end DrawfDirectionPopup */


Boolean GetSQLDataSources( SQLDataSourcesRec *info )
{
	DialogPtr				theDialog;
	GrafPtr					savePort;
	Boolean					result;
	Boolean					done;
	short					itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLDataSourcesID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info  );
	SetPort( theDialog );

	ItemCount = CountMItems( fDirectionMenu );
	if( info->fDirectionChoice < 1 || info->fDirectionChoice > ItemCount )
	{
		info->fDirectionChoice			= 1;
		GetItem( fDirectionMenu, 1, info->fDirectionText );
	}

	SetDText( fDirectionTxField,				info->fDirectionText	);
	SetDText( cbDSNMaxTxField,					info->cbDSNMaxText		);
	SetDText( cbDescMaxTxField,					info->cbDescMaxText		);
	SetCheckbox( NullHenvCheck,					info->NullHenvChecked );
	SetCheckbox( NullSzDSNOutCheck,				info->NullSzDSNOutChecked );
	SetCheckbox( NullPcbDSNOutCheck,			info->NullPcbDSNOutChecked );
	SetCheckbox( NullSzDescriptionOutCheck,		info->NullSzDescriptionOutChecked );
	SetCheckbox( NullPcbDescriptionOutCheck,	info->NullPcbDescriptionOutChecked );
	SetUserItem( fDirectionPopup,	(ProcPtr)&DrawfDirectionPopup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case fDirectionTxField:
			GetDText( itemNr, info->fDirectionText );
			break;
		case cbDSNMaxTxField:
			GetDText( itemNr, info->cbDSNMaxText );
			break;
		case cbDescMaxTxField:
			GetDText( itemNr, info->cbDescMaxText );
			break;

		case NullSzDSNOutCheck:
			DoCheckbox( itemNr, &info->NullSzDSNOutChecked );
			break;
		case NullPcbDSNOutCheck:
			DoCheckbox( itemNr, &info->NullPcbDSNOutChecked );
			break;
		case NullSzDescriptionOutCheck:
			DoCheckbox( itemNr, &info->NullSzDescriptionOutChecked );
			break;
		case NullPcbDescriptionOutCheck:
			DoCheckbox( itemNr, &info->NullPcbDescriptionOutChecked );
			break;
		case NullHenvCheck:
			DoCheckbox( itemNr, &info->NullHenvChecked );
			break;

		case fDirectionPopup:
			DoPopup( fDirectionPopup, fDirectionID, &info->fDirectionChoice );
			UpdateText( fDirectionMenu, info->fDirectionChoice,
						info->fDirectionText, fDirectionTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLDataSources */


#define hstmtLabel		3 
#define hstmtTxLabel	4 
#define icolLabel		5 
#define icolTxField		6 
#define NullSzColNameOutCheck	7 
#define cbColNameMaxLabel	8 
#define cbColNameMax9Field	9 
#define NullPcbColNameOutCheck	10 
#define NullPfSqlTypeOutCheck	11 
#define NullPcbColDefOutCheck	12 
#define NullPibScaleOutCheck	13 
#define NullPfNullableOutCheck	14 


Boolean GetSQLDescribeCol( SQLDescribeColRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLDescribeColID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetDText( icolTxField,					info->icolText					);
	SetDText( cbColNameMax9Field,			info->cbColNameMaxText			);
	SetCheckbox( NullSzColNameOutCheck,		info->NullSzColNameOutChecked	);
	SetCheckbox( NullPcbColNameOutCheck,	info->NullPcbColNameOutChecked	);
	SetCheckbox( NullPfSqlTypeOutCheck,		info->NullPfSqlTypeOutChecked	);
	SetCheckbox( NullPcbColDefOutCheck,		info->NullPcbColDefOutChecked	);
	SetCheckbox( NullPibScaleOutCheck,		info->NullPibScaleOutChecked	);
	SetCheckbox( NullPfNullableOutCheck,	info->NullPfNullableOutChecked	);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case icolTxField:
			GetDText( itemNr, info->icolText );
			break;
		case NullSzColNameOutCheck:
			DoCheckbox( itemNr, &info->NullSzColNameOutChecked );
			break;
		case cbColNameMax9Field:
			GetDText( itemNr, info->cbColNameMaxText );
			break;
		case NullPcbColNameOutCheck:
			DoCheckbox( itemNr, &info->NullPcbColNameOutChecked );
			break;
		case NullPfSqlTypeOutCheck:
			DoCheckbox( itemNr, &info->NullPfSqlTypeOutChecked );
			break;
		case NullPcbColDefOutCheck:
			DoCheckbox( itemNr, &info->NullPcbColDefOutChecked );
			break;
		case NullPibScaleOutCheck:
			DoCheckbox( itemNr, &info->NullPibScaleOutChecked );
			break;
		case NullPfNullableOutCheck:
			DoCheckbox( itemNr, &info->NullPfNullableOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLDescribeCol */


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define iparLabel				5 
#define NullPfSqlTypeOutCheck	6 
#define NullPcbColDefOutCheck	7 
#define NullPibScaleOutCheck	8 
#define NullPfNullableOutCheck	9 
#define iparTxField				10 


Boolean GetSQLDescribeParam( SQLDescribeParamRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLDescribeParamID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetCheckbox( NullPfSqlTypeOutCheck,		info->NullPfSqlTypeOutChecked	);
	SetCheckbox( NullPcbColDefOutCheck,		info->NullPcbColDefOutChecked	);
	SetCheckbox( NullPibScaleOutCheck,		info->NullPibScaleOutChecked	);
	SetCheckbox( NullPfNullableOutCheck,	info->NullPfNullableOutChecked	);
	SetDText( iparTxField, info->iparText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullPfSqlTypeOutCheck:
			DoCheckbox( itemNr, &info->NullPfSqlTypeOutChecked );
			break;
		case NullPcbColDefOutCheck:
			DoCheckbox( itemNr, &info->NullPcbColDefOutChecked );
			break;
		case NullPibScaleOutCheck:
			DoCheckbox( itemNr, &info->NullPibScaleOutChecked );
			break;
		case NullPfNullableOutCheck:
			DoCheckbox( itemNr, &info->NullPfNullableOutChecked );
			break;
		case iparTxField:
			GetDText( itemNr, info->iparText );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLDescribeParam */


#define hdbcLabel					3
#define NullHwndCheck				4
#define VALIDLabel					5
#define szConnStrInTxField			6
#define cbConnStrInLabel			7
#define cbConnStrInTxField			8
#define NullPcbConnStrOutCheck		9
#define NullSzConnStrOutCheck		10
#define fDriverCompletionTxField	11 
#define cbConnStrOutMaxLabel		12
#define MaxTxField					13
#define szConnStrInLabel			14
#define szConnStrIn41Popup			15
#define fDriverCompletionLabel		16
#define fDriverCompletionPopup		17
#define hdbcTxLabel					18
#define cbConnStrIn41Popup			19


static pascal void DrawszConnStrIn41Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, szConnStrIn41ID, 0 );
	return;
}/* end DrawszConnStrIn41Popup */


static pascal void DrawcbConnStrIn41Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbConnStrIn41ID, 0 );
	return;
}/* end DrawcbConnStrIn41Popup */


static pascal void DrawfDriverCompletionPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fDriverCompletionID, 0 );
	return;
}/* end DrawfDriverCompletionPopup */


Boolean GetSQLDriverConnect( SQLDriverConnectRec *info )
{
	DialogPtr				theDialog;
	GrafPtr					savePort;
	Boolean					result;
	Boolean					done;
	short					itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLDriverConnectID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( szConnStrIn41Menu );
	if( info->szConnStrInChoice < 1 || info->szConnStrInChoice > ItemCount )
	{
		info->szConnStrInChoice			= 1;
		info->cbConnStrInChoice			= 1;
		info->fDriverCompletionChoice	= 1;

		GetItem( szConnStrIn41Menu,		1, info->szConnStrInText		);
		GetItem( cbConnStrIn41Menu,		1, info->cbConnStrInText		);
		GetItem( fDriverCompletionMenu,	1, info->fDriverCompletionText	);
	}

	SetCheckbox( NullHwndCheck,				info->NullHwndChecked			);
	SetCheckbox( NullPcbConnStrOutCheck,	info->NullPcbConnStrOutChecked	);
	SetCheckbox( NullSzConnStrOutCheck,		info->NullSzConnStrOutChecked	);

	SetDText( szConnStrInTxField,			info->szConnStrInText		);
	SetDText( cbConnStrInTxField,			info->cbConnStrInText		);
	SetDText( fDriverCompletionTxField,		info->fDriverCompletionText	);
	SetDText( MaxTxField,					info->MaxText				);

	SetUserItem( szConnStrIn41Popup,		(ProcPtr)&DrawszConnStrIn41Popup		);
	SetUserItem( cbConnStrIn41Popup,		(ProcPtr)&DrawcbConnStrIn41Popup		);
	SetUserItem( fDriverCompletionPopup,	(ProcPtr)&DrawfDriverCompletionPopup	);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;		done = TRUE;		break;
		case CancelButton:	result = FALSE;		done = TRUE;		break;

		case NullHwndCheck:
			DoCheckbox( itemNr, &info->NullHwndChecked );			break;
		case NullPcbConnStrOutCheck:
			DoCheckbox( itemNr, &info->NullPcbConnStrOutChecked );	break;
		case NullSzConnStrOutCheck:
			DoCheckbox( itemNr, &info->NullSzConnStrOutChecked );	break;

		case szConnStrInTxField:
			tx2cb(	itemNr, info->szConnStrInText,
					cbConnStrInTxField, cbConnStrIn41Menu, info->cbConnStrInChoice,
					info->cbConnStrInText );
			break;
		case cbConnStrInTxField:
			GetDText( itemNr, info->cbConnStrInText );				break;
		case fDriverCompletionTxField:
			GetDText( itemNr, info->fDriverCompletionText );		break;
		case MaxTxField:
			GetDText( itemNr, info->MaxText );						break;

		case szConnStrIn41Popup:
			DoPopup(  szConnStrIn41Popup, szConnStrIn41ID, &info->szConnStrInChoice );
			UpdateText( szConnStrIn41Menu,		info->szConnStrInChoice,
						info->szConnStrInText,	szConnStrInTxField );

			updateCBpop(	szConnStrIn41Menu,
							info->szConnStrInChoice,
							info->szConnStrInText,
							cbConnStrIn41Menu,
							info->cbConnStrInChoice,
							info->cbConnStrInText,		 cbConnStrInTxField );
			break;
		case cbConnStrIn41Popup:
			DoPopup( cbConnStrIn41Popup, cbConnStrIn41ID, &info->cbConnStrInChoice );
			UpdateText( cbConnStrIn41Menu,		info->cbConnStrInChoice,
						info->cbConnStrInText,	cbConnStrInTxField );
			break;
		case fDriverCompletionPopup:
			DoPopup( fDriverCompletionPopup, fDriverCompletionID, &info->fDriverCompletionChoice );
			UpdateText( fDriverCompletionMenu,			info->fDriverCompletionChoice,
						info->fDriverCompletionText,	fDriverCompletionTxField );
			break;
		}/* end  SWITCH */
	}/* end  FOR */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLDriverConnect */


#define NullHenvCheck				3 
#define NullHdbcCheck				4 
#define NullHstmtCheck				5 
#define NullSzSqlStateOutCheck		6 
#define NullPfNativeErrorOutCheck	7 
#define NullSzErrorMsgOutCheck		8 
#define cbErrorMsgMaxLabel			9 
#define cbErrorMsgMaxTxField		10 
#define NullPcbErrorMsgOutCheck		11 


Boolean GetSQLError( SQLErrorRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLErrorID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetCheckbox( NullHenvCheck,				info->NullHenvChecked );
	SetCheckbox( NullHdbcCheck,				info->NullHdbcChecked );
	SetCheckbox( NullHstmtCheck,			info->NullHstmtChecked );
	SetCheckbox( NullSzSqlStateOutCheck,	info->NullSzSqlStateOutChecked );
	SetCheckbox( NullPfNativeErrorOutCheck, info->NullPfNativeErrorOutChecked );
	SetCheckbox( NullSzErrorMsgOutCheck,	info->NullSzErrorMsgOutChecked );
	SetCheckbox( NullPcbErrorMsgOutCheck,	info->NullPcbErrorMsgOutChecked );

	SetDText( cbErrorMsgMaxTxField,			info->cbErrorMsgMaxText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullHenvCheck:
			DoCheckbox( itemNr, &info->NullHenvChecked );
			break;
		case NullHdbcCheck:
			DoCheckbox( itemNr, &info->NullHdbcChecked );
			break;
		case NullHstmtCheck:
			DoCheckbox( itemNr, &info->NullHstmtChecked );
			break;
		case NullSzSqlStateOutCheck:
			DoCheckbox( itemNr, &info->NullSzSqlStateOutChecked );
			break;
		case NullPfNativeErrorOutCheck:
			DoCheckbox( itemNr, &info->NullPfNativeErrorOutChecked );
			break;
		case NullSzErrorMsgOutCheck:
			DoCheckbox( itemNr, &info->NullSzErrorMsgOutChecked );
			break;
		case cbErrorMsgMaxTxField:
			GetDText( itemNr, info->cbErrorMsgMaxText );
			break;
		case NullPcbErrorMsgOutCheck:
			DoCheckbox( itemNr, &info->NullPcbErrorMsgOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLError */


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define NullSzSqlStrCheck		5 
#define fromInputWindowLabel	6 
#define cbSqlStrLabel			7 
#define cbSqlStr11Popup			8 
#define cbSqlStTxField			9 


static pascal void DrawcbSqlStr11Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbSqlStrPop19ID, 0 );
	return;
}/* end DrawcbSqlStr11Popup */


Boolean GetSQLExecDirect( SQLExecDirectRec *info )		// #11
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLExecDirectID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetItem( cbSqlStrPop11Menu, 1, info->cbSqlStrText );

	ItemCount = CountMItems( cbSqlStrPop11Menu );
	if( info->cbSqlStrChoice < 1 || info->cbSqlStrChoice > ItemCount )
	{
		info->cbSqlStrChoice = 1;
		GetItem( cbSqlStrPop11Menu, 1, info->cbSqlStrText );
	}

	SetCheckbox( NullSzSqlStrCheck, info->NullSzSqlStrChecked );
	SetUserItem( cbSqlStr11Popup, (ProcPtr)&DrawcbSqlStr11Popup );
	SetDText( cbSqlStTxField, info->cbSqlStrText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case NullSzSqlStrCheck:
			DoCheckbox( itemNr, &info->NullSzSqlStrChecked );
			break;

		case cbSqlStTxField:
			GetDText( itemNr, info->cbSqlStrText );
			break;

		case cbSqlStr11Popup:
			DoPopup(  cbSqlStr11Popup, cbSqlStrPop11ID, &info->cbSqlStrChoice );
			UpdateText( cbSqlStrPop11Menu, info->cbSqlStrChoice,
						info->cbSqlStrText, cbSqlStTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLExecDirect */


#define hstmtLabel					3 
#define hstmtTxLabel				4 
#define fFetchTypeLabel				5 
#define fFetchTypePop59Popup		6 
#define fFetchTypeTxField			7 
#define irowLabel					8 
#define irowTxField					9 
#define NullPcrowOutCheck			10 
#define NullRgfRowStatusOutCheck	11 


static pascal void DrawfFetchTypePop59Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fFetchTypePop59ID, 0 );
	return;
}/* end DrawfFetchTypePop59Popup */


Boolean GetSQLExtendedFetch( SQLExtendedFetchRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLExtendedFetchID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fFetchTypePop59Menu );
	if( info->fFetchTypeChoice < 1 || info->fFetchTypeChoice > ItemCount )
	{
		info->fFetchTypeChoice = 1;
		GetItem( fFetchTypePop59Menu, 1, info->fFetchTypeText );
	}

	SetDText( fFetchTypeTxField,	info->fFetchTypeText );
	SetDText( irowTxField,			info->irowText );
	SetCheckbox( NullPcrowOutCheck,			info->NullPcrowOutChecked );
	SetCheckbox( NullRgfRowStatusOutCheck,	info->NullRgfRowStatusOutChecked );
	SetUserItem( fFetchTypePop59Popup, (ProcPtr)&DrawfFetchTypePop59Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case fFetchTypeTxField:
			GetDText( itemNr, info->fFetchTypeText );
			break;
		case irowTxField:
			GetDText( itemNr, info->irowText );
			break;
		case NullPcrowOutCheck:
			DoCheckbox( itemNr, &info->NullPcrowOutChecked );
			break;
		case NullRgfRowStatusOutCheck:
			DoCheckbox( itemNr, &info->NullRgfRowStatusOutChecked );
			break;
		case fFetchTypePop59Popup:
			DoPopup( fFetchTypePop59Popup, fFetchTypePop59ID, &info->fFetchTypeChoice );
			UpdateText( fFetchTypePop59Menu, info->fFetchTypeChoice,
						info->fFetchTypeText, fFetchTypeTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLExtendedFetch*/


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szPkTableLabel		5 
#define QualifierTxField	6 
#define OwnerTxField		7 
#define NameTxField			8 
#define cbPkTableLabel		9 
#define cbQualifierField	10 
#define cbOwnerField		11 
#define cbNameField			12 
#define szFkTableLabel		13 
#define cbFkTableLabel		14 
#define FKqualifierTxField	15 
#define FKownerTxField		16 
#define FKnameTxField		17 
#define cbFKqualifierField	18
#define cbFKownerField		19 
#define cbFKnameField		20 
#define QualifierLabel		21 
#define Qualifier60Popup	22 
#define OwnerLabel			23 
#define Owner60Popup		24 
#define NameLabel			25 
#define Name60Popup			26 
#define QualifierLabel		27 
#define Qual260Popup		28 
#define OwnerLabel			29 
#define Owner260Popup		30 
#define NameLabel			31 
#define Name260Popup		32 
#define QualifierLabel		33 
#define cbQualifier60Popup	34 
#define OwnerLabel			35 
#define cbOwner60Popup		36 
#define NameLabel			37 
#define cbName60Popup		38 
#define QualifierLabel		39 
#define cbQual260Popup		40 
#define OwnerLabel			41 
#define cbOwner260Popup		42 
#define NameLabel			43 
#define cbName260Popup		44 


static pascal void DrawQualifier60Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop60ID, 0 );
	return;
}/* end DrawQualifier60Popup */


static pascal void DrawOwner60Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop60ID, 0 );
	return;
}/* end DrawOwner60Popup */


static pascal void DrawName60Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop60ID, 0 );
	return;
}/* end DrawName60Popup */


static pascal void DrawQual260Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Qual2Pop60ID, 0 );
	return;
}/* end DrawQual260Popup */


static pascal void DrawOwner260Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Owner2Pop60ID, 0 );
	return;
}/* end DrawOwner260Popup */


static pascal void DrawName260Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Name2Pop60ID, 0 );
	return;
}/* end DrawName260Popup */


static pascal void DrawcbQualifier60Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop60ID, 0 );
	return;
}/* end DrawcbQualifier60Popup */


static pascal void DrawcbOwner60Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop60ID, 0 );
	return;
}/* end DrawcbOwner60Popup */


static pascal void DrawcbName60Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop60ID, 0 );
	return;
}/* end DrawcbName60Popup */


static pascal void DrawcbQual260Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQual2Pop60ID, 0 );
	return;
}/* end DrawcbQual260Popup */


static pascal void DrawcbOwner260Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwner2Pop60ID, 0 );
	return;
}/* end DrawcbOwner260Popup */


static pascal void DrawcbName260Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbName2Pop60ID, 0 );
	return;
}/* end DrawcbName260Popup */


Boolean GetSQLForeignKeys( SQLForeignKeysRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLForeignKeysID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop60Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->Qual2Choice		= 1;
		info->Owner2Choice		= 1;
		info->Name2Choice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->cbQual2Choice		= 1;
		info->cbOwner2Choice	= 1;
		info->cbName2Choice		= 1;

		GetItem( QualifierPop60Menu,	1, info->QualifierText		);
		GetItem( OwnerPop60Menu, 		1, info->OwnerText			);
		GetItem( NamePop60Menu,			1, info->NameText			);
		GetItem( Qual2Pop60Menu,		1, info->FKqualifierText	);
		GetItem( Owner2Pop60Menu, 		1, info->FKownerText		);
		GetItem( Name2Pop60Menu,		1, info->FKnameText			);
		GetItem( cbQualifierPop60Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop60Menu, 		1, info->cbOwnerText		);
		GetItem( cbNamePop60Menu,		1, info->cbNameText			);
		GetItem( cbQual2Pop60Menu,		1, info->cbFKqualifierText	);
		GetItem( cbOwner2Pop60Menu,		1, info->cbFKownerText		);
		GetItem( cbName2Pop60Menu,		1, info->cbFKnameText		);
	}

	SetDText( QualifierTxField,		info->QualifierText		);
	SetDText( OwnerTxField,			info->OwnerText			);
	SetDText( NameTxField,			info->NameText			);
	SetDText( FKqualifierTxField,	info->FKqualifierText	);
	SetDText( FKownerTxField,		info->FKownerText		);
	SetDText( FKnameTxField,		info->FKnameText		);
	SetDText( cbQualifierField,		info->cbQualifierText	);
	SetDText( cbOwnerField,			info->cbOwnerText		);
	SetDText( cbNameField,			info->cbNameText		);
	SetDText( cbFKqualifierField,	info->cbFKqualifierText	);
	SetDText( cbFKownerField,		info->cbFKownerText		);
	SetDText( cbFKnameField,		info->cbFKnameText		);

	SetUserItem( Qualifier60Popup,		(ProcPtr)&DrawQualifier60Popup		);
	SetUserItem( Owner60Popup,			(ProcPtr)&DrawOwner60Popup			);
	SetUserItem( Name60Popup,			(ProcPtr)&DrawName60Popup			);
	SetUserItem( Qual260Popup,			(ProcPtr)&DrawQual260Popup			);
	SetUserItem( Owner260Popup,			(ProcPtr)&DrawOwner260Popup			);
	SetUserItem( Name260Popup,			(ProcPtr)&DrawName260Popup			);
	SetUserItem( cbQualifier60Popup,	(ProcPtr)&DrawcbQualifier60Popup	);
	SetUserItem( cbOwner60Popup,		(ProcPtr)&DrawcbOwner60Popup		);
	SetUserItem( cbName60Popup,			(ProcPtr)&DrawcbName60Popup			);
	SetUserItem( cbQual260Popup,		(ProcPtr)&DrawcbQual260Popup		);
	SetUserItem( cbOwner260Popup,		(ProcPtr)&DrawcbOwner260Popup		);
	SetUserItem( cbName260Popup,		(ProcPtr)&DrawcbName260Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop60Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop60Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop60Menu, info->cbNameChoice,
					info->cbNameText );
			break;
		case FKqualifierTxField:
			tx2cb(	itemNr, info->FKqualifierText,
					cbFKqualifierField, cbQual2Pop60Menu, info->cbQual2Choice,
					info->cbFKqualifierText );
			break;
		case FKownerTxField:
			tx2cb(	itemNr, info->FKownerText,
					cbFKownerField, cbOwner2Pop60Menu, info->cbOwner2Choice,
					info->cbFKownerText );
			break;
		case FKnameTxField:
			tx2cb(	itemNr, info->FKnameText,
					cbFKnameField, cbName2Pop60Menu, info->cbName2Choice,
					info->cbFKnameText );
			break;
		case cbQualifierField:		GetDText( itemNr, info->cbQualifierText );		break;
		case cbOwnerField:			GetDText( itemNr, info->cbOwnerText );			break;
		case cbNameField:			GetDText( itemNr, info->cbNameText );			break;
		case cbFKqualifierField:	GetDText( itemNr, info->cbFKqualifierText );	break;
		case cbFKownerField:		GetDText( itemNr, info->cbFKownerText );		break;
		case cbFKnameField:		GetDText( itemNr, info->cbFKnameText );			break;

		case Qualifier60Popup:
			DoPopup( Qualifier60Popup, QualifierPop60ID, &info->QualifierChoice );
			UpdateText( QualifierPop60Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop60Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop60Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner60Popup:
			DoPopup( Owner60Popup, OwnerPop60ID, &info->OwnerChoice );
			UpdateText( OwnerPop60Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop60Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop60Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name60Popup:
			DoPopup( Name60Popup, NamePop60ID, &info->NameChoice );
			UpdateText( NamePop60Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop60Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop60Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;
		case Qual260Popup:
			DoPopup( Qual260Popup, Qual2Pop60ID, &info->Qual2Choice );
			UpdateText( Qual2Pop60Menu, info->Qual2Choice,
						info->FKqualifierText, FKqualifierTxField );
			updateCBpop(	Qual2Pop60Menu,
							info->Qual2Choice,
							info->FKqualifierText,
							cbQualifierPop60Menu,
							info->cbQual2Choice,
							info->cbFKqualifierText, cbFKqualifierField );
			break;
		case Owner260Popup:
			DoPopup( Owner260Popup, Owner2Pop60ID, &info->Owner2Choice );
			UpdateText( Owner2Pop60Menu, info->Owner2Choice,
						info->FKownerText, FKownerTxField );
			updateCBpop(	Owner2Pop60Menu,
							info->Owner2Choice,
							info->FKownerText,
							cbOwnerPop60Menu,
							info->cbOwner2Choice,
							info->cbFKownerText, cbFKownerField );
			break;
		case Name260Popup:
			DoPopup( Name260Popup, Name2Pop60ID, &info->Name2Choice );
			UpdateText( Name2Pop60Menu, info->Name2Choice,
						info->FKnameText, FKnameTxField );
			updateCBpop(	Name2Pop60Menu,
							info->Name2Choice,
							info->FKnameText,
							cbNamePop60Menu,
							info->cbName2Choice,
							info->cbFKnameText, cbFKnameField );
			break;

		case cbQualifier60Popup:
			DoPopup( cbQualifier60Popup, cbQualifierPop60ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop60Menu,	info->cbQualifierChoice,
										info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner60Popup:
			DoPopup( cbOwner60Popup, cbOwnerPop60ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop60Menu,	info->cbOwnerChoice,
										info->cbOwnerText, cbOwnerField );
			break;
		case cbName60Popup:
			DoPopup( cbName60Popup, cbNamePop60ID, &info->cbNameChoice );
			UpdateText( cbNamePop60Menu,	info->cbNameChoice,
										info->cbNameText, cbNameField );
			break;
		case cbQual260Popup:
			DoPopup( cbQual260Popup, cbQual2Pop60ID, &info->cbQual2Choice );
			UpdateText( cbQual2Pop60Menu,	info->cbQual2Choice,
										info->cbFKqualifierText, cbFKqualifierField );
			break;
		case cbOwner260Popup:
			DoPopup( cbOwner260Popup, cbOwner2Pop60ID, &info->cbOwner2Choice );
			UpdateText( cbOwner2Pop60Menu,	info->cbOwner2Choice,
										info->cbFKownerText, cbFKownerField );
			break;
		case cbName260Popup:
			DoPopup( cbName260Popup, cbName2Pop60ID, &info->cbName2Choice );
			UpdateText( cbName2Pop60Menu,	info->cbName2Choice,
										info->cbFKnameText, cbFKnameField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLForeignKeys */


#define hstmtLabel		3 
#define hstmtTxLabel	4 
#define fOptionLabel	5 
#define Popup16			6 
#define fOptionTXField	7 


static pascal void DrawPopup16( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fOptionPop16ID, 0 );
	return;
}/* end DrawPopup16 */


Boolean GetSQLFreeStmt( SQLFreeStmtRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLFreeStmtID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fOptionPop16Menu );
	if( info->fOptionChoice < 1 || info->fOptionChoice > ItemCount )
	{
		info->fOptionChoice = 1;
		GetItem( fOptionPop16Menu, 1, info->fOptionText );
	}

	SetUserItem( Popup16, (ProcPtr)&DrawPopup16);
	SetDText( fOptionTXField, info->fOptionText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case fOptionTXField:
			GetDText( itemNr, info->fOptionText );
			break;

		case Popup16:
			DoPopup( Popup16, fOptionPop16ID, &info->fOptionChoice );
			UpdateText( fOptionPop16Menu,	info->fOptionChoice,
						info->fOptionText,	fOptionTXField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLFreeStmt */


#define hdbcLabel			3 
#define hdbcTxLabel			4 
#define fOptionTxField		5 
#define NullPvParamOutCheck	6 
#define fOptionLabel		7 
#define fOption42Popup		8 


static pascal void DrawfOption42Popup( DialogPtr , short itemNr )
{
	DrawPopup( itemNr, fOptionPop42ID, 0 );
}/* end DrawfOption42Popup */


Boolean GetSQLGetConnectOption( SQLGetConnectOptionRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetConnectOptionID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( fOptionPop42Menu );
	if( info->fOptionChoice < 1 || info->fOptionChoice > ItemCount )
	{
		info->fOptionChoice = 1;
		GetItem( fOptionPop42Menu, 1, info->fOptionText );
	}

	SetDText(		fOptionTxField,			info->fOptionText );
	SetCheckbox(	NullPvParamOutCheck,	info->NullPvParamOutChecked );
	SetUserItem(	fOption42Popup,		(ProcPtr)&DrawfOption42Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case fOptionTxField:
			GetDText( itemNr, info->fOptionText );
			break;
		case NullPvParamOutCheck:
			DoCheckbox( itemNr, &info->NullPvParamOutChecked );
			break;
		case fOption42Popup:
				DoPopup( fOption42Popup, fOptionPop42ID, &info->fOptionChoice );
				UpdateText( fOptionPop42Menu,	info->fOptionChoice,
							info->fOptionText,	fOptionTxField );
			break;
		}/* end  SWITCH */
	}/* end  FOR */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetConnectOption */


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define NullSzCursorOutCheck	5 
#define cbCursorMaxLabel		6 
#define cbCursorMaxTxField		7 
#define NullPcbCursorOutCheck	8 


Boolean GetSQLGetCursorName( SQLGetCursorNameRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetCursorNameID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetCheckbox( NullSzCursorOutCheck,	info->NullSzCursorOutChecked  );
	SetCheckbox( NullPcbCursorOutCheck,	info->NullPcbCursorOutChecked );
	SetDText( cbCursorMaxTxField,		info->cbCursorMaxText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case NullSzCursorOutCheck:
			DoCheckbox( itemNr, &info->NullSzCursorOutChecked );
			break;
		case NullPcbCursorOutCheck:
			DoCheckbox( itemNr, &info->NullPcbCursorOutChecked );
			break;

		case cbCursorMaxTxField:
			GetDText( itemNr, info->cbCursorMaxText );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetCursorName */


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define icolLabel				5 
#define icolTxField				6 
#define fCTypeLabel				7 
#define fCTypePop43Popup		8 
#define fCTypeTxField			9 
#define NullRgbValueOutCheck	10 
#define cbValueMaxLabel			11 
#define cbValueMaxField			12 
#define NullPcbValueOutCheck	13 


static pascal void DrawfCTypePop43Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fCTypePop43ID, 0 );
	return;
}/* end DrawfCTypePop43Popup */


Boolean GetSQLGetData( SQLGetDataRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetDataID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	ItemCount = CountMItems( fCTypePop43Menu );
	if( info->fCTypeChoice < 1 || info->fCTypeChoice > ItemCount )
	{
		info->fCTypeChoice = 1;
		GetItem( fCTypePop43Menu, 1, info->fCTypeText );
	}

	SetDText( hstmtTxLabel, hstmtText );

	SetDText( icolTxField,		info->icolText );
	SetDText( fCTypeTxField,	info->fCTypeText );
	SetDText( cbValueMaxField,	info->cbValueMaxText );
	SetUserItem( fCTypePop43Popup, (ProcPtr)&DrawfCTypePop43Popup );
	SetCheckbox( NullRgbValueOutCheck, info->NullRgbValueOutChecked );
	SetCheckbox( NullPcbValueOutCheck, info->NullPcbValueOutChecked );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:			result = TRUE;	done = TRUE;				break;
		case CancelButton:		result = FALSE;	done = TRUE;				break;
		case icolTxField:		GetDText( itemNr, info->icolText );			break;
		case fCTypeTxField:		GetDText( itemNr, info->fCTypeText );		break;
		case cbValueMaxField:	GetDText( itemNr, info->cbValueMaxText );	break;

		case fCTypePop43Popup:
			DoPopup( fCTypePop43Popup, fCTypePop43ID, &info->fCTypeChoice );
			UpdateText( fCTypePop43Menu, info->fCTypeChoice,
						info->fCTypeText, fCTypeTxField );
			break;

		case NullRgbValueOutCheck:
			DoCheckbox( itemNr, &info->NullRgbValueOutChecked );
			break;
		case NullPcbValueOutCheck:
			DoCheckbox( itemNr, &info->NullPcbValueOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetData */


#define hdbcLabel				3
#define fFunctionLabel			4
#define fFunction44Popup		5
#define fFunctionTxField		6
#define NullPfExistsOutCheck	7
#define hdbcTxLabel				8


static pascal void DrawfFunction44Popup( DialogPtr whichDialog,short itemNr )
{
	SQLGetFunctionsRecPtr	data;


	data = (SQLGetFunctionsRecPtr)GetWRefCon( whichDialog );
	DrawPopup( itemNr, fFunctionPop44ID, 0 );
}/* end DrawfFunction44Popup */


Boolean GetSQLGetFunctions( SQLGetFunctionsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetFunctionsID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( fFunctionPop44Menu );
	if( info->fFunctionChoice < 1 || info->fFunctionChoice > ItemCount )
	{
		info->fFunctionChoice = 1;
		GetItem( fFunctionPop44Menu, 1, info->fFunctionText );
	}

	SetUserItem( fFunction44Popup, (ProcPtr)&DrawfFunction44Popup );
	SetDText( fFunctionTxField, info->fFunctionText );
	SetCheckbox( NullPfExistsOutCheck, info->NullPfExistsOutChecked );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case fFunctionTxField:
			GetDText( itemNr, info->fFunctionText );
			break;
		case NullPfExistsOutCheck:
			DoCheckbox( itemNr, &info->NullPfExistsOutChecked );
			break;
		case fFunction44Popup:
			DoPopup( fFunction44Popup, fFunctionPop44ID, &info->fFunctionChoice );
			UpdateText( fFunctionPop44Menu, info->fFunctionChoice,
						info->fFunctionText, fFunctionTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetFunctions */


#define hdbcLabel					3 
#define hdbcTxLabel					4 
#define NullRgbInfoValueOutCheck	5 
#define NullPcbInfoValueOutCheck	6 
#define fInfoTypeLabel				7 
#define fInfoTypePopup				8 
#define fInfoTypeTxField			9 
#define cbInfoValueMaxLabel			10 
#define cbMaxTxField				11 


static pascal void DrawfInfoTypePopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fInfoTypeID, 0 );
	return;
}/* end DrawfInfoTypePopup */


Boolean GetSQLGetInfo( SQLGetInfoRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetInfoID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( fInfoTypeMenu );
	if( info->fInfoTypeChoice < 1 || info->fInfoTypeChoice > ItemCount )
	{
		info->fInfoTypeChoice = 1;
		GetItem( fInfoTypeMenu, 1, info->fInfoTypeText );
	}

	SetCheckbox( NullRgbInfoValueOutCheck, info->NullRgbInfoValueOutChecked );
	SetCheckbox( NullPcbInfoValueOutCheck, info->NullPcbInfoValueOutChecked );
	SetDText( fInfoTypeTxField, info->fInfoTypeText );
	SetDText( cbMaxTxField, info->cbMaxText );
	SetUserItem( fInfoTypePopup, (ProcPtr)&DrawfInfoTypePopup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullRgbInfoValueOutCheck:
			DoCheckbox( itemNr, &info->NullRgbInfoValueOutChecked );
			break;
		case NullPcbInfoValueOutCheck:
			DoCheckbox( itemNr, &info->NullPcbInfoValueOutChecked );
			break;
		case fInfoTypeTxField:
			GetDText( itemNr, info->fInfoTypeText );
			break;
		case cbMaxTxField:
			GetDText( itemNr, info->cbMaxText );
			break;
		case fInfoTypePopup:
			DoPopup( fInfoTypePopup, fInfoTypeID, &info->fInfoTypeChoice );
			UpdateText( fInfoTypeMenu, info->fInfoTypeChoice,
						info->fInfoTypeText, fInfoTypeTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetInfo */


#define hdbcLabel			3 
#define hstmtTxLabel		4 
#define fOptionTxField		5 
#define NullPvParamOutCheck	6 
#define fOptionLabel		7 
#define fOptionPop46Popup	8 


static pascal void DrawfOption46Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fOptionPop46ID, 0 );
	return;
}/* end DrawfOption46Popup */


Boolean GetSQLGetStmtOption( SQLGetStmtOptionRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetStmtOptionID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fOptionPop46Menu );
	if( info->fOptionChoice < 1 || info->fOptionChoice > ItemCount )
	{
		info->fOptionChoice = 1;
		GetItem( fOptionPop46Menu, 1, info->fOptionText );
	}

	SetDText( fOptionTxField, info->fOptionText );
	SetCheckbox( NullPvParamOutCheck, info->NullPvParamOutChecked );
	SetUserItem( fOptionPop46Popup, (ProcPtr)&DrawfOption46Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case fOptionTxField:
			GetDText( itemNr, info->fOptionText );
			break;
		case NullPvParamOutCheck:
			DoCheckbox( itemNr, &info->NullPvParamOutChecked );
			break;
		case fOptionPop46Popup:
			DoPopup( fOptionPop46Popup, fOptionPop46ID, &info->fOptionChoice );
			UpdateText( fOptionPop46Menu, info->fOptionChoice,
						info->fOptionText, fOptionTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetStmtOption */


#define hstmtLabel		3 
#define hstmtTxLabel	4 
#define fSqlTypeLabel	5 
#define fSqlType47Popup	6 
#define fSqlTypeTxField	7 


static pascal void DrawfSqlType47Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fSqlTypePop47ID, 0 );
	return;
}/* end DrawfSqlType47Popup */


Boolean GetSQLGetTypeInfo( SQLGetTypeInfoRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLGetTypeInfoID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fSqlType47Menu );
	if( info->fSqlTypeChoice < 1 || info->fSqlTypeChoice > ItemCount )
	{
		info->fSqlTypeChoice = 1;
		GetItem( fSqlType47Menu, 1, info->fSqlTypeText );
	}

	SetUserItem( fSqlType47Popup, (ProcPtr)&DrawfSqlType47Popup );
	SetDText( fSqlTypeTxField, info->fSqlTypeText );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case fSqlTypeTxField:
			GetDText( itemNr, info->fSqlTypeText );
			break;
		case fSqlType47Popup:
			DoPopup( fSqlType47Popup, fSqlTypePop47ID, &info->fSqlTypeChoice );
			UpdateText( fSqlType47Menu, info->fSqlTypeChoice,
						info->fSqlTypeText, fSqlTypeTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLGetTypeInfo */


#define hdbcLabel				3 
#define hdbcTxLabel				4 
#define NullSzSqlStrInCheck		5 
#define fromInputWindowLabel	6 
#define cbSqlStrInLabel			7 
#define cbSqlStrIn62Popup		8 
#define cbSqlStrInTxField		9 
#define NullSzSqlStrOutCheck	10 
#define cbSqlStrMaxLabel		11 
#define cbSqlStrMaxField		12 
#define NullPcbSqlStrOutCheck	13 


static pascal void DrawcbSqlStrIn62Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbSqlStrInPop62ID, 0 );
	return;
}/* end DrawcbSqlStrIn62Popup */


Boolean GetSQLNativeSQL( SQLNativeSQLRec *info )		// #62
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLNativeSQLID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	SetItem( cbSqlStrInPop62Menu, 1, info->cbSqlStrInText );

	ItemCount = CountMItems( cbSqlStrInPop62Menu );
	if( info->cbSqlStrInChoice < 1 || info->cbSqlStrInChoice > ItemCount )
	{
		info->cbSqlStrInChoice	= 1;
		GetItem( cbSqlStrInPop62Menu, 1, info->cbSqlStrInText );
	}

	SetCheckbox( NullSzSqlStrInCheck,	info->NullSzSqlStrInChecked		);
	SetCheckbox( NullSzSqlStrOutCheck,	info->NullSzSqlStrOutChecked	);
	SetCheckbox( NullPcbSqlStrOutCheck,	info->NullPcbSqlStrOutChecked	);
	SetDText( cbSqlStrInTxField,	info->cbSqlStrInText	);
	SetDText( cbSqlStrMaxField,		info->cbSqlStrMaxText	);
	SetUserItem( cbSqlStrIn62Popup, (ProcPtr)&DrawcbSqlStrIn62Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case NullSzSqlStrInCheck:
			DoCheckbox( itemNr, &info->NullSzSqlStrInChecked );
			break;
		case NullSzSqlStrOutCheck:
			DoCheckbox( itemNr, &info->NullSzSqlStrOutChecked );
			break;
		case NullPcbSqlStrOutCheck:
			DoCheckbox( itemNr, &info->NullPcbSqlStrOutChecked );
			break;

		case cbSqlStrInTxField:
			GetDText( itemNr, info->cbSqlStrInText );
			break;
		case cbSqlStrMaxField:
			GetDText( itemNr, info->cbSqlStrMaxText );
			break;

		case cbSqlStrIn62Popup:
			DoPopup( cbSqlStrIn62Popup, cbSqlStrInPop62ID, &info->cbSqlStrInChoice );
			UpdateText( cbSqlStrInPop62Menu,	info->cbSqlStrInChoice,
										info->cbSqlStrInText, cbSqlStrInTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLNativeSQL */


#define hstmtLabel		3 
#define hstmtTxLabel	4 
#define NullPcparOutCheck	5 



Boolean GetSQLNumParams( SQLNumParamsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLNumParamsID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetCheckbox( NullPcparOutCheck, info->NullPcparOutChecked );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullPcparOutCheck:
			DoCheckbox( itemNr, &info->NullPcparOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLNumParams */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define NullPccolOutCheck	5 


Boolean GetSQLNumResultCols( SQLNumResultColsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLNumResultColsID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetCheckbox( NullPccolOutCheck, info->NullPccolOutChecked );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullPccolOutCheck:
			DoCheckbox( itemNr, &info->NullPccolOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLNumResultCols */


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define NullPrgbValueOutCheck	5


Boolean GetSQLParamData( SQLParamDataRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLParamDataID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetCheckbox( NullPrgbValueOutCheck, info->NullPrgbValueOutChecked );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullPrgbValueOutCheck:
			DoCheckbox( itemNr, &info->NullPrgbValueOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLParamData */


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define crowLabel				5 
#define crowTxField				6 
#define NullPirowPointerCheck	7


Boolean GetSQLParamOptions( SQLParamOptionsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLParamOptionsID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetDText( crowTxField, info->crowText );
	SetCheckbox( NullPirowPointerCheck, info->NullPirowPointerChecked );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case crowTxField:
			GetDText( itemNr, info->crowText );
			break;
		case NullPirowPointerCheck:
			DoCheckbox( itemNr, &info->NullPirowPointerChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLParamOption s*/


#define hstmtLabel				3 
#define hstmtTxLabel			4 
#define NullSzSqlStrCheck		5 
#define fromInputWindowLabel	6 
#define cbSqlStrLabel			7 
#define cbSqlStrPop19Popup		8 
#define cbSqlStrTxField			9 


static pascal void DrawcbSqlStrPop19Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbSqlStrPop19ID, 0 );
	return;
}/* end DrawcbSqlStrPop19Popup */


Boolean GetSQLPrepare( SQLPrepareRec *info )		// #19
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLPrepareID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetItem( cbSqlStrPop19Menu, 1, info->cbSqlStrText );

	ItemCount = CountMItems( cbSqlStrPop19Menu );
	if( info->cbSqlStrChoice < 1 || info->cbSqlStrChoice > ItemCount )
	{
		info->cbSqlStrChoice = 1;
		GetItem( cbSqlStrPop19Menu, 1, info->cbSqlStrText );
	}

	SetCheckbox( NullSzSqlStrCheck,	info->NullSzSqlStrChecked );
	SetDText( cbSqlStrTxField,		info->cbSqlStrText );
	SetUserItem( cbSqlStrPop19Popup, (ProcPtr)&DrawcbSqlStrPop19Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case cbSqlStrTxField:
			GetDText( itemNr, info->cbSqlStrText );
			break;

		case NullSzSqlStrCheck:
			DoCheckbox( itemNr, &info->NullSzSqlStrChecked );
			break;

		case cbSqlStrPop19Popup:
			DoPopup( cbSqlStrPop19Popup, cbSqlStrPop19ID, &info->cbSqlStrChoice );
			GetItem(  cbSqlStrPop19Menu, info->cbSqlStrChoice, info->cbSqlStrText );
			SetDText( cbSqlStrTxField,   info->cbSqlStrText );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLPrepare */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define QualifierTxField	6 
#define OwnerTxField		7 
#define NameTxField			8 
#define cbTableLabel		9 
#define cbQualifierField	10 
#define QualifierLabel		11 
#define cbQualifier65Popup	12 
#define OwnerLabel			13 
#define cbOwner65Popup		14 
#define cbOwnerField		15 
#define NameLabel			16 
#define cbName65Popup		17 
#define cbNameField			18 
#define QualLabel			19 
#define Qualifier65Popup	20 
#define OwnerLabel			21 
#define Owner65Popup		22 
#define NameLabel			23 
#define Name65Popup			24 


static pascal void DrawcbQualifier65Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop65ID, 0 );
}/* end DrawcbQualifier65Popup */


static pascal void DrawcbOwner65Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop65ID, 0 );
}/* end DrawcbOwner65Popup */


static pascal void DrawcbName65Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop65ID, 0 );
}/* end DrawcbName65Popup */


static pascal void DrawQualifier65Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop65ID, 0 );
}/* end DrawQualifier65Popup */


static pascal void DrawOwner65Popup( DialogPtr,  short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop65ID, 0 );
}/* end DrawOwner65Popup */


static pascal void DrawName65Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop65ID, 0 );
}/* end DrawName65Popup */


Boolean GetSQLPrimaryKeys( SQLPrimaryKeysRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLPrimaryKeysID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop65Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;

		GetItem( QualifierPop65Menu,	1, info->QualifierText		);
		GetItem( OwnerPop65Menu, 		1, info->OwnerText			);
		GetItem( NamePop65Menu,			1, info->NameText			);
		GetItem( cbQualifierPop65Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop65Menu, 		1, info->cbOwnerText		);
		GetItem( cbNamePop65Menu,		1, info->cbNameText			);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);

	SetUserItem( cbQualifier65Popup,	(ProcPtr)&DrawcbQualifier65Popup	);
	SetUserItem( cbOwner65Popup,		(ProcPtr)&DrawcbOwner65Popup		);
	SetUserItem( cbName65Popup,			(ProcPtr)&DrawcbName65Popup			);
	SetUserItem( Qualifier65Popup,		(ProcPtr)&DrawQualifier65Popup		);
	SetUserItem( Owner65Popup,			(ProcPtr)&DrawOwner65Popup			);
	SetUserItem( Name65Popup,			(ProcPtr)&DrawName65Popup			);
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop65Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop65Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop65Menu, info->cbNameChoice,
					info->cbNameText );
			break;
		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;

		case Qualifier65Popup:
			DoPopup( Qualifier65Popup, QualifierPop65ID, &info->QualifierChoice );
			UpdateText( QualifierPop65Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop65Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop65Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner65Popup:
			DoPopup( Owner65Popup, OwnerPop65ID, &info->OwnerChoice );
			UpdateText( OwnerPop65Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop65Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop65Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name65Popup:
			DoPopup( Name65Popup, NamePop65ID, &info->NameChoice );
			UpdateText( NamePop65Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop65Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop65Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;

		case cbQualifier65Popup:
			DoPopup( cbQualifier65Popup, cbQualifierPop65ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop65Menu,	info->cbQualifierChoice,
										info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner65Popup:
			DoPopup( cbOwner65Popup, cbOwnerPop65ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop65Menu,	info->cbOwnerChoice,
										info->cbOwnerText, cbOwnerField );
			break;
		case cbName65Popup:
			DoPopup( cbName65Popup, cbNamePop65ID, &info->cbNameChoice );
			UpdateText( cbNamePop65Menu,	info->cbNameChoice,
										info->cbNameText, cbNameField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLPrimaryKeys */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szProcLabel			5 
#define QualifierLabel		6 
#define Qualifier66Popup	7 
#define QualifierTxField	8 
#define OwnerLabel			9 
#define Owner66Popup		10 
#define OwnerTxField		11 
#define NameLabel			12 
#define Name66Popup			13 
#define NameTxField			14 
#define cbProcLabel			15 
#define cbQualifierField	16 
#define QualifierLabel		17 
#define cbQualifier66Popup	18 
#define OwnerLabel			19 
#define cbOwner66Popup		20 
#define cbOwnerField		21 
#define NameLabel			22 
#define cbName66Popup		23 
#define cbNameField			24 
#define szColumnLabel		25 
#define cbColumnLabel		26 
#define ColNameTxField		27 
#define cbColNameField		28 
#define NameLabel			29 
#define ColName66Popup		30 
#define cbColName66Popup	31 
#define NameLabel			32 


static pascal void DrawQualifier66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop66ID, 0 );
	return;
}/* end DrawQualifier66Popup */


static pascal void DrawOwner66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop66ID, 0 );
	return;
}/* end DrawOwner66Popup */


static pascal void DrawName66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop66ID, 0 );
	return;
}/* end DrawName66Popup */


static pascal void DrawColName66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, ColumnPop66ID, 0 );
	return;
}/* end DrawColName66Popup */


static pascal void DrawcbQualifier66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop66ID, 0 );
	return;
}/* end DrawcbQualifier66Popup */


static pascal void DrawcbOwner66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop66ID, 0 );
	return;
}/* end DrawcbOwner66Popup */


static pascal void DrawcbName66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop66ID, 0 );
	return;
}/* end DrawcbName66Popup */


static pascal void DrawcbColName66Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbColumnPop66ID, 0 );
	return;
}/* end DrawcbColName66Popup */


Boolean GetSQLProcedureColumns( SQLProcedureColumnsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLProcedureColumnsID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop66Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->ColNameChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->cbColNameChoice	= 1;

		GetItem( QualifierPop66Menu,	1, info->QualifierText		);
		GetItem( OwnerPop66Menu,		1, info->OwnerText			);
		GetItem( NamePop66Menu,			1, info->NameText			);
		GetItem( ColumnPop66Menu,		1, info->ColNameText		);
		GetItem( cbQualifierPop66Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop66Menu,		1, info->cbOwnerText		);
		GetItem( cbNamePop66Menu,		1, info->cbNameText			);
		GetItem( cbColumnPop66Menu,		1, info->cbColNameText		);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( ColNameTxField,	info->ColNameText		);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);
	SetDText( cbColNameField,	info->cbColNameText		);

	SetUserItem( Qualifier66Popup,		(ProcPtr)&DrawQualifier66Popup		);
	SetUserItem( Owner66Popup,			(ProcPtr)&DrawOwner66Popup			);
	SetUserItem( Name66Popup,			(ProcPtr)&DrawName66Popup			);
	SetUserItem( ColName66Popup,		(ProcPtr)&DrawColName66Popup		);
	SetUserItem( cbQualifier66Popup,	(ProcPtr)&DrawcbQualifier66Popup	);
	SetUserItem( cbOwner66Popup,		(ProcPtr)&DrawcbOwner66Popup		);
	SetUserItem( cbName66Popup,			(ProcPtr)&DrawcbName66Popup			);
	SetUserItem( cbColName66Popup,		(ProcPtr)&DrawcbColName66Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop66Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop66Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop66Menu, info->cbNameChoice,
					info->cbNameText );
			break;
		case ColNameTxField:
			tx2cb(	itemNr, info->ColNameText,
					cbColNameField, cbColumnPop66Menu, info->cbColNameChoice,
					info->cbColNameText );
			break;

		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;
		case cbColNameField:	GetDText( itemNr, info->cbColNameText );	break;

		case Qualifier66Popup:
			DoPopup( Qualifier66Popup, QualifierPop66ID, &info->QualifierChoice );
			UpdateText( QualifierPop66Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop66Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop66Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner66Popup:
			DoPopup( Owner66Popup, OwnerPop66ID, &info->OwnerChoice );
			UpdateText( OwnerPop66Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop66Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop66Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name66Popup:
			DoPopup( Name66Popup, NamePop66ID, &info->NameChoice );
			UpdateText( NamePop66Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop66Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop66Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;
		case ColName66Popup:
			DoPopup( ColName66Popup, ColumnPop66ID, &info->ColNameChoice );
			UpdateText( ColumnPop66Menu, info->ColNameChoice,
						info->ColNameText, ColNameTxField );
			updateCBpop(	ColumnPop66Menu,
							info->ColNameChoice,
							info->ColNameText,
							cbColumnPop66Menu,
							info->cbColNameChoice,
							info->cbColNameText, cbColNameField );
			break;

		case cbQualifier66Popup:
			DoPopup( cbQualifier66Popup, cbQualifierPop66ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop66Menu,	info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner66Popup:
			DoPopup( cbOwner66Popup, cbOwnerPop66ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop66Menu,	info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName66Popup:
			DoPopup( cbName66Popup, cbNamePop66ID, &info->cbNameChoice );
			UpdateText( cbNamePop66Menu,	info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		case cbColName66Popup:
			DoPopup( cbColName66Popup, cbColumnPop66ID, &info->cbColNameChoice );
			UpdateText( cbColumnPop66Menu,	info->cbColNameChoice,
						info->cbColNameText, cbColNameField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */
	
	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLProcedureColumns */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szProcLabel			5 
#define QualifierTxField	6 
#define OwnerLabel			7 
#define Owner67Popup		8 
#define OwnerTxField		9 
#define NameLabel			10 
#define Name67Popup			11 
#define NameTxField			12 
#define cbProcLabel			13 
#define cbQualifierField	14 
#define QualifierLabel		15 
#define cbQualifier67Popup	16 
#define OwnerLabel			17 
#define cbOwner67Popup		18 
#define cbOwnerField		19 
#define NameLabel			20 
#define cbName67Popup		21 
#define cbNameField			22 
#define QualifierLabel		23 
#define Qualifier67Popup	24


static pascal void DrawQualifier67Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop67ID, 0 );
	return;
}/* end DrawQualifier67Popup */


static pascal void DrawOwner67Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop67ID, 0 );
	return;
}/* end DrawOwner67Popup */


static pascal void DrawName67Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop67ID, 0 );
	return;
}/* end DrawName67Popup */


static pascal void DrawcbQualifier67Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop67ID, 0 );
	return;
}/* end DrawcbQualifier67Popup */


static pascal void DrawcbOwner67Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop67ID, 0 );
	return;
}/* end DrawcbOwner67Popup */


static pascal void DrawcbName67Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop67ID, 0 );
	return;
}/* end DrawcbName67Popup */


Boolean GetSQLProcedures( SQLProceduresRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLProceduresID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop67Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice		= 1;
		info->OwnerChoice			= 1;
		info->NameChoice			= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;

		GetItem( QualifierPop67Menu,	1, info->QualifierText		);
		GetItem( OwnerPop67Menu,		1, info->OwnerText			);
		GetItem( NamePop67Menu,			1, info->NameText			);
		GetItem( cbQualifierPop67Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop67Menu,		1, info->cbOwnerText		);
		GetItem( cbNamePop67Menu,		1, info->cbNameText			);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);

	SetUserItem( Qualifier67Popup,	(ProcPtr)&DrawQualifier67Popup	);
	SetUserItem( Owner67Popup,		(ProcPtr)&DrawOwner67Popup		);
	SetUserItem( Name67Popup,		(ProcPtr)&DrawName67Popup		);
	SetUserItem( cbQualifier67Popup,	(ProcPtr)&DrawcbQualifier67Popup	);
	SetUserItem( cbOwner67Popup,		(ProcPtr)&DrawcbOwner67Popup		);
	SetUserItem( cbName67Popup,			(ProcPtr)&DrawcbName67Popup			);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop67Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop67Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop67Menu, info->cbNameChoice,
					info->cbNameText );
			break;

		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;

		case Qualifier67Popup:
			DoPopup( Qualifier67Popup, QualifierPop67ID, &info->QualifierChoice );
			UpdateText( QualifierPop67Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop67Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop67Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner67Popup:
			DoPopup( Owner67Popup, OwnerPop67ID, &info->OwnerChoice );
			UpdateText( OwnerPop67Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop67Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop67Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name67Popup:
			DoPopup( Name67Popup, NamePop67ID, &info->NameChoice );
			UpdateText( NamePop67Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop67Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop67Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;

		case cbQualifier67Popup:
			DoPopup( cbQualifier67Popup, cbQualifierPop67ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop67Menu,	info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner67Popup:
			DoPopup( cbOwner67Popup, cbOwnerPop67ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop67Menu,	info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName67Popup:
			DoPopup( cbName67Popup, cbNamePop67ID, &info->cbNameChoice );
			UpdateText( cbNamePop67Menu,	info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLProcedures */


#define hstmtLabel		3 
#define hstmtTxLabel	4 
#define NullRgbValueCheck	5 
#define fromInputWindowLabel	6 
#define cbValueLabel	7 
#define cbValuePop49Popup	8 
#define cbValueTxField	9 


static pascal void DrawcbValuePop49Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbValuePop49ID, 0 );
	return;
}/* end DrawcbValuePop49Popup */


Boolean GetSQLPutData( SQLPutDataRec *info )		// #49
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLPutDataID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetItem( cbValuePop49Menu, 1, info->cbValueText );

	ItemCount = CountMItems( cbValuePop49Menu );
	if( info->cbValueChoice < 1 || info->cbValueChoice > ItemCount )
	{
		info->cbValueChoice = 1;
		GetItem( cbValuePop49Menu, 1, info->cbValueText );
	}

	SetCheckbox( NullRgbValueCheck, info->NullRgbValueChecked );
	SetDText( cbValueTxField, info->cbValueText );
	SetUserItem( cbValuePop49Popup, (ProcPtr)&DrawcbValuePop49Popup );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullRgbValueCheck:
			DoCheckbox( itemNr, &info->NullRgbValueChecked );
			break;
		case cbValueTxField:
			GetDText( itemNr, info->cbValueText );
			break;
		case cbValuePop49Popup:
			DoPopup( cbValuePop49Popup, cbValuePop49ID, &info->cbValueChoice );
			UpdateText( cbValuePop49Menu, info->cbValueChoice,
						info->cbValueText, cbValueTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLPutData */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define NullPcrowOutCheck	5 


Boolean GetSQLRowCount( SQLRowCountRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLRowCountID, nil, (WindowPtr) -1L );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetCheckbox( NullPcrowOutCheck, info->NullPcrowOutChecked );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case NullPcrowOutCheck:
			DoCheckbox( itemNr, &info->NullPcrowOutChecked );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLRowCount */


#define hdbcLabel		3 
#define hdbcTxLabel		4 
#define fOptionTxField	5 
#define vParamTxField	6 
#define fOptionLabel	7 
#define fOption50Popup	8 
#define vParamLabel		9 
#define vParam50Popup	10 


static pascal void DrawfOption50Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fOptionPop50ID, 0 );
	return;
}/* end DrawfOption50Popup */


static pascal void DrawvParam50Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, vParamPop50ID, 0 );
	return;
}/* end DrawvParam50Popup */


Boolean GetSQLSetConnectOption( SQLSetConnectOptionRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSetConnectOptionID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hdbcTxLabel, hdbcText );

	ItemCount = CountMItems( fOptionPop50Menu );
	if( info->fOptionChoice < 1 || info->fOptionChoice > ItemCount )
	{
		info->fOptionChoice		= 1;
		info->vParamChoice		= 1;
		GetItem( fOptionPop50Menu,	1, info->fOptionText	);
		GetItem( vParamPop50Menu,	1, info->vParamText		);
	}

	SetDText( fOptionTxField, info->fOptionText );
	SetDText( vParamTxField, info->vParamText );
	SetUserItem( fOption50Popup, (ProcPtr)&DrawfOption50Popup );
	SetUserItem( vParam50Popup, (ProcPtr)&DrawvParam50Popup );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case fOptionTxField:
			GetDText( itemNr, info->fOptionText );
			break;
		case vParamTxField:
			GetDText( itemNr, info->vParamText );
			break;
		case fOption50Popup:
			DoPopup( fOption50Popup, fOptionPop50ID, &info->fOptionChoice );
			UpdateText( fOptionPop50Menu, info->fOptionChoice,
						info->fOptionText, fOptionTxField );
			break;
		case vParam50Popup:
			DoPopup( vParam50Popup, vParamPop50ID, &info->vParamChoice );
			UpdateText( vParamPop50Menu, info->vParamChoice,
						info->vParamText, vParamTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSetConnectOption */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szCursorLabel		5 
#define szCursorPopup		6 
#define szCursorTxField		7 
#define cbCursorLabel		8 
#define cbCursorPopup		9 
#define cbCursorTxField		10 


static pascal void DrawszCursorPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, szCursorPopID, 0 );
	return;
}/* end DrawszCursorPopup */


static pascal void DrawcbCursorPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbCursorPopID, 0 );
	return;
}/* end DrawcbCursorPopup */


Boolean GetSQLSetCursorName( SQLSetCursorNameRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSetCursorNameID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( szCursorPopMenu );
	if( info->szCursorChoice < 1 || info->szCursorChoice > ItemCount )
	{
		GetItem( szCursorPopMenu, 1, info->szCursorText );
		GetItem( cbCursorPopMenu, 1, info->cbCursorText );

		info->szCursorChoice = 1;
		info->cbCursorChoice = 1;
	}

	SetDText( szCursorTxField, info->szCursorText );
	SetDText( cbCursorTxField, info->cbCursorText );
	SetUserItem( szCursorPopup, (ProcPtr)&DrawszCursorPopup );
	SetUserItem( cbCursorPopup, (ProcPtr)&DrawcbCursorPopup );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case szCursorTxField:
			GetDText( itemNr, info->szCursorText );
			sprintf( info->cbCursorText, "%d", info->szCursorText[0] );
			c2pstr(  info->cbCursorText );
			SetItem( cbCursorPopMenu, 1, info->cbCursorText );
			if( info->cbCursorChoice == 1 )
				SetDText( cbCursorTxField, info->cbCursorText );
			break;

		case cbCursorTxField:
			GetDText( itemNr, info->cbCursorText );
			break;

		case szCursorPopup:
			DoPopup( szCursorPopup, szCursorPopID, &info->szCursorChoice );
			UpdateText( szCursorPopMenu, info->szCursorChoice, info->szCursorText, szCursorTxField );
			updateCBpop(	szCursorPopMenu, info->szCursorChoice, info->szCursorText,
							cbCursorPopMenu, info->cbCursorChoice,
							info->cbCursorText, cbCursorTxField );
			break;

		case cbCursorPopup:
			DoPopup( cbCursorPopup, cbCursorPopID, &info->cbCursorChoice );
			UpdateText( cbCursorPopMenu, info->cbCursorChoice, info->cbCursorText, cbCursorTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSetCursorName */


#define hstmtLabel					3 
#define hstmtTxLabel				4 
#define NullPcbValuePointerCheck	5 
#define iparLabel					6 
#define iparTxField					7 
#define fCTypeLabel					8 
#define fCTypePop22Popup			9 
#define fSqlTypeLabel				10
#define fSqlTypePop22Popup			11 
#define rgbValueLabel				12 
#define rgbValuePop22Popup			13 
#define cbColDefLabel				14 
#define ibScaleLabel				15
#define cbValueMaxLabel				16 
#define cbColDefField				17 
#define ibScaleField				18
#define cbValMaxField				19 
#define fcTypeTxField				20
#define fSqlTypeTxField				21 
#define rgbValueTxField				22 
#define Rect23						23 


static pascal void DrawfCTypePop22Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fCTypePop22ID, 0 );
	return;
}/* end DrawfCTypePop22Popup */


static pascal void DrawfSqlTypePop22Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fSqlTypePop22ID, 0 );
	return;
}/* end DrawfSqlTypePop22Popup */


static pascal void DrawrgbValuePop22Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, rgbValuePop22ID, 0 );
	return;
}/* end DrawrgbValuePop22Popup */


Boolean GetSQLSetParam( SQLSetParamRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSetParamID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fCTypePop22Menu );
	if( info->fCTypeChoice < 1 || info->fCTypeChoice > ItemCount )
	{
		info->fCTypeChoice   = 1;	GetItem( fCTypePop22Menu,   1, info->fcTypeText );
		info->fSqlTypeChoice = 1;	GetItem( fSqlTypePop22Menu, 1, info->fSqlTypeText );
		info->rgbValueChoice = 1;	GetItem( rgbValuePop22Menu, 1, info->rgbValueText );
	}

	SetDText( cbColDefField,	info->cbColDefText	);
	SetDText( ibScaleField,		info->ibScaleText	);
	SetDText( cbValMaxField,	info->cbValMaxText	);
	SetDText( fcTypeTxField,	info->fcTypeText	);
	SetDText( fSqlTypeTxField,	info->fSqlTypeText	);
	SetDText( rgbValueTxField,	info->rgbValueText	);
	SetDText( iparTxField,		info->iparText		);
	SetCheckbox( NullPcbValuePointerCheck, info->NullPcbValuePointerChecked );
	SetUserItem( Rect23,				(ProcPtr)&RectItem );	// outline rect
	SetUserItem( fCTypePop22Popup,		(ProcPtr)&DrawfCTypePop22Popup );
	SetUserItem( fSqlTypePop22Popup,	(ProcPtr)&DrawfSqlTypePop22Popup );
	SetUserItem( rgbValuePop22Popup,	(ProcPtr)&DrawrgbValuePop22Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case cbColDefField:		GetDText( itemNr, info->cbColDefText );		break;
		case ibScaleField:		GetDText( itemNr, info->ibScaleText );		break;
		case cbValMaxField:		GetDText( itemNr, info->cbValMaxText );		break;
		case fcTypeTxField:		GetDText( itemNr, info->fcTypeText );		break;
		case fSqlTypeTxField:	GetDText( itemNr, info->fSqlTypeText );		break;
		case rgbValueTxField:	GetDText( itemNr, info->rgbValueText );		break;
		case iparTxField:		GetDText( itemNr, info->iparText );			break;

		case NullPcbValuePointerCheck:
			DoCheckbox( itemNr, &info->NullPcbValuePointerChecked );
			break;
		case fCTypePop22Popup:
			DoPopup( fCTypePop22Popup, fCTypePop22ID, &info->fCTypeChoice );
			UpdateText( fCTypePop22Menu,	info->fCTypeChoice,
											info->fcTypeText, fcTypeTxField );
			break;
		case fSqlTypePop22Popup:
			DoPopup( fSqlTypePop22Popup, fSqlTypePop22ID, &info->fSqlTypeChoice );
			UpdateText( fSqlTypePop22Menu,	info->fSqlTypeChoice,
											info->fSqlTypeText, fSqlTypeTxField );
			break;
		case rgbValuePop22Popup:
			DoPopup( rgbValuePop22Popup, rgbValuePop22ID, &info->rgbValueChoice );
			UpdateText( rgbValuePop22Menu,	info->rgbValueChoice,
											info->rgbValueText, rgbValueTxField );
			break;
		}/* end  SWITCH on item number */
	}/* end  WHILE not OK or CANCEL */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSetParam */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define irowLabel			5 
#define irowTxField			6 
#define fRefreshLabel		7 
#define fRefreshPop68Popup	8 
#define fRefreshTxField		9 
#define fLockLabel			10 
#define fLockPop68Popup		11 
#define fLockTxField		12 


static pascal void DrawfRefreshPop68Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fRefreshPop68ID, 0 );
	return;
}/* end DrawfRefreshPop68Popup */


static pascal void DrawfLockPop68Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fLockPop68ID, 0 );
	return;
}/* end DrawfLockPop68Popup */


Boolean GetSQLSetPos( SQLSetPosRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSetPosID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fRefreshPop68Menu );
	if( info->fRefreshChoice < 1 || info->fRefreshChoice > ItemCount )
	{
		info->fRefreshChoice	= 1;
		info->fLockChoice		= 1;
		GetItem( fRefreshPop68Menu,	1, info->fRefreshText );
		GetItem( fLockPop68Menu, 	1, info->fLockText  );
	}

	SetDText( irowTxField,		info->irowText		);
	SetDText( fRefreshTxField,	info->fRefreshText	);
	SetDText( fLockTxField,		info->fLockText		);

	SetUserItem( fRefreshPop68Popup,	(ProcPtr)&DrawfRefreshPop68Popup	);
	SetUserItem( fLockPop68Popup,		(ProcPtr)&DrawfLockPop68Popup		);
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case irowTxField:		GetDText( itemNr, info->irowText );		break;
		case fRefreshTxField:	GetDText( itemNr, info->fRefreshText );	break;
		case fLockTxField:		GetDText( itemNr, info->fLockText );	break;

		case fRefreshPop68Popup:
			DoPopup( fRefreshPop68Popup, fRefreshPop68ID, &info->fRefreshChoice );
			UpdateText( fRefreshPop68Menu, info->fRefreshChoice,
						info->fRefreshText, fRefreshTxField );
			break;
		case fLockPop68Popup:
			DoPopup( fLockPop68Popup, fLockPop68ID, &info->fLockChoice );
			UpdateText( fLockPop68Menu, info->fLockChoice,
						info->fLockText, fLockTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSetPos */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define fConcurrencyLabel	5 
#define fConcurrency69Popup	6 
#define fConcurrencyTxField	7 
#define crowKeysetLabel		8 
#define crowKeyset69Popup	9 
#define crowKeysetTxField	10 
#define crowRowsetLabel		11 
#define crowRowsetTxField	12 


static pascal void DrawfConcurrency69Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fConcurrencyPop69ID, 0 );
	return;
}/* end DrawfConcurrency69Popup */


static pascal void DrawcrowKeyset69Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, crowKeysetPop69ID, 0 );
	return;
}/* end DrawcrowKeyset69Popup */


Boolean GetSQLSetScrollOptions( SQLSetScrollOptionsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSetScrollOptionsID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fConcurrencyPop69Menu );
	if( info->fConcurrencyChoice < 1 || info->fConcurrencyChoice > ItemCount )
	{
		info->fConcurrencyChoice	= 1;
		info->crowKeysetChoice		= 1;
		GetItem( fConcurrencyPop69Menu,	1, info->fConcurrencyText	);
		GetItem( crowKeysetPop69Menu,	1, info->crowKeysetText		);
	}

	SetDText( fConcurrencyTxField,	info->fConcurrencyText	);
	SetDText( crowKeysetTxField,	info->crowKeysetText	);
	SetDText( crowRowsetTxField,	info->crowRowsetText	);
	SetUserItem( fConcurrency69Popup,	(ProcPtr)&DrawfConcurrency69Popup	);
	SetUserItem( crowKeyset69Popup,		(ProcPtr)&DrawcrowKeyset69Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case fConcurrencyTxField:	GetDText( itemNr, info->fConcurrencyText );	break;
		case crowKeysetTxField:		GetDText( itemNr, info->crowKeysetText );	break;
		case crowRowsetTxField:		GetDText( itemNr, info->crowRowsetText );	break;

		case fConcurrency69Popup:
			DoPopup( fConcurrency69Popup, fConcurrencyPop69ID, &info->fConcurrencyChoice );
			UpdateText( fConcurrencyPop69Menu, info->fConcurrencyChoice,
						info->fConcurrencyText, fConcurrencyTxField );
			break;
		case crowKeyset69Popup:
			DoPopup( crowKeyset69Popup, crowKeysetPop69ID, &info->crowKeysetChoice );
			UpdateText( crowKeysetPop69Menu, info->crowKeysetChoice,
						info->crowKeysetText, crowKeysetTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSetScrollOptions */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define fOptionTxField		5 
#define vParamTxField		6 
#define fOptionLabel		7 
#define fOption51Popup		8 
#define vParamLabel			9 
#define vParam51Popup		10 


static pascal void DrawfOption51Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fOptionPop51ID, 0 );
	return;
}/* end DrawfOption51Popup */


static pascal void DrawvParam51Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, vParamPop51ID, 0 );
	return;
}/* end DrawvParam51Popup */


Boolean GetSQLSetStmtOption( SQLSetStmtOptionRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSetStmtOptionID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fOptionPop51Menu );
	if( info->fOptionChoice < 1 || info->fOptionChoice > ItemCount )
	{
		info->fOptionChoice	= 1;
		info->vParamChoice	= 1;
		GetItem( fOptionPop51Menu, 1, info->fOptionText );
		GetItem( vParamPop51Menu,  1, info->vParamText  );
	}

	SetDText( fOptionTxField, info->fOptionText );
	SetDText( vParamTxField, info->vParamText );
	SetUserItem( fOption51Popup, (ProcPtr)&DrawfOption51Popup );
	SetUserItem( vParam51Popup, (ProcPtr)&DrawvParam51Popup );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case fOptionTxField:
			GetDText( itemNr, info->fOptionText );
			break;
		case vParamTxField:
			GetDText( itemNr, info->vParamText );
			break;
		case fOption51Popup:
			DoPopup( fOption51Popup, fOptionPop51ID, &info->fOptionChoice );
			UpdateText( fOptionPop51Menu, info->fOptionChoice,
						info->fOptionText, fOptionTxField );
			break;
		case vParam51Popup:
			DoPopup( vParam51Popup, vParamPop51ID, &info->vParamChoice );
			UpdateText( vParamPop51Menu, info->vParamChoice,
						info->vParamText, vParamTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSetStmtOption */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define QualifierLabel		6 
#define Qualifier52Popup	7 
#define QualifierTxField	8 
#define OwnerLabel			9 
#define Owner52Popup		10 
#define OwnerTxField		11 
#define NameLabel			12 
#define Name52Popup			13 
#define NameTxField			14 
#define cbTableLabel		15 
#define cbQualifierField		16 
#define QualifierLabel		17 
#define cbQualifier52Popup	18 
#define OwnerLabel			19 
#define cbOwner52Popup		20 
#define cbOwnerField			21 
#define NameLabel			22 
#define cbName52Popup		23 
#define cbNameField			24 
#define fScopeTxField		25 
#define fNullableTxField	26 
#define fColTypeLabel		27 
#define fColType52Popup		28 
#define fColTypeTxField		29 
#define fNullableLabel		30 
#define fNullable52Popup	31 
#define fScopeLabel			32 
#define fScope52Popup		33 


static pascal void DrawQualifier52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop52ID, 0 );
	return;
}/* end DrawQualifier52Popup */


static pascal void DrawOwner52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop52ID, 0 );
	return;
}/* end DrawOwner52Popup */


static pascal void DrawName52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop52ID, 0 );
	return;
}/* end DrawName52Popup */


static pascal void DrawcbQualifier52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop52ID, 0 );
	return;
}/* end DrawcbQualifier52Popup */


static pascal void DrawcbOwner52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop52ID, 0 );
	return;
}/* end DrawcbOwner52Popup */


static pascal void DrawcbName52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop52ID, 0 );
	return;
}/* end DrawcbName52Popup */


static pascal void DrawfColType52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fColTypePop52ID, 0 );
	return;
}/* end DrawfColType52Popup */


static pascal void DrawfNullable52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fNullablePop52ID, 0 );
	return;
}/* end DrawfNullable52Popup */


static pascal void DrawfScope52Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fScopePop52ID, 0 );
	return;
}/* end DrawfScope52Popup */


Boolean GetSQLSpecialColumns( SQLSpecialColumnsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;


	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLSpecialColumnsID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( fColTypePop52Menu );
	if( info->fColTypeChoice < 1 || info->fColTypeChoice > ItemCount )
	{
		info->fColTypeChoice	= 1;
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->fColTypeChoice	= 1;
		info->fScopeChoice		= 1;
		info->fNullableChoice	= 1;

		GetItem( fColTypePop52Menu,		1, info->fColTypeText	);
		GetItem( QualifierPop52Menu,	1, info->QualifierText	);
		GetItem( OwnerPop52Menu,		1, info->OwnerText		);
		GetItem( NamePop52Menu,			1, info->NameText		);
		GetItem( cbQualifierPop52Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop52Menu,		1, info->cbOwnerText		);
		GetItem( cbNamePop52Menu,		1, info->cbNameText		);
		GetItem( fScopePop52Menu,		1, info->fScopeText		);
		GetItem( fNullablePop52Menu,	1, info->fNullableText	);
	}

	SetDText( fColTypeTxField,	info->fColTypeText		);
	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);
	SetDText( fScopeTxField,	info->fScopeText		);
	SetDText( fNullableTxField,	info->fNullableText		);

	SetUserItem( Qualifier52Popup,		(ProcPtr)&DrawQualifier52Popup		);
	SetUserItem( Owner52Popup,			(ProcPtr)&DrawOwner52Popup			);
	SetUserItem( Name52Popup,			(ProcPtr)&DrawName52Popup			);
	SetUserItem( cbQualifier52Popup,	(ProcPtr)&DrawcbQualifier52Popup	);
	SetUserItem( cbOwner52Popup,		(ProcPtr)&DrawcbOwner52Popup		);
	SetUserItem( cbName52Popup,			(ProcPtr)&DrawcbName52Popup			);
	SetUserItem( fColType52Popup,		(ProcPtr)&DrawfColType52Popup		);
	SetUserItem( fScope52Popup,			(ProcPtr)&DrawfScope52Popup			);
	SetUserItem( fNullable52Popup,		(ProcPtr)&DrawfNullable52Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case fColTypeTxField:	GetDText( itemNr, info->fColTypeText );		break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop52Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop52Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop52Menu, info->cbNameChoice,
					info->cbNameText );
			break;

		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;
		case fScopeTxField:		GetDText( itemNr, info->fScopeText );		break;
		case fNullableTxField:	GetDText( itemNr, info->fNullableText );	break;

		case fColType52Popup:
			DoPopup( fColType52Popup, fColTypePop52ID, &info->fColTypeChoice );
			UpdateText( fColTypePop52Menu, info->fColTypeChoice,
						info->fColTypeText, fColTypeTxField );
			break;
		case Qualifier52Popup:
			DoPopup( Qualifier52Popup, QualifierPop52ID, &info->QualifierChoice );
			UpdateText( QualifierPop52Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			break;
		case Owner52Popup:
			DoPopup( Owner52Popup, OwnerPop52ID, &info->OwnerChoice );
			UpdateText( OwnerPop52Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			break;
		case Name52Popup:
			DoPopup( Name52Popup, NamePop52ID, &info->NameChoice );
			UpdateText( NamePop52Menu, info->NameChoice,
						info->NameText, NameTxField );
			break;
		case cbQualifier52Popup:
			DoPopup( cbQualifier52Popup, cbQualifierPop52ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop52Menu, info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner52Popup:
			DoPopup( cbOwner52Popup, cbOwnerPop52ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop52Menu, info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName52Popup:
			DoPopup( cbName52Popup, cbNamePop52ID, &info->cbNameChoice );
			UpdateText( cbNamePop52Menu, info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		case fScope52Popup:
			DoPopup( fScope52Popup, fScopePop52ID, &info->fScopeChoice );
			UpdateText( fScopePop52Menu, info->fScopeChoice,
						info->fScopeText, fScopeTxField );
			break;
		case fNullable52Popup:
			DoPopup( fNullable52Popup, fNullablePop52ID, &info->fNullableChoice );
			UpdateText( fNullablePop52Menu, info->fNullableChoice,
						info->fNullableText, fNullableTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLSpecialColumns */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define cbTableLabel		6 
#define QualifierTxField	7 
#define OwnerTxField		8 
#define NameTxField			9 
#define fUniqueTxField		10 
#define fAccuracyTxField	11 
#define Qual9Field			12 
#define cbOwnerField			13 
#define cbNameField			14 
#define QualifierLabel		15 
#define Qualifier53Popup	16 
#define OwnerLabel			17 
#define Owner53Popup		18 
#define NameLabel			19 
#define Name53Popup			20 
#define fUniqueLabel		21 
#define fUnique53Popup		22 
#define fAccuracyLabel		23 
#define fAccuracy53Popup	24 
#define QualifierLabel		25 
#define cbQualifier53Popup	26
#define OwnerLabel			27 
#define cbOwner53Popup		28
#define NameLabel			29 
#define cbName53Popup		30 


static pascal void DrawQualifier53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop53ID, 0 );
}/* end DrawQualifier53Popup */


static pascal void DrawOwner53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop53ID, 0 );
}/* end DrawOwner53Popup */


static pascal void DrawName53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop53ID, 0 );
}/* end DrawcbName53Popup */


static pascal void DrawcbQualifier53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop53ID, 0 );
}/* end DrawcbQualifier53Popup */


static pascal void DrawcbOwner53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop53ID, 0 );
}/* end DrawcbOwner53Popup */


static pascal void DrawcbName53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop53ID, 0 );
}/* end DrawcbName53Popup */


static pascal void DrawfUnique53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fUniquePop53ID, 0 );
}/* end DrawfUnique53Popup */


static pascal void DrawfAccuracy53Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fAccuracyPop53ID, 0 );
}/* end DrawfAccuracy53Popup */


Boolean GetSQLStatistics( SQLStatisticsRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLStatisticsID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop53Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->fUniqueChoice		= 1;
		info->fAccuracyChoice	= 1;

		GetItem( QualifierPop53Menu,	1, info->QualifierText		);
		GetItem( OwnerPop53Menu,		1, info->OwnerText			);
		GetItem( NamePop53Menu,			1, info->NameText			);
		GetItem( cbQualifierPop53Menu,	1, info->cbQualifierText			);
		GetItem( cbOwnerPop53Menu,		1, info->cbOwnerText		);
		GetItem( cbNamePop53Menu,		1, info->cbNameText			);
		GetItem( fUniquePop53Menu,		1, info->fUniqueText		);
		GetItem( fAccuracyPop53Menu,	1, info->fAccuracyText		);
	}

	SetDText( QualifierTxField,	info->QualifierText	);
	SetDText( OwnerTxField,		info->OwnerText		);
	SetDText( NameTxField,		info->NameText		);
	SetDText( Qual9Field,		info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText	);
	SetDText( cbNameField,		info->cbNameText	);
	SetDText( fUniqueTxField,	info->fUniqueText	);
	SetDText( fAccuracyTxField,	info->fAccuracyText	);

	SetUserItem( Qualifier53Popup,		(ProcPtr)&DrawQualifier53Popup		);
	SetUserItem( Owner53Popup,			(ProcPtr)&DrawOwner53Popup			);
	SetUserItem( Name53Popup,			(ProcPtr)&DrawName53Popup			);
	SetUserItem( cbQualifier53Popup,	(ProcPtr)&DrawcbQualifier53Popup	);
	SetUserItem( cbOwner53Popup,		(ProcPtr)&DrawcbOwner53Popup		);
	SetUserItem( cbName53Popup,			(ProcPtr)&DrawcbName53Popup			);
	SetUserItem( fUnique53Popup,		(ProcPtr)&DrawfUnique53Popup		);
	SetUserItem( fAccuracy53Popup,		(ProcPtr)&DrawfAccuracy53Popup		);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					Qual9Field, cbQualifierPop53Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop53Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop53Menu, info->cbNameChoice,
					info->cbNameText );
			break;

		case Qual9Field:		GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;

		case fUniqueTxField:	GetDText( itemNr, info->fUniqueText );		break;
		case fAccuracyTxField:	GetDText( itemNr, info->fAccuracyText );	break;

		case Qualifier53Popup:
			DoPopup( Qualifier53Popup, QualifierPop53ID, &info->QualifierChoice );
 			UpdateText( QualifierPop53Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop53Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop53Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, Qual9Field );
			break;
		case Owner53Popup:
			DoPopup( Owner53Popup, OwnerPop53ID, &info->OwnerChoice );
			UpdateText( OwnerPop53Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop53Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop53Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name53Popup:
			DoPopup( Name53Popup, NamePop53ID, &info->NameChoice );
			UpdateText( NamePop53Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop53Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop53Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;

		case cbQualifier53Popup:
			DoPopup( cbQualifier53Popup, cbQualifierPop53ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop53Menu, info->cbQualifierChoice,
						info->cbQualifierText, Qual9Field );
			break;
		case cbOwner53Popup:
			DoPopup( cbOwner53Popup, cbOwnerPop53ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop53Menu, info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName53Popup:
			DoPopup( cbName53Popup, cbNamePop53ID, &info->cbNameChoice );
			UpdateText( cbNamePop53Menu, info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;

		case fUnique53Popup:
			DoPopup( fUnique53Popup, fUniquePop53ID, &info->fUniqueChoice );
			UpdateText( fUniquePop53Menu, info->fUniqueChoice,
						info->fUniqueText, fUniqueTxField );
			break;
		case fAccuracy53Popup:
			DoPopup( fAccuracy53Popup, fAccuracyPop53ID, &info->fAccuracyChoice );
			UpdateText( fAccuracyPop53Menu, info->fAccuracyChoice,
						info->fAccuracyText, fAccuracyTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLStatistics */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define QualifierTxField	6 
#define OwnerTxField		7 
#define NameTxField			8 
#define cbTableLabel		9 
#define cbQualifierField	10 
#define QualifierLabel		11 
#define cbQualifier70Popup	12 
#define OwnerLabel			13 
#define cbOwner70Popup		14 
#define cbOwnerField		15 
#define NameLabel			16 
#define cbName70Popup		17 
#define cbNameField			18 
#define QualifierLabel		19 
#define Qualifier70Popup	20 
#define OwnerLabel			21 
#define Owner70Popup		22 
#define NameLabel			23 
#define Name70Popup			24 


static pascal void DrawQualifier70Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, QualifierPop70ID, 0 );
	return;
}/* end DrawQualifier70Popup */


static pascal void DrawOwner70Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, OwnerPop70ID, 0 );
	return;
}/* end DrawOwner70Popup */


static pascal void DrawName70Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, NamePop70ID, 0 );
	return;
}/* end DrawName70Popup */


static pascal void DrawcbQualifier70Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifierPop70ID, 0 );
	return;
}/* end DrawcbQualifier70Popup */


static pascal void DrawcbOwner70Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwnerPop70ID, 0 );
	return;
}/* end DrawcbOwner70Popup */


static pascal void DrawcbName70Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbNamePop70ID, 0 );
	return;
}/* end DrawcbName70Popup */


Boolean GetSQLTablePrivileges( SQLTablePrivilegesRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLTablePrivilegesID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( QualifierPop70Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice		= 1;
		info->OwnerChoice			= 1;
		info->NameChoice			= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;

		GetItem( QualifierPop70Menu,	1, info->QualifierText		);
		GetItem( OwnerPop70Menu,		1, info->OwnerText			);
		GetItem( NamePop70Menu,			1, info->NameText			);
		GetItem( cbQualifierPop70Menu,	1, info->cbQualifierText	);
		GetItem( cbOwnerPop70Menu,		1, info->cbOwnerText		);
		GetItem( cbNamePop70Menu,		1, info->cbNameText			);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);

	SetUserItem( Qualifier70Popup,	(ProcPtr)&DrawQualifier70Popup	);
	SetUserItem( Owner70Popup,		(ProcPtr)&DrawOwner70Popup		);
	SetUserItem( Name70Popup,		(ProcPtr)&DrawName70Popup		);
	SetUserItem( cbQualifier70Popup,	(ProcPtr)&DrawcbQualifier70Popup	);
	SetUserItem( cbOwner70Popup,		(ProcPtr)&DrawcbOwner70Popup		);
	SetUserItem( cbName70Popup,			(ProcPtr)&DrawcbName70Popup			);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;		done = TRUE;	break;
		case CancelButton:	result = FALSE;		done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifierPop70Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwnerPop70Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbNamePop70Menu, info->cbNameChoice,
					info->cbNameText );
			break;

		case cbQualifierField:	GetDText( itemNr, info->cbQualifierText );	break;
		case cbOwnerField:		GetDText( itemNr, info->cbOwnerText );		break;
		case cbNameField:		GetDText( itemNr, info->cbNameText );		break;

		case Qualifier70Popup:
			DoPopup( Qualifier70Popup, QualifierPop70ID, &info->QualifierChoice );
 			UpdateText( QualifierPop70Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	QualifierPop70Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifierPop70Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner70Popup:
			DoPopup( Owner70Popup, OwnerPop70ID, &info->OwnerChoice );
 			UpdateText( OwnerPop70Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	OwnerPop70Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwnerPop70Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name70Popup:
			DoPopup( Name70Popup, NamePop70ID, &info->NameChoice );
 			UpdateText( NamePop70Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	NamePop70Menu,
							info->NameChoice,
							info->NameText,
							cbNamePop70Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;

		case cbQualifier70Popup:
			DoPopup( cbQualifier70Popup, cbQualifierPop70ID, &info->cbQualifierChoice );
			UpdateText( cbQualifierPop70Menu, info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner70Popup:
			DoPopup( cbOwner70Popup, cbOwnerPop70ID, &info->cbOwnerChoice );
			UpdateText( cbOwnerPop70Menu, info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName70Popup:
			DoPopup( cbName70Popup, cbNamePop70ID, &info->cbNameChoice );
			UpdateText( cbNamePop70Menu, info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLTablePrivileges */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define szTableLabel		5 
#define QualifierTxField	6 
#define OwnerTxField		7 
#define NameTxField			8 
#define TypeTxField			9 
#define cbQualifierField	10 
#define QualifierLabel		11 
#define cbQualifier54Popup	12 
#define OwnerLabel			13 
#define cbOwner54Popup		14 
#define cbOwnerField		15 
#define NameLabel			16 
#define cbName54Popup		17 
#define cbNameField			18 
#define TypeLabel			19 
#define cbType54Popup		20 
#define Type9Field			21 
#define QualifierLabel		22 
#define Qualifier54Popup	23 
#define OwnerLabel			24 
#define Owner54Popup		25 
#define NameLabel			26 
#define Name54Popup			27 
#define TypeLabel			28 
#define Popup54				29


static pascal void DrawQualifier54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Qualifier54ID, 0 );
}/* end DrawQualifier54Popup */


static pascal void DrawOwner54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Owner54ID, 0 );
}/* end DrawOwner54Popup */


static pascal void DrawName54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Name54ID, 0 );
}/* end DrawName54Popup */


static pascal void DrawPopup54( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, Type54ID, 0 );
}/* end DrawPopup54 */


static pascal void DrawcbQualifier54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbQualifier54ID, 0 );
}/* end DrawcbQualifier54Popup */


static pascal void DrawcbOwner54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbOwner54ID, 0 );
}/* end DrawcbOwner54Popup */


static pascal void DrawcbName54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbName54ID, 0 );
}/* end DrawcbName54Popup */


static pascal void DrawcbType54Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, cbType54ID, 0 );
}/* end DrawcbType54Popup */


Boolean GetSQLTables( SQLTablesRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr, ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLTablesID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	ItemCount = CountMItems( Qualifier54Menu );
	if( info->QualifierChoice < 1 || info->QualifierChoice > ItemCount )
	{
		info->QualifierChoice	= 1;
		info->OwnerChoice		= 1;
		info->NameChoice		= 1;
		info->TypeChoice		= 1;
		info->cbQualifierChoice	= 1;
		info->cbOwnerChoice		= 1;
		info->cbNameChoice		= 1;
		info->cbTypeChoice		= 1;

		GetItem( Qualifier54Menu,	1, info->QualifierText		);
		GetItem( Owner54Menu,		1, info->OwnerText			);
		GetItem( Name54Menu,		1, info->NameText			);
		GetItem( Type54Menu,		1, info->TypeText			);
		GetItem( cbQualifier54Menu,	1, info->cbQualifierText	);
		GetItem( cbOwner54Menu,		1, info->cbOwnerText		);
		GetItem( cbName54Menu,		1, info->cbNameText			);
		GetItem( cbType54Menu,		1, info->cbTypeText			);
	}

	SetDText( QualifierTxField,	info->QualifierText		);
	SetDText( OwnerTxField,		info->OwnerText			);
	SetDText( NameTxField,		info->NameText			);
	SetDText( TypeTxField,		info->TypeText			);
	SetDText( cbQualifierField,	info->cbQualifierText	);
	SetDText( cbOwnerField,		info->cbOwnerText		);
	SetDText( cbNameField,		info->cbNameText		);
	SetDText( Type9Field,		info->cbTypeText		);

	SetUserItem( Qualifier54Popup,		(ProcPtr)&DrawQualifier54Popup		);
	SetUserItem( Owner54Popup,			(ProcPtr)&DrawOwner54Popup			);
	SetUserItem( Name54Popup,			(ProcPtr)&DrawName54Popup			);
	SetUserItem( Popup54,				(ProcPtr)&DrawPopup54				);
	SetUserItem( cbQualifier54Popup,	(ProcPtr)&DrawcbQualifier54Popup	);
	SetUserItem( cbOwner54Popup,		(ProcPtr)&DrawcbOwner54Popup		);
	SetUserItem( cbName54Popup,			(ProcPtr)&DrawcbName54Popup			);
	SetUserItem( cbType54Popup,			(ProcPtr)&DrawcbType54Popup			);

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;		done = TRUE;	break;
		case CancelButton:	result = FALSE;		done = TRUE;	break;

		case QualifierTxField:
			tx2cb(	itemNr, info->QualifierText,
					cbQualifierField, cbQualifier54Menu, info->cbQualifierChoice,
					info->cbQualifierText );
			break;
		case OwnerTxField:
			tx2cb(	itemNr, info->OwnerText,
					cbOwnerField, cbOwner54Menu, info->cbOwnerChoice,
					info->cbOwnerText );
			break;
		case NameTxField:
			tx2cb(	itemNr, info->NameText,
					cbNameField, cbName54Menu, info->cbNameChoice,
					info->cbNameText );
			break;
		case TypeTxField:
			tx2cb(	itemNr, info->TypeText,
					Type9Field, cbType54Menu, info->cbTypeChoice,
					info->cbTypeText );
			break;

		case cbQualifierField:
			GetDText( itemNr, info->cbQualifierText );
			break;
		case cbOwnerField:
			GetDText( itemNr, info->cbOwnerText );
			break;
		case cbNameField:
			GetDText( itemNr, info->cbNameText );
			break;
		case Type9Field:
			GetDText( itemNr, info->cbTypeText );
			break;

		case Qualifier54Popup:
			DoPopup( Qualifier54Popup, Qualifier54ID, &info->QualifierChoice );
 			UpdateText( Qualifier54Menu, info->QualifierChoice,
						info->QualifierText, QualifierTxField );
			updateCBpop(	Qualifier54Menu,
							info->QualifierChoice,
							info->QualifierText,
							cbQualifier54Menu,
							info->cbQualifierChoice,
							info->cbQualifierText, cbQualifierField );
			break;
		case Owner54Popup:
			DoPopup( Owner54Popup, Owner54ID, &info->OwnerChoice );
 			UpdateText( Owner54Menu, info->OwnerChoice,
						info->OwnerText, OwnerTxField );
			updateCBpop(	Owner54Menu,
							info->OwnerChoice,
							info->OwnerText,
							cbOwner54Menu,
							info->cbOwnerChoice,
							info->cbOwnerText, cbOwnerField );
			break;
		case Name54Popup:
			DoPopup( Name54Popup, Name54ID, &info->NameChoice );
 			UpdateText( Name54Menu, info->NameChoice,
						info->NameText, NameTxField );
			updateCBpop(	Name54Menu,
							info->NameChoice,
							info->NameText,
							cbName54Menu,
							info->cbNameChoice,
							info->cbNameText, cbNameField );
			break;
		case Popup54:
			DoPopup( Popup54, Type54ID, &info->TypeChoice );
 			UpdateText( Type54Menu, info->TypeChoice,
						info->TypeText, TypeTxField );
			updateCBpop(	Type54Menu,
							info->TypeChoice,
							info->TypeText,
							cbType54Menu,
							info->cbTypeChoice,
							info->cbTypeText, Type9Field );
			break;

		case cbQualifier54Popup:
			DoPopup( cbQualifier54Popup, cbQualifier54ID, &info->cbQualifierChoice );
			UpdateText( cbQualifier54Menu, info->cbQualifierChoice,
						info->cbQualifierText, cbQualifierField );
			break;
		case cbOwner54Popup:
			DoPopup( cbOwner54Popup, cbOwner54ID, &info->cbOwnerChoice );
			UpdateText( cbOwner54Menu, info->cbOwnerChoice,
						info->cbOwnerText, cbOwnerField );
			break;
		case cbName54Popup:
			DoPopup( cbName54Popup, cbName54ID, &info->cbNameChoice );
			UpdateText( cbName54Menu, info->cbNameChoice,
						info->cbNameText, cbNameField );
			break;
		case cbType54Popup:
			DoPopup( cbType54Popup, cbType54ID, &info->cbTypeChoice );
			UpdateText( cbType54Menu, info->cbTypeChoice,
						info->cbTypeText, Type9Field );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLTables */


#define NullHenvCheck	3 
#define NullHdbcCheck	4 
#define fTypeTxField	5 
#define fTypeLabel		6 
#define fTypePop23Popup	7 


static pascal void DrawfTypePop23Popup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, fTypePop23ID, 0 );
	return;
}/* end DrawfTypePop23Popup */


Boolean GetSQLTransact( SQLTransactRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;
	short			ItemCount;

	GetPort( &savePort );
	InitCursor();
	theDialog = GetNewDialog( SQLTransactID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long)info );
	SetPort( theDialog );

	ItemCount = CountMItems( fTypePop23Menu );
	if( info->fTypeChoice < 1 || info->fTypeChoice > ItemCount )
	{
		info->fTypeChoice = 1;
		GetItem( fTypePop23Menu, 1, info->fTypeText );
	}

	SetCheckbox( NullHenvCheck, info->NullHenvChecked );
	SetCheckbox( NullHdbcCheck, info->NullHdbcChecked );
	SetDText( fTypeTxField, info->fTypeText );
	SetUserItem( fTypePop23Popup, (ProcPtr)&DrawfTypePop23Popup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;

		case NullHenvCheck:	DoCheckbox( itemNr, &info->NullHenvChecked );	break;
		case NullHdbcCheck:	DoCheckbox( itemNr, &info->NullHdbcChecked );	break;

		case fTypeTxField:	GetDText( itemNr, info->fTypeText );			break;

		case fTypePop23Popup:
			DoPopup( fTypePop23Popup, fTypePop23ID, &info->fTypeChoice );
			UpdateText( fTypePop23Menu,	info->fTypeChoice,
										info->fTypeText, fTypeTxField );
			break;
		}/* end  SWITCH */
	}/* end  WHILE */

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetSQLTransact */


#define hstmtLabel			3 
#define hstmtTxLabel		4 
#define iparLabel			5 
#define iparTxField			6 
#define fCTypeLabel			7 
#define fSqlTypeLabel		8 
#define cbColDefLabel		9 
#define ibScaleLabel		10 
#define rgbValueLabel		11 
#define rgbValueTxField		12 
#define pcbValueLabel		13 
#define FPpcbValuePopPopup	14 
#define pcbValueTxField		15 
#define cbValueMaxLabel		16 
#define cbValueMaxTxLabel	17 
#define fCTypeTxLabel		18 
#define fSqlTypeTxLabel		19 
#define cbColDefTxLabel		20 
#define ibScaleTxLabel		21


static pascal void DrawFPpcbValuePopPopup( DialogPtr, short itemNr )
{
	DrawPopup( itemNr, 79, 0 );
	return;
} /* end DrawFPpcbValuePopPopup */


Boolean GetFillParam( FillParamRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort( &savePort);
	InitCursor();
	theDialog = GetNewDialog( FillParamID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long) info  );
	SetPort( theDialog );

	SetDText( hstmtTxLabel, hstmtText );

	SetDText( iparTxField,		info->iparText		);
	SetDText( rgbValueTxField,	info->rgbValueText	);
	SetDText( pcbValueTxField,	info->pcbValueText	);
	SetUserItem( FPpcbValuePopPopup, (ProcPtr)&DrawFPpcbValuePopPopup );

	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case iparTxField:
			GetDText( itemNr, info->iparText );
			break;
		case rgbValueTxField:
			GetDText( itemNr, info->rgbValueText );
			break;
		case FPpcbValuePopPopup:
			DoPopup( FPpcbValuePopPopup, 79, &info->FPpcbValueChoice );
			break;
		case pcbValueTxField:
			GetDText( itemNr, info->pcbValueText );
			break;
		}
	}

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetFillParam */


#define DataSourceLabel	3 
#define UserIDtxField	4 
#define PasswordTxField	5 
#define DataSourcePopup	6 
#define DataSourceTxField	7 
#define UserIDLabel		8 
#define PasswordLabel	9 


static pascal void DrawDataSourcePopup( DialogPtr whichDialog, short itemNr );


static pascal void DrawDataSourcePopup( DialogPtr whichDialog, short itemNr )
{
	FullConnectRecPtr	data;


	data = (FullConnectRecPtr)GetWRefCon( whichDialog );
	DrawPopup(itemNr, 31, 0 );
}/* end DrawDataSourcePopup */


Boolean GetFullConnect( FullConnectRec *info )
{
	DialogPtr		theDialog;
	GrafPtr			savePort;
	Boolean			result;
	Boolean			done;
	short			itemNr;

	GetPort(  &savePort );
	InitCursor();
	theDialog = GetNewDialog(  FullConnectID, nil, (WindowPtr) -1L );
	SetWRefCon( theDialog, (long) info  );
	SetPort(  theDialog );

	SetDText( UserIDtxField, info->UserIDText );
	SetDText( PasswordTxField, info->PasswordText );
	SetUserItem( DataSourcePopup, (ProcPtr)&DrawDataSourcePopup );
	SetDText( DataSourceTxField, info->DataSourceText );
		
	ShowWindow( theDialog );
	OutlineButton( OKButton );

	for( done = FALSE; !done; )
	{
		MovableDialog( (ModalFilterProcPtr)StandardFilter, &itemNr );
		switch( itemNr )
		{
		case OKButton:		result = TRUE;	done = TRUE;	break;
		case CancelButton:	result = FALSE;	done = TRUE;	break;
		case UserIDtxField:
			GetDText( itemNr, info->UserIDText );
			break;
		case PasswordTxField:
			GetDText( itemNr, info->PasswordText );
			break;
		case DataSourcePopup:
			DoPopup( DataSourcePopup, 31, &info->DataSourceChoice );
			break;
		case DataSourceTxField:
			GetDText( itemNr, info->DataSourceText );
			break;
		}
	}

	DisposDialog( theDialog );
	SetPort( savePort );
	return result;
}/* end GetFullConnect */
